#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <sstream>
#include <random>
#include <bitset>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
typedef long long ll;
//#define int ll
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9 + 7;
const ll LINF = 1e18;
const db EPS = 1e-9;

struct fenwick {
    int n;
    vector<int> f;
    fenwick (int _n) {
        n = _n;
        f.assign(n,0);
    }
    void update(int i, int v) {
        for (; i <= n; i += i & (-i)) {
            f[i] += v;
        }
    }
    int get_sum(int i) {
        int s = 0;
        for (; i > 0; i -= i & (-i)) {
            s += f[i];
        }
    }
    int get(int L, int R) {
        return get_sum(R) - get_sum(L - 1);
    }
};

void solve() {
    int n, t;
     cin >> n >> t;
     vector<int> a(n);
     for (int i = 0; i < n; ++i) {
         cin >> a[i];
     }
     vector<int> b, c;
     int cnt = 0;
     while (true) {
         b = a;
         c = a;
         vector<int> m(3);
         for (int i = 1; i < n - 1; ++i) {
             m[0] = a[i - 1];
             m[1] = a[i];
             m[2] = a[i + 1];
             sort(all(m));
             c[i] = m[1];
         }
         a = c;
         if (a == b) {
             break;
         }
         else {
             ++cnt;
         }
     }
     cout << cnt << en;
     if (t) {
         for (auto& i: a) {
             cout << i << ' ';
         }
     }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}