#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}
ll time() {
    return chrono::steady_clock::now().time_since_epoch().count();
}

#define SPAR 0
#define FEN 0

#ifdef SPAR
namespace SPARSE {
    bool run = false;
    const int N = 1e5;
    const int LOG = 17;

    int log[N];

    void init() {
        if (!run) {
            run = true;
            log[0] = 0;

            for (int i = 1; i < LOG; ++i) {
                for (int j = (1 << i); j < (1 << (i + 1)) && j < N; ++j)
                    log[j] = i;
            }
        }
    }
};
struct Sparse {
    int n, p = 0;
    int **t;

    Sparse(int _n) {
        SPARSE::init();
        n = _n;
        t = new int*[n];
        for (int i = 0; i < n; ++i)
            t[i] = new int[SPARSE::LOG];
    }

    void push(int x) {
        t[n - p - 1][0] = x;
        for (int i = 0; i < SPARSE::LOG - 1; ++i) {
            if (n - p - 1 + (1 << i) < n)
                t[n - p - 1][i + 1] = min(t[n - p - 1][i], t[n - p - 1 + (1 << i)][i]);
            else
                t[n - p - 1][i + 1] = t[n - p - 1][i];
        }
        p++;
    }

    int get(int l, int r) {
        int k = SPARSE::log[r - l];

        return min(t[l][k], t[r - (1 << k)][k]);
    }
};
#endif

#ifdef FEN
struct Fen {
    int *t, n;
    Fen(int _n) {
        n = _n;
        t = new int[n];

        memset(t, 0, t[0] * n);
    }

    void add(int i, int x) {
        for (;i < n; i = i | (i + 1))
            t[i] += x;
    }

    int get(int r) {
        r--;
        int res = 0;
        for (;r >= 0; r = (r & (r - 1)) - 1)
            res += t[r];
        return res;
    }
};
#endif

int median(int a, int b, int c) {
    vector<int> v = {a, b, c};

    sort(v.begin(), v.end());

    return v[1];
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n, t;
    cin >> n >> t;

    int check_group_max = 0;

    int a[n][2];
    for (int i = 0; i < n; ++i) {
        cin >> a[i][0];
        a[i][1] = a[i][0];
        check_group_max = max(check_group_max, a[i][0]);
    }

    int cnt = 0;

    if (check_group_max <= 2) {
        for (int i = 1, pr = 0; i < n; ++i) {
            if (a[i][0] == a[i - 1][0]) {
                if (pr != -1 && pr != i - 1) {
                    cnt = max(cnt, (i - pr - 1) / 2);

                    for (int j = pr + 1; j < (pr + 1 + i - 2) / 2; ++j)
                        a[j][1] = a[pr][0];
                    for (int j = 1 + (pr + 1 + i - 2) / 2; j < i; ++j)
                        a[j][1] = a[i][0];
                }
                pr = i;
            }

            if (i == n - 1 && pr != i) {
                cnt = max(cnt, (i - pr) / 2);

                for (int j = pr + 1; j < (pr + 1 + i - 1) / 2; ++j)
                    a[j][1] = a[pr][0];
                for (int j = 1 + (pr + 1 + i - 1) / 2; j < i; ++j)
                    a[j][1] = a[i][0];
            }
        }
    } else {
        return -1;
        int p = 0;
        a[0][1] = a[0][0];
        a[n - 1][1] = a[n - 1][0];

        while (true) {
            bool f = true;

            for (int i = 1; i < n - 1; ++i)
                a[i][p ^ 1] = median(a[i - 1][p], a[i][p], a[i + 1][p]), f = f & (median(a[i - 1][p], a[i][p],
                                                                                         a[i + 1][p]) == a[i][p]);

            if (f)
                break;
            else
                cnt++, p = p ^ 1;
        }

    }
    cout << cnt << "\n";

    if (t) {
        for (int i = 0; i < n; ++i)
            cout << a[i][1] << " ";
    }
    return 0;
}
