#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <algorithm>
#include <random>
#include <cassert>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <map>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <iomanip>
#include <bitset>
#include <stack>
#include <list>

#pragma warning (disable : 4996)
using namespace std;

#define all(a) (a).begin(), (a).end()
#define allr(a) (a).rbegin(), (a).rend()
#define nl '\n'
#define sz(a) (int)(a).size()
#define maxeq(a, b) (a) = max(a, b);
#define mineq(a, b) (a) = min(a, b);

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;

const int INF = numeric_limits<int>::max();
const ll LINF = numeric_limits<ll>::max();
const dl EPS = 1e-8;
const dl PI = acos(-1);
mt19937 rnd(5625445);
mt19937_64 rnd64(3465467567);

template <typename T, typename D>
istream& operator >> (istream& in, pair<T, D>& a) {
	in >> a.first >> a.second;
	return in;
}

template <typename T, typename D>
ostream& operator << (ostream& out, pair<T, D>& a) {
	out << a.first << " " << a.second;
	return out;
}

template <typename T>
istream& operator >> (istream& in, vector<T>& a) {
	for (auto& i : a)
		in >> i;
	return in;
}

void IO() {
#ifdef _SEVA
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _SEVA
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cout.setf(ios::fixed);
	cout.precision(10);
}

const int N = 5000 + 10;

void solve1(int n, int t, vector<int>& a) {
	vector<int> b(n);
	bool isAction = true;
	int ans = 0;
	while (isAction) {
		isAction = false;
		ans++;
		b[0] = a[0];
		for (int i = 1; i + 1 < n; i++) {
			b[i] = a[i - 1] + a[i] + a[i + 1]
				- max({ a[i - 1], a[i], a[i + 1] })
				- min({ a[i - 1], a[i], a[i + 1] });
			isAction |= b[i] != a[i];
		}
		b[n - 1] = a[n - 1];
		swap(a, b);
	}

	cout << ans - 1 << nl;
	for (int i = 0; i < n && t == 1; i++) {
		cout << a[i] << " ";
	}
}

int getVal(int pos, int timer, const vector<int>& a, const set<int>& stable) {
	if (stable.find(pos) != stable.end())
		return a[pos];
	if (timer & 1)
		return 3 - a[pos];
	else
		return a[pos];
}

void solve2(int n, int t, vector<int>& a) {
	set<int> stable;
	stable.insert(0);
	stable.insert(n - 1);
	for (int i = 1; i < n; i++) {
		if (a[i] == a[i - 1]) {
			stable.insert(i);
			stable.insert(i - 1);
		}
	}
	int ans = 0;
	for (auto it = stable.begin(); next(it) != stable.end(); it++) {
		maxeq(ans, (*next(it) - *it) / 2);
	}

	cout << ans << nl;
	if (t == 0)
		return;

	for (int i = 0; i < n; i++) {
		if (stable.find(i) != stable.end()) {
			cout << a[i] << " ";
		}
		auto it2 = stable.lower_bound(i);
		auto it1 = prev(it2);
		if (i - *it1 < *it2 - i) {
			cout << a[*it1] << " ";
		}
		else {
			cout << a[*it2] << " ";
		}
	}


}

int main() {
	IO();

	int n, t;
	cin >> n >> t;
	vector<int> a(n);
	cin >> a;

	if (n <= 1000)
		solve1(n, t, a);
	else
		solve2(n, t, a);
	return 0;
}
