#pragma region Include
#include<algorithm>
#include<iostream>
#include<assert.h>
#include<utility>
#include<fstream>
#include<vector>
#include<random>
#include<map>
using namespace std;
#pragma endregion
#pragma region Constant
const int N = 2e5, INF = 1e9, MOD = 1e9 + 7;
const long long llINF = 1e18;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (T& el : vec) {
		in >> el;
	}
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> const& vec) {
	for (T const& el : vec) {
		out << el << ' ';
	}
	return out;
}

template<typename T, typename P>
istream& operator >> (istream& in, pair<T, P>& p) {
	in >> p.first >> p.second;
	return in;
}

template<typename T, typename P>
ostream& operator << (ostream& out, pair<T, P> const& p) {
	out << p.first << ' ' << p.second;
}
#pragma endregion

bool simulate_change(int n, vector<int>& vec) {
	vector<int> n_vec(n);
	
	n_vec[0] = vec[0];
	n_vec[n - 1] = vec[n - 1];
	bool flag = false;
	
	for (int i = 1; i + 1 < n; i++) {
		vector<int> mid({ vec[i - 1], vec[i], vec[i + 1] });
		sort(mid.begin(), mid.end());
		n_vec[i] = mid[1];
		if (n_vec[i] != vec[i]) {
			flag = true;
		}
	}

	vec.swap(n_vec);
	return flag;
}

int solve_t0(int n, vector<int> v) {
	int spike_fst = 0, ans = 0;
	for (int i = 1; i + 1 < n; i++) {
		if (v[i] > max(v[i - 1], v[i + 1]) || v[i] < min(v[i - 1], v[i + 1])) {
			continue;
		} else {
			vector<int> n_v(v.begin() + spike_fst, v.begin() + i);
			spike_fst = i;
			if (n_v.size() > ans) {
				int cur_ans = 0;
				while (simulate_change(n_v.size(), n_v)) {
					++cur_ans;
				}
				ans = max(ans, cur_ans);
			}
		}
	}

	return ans;
}

int main() {
	//ifstream cin("input.txt");
	//ofstream cout("output.txt");
	
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, t;
	while (cin >> n >> t) {
		int cnt = 0;
		vector<int> v(n);
		cin >> v;

		if (t == 0) {
			cout << solve_t0(n, v) << '\n';
		} else {
			while (simulate_change(n, v)) {
				++cnt;
			}

			cout << cnt << '\n';
			if (t == 1) {
				cout << v << '\n';
			}
		}
	}
}
/*
7 1
1 3 2 4 2 3 1
7 0
1 3 2 4 2 3 1
*/