#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <ctime>
#include <stack>

using namespace std;
using ll = long long;
using ld = long double;

int med(int a, int b, int c)
{
	if ((a <= b && b <= c) || (c <= b && b <= a))
		return b;
	if ((a <= c && c <= b) || (b <= c && c <= a))
		return c;
	return a;
}

int main()
{

	srand(time(0));
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, t = 0;
	cin >> n >> t;

	vector<int> h(n);
	for (int i = 0; i < n; ++i)
		cin >> h[i];

	int ans = 0;

	if (n <= 1000)
	{
		while (true)
		{
			int cnt = 0;
			vector<int> newH = h;
			for (int i = 1; i < n - 1; ++i)
			{
				newH[i] = med(h[i - 1], h[i], h[i + 1]);
				if (h[i] != newH[i])
					cnt = 1;
			}

			if (cnt)
			{
				++ans;
				swap(h, newH);
			}
			else
				break;
		}
	}
	else
	{
		vector<int> stable;
		stable.push_back(0);
		for (int i = 1; i < n - 1; ++i)
			if (h[i] == h[i - 1] || h[i] == h[i + 1])
				stable.push_back(i);

		stable.push_back(n - 1);
		
		for (int i = 0; i < stable.size() - 1; ++i)
		{
			if (stable[i] + 1 == stable[i + 1])
				continue;

			int j = stable[i] + 1;
			while (j - stable[i] < stable[i + 1] - j)
				h[j] = h[stable[i]], ++j;

			ans = max(ans, j - stable[i]);
			while (j < stable[i + 1])
				h[j] = h[stable[i + 1]], ++j;
		}
	}

	cout << ans << "\n";
	if (t)
	{
		for (auto x : h)
			cout << x << " ";
	}

	return 0;
}