#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void update(vector<int> &cnt, vector<int> &v, int n, int i, int f = 1) {
    if (i < 0) {
        cnt[v[0]] += f;
    } else if (i >= n) {
        cnt[v[n - 1]] += f;
    } else {
        cnt[v[i]] += f;
    }
}

int get(vector<int> &cnt, int k) {
    for (int i = 0; i < cnt.size(); ++i) {
        if (cnt[i] >= k) {
            return i;
        }
        k -= cnt[i];
    }
}

vector<int> construct(vector<int> &v, int n, int k) {
    vector<int> res(n);
    vector<int> cnt(101);
    for (int i = -k; i <= k; ++i) {
        update(cnt, v, n, i);
    }
    res[0] = get(cnt, k + 1);
    for (int i = 1; i < n; ++i) {
        update(cnt, v, n, i - k - 1, -1);
        update(cnt, v, n, i + k);
        res[i] = get(cnt, k + 1);
    }
    return res;
}

bool check(vector<int> &v, int n, int mid) {
    auto last = construct(v, n, mid);
    for (int i = 1; i < n - 1; ++i) {
        vector<int> temp;
        for (int j = -1; j < 2; ++j) {
            temp.push_back(last[i + j]);
        }
        sort(temp.begin(), temp.end());
        if (temp[1] != last[i]) {
            return false;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, t;
    cin >> n >> t;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }

    int l = -1, r = 2 * n;
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        if (check(v, n, mid)) {
            r = mid;
        } else {
            l = mid;
        }
    }
    cout << r << endl;
    if (t == 1) {
        auto ans = construct(v, n, r);
        for (int i : ans) {
            cout << i << " ";
        }
        cout << endl;
    }
}