#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstdlib>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <bitset>
#include <cassert>
#define len(X) ((int)(X).size())
#ifdef __LOCAL
#define DBG(X) cout << "[DBG] " #X << ": " << (X) << '\n';
#else
#define DBG(X) 42;
#endif
using namespace std;
using ll = long long int;
using ull = unsigned long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const int INT_INF = (int)2e9;
const ll  LL_INF  = (ll)2e18;
const int NIL     = -1;
template<class T> ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}
void fastIO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}
const int MAXN = (int)5e5 + 7;
int a[MAXN], pa[MAXN], sz[MAXN], last[MAXN], n, t, answ = 0;
vector<pii> A;
int median(int a, int b, int c) {
	if(a > b) swap(a, b);
	if(a > c) swap(a, c);
	if(b > c) swap(b, c);
	return b;
}
int good(int a, int b, int c) {
	if(a <= b && b <= c) return 1;
	if(a >= b && b >= c) return 1;
	return 0;
}
int getParent(int v) {
	while(pa[v] != v) v = pa[v];
	return v;
}
int getNxt(int v) {
	int pv = getParent(v);
	return last[pv];
}
void upd(int pos) {
	if(pos > 0 && pos < n - 1) {
		A.emplace_back(pos, median(a[pos - 1], a[pos], a[pos + 1]));
	}
}
void linkUp(int pos) {
	int v = getParent(pos);
	int u = getParent(pos + 1);
	int x = last[u];
	if(v == u) return;
	if(sz[v] > sz[u]) swap(v, u);
	pa[v] = u;
	sz[u] += sz[v];
	last[u] = x;
}
void solve() {
	cin >> n >> t;
	for(int i = 0; i < n; ++i) cin >> a[i];
	for(int i = 0; i < n; ++i) {
		pa[i] = i;
		last[i] = i;
		sz[i] = 1;
	}
	int ch = 1;
	while(ch) {
		ch = 0;
		int pos = 0;
		A.clear();
		while(pos < n) {
			pos = getNxt(pos);
			upd(pos);
			upd(pos + 1);
			++pos;
		}
		for(auto& pr: A) {
			int id = pr.first;
			int val = pr.second;
			if(a[id] != val) ch = 1;
			a[id] = val;
		}
		answ += ch;
		if(ch) {
			pos = 0;
			while(pos < n) {
				pos = getNxt(pos);
				if(pos < n - 1) {
					int par1 = getParent(pos);
					int par2 = getParent(pos + 1);
					if(sz[par1] == 1 && sz[par2] == 1) {
						linkUp(pos);
					} else if(sz[par1] == 1) {
						if(pos < n - 2 && good(a[pos], a[pos + 1], a[pos + 2])) {
							linkUp(pos);
						}
					} else if(sz[par2] == 1) {
						if(pos > 0 && good(a[pos - 1], a[pos], a[pos + 1])) {
							linkUp(pos);
						}
					} else {
						if(good(a[pos - 1], a[pos], a[pos + 1]) && good(a[pos], a[pos + 1], a[pos + 2])) {
							linkUp(pos);
						}
					}
					par1 = getParent(pos);
					par2 = getParent(pos + 1);
					if(par1 != par2 && sz[par1] >= 3 && sz[par2] >= 3) {
						linkUp(pos);
					}
				}
				++pos;
			}
		}
		if(t > 1) {
			for(int i = 0; i < n; ++i) cout << a[i] << ' ';
			cout << '\n'; 
		}
	}
	cout << answ << '\n';
	if(t != 0) {
		for(int i = 0; i < n; ++i) cout << a[i] << ' ';
		cout << '\n'; 
	}
}
int main() {
	fastIO();
	solve();
	return 0;
}
