#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <iterator>
#include <iomanip>
#include <utility>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <climits>
#include <numeric>
#include <string>
#include <algorithm>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
using namespace std;
#define int long long
vector<bool> used, covered;
vector<int> matched;
vector<vector<int>> g;
bool trykuhn(int v) {
	used[v] = true;
	for (auto x : g[v]) {
		if (matched[x] == -1 || !used[matched[x]]) {
			used[x] = true;
			if (matched[x] == -1 || trykuhn(matched[x])) {
				matched[x] = v;
				return true;
			}
		}
	}
	return false;
}
struct fenwick {
	int n;
	vector<int> f;
	fenwick(int _n) {
		n = _n;
		f.assign(n, 0);
	}
	void add(int i, int val) {
		for (; i < n; i |= (i + 1))
			f[i] += val;
	}
	int getsum(int i) {
		int ans = 0;
		for (; i >= 0; i &= (i + 1), --i)
			ans += f[i];
		return ans;
	}
	int get(int L, int R) {
		return getsum(R) - getsum(L - 1);
	}
};
int med(int a, int b, int c) {
	if (a <= b && a <= c) {
		if (b <= c) return b;
		else return c;
	}
	if (b <= a && b <= c) {
		if (a <= c) return a;
		else return c;
	}
	if (c <= a && c <= b) {
		if (a <= b) return a;
		else return b;
	}
}
int n, t;
vector<int> go(vector<int> b) {
	vector<int> a(n);
	a[0] = b[0];
	a[n - 1] = b[n - 1];
	for (int i = 1; i < n - 1; ++i) {
		a[i] = med(b[i - 1], b[i], b[i + 1]);
	}
	return a;
}
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	srand(time(0));
	cin >> n >> t;
	vector<int> cur(n), a(n);
	for (int i = 0; i < n; ++i) {
		cin >> cur[i];
		a[i] = cur[i];
	}
	if (n <= 1000) {
		for (int cnt = 0;; ++cnt) {
			vector<int> newcur = go(cur);
			if (newcur == cur) {
				cout << cnt << '\n';
				if (t) {
					for (auto x : cur) cout << x << ' ';
				}
				return 0;
			}
			cur = newcur;
		}
	}
	int ans = 0, R;
	vector<int> ansex;
	for (int L = 0; L < n; L = max(R + 1, L + 1)) {
		R = L;
		int f = a[L] - 1;
		vector<int> cnt(2);
		cnt[f]++;
		while (R + 1 < n && a[R + 1] != a[R]) {
			R++;
			f = !f;
			cnt[f]++;
		}
		if (R <= L + 1) {
			ansex.push_back(a[L]);
			R = L;
			continue;
		}
		int mayans = 0;
		mayans = min(cnt[0], cnt[1]);
		if (cnt[0] == cnt[1]) mayans--;
		ans = max(ans, mayans);
		if (a[L] == a[R]) {
			for (int kek = 0; kek < cnt[0] + cnt[1]; ++kek)
				ansex.push_back(a[L]);
		} else {
			for (int kek = 0; kek < cnt[a[L] - 1]; ++kek)
				ansex.push_back(a[L]);
			for (int kek = 0; kek < cnt[a[R] - 1]; ++kek)
				ansex.push_back(a[R]);
		}
	}
	cout << ans << '\n';
	if (t == 1)
		for (auto x : ansex) cout << x << ' ';
}