#include <iostream>
#include <random>
#include <algorithm>
#include <vector>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run(int n, int t, int *a);
void two(int n, int t, int *a);

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    int n, t;
    cin >> n >> t;
    auto a = arr<int>(n);
    bool only_two = true;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        only_two = only_two && a[i] <= 2;
    }
    if (only_two) {
        two(n, t, a);
    } else {
        run(n, t, a);
    }
}

void two(int n, int t, int *a) {
    int st = 1;
    vector<pair<int, int>> seg;
    for (int i = 1; i < n; i++) {
        if (a[i] == a[i - 1] || i == n - 1) {
            seg.emplace_back(st, i - 1);
            st = i + 1;
        }
    }
    for (auto &p: seg) {
        if (a[p.first] == a[p.first - 1])
            p.first++;
        if (a[p.second] == a[p.second + 1])
            p.second--;
        //cerr << p.first << ' ' << p.second << endl;
    }
    int ans = 0;
    for (auto p: seg) {
        if (p.first > p.second)
            continue;
        //cerr << p.first << ' ' << p.second << endl;
        ans = max(ans, (p.second - p.first + 2) / 2);
        if ((p.second - p.first + 1) % 2 == 1) {
            int clr = a[p.first - 1];
            for (int i = p.first; i <= p.second; i++) {
                a[i] = clr;
            }
        } else {
            int k = (p.second + p.first + 1) / 2;
            for (int i = p.first; i < k; i++) {
                a[i] = a[p.first - 1];
            }
            for (int i = k; i <= p.second; i++) {
                a[i] = a[p.second + 1];
            }
        }
    }
    cout << ans << endl;
    if (t) {
        for (int i = 0; i < n; i++) {
            cout << a[i] << ' ';
        }
    }
}

void run(int n, int t, int *a) {
    auto b = arr<int>(n);
    int ans = 0;
    bool changed = true;
    while (changed) {
        changed = false;
        copy(a, a + n, b);
        for (int i = 1; i < n - 1; i++) {
            int p[3] = {b[i - 1], b[i], b[i + 1]};
            sort(p, p + 3);
            a[i] = p[1];
            changed = changed || a[i] != b[i];
        }
        ans += changed;
    }
    cout << ans << endl;
    if (t) {
        for (int i = 0; i < n; i++) {
            cout << a[i] << ' ';
        }
    }
}