#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>

using ll = long long;
using namespace std;

//#define int long long
#define rep(i, a, b) for (int i = (a); i < (b); ++i)
#define per(i, a, b) for (int i = (a) - 1; i >= (b); --i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair

int median(int a, int b, int c) {
    vector<int> tmp = { a, b, c };
    sort(all(tmp));
    return tmp[1];
}

void slow(int n, int t, vector<int>& a) {
    int cnt = 0;
    while (true) {
        vector<int> b = a;
        rep(i, 1, n - 1) b[i] = median(a[i - 1], a[i], a[i + 1]);
        bool flag = false;
        rep(i, 0, n) flag |= b[i] != a[i];
        cnt += flag, a = b;
        if (!flag) break;
    }
    cout << cnt << '\n';
    if (t) rep(i, 0, n) cout << a[i] << ' ';
}

int relax(int L, int R, vector<int>& a) {
    int len = R - L + 1;
    if (a[L] == 1) {
        if (len % 2) {
            rep(i, L, R + 1) a[i] = 2;
            return (len + 1) / 2;
        }
        rep(i, L, L + len / 2) a[i] = 2;
        rep(i, L + len / 2, R + 1) a[i] = 1;
        return len / 2;
    } else {
        if (len % 2) {
            rep(i, L, R + 1) a[i] = 1;
            return (len + 1) / 2;
        }
        rep(i, L, L + len / 2) a[i] = 1;
        rep(i, L + len / 2, R + 1) a[i] = 2;
        return len / 2;
    }
}

void low(int n, int t, vector<int>& a) {
    vector<int> pos;
    rep(i, 1, n - 1) {
        int m = median(a[i - 1], a[i], a[i + 1]);
        if (m != a[i]) pos.pb(i);
    }
    int ans = 0, L = -1;
    rep(i, 0, pos.size()) {
        if (L == -1) {
            L = pos[i];
            continue;
        }
        if (pos[i] == pos[i - 1] + 1) continue;
        ans = max(ans, relax(L, pos[i - 1], a));
        L = pos[i];
    }
    if (pos.size() != 0) ans = max(ans, relax(L, n - 2, a));
    cout << ans << '\n';
    if (t) rep(i, 0, n) cout << a[i] << ' ';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int n, t;
    cin >> n >> t;
    vector<int> a(n);
    rep(i, 0, n) cin >> a[i];
    if (n <= 10000) return slow(n, t, a), 0;
    int mx = *max_element(all(a));
    if (mx <= 2) return low(n, t, a), 0;
    rep(i, 0, n) cout << a[i] << ' ';
    cout << '\n';
}
