#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <random>


using namespace std;


vector<int> a;


bool sim(int l, int r) {
    vector<int> nv(r - l - 2);
    for (int i = l + 1; i < r - 1; ++i) {
        vector<int> vs = { a[i - 1], a[i], a[i + 1] };
        sort(vs.begin(), vs.end());

        nv[i - l - 1] = vs[1];
    }

    bool res = false;
    for (int i = l + 1; i < r - 1; ++i) {
        if (a[i] != nv[i - l - 1]) {
            res = true;
        }

        a[i] = nv[i - l - 1];
    }

    return res;
}


int solve(int l, int r) {
    if (r - l < 3) {
        return 0;
    }

    int maxv = 0;
    for (int i = l; i < r; ++i) {
        if (a[i] > maxv) {
            maxv = a[i];
        }
    }

    vector<int> mvi;

    for (int i = l; i < r; ++i) {
        if (a[i] == maxv) {
            mvi.push_back(i);
        }
    }

    return mvi.size();
}


int gl_solve(int l, int r) {
    if (r - l < 3) {
        return 0;
    }

    int res = 0;
    int last = l;
    for (int i = l; i < r - 1; ++i) {
        if (a[i] == a[i + 1]) {
            res = max(res, solve(last, i + 1));

            last = i + 1;
        }
    }

    if (last != l) {
        return max(res, solve(last, r));
    }

    if (!sim(l, r)) {
        return 0;
    }

    return 1 + solve(l, r);
}


const int SC = 10;


int n, t;


void answer(int c) {
    cout << c << '\n';

    if (t == 1) {
        for (int i = 0; i < n; ++i) {
            cout << a[i] << ' ';
        }
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> t;

    a.resize(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    for (int c = 0; c < SC; ++c) {
        if (!sim(0, n)) {
            answer(c);

            return 0;
        }
    }

    int answ = SC;

    int res = gl_solve(0, n);

    answer(answ + res);

    return 0;
}
