#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
#define pb push_back
#define all(arr) arr.begin(), arr.end()
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vi> vvi;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define forn1(i0, n0) for (int i0 = 1; i0 < n0; ++i0)
#define F first
#define S second

const int maxn = 5e5 + 3;
vll p1(maxn), p2(maxn);
const ll mod1 = 1e9 + 7, mod2 = 1e9 + 9;

vpll Hash(string s) {
    s = "#" + s;
    int n = s.length();
    vpll ans(n);
    ll h1 = 0, h2 = 0;
    forn(i, n) {
        ll x = s[i] - 'a' + 1;
        h1 = (h1 + p1[i] * x) % mod1;
        h2 = (h2 + p2[i] * x) % mod2;
        ans[i] = {h1, h2};
    }
    return ans;
}

pll get(vpll &h, int l, int r) {
    //cout << h.size() << endl;
    pll ans = h[r + 1];
    ans.F -= h[l].F;
    ans.S -= h[l].S;
    if (ans.F < 0) ans.F += mod1;
    if (ans.S < 0) ans.S += mod2;
    ans.F = (ans.F * p1[maxn - l - 1]) % mod1;
    ans.S = (ans.S * p2[maxn - l - 1]) % mod2;
    return ans;
}

bool palindrome(int n, vpll &h1, vpll &h2, int l, int r) {
    int l1 = l, r1 = (l + r) >> 1;
    int l2 = r1 + (r - l) % 2, r2 = r;
    l2 = n - l2 - 1, r2 = n - r2 - 1;
    swap(l2, r2);
    //cout << l << ' ' << r << ' ' << l1 << ' ' << r1 << ' ' << l2 << ' ' << r2 << endl;
    return (get(h1, l1, r1) == get(h2, l2, r2));
}

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main() {
    int n, t;
    cin >> n >> t;
    vi a(n);
    forn(i, n) cin >> a[i];
    if (n <= 1000){
        int ans = 0;
        while(true){
            bool flag = 0;
            vi a1(n);
            a1[0] = a[0];
            a1[n - 1] = a[n - 1];
            forn1(i, n - 1){
                vi x = {a[i - 1], a[i], a[i + 1]};
                sort(all(x));
                a1[i] = x[1];
                if (a1[i] != a[i]) flag = 1;
            }
            if (!flag) break;
            ans++;
            a = a1;
        }
        cout << ans << '\n';
        if (t){
            forn(i, n) cout << a[i] << ' ';
            cout << '\n';
        }
        return 0;
    }
    int l = -1;
    int ans = 0;
    forn1(i, n - 1){
        if (a[i] != a[i - 1] && a[i] != a[i + 1]){
            if (l == -1) l = i;
        } else {
            if (l != -1){
                int r = i - 1;
                int len = r - l + 1;
                ans = max(ans, (len + 1) / 2);
                if (len % 2 == 1){
                    for (int k = l; k <= r; ++k) a[k] = a[l - 1];
                } else {
                    for (int k = 0; k < len / 2; ++k){
                        a[l + k] = a[l - 1];
                        a[l + k + len / 2] = a[r + 1];
                    }
                }
            }
            l = -1;
        }
    }
    if (l != -1){
        int r = n - 2;
        int len = r - l + 1;
        ans = max(ans, (len + 1) / 2);
        if (len % 2 == 1){
            for (int k = l; k <= r; ++k) a[k] = a[l - 1];
        } else {
            for (int k = 0; k < len / 2; ++k){
                a[l + k] = a[l - 1];
                a[l + k + len / 2] = a[r + 1];
            }
        }
    }
    cout << ans << '\n';
    if (t){
        forn(i, n) cout << a[i] << ' ';
        cout << '\n';
    }
    return 0;
}