#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

template<typename T>
using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//cout.setf(ios::fixed);
	//cout.precision(20);
	#ifndef _offline
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
	#endif
}

const int INF = 1e9 + 7;
const int MAXN = 5e5 + 100;
int arr[MAXN], tmp[MAXN], mm[MAXN], n, ans = 0;
bool st[MAXN];

int get_mn(int l, int r) {
	int res = INF;
	for (int i = l; i <= r; i += 2) {
		if (i < 0 || i >= n) {
			continue;
		}
		res = min(res, arr[i]);
	}
	return res;
}

int get_mx(int l, int r) {
	int res = 0;
	for (int i = l; i <= r; i += 2) {
		if (i < 0 || i >= n) {
			continue;
		}
		res = max(res, arr[i]);
	}
	return res;
}

void get(int i, int l, int f) {
	if ((i - l) % 2 == f) {
		int bl = -1, br = n, mid;
		while (bl + 1 < br) {
			mid = (bl + br) >> 1;
			int c = mid * 2;
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				br = mid;
				continue;
			} 
			int y = get_mn(lf, rg);
			int x = (st[i - 1] ? arr[i - 1] : get_mx(i - 1 - c, i - 1 + c));
			int z = (st[i + 1] ? arr[i + 1] : get_mx(i + 1 - c, i + 1 + c));
			if (min(x, z) <= y && y <= max(x, z)) {
				br = mid;
			}
			else {
				bl = mid;
			}
		}
		mm[i] = 2 * br;
		bl = -1, br = n;
		while (bl + 1 < br) {
			mid = (bl + br) >> 1;
			int c = mid * 2 + 1;
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				br = mid;
				continue;
			} 
			int y = get_mx(lf, rg);
			int x = (st[i - 1] ? arr[i - 1] : get_mn(i - 1 - c, i - 1 + c));
			int z = (st[i + 1] ? arr[i + 1] : get_mn(i + 1 - c, i + 1 + c));
			if (min(x, z) <= y && y <= max(x, z)) {
				br = mid;
			}
			else {
				bl = mid;
			}
		}
		mm[i] = min(mm[i], 2 * br + 1);
	}
	else {
		int bl = -1, br = n, mid;
		while (bl + 1 < br) {
			mid = (bl + br) >> 1;
			int c = mid * 2;
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				br = mid;
				continue;
			} 
			int y = get_mx(lf, rg);
			int x = (st[i - 1] ? arr[i - 1] : get_mn(i - 1 - c, i - 1 + c));
			int z = (st[i + 1] ? arr[i + 1] : get_mn(i + 1 - c, i + 1 + c));
			if (min(x, z) <= y && y <= max(x, z)) {
				br = mid;
			}
			else {
				bl = mid;
			}
		}
		mm[i] = 2 * br;
		bl = -1, br = n;
		while (bl + 1 < br) {
			mid = (bl + br) >> 1;
			int c = mid * 2 + 1;
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				br = mid;
				continue;
			} 
			int y = get_mn(lf, rg);
			int x = (st[i - 1] ? arr[i - 1] : get_mx(i - 1 - c, i - 1 + c));
			int z = (st[i + 1] ? arr[i + 1] : get_mx(i + 1 - c, i + 1 + c));
			if (min(x, z) <= y && y <= max(x, z)) {
				br = mid;
			}
			else {
				bl = mid;
			}
		}
		mm[i] = min(mm[i], 2 * br + 1);
	}
}

void solve(int l, int r) {
	for (int i = l + 1; i < r; ++i) {
		mm[i] = -1;
	}
	int f = 1;
	if (arr[l + 1] < arr[l]) {
		f ^= 1;
	}
	for (int i = l + 1; i < r; ++i) {
		get(i, l, f);
	}
}

void work() {
	for (int i = 1; i < n - 1; ++i) {
		vector<int> v = {arr[i - 1], arr[i], arr[i + 1]};
		sort(all(v));
		tmp[i] = v[1];
	}
	for (int i = 1; i < n - 1; ++i) {
		arr[i] = tmp[i];
	}
}

signed main() {
	FAST_IO();
	int t;
	cin >> n >> t;
	for (int i = 0; i < n; ++i) {
		cin >> arr[i];
	}
	int ans = 0;
	st[0] = st[n - 1] = true;
	while (true) {
		for (int i = 1; i < n - 1; ++i) {
			if (arr[i] >= min(arr[i - 1], arr[i + 1]) && arr[i] <= max(arr[i - 1], arr[i + 1])) {
				st[i] = true;
			}
			else {
				st[i] = false;
			}
		}
		solve(0, n - 1);
		bool any = false;
		int l = -1;
		int mn = INF;
		for (int i = 0; i < n; ++i) {
			if (st[i]) {
				if (l != -1) {
					any = true;
					solve(l, i);
					for (int j = l + 1; j < i; ++j) {
						mn = min(mn, mm[j]);
					} 
				}
				l = -1;
			}
			else if (l == -1) {
				l = i - 1;
			}
		}
		if (!any) {
			break;
		}
		ans += mn;
		while (mn > 0) {
			work();
			mn--;
		}
	}
	cout << ans << '\n';
	if (t == 1) for (int i = 0; i < n; ++i) {
		cout << arr[i] << ' ';
	}
}