#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef pair<ld, ld> pld;

template<typename T>
using kawaii_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define all(x) (x).begin(), (x).end()

void FAST_IO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	//cout.setf(ios::fixed);
	//cout.precision(20);
	#ifndef _offline
		//freopen("input.txt", "r", stdin);
		//freopen("output.txt", "w", stdout);
	#endif
}

const int INF = 1e9 + 7;
const int MAXN = 5e5 + 100;
int arr[MAXN], brr[MAXN], tmp[MAXN], mm[MAXN], n, ans = 0;
bool st[MAXN];

int get_mn(int l, int r) {
	int res = INF;
	for (int i = l; i <= r; i += 2) {
		if (i < 0 || i >= n) {
			continue;
		}
		res = min(res, arr[i]);
	}
	return res;
}

int get_mx(int l, int r) {
	int res = 0;
	for (int i = l; i <= r; i += 2) {
		if (i < 0 || i >= n) {
			continue;
		}
		res = max(res, arr[i]);
	}
	return res;
}

int check(int i, int l, int f, int c) {
	if ((i - l) % 2 == f) {
		int x = -1, y = -1, z = -1;
		if (c % 2 == 0) {
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				return y;
			} 
			y = get_mn(lf, rg);
			x = (c > mm[i - 1] ? brr[i - 1] : get_mx(i - 1 - c, i - 1 + c));
			z = (c > mm[i + 1] ? brr[i + 1] : get_mx(i + 1 - c, i + 1 + c));
			if (min(x, z) <= y && y <= max(x, z)) {
				return y;
			}
		}
		else {
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				return y;
			} 
			y = get_mx(lf, rg);
			x = (c > mm[i - 1] ? brr[i - 1] : get_mn(i - 1 - c, i - 1 + c));
			z = (c > mm[i + 1] ? brr[i + 1] : get_mn(i + 1 - c, i + 1 + c));
			if (min(x, z) <= y && y <= max(x, z)) {
				return y;
			}
		}
	}
	else {
		int x = -1, y = -1, z = -1;
		if (c % 2 == 1) {
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				return y;
			} 
			y = get_mn(lf, rg);
			x = (c > mm[i - 1] ? brr[i - 1] : get_mx(i - 1 - c, i - 1 + c));
			z = (c > mm[i + 1] ? brr[i + 1] : get_mx(i + 1 - c, i + 1 + c));
			if (min(x, z) <= y && y <= max(x, z)) {
				return y;
			}
		}
		else {
			int lf = i - c, rg = i + c;
			if (lf < 0 || rg >= n) {
				return y;
			}  
			y = get_mx(lf, rg);
			x = (c > mm[i - 1] ? brr[i - 1] : get_mn(i - 1 - c, i - 1 + c));
			z = (c > mm[i + 1] ? brr[i + 1] : get_mn(i + 1 - c, i + 1 + c));
			if (min(x, z) <= y && y <= max(x, z)) {
				return y;
			}
		}
	}
	return -1;
}

void solve(int l, int r) {
	for (int i = l + 1; i < r; ++i) {
		mm[i] = INF;
	}
	for (int c = 1; ; ++c) {
		if (l + 1 > r - 1) {
			break;
		}
		int f = 1;
		if (arr[l + 1] < arr[l]) {
			f ^= 1;
		}
		int lf = l + 1, rg = r - 1;
		while (lf <= rg) {
			int x = check(lf, l, f, c);
			if (x != -1) {
				mm[lf] = c;
				brr[lf] = x;
				lf++;
				continue;
			}
			x = check(rg, l, f, c);
			if (x != -1) {
				mm[rg] = c;
				brr[rg] = x;
				rg--;
				continue;
			}
			break;
		}
		l = lf - 1;
		r = rg + 1;
	}
}

void work() {
	for (int i = 1; i < n - 1; ++i) {
		vector<int> v = {arr[i - 1], arr[i], arr[i + 1]};
		sort(all(v));
		tmp[i] = v[1];
	}
	for (int i = 1; i < n - 1; ++i) {
		arr[i] = tmp[i];
	}
}

signed main() {
	FAST_IO();
	int t;
	cin >> n >> t;
	for (int i = 0; i < n; ++i) {
		cin >> arr[i];
	}
	st[0] = st[n - 1] = true;
	brr[0] = arr[0];
	brr[n - 1] = arr[n - 1];
	for (int i = 1; i < n - 1; ++i) {
		if (arr[i] >= min(arr[i - 1], arr[i + 1]) && arr[i] <= max(arr[i - 1], arr[i + 1])) {
			st[i] = true;
		}
		if (st[i]) {
			brr[i] = arr[i];
		}
	}
	int l = -1;
	for (int i = 0; i < n; ++i) {
		if (st[i]) {
			if (l != -1) {
				solve(l, i);
			}
			l = -1;
		}
		else if (l == -1) {
			l = i - 1;
		}
	}
	int mx = 0;
	for (int i = 0; i < n; ++i) {
		mx = max(mx, mm[i]);
	}
	cout << mx << '\n';
	if (t == 1) for (int i = 0; i < n; ++i) {
		cout << brr[i] << ' ';
	}
}