#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

struct stn{
    bool v = false;
    int s = -1;
    int e = -1;
};

void build(std::vector<stn>& segt, int i){
    if (i == 0){
        return;
    }
    stn& p = segt[i];
    if (2 * i >= segt.size()){
        p.v = true;
        build(segt, i / 2);
    }
    else{
        stn& r = segt[i * 2 + 1];
        stn& l = segt[i * 2];
        if (r.v and l.v){
            p.v = true;
            p.s = std::min(r.s, l.s);
            p.e = std::max(r.e, l.e);
            build(segt, i / 2);
        }
    }
}

void update(std::vector<stn>& segt, int i){
    if (i == 0){
        return;
    }
    stn& p = segt[i];
    p.v = false;
    update(segt, i / 2);
}

std::pair<int, int> get_left(std::vector<stn>& segt, int i){
    stn& p = segt[i];
    if (p.v){
        return {p.s, p.e};
    }
    if (2 * i >= segt.size()) {
        return {-1, -1};
    }
    stn& l = segt[2 * i];
    stn& r = segt[2 * i + 1];
    if (l.v){
        std::pair<int, int> d = get_left(segt, 2 * i + 1);
        if (d.second != -1){
            return {l.s, d.second};
        }
        return {l.s, l.e};
    }
    else{
        return get_left(segt, 2 * i);
    }

}

std::pair<int, int> get_right(std::vector<stn>& segt, int i){
    stn& p = segt[i];
    if (p.v){
        return {p.s, p.e};
    }
    if (2 * i >= segt.size()) {
        return {-1, -1};
    }
    stn& l = segt[2 * i];
    stn& r = segt[2 * i + 1];
    if (r.v){
        std::pair<int, int> d = get_right(segt, 2 * i);
        if (d.first != -1){
            return {d.first, r.e};
        }
        return {r.s, r.e};
    }
    else{
        return get_left(segt, 2 * i + 1);
    }

}

std::vector<std::pair<int, int>> get_segs(std::vector<stn>& segt, int i){
//    stn& p = segt[i];
//    if (p.v){
//        return {{p.s, p.e}};
//    }
//    if (2 * i >= segt.size()){
//        return {};
//    }
//    stn& l = segt[2 * i ];
//    stn& r = segt[2 * i + 1];
//    if (l.v){
//        auto ans = get_segs(segt, 2 * i + 1);
//        std::pair<int, int> rls = get_left(segt, 2 * i + 1);
//        if (rls.second != -1){
//            ans.emplace_back(l.s, rls.second);
//        }
//        else{
//            ans.emplace_back(l.s, l.e);
//        }
//        return ans;
//    }
//    if (r.v){
//        auto ans = get_segs(segt, 2 * i);
//        std::pair<int, int> lrs = get_right(segt, 2 * i);
//        if (lrs.first != -1){
//            ans.emplace_back(lrs.first, r.e);
//        }
//        else{
//            ans.emplace_back(r.s, r.e);
//        }
//        return ans;
//    }
//    auto ans1 = get_segs(segt, 2 * i);
//    auto ans2 = get_segs(segt, 2 * i + 1);
//    std::copy(ans2.begin(), ans2.end(), std::back_inserter(ans1));
//    return ans1;
    stn& p = segt[i];
    if (2 * i >= segt.size()){
        return {};
    }
    if (p.v){
        return {{p.s, p.e}};
    }
    stn& l = segt[2 * i];
    stn& r = segt[2 * i + 1];

    std::pair<int, int> lrs = get_right(segt, 2 * i);
    std::pair<int, int> rls = get_left(segt, 2 * i + 1);

    std::pair<int, int> ap = {lrs.first, rls.second};
    if (ap.first == -1){
        ap.first = rls.first;
    }
    if (ap.second == -1){
        ap.second = lrs.second;
    }
    std::vector<std::pair<int, int>> ans;
    if (ap.first != -1 and ap.second != -1) {
        ans.push_back(ap);
    }
    if (!l.v){
        auto ans2 = get_segs(segt, 2 * i);
        std::copy(ans2.begin(), ans2.end(), std::back_inserter(ans));
    }
    if (!r.v){
        auto ans2 = get_segs(segt, 2 * i + 1);
        std::copy(ans2.begin(), ans2.end(), std::back_inserter(ans));
    }

    return ans;
}

int main() {
    int n, t;
    std::cin >> n >> t;
    std::vector<int> mr(n);
//    int n2 = std::pow(2, ceil(log2(n)));
//    std::vector<stn> segt(2 * n2);
//    for (int i = 0; i < n; i++){
//        segt[n2 + i].s = i;
//        segt[n2 + i].e = i;
//        build(segt, n2 + i);
//    }
//    update(segt, n2);
//    update(segt, n2 + n - 1);

    for (int i = 0; i < n;i++){
        std::cin >> mr[i];
    }
    std::vector<bool> change(n, 1);
    change[0] = false;
    change[n - 1] = false;

    bool bDone;
    int c = 0;
    do{
        bDone = true;
        std::vector<int> nmr = mr;
        for (int i = 0; i < n; i++){
            if (! change[i]){
                continue;
            }
            if (mr[i] < mr[i-1] and mr[i] < mr[i+1]){
                    nmr[i] = std::min(mr[i + 1], mr[i - 1]);
                    bDone = false;
                }
            else if (mr[i] > mr[i-1] and mr[i] > mr[i+1]){
                    nmr[i] = std::max(mr[i + 1], mr[i - 1]);
                    bDone = false;
                }
            else{
                change[i] = false;
            }

        }
//        std::vector<bool> change(n, false);
//        for (auto& s : get_segs(segt, 1)){
//            std::cout << "print s " << s.first << " " << s.second << std::endl;
//            for (int i = s.first; i <= s.second; i++){
//                if (mr[i] < mr[i-1] and mr[i] < mr[i+1]){
//                    nmr[i] = std::min(mr[i + 1], mr[i - 1]);
//                    change[i] = true;
//                    bDone = false;
//                }
//                else if (mr[i] > mr[i-1] and mr[i] > mr[i+1]){
//                    nmr[i] = std::max(mr[i + 1], mr[i - 1]);
//                    change[i] = true;
//                    bDone = false;
//                }
//            }
//        }
//        for (int i = 0; i < n; i++){
//            if (change[i]){
//                continue;
//            }
//            update(segt, n2 + i);
//        }
        mr = nmr;
        c += !bDone;

    } while(!bDone);

    std::cout << c << std::endl;
    if (t){
        std::cout << mr[0];
        for (int i = 1; i < n; i++){
            std::cout << " " << mr[i];
        }
        std::cout << std::endl;
    }

    return 0;
}