#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstring>
#include <ctime>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stdio.h>
#include <string>
#include <vector>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 0

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, int> pli;
typedef pair<ll, ll> pll;

void solve();

const ll MAXN = 3e5 + 7;
const ll INF = 2e9 + 11;
const ll MOD = 1e9 + 9;
const ll INF1 = 9e18;
const ld EPS = 1e-8;

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    if (multi_test) cin >> q;
    while (q--) solve();
}

/*----------------------------------------------------------------------------*/

bool subtask1(int n, int t, const vector<int> &v) {
    return n <= 1000;
}

int med(vector<int> v) {
    sort(all(v));
    return v[1];
}

bool subtask2(int n, int t, const vector<int> &v) {
    for (int i = 0; i < n; ++i)
        if (v[i] > 2)
            return false;
    return true;
}

void solve() {
    int n, t;
    cin >> n >> t;
    vector<int> a(n);
    for (int &i : a)
        cin >> i;
    if (subtask1(n, t, a)) {
        for (int i = 0; ; ++i) {
            vector<int> b(n);
            b[0] = a[0];
            b[n - 1] = a[n - 1];
            for (int i = 1; i < n - 1; ++i) {
                b[i] = med({ a[i - 1], a[i], a[i + 1] });
            }
            if (a == b) {
                cout << i << '\n';
                if (t == 1) {
                    for (int j : a)
                        cout << j << ' ';
                    cout << '\n';
                }
                exit(0);
            }
            else {
                a = b;
            }
        }
    }
    else {
        int ans = 0;
        vector<int> vans = a;
        vector<int> cur;
        for (int i = 1; i < n - 1; ++i) {
            if (a[i - 1] == a[i + 1] && a[i - 1] != a[i]) {
                cur.push_back(a[i - 1]);
                while (i < n - 1 && a[i - 1] == a[i + 1] && a[i - 1] != a[i]) {
                    cur.push_back(a[i++]);
                }
                cur.push_back(a[i++]);
                ans = max(ans, (int)(cur.size() - 1) / 2);
                for (int j = i - (int)cur.size(); j < i; ++j) {
                    if (cur[0] == cur.back()) {
                        vans[j] = cur[0];
                    } else {
                        if (j - i + (int)cur.size() < cur.size() / 2)
                            vans[j] = cur[0];
                        else
                            vans[j] = cur.back();
                    }
                }
                cur.clear();
            }
        }
        cout << ans << '\n';
        if (t == 1) {
            for (int i : vans)
                cout << i << ' ';
            cout << '\n';
        }
    }
}