#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (1 << 17);

void IOOptimize() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
}

void Small(int n, int t) {
	vector <int> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	int k = 0;
	while (true) {
#ifdef LOCAL
		for (auto i : v)
			cout << i << " ";
		cout << endl;
#endif
		vector <int> t(n);
		t[0] = v[0];
		t.back() = v.back();
		for (int i = 1; i + 1 < v.size(); i++) {
			vector <int> q = { v[i - 1], v[i], v[i + 1] };
			sort(q.begin(), q.end());
			t[i] = q[1];
		}
		if (t != v) {
			v = t, k++;
		}
		else break;
	}
	cout << k << endl;
	if (t == 1) {
		for (auto i : v)
			cout << i << " ";
	}
}

int answ = 0;
vector <int> result;

void SolveForSeg(int l, int r) {
	answ = max(answ, (-l + r) / 2);
	if ((-l + r - 1) % 2 == 0) {
		for (int t = l; t <= (l + r) / 2; t++)
			result[t] = result[l];
		for (int t = (l + r) / 2 + 1;t < r; t++)
			result[t] = result[r];
	}
	else for (int i = l; i < r; i++)
		result[i] = result[r];
}

void Solve() {
	int n, t;
	cin >> n >> t;
	if (n <= 1000) {
		Small(n, t);
		return;
	}
	vector <int> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i];
	}
	result = v;
	int st = 0;
	while (st + 1 < v.size()) {
		int i = st;
		while (i + 1 < v.size()) {
			if (v[st] < v[st + 1]) {
				if ((i - st) % 2 == 0 && v[i] < v[i + 1])
					i++;
				else if ((i - st) % 2 == 1 && v[i] > v[i + 1])
					i++;
				else break;
			}
			else if (v[st] > v[st + 1]) {
				if ((i - st) % 2 == 0 && v[i] > v[i + 1])
					i++;
				else if ((i - st) % 2 == 1 && v[i] < v[i + 1])
					i++;
				else break;
			}
			else {
				i++;
				break;
			}
		}
		SolveForSeg(st, i);
		st = i;
	}
	cout << answ << endl;
	if (t) {
		for (auto i : result)
			cout << i << " ";
	}
}

int main() {
	IOOptimize();
	Solve();
}