#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

void update(vector<int> &cnt, vector<int> &v, int n, int i, int f = 1) {
    if (i < 0) {
        cnt[v[0]] += f;
    } else if (i >= n) {
        cnt[v[n - 1]] += f;
    } else {
        cnt[v[i]] += f;
    }
}

int get(vector<int> &cnt, int k) {
    for (int i = 0; i < cnt.size(); ++i) {
        if (cnt[i] >= k) {
            return i;
        }
        k -= cnt[i];
    }
}

vector<int> construct(vector<int> &v, int n, int k) {
    vector<int> res(n);
    vector<int> cnt(101);
    for (int i = -k; i <= k; ++i) {
        update(cnt, v, n, i);
    }
    res[0] = get(cnt, k + 1);
    for (int i = 1; i < n; ++i) {
        update(cnt, v, n, i - k - 1, -1);
        update(cnt, v, n, i + k);
        res[i] = get(cnt, k + 1);
    }
    return res;
}

bool check(vector<int> &v, int n, int mid) {
    auto last = construct(v, n, mid);
    for (int i = 1; i < n - 1; ++i) {
        vector<int> temp;
        for (int j = -1; j < 2; ++j) {
            temp.push_back(last[i + j]);
        }
        sort(temp.begin(), temp.end());
        if (temp[1] != last[i]) {
            return false;
        }
    }
    return true;
}

void solve(vector<int> &v, int &ansk) {
    int n = v.size();
    int l = -1, r = 2 * n;
    while (l + 1 < r) {
        int mid = (l + r) / 2;
        if (check(v, n, mid)) {
            r = mid;
        } else {
            l = mid;
        }
    }
    ansk = max(ansk, r);
    auto ans = construct(v, n, r);
    v.swap(ans);
}

bool f(vector<int> &v, int n) {
    bool f = false;
    vector<int> new_v(n);
    new_v[0] = v[0];
    new_v[n - 1] = v[n - 1];
    for (int i = 1; i < n - 1; ++i) {
        vector<int> temp;
        for (int j = -1; j < 2; ++j) {
            temp.push_back(v[i + j]);
        }
        sort(temp.begin(), temp.end());
        new_v[i] = temp[1];
        if (new_v[i] != v[i]) {
            f = true;
        }
    }
    swap(v, new_v);
    return f;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, t;
    cin >> n >> t;
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
    }

    if (n <= 1000) {
        int ans = 0;
        while (true) {
            if (!f(v, n)) {
                break;
            }

            ans++;
        }
        cout << ans << endl;
        for (auto i : v) {
            cout << i << " ";
        }
        cout << endl;
        return 0;
    }

    if (n == 1) {
        cout << 0 << endl;
        if (t) {
            cout << v[0] << endl;
        }
        return 0;
    }

    int ansk = 0;
    int st = 0;
    vector<int> v2;
    for (int i = 0; i < n; ++i) {
        v2.push_back(v[i]);
        if (v2.size() < 2) {
            continue;
        }
        if (i < n - 1 && v[i] == v[i + 1]) {
            solve(v2, ansk);
            for (int j = 0; j < v2.size(); ++j) {
                v[st + j] = v2[j];
            }
            st = i + 1;
            v2.clear();
        }
    }
    solve(v2, ansk);
    for (int j = 0; j < v2.size(); ++j) {
        v[st + j] = v2[j];
    }
    v2.clear();


    cout << ansk << endl;
    if (t == 1) {
        for (int i : v) {
            cout << i << " ";
        }
        cout << endl;
    }
}