#include <algorithm>
#include <iostream>
#include <vector>

using namespace std;

typedef int64_t ll;

vector<ll> a;

ll get(ll left, ll right) {
	if (right - left <= 1) {
		return 0;
	}
	vector<ll> cord;
	for (ll i = left; i <= right; ++i) {
		cord.emplace_back(a[i]);
	}
	sort(cord.begin(), cord.end());
	cord.resize(unique(cord.begin(), cord.end()) - cord.begin());
	if (cord.size() == 2) {
		bool flag = false;
		for (ll i = left + 1; i <= right; ++i) {
			if (a[i - 1] == a[i]) {
				flag = true;
				break;
			}
		}
		if (!flag) {
			if (a[left] == a[right]) {
				ll cnt = 0;
				for (ll i = left; i <= right; ++i) {
					if (a[i] != a[left]) {
						++cnt;
					}
					a[i] = a[left];
				}
				return cnt;
			}
			for (ll i = left; i <= (left + right) / 2; ++i) {
				a[i] = a[left];
			}
			for (ll i = (left + right) / 2 + 1; i <= right; ++i) {
				a[i] = a[right];
			}
			return (right - left) / 2;
		}
	}
	for (ll i = left; i <= right; ++i) {
		a[i] = lower_bound(cord.begin(), cord.end(), a[i]) - cord.begin();
	}
	ll result = 0;
	vector<pair<ll, ll>> update;
	for (ll i = left + 1; i < right; ++i) {
		if (a[i] > a[i + 1] && a[i] > a[i - 1]) {
			update.emplace_back(i, max(a[i - 1], a[i + 1]));
		}
		if (a[i] < a[i + 1] && a[i] < a[i - 1]) {
			update.emplace_back(i, min(a[i - 1], a[i + 1]));
		}
	}
	if (update.empty()) {
		for (ll i = left; i <= right; ++i) {
			a[i] = cord[a[i]];
		}
		return 0;
	}
	for (auto i : update) {
		a[i.first] = i.second;
	}
	ll begin = left;
	for (ll i = left + 1; i <= right; ++i) {
		if (a[i] == a[i - 1]) {
			result = max(result, 1 + get(begin, i - 1));
			begin = i;
		}
	}
	result = max(result, 1 + get(begin, right));
	for (ll i = left; i <= right; ++i) {
		a[i] = cord[a[i]];
	}
	return result;
}

int main() {
	ll n, t;
	cin >> n >> t;
	a.resize(n);
	for (ll i = 0; i < n; ++i) {
		cin >> a[i];
	}

	cout << get(0, n - 1) << endl;
	if (t) {
		for (ll i : a) {
			cout << i << " ";
		}
		cout << endl;
	}
	return 0;
}
