#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,mmx,avx,avx2")
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pll pair<ll, ll>

mt19937 rnd;

ll const N = 2e5 + 1, M = 228228227, INF = 1e18, P = 257;
ld const EPS = 1e-10;

void FastIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

void zfunc(string s) {
    vector<ll> z(s.size(), 0);
    ll l = 0, r = 0;
    for (int i = 1; i < s.size(); ++i) {
        if (r >= i) {
            z[i] = min(z[i - l], r - i + 1);
        }

        while (i + z[i] < s.size() && s[z[i]] == s[i + z[i]]) {
            ++z[i];
        }

        if (i + z[i] - 1 > r) {
            r = i + z[i] - 1;
            l = i;
        }
    }
}

void pfunc(string s) {
    vector<ll> p(s.size(), 0);
    for (int i = 1; i < s.size(); ++i) {
        ll j = p[i - 1];
        while (j > 0 && s[i] != s[j]) {
            j = p[j - 1];
        }
        if (s[i] == s[j]) {
            ++j;
        }
        p[i] = j;
    }
}

ll tree[4 * N], mode[4 * N];

void Build(ll v, ll l , ll r) {
    if (r - l == 1) {
        tree[v] = 0;
    }

    ll m = (l + r) / 2;
    Build(v * 2, l, m);
    Build(v * 2 + 1, m, r);
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

void Upd(ll v, ll l, ll r, ll pos, ll val) {
    if (r - l == 1 && l == pos) {
        tree[v] = val;
        return;
    }

    if (l > pos || r <= pos) {
        return;
    }

    ll m = (l + r) / 2;
    Upd(v * 2, l, m, pos, val);
    Upd(v * 2 + 1, m, r, pos, val);
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

ll Get(ll v, ll l, ll r, ll ql, ll qr) {
    if (l >= qr || r <= ql) {
        return 0;
    }

    if (l >= ql && r <= qr) {
        return tree[v];
    }

    ll m = (l + r) / 2;
    return Get(v * 2, l, m, ql, qr) + Get(v * 2 + 1, m, r, ql, qr);
}

struct Node {
    ll x, sz, pr;
    Node* left = nullptr;
    Node* right = nullptr;
    Node() {}
    Node(ll _x) {
        x = _x;
        sz = 1;
        pr = rnd();
    }
};

ll GetSz(Node* tree) {
    return (tree ? tree->sz : 0);
}

void Update(Node* tree) {
    tree->sz = GetSz(tree->left) + GetSz(tree->right) + 1;
}

Node* Merge(Node* left, Node* right) {
    if (! left) {
        return right;
    }
    if (! right) {
        return left;
    }

    if (left->pr > right->pr) {
        left->right = Merge(left->right, right);
        Update(left);
        return left;
    }
    else {
        right->left = Merge(left, right->left);
        Update(right);
        return right;
    }
}

pair<Node*, Node*> Split(Node* tree, ll x) {
    if (! tree) {
        return {tree, tree};
    }

    if (GetSz(tree->left) == x - 1) {
        auto tmp = tree->right;
        tree->right = nullptr;
        Update(tree);
        return {tree, tmp};
    }
    else if (GetSz(tree->left) > x - 1) {
        auto tmp = Split(tree->left, x);
        tree->left = tmp.second;
        Update(tree);
        return {tmp.first, tree};
    }
    else {
        auto tmp = Split(tree->right, x - GetSz(tree->left) - 1);
        tree->right = tmp.first;
        Update(tree);
        return {tree, tmp.second};
    }
}

Node* Ins(Node* tree, ll x, ll pos) {
    Node* node = new Node(x);
    auto tmp = Split(tree, pos - 1);
    return Merge(Merge(tmp.first, node), tmp.second);
}

int main() {
    FastIO();

    ll n, t;
    cin >> n >> t;
    vector<ll> v(n);
    bool flag = true;
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        if (v[i] > 2) {
            flag = false;
        }
    }

    if (flag) {
        ll ind = 0;
        vector<ll> tmp;
        while (ind < n) {
            ll was = ind;
            while (ind < n - 1 && v[ind] != v[ind + 1]) {
                ++ind;
            }
            ++ind;
            tmp.push_back(ind - was);
        }

        ll mx = 0;
        for (int i = 0; i < tmp.size(); ++i) {
            mx = max(mx, tmp[i]);
        }

        if (mx < 3) {
            cout << 0 << '\n';
        }
        else {
            cout << (mx + 1) / 2 - 1 << '\n';
        }

        if (t) {
            ll cur = 0;
            for (int i = 0; i < tmp.size(); ++i) {
                if (tmp[i] % 2) {
                    for (int j = 0; j < tmp[i]; ++j) {
                        cout << v[cur] << ' ';
                    }
                }
                else {
                    for (int j = 0; j < tmp[i] / 2; ++j) {
                        cout << v[cur] << ' ';
                    }
                    for (int j = 0; j < tmp[i] / 2; ++j) {
                        cout << v[cur + 1] << ' ';
                    }
                }
                cur += tmp[i];
            }
        }
    }
    else if (n <= 1000){
        ll cnt = 0;
        while (true) {
            vector<ll> newv(n);
            newv[0] = v[0];
            newv[n - 1] = v[n - 1];
            bool flag = false;
            for (int i = 1; i < n - 1; ++i) {
                vector<ll> tmp;
                tmp.push_back(v[i - 1]);
                tmp.push_back(v[i]);
                tmp.push_back(v[i + 1]);
                sort(tmp.begin(), tmp.end());
                if (v[i] != tmp[1]) {
                    flag = true;
                }
                newv[i] = tmp[1];
            }
            v = newv;
            if (flag) {
                ++cnt;
            }
            else {
                break;
            }
        }

        cout << cnt << '\n';
        if (t) {
            for (int i = 0; i < n; ++i) {
                cout << v[i] << ' ';
            }
        }
    }
    else {
        vector<ll> tmp(n);
        for (int i = 1; i < n - 1; ++i) {
            if (v[i] > v[i - 1] && v[i] > v[i + 1]) {
                tmp[i] = 1;
            }
            else if (v[i] < v[i - 1] && v[i] < v[i + 1]) {
                tmp[i] = -1;
            }
            else {
                tmp[i] = 0;
            }
        }
        tmp[0] = 0;
        tmp[n - 1] = 0;

        ll ind = 1;
        vector<ll> tmp1;
        while (ind < n - 1) {
            ll was = ind;
            while (ind < n - 1) {
                if (tmp[ind] == 0) {
                    break;
                }

                if (tmp[ind] == 1 && tmp[ind + 1] == -1) {
                    ++ind;
                }
                else if (tmp[ind] == -1 && tmp[ind + 1] == 1) {
                    ++ind;
                }
                else {
                    break;
                }
            }
            ++ind;
            ll sz = ind - was;
            while (sz > 250) {
                tmp1.push_back(250);
                sz -= 250;
            }
            tmp1.push_back(sz);
        }

        ll cur = 1, ans = 0;
        for (int i = 0; i < tmp1.size(); ++i) {
            ll cnt = 0;
            vector<ll> tmp3;
            tmp3.push_back(v[cur - 1]);
            for (int j = cur; j < cur + tmp1[i]; ++j) {
                tmp3.push_back(v[j]);
            }
            tmp3.push_back(v[cur + tmp1[i]]);
            while (true) {
                bool flag = false;
                vector<ll> ntmp3(tmp1[i] + 2);
                ntmp3[0] = tmp3[0];
                ntmp3[tmp1[i] + 1] = tmp3.back();
                for (int k = 1; k < tmp1[i] + 1; ++k) {
                    vector<ll> tmp2;
                    tmp2.push_back(tmp3[k - 1]);
                    tmp2.push_back(tmp3[k]);
                    tmp2.push_back(tmp3[k + 1]);
                    sort(tmp2.begin(), tmp2.end());
                    if (tmp3[k] != tmp2[1]) {
                        flag = true;
                    }
                    ntmp3[k] = tmp2[1];
                }
                tmp3 = ntmp3;
                if (flag) {
                    ++cnt;
                }
                else {
                    break;
                }
            }
            ans = max(ans, cnt);
            cur += tmp1[i];
        }
        cout << ans;
    }

    return 0;
}
