//#pragma GCC target("avx2")

#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {/*
    ios_base::sync_with_stdio(0);
    cin.tie(0);*/
    solve();
}

int n, t;
vector<int> a, b;

void relax(int l, int r) {
    b[0] = a[0];
    b[n - 1] = a[n - 1];
    multiset<int> s = {a[l - 1], a[l], a[l + 1]};
    for (int i = l; i <= r; ++i) {
        b[i] = *(++s.begin());
        s.erase(s.find(a[i - 1]));
        s.insert(a[i + 2]);
    }
    swap(a, b);
}

void solve2() {
    int ans = 1;
    relax(1, n - 2);
    if (a == b) {
        cout << 0 nl;
        return;
    }
    vector<pair<int, int>> c;
    int i = 0, j = 0;
    int p = n - 1, q = n - 1;

    if (a[0] == a[1]) {
        i = 1;
        while (i + 1 < n && a[i + 1] == a[0]) ++i;
        c.push_back({j, i});
        j = i;
    } else {
        i = 1, j = 1;
    }

    if (a[n - 1] == a[n - 2]) {
        p = n - 2;
        while (p > 0 && a[p - 1] == a[n - 1]) --p;
    }

    while (i < p) {
        j = i;
        while (i + 1 < p && a[i + 1] == a[j]) ++i;
        if (i - j + 1 > 1) {
            c.push_back({j, i});
        }
        ++i;
    }

    if (q - p + 1 > 1) {
        c.push_back({p, q});
    }

    //cout << "p, q" sp p sp q nl;

    //for (auto &i: c) cout << i.first sp i.second nl;

    int mx = 0;

    for (int i = 0; i + 1 < c.size(); ++i) {
        fill(a.begin() + c[i].first, a.begin() + c[i].second, a[c[i].first]);
        fill(a.begin() + c[i + 1].first, a.begin() + c[i + 1].second, a[c[i + 1].first]);

        int len = c[i + 1].first - c[i].second + 1;

        if (len) {
            if (len % 2) {
                //cout << "odd" nl;
                for (int j = c[i].second + 1; j < c[i + 1].first; ++j) {
                    a[j] = a[c[i].second];
                }
                mx = max(mx, len / 2);
            } else {
                //cout << "even" nl;
                int k = (c[i].second + c[i + 1].first) / 2;
                for (int j = c[i].second + 1; j <= k; ++j) {
                    a[j] = a[c[i].second];
                }
                for (int j = k + 1; j < c[i + 1].first; ++j) {
                    a[j] = a[c[i + 1].first];
                }
                mx = max(mx, (len - 1) / 2);
            }
        }
    }
    //cout << ans sp mx nl;
    cout << ans + mx nl;
    if (t) {
        for (auto &i: a) cout << i sq;
        cout nl;
    }
}

void solve() {
    cin >> n >> t;
    a.resize(n);
    b.resize(n);

    for (auto &i: a) cin >> i;

    if (n == 1) {
        cout << 0 nl;
        if (t) {
            for (auto &i: a) cout << i sq;
            cout nl;
        }
        return;
    }

    if (n == 2) {
        cout << (a[0] > a[1] ? 1 : 0) nl;
        sort(a.begin(), a.end());
        if (t) {
            for (auto &i: a) cout << i sq;
            cout nl;
        }
        return;
    }

    bool f = n > 1000;

    for (int i = 0; i < n; ++i)  {
        if (a[i] > 2) f = false;
    }

    if (f) {
        solve2();
        return;
    }

    bool flag = true;
    int ans = 0;

    int l = 1, r = n - 2;

    while(flag) {
        flag = false;
        b[0] = a[0];
        b[n - 1] = a[n - 1];
        multiset<int> s = {a[l - 1], a[l], a[l + 1]};
        int l2 = 1e9, r2 = -1;

        //cout << "l, r" sp l sp r nl;

        for (int i = l; i <= r; ++i) {
            b[i] = *(++s.begin());
            s.erase(s.find(a[i - 1]));
            s.insert(a[i + 2]);
            if (b[i] != a[i]) {
                flag = true;
                l2 = min(l2, i);
                r2 = max(r2, i);
            }
        }

        ans += flag;
        swap(a, b);
        if (flag) {
            l = l2, r = r2;
        }
    }

    cout << ans nl;
    if (t) {
        for (auto &i: a) {
            cout << i sq;
        } cout nl;
    }
}
