#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <string>
#include <set>
#include <map>
#include <random>

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pa;
typedef pair<ll, ll> pall;
typedef pair<ld, ld> pald;

mt19937 rnd(228228);

void die() {
	int i = 0;
	while (true) {
		++i;
	}
}

void warp() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

int n, t;

vector<int> get(vector<int> a) {
	vector<int> b(n);
	b[0] = a[0], b[n - 1] = a[n - 1];
	for (int i = 1; i < n - 1; ++i) {
		vector<int> c = { a[i - 1], a[i], a[i + 1] };
		sort(c.begin(), c.end());
		b[i] = c[1];
	}
	return b;
}

int fastsolve(vector<int> a) {
	int ans = 0;
	vector<int> s = get(a);
	if (a != s) {
		++ans;
		a = s;
	} else {
		return 0;
	}
	int mx = 0;
	for (int i = 0; i < n - 1; ++i) {
		int j = i;
		int pl = -1;
		if (a[i] < a[i + 1])
			pl = 1;
		else if (a[i] > a[i + 1])
			pl = -1;
		else
			continue;
		while (j + 1 < n) {
			if (pl == 1) {
				if (a[j] < a[j + 1])
					++j, pl = -1;
				else
					break;
			} else if (pl == -1) {
				if (a[j] > a[j + 1])
					++j, pl = 1;
				else
					break;
			}
		}
		if (i + 1 < j) {
			int len = j - i + 1;
			int nw = (len - 1) / 2;
			for (int x = i; x <= i + nw; ++x)
				a[x] = a[i];
			for (int x = i + nw + 1; x < j; ++x)
				a[x] = a[j];
			mx = max(mx, (len - 1) / 2);
			i = j;
		}
	}
	cout << ans + mx << "\n";
	if (t) {
		for (int i : a) {
			cout << i << " ";
		}
	}
	return ans + mx;
}

int solve(vector<int> a) {
	int ans = 0;
	while (true) {
		vector<int> s = get(a);
		if (s != a) {
			a = s;
			++ans; 
		} else {
			break;
		}
	}
	cout << ans << '\n';
	if (t) {
		for (int i : a) {
			cout << i << " ";
		}
	}
	return ans;
}

signed main() {
	warp();
	cin >> n >> t;
	vector<int> a(n);

	for (int& i : a)
		cin >> i;
	if (n <= 1000) {
		solve(a);
		return 0;
	}
	fastsolve(a);
	return 0;

	for (int test = 0; test < 10; ++test) {
		//cin >> n >> t;
		n = 10, t = 1;
		vector<int> a(n);
		int pr = -1;
		for (int& i : a) {
			//cin >> i;
			i = pr;
			while (i == pr) {
				i = rnd() % 4;
			}
			pr = i;
		}
		a = { 0, 5, 1, 6, 5 , 7, 3, 6, 4, 9 };
		int SS = fastsolve(a), FF = solve(a);
		cout << FF;
		cout << "\n\n";
	}
}