#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (1 << 17);

void IOOptimize() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
}

vector <int> v;

vector <int> Try(int d) {
	vector <int> t(v.size());
	int n = v.size();
	vector <int> q;
	int j = 0;
	for (int i = 0; i < n; i++) {
		vector <int> q;
		int d_ = min(d, i);
		d_ = min(d_, n - i - 1);
		for (int j = i - d_; j <= i + d_; j++)
			q.push_back(v[j]);
		sort(q.begin(), q.end());
		t[i] = q[q.size() / 2];
	}
	return t;
}

void Solve() {
	int n, t;
	cin >> n >> t;
	v.resize(n);
	for (int i = 0; i < n; i++)
		cin >> v[i];
	int l = 0, r = n + 1;
	while (l < r - 1) {
		int d = (l + r) / 2;
		if (Try(d) != Try(d+1)) l = d;
		else r = d;
	}
	cout << r << endl;
	if (t) {
		auto v = Try(r);
		for (auto i : v)
			cout << i << " ";
	}
}

int main() {
	IOOptimize();
	Solve();
}