#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(a) cout << #a << " := " << a << '\n'

#define hash alsdlkfjslfj

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif // LOCAL

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & a, int size_, T value = 0) { a.assign(size_, value); }

void solve();
void boot_up() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}


class HashString {
private:
    int size;
    ll base, mod;
    vector<ll> powers;
    vector<ll> hash;
public:
    HashString() {}

    HashString(string & s, ll base_, ll mod_) : size(len(s)), base(base_), mod(mod_) {
        init(powers, size + 1);
        powers[0] = 1;
        for (int i = 1; i <= size; ++i) {
            powers[i] = powers[i - 1] * base;

            if (mod) {
                powers[i] %= mod;
            }
        }

        init(hash, size);
        hash[0] = s[0] - 'a' + 1;
        for (int i = 1; i < size; ++i) {
            hash[i] = hash[i - 1] * base + s[i] - 'a' + 1;

            if (mod) {
                hash[i] %= mod;
            }
        }
    }

    ll get_hash(int l, int r) {
        if (!mod) {
            return hash[r] - (!l ? 0 : hash[l - 1] * powers[r - l + 1]);
        }
        else {
            return (mod + hash[r] - (!l ? 0 : hash[l - 1] * powers[r - l + 1] % mod)) % mod;
        }
    }
};


int n;
string s;
HashString hash;
HashString hash_rev;

inline int check(int l, int r);
inline int is_pal(int l, int r);

signed main() {
    boot_up();

    while (cin >> n >> s) {
        solve();
    }
}

ll base = 37;

void solve() {
    hash = HashString(s, base, 0);
    reverse(all(s));
    hash_rev = HashString(s, base, 0);

    ll ans = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            ans += check(i, j);
        }
    }

    cout << ans << '\n';
}

inline int check(int l, int r) {
    if ((r - l + 1) % 2) {
        return 0;
    }

    int length = (r - l + 1) / 2;

    return is_pal(l, l + length - 1) + is_pal(l + length, r) == 2;
}

inline int is_pal(int l, int r) {
    ll forward = hash.get_hash(l, r);
    ll reversed = hash_rev.get_hash(n - 1 - r, n - 1 - l);

    return forward == reversed;
}