#include <bits/stdc++.h>

using namespace std;

vector<long long> m_power(500000, 1);
vector<long long> m_hash(500000);
vector<long long> rev_hash(500000);

const long long MOD = 1e9 + 7;
const long long P = 31;

int n;

long long get_hash(int l, int r) {
    if (l == 0)
        return m_hash[r];
    return (m_hash[r] - m_hash[l - 1] * m_power[r - l + 1] %  MOD + MOD) % MOD;
}

long long get_rev_hash(int l, int r) {
    if (r == n - 1)
        return rev_hash[l];
    return (rev_hash[l] - rev_hash[r + 1] * m_power[r - l + 1] %  MOD + MOD) % MOD;
}

bool check(int l, int r) {
    int m = (l + r) / 2;
    if ((r - l) % 2 == 0)
        return (get_hash(l, m) == get_rev_hash(m, r));
    return (get_hash(l, m) == get_rev_hash(m + 1, r));
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    string s;
    cin >> s;
    for (int i = 0; i < n; i++) {
        if (i == 0)
            m_hash[i] = s[i];
        else
            m_hash[i] = (m_hash[i - 1] * P + s[i]) % MOD;
    }
    for (int i = n - 1; i >= 0; i--) {
        if (i == n - 1)
            rev_hash[i] = s[i];
        else
            rev_hash[i] = (rev_hash[i + 1] * P + s[i]) % MOD;
    }
    for (int i = 1; i < n; i++)
        m_power[i] = (m_power[i - 1] * P) % MOD;
    int ans = 0;
    for (int len = 2; len <= n; len += 2) {
        for (int start = 0; start < n - len + 1; start++) {
            int s1 = start;
            int f1 = start + len / 2 - 1;
            int s2 = f1 + 1;
            int f2 = start + len - 1;
            if (check(s1, f1) && check(s2, f2))
                ans++;
        }
    }
    cout << ans;
}

