#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

struct Hash {
	static const int MA = 1e9 + 7, MB = 1e9 + 9;
	int a, b;
	Hash() : a(0), b(0) {}
	Hash(int a, int b) : a(a), b(b) {}
	Hash(int a) : a(a), b(a) {}
	Hash operator +(const Hash &other) const {
		return Hash((a + other.a) % MA, (b + other.b) % MB);
	}
	Hash operator -(const Hash &other) const {
	 	return Hash((a - other.a + MA) % MA, (b - other.b + MB) % MB);
	}
	Hash operator *(const Hash &other) const {
		return Hash(((ll)a * other.a) % MA, ((ll)b * other.b) % MB);
	}
	bool operator ==(const Hash &other) const {
		return a == other.a && b == other.b;
	}
	bool operator !=(const Hash &other) const {
	 	return a != other.a || b != other.b;
	}
};

const Hash P = 239;

ll solve(string s) {
	int n = s.size();
	vector <Hash> deg(n + 1);
	deg[0] = 1;
	vector <Hash> h(n + 1), rh(n + 1);
	for (int i = 0; i < n; ++i) {
		deg[i + 1] = deg[i] * P;
	}
	for (int i = 0; i < n; ++i) {
		h[i + 1] = h[i] * P + s[i];
	}
	for (int i = n - 1; i >= 0; --i) {
		rh[i] = rh[i + 1] * P + s[i];
	}
	auto get1 = [&] (int l, int len) {
		return h[l + len] - h[l] * deg[len];
	};
	auto get2 = [&] (int l, int len) {
		return rh[l] - rh[l + len] * deg[len];		
	};
	auto is_pal = [&] (int l, int r) {
		int len = r - l + 1;
		return get1(l, len) == get2(l, len);
	};
	ll ans = 0;
	for (int l = 0; l < n; ++l) {
		for (int r = l + 1; r < n; r += 2) {
		 	int mid = (r + l) / 2;
		 	if (is_pal(l, mid) && is_pal(mid + 1, r)) {
		 		++ans;
		 	}
		}
	}
	return ans;
}	

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	int n;
	cin >> n;
	string s;
	cin >> s;
	cout << solve(s) << '\n';
}