#include <iostream>
#include <cstdint>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>

#define BASE 97
#define MOD 1'000'000'007

void init(int32_t* powers) {
    powers[0] = 1;
    for(int32_t i = 1 ; i < 5005; i++)
        powers[i] = ((int64_t)powers[i - 1] * BASE) % MOD;
}

void compute_prefix(std::string& str, int32_t* result) {
    result[0] = 0;
    for(int32_t i = 1; i <= str.size(); i++) {
        result[i] = ((int64_t)result[i - 1] * BASE) % MOD + str[i - 1] - 'a' + 1;
    }
}

int32_t get_substring_hash(int32_t left, int32_t right, int32_t* hashes, int32_t* powers) {
    return (hashes[right + 1] - (((int64_t)hashes[left] * powers[right - left + 1]) % MOD) + MOD) % MOD;
}

int main() {
    int32_t n;
    std::cin >> n;

    std::string str;
    std::cin >> str;

    int32_t* base_powers = new int32_t[5005];
    init(base_powers);

    int32_t* prefix1 = new int32_t[str.size() + 1];
    compute_prefix(str, prefix1);
    std::reverse(str.begin(), str.end());
    int32_t* prefix2 = new int32_t[str.size() + 1];
    compute_prefix(str, prefix2);

    int32_t answer = 0;
    for(int32_t i = 0; i < n; i++)
        for(int32_t j = i ; j < n; j++) {
            int32_t length = j - i + 1;
            if(length % 2 == 1)
                continue;
            bool ok = true;
            if( get_substring_hash(i, i + length / 2 - 1, prefix1, base_powers) !=
                get_substring_hash(str.size() - 1 - (i + length / 2 - 1), str.size() - 1 - i, prefix2, base_powers))
                ok = false;
            if( get_substring_hash(i + length / 2, j, prefix1, base_powers) !=
                get_substring_hash(str.size() - 1 - j, str.size() - 1 - (i + length / 2), prefix2, base_powers))
                ok = false;
            if(ok)
                answer++;
        }
    std::cout << answer;
    return 0;
}