#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll INF = 1e9 + 7;
const ll BASE = 29;
const ll BASE2 = 37;
const ll M = 1e9 + 7;

void fast() {
    ios::sync_with_stdio(0);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

vector<ll> h1, h2;
vector<ll> hh1, hh2;
vector<ll> bb;
vector<ll> b;

void build(ll n, string& s) {
    h1.resize(n + 1, 0), h2.resize(n + 1, 0);
    b.resize(n + 1, 1), bb.resize(n + 1, 1);
    hh1.resize(n + 1, 0), hh2.resize(n + 1, 0);
    for (ll i = 1; i <= n; i++) {
        h1[i] = h1[i - 1] * BASE + s[i - 1] - 'a' + 1;
        b[i] = b[i - 1] * BASE;
        hh1[i] = hh1[i - 1] * BASE2 % M + s[i - 1] - 'a' + 1;
        hh1[i] %= M;
        bb[i] = bb[i - 1]* BASE2 % M;
    }
    reverse(s.begin(), s.end());
    for (ll i = 1; i <= n; i++) {
        h2[i] = h2[i - 1] * BASE + s[i - 1] - 'a' + 1;
        hh2[i] = hh2[i - 1] * BASE2 % M + s[i - 1] - 'a' + 1;
        hh2[i] %= M;
    }
    reverse(s.begin(), s.end());
}

pair<ll, ll> get_hash1(ll l, ll r) {
    l++, r++;
    return {h1[r] - h1[l - 1] * b[r - l + 1], (hh1[r] - hh1[l - 1] * bb[r - l + 1] % M + M) % M};
}

pair<ll, ll> get_hash2(ll l, ll r, ll n) {
    l++, r++;
    ll val1 = l;
    ll val2 = r;
    ll len = r - l + 1;
    l = n - r + 1;
    r = l + len - 1;
    return {h2[r] - h2[l - 1] * b[r - l + 1], (hh2[r] - hh2[l - 1] * bb[r - l + 1] % M + M) % M};
}

signed main() {
    fast();

    ll n;
    cin >> n;
    string s;
    cin >> s;
    build(n, s);
    vector<vector<ll>> m1(n), m2(n);
    for (ll i = 0; i < n; i++) {
        m1[i].push_back(1);
        m2[i].push_back(1);
        for (ll len = 1; len <= n; len++) {
            ll l1 = i - len;
            ll r1 = i - 1;
            ll l2 = i + 1;
            ll r2 = i + len;
            if (l1 < 0 || r2 >= n) {
                continue;
            }
            pair<ll, ll> val1 = get_hash1(l1, r1);
            pair<ll, ll> val2 = get_hash2(l2, r2, n);
            if (val1.first == val2.first && val1.second == val2.second) {
                m1[l1].push_back(r2 - l1 + 1);
                m2[r2].push_back(r2 - l1 + 1);
            }
        }
    }
    for (ll i = 0; i < n; i++) {
        for (ll len = 1; len <= n; len++) {
            ll l1 = i - len + 1;
            ll r1 = i;
            ll l2 = i + 1;
            ll r2 = l2 + len - 1;
            if (l1 < 0 || r2 >= n) {
                continue;
            }
            pair<ll, ll> val1 = get_hash1(l1, r1);
            pair<ll, ll> val2 = get_hash2(l2, r2, n);
            if (val1.first == val2.first && val1.second == val2.second) {
                m1[l1].push_back(r2 - l1 + 1);
                m2[r2].push_back(r2 - l1 + 1);
            }
        }
    }
    ll ans = 0;
    for (auto& el : m1) {
        sort(el.begin(), el.end());
    }
    for (auto& el : m2) {
        sort(el.begin(), el.end());
    }
    for (ll i = 0; i < n; i++) {
        for (auto& len : m2[i]) {
            if (i == n - 1) {
                break;
            }
            auto it = lower_bound(m1[i + 1].begin(), m1[i + 1].end(), len);
            if (it != m1[i + 1].end() && *it == len) {
                ans++;
            }
        }
    }
    cout << ans;
    return 0;
}
