#include <bits/stdc++.h>
#define int long long
using namespace std;

struct Hash {
    static const int h_m = 1e9+7, h_p = 4242;
    string s;
    vector<int> h, d;

    void build(string _s) {
        s = _s;
        int n = s.size();

        h.assign(n+1, 0);
        d.assign(n+1, 0);
        d[0] = 1;

        for(int i = 0; i < n; ++i) {
            h[i+1] = (h[i]*h_p + s[i]) % h_m;
            d[i+1] = (d[i]*h_p) % h_m;
        }
    }

    int get(int l, int r) {
        int t = (h[l]*d[r-l+1]) % h_m;
        return (h_m + h[r+1] - t) % h_m;
    }
};

struct Solver {
    string s;
    Hash hs, ht;
    int n;

    Solver(string s): s(s) {
        n = s.size();
    }

    int pal(int l, int r) {
        int h1 = hs.get(l, r);
        int h2 = ht.get(n-1-r, n-1-l);
        return h1 == h2;
    }

    int check(int l, int r) {
        if((r-l+1) % 2) return 0;
        int m = (l+r)/2+1;

        return pal(l, m-1) && pal(m, r);
    }

    int solve() {
        string t = s;
        reverse(t.begin(), t.end());

        hs.build(s);
        ht.build(t);

        int res = 0;
        for(int l = 0; l < n; ++l)
            for(int r = l+1; r < n; ++r)
                res += check(l, r);

        return res;
    }
};

const int local = 0, stress = 0;
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    if(local) freopen("input.txt", "r", stdin);

    ///---------///
    ///---------///

    int tests = 1;
    if((local) && (!stress)) cin >> tests;

    while(tests--) {
        if(!stress) {
            int n;
            cin >> n;

            string s;
            cin >> s;

            Solver solver(s);
            int res = solver.solve();
            cout << res << "\n";

        } else {}
    }

    return 0;
}
