#include <bits/stdc++.h>
using namespace std;

random_device rddev;
mt19937 rd(rddev());

using ll = long long;
using ldb = long double;

const int MOD = 1e9 + 7;
const int p = 517;// + rd() % 17957;
const int MAXN = 500000 + 228;

int n;
int ppow[MAXN];
int h1[MAXN];
int h2[MAXN];

void prepHash(const string &s) {
	ppow[0] = 1;
	for (int i = 0; i < n; i++) {
		ppow[i + 1] = 1LL * ppow[i] * p % MOD;
		h1[i + 1] = (1LL * h1[i] * p + s[i]) % MOD;
		h2[i + 1] = (1LL * h2[i] * p + s[n - 1 - i]) % MOD;
	}
}

int getHash1(int pos, int len) {
	return ((h1[pos + len] - 1LL * h1[pos] * ppow[len]) % MOD + MOD) % MOD;
}

int getHash2(int pos, int len) {
	return ((h2[pos + len] - 1LL * h2[pos] * ppow[len]) % MOD + MOD) % MOD;
}

bool check(int pos, int len) {
	int h1 = getHash1(pos, len);
	int h2 = getHash2(n - (pos + len - 1) - 1, len);
	return h1 == h2;
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	string s;
	cin >> s;
	prepHash(s);
	int ans = 0;
	for (int len = 1; len <= n; len++) {
		for (int i = len - 1; i + len + 1 <= n; i++) {
			if (check(i - len + 1, len) && check(i + 1, len)) {
				ans++;
			}
		}
	}
	cout << ans << endl;
}

