#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(int &a, const int &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(int &a, const int &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

struct HS {
	int MOD, p;

	HS() {}

	int mul(int a, int b) {
		return (1LL * a * b) % MOD;
	}

	int power(int a, int deg) {
		int res = 1;
		while (deg) {
			if (deg & 1) {
				res = mul(res, a);
			}
			a = mul(a, a);
			deg >>= 1;
		}
		return res;
	}

	int sum(int a, int b) {
		return (a + b) % MOD;
	}

	int diff(int a, int b) {
		return (a - b + MOD) % MOD;
	}

	void add(int &a, int b) {
		a = (a + b) % MOD;
	}

	void subt(int &a, int b) {
		a = (a - b + MOD) % MOD;
	}

	int inverse(int a) {
		return power(a, MOD - 2);
	}

	vector<int> deg, h;

	HS(string &s, int _MOD, int _p) {
		MOD = _MOD;
		p = _p;
		int n = s.size();
		deg.resize(n + 1);
		deg[0] = 1;
		for (int i = 1; i <= n; ++i) {
			deg[i] = mul(deg[i - 1], p);
		}
		h.resize(n + 1);
		for (int i = n - 1; i >= 0; --i) {
			h[i] = sum(s[i], mul(h[i + 1], p));
		}
	}

	int get_hash(int l, int r) {
		return (diff(h[l], mul(h[r + 1], deg[r - l + 1])));
	}
};

struct rev_HS {
	HS a;
	int n;

	rev_HS(string s, int _MOD, int _p) {
		reverse(all(s));
		a = HS(s, _MOD, _p);
		n = s.size();
	}

	int get_hash(int l, int r) {
		return a.get_hash(n - 1 - r, n - 1 - l);
	}
};

void get_pal(string &s, vector<int> &odd, vector<int> &even) {
	HS H(s, 1e9 + 7, 14355);
	rev_HS _H(s, 1e9 + 7, 14355);
	int n = s.size();
	odd.assign(n, 0);
	even.assign(n - 1, 0);
	for (int i = 0; i < n; ++i) {
		int l = 0, r = min(i, n - 1 - i);
		while (l < r) {
			int mid = (l + r) >> 1;
			if (H.get_hash(i - mid - 1, i + mid + 1) == _H.get_hash(i - mid - 1, i + mid + 1)) {
				l = mid + 1;
			} else {
				r = mid;
			}
		}
		odd[i] = l;
	}
	for (int i = 0; i < n - 1; ++i) {
		int l = 0, r = min(i + 1, n - 1 - i);
		while (l < r) {
			int mid = (l + r) >> 1;
			if (H.get_hash(i - mid, i + mid + 1) == _H.get_hash(i - mid, i + mid + 1)) {
				l = mid + 1;
			} else {
				r = mid;
			}
		}
		even[i] = l;
	}
}

struct fenwick {
	vector<int> t;
	int n;

	fenwick() {}

	void init(int _n) {
		// cerr << "init " << _n << endl;
		n = _n;
		t.resize(n);
		// cerr << t.size() << endl;
	}

	void update(int pos, int val) {
		while (pos < n) {
			t[pos] += val;
			pos = (pos | (pos + 1));
		}
	}

	int get(int r) {
		int res = 0;
		while (r >= 0) {
			res += t[r];
			r = (r & (r + 1)) - 1;
		}
		return res;
	}

	int get(int l, int r) {
		int res = get(r) - get(l - 1);
		return res;
	}
};

const int mx = 5e5 + 228;
int n;
string s;
vector<int> odd, even;
ll ans;

void process_odd() {
	vector<vector<int> > ev;
	ev.resize(n);
	vector<fenwick> F(2);
	F[0].init(n);
	F[1].init(n);
	for (int i = n - 1; i >= 0; --i) {
		int L = i - odd[i];
		int _L = (L - 1) - odd[i];
		if (_L >= 0) {
			ev[_L].push_back(i);
		}
		F[i % 2].update(i, 1);
		ans += (ll)F[(i % 2) ^ 1].get(i + 1, min(n - 1, i + odd[i] + 1 + odd[i]));
		for (auto pos : ev[i]) {
			F[pos % 2].update(pos, -1);
		}
	}
}

void process_even() {
	vector<vector<int> > ev;
	ev.resize(n);
	vector<fenwick> F(2);
	F[0].init(n - 1);
	F[1].init(n - 1);
	for (int i = n - 2; i >= 0; --i) {
		int L = i - even[i] - even[i];
		if (L >= 0) {
			ev[L].push_back(i);
		}
		F[i % 2].update(i, 1);
		ans += (ll)F[i % 2].get(i + 1, min(n - 2, i + even[i] + even[i]));
		for (auto pos : ev[i]) {
			F[pos % 2].update(pos, -1);
		}
	}
}

signed main() {
	fast_io();
	cin >> n;
	cin >> s;
	// cerr << s << endl;
	get_pal(s, odd, even);
	// output(all(odd));
	// output(all(even));
	process_odd();
	process_even();
	cerr << ans << endl;
}
