#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <math.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define z(n) fixed << setprecision(n)

typedef long long ll;
typedef int T;

const int INF = 1e9;
const double EPS = 1e-5;
const double PI = cos(-1);

inline void IO() {
#ifdef Dmitry07
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0); 
}

#define int ll

const int P = 37, MOD = 1e9 + 7;
int n;

vector<int> calc_hash(string& s, int P, int MOD) {
	vector<int> hash(n + 1);
	hash[0] = 0;
	for (int i = 1; i <= n; i++) {
		hash[i] = (hash[i - 1] * P + s[i - 1]) % MOD;
	}
	return hash;
}

int get_hash(vector<int>& hash, vector<int>& p, int l, int r, int MOD) {
	return (hash[r] - (hash[l] * p[r - l]) % MOD + MOD) % MOD;
}

vector<int> h1, h1r, p;

bool is_palindrome(int l, int r) {
	r--;
	int r1 = n - l - 1;
	int l1 = n - r - 1;
	return get_hash(h1, p, l, r + 1, MOD) == get_hash(h1r, p, l1, r1 + 1, MOD);
}

inline void solve() {
	cin >> n;
	string s;
	cin >> s;
	h1 = calc_hash(s, P, MOD);
	reverse(all(s));
	h1r = calc_hash(s, P, MOD);
	p.resize(n + 1);
	p[0] = 1;
	for (int i = 1; i <= n; i++) {
		p[i] = p[i - 1] * P;
	}
	int ans = 0;
	for (int l = 0; l < n; l++) {
		for (int r = l + 2; r <= n; r += 2) {
			int mid = (l + r) / 2;
			ans += is_palindrome(l, mid) && is_palindrome(mid, r);
		}
	}
	cout << ans;

}

signed main() {
	IO();
	int t;
	t = 1;
	while (t--)
		solve();
}