#include <iostream>
#include <random>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run();

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    run();
}

struct Hash {
    const int MOD = 1e9 + 21;
    const int BASE = 29;
    int *h, *pw;
    explicit Hash(string &s) {
        int n = s.size();
        h = arr<int>(n + 1);
        h[0] = 0;
        for (int i = 1; i <= n; i++) {
            h[i] = ((long long) h[i - 1] * BASE + s[i - 1] - 'a') % MOD;
        }
        pw = arr<int>(n + 1);
        pw[0] = 1;
        for (int i = 1; i <= n; i++) {
            pw[i] = (long long) pw[i - 1] * BASE % MOD;
        }
    }
    int get(int l, int r) {
        int sub = (long long) h[l] * pw[r - l] % MOD;
        int res = (h[r] - sub + MOD) % MOD;
        return res;
    }
};

bool is_pal(Hash &h, int l, int r) {
    if ((r - l) % 2 == 0) {
        int k = (l + r) / 2;
        return h.get(l, k) == h.get(k, r);
    } else {
        int k = (l + r) / 2;
        return h.get(l, k) == h.get(k + 1, r);
    }
}

void run() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    Hash h(s);
    /*for (int i = 0; i < n; i++) {
        for (int j = i; j <= n; j++) {
            cerr << i << ' ' << j << ' ' << is_pal(h, i, j) << endl;
        }
    }*/
    long long ans = 0;
    /*for (int i = 1; i < n; i++) {
        for (int k = 1; i - k >= 0 && i + k <= n; k++) {
            int cur = is_pal(h, i - k, i) && is_pal(h, i, i + k);
            ans += cur;
            //cerr << i << ' ' << k << ' ' << cur << endl;
        }
    }*/
    for (int i = 0; i < n; i++) {
        for (int j = i + 2; j <= n; j += 2) {
            int k = (i + j) / 2;
            bool res = is_pal(h, i, k) && is_pal(h, k, j);
            ans += res;
            //cerr << i << ' ' << j << ' ' << res << endl;
        }
    }
    cout << ans << endl;
}