#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <algorithm>
#include <random>
#include <cassert>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <map>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <iomanip>
#include <bitset>
#include <stack>
#include <list>

#pragma warning (disable : 4996)
using namespace std;

#define all(a) (a).begin(), (a).end()
#define allr(a) (a).rbegin(), (a).rend()
#define nl '\n'
#define sz(a) (int)(a).size()

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;

const int INF = numeric_limits<int>::max();
const ll LINF = numeric_limits<ll>::max();
const dl EPS = 1e-8;
const dl PI = acos(-1);
mt19937 rnd(5625445);
mt19937_64 rnd64(3465467567);

template <typename T, typename D>
istream& operator >> (istream& in, pair<T, D>& a) {
	in >> a.first >> a.second;
	return in;
}

template <typename T, typename D>
ostream& operator << (ostream& out, pair<T, D>& a) {
	out << a.first << " " << a.second;
	return out;
}

template <typename T>
istream& operator >> (istream& in, vector<T>& a) {
	for (auto& i : a)
		in >> i;
	return in;
}

void IO() {
#ifdef _SEVA
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _SEVA
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cout.setf(ios::fixed);
	cout.precision(10);
}

const int N = 5000 + 10;

short isPal[N][N];
short isPal2[N][N];

void solve() {
	int n;
	cin >> n;
	string s;
	cin >> s;
	int ans = 0;

	for (int i = 0; i < n; i++) {
		isPal[i][i] = true;
		if (i + 1 < n && s[i] == s[i + 1]) {
			isPal[i][i + 1] = true;
		}
	}

	for (int len = 2; len <= n; len++) {
		for (int left = 0; left + len - 1 < n; left++) {
			int right = left + len - 1;
			isPal[left][right] |= isPal[left + 1][right - 1] && s[left] == s[right];
			isPal2[left][right] = 
				len % 2 == 0
				&& isPal[left][left + len / 2 - 1]
				&& isPal[left + len / 2][right];
			ans += isPal2[left][right];
		}
	}

	cout << ans << nl;

}

int main() {
	IO();
	solve();
	return 0;
}
