#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <iterator>
#include <iomanip>
#include <utility>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <climits>
#include <numeric>
#include <string>
#include <algorithm>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
using namespace std;
//#define int long long
vector<bool> used, covered;
vector<int> matched;
vector<vector<int>> g;
bool trykuhn(int v) {
	used[v] = true;
	for (auto x : g[v]) {
		if (matched[x] == -1 || !used[matched[x]]) {
			used[x] = true;
			if (matched[x] == -1 || trykuhn(matched[x])) {
				matched[x] = v;
				return true;
			}
		}
	}
	return false;
}
struct fenwick {
	int n;
	vector<int> f;
	fenwick(int _n) {
		n = _n;
		f.assign(n,0);
	}
	void add(int i, int val) {
		for (; i < n; i |= (i + 1))
			f[i] += val;
	}
	int getsum(int i) {
		int ans = 0;
		for (; i >= 0; i &= (i + 1), --i)
			ans += f[i];
		return ans;
	}
	int get(int L, int R) {
		return getsum(R) - getsum(L - 1);
	}
};
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int n;
	string s;
	cin >> n >> s;
	vector<vector<char>> ispal(n, vector<char>(n, 0));
	for (int i = 0; i < n; ++i) {
		ispal[i][i] = 1;
		if (i > 0) ispal[i][i - 1] = 1;
	}
	for (int len = 2; len <= n; ++len) {
		for (int L = 0; L + len - 1 < n; ++L) {
			int R = L + len - 1;
			if (ispal[L + 1][R - 1] && s[L] == s[R]) ispal[L][R] = true;
		}
	}
	int ans = 0;
	for (int len = 2; len <= n; len += 2) {
		for (int L = 0; L + len - 1 < n; ++L) {
			int R = L + len - 1, sublen = len / 2;
			if (ispal[L][L + sublen - 1] && ispal[L + sublen][R]) ans++;
		}
	}
	cout << ans;
}