#include <iostream>
#include <map>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <string>
#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define ull unsigned long long

using namespace std;

int n;
string s;

struct phash {
    const ull base = 1e5 + 7;
    vector<ull> pows;
    vector<ull> hsh;
    const ull mxpow = 1e6 + 10;

    phash(const string& s)
    {
        while (pows.size() < mxpow)
        {
            if (pows.empty())
                pows.push_back(1ll);
            else
                pows.push_back(pows.back() * base);
        }

        hsh.resize(s.size() + 10, 0);
        
        for (int i = 0; i < s.size(); ++i)
            hsh[i + 1] = (ull)pows[i + 1] * s[i] + hsh[i];
    }

    ull gethash(int i, int len)
    {
        return (hsh[i + len] - hsh[i]) * ((ull)pows[mxpow - i - 1]);
    }
};

int32_t main()
{
    cin >> n >> s;

    phash sh(s);

    int ans = 0;

    for(int i = 0; i < s.size(); ++i)
        for(int l = 1; l <= s.size(); ++l)
            if (i + 2 * l - 1 < s.size())
            {
                if (l == 1)
                    ++ans;
                else if (l % 2 == 0 && sh.gethash(i, l / 2) == sh.gethash(i + l / 2, l / 2)
                    && sh.gethash(i + l, l / 2) == sh.gethash(i + l + l / 2, l / 2))
                    ++ans;
                else if (l % 2 == 1)
                    if (sh.gethash(i, l / 2) == sh.gethash(i + l / 2 + 1, l / 2)
                        && sh.gethash(i + l, l / 2) == sh.gethash(i + l + l / 2 + 1, l / 2))
                        ++ans;

            }

    cout << ans << endl;
}


