#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <ctime>
#include <random>
#include <queue>
#include <stack>
#include <deque>
#include <string>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#pragma GCC target("sse")

using namespace std;

using ll = long long;
using ld = long double;
using itn = int;

#define endl '\n'

mt19937 gen(41);
mt19937_64 genl(41);

const int N = 500'000;

int n;
string s;

struct Hash {
    const int p1 = 29, p2 = 41, mod = 1e9 + 7;
    vector<int> h1, h2;
    vector<int> h1r, h2r;
    vector<int> pows1;
    vector<int> pows2;
    void add(string s) {
        pows1.push_back(1);
        pows2.push_back(1);
        for (int i = 0; i < s.size(); i++) {
            pows1.push_back((1ll * pows1.back() * p1) % mod);
            pows2.push_back((1ll * pows2.back() * p2) % mod);
        }
        h1.resize(n + 1);
        h2.resize(n + 1);
        h1[0] = 0;
        h2[0] = 0;
        for (int i = 0; i < s.size(); i++) {
            h1[i + 1] = (1ll * h1[i] * p1 + s[i] - 'a' + 1) % mod;
            h2[i + 1] = (1ll * h2[i] * p2 + s[i] - 'a' + 1) % mod;
        }
        h1r.resize(n + 1);
        h2r.resize(n + 1);
        h1r[0] = 0;
        h2r[0] = 0;
        reverse(s.begin(), s.end());
        for (int i = 0; i < s.size(); i++) {
            h1r[i + 1] = (1ll * h1r[i] * p1 + s[i] - 'a' + 1) % mod;
            h2r[i + 1] = (1ll * h2r[i] * p2 + s[i] - 'a' + 1) % mod;
        }
    }
    bool check(int l, int r) {
        if (l < 0 || l >= n || r < 0 || r >= n)
            return false;
        int a1 = (h1[r + 1] - (1ll * h1[l] * pows1[r - l + 1]) % mod + mod) % mod;
        int a2 = (h1r[n - l] - (1ll * h1r[n - r - 1] * pows1[r - l + 1]) % mod + mod) % mod;
        if (a1 != a2)
            return false;
        int b1 = (h2[r + 1] - (1ll * h2[l] * pows2[r - l + 1]) % mod + mod) % mod;
        int b2 = (h2r[n - l] - (1ll * h2r[n - r - 1] * pows2[r - l + 1]) % mod + mod) % mod;
        if (b1 != b2)
            return false;
        return true;
    }

};
Hash h;

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout << fixed << setprecision(10);
///--------------------------------------------------------///
    cin >> n >> s;
    h.add(s);
    ll cnt = 0;
    for (int i = 0; i < n - 1; i++) {
        for (int j = 0; j <= min(i + 1, n - i - 1); j++) {
            if (h.check(i - j, i) && h.check(i + 1, i + j + 1)) {
                cnt++;
            }
        }
    }
    cout << cnt;
///--------------------------------------------------------///
}