#include <iostream>
#include <cstring>
#include <vector>
#include <algorithm>
#define int long long

using namespace std;

const int N = 5e5 + 7, M1 = 1e9 + 7, M2 = 1e9 + 9, b1 = 239, b2 = 419;
int tot_ans = 0;

int my_mod(int x, int M) {
    x %= M;
    if (x < 0) x += M;
    return x;
}

int f[N], len[N];
pair <int, int> h[N], h2[N], poww[N];

void upd(int pos) {
    for (int i = pos; i < N; i += i & (-i)) f[i]++;
}

int get_pref(int pos) {
    int res = 0;
    for (int i = pos; i > 0; i -= i & (-i)) res += f[i];
    return res;
}

int get(int l, int r) {
    if (l > r) return 0;
    l = max(l, 1ll);
    r = min(r, N - 1);
    return get_pref(r) - get_pref(l - 1);
}

pair <int, int> get_hash(int l, int r, int t) {
    int ans1 = my_mod(h[r].first - h[l - 1].first * poww[r - l + 1].first, M1);
    int ans2 = my_mod(h[r].second - h[l - 1].second * poww[r - l + 1].second, M2);
    if (t == 2) {
        ans1 = my_mod(h2[r].first - h2[l - 1].first * poww[r - l + 1].first, M1);
        ans2 = my_mod(h2[r].second - h2[l - 1].second * poww[r - l + 1].second, M2);
    }
    return {ans1, ans2};
}

void init(string s) {
    string t = s;
    reverse(t.begin(), t.end());
    poww[0] = {1, 1};
    for (int i = 1; i < N; i++) {
        poww[i] = {(poww[i - 1].first * b1) % M1, (poww[i - 1].second * b2) % M2};
    }
    int n = s.length();
    h[0] = h2[0] = {0, 0};
    for (int i = 1; i <= n; i++) {
        h[i].first = (h[i - 1].first * b1 + s[i - 1] - 'a' + 1) % M1;
        h[i].second = (h[i - 1].second * b2 + s[i - 1] - 'a' + 1) % M2;
        h2[i].first = (h2[i - 1].first * b1 + t[i - 1] - 'a' + 1) % M1;
        h2[i].second = (h2[i - 1].second * b2 + t[i - 1] - 'a' + 1) % M2;
    }
}

bool check_palindrome(int n, int l, int r) {
    if (l > r || l < 1 || r > n) return 0;
    auto a = get_hash(l, r, 1);
    auto b = get_hash(n - r + 1, n - l + 1, 2);
    return (a == b);
}

void calc_nech(string s) {
    int n = s.length();
    vector <pair <int, int>> poss;
    for (int i = 1; i <= n; i++) {
        int l = 1, r = n + 1, mid;
        while (r - l > 1) {
            mid = (l + r) / 2;
            if (check_palindrome(n, i - mid + 1, i + mid - 1)) l = mid;
            else r = mid;
        }
        len[i] = l;
        //cout << len[i] << endl;
        poss.push_back({len[i], i});
    }
    memset(f, 0, sizeof(f));
    sort(poss.begin(), poss.end(), greater <pair <int, int>> ());
    for (pair <int, int> elem : poss) {
        if (elem.second % 2 == 0) upd(elem.second);
        else tot_ans += get(elem.second - elem.first * 2 + 1, elem.second + elem.first * 2 - 1);
    }
    memset(f, 0, sizeof(f));
    for (pair <int, int> elem : poss) {
        if (elem.second % 2 == 1) upd(elem.second);
        else tot_ans += get(elem.second - elem.first * 2 + 1, elem.second + elem.first * 2 - 1);
    }
    //cout << tot_ans << endl;
}

void calc_ch(string s) {
    int n = s.length();
    vector <pair <int, int>> poss;
    for (int i = 1; i < n; i++) {
        int l = 0, r = n + 1, mid;
        while (r - l > 1) {
            mid = (l + r) / 2;
            if (check_palindrome(n, i - mid + 1, i + mid)) l = mid;
            else r = mid;
        }
        len[i] = l;
        poss.push_back({len[i], i});
    }
    memset(f, 0, sizeof(f));
    sort(poss.begin(), poss.end(), greater <pair <int, int>> ());
    for (pair <int, int> elem : poss) {
        if (elem.second % 2 == 0) continue;
        tot_ans += get(elem.second - elem.first * 2, elem.second + elem.first * 2);
        upd(elem.second);
    }
    memset(f, 0, sizeof(f));
    for (pair <int, int> elem : poss) {
        if (elem.second % 2 == 1) continue;
        tot_ans += get(elem.second - elem.first * 2, elem.second + elem.first * 2);
        upd(elem.second);
    }
}

signed main() {
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    int n;
    string s;
    cin >> n >> s;
    init(s);
    calc_nech(s);
    calc_ch(s);
    cout << tot_ans << endl;
}
