#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <string>

using namespace std;
using ll = long long;
using ld = long double;

const ll p = 179;
const int maxN = 500000;
const ll mod = (ll)1e9 + 7;

int pows[maxN + 1];
int h[maxN + 1], hR[maxN + 1];

void init(const string& s)
{
	pows[0] = 1;
	for (int i = 0; i < s.size(); ++i)
		pows[i + 1] = (pows[i] * p) % mod;

	h[0] = 0;
	for (int i = 0; i < s.size(); ++i)
		h[i + 1] = ((ll)h[i] * p + s[i]) % mod;

	hR[0] = 0;
	for (int i = 0; i < s.size(); ++i)
		hR[i + 1] = ((ll)hR[i] * p + s[s.size() - i - 1]) % mod;
}

int getH(int l, int r)
{
	return ((ll)h[r + 1] - ((ll)h[l] * pows[r - l + 1]) % mod + mod) % mod;
}

int getHR(int l, int r, int n)
{
	return ((ll)hR[n - l] - ((ll)hR[n - r - 1] * pows[r - l + 1]) % mod + mod) % mod;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0;
	cin >> n;

	string s;
	cin >> s;

	init(s);

	vector<vector<int>> c(n, vector<int>(n));
	for (int i = 0; i < n; ++i)
		for (int j = i; j < n; ++j)
			c[i][j] = (getH(i, j) == getHR(i, j, n));

	int cnt = 0;
	for (int len = 1; (len << 1) <= n; ++len)
		for (int i = 0; i + (len << 1) <= n; ++i)
			if (c[i][i + len - 1] && c[i + len][i + (len << 1) - 1])
				++cnt;

	cout << cnt << endl;

	return 0;
}