#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <math.h>
#include <deque>
#define ll long long
#define ld long double

using namespace std;

const int MAXN = 5005;

const ll mod1 = 1200720071;
const ll mod2 = 1791791791;
const ll x1 = 113;
const ll x2 = 43;
vector<ll> p1;
vector<ll> p2;

void precalc() {
	p1.resize(MAXN);
	p2.resize(MAXN);
	p1[0] = 1;
	p2[0] = 1;
	for (int i = 1; i < MAXN; i++) {
		p1[i] = p1[i - 1] * x1 % mod1;
		p2[i] = p2[i - 1] * x2 % mod2;
	}
}

ll geth1(vector<ll>& h, int L, int R, vector<ll>& p, ll mod) {
	ll hr = h[R + 1];
	ll hl = h[L] * p[R - L + 1] % mod;
	hr -= hl;
	hr = (hr % mod + mod) % mod;
	return hr;
}

ll geth2(vector<ll>& h, int L, int R, vector<ll>& p, ll mod) {
	ll hr = h[R + 1] * p[R - L + 1] % mod;
	ll hl = h[L];
	hl -= hr;
	hl = (hl % mod + mod) % mod;
	return hl;
}

bool check(int L, int R, vector<ll> &h1, vector<ll> &h2, vector<ll> &H1, vector<ll> &H2) {
	ll a1 = geth1(h1, L, R, p1, mod1);
	ll a2 = geth1(h2, L, R, p2, mod2);
	ll b1 = geth2(H1, L, R, p1, mod1);
	ll b2 = geth2(H2, L, R, p2, mod2);
	return (a1 == b1) && (a2 == b2);
}

int main() {
	precalc();
	int n;
	cin >> n;
	string s;
	cin >> s;
	vector<ll> h1(n + 1), h2(n + 1);
	for (int i = 1; i <= n; i++) {
		h1[i] = (h1[i - 1] * x1 + (s[i - 1] - 'a') + 1) % mod1;
		h2[i] = (h2[i - 1] * x2 + (s[i - 1] - 'a') + 1) % mod2;
	}
	vector<ll> H1(n + 1), H2(n + 1);
	for (int i = n - 1; i >= 0; i--) {
		H1[i] = (H1[i + 1] * x1 + (s[i] - 'a') + 1) % mod1;
		H2[i] = (H2[i + 1] * x2 + (s[i] - 'a') + 1) % mod2;
	}
	ll ans = 0;
	for (int i = 0; i < n - 1; i++) {
		int x1 = i;
		int x2 = i + 1;
		while (x1 >= 0 && x2 < n) {
			if (check(x1, i, h1, h2, H1, H2) && check(i + 1, x2, h1, h2, H1, H2))
				ans++;
			x1--;
			x2++;
		}
	}
	cout << ans << endl;
}
//*/