#pragma GCC optimize("Ofast,unroll-loops,no-stack-protector,fast-math")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,mmx,avx,avx2")
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define pll pair<ll, ll>

mt19937 rnd;

ll const N = 2e5 + 1, M = 228228227, INF = 1e18, P = 257;
ld const EPS = 1e-10;

void FastIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

void zfunc(string s) {
    vector<ll> z(s.size(), 0);
    ll l = 0, r = 0;
    for (int i = 1; i < s.size(); ++i) {
        if (r >= i) {
            z[i] = min(z[i - l], r - i + 1);
        }

        while (i + z[i] < s.size() && s[z[i]] == s[i + z[i]]) {
            ++z[i];
        }

        if (i + z[i] - 1 > r) {
            r = i + z[i] - 1;
            l = i;
        }
    }
}

void pfunc(string s) {
    vector<ll> p(s.size(), 0);
    for (int i = 1; i < s.size(); ++i) {
        ll j = p[i - 1];
        while (j > 0 && s[i] != s[j]) {
            j = p[j - 1];
        }
        if (s[i] == s[j]) {
            ++j;
        }
        p[i] = j;
    }
}

ll tree[4 * N], mode[4 * N];

void Build(ll v, ll l , ll r) {
    if (r - l == 1) {
        tree[v] = 0;
    }

    ll m = (l + r) / 2;
    Build(v * 2, l, m);
    Build(v * 2 + 1, m, r);
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

void Upd(ll v, ll l, ll r, ll pos, ll val) {
    if (r - l == 1 && l == pos) {
        tree[v] = val;
        return;
    }

    if (l > pos || r <= pos) {
        return;
    }

    ll m = (l + r) / 2;
    Upd(v * 2, l, m, pos, val);
    Upd(v * 2 + 1, m, r, pos, val);
    tree[v] = tree[v * 2] + tree[v * 2 + 1];
}

ll Get(ll v, ll l, ll r, ll ql, ll qr) {
    if (l >= qr || r <= ql) {
        return 0;
    }

    if (l >= ql && r <= qr) {
        return tree[v];
    }

    ll m = (l + r) / 2;
    return Get(v * 2, l, m, ql, qr) + Get(v * 2 + 1, m, r, ql, qr);
}

struct Node {
    ll x, sz, pr;
    Node* left = nullptr;
    Node* right = nullptr;
    Node() {}
    Node(ll _x) {
        x = _x;
        sz = 1;
        pr = rnd();
    }
};

ll GetSz(Node* tree) {
    return (tree ? tree->sz : 0);
}

void Update(Node* tree) {
    tree->sz = GetSz(tree->left) + GetSz(tree->right) + 1;
}

Node* Merge(Node* left, Node* right) {
    if (! left) {
        return right;
    }
    if (! right) {
        return left;
    }

    if (left->pr > right->pr) {
        left->right = Merge(left->right, right);
        Update(left);
        return left;
    }
    else {
        right->left = Merge(left, right->left);
        Update(right);
        return right;
    }
}

pair<Node*, Node*> Split(Node* tree, ll x) {
    if (! tree) {
        return {tree, tree};
    }

    if (GetSz(tree->left) == x - 1) {
        auto tmp = tree->right;
        tree->right = nullptr;
        Update(tree);
        return {tree, tmp};
    }
    else if (GetSz(tree->left) > x - 1) {
        auto tmp = Split(tree->left, x);
        tree->left = tmp.second;
        Update(tree);
        return {tmp.first, tree};
    }
    else {
        auto tmp = Split(tree->right, x - GetSz(tree->left) - 1);
        tree->right = tmp.first;
        Update(tree);
        return {tree, tmp.second};
    }
}

Node* Ins(Node* tree, ll x, ll pos) {
    Node* node = new Node(x);
    auto tmp = Split(tree, pos - 1);
    return Merge(Merge(tmp.first, node), tmp.second);
}

int main() {
    FastIO();

    ll n;
    cin >> n;
    string s;
    cin >> s;

    vector<ll> h(n + 1), rh(n + 1), p(n + 1);

    p[0] = 1;
    for (int i = 1; i <= n; ++i) {
        p[i] = (p[i - 1] * P) % M;
    }

    h[0] = 0;
    rh[0] = 0;
    for (int i = 1; i <= n; ++i) {
        h[i] = ((h[i - 1] * P) % M + (ll)s[i - 1]) % M;
        rh[i] = ((rh[i - 1] * P) % M + (ll)s[n - i]) % M;
    }

    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            if ((j - i + 1) % 2) {
                continue;
            }

            ll l1 = i, r1 = i + (j - i + 1) / 2, l2 = i + (j - i + 1) / 2, r2 = j + 1;
            ll h1 = (h[r1] - (h[l1] * p[r1 - l1]) % M + M) % M;
            ll rh1 = (rh[n - l1] - (rh[n - r1] * p[r1 - l1]) % M + M) % M;
            ll h2 = (h[r2] - (h[l2] * p[r2 - l2]) % M + M) % M;
            ll rh2 = (rh[n - l2] - (rh[n - r2] * p[r2 - l2]) % M + M) % M;
            if (h1 == rh1 && h2 == rh2) {
                ++ans;
            }
        }
    }

    cout << ans;

    return 0;
}
