#pragma region Include
#include<algorithm>
#include<iostream>
#include<assert.h>
#include<utility>
#include<fstream>
#include<vector>
#include<random>
#include<map>
using namespace std;
#pragma endregion
#pragma region Constant
const int N = 2e5, INF = 1e9, MOD = 1e9 + 7;
const long long llINF = 1e18;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (T& el : vec) {
		in >> el;
	}
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> const& vec) {
	for (T const& el : vec) {
		out << el << ' ';
	}
	return out;
}

template<typename T, typename P>
istream& operator >> (istream& in, pair<T, P>& p) {
	in >> p.first >> p.second;
	return in;
}

template<typename T, typename P>
ostream& operator << (ostream& out, pair<T, P> const& p) {
	out << p.first << ' ' << p.second;
}
#pragma endregion

int main() {
	//ifstream cin("input.txt");
	//ofstream cout("output.txt");
	
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int n;
	string s;
	cin >> n >> s;

	vector<int> max_ev_pal(n - 1), max_odd_pal(n);

	for (int i = 0; i + 1 < n; i++) {
		for (int j = 0; i - j >= 0 && i + j + 1 < n; j++) {
			if (s[i - j] == s[i + j + 1]) {
				max_ev_pal[i] = j + 1;
			} else {
				break;
			}
		}
	}

	for (int i = 0; i < n; i++) {
		for (int j = 1; i - j >= 0 && i + j < n; j++) {
			if (s[i - j] == s[i + j]) {
				max_odd_pal[i] = j;
			} else {
				break;
			}
		}
	}

	long long ans = 0;

	for (int mid = 0; mid + 1 < n; mid++) {
		for (int len = 1; mid - len + 1 >= 0 && mid + len < n; len++) {
			if (len & 1) {
				if (max_odd_pal[mid - len / 2] >= len / 2 && max_odd_pal[mid + (len + 1) / 2] >= len / 2) {
					++ans;
				}
			} else {
				if (max_ev_pal[mid - len / 2] >= len / 2 && max_ev_pal[mid + len / 2] >= len / 2) {
					++ans;
				}
			}
		}
	}

	cout << ans << '\n';
}