#include <bits/stdc++.h>

using namespace std;

const int maxn = 5e5 + 3;
const int mod = 1e9 + 7;
const int base = 29;

int n;
string s;
void read()
{
    cin >> n >> s;
}

int len1[maxn], len2[maxn];
long long hsh[maxn], rev_hsh[maxn];
long long base_pow[maxn];

long long get_hsh(int l, int r)
{
    return (hsh[r] - hsh[l-1] * base_pow[r-l+1] % mod + mod) % mod;
}

long long get_rev_hsh(int l, int r)
{
    return (rev_hsh[l] - rev_hsh[r+1] * base_pow[r-l+1] % mod + mod) % mod;
}

bool is_pal(int l, int r)
{
    if (get_hsh(l, r) == get_rev_hsh(l, r))
        return true;

    return false;
}

bool is_double_pal(int l, int r)
{
    if ((r - l + 1) % 2 != 0)
        return false;

    int m = (r - l + 1) / 2;

    if (is_pal(l, l + m - 1) && is_pal(l + m, r))
        return true;

    return false;
}

void solve()
{
    base_pow[0] = 1;
    for (int i = 1; i <= n; i++)
        base_pow[i] = base_pow[i-1] * base % mod;

    for (int i = 1; i <= n; i++)
        hsh[i] = (hsh[i-1] * base + s[i-1] - 'a' + 1) % mod;

    for (int i = n; i >= 1; i--)
        rev_hsh[i] = (rev_hsh[i+1] * base + s[i-1] - 'a' + 1) % mod;

    long long ans = 0;
    for (int i = 1; i <= n; i++)
        for (int j = i; j <= n; j++)
        if (is_double_pal(i, j))
            ans++;

    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
