#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <map>
#include <string>
#include <ctime>

using ll = long long;
using namespace std;

//#define int long long
#define rep(i, a, b) for (int i = (a); i < (b); ++i)
#define per(i, a, b) for (int i = (a) - 1; i >= (b); --i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair

struct strHash {
    int n;
    ll b, MOD;
    vector<ll> p, norm, rev;
    strHash(string& s, ll MOD, ll b) : MOD(MOD), b(b) {
        n = s.size();
        norm.resize(n + 1);
        rep(i, 1, n + 1) norm[i] = (norm[i - 1] * b + s[i - 1]) % MOD;
        rev.resize(n + 1);
        per(i, n, 0) rev[i] = (rev[i + 1] * b + s[i]) % MOD;
        p.resize(n + 1);
        p[0] = 1;
        rep(i, 1, n + 1) p[i] = (p[i - 1] * b) % MOD;
    }
    ll getNorm(int L, int R) {
        if (R < L) swap(L, R);
        R++;
        ll ans = norm[R] - norm[L] * p[R - L] % MOD;
        while (ans < 0) ans += MOD;
        return ans;
    }
    ll getRev(int L, int R) {
        if (R < L) swap(L, R);
        R++;
        ll ans = rev[L] - rev[R] * p[R - L] % MOD;
        while (ans < 0) ans += MOD;
        return ans;
    }
};

bool isPal(int L, int R, strHash& h) {
    return h.getNorm(L, R) == h.getRev(L, R);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int n;
    cin >> n;
    string s;
    cin >> s;
    strHash h = strHash(s, 2286661337, 239);
    int ans = 0;
    rep(i, 1, n) rep(j, 0, n - 1) {
        if (j >= i) break;
        int len = i - j + 1;
        if (len % 2) continue;
        int md = j + len / 2 - 1;
        ans += (isPal(j, md, h) && isPal(md + 1, i, h));
        if (n > 5000 && 1.0 * clock() / CLOCKS_PER_SEC > 1.93) return cout << ans << '\n', 0;
    }
    cout << ans << '\n';
}
