#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}
ll time() {
    return chrono::steady_clock::now().time_since_epoch().count();
}

#define SPAR 0
#define FEN 0

#ifdef SPAR
namespace SPARSE {
    bool run = false;
    const int N = 1e5;
    const int LOG = 17;

    int log[N];

    void init() {
        if (!run) {
            run = true;
            log[0] = 0;

            for (int i = 1; i < LOG; ++i) {
                for (int j = (1 << i); j < (1 << (i + 1)) && j < N; ++j)
                    log[j] = i;
            }
        }
    }
};
struct Sparse {
    int n, p = 0;
    int **t;

    Sparse(int _n) {
        SPARSE::init();
        n = _n;
        t = new int*[n];
        for (int i = 0; i < n; ++i)
            t[i] = new int[SPARSE::LOG];
    }

    void push(int x) {
        t[n - p - 1][0] = x;
        for (int i = 0; i < SPARSE::LOG - 1; ++i) {
            if (n - p - 1 + (1 << i) < n)
                t[n - p - 1][i + 1] = min(t[n - p - 1][i], t[n - p - 1 + (1 << i)][i]);
            else
                t[n - p - 1][i + 1] = t[n - p - 1][i];
        }
        p++;
    }

    int get(int l, int r) {
        int k = SPARSE::log[r - l];

        return min(t[l][k], t[r - (1 << k)][k]);
    }
};
#endif

#ifdef FEN
struct Fen {
    int *t, n;
    Fen(int _n) {
        n = _n;
        t = new int[n];

        memset(t, 0, t[0] * n);
    }

    void add(int i, int x) {
        for (;i < n; i = i | (i + 1))
            t[i] += x;
    }

    int get(int r) {
        r--;
        int res = 0;
        for (;r >= 0; r = (r & (r - 1)) - 1)
            res += t[r];
        return res;
    }
};
#endif

int median(int a, int b, int c) {
    vector<int> v = {a, b, c};

    sort(v.begin(), v.end());

    return v[1];
}

const int CNT = 1;

vector<int> mods = {(int)1e9 + 7, (int)1e9 + 9};
vector<int> base;

struct Hash {
    int n;
    int *t[CNT], *p[CNT];
    Hash(string &s) {
        n = s.length();

        for (int i = 0; i < CNT; ++i) {
            t[i] = new int[n];
            p[i] = new int[n];

            t[i][0] = s[0] - 'a' + 1;
            p[i][0] = 1;

            for (int j = 1; j < n; ++j) {
                t[i][j] = ((ll)t[i][j - 1] * (ll)base[i] + s[j] - 'a' + 1) % mods[i];
                p[i][j] = ((ll)p[i][j - 1] * base[i]) % mods[i];
            }
        }
    }

    vector<int> get(int l, int r) { // [l, r]
        vector<int> res;

        for (int i = 0; i < CNT; ++i) {
            int now = t[i][r];
            if (l)
                now -= ((ll)t[i][l - 1] * p[i][r - l + 1]) % mods[i];
            if (now < 0) now += mods[i];
            res.push_back(now);
        }

        return res;
    }
};

bool check_polindrom(int l, int r, Hash h, Hash rh) {
    if (l == r)
        return true;

    int n = h.n;

    auto a = h.get(l, r);
    auto b = rh.get(n - r - 1, n - l - 1);

    return a == b;
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    mt19937 rnd(time());

    for (int i = 0; i < CNT; ++i)
        base.push_back(rnd() % 30 + 20);

    int n;
    cin >> n;
    string s, rs;
    cin >> s;
    rs = s;
    reverse(rs.begin(), rs.end());

    Hash h(s), rh(rs);

    int res = 0;
    for (int i = 0; i < n - 1; ++i) {
        for (int len = 1; len < n; ++len) {
            int l = i - len + 1;
            int r = i + len;

            if (l < 0 || r >= n)
                break;
            res += check_polindrom(l, i, h, rh) & check_polindrom(i + 1, r, h, rh);
        }
    }

    cout << res;

//    cout << check_polindrom(0, 2, h, rh);

    return 0;
}
