#define FASTIO ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

#ifndef BZ
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

#ifdef Debug
#define LOG(v) cout << #v << ": " << v << "\n";
#else
#define LOG(v) ;
#endif

#define F first
#define S second
#define forEach(c) for (auto &it : c)
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define pb push_back

template <class T>
void chMax(T &a, T b) {
    if (a < b) a = b;
}

template <class T>
void chMin(T &a, T b) {
    if (b < a) a = b;
}

inline ll divUp(ll a, ll b) {
    return (a + b - 1) / b;
}

const ll p = 79;
const ll base = 3000000019;

vector<ll> Hsh(const string &s) {
    vector<ll> h{0};
    forEach(s) {
        h.pb(h.back() * p % base + it);
        h.back() %= base;
    }
    return h;
}

vector<ll> revHsh(string s) {
    reverse(s.begin(), s.end());
    vector<ll> h = Hsh(s);
    reverse(h.begin(), h.end());
    return h;
}

vector<ll> m_pow{1};
inline ll mpow(ll a, ll pw) {
    assert(a == p);
    while (m_pow.size() <= pw + 1) m_pow.pb(m_pow.back() * p % base);
    return m_pow[pw];
}

ll subHash(ll l, ll r, const vector<ll> &h) {
    r++;
    return ((h[r] - h[l] * mpow(p, r - l)) % base + base) % base;
}

ll revSubHash(ll l, ll r, const vector<ll> &rh) {
    r++;
    return ((rh[l] - rh[r] * mpow(p, r - l)) % base + base) % base;
}

bool isPal(ll l, ll r, const vector<ll> &h, const vector<ll> &rh) {
    return revSubHash(l, r, rh) == subHash(l, r, h);
}

void solve() {
#ifndef abracdabra
    ll n;
    string s;
    cin >> n >> s;
    vector<ll> h = Hsh(s);
    vector<ll> rh = revHsh(s);
    ll ans = 0;
    for (ll i = 0; i < n; i++) {
        for (ll d = 1; d <= i; d++) {
            if (i + d > n) break;
            if (isPal(i - d, i - 1, h, rh) && isPal(i, i + d - 1, h, rh)) {
                ans++;
            }
        }
    }
    cout << ans << "\n";
#else
    string s = "aaaaaaa";
    auto h = Hsh(s);
    auto rh = revHsh(s);
    forEach(h) cout << it << " ";
    cout << "\n";
    forEach(rh) cout << it << " ";
    cout << "\n";
    cout << subHash(0, s.size() - 1, h) << "\n";
    cout << revSubHash(0, s.size() - 1, rh) << "\n";
#endif
}

int main() {
    FASTIO
    solve();
    return 0;
}