#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
#include <string>
using namespace std;

typedef long long ll;

#define nl '\n'
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

//comments
/*
	1) N^2
*/

bool palindrom(string& s)
{
	int p1 = 0, p2 = s.size() - 1;
	while (p1 < p2)
	{
		if (s[p1] != s[p2])
			return false;
		++p1; --p2;
	}
	return true;
}

struct hash_
{
private:
	vector<int> prefix, power, reverse_prefix;
	int MOD, BASE;
	int n;
public:
	hash_(string& s, int BASE = 0, int MOD = 0) : n(s.size()), MOD(MOD), BASE(BASE)
	{
		prefix.resize(n + 1);
		power.resize(n + 1);
		reverse_prefix.resize(n + 1);

		power[0] = 1;
		for (int i = 1; i <= n; ++i)
			power[i] = (ll)power[i - 1] * BASE % MOD;

		for (int i = 0; i < n; ++i)
		{
			prefix[i + 1] = ((ll)prefix[i] * BASE % MOD + s[i]) % MOD;
			reverse_prefix[i + 1] = ((ll)reverse_prefix[i] * BASE % MOD + s[n - 1 - i]) % MOD;
		}
	}

	int get_hash(int i, int j)
	{
		++i, ++j;
		return (prefix[j] - (ll)prefix[i - 1] * power[j - i + 1] % MOD + MOD) % MOD;
	}

	int get_reverse_hash(int i, int j)
	{
		++i, ++j;
		int sz = j - i + 1;
		j = n - i + 1;
		i = j - sz + 1;
		return (reverse_prefix[j] - (ll)reverse_prefix[i - 1] * power[j - i + 1] % MOD + MOD) % MOD;
	}

	bool palindrom(int i, int j)
	{
		return get_hash(i, j) == get_reverse_hash(i, j);
	}
};

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;
	string s;
	cin >> s;

	hash_* hs = new hash_(s, 211, 1e9 + 7);
	
	int ans = 0;
	for (int k = 2; k <= n; k += 2)
	{
		for (int i = 0; i <= n - k; ++i)
		{
			
			if (hs->palindrom(i, i + k / 2 - 1) && hs->palindrom(i + k / 2, i + k - 1))
				++ans;
		}
	}
	cout << ans;
	return 0;
}