#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

struct hashs{
    int p;
    int MOD;
    vector<int> pw;
    vector<int> h;

    void init(string &s, int _p, int _MOD){
        p = _p;
        MOD = _MOD;
        int n = s.size();
        h.resize(n + 1);
        pw.resize(n + 1);
        pw[0] = 1;
        for (int i = 0; i < n; i++){
            pw[i + 1] = (pw[i] * p) % MOD;
            h[i + 1] = (h[i] * p + s[i]) % MOD;
        }
    }

    int mod(int a){
        a = a % MOD;
        if (a < 0){
            a += MOD;
        }
        return a;
    }

    int gethash(int l, int r){
        int ost = h[l] * pw[r - l] % MOD;
        return mod(h[r] - ost);
    }

};

bool is_equal(int l1, int r1, hashs h1, int l2, int r2, hashs h2){
    int res1 = h1.gethash(l1, r1);
    int res2 = h2.gethash(l2, r2);
    return res1 == res2;
}

signed main()
{
    int n;
    cin >> n;
    string s;
    cin >> s;
    hashs h;
    h.init(s, 57, 2286661337);
    reverse(s.begin(), s.end());
    hashs hr;
    hr.init(s, 57, 2286661337);
    reverse(s.begin(), s.end());
    vector<int> ch(n - 1);
    vector<int> nc(n);
    for (int i = 0; i < n; i++){
        int l = 0;
        int r = min(i, n - i - 1);
        if (is_equal(i - r, i + 1, h, n - i - r - 1, n - i, hr)){
            nc[i] = r;
        }else{
            while (r - l > 1){
                int m = (r + l) / 2;
                if (is_equal(i - m, i + 1, h, n - i - m - 1, n - i, hr)){
                    l = m;
                }else{
                    r = m;
                }
            }
        }
    }
    for (int i = 0; i < n - 1; i++){
        int l = 0;
        int r = min(i + 1, n - i - 1);
        if (is_equal(i - r + 1, i + 1, h, n - i - r - 1, n - i - 1, hr)){
            ch[i] = r;
        }else{
            while (r - l > 1){
                int m = (r + l) / 2;
                if (is_equal(i - m + 1, i + 1, h, n - i - m - 1, n - i - 1, hr)){
                    l = m;
                }else{
                    r = m;
                }
            }
            ch[i] = l;
        }
    }
    /*for (auto i : nc){
        cout << i << ' ';
    }
    cout << endl;
    for (auto i : ch){
        cout << i << ' ';
    }
    cout << endl;*/
    int ans = 0;
    for (int i = 0; i < n; i++){
        for (int j = i + 1; j < n; j+=2){
            if ((j - i - 1) / 2 <= nc[i] && (j - i - 1) / 2 <= nc[j]){
                ans++;
            }
        }
    }
    for (int i = 0; i < n - 1; i++){
        for (int j = i + 2; j < n - 1; j+=2){
            if ((j - i) / 2 <= ch[i] && (j - i) / 2 <= ch[j]){
                ans++;
            }
        }
    }
    cout << ans << endl;
    return 0;
}
