#include <bits/stdc++.h>

#define int long long
#define endl "\n"
#define pii pair<int, int>
#define B begin
#define E end
#define F first
#define S second

typedef long long ll;

const int INF = 1e9 + 1;
const ll P = 1e9 + 7;
const ll Q = 47;

using namespace std;

void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
}

void show(vector <int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<vector<int>>& arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}

const int MAXN = 2e5 * 4 + 1;
int tree[MAXN];

void build(int v, int cl, int cr, vector <int>& data)
{
    if (cl == cr)
    {
        tree[v] = data[cl];
        return;
    }
    int cm = (cl + cr) / 2;
    build(2 * v, cl, cm, data);
    build(2 * v + 1, cm + 1, cr, data);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

void change(int v, int cl, int cr, int ind, int val)
{
    if (cl > ind || cr < ind)
        return;
    if (cl == cr)
    {
        tree[v] = val;
        return;
    }
    int cm = (cl + cr) / 2;
    change(2 * v, cl, cm, ind, val);
    change(2 * v + 1, cm + 1, cr, ind, val);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

int query(int v, int cl, int cr, int l, int r)
{
    if (cl >= l && cr <= r)
        return tree[v];
    if (cl > r || l > cr)
        return 0;
    int cm = (cl + cr) / 2;
    return query(2 * v, cl, cm, l, r) + query(2 * v + 1, cm + 1, cr, l, r);
}

vector <int> st;

int subhash(int l, int r, vector <int>& hashes)
{
    return (hashes[r] - hashes[l - 1] * st[r - l + 1] + P * P) % P;
}

signed main()
{
    hello();

    int n;
    cin >> n;
    string s;
    cin >> s;
    vector <int> shash(n + 1), rhash(n + 1);
    st.resize(n + 1);
    st[0] = 1;

    for (int i = 1; i <= n; ++i)
    {
        shash[i] = (shash[i - 1] * Q + s[i - 1] - 'a' + 1) % P;
        rhash[i] = (rhash[i - 1] * Q + s[n - i] - 'a' + 1) % P;
        st[i] = st[i - 1] * Q % P;
    }

    int res = 0;
    for (int i = 0; i < n; ++i)
        for (int j = i + 1; j < n; ++j)
        {
            if ((j - i + 1) % 2)
                continue;
            int v1, v2, u1, u2;
            int mid = (j + i) / 2;
            if ((j - i + 1) / 2 % 2)
            {
                v1 = subhash(i + 1, (i + mid) / 2 + 1, shash);
                v2 = subhash(n - mid, n - (i + mid) / 2, rhash);
                ++mid;
                u1 = subhash((j + mid) / 2 + 1, j + 1, shash);
                u2 = subhash(n - (j + mid) / 2, n - mid, rhash);
            }
            else
            {
                v1 = subhash(i + 1, (i + mid) / 2 + 1, shash);
                v2 = subhash(n - mid, n - (i + mid) / 2 - 1, rhash);
                ++mid;
                u1 = subhash((j + mid) / 2 + 1, j + 1, shash);
                u2 = subhash(n - (j + mid) / 2 - 1, n - mid, rhash);
            }
            if (v1 == v2 && u1 == u2)
                ++res;
        }

    cout << res << endl;
}
