#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <climits>
#include <cassert>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <string>
#include <sstream>
#include <deque>
#include <queue>
#include <ctime>

using namespace std;

#define ll long long
#define ull unsigned ll
#define db double
#define ldb long double
#define ior(a) for (auto& i : a)
#define sbe(a) a.begin(), a.end()
#define srbe(a) a.rbegin(), a.rend()
#define pii pair<int, int>

#define int ll

const ll mod = 1e9 + 7;
const ll base = 26;

struct thash {
	ll x;

	thash() : x(0) {}
	thash(ll x) : x((x + mod * mod) % mod) {}
	
	thash operator+ (const thash& obj) const {
		return { x + obj.x };
	}

	thash operator* (const thash& obj) const {
		return { x * obj.x };
	}

	thash operator- (const thash& obj) const {
		return { x - obj.x };
	}

	bool operator== (const thash& obj) {
		return x == obj.x;
	}
};

int n;
vector<thash> powers;

thash line(int l, int r, const vector<thash>& hash) {
	return (hash[r] - (hash[l] * powers[r - l]));
}

bool is_p(int l, int r, const vector<thash>& hash, const vector<thash> rhash) {
	return (line(l, r, hash) == line(n - r - 1, n - l - 1, rhash));
}

void solve() {
	cin >> n;
	string s, s1;
	cin >> s;
	vector<thash> hash(n + 1), rhash(n + 1);
	powers.resize(n + 1);
	powers[0] = 1;
	for (int i = 0; i < n; ++i) {
		hash[i + 1] = hash[i] * base + s[i];
		rhash[i + 1] = rhash[i] * base + s[n - i - 1];
		powers[i + 1] = powers[i] * base;
	}
	int ans = 0;
	for (int l = 0; l < n; ++l)
		for (int r = l; r < n; ++r) {
			if ((r - l + 1) & 1)
				continue;
			if (is_p(l, (l + r) / 2, hash, rhash) && is_p((l + r) / 2 + 1, r, hash, rhash))
				++ans;
		}
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
	return 0;
}