#include <bits/stdc++.h>

using namespace std;

const int MOD = 1e9 + 7;
const int MAXN = 5e4 + 228;
const int P = 50;

int pows[MAXN];

struct Hash {
  vector<int> pref;
  int n;

  Hash(string &a) {
    n = a.size();
    pref.resize(n + 1);
    pref[0] = 0;
    for (int i = 0; i < n; i++) {
      pref[i + 1] = (pref[i] * 1LL * P) % MOD + a[i];
    }
  }

  int substr(int l, int r) { // [l, r]
    return (pref[r + 1] * 1LL - pref[l] * 1LL * pows[r - l + 1] + MOD * 1LL * MOD) % MOD;
  }
};

void precalc() {
  pows[0] = 1;
  for (int i = 1; i < MAXN; i++) {
    pows[i] = (pows[i - 1] * 1LL * P) % MOD;
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);

  precalc();

  int n;
  cin >> n;
  string s;
  cin >> s;
  Hash h(s);
  reverse(s.begin(), s.end());
  Hash rh(s);

  int ans = 0;
  for (int i = 0; i < n - 1; i++) {
    int ri = n - i - 1;
    int maxlen = min(i + 1, n - (i + 1));
    for (int len = 1; len <= maxlen; len++) {
      if (len % 2) {
        if (h.substr(i - len / 2, i) == rh.substr(ri + len / 2, ri + len - 1)
            && h.substr(i + 1, i + len / 2 + 1) == rh.substr(ri - len, ri - len / 2 - 1)) {
          ans++;
        }
      } else {
        if (h.substr(i - len / 2 + 1, i) == rh.substr(ri + len / 2, ri + len - 1)
            && h.substr(i + 1, i + len / 2) == rh.substr(ri - len / 2 - 1, ri - len)) {
          ans++;
        }
      }
    }

  }
  cout << ans;
  return 0;
}