#include <bits/stdc++.h>

using namespace std;

struct my_hash{
    long long base;
    long long mod;
    string s;
    vector < long long > h;
    vector < long long > base_pow;
    my_hash() {}
    my_hash(string s, long long base, long long mod): s(s), base(base), mod(mod) {
        h.resize(s.size(), 0);
        base_pow.resize(s.size() + 1, 0);
        h[0] = s[0] - 'a' + 1;
        for (int i = 1; i < s.size(); i++) {
            h[i] = h[i - 1] * base + s[i] - 'a' + 1;
            h[i] %= mod;
        }
        base_pow[0] = 1;
        for (int i = 1; i <= s.size(); i++) {
            base_pow[i] = base_pow[i - 1] * base;
            base_pow[i] %= mod;
        }
    }
    long long get_lr(int l, int r) {
        if (l == 0) {
            return h[r];
        }
        return (h[r] - (h[l - 1] * base_pow[r - l + 1] % mod) + mod) % mod;
    }
};

int get1(int i, int n, my_hash& a, my_hash& b) {
    int l = 0;
    int r = min(i + 1, n - i) + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        int j = i - m + 1;
        int x = i + 1;
        int y = x + m - 1;
        if (a.get_lr(j, i) == b.get_lr(n - y - 1, n - x - 1)) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

int get2(int c, int n, my_hash& a, my_hash& b) {
    int l = 0;
    int r = min(c, n - c - 1) + 1;
    //cout << a.get_lr(0, 0) << " " << b.get_lr(1, 1) << endl;
    while (r - l > 1) {
        int m = (l + r) / 2;
        int i = c - 1;
        int j = i - m + 1;
        int x = c + 1;
        int y = x + m - 1;
        if (a.get_lr(j, i) == b.get_lr(n - y - 1, n - x - 1)) {
            l = m;
        } else {
            r = m;
        }
    }
    return l + 1;
}

const int MAX_N = 5 * 1e3 + 42;
int x[MAX_N];
int y[MAX_N];

int main() {
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    string s;
    cin >> s;
    long long base = 41;
    long long mod = 1e9 + 7;
    my_hash a(s, base, mod);
    reverse(s.begin(), s.end());
    my_hash b(s, base, mod);
    //cout << get2(1, n, a, b) << endl;
    for (int i = 0; i < n; i++) {
        x[i] = get1(i, n, a, b);
        y[i] = get2(i, n, a, b);
    }
    long long ans = 0;
    for (int i = 0; i < n; i++) {
        for (int len = 1; len <= x[i]; len++) {
            int j = i + 2 * len;
            if (j > n) {
                continue;
            }
            //cout << 1 << " " << i << " " << j << " " << len << endl;
            if (x[j] >= len) {
                ans++;
            }
        }
        for (int len = 1; len <= y[i]; len++) {
            int j = i + 2 * len - 1;
            if (j > n) {
                continue;
            }
            //cout << 2 << " " << i << " " << j << " " << len << endl;
            if (y[j] >= len) {
                ans++;
            }
        }
    }
    cout << ans;
    return 0;
}
