#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>
#include <map>
#include <tuple>
#include <deque>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_set;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    auto find_double_palindromes = [&](string s, bool even) {
        if (even) {
            string t;
            for (ll i = 0; i < (ll) s.size(); i++) {
                if (i != 0) {
                    t.push_back('#');
                }
                t.push_back(s[i]);
            }
            s = t;
        }
        ll n = s.size();
        vector<ll> a(n);
        ll l = -1, r = -1;
        for (ll i = 0; i < n; i++) {
            if (i <= r) {
                ll j = l + r - i;
                a[i] = min(a[j], r - i);
            }
            while (i - a[i] - 1 >= 0 && i + a[i] + 1 < n && s[i - a[i] - 1] == s[i + a[i] + 1]) {
                a[i]++;
            }
            if (i + a[i] > r) {
                l = i - a[i];
                r = i + a[i];
            }
        }
        if (even) {
            for (ll i = 0; i < n; i += 2) {
                if (a[i] % 2 != 0) {
                    a[i]--;
                }
            }
        }
        vector<ll> b(n);
        for (ll i = 0; i < n; i++) {
            b[i] = a[i] * 2 + (even ? 2 : 1);
        }
        if (even) {
            for (ll i = 0; i < n; i += 2) {
                b[i] = -1;
            }
        }
        ll o = 0;
        for (ll i = 0; i < n; i++) {
            for (ll d = even ? 4 : 1; d <= b[i]; d += even ? 4 : 2) {
                if (i + d < n && b[i + d] >= d) {
                    o++;
                }
            }
        }
        return o;
    };
    ll n;
    cin >> n;
    string s;
    cin >> s;
    cout << find_double_palindromes(s, false) + find_double_palindromes(s, true) << endl;
    return 0;
}
