#include <iostream>
#include <map>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <string>
#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define ull unsigned long long
#define ll long long

using namespace std;

int n;
string s;

struct phash {
    const ull base1 = 1e9 + 7;
    const ll base2 = 1e9 + 7;
    vector<ull> pows1;
    vector<ll> pows2;
    vector<ull> hsh1;
    vector<ll> hsh2;
    const ull mxpow = 1e6 + 10;
    const ll mod = (1ll << 31) - 1ll;

    phash(const string& s)
    {
        while (pows1.size() < mxpow)
        {
            if (pows1.empty())
                pows1.push_back(1ll);
            else
                pows1.push_back(pows1.back() * base1);
        }

        hsh1.resize(s.size() + 10, 0);
        
        for (int i = 0; i < s.size(); ++i)
            hsh1[i + 1] = (ull)pows1[i + 1] * s[i] + hsh1[i];

        while (pows2.size() < mxpow)
        {
            if (pows2.empty())
                pows2.push_back(1ll);
            else
                pows2.push_back(pows2.back() * base2 % mod);
        }

        hsh2.resize(s.size() + 10, 0);

        for (int i = 0; i < s.size(); ++i)
            hsh2[i + 1] = ((ll)pows2[i + 1] * s[i] % mod + hsh2[i]) % mod;
    }

    ll sub(ll x, ll y)
    {
        ll sb = x - y;

        if (sb < 0)
            sb += mod;

        return sb;
    }

    pair<ull, ll> gethash(int i, int len)
    {
        ull hash1 = (hsh1[i + len] - hsh1[i]) * ((ull)pows1[mxpow - i - 1]);
        ll hash2 = sub(hsh2[i + len], hsh2[i]) * pows2[mxpow - i - 1];
        hash2 %= mod;

        return make_pair(hash1, hash2);
    }
};

int32_t main()
{
    cin >> n >> s;

    phash sh(s);
    
    string rs = s;

    reverse(rs.begin(), rs.end());

    int ans = 0;

    for(int i = 0; i < s.size(); ++i)
        for(int l = 1; l <= s.size(); ++l)
            if (i + 2 * l - 1 < s.size())
            {
                if (l == 1)
                    ++ans;
                else if (l % 2 == 0 && rs.substr(n - i - 1, l / 2) == s.substr(i + l / 2, l / 2)
                    && rs.substr(n - (i + l) - 1, l / 2) == s.substr(i + l + l / 2, l / 2))
                    ++ans;
                else if (l % 2 == 1)
                    if (rs.substr(n - i - 1, l / 2) == s.substr(i + l / 2 + 1, l / 2)
                        && rs.substr(n - (i + l) - 1, l / 2) == s.substr(i + l + l / 2 + 1, l / 2))
                        ++ans;

            }

    cout << ans << endl;
}


