//#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <sstream>
#include <random>
#include <bitset>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
typedef long long ll;
//#define int ll
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9 + 7;
const ll LINF = 1e18;
const db EPS = 1e-9;

struct fenwick {
    int n;
    vector<int> f;
    fenwick (int _n) {
        n = _n;
        f.assign(n,0);
    }
    void update(int i, int v) {
        for (; i <= n; i += i & (-i)) {
            f[i] += v;
        }
    }
    int get_sum(int i) {
        int s = 0;
        for (; i > 0; i -= i & (-i)) {
            s += f[i];
        }
    }
    int get(int L, int R) {
        return get_sum(R) - get_sum(L - 1);
    }
};

bool check(string a, int len) {
    string s1, s2, s11, s22;
    s1 = a.substr(0, len / 2);
    s11 = s1;
    s2 = a.substr(len / 2, len / 2);
    s22 = s2;
    reverse(all(s11));
    reverse(all(s22));
    return s1 == s11 && s2 == s22;
}

void solve() {
    int N, n;
    string s;
    cin >> N >> s;
    n = N / 2 * 2;
    int cnt = N - 1;
    for (int len = 4; len <= n; len += 2) {
        for (int i = 0; i < N - len + 1; ++i) {
            string sl = s.substr(i, len);
            if (check(sl, len)) ++cnt;
        }
    }
    cout << cnt << en;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}