#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,avx,avx2,popcnt")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second

const int MAXN = 5e5 + 5; 
int n;
string s;
int even[MAXN];
int odd[MAXN];

void find_pals() {
    int mx = -1, ps = 0;
    for (int i = 0; i < n; ++i) {
        if (mx > i) {
            even[i] = min(mx - i, even[ps - (i - ps)]);
        }
        while (i + even[i] + 1 < n && s[i + even[i] + 1] == s[i - even[i]]) {
            even[i]++;
        }
        if (i + even[i] > mx) {
            mx = i + even[i];
            ps = i;
        }
    }

    mx = -1, ps = 0;
    for (int i = 0; i < n; ++i) {
        if (mx > i) {
            odd[i] = min(mx - i + 1, odd[ps - (i - ps)]);
        }
        while (i + odd[i] < n && s[i + odd[i]] == s[i - odd[i]]) {
            odd[i]++;
        }
        if (i + odd[i] - 1 > mx) {
            mx = i + odd[i] - 1;
            ps = i;
        }
    }
}

int fen[MAXN * 2];

void init() {
    memset(fen, 0, sizeof(fen));
}

void add(int p, int x) {
    p += MAXN;
    for (int i = p; i < MAXN * 2; i = (i | (i + 1))) {
        // cout << "> " << i << endl;
        fen[i] += x;
    }
}

int get(int r) {
    r += MAXN;
    int res = 0;
    for (int i = r; i >= 0; i = (i & (i + 1)) - 1) {
        res += fen[i];
    }
    return res;
}

struct query {
    int x, y, k;
};

bool operator<(const query &a, const query &b) {
    return a.x < b.x;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n;
    cin >> s;
    find_pals();
    
    // rep(i, n) {
    //     cout << even[i] << ' ';
    // }
    // cout << endl;
    // rep(i, n) {
    //     cout << odd[i] << ' ';
    // }
    // cout << endl;

    ll res = 0;

    rep(t, 2) {
        init();
        vector<query> q;
        for (int i = t; i < n; i += 2) {
            q.push_back({i, i, -1});
            q.push_back({i + 2 * even[i], i, 1});
        }
        sort(all(q));

        // for (auto it : q) {
        //     cout << it.x << ' ' << it.y << ' ' << it.k << endl;
        // }
        int j = 0;
        for (int i = t; i < n; i += 2) {
            // cout << i << endl;
            add(i - 2 * even[i], 1);
            while (j < q.size() && q[j].x <= i) {
                // cout << ": " << j << endl;
                res += get(q[j].y) * q[j].k;
                j++;
            }
        }

        while (j < q.size()) {
            // cout << ": " << j << endl;
            res += get(q[j].y) * q[j].k;
            j++;
        }

        // return 0;
    }

    // for (int i = 0; i < n; ++i) {
    //     for (int j = i + 2; j < n; j += 2) {
    //         int d = (j - i) / 2;
    //         if (even[i] >= d && even[j] >= d) {
    //             res++;
    //         }
    //     }
    // }

    rep(t, 2) {
        init();
        vector<query> q;
        for (int i = t; i < n; i += 2) {
            if (i - 1 >= 0) q.push_back({i - 1, i, -1});
            q.push_back({i + 2 * odd[i] - 1, i, 1});
        }
        sort(all(q));

        // for (auto it : q) {
        //     cout << it.x << ' ' << it.y << ' ' << it.k << endl;
        // }
        int j = 0;
        for (int i = (t ^ 1); i < n; i += 2) {
            // cout << i << endl;
            add(i - 2 * odd[i], 1);
            while (j < q.size() && q[j].x <= i) {
                // cout << ": " << j << endl;
                res += get(q[j].y - 1) * q[j].k;
                j++;
            }
        }

        while (j < q.size()) {
            // cout << ": " << j << endl;
            res += get(q[j].y - 1) * q[j].k;
            j++;
        }

        // return 0;
    }

    // for (int i = 0; i < n; ++i) {
    //     for (int j = i + 1; j < n; j += 2) {
    //         int d = (j - i + 1) / 2;
    //         if (odd[i] >= d && odd[j] >= d) {
    //             res++;
    //         }
    //     }
    // }

    cout << res << endl;
}
