#include <iostream>
#include <math.h>
#include <vector>
#include <map>
#include <algorithm>
#include <random>
#include <chrono>
#include <set>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,popcnt")

#define ll long long
#define vll vector<ll>
#define pb push_back
#define pll pair<ll, ll>
#define vii vector<int>
#define pii pair<int, int>
#define vpll vector<pll>
#define f first
#define s second

#define MOD (ll)(1e9 + 7)

vll p;
vll h;

ll count_hash(ll l, ll r)
{
    if(l == 0)
        return h[r];

    return (h[r] - h[l] * p[r - l + 1] + MOD) % MOD;
}

bool check(ll l, ll r)
{
    if(l == r)
        return 1;

    ll len = r - l + 1;
    ll l1, r1, l2, r2;
    l1 = l;
    r1 = l1 + len / 2 - 1;

    if(len % 2 == 0)
        l2 = r1 + 1;
    else
        l2 = r1 + 2;
    r2 = l2 + len / 2 - 1;


   // cerr << "l " << l << " r " << r << endl;
   // cerr << "comparing pairA " << l1 << " " << r1 << " pairB " << l2 << " " << r2 << endl;
   // cerr << "res " << count_hash(l1, r1) << " " << count_hash(l2, r2) << endl;
    return count_hash(l1, r1) == count_hash(l2, r2);
}
int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n;
    cin >> n;
    string st;
    cin >> st;

    p.resize(n + 2);
    for(int i = 1; i < n; i++)
        p[i] = (p[i - 1] * 31) % MOD;

    h.resize(n);
    h[0] = st[0] - 'a' + 1;
    for(int i = 1; i < st.size(); i++)
        h[i] = ((h[i - 1] * p[1]) % MOD + st[i] - 'a' + 1 + MOD) % MOD;

    ll answ = 0;
    for(int l = 0; l < n; l++)
    {
        for(int r = l + 1; r < n; r++)
        {
            int len = r - l + 1;
            if(len % 2 == 1)
                continue;

            ll l1 = l;
            ll r1 = l + len / 2 - 1;
            ll l2 = r1 + 1;
            ll r2 = l2 + len / 2 - 1;

            if(check(l1, r1) && check(l2, r2))
                answ++;
        }
    }
    cout << answ << endl;
    return 0;
}