#include <bits/stdc++.h>

using namespace std;

const int maxn = 5e5 + 3;
const int mod = 1e9 + 7;
const int base = 29;

int n;
string s;
void read()
{
    cin >> n >> s;
}

int len1[maxn], len2[maxn];
long long hsh[maxn], rev_hsh[maxn];
long long base_pow[maxn];
int tr[2][maxn];

void clear(int *fenw)
{
    for (int i = 1; i <= n; i++)
        fenw[i] = 0;
}

void add(int *fenw, int pos, int val)
{
    for (int i = pos; i <= n; i += i & -i)
        fenw[pos] += val;
}

int get_prefix(int *fenw, int pos)
{
    pos = min(pos, n);
    int ans = 0;
    for (int i = pos; i >= 1; i -= i & -i)
        ans += fenw[i];

    return ans;
}

long long get_hsh(int l, int r)
{
    return (hsh[r] - hsh[l-1] * base_pow[r-l+1] % mod + mod) % mod;
}

long long get_rev_hsh(int l, int r)
{
    return (rev_hsh[l] - rev_hsh[r+1] * base_pow[r-l+1] % mod + mod) % mod;
}

bool is_pal(int l, int r)
{
    if (get_hsh(l, r) == get_rev_hsh(l, r))
        return true;

    return false;
}

void solve()
{
    base_pow[0] = 1;
    for (int i = 1; i <= n; i++)
        base_pow[i] = base_pow[i-1] * base % mod;

    for (int i = 1; i <= n; i++)
        hsh[i] = (hsh[i-1] * base + s[i-1] - 'a' + 1) % mod;

    for (int i = n; i >= 1; i--)
        rev_hsh[i] = (rev_hsh[i+1] * base + s[i-1] - 'a' + 1) % mod;

    for (int i = 1; i <= n; i++)
    {
        int low = 0, high = min(i-1, n-i);
        while (low < high)
        {
            int mid = (low + high + 1) / 2;
            if (is_pal(i-mid, i+mid))
                low = mid;

            else
                high = mid-1;
        }

        len1[i] = low;
    }

    for (int i = 1; i <= n; i++)
    {
        int low = 0, high = min(i-1, n-i+1);
        while (low < high)
        {
            int mid = (low + high + 1) / 2;
            if (is_pal(i-mid, i+mid-1))
                low = mid;

            else
                high = mid-1;
        }

        len2[i] = low;
    }

    set <pair <int, int> > s;
    long long ans = 0;
    for (int i = n; i >= 1; i--)
    {
        for (;;)
        {
            if (s.empty())
                break;

            auto it = prev(s.end());
            if (it->first > i+1)
            {
                add(tr[it->second%2], it->second, -1);
                s.erase(it);
            }

            else
                break;
        }

        ans += get_prefix(tr[(i%2+1)%2], 2*len1[i]+i+1);
        add(tr[i%2], i, 1);
        s.insert({i-2*len1[i], i});
    }

    s.clear();
    clear(tr[0]);
    clear(tr[1]);

    for (int i = n; i >= 1; i--)
    {
        for (;;)
        {
            if (s.empty())
                break;

            auto it = prev(s.end());
            if (it->first > i)
            {
                add(tr[it->second%2], it->second, -1);
                s.erase(it);
            }

            else
                break;
        }

        ans += get_prefix(tr[i%2], 2*len2[i]+i);
        add(tr[i%2], i, 1);
        s.insert({i-2*len2[i], i});
    }

    cout << ans << endl;

}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
