#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <deque>
#include <set>

typedef long long ll;
using namespace std;
int p = 31, mod = 1e9 + 7, n;
vector<int> pow, hashes, revhashes;

int gethash(int l, int r){
    if(l == 0) return hashes[r];
    return (hashes[r] - (hashes[l - 1]*pow[r - l + 1])%mod)%mod;
}

int getrevhash(int l, int r){
    if(r == n - 1) return revhashes[l];
    return (revhashes[l] - (revhashes[r + 1]*pow[r - l + 1])%mod)%mod;
}


signed main()
{
    cin >> n;
    string s; cin >> s;
    hashes.resize(n);
    revhashes.resize(n);
    pow.resize(n);
    pow[0] = 1;
    for(int i = 1; i < n; i++){
        pow[i] = (pow[i - 1] * p)%mod;
    }
    hashes[0] = s[0] - 'a';
    revhashes[n - 1] = s[n - 1] - 'a';
    for(int i = 1; i < n; i++){
        hashes[i] = ((hashes[i - 1] * p)%mod + (s[i] - 'a'))%mod;
        revhashes[n - i - 1] = ((revhashes[n - i] * p)%mod + (s[n - i - 1] - 'a'))%mod;
    }
    int ans = 0;
    for(int i = 1; i < n; i+=2){
        for(int j = 0; j + i < n; j++){
            int bm  = (2*j + i)/2;
            if(gethash(j, bm) == getrevhash(j, bm) && gethash(bm + 1, i + j) == getrevhash(bm + 1, i + j)){
                ans++;
            }
        }
    }
    cout << ans;
}