#include <iostream>
#include <vector>
#include <algorithm>
#define int long long

using namespace std;

const int P = 27;
const int MOD = 1e9 + 7;
const int NUM = 5 * 1e3;

vector<int> hash1; // прямая строка
vector<int> hash2; // обратная строка
vector<int> pows;

void completePows() {
	pows.push_back(1);
	for (int i = 1; i <= NUM; i++) {
		int temp = pows[(int)pows.size() - 1] * P % MOD;
		pows.push_back(temp);
	}
}

void completeHash(string s, vector<int>& hash) {
	hash.push_back(0);
	for (int i = 0; i < (int)s.size(); i++) {
		int temp = (hash[hash.size() - 1] + ((s[i] - 'a' + 1) * pows[i] % MOD)) % MOD; 
		hash.push_back(temp);
	}
}

signed main() {
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	int n;
	cin >> n;
	string s;
	cin >> s;
	string sRev = s;
	reverse(sRev.begin(), sRev.end());

	completePows();
	completeHash(s, hash1);
	completeHash(sRev, hash2);

	int ans = 0;

	/*for (auto x: hash1) {
		cout << x << ' ';
	}
	cout << endl;

	for (auto x: hash2) {
		cout << x << ' ';
	}
	cout << endl; */

	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if ((j - i + 1) % 2 == 0) {
				int l1 = i;
				int r1 = i + (j - i + 1) / 2 - 1;
				int l2 = i + (j - i + 1) / 2;
				int r2 = j;

				int h11 = (hash1[r1 + 1] - hash1[l1]) % MOD / pows[l1];
				int h12 = (hash2[n - l1] - hash2[n - r1 - 1]) % MOD / pows[n - r1 - 1];

				int h21 = (hash1[r2 + 1] - hash1[l2]) % MOD / pows[l2];
				int h22 = (hash2[n - l2] - hash2[n - r2 - 1]) % MOD / pows[n - r2 - 1];

				if (h11 == h12 && h21 == h22) {
					//cout << l1 << ' ' << r1 << '-' << l2 << ' ' << r2 << endl;
					ans++;
				}
				
			}
		}
	}
	cout << ans;
}	