//#pragma GCC optimize "-O3"
#include "bits/stdc++.h"

#define le(v) ((int)v.size())
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define x first
#define y second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v)
		os << x << " ";
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &pp) {
	os << pp.x << " " << pp.y << " ";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v)
		is >> x;
	return is;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &pp) {
	is >> pp.x >> pp.y;
	return is;
}

vector<int> manacher(string s) {
	vector<int> eq(le(s), 1);
	for (int i = 0; i < le(s); i++) {
		while (true) {
			int a = i - eq[i];	
			int b = i + eq[i];
			if (a < 0 || b >= le(s)) break;
			if (s[a] != s[b]) break;
			eq[i]++;
		}
	}
	return eq;
}

void run() {
	int n; cin >> n;
	string s; cin >> s;
	string t;
	for (char c : s) {
		t += '*';
		t += c;
	}
	t += "*";
	int total = 0;
	{
		vector<int> eq = manacher(s);
		// cout << s << endl;
		// cout << eq << endl;
		for (int i = 0; i < le(s); i++) {
			for (int j = 0; j < i; j++) {
				if ((i + j) % 2 != 0)
				if ((i - j + 1) <= 2 * min(eq[i], eq[j])) {
					total++;
				}
			}
		}
	}
	{
		vector<int> eq = manacher(t);
		for (int i = 0; i < le(t); i++) {
			if (t[i] == '*')
			for (int j = 0; j < i; j++) {
				if (t[j] == '*') {
					if ((i - j) % 4 == 0) {
						if ((i - j + 1) <= 2 * min(eq[i], eq[j]) - 1) {
							total++;
						}
					}
				}
			}
		}
	}
	cout << total << endl;
}

signed main(int argc, char const *argv[]) {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	// freopen("test.in", "r", stdin);
	run();
}