#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES

#pragma GCC optimize("Ofast")
//#pragma GCC target("sse, sse2, sse3, avx, avx2, popcnt")
//#pragma GCC optimize("fast-math")
//#pragma GCC optimize("uroll-loops")

#include <iostream>
#include <math.h>
#include <algorithm>
#include <bitset>
#include <vector>
#include <string>
#include <random>
#include <iomanip>
#include <time.h>
#include <map>
#include <set>
#include <stack>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <cassert>

#define nn '\n'
#define pp ' '
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair

using namespace std;

typedef long long ll;
typedef long double ld;

template <typename T>
bool uax(T& a, T b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uin(T& a, T b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
void debug(string name, T r) {
	cout << name << " = " << r << nn;
}
#define value(x) debug(#x, x);

mt19937 rnd(1928);

//struct Seg {
//	int l, r, pos;
//	bool ty;
//	Seg() {};
//	Seg(int l_, int r_, int pos_, bool ty_) {
//		l = l_;
//		r = r_;
//		pos = pos_;
//		ty = ty_;
//	}
//};

struct Act {
	int pos, ind;
	bool ty;
	Act() {};
	Act(int pos_, int ind_, bool ty_) {
		pos = pos_;
		ty = ty_;
		ind = ind_;
	}
	bool operator<(Act r) {
		return pos < r.pos;
	}
};

const int N = 5e5 + 7;
const int MOD1 = 1e9 + 7;
const int MOD2 = 1e9 + 9;
const int P = 31;

pair<int, int> poww[N];

struct Hash {
	int h1, h2;
	Hash() {
		h1 = h2 = 0;
	}
	Hash(int h1_, int h2_) {
		h1 = h1_;
		h2 = h2_;
	}
	bool operator== (Hash q) {
		return (h1 == q.h1 && h2 == q.h2);
	}
	void add(char t) {
		h1 = (ll(h1) * P + (t - 'a' + 1)) % MOD1;
		h2 = (ll(h2) * P + (t - 'a' + 1)) % MOD2;
	}
	Hash operator*(int ind) {
		Hash r;
		r.h1 = (ll(h1) * poww[ind].first) % MOD1;
		r.h2 = (ll(h2) * poww[ind].second) % MOD2;
		return r;
	}
	Hash operator+(Hash t) {
		Hash r;
		r.h1 = (h1 + t.h1) % MOD1;
		r.h2 = (h2 + t.h2) % MOD2;
		return r;
	}
	Hash operator-(Hash t) {
		Hash r;
		r.h1 = (h1 - t.h1 + MOD1) % MOD1;
		r.h2 = (h2 - t.h2 + MOD2) % MOD2;
		return r;
	}
};

int n;
string s;
vector<Hash> h, rh;
ll ans = 0;

Hash get_hash(int l, int r) {
	if (!l) return h[r];
	return h[r] - h[l - 1] * (r - l + 1);
}

Hash get_rhash(int l, int r) {
	l = n - l - 1;
	r = n - r - 1;
	swap(l, r);
	if (!l) return rh[r];
	return rh[r] - rh[l - 1] * (r - l + 1);
}

//int lb(int x) {
//	if (!x) return 1;
//	return (x & (-x));
//}
//
//void upd(vector<int> &t, int pos, int del) {
//	pos++;
//	for (; pos < n; pos += lb(pos)) {
//		t[pos] += del;
//	}
//}
//
//int summ(vector<int> &t, int pos) {
//	int res = 0;
//	for (; pos >= 0; pos -= lb(pos)) {
//		res += t[pos];
//	}
//	return res;
//}
//int summ(vector<int> &t, int l, int r) {
//	l++; r++;
//	return summ(t, r) - summ(t, l - 1);
//}

void precalc() {
	poww[0] = mp(1, 1);
	for (int i = 1; i < N; i++) {
		poww[i].first = (ll(poww[i - 1].first) * P) % MOD1;
		poww[i].second = (ll(poww[i - 1].second) * P) % MOD2;
	}
}

void build_hash(string& s, vector<Hash>& h) {
	int n = s.size();
	Hash cur = Hash();
	h.resize(n);
	for (int i = 0; i < n; i++) {
		cur.add(s[i]);
		h[i] = cur;
	}
}

int get_chet_len(int pos) {
	int l = 0, r = min(n - pos - 1, pos + 1) + 1, mid;
	while (r > l + 1) {
		mid = (l + r) / 2;
		if (get_hash(pos - mid + 1, pos) == get_rhash(pos + 1, pos + mid)) {
			l = mid;
		}
		else r = mid;
	}
	return l;
}

int get_nechet_len(int pos) {
	int l = 1, r = min(n - pos, pos + 1) + 1, mid;
	while (r > l + 1) {
		mid = (l + r) / 2;
		Hash a = get_hash(pos - mid + 1, pos - 1);
		Hash b = get_rhash(pos + 1, pos + mid - 1);
		if (get_hash(pos - mid + 1, pos - 1) == get_rhash(pos + 1, pos + mid - 1)) {
			l = mid;
		}
		else r = mid;
	}
	return l;
}

int lp[N];

//vector<int> tc, tn;

void solve_chet() {
	for (int i = 0; i < n - 1; i++) {
		lp[i] = get_chet_len(i);
	}
	for (int i = 0; i < n - 1; i++) {
		for (int j = i + 2, cur = 1; j < n - 1; j += 2, cur++) {
			if (lp[i] >= cur && lp[j] >= cur) ans++;
		}
	}
}

void solve_nechet() {
	for (int i = 0; i < n; i++) {
		lp[i] = get_nechet_len(i);
	}
	for (int i = 0; i < n; i++) {
		for (int j = i + 1, cur = 1; j < n; j += 2, cur++) {
			if (lp[i] >= cur && lp[j] >= cur) ans++;
		}
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#endif
	precalc();
	cin >> n;
	cin >> s;
	build_hash(s, h);
	reverse(all(s));
	build_hash(s, rh);
	reverse(all(s));
	solve_chet();
	solve_nechet();
	cout << ans;
}