#include <iostream>
#include <vector>
#include <random>
#include <algorithm>
#define ll long long

using namespace std;

const ll MOD1 = 955555561;
const ll MOD2 = 955555547;
const ll P = 29;

void create_hash(vector <ll>& h1_s, vector <ll>& h2_s, vector <ll> &p1, vector <ll> &p2, string &s) {
	h1_s[0] = s[0] - 'a' + 1;
	h2_s[0] = s[0] - 'a' + 1;
	for (ll i = 1; i < s.size(); i++) {
		h1_s[i] = (h1_s[i - 1] + (s[i] - 'a' + 1) * p1[i]) % MOD1;
		h2_s[i] = (h2_s[i - 1] + (s[i] - 'a' + 1) * p2[i]) % MOD2;
	}
}

bool check(vector <ll>& hs, vector <ll>& hr, vector <ll>& p, ll l, ll r, ll n, ll MOD) {
	ll a = hs[r];
	if (l > 0)
		a -= hs[l - 1];
	a = (a + MOD) % MOD;
	a = a * p[n - r] % MOD;
	ll b = hr[n - l - 1];
	if (n - r - 1 > 0)
		b -= hr[n - r - 2];
	b = (b + MOD) % MOD;
	b = b * p[l + 1] % MOD;
	return (a == b);
}

int main() {
	ll n;
	cin >> n;
	string s;
	cin >> s;
	vector <ll> h1_s(n), h2_s(n), h1_r(n), h2_r(n);
	vector <ll> p1(n + 1), p2(n + 1);
	p1[0] = p2[0] = 1;
	for (ll i = 1; i <= n; i++) {
		p1[i] = p1[i - 1] * P % MOD1;
		p2[i] = p2[i - 1] * P % MOD2;
	}
	create_hash(h1_s, h2_s, p1, p2, s);
	reverse(s.begin(), s.end());
	create_hash(h1_r, h2_r, p1, p2, s);
	ll ans = 0;
	for (ll l = 0; l < n; l++) 
		for (ll r = l + 1; r < n; r += 2) {
			ll m = (l + r) / 2;
			bool tf = check(h1_s, h1_r, p1, l, m, n, MOD1) && check(h1_s, h1_r, p1, m + 1, r, n, MOD1) && check(h2_s, h2_r, p2, l, m, n, MOD2) && check(h2_s, h2_r, p2, m + 1, r, n, MOD2);
			ans += tf;
		}
	cout << ans;
	return 0;
}