#include<iostream>

using namespace std;

const int MAXN = 5e5 + 5;
const pair <long long, long long> key = {29, 31};
const pair <long long, long long> mod = {1e9+7, 1e9+9};

int n;
string s;

pair <long long, long long> p[MAXN];
pair <long long, long long> h[MAXN], hRev[MAXN];

int palSize[MAXN];

void Init()
{
    p[0] = {1, 1};
    for(int i = 1;i<=n;i++)
    {
        p[i].first = (p[i-1].first*key.first)%mod.first;
        p[i].second = (p[i-1].second*key.second)%mod.second;
    }

    h[0] = {s[0]-'a'+1, s[0]-'a'+1};
    for(int i = 1;i<n;i++)
    {
        h[i].first = (h[i-1].first*key.first+(s[i]-'a'+1))%mod.first;
        h[i].second = (h[i-1].second*key.second+(s[i]-'a'+1))%mod.second;
    }

    hRev[n-1] = {s[n-1]-'a'+1, s[n-1]-'a'+1};
    for(int i = n-2;i>=0;i--)
    {
        hRev[i].first = (hRev[i+1].first*key.first+(s[i]-'a'+1))%mod.first;
        hRev[i].second = (hRev[i+1].second*key.second+(s[i]-'a'+1))%mod.second;
    }
}

pair <long long, long long> getHash(int l, int r)
{
    if(l==0) return h[r];
    return {(h[r].first-h[l-1].first*p[r-l+1].first+mod.first*mod.first)%mod.first,
            (h[r].second-h[l-1].second*p[r-l+1].second+mod.second*mod.second)%mod.second};
}

pair <long long, long long> getHashRev(int l, int r)
{
    if(r==n-1) return hRev[l];
    return {(hRev[l].first-hRev[r+1].first*p[r-l+1].first+mod.first*mod.first)%mod.first,
            (hRev[l].second-hRev[r+1].second*p[r-l+1].second+mod.second*mod.second)%mod.second};
}

long long solveOdd()
{
    long long answer = 0;
    for(int i = 0;i<n;i++)
    {
        int l = 1, r = min(i+1, n-i), mid;
        while(l+1<r)
        {
            mid = (l+r)/2;

            if(getHash(i-mid+1, i)==getHashRev(i, i+mid-1)) l = mid;
            else r = mid - 1;
        }

        if(getHash(i-r+1, i)==getHashRev(i, i+r-1)) palSize[i] = r;
        else palSize[i] = l;
    }

    for(int i = 0;i<n;i++)
    {
        //cout << " --- " << i << " --- " << '\n';
        for(int j = 0;j<i;j++)
        {
            if(i-palSize[i]*2+1>j) continue;
            if(i%2==j%2) continue;


            if(j+palSize[j]*2-1>=i)
            {
                answer++;
                //cout << " -> " << j << '\n';
            }
        }
    }

    return answer;
}

long long solveEven()
{
    long long answer = 0;
    for(int i = 0;i<n-1;i++)
    {
        int l = 0, r = min(i+1, n-i-1), mid;
        while(l+1<r)
        {
            mid = (l+r)/2;

            if(getHash(i-mid+1, i)==getHashRev(i+1, i+1+mid-1)) l = mid;
            else r = mid - 1;
        }

        if(getHash(i-r+1, i)==getHashRev(i+1, i+1+r-1)) palSize[i] = r;
        else palSize[i] = l;

        //cout << i << " -> " << palSize[i] << '\n';
    }

    for(int i = 0;i<n-1;i++)
    {
        //cout << " --- " << i << " --- " << '\n';
        for(int j = 0;j<i;j++)
        {
            if(i-palSize[i]*2+1-1>j) continue;
            if(i%2!=j%2) continue;

            if(j+1+palSize[j]*2-1>=i)
            {
                answer++;
                //cout << " -> " << j << '\n';
            }
        }
    }

    return answer;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    long long answer = 0;

    cin >> n;
    cin >> s;

    Init();
    answer += solveOdd();
    //cout << "%%%%%%%%%%%" << '\n';
    answer += solveEven();

    cout << answer << '\n';
}
