#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;
typedef double dbl;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

const int maxN = 500005;
int n;
string s;
int dp[maxN];
int dq[maxN];

struct Hash
{
    static const int MA = 998244353, MB = 100992299;

    int a, b;

    Hash(): a(0), b(0)
    {
    }
    Hash(int _a): a(_a), b(_a)
    {
    }
    Hash(int _a, int _b): a(_a), b(_b)
    {
    }

    Hash operator + (const Hash &x) const
    {
        return Hash((a + x.a) % MA, (b + x.b) % MB);
    }
    Hash operator + (int x) const
    {
        return Hash((a + x) % MA, (b + x) % MB);
    }
    Hash operator - (const Hash &x) const
    {
        return Hash((a - x.a + MA) % MA, (b - x.b + MB) % MB);
    }
    Hash operator - (int x) const
    {
        return Hash((a - x + MA) % MA, (b - x + MB) % MB);
    }
    Hash operator * (const Hash &x) const
    {
        return Hash(a * (ll)x.a % MA, b * (ll)x.b % MB);
    }
    Hash operator * (int x) const
    {
        return Hash(a * (ll)x % MA, b * (ll)x % MB);
    }
    bool operator == (const Hash &x) const
    {
        return a == x.a && b == x.b;
    }
};
const Hash B(31);
Hash pw[maxN];

Hash append(Hash H, char c)
{
    return H * B + (c - 'a' + 1);
}

Hash pref[maxN], suf[maxN];

Hash pgt(int l, int r)
{
    return pref[r + 1] - pref[l] * pw[r - l + 1];
}
Hash sgt(int l, int r)
{
    return suf[l] - suf[r + 1] * pw[r - l + 1];
}

bool palindrome(int l, int r)
{
    if ((r - l + 1) % 2 == 0)
    {
        int i = (l + r) / 2;
        return pgt(l, i) == sgt(i + 1, r);
    }
    else
    {
        int i = (l + r) / 2;
        return pgt(l, i) == sgt(i, r);
    }
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    pw[0] = Hash(1);
    for (int i = 1; i < maxN; ++i)
        pw[i] = pw[i - 1] * B;

    cin >> n >> s;
    pref[0] = Hash(0);
    for (int i = 0; i < n; ++i)
    {
        pref[i + 1] = append(pref[i], s[i]);
    }
    suf[n] = Hash(0);
    for (int i = n - 1; i >= 0; --i)
    {
        suf[i] = append(suf[i + 1], s[i]);
    }
    for (int i = 0; i < n; ++i)
    {
        int l = 1;
        int r = min(i + 1, n - i) + 1;
        while (r - l > 1)
        {
            int j = (l + r) / 2;
            if (palindrome(i - j + 1, i + j - 1))
                l = j;
            else
                r = j;
        }
        dp[i] = l;
    }
    for (int i = 1; i < n; ++i)
    {
        dq[i] = 0;
        int l = 0;
        int r = min(i, n - i) + 1;
        while (r - l > 1)
        {
            int j = (l + r) / 2;
            if (palindrome(i - j, i + j - 1))
                l = j;
            else
                r = j;
        }
        dq[i] = l;
    }
    ll ans = 0;
    for (int i = 0; i < n; ++i)
    {
        for (int j = 0; j < i; ++j)
        {
            if (i % 2 == j % 2)
            {
                if (2 * dp[j] + j >= i + 1 && j >= i + 1 - 2 * dp[i])
                {
                    ++ans;
                }
                if (2 * dq[j] + j >= i && j >= i - 2 * dq[i])
                {
                    ++ans;
                }
            }
        }
    }
    cout << ans << '\n';

    return 0;
}

