#define _CRT_SECURE_NO_WARNINGS
#define mp make_pair
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define allv(a) a.begin(), a.end()
#define allar(a, n) a, a + n
#define fastio ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

#include <functional>
#include <algorithm>
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>
#include <queue>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int INF = (int)1e9 + 7;
const ll MOD = (ll)1e9 + 7;
const db EPS = 1e-7;

const int N = (int)5e5;

struct node {
    vector <int> elems;
};

int n;
node t0[4 * N], t1[4 * N];
string s;
vector <int> p1, p0;

void make_pals_1(string & s, vector <int> & p) {
    p[0] = 0;
    int md = 0, r = 0;
    for (int i = 1; i < s.size(); ++i) {
        if (i <= r) {
            p[i] = min(r - i, p[2 * md - i]);
        }
        while (i - p[i] - 1 >= 0 && i + p[i] + 1 < s.size() && s[i - p[i] - 1] == s[i + p[i] + 1]) {
            ++p[i];
        }
        if (i + p[i] > r) {
            r = i + p[i];
            md = i;
        }
    }
}

void make_pals_0(string& s, vector <int>& p) {
    p[0] = 0;
    int md = 0, r = 0;
    for (int i = 1; i < s.size(); ++i) {
        if (i <= r) {
            p[i] = min(r - i, p[2 * md - i]);
        }
        while (i - p[i] - 1 >= 0 && i + p[i] < s.size() && s[i - p[i] - 1] == s[i + p[i]]) {
            ++p[i];
        }
        if (i + p[i] > r) {
            r = i + p[i];
            md = i;
        }
    }
}

void build(vector <int>& p, node t[4 * N], int r, int v = 0, int vl = 0, int vr = s.size()) {
    t[v].elems.clear();
    for (int i = vl; i < vr; ++i) {
        if (i % 2 == r) {
            t[v].elems.push_back(p[i]);
        }
    }
    sort(allv(t[v].elems));
    if (vl + 1 != vr) {
        build(p, t, r, v * 2 + 1, vl, vl + vr >> 1);
        build(p, t, r, v * 2 + 2, vl + vr >> 1, vr);
    }
}

int get(node t[4 * N], int l, int r, int k, int v = 0, int vl = 0, int vr = s.size()) {
    if (vl >= r || vr <= l) {
        return 0;
    }
    if (vl >= l && vr <= r) {
        int ind = lower_bound(allv(t[v].elems), k) - t[v].elems.begin();
        return t[v].elems.size() - ind;
    }
    int res1 = get(t, l, r, k, v * 2 + 1, vl, vl + vr >> 1);
    int res2 = get(t, l, r, k, v * 2 + 2, vl + vr >> 1, vr);
    return res1 + res2;
}

ll solve_1() {
    make_pals_1(s, p1);
    rep(s.size(), i) {
        p1[i] = 2 * p1[i] - i;
    }
    build(p1, t0, 0);
    build(p1, t1, 1);
    ll res = 0;
    rep(s.size(), i) {
        int l = i + 1;
        int r = 2 * i + p1[i] + 2;
        if (i & 1) {
            res += get(t0, l, r, -1 - i);
        } else {
            res += get(t1, l, r, -1 - i);
        }
    }
    return res;
}

ll solve_0() {
    make_pals_0(s, p0);
    rep(s.size(), i) {
        p0[i] = 2 * p0[i] - i;
    }
    build(p0, t0, 0);
    build(p0, t1, 1);
    ll res = 0;
    rep(s.size(), i) {
        int l = i + 2;
        int r = 2 * i + p0[i] + 1;
        if (i & 1) {
            res += get(t1, l, r, -i);
        } else {
            res += get(t0, l, r, -i);
        }
    }
    return res;
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    fastio;
    cin >> n >> s;
    p1.resize(s.size(), 0);
    p0.resize(s.size(), 0);
    cout << solve_0() + solve_1();
    return 0;
}