#include <bits/stdc++.h>
using namespace std;
#define int int64_t

#define all(v) (v.begin(), v.end())

const int MAXN = 2e6, MOD = 1791791791, B = 57;
int pref[MAXN], suf[MAXN], power[MAXN];

bool is_pal(int l, int r) {
    int h1 = pref[r] - pref[l] * power[r - l];
    int h2 = suf[l] - suf[r] * power[r - l];
    return (h1 - h2) % MOD == 0;
}

int pal[MAXN];
int arr[MAXN];

vector<int> tree[MAXN];

void build(int v, int vl, int vr) {
    tree[v].clear();
    if (vr - vl == 1) {
        tree[v].push_back(arr[vl]);
        return;
    }
    int vm = (vl + vr) / 2;
    build(v * 2, vl, vm);
    build(v * 2 + 1, vm, vr);
    merge(tree[v * 2].begin(), tree[v * 2].end(), tree[v * 2 + 1].begin(), tree[v * 2 + 1].end(), back_inserter(tree[v]));
}

int get(int v, int vl, int vr, int l, int r, int val) {
    if (r <= vl || l >= vr) {
        return 0;
    }
    if (l <= vl && r >= vr) {
        int k = lower_bound(tree[v].begin(), tree[v].end(), val) - tree[v].begin();
        return vr - vl - k;
    }
    int vm = (vl + vr) / 2;
    int res1 = get(v * 2, vl, vm, l, r, val);
    int res2 = get(v * 2 + 1, vm, vr, l, r, val);
    return res1 + res2;
}

main() {
    int n;
    string s;
    cin >> n >> s;
    power[0] = 1;
    for (int i = 0; i < n; ++i) {
        power[i + 1] = (power[i] * B) % MOD;
        pref[i + 1] = (pref[i] * B + s[i] - 'a' + 1) % MOD;
        suf[n - i - 1] = (suf[n - i] * B + s[n - i - 1] - 'a' + 1) % MOD;
    }
    for (int i = 1; i < n; ++i) {
        int l = 0, r = min(i, n - i) + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (is_pal(i - m, i + m)) {
                l = m;
            } else {
                r = m;
            }
        }
        pal[i] = l;
    }
    int ans = 0;
    fill(arr, arr + n, -1e9);
    for (int i = 1; i < n; i += 2) {
        arr[i] = 2 * pal[i] - i;
    }
    build(1, 0, n);
    for (int i = 1; i < n; i += 2) {
        /**for (int k = 1; k <= min(pal[i], (n - i - 1) / 2); ++k) {
            if (2 * pal[i + 2 * k] - i - 2 * k >= -i) {
                ans++;
            }
        }*/
        int x = min(pal[i], (n - i - 1) / 2) + 1;
        ans += get(1, 0, n, i + 2, i + 2 * x, -i);
    }
    fill(arr, arr + n, -1e9);
    for (int i = 2; i < n; i += 2) {
        arr[i] = 2 * pal[i] - i;
    }
    build(1, 0, n);
    for (int i = 2; i < n; i += 2) {
        int x = min(pal[i], (n - i - 1) / 2) + 1;
        ans += get(1, 0, n, i + 2, i + 2 * x, -i);
    }
    for (int i = 0; i < n; ++i) {
        int l = 0, r = min(i + 1, n - i) + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (is_pal(i - m + 1, i + m)) {
                l = m;
            } else {
                r = m;
            }
        }
        pal[i] = l;
    }
    /**for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; j += 2) {
            if (pal[i] >= (j - i + 1) / 2 && pal[j] >= (j - i + 1) / 2) {
                ans++;
            }
        }
    }*/
    for (int i = 0; i < n; ++i) {
        for (int k = 0; k <= min(pal[i] - 1, (n - i - 2) / 2); ++k) {
            if (2 * pal[i + 2 * k + 1] - i - 2 * k - 1 >= 1 - i) {
                ans++;
            }
        }
    }
    cout << ans;
    return 0;
}
