#include <iostream>
#include <algorithm>

using namespace std;

#define int long long

const int N = 5e5 + 1;

int n;
char s[N];

const int MOD1 = 1e9 + 7;
const int MOD2 = 777777773;
const int P = 239;

int sum(int x, int y, int mod) { return x + y < mod ? x + y : x + y - mod; }
int sub(int x, int y, int mod) { return x - y < 0 ? x - y + mod : x - y; }
int mul(int x, int y, int mod) { return x * 1LL * y % mod; }

int p[N][2];

void build_p() {
	p[0][0] = p[0][1] = 1;
	for (int i = 1; i < N; ++i) {
		p[i][0] = mul(P, p[i - 1][0], MOD1);
		p[i][1] = mul(P, p[i - 1][1], MOD2);
	}
}

int h[N][2];

void build_h() {
	h[0][0] = h[0][1] = 0;
	for (int i = 0; i < n; ++i) {
		h[i + 1][0] = sum(mul(P, h[i][0], MOD1), s[i], MOD1);
		h[i + 1][1] = sum(mul(P, h[i][1], MOD2), s[i], MOD2);
	}
}

pair<int, int> gh(int i, int j) {
	if (i > j) {
		return {0, 0};
	}
	return {
		sub(h[j + 1][0], mul(h[i][0], p[j - i + 1][0], MOD1), MOD1),
		sub(h[j + 1][1], mul(h[i][1], p[j - i + 1][1], MOD2), MOD2)
	};
}

int rh[N][2];

void build_rh() {
	reverse(s, s + n);
	rh[0][0] = rh[0][1] = 0;
	for (int i = 0; i < n; ++i) {
		rh[i + 1][0] = sum(mul(P, rh[i][0], MOD1), s[i], MOD1);
		rh[i + 1][1] = sum(mul(P, rh[i][1], MOD2), s[i], MOD2);
	}
	reverse(s, s + n);
}

pair<int, int> grh(int i, int j) {
	i = n - 1 - i;
	j = n - 1 - j;
	swap(i, j);
	if (i > j) {
		return { 0, 0 };
	}
	return {
		sub(rh[j + 1][0], mul(rh[i][0], p[j - i + 1][0], MOD1), MOD1),
		sub(rh[j + 1][1], mul(rh[i][1], p[j - i + 1][1], MOD2), MOD2)
	};
}

int a[N];

int f1() {
	int res = 0;
	for (int i = 0; i < n; ++i) {
		a[i] = 0;
		while (i - a[i] >= 0 && i + a[i] < n && gh(i, i + a[i]) == grh(i - a[i], i)) {
			++a[i];
		}
		for (int j = 0; j < i; ++j) {
			res += ((i - j) % 2 == 1 && a[i] > (i - j) / 2 && a[j] > (i - j) / 2);
		}
	}
	return res;
}

int f2() {
	int res = 0;
	for (int i = 0; i < n; ++i) {
		a[i] = 0;
		while (i - a[i] >= 0 && i + 1 + a[i] < n && gh(i + 1, i + 1 + a[i]) == grh(i - a[i], i)) {
			++a[i];
		}
		for (int j = 0; j < i; ++j) {
			res += ((i - j) % 2 == 0 && a[i] >= (i - j) / 2 && a[j] >= (i - j) / 2);
		}
	}
	return res;
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	build_p();
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	build_h();
	build_rh();
	cout << f1() + f2() << '\n';
	return 0;
}