#include <iostream>
#include <algorithm>
using namespace std;

const int MAXN = 500005;
const int MOD = 1000000009;
const int BASE = 33;

int n;
string ss, sr;

long long bpow[MAXN];

long long hs[MAXN];
long long hr[MAXN];

int odd[MAXN], even[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> ss;
    sr = ss;

    reverse(sr.begin(), sr.end());

    //cout << ss << endl << sr << endl;

    bpow[0] = 1;
    for (int i = 1; i < MAXN; ++ i)
    {
        bpow[i] = (bpow[i - 1] * BASE) % MOD;
    }
}

void Hashing()
{
    for (int i = 0; i < n; ++ i)
    {
        hs[i] = (ss[i] - 'a' + 1) * bpow[i];
        if (i != 0) hs[i] += hs[i - 1];
        hs[i] %= MOD;
        //cout << hs[i] << ' ';
    }
    //cout << endl;

    for (int i = 0; i < n; ++ i)
    {
        hr[i] = (sr[i] - 'a' + 1) * bpow[i];
        if (i != 0) hr[i] += hr[i - 1];
        hr[i] %= MOD;

        //cout << hr[i] << ' ';
    }
    //cout << endl;
}

int getHash(int l, int r, int fl)
{
    if (fl == 0)
    {
        long long h = hs[r];
        if (l != 0) h -= hs[l - 1];

        //cout << "!" << h << endl;
        if (h < 0) h += MOD;
        h *= bpow[n - r];
        h %= MOD;

        //cout << l << ' ' << r << ' ' << fl << " = " << h << endl;
        return h;
    }
    else
    {
        l = n - l - 1;
        r = n - r - 1;
        swap(l, r);

        long long h = hr[r];
        if (l != 0) h -= hr[l - 1];

        //cout << "!" << h << endl;
        if (h < 0) h += MOD;
        h *= bpow[n - r];
        h %= MOD;

        //cout << l << ' ' << r << ' ' << fl << " = " << h << endl;
        return h;
    }
}

bool check_pal(int i, int l)
{
    if (l % 2 == 0)
    {
        return even[i + l / 2] >= (l / 2);
    }
    else
    {
        return odd[i + l / 2 - 1] >= (l / 2);
    }
}

int main()
{
    Init();
    Hashing();

    for (int i = 0; i < n; ++ i)
    {
        int l, r, ans;

        // cout << "for i e/o " << i << '\n';

        l = 1; r = min(i, n - i); ans = 0; // even
        while (l <= r)
        {
            int mid = (l + r) / 2;
            if (getHash(i - mid, i - 1, 0) == getHash(i, i + mid - 1, 1))
            {
                ans = mid;
                l = mid + 1;
            }
            else r = mid - 1;
        }

        even[i] = ans;

        l = 1; r = min(i + 1, n - i); ans = 0; // odd
        while (l <= r)
        {
            int mid = (l + r) / 2;
            if (getHash(i - mid + 1, i, 0) == getHash(i, i + mid - 1, 1))
            {
                ans = mid;
                l = mid + 1;
            }
            else r = mid - 1;
        }

        odd[i] = ans;
    }

    /*for (int i = 0; i < n; ++ i) cout << even[i] << ' ';
    cout << endl;
    for (int i = 0; i < n; ++ i) cout << odd[i] << ' ';
    cout << endl;*/

    //cout << check_pal(0, 3) << endl;

    long long cnt = 0;
    for (int i = 0; i < n; ++ i)
    {
        for (int j = 1; i < n; ++ j)
        {
            if (i + 2 * j <= n)
            {

                if (check_pal(i, j) and check_pal(i + j, j))
                {
                    //cout << i << ' ' << j << endl;
                    cnt++;
                }
            }
            else break;
        }
    }

    cout << cnt << endl;
    return 0;
}
