//#pragma GCC optimize "-O3"
#include "bits/stdc++.h"

#define le(v) ((int)v.size())
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define x first
#define y second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v)
		os << x << " ";
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &pp) {
	os << pp.x << " " << pp.y << " ";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v)
		is >> x;
	return is;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &pp) {
	is >> pp.x >> pp.y;
	return is;
}

vector<int> manacher(string s) {
	vector<int> eq(le(s), 1);
	for (int i = 0; i < le(s); i++) {
		while (true) {
			int a = i - eq[i];	
			int b = i + eq[i];
			if (a < 0 || b >= le(s)) break;
			if (s[a] != s[b]) break;
			eq[i]++;
		}
	}
	return eq;
}

struct Fen {
	vector<int> T;
	void inc(int i, int d) {
		for (; i < le(T); i = (i | (i + 1)))
			T[i] += d;
	}
	int get(int i) {
		int r = 0;
		for (; i >= 0; i = (i & (i + 1)) - 1) {
			r += T[i];
		}
		return r;
	}
	int get(int l, int r) {
		r = min(r, le(T));
		l = max(l, 0);
		return get(r - 1) - get(l - 1);
	}
	Fen() {}
	Fen(int n) {
		T.resize(n);
	}
};

void run() {
	int n; cin >> n;
	string s; cin >> s;
	string t;
	for (char c : s) {
		t += '*';
		t += c;
	}
	t += "*";
	ll total = 0;
	{
		vector<int> eq = manacher(s);
		Fen fen[2]; fen[0] = Fen(le(s)); fen[1] = Fen(le(s));
		vector<pii> all;
		for (int i = 0; i < le(s); i++)
			all.emplace_back(eq[i], i);
		sort(all.rbegin(), all.rend());
		for (pii pp : all) {
			total += fen[1 - (pp.y & 1)].get(pp.y - 2 * pp.x, pp.y + 2 * pp.x + 1);
			fen[pp.y & 1].inc(pp.y, 1);
		}
	}
	{
		vector<int> eq = manacher(t);
		vector<pii> all;
		for (int i = 0; i < le(t); i++) {
			if (t[i] == '*') {
				all.emplace_back(eq[i], i);
			}
		}
		sort(all.rbegin(), all.rend());
		Fen fen[4];
		for (int i = 0; i < 4; i++)
			fen[i] = Fen(le(t));
		for (pii pp : all) {
			total += fen[pp.y % 4].get(pp.y - 2 * pp.x, pp.y + 2 * pp.x + 1);
			fen[pp.y % 4].inc(pp.y, 1);
		}
		// for (int i = 0; i < le(t); i++) {
		// 	if (t[i] == '*')
		// 	for (int j = 0; j < i; j++) {
		// 		if (t[j] == '*') {
		// 			if ((i - j) % 4 == 0) {
		// 				if ((i - j + 1) <= 2 * min(eq[i], eq[j]) - 1) {
		// 					total++;
		// 				}
		// 			}
		// 		}
		// 	}
		// }
	}
	cout << total << endl;
}

signed main(int argc, char const *argv[]) {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	run();
}