#include <iostream>
#include <vector>
#include <string>
#include <algorithm>


using namespace std;


#define int long long


const int M = (int)1e9 + 7;
const int P = 57;

const int MAXN = (int)5e5 + 5;

int PPOW[MAXN];


int mod(int x) {
    x %= M;

    if (x < 0) {
        return x + M;
    }

    return x;
}


struct HS {
    string s;
    int n;
    vector<int> ph;

    HS(string _s) : s(_s), n(_s.length()) {
        ph.resize(n + 1);

        for (int i = 0; i < n; ++i) {
            ph[i + 1] = (ph[i] * P + s[i]) % M;
        }
    }

    int operator()(int i, int len) {
        return mod(ph[i + len] - ph[i] * PPOW[len]);
    }
};


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    PPOW[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        PPOW[i] = PPOW[i - 1] * P % M;
    }

    int n;
    cin >> n;

    string s;
    cin >> s;

    HS sh(s);

    reverse(s.begin(), s.end());

    HS rsh(s);

    vector<int> odd(n), even(n - 1);
    for (int i = 0; i < n; ++i) {
        int low = 0, high = min(i + 1, n - i) + 1;
        while (high - low > 1) {
            int mid = (low + high) / 2;

            if (sh(i, mid) == rsh(n - i - 1, mid)) {
                low = mid;
            } else {
                high = mid;
            }
        }

        odd[i] = low;
    }

    for (int i = 0; i < n - 1; ++i) {
        int low = 0, high = min(i + 1, n - i - 1) + 1;
        while (high - low > 1) {
            int mid = (low + high) / 2;

            if (sh(i + 1, mid) == rsh(n - i - 1, mid)) {
                low = mid;
            } else {
                high = mid;
            }
        }

        even[i] = low;
    }

    vector<int> dps(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        for (int j = 1; j <= min(i + 1, n - i - 1); ++j) {
            if (j % 2 == 1) {
                dps[i] += (odd[i - j / 2] > j / 2 && odd[i + j / 2] > j / 2);
            } else {
                dps[i] += (even[i - j / 2] >= j / 2 && even[i + j / 2] >= j / 2);
            }
        }
    }

    int answ = 0;
    for (int i = 0; i < n - 1; ++i) {
        answ += dps[i];
    }

    cout << answ;

    return 0;
}
