#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair < int, int > pii;
#define sz(x) int(x.size())
const int inf = INT_MAX / 2;
const ll INF = LLONG_MAX / 2;
const int MOD = 1e9 + 7;
const int N = 5e3 + 7;

int n;
ll p[N];

struct Hash {
    ll h, p;
};


bool operator== (Hash a, Hash b) {
    if (a.p > b.p) {
        swap(a, b);
    }

    a.h = (a.h * p[b.p - a.p]) % MOD;
    return a.h == b.h;
}



Hash h[N], hr[N];


Hash get(int l, int r) {
    ll c = h[r].h - (l ? h[l - 1].h : 0);
    if (c < 0) {
        c += MOD;
    }

    return { c, r };
}


Hash getr(int l, int r) {
    l = n - l - 1;
    r = n - r - 1;
    swap(l, r);
    //cout << l << " " << r << endl;

    ll c = hr[r].h - (l ? hr[l - 1].h : 0);
    if (c < 0) {
        c += MOD;
    }

    return { c, r };
}



bool check(int l, int r) {
    if ((r - l + 1) % 2) {
        int m = (l + r) / 2;
        Hash hl = get(l, m), hr = getr(m, r);
        //cout << hl.h << " " << hr.h << endl;

        return hl == hr;
    }
    else {
        int m = (l + r) / 2;
        Hash hl = get(l, m), hr = getr(m + 1, r);
        //cout << hl.h << " " << hr.h << endl;

        return hl == hr;
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

    p[0] = 1;
    for (int i = 1; i < N; i++) {
        p[i] = (p[i - 1] * 229) % MOD;
    }
    
    string s;

    cin >> n >> s;
    h[0].h = s[0] - 'a' + 1;
    h[0].p = 0;

    for (int i = 1; i < n; i++) {
        h[i] = { (h[i - 1].h + p[i] * (s[i] - 'a' + 1)) % MOD, i };
    }


    reverse(s.begin(), s.end());

    hr[0].h = s[0] - 'a' + 1;
    hr[0].p = 0;

    for (int i = 1; i < n; i++) {
        hr[i] = { (hr[i - 1].h + p[i] * (s[i] - 'a' + 1)) % MOD, i };
    }

    int ans = 0;
    for (int i = 0; i < n - 1; i++) {
        for (int l = i, r = i + 1; l >= 0 && r < n; l--, r++) {
            if (check(l, i) && check(i + 1, r)) {
                ans++;
            }
        }
    }

    cout << ans << endl;

    return 0;
}
