#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;
typedef double dbl;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

const int maxN = 500005;
int n;
string s;
int dp[maxN];
int dq[maxN];

struct Hash
{
    static const int MA = 998244353, MB = 100992299;

    int a, b;

    Hash(): a(0), b(0)
    {
    }
    Hash(int _a): a(_a), b(_a)
    {
    }
    Hash(int _a, int _b): a(_a), b(_b)
    {
    }

    Hash operator + (const Hash &x) const
    {
        return Hash((a + x.a) % MA, (b + x.b) % MB);
    }
    Hash operator + (int x) const
    {
        return Hash((a + x) % MA, (b + x) % MB);
    }
    Hash operator - (const Hash &x) const
    {
        return Hash((a - x.a + MA) % MA, (b - x.b + MB) % MB);
    }
    Hash operator - (int x) const
    {
        return Hash((a - x + MA) % MA, (b - x + MB) % MB);
    }
    Hash operator * (const Hash &x) const
    {
        return Hash(a * (ll)x.a % MA, b * (ll)x.b % MB);
    }
    Hash operator * (int x) const
    {
        return Hash(a * (ll)x % MA, b * (ll)x % MB);
    }
    bool operator == (const Hash &x) const
    {
        return a == x.a && b == x.b;
    }
};
const Hash B(31);
Hash pw[maxN];

Hash append(Hash H, char c)
{
    return H * B + (c - 'a' + 1);
}

Hash pref[maxN], suf[maxN];

Hash pgt(int l, int r)
{
    return pref[r + 1] - pref[l] * pw[r - l + 1];
}
Hash sgt(int l, int r)
{
    return suf[l] - suf[r + 1] * pw[r - l + 1];
}

bool palindrome(int l, int r)
{
    if ((r - l + 1) % 2 == 0)
    {
        int i = (l + r) / 2;
        return pgt(l, i) == sgt(i + 1, r);
    }
    else
    {
        int i = (l + r) / 2;
        return pgt(l, i) == sgt(i, r);
    }
}

struct Query
{
    int j, i, x, coef;

    Query()
    {
    }
    Query(int _j, int _i, int _x, int _coef): j(_j), i(_i), x(_x), coef(_coef)
    {
    }

    bool operator < (const Query &q) const
    {
        return i < q.i;
    }
};

struct fnw
{
    static const int maxM = 2 * maxN + 1337;
    int f[maxM];

    void clr()
    {
        memset(f, 0, sizeof(f));
    }

    fnw()
    {
        clr();
    }

    void add(int i)
    {
        if (i <= 0) return;
        for (; i < maxM; i += i & -i)
        {
            ++f[i];
        }
    }

    int pref(int i)
    {
        int res = 0;
        for (; i >= 1; i -= i & -i)
            res += f[i];
        return res;
    }

    int gt(int i)
    {
        return pref(maxM - 1) - pref(i - 1);
    }
} fp[2], fq[2];

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    pw[0] = Hash(1);
    for (int i = 1; i < maxN; ++i)
        pw[i] = pw[i - 1] * B;

    cin >> n >> s;
    pref[0] = Hash(0);
    for (int i = 0; i < n; ++i)
    {
        pref[i + 1] = append(pref[i], s[i]);
    }
    suf[n] = Hash(0);
    for (int i = n - 1; i >= 0; --i)
    {
        suf[i] = append(suf[i + 1], s[i]);
    }
    for (int i = 0; i < n; ++i)
    {
        int l = 1;
        int r = min(i + 1, n - i) + 1;
        while (r - l > 1)
        {
            int j = (l + r) / 2;
            if (palindrome(i - j + 1, i + j - 1))
                l = j;
            else
                r = j;
        }
        dp[i] = l;
    }
    for (int i = 1; i < n; ++i)
    {
        dq[i] = 0;
        int l = 0;
        int r = min(i, n - i) + 1;
        while (r - l > 1)
        {
            int j = (l + r) / 2;
            if (palindrome(i - j, i + j - 1))
                l = j;
            else
                r = j;
        }
        dq[i] = l;
    }
    ll ans = 0;
    vector<Query> qp, qq;
    for (int i = 0; i < n; ++i)
    {
        {
            int l = i + 1 - 2 * dp[i];
            int r = i - 1;
            chkmax(l, 0);
            if (l <= r)
            {
                qp.emplace_back(i & 1 ^ 1, l - 1, i + 1, -1);
                qp.emplace_back(i & 1 ^ 1, r, i + 1, 1);
            }
        }
        {
            int l = i - 2 * dq[i];
            int r = i - 1;
            chkmax(l, 0);
            if (l <= r)
            {
                qq.emplace_back(i & 1, l - 1, i, -1);
                qq.emplace_back(i & 1, r, i, 1);
            }
        }
        /*for (int j = 0; j < i; ++j)
        {
            if (i % 2 != j % 2 && 2 * dp[j] + j >= i + 1 && j >= i + 1 - 2 * dp[i])
            {
                ++ans;
            }
            if (i % 2 == j % 2 && 2 * dq[j] + j >= i && j >= i - 2 * dq[i])
            {
                ++ans;
            }
        }*/
    }
    sort(all(qp));
    sort(all(qq));
    int p_ptr = 0, q_ptr = 0;
    while (p_ptr < qp.size() && qp[p_ptr].i == -1) ++p_ptr;
    while (q_ptr < qq.size() && qq[q_ptr].i == -1) ++q_ptr;
    for (int j = 0; j < n; ++j)
    {
        fp[j & 1].add(2 * dp[j] + j);
        fq[j & 1].add(2 * dq[j] + j);
        while (p_ptr < qp.size() && qp[p_ptr].i == j)
        {
            auto &q = qp[p_ptr++];
            ans += q.coef * fp[q.j].gt(q.x);
        }
        while (q_ptr < qq.size() && qq[q_ptr].i == j)
        {
            auto &q = qq[q_ptr++];
            ans += q.coef * fq[q.j].gt(q.x);
        }
    }

    cout << ans << '\n';

    return 0;
}

