#include <bits/stdc++.h>


using namespace std;


#define int long long


const int MOD = 1791791791;
const int base = 57;
const int maxn = 5e5 + 3;
int precalc[maxn];


void warp()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}


int bp(int a, int p)
{
    if (p == 0) return 1;
    int temp = bp(a, p / 2);
    temp *= temp;
    temp %= MOD;
    if (p % 2) temp *= a;
    temp %= MOD;
    return temp;
}


int div(int a)
{
    return bp(a, MOD - 2);
}


int getHash(vector<int> &h, int l, int r)
{
    if (l == 0) return h[r];
    int len = (r - l + 1);
    int temp = h[l - 1] * precalc[len];
    temp %= MOD;
    int ans = h[r] - temp + MOD;
    ans %= MOD;
    return ans;
}


bool isPalindrome(int l, int r, vector<int> &normal, vector<int> &rev)
{
    int n = normal.size();
    return getHash(normal, l, r) == getHash(rev, n - 1 - r, n - 1 - l);
}


int tree[maxn];


int sum(int r)
{
    int ans = 0;
    while (r >= 0)
    {
        ans += tree[r];
        r = (r & (r + 1)) - 1;
    }
    return ans;
}


void upd(int pos, int val)
{
    while (pos < maxn)
    {
        tree[pos] += val;
        pos |= (pos + 1);
    }
}


void clearTree()
{
    for (int i = 0; i < maxn; i++) tree[i] = 0;
}


int countOddAnswer(vector<int> l)
{
    clearTree();
    int ans = 0;
    int n = l.size();
    vector<vector<int> > ends(n);
    for (int i = 0; i < n; i++)
    {
        int pos = i - 2 * l[i] - 1;
        if (pos < 0) continue;
        ends[pos].push_back(i);
    }
    for (int i = n - 1; i > -1; i--)
    {
        if (i % 2)
        {
            upd(i, 1);
        }
        else
        {
            ans += sum(min(n - 1, i + 2 * l[i] + 1));
            for (int j = 0; j < ends[i].size(); j++)
            {
                int c = ends[i][j];
                upd(c, -1);
            }
        }
    }
    clearTree();
    for (int i = n - 1; i > -1; i--)
    {
        if (i % 2)
        {
            ans += sum(min(n - 1, i + 2 * l[i] + 1));
            for (int j = 0; j < ends[i].size(); j++)
            {
                int c = ends[i][j];
                upd(c, -1);
            }
        }
        else upd(i, 1);
    }
    return ans;
}


int countEvenAnswer(vector<int> l)
{
    int ans = 0;
    int n = l.size();
    vector<vector<int> > ends(n);
    for (int i = 0; i < n; i++)
    {
        int pos = i - 2 * l[i];
        if (pos < 0) continue;
        ends[pos].push_back(i);
    }
    clearTree();
    for (int i = n - 1; i > -1; i--)
    {
        if (i % 2 == 0) continue;
        ans += sum(min(n - 1, i + 2 * l[i]));
        upd(i, 1);
        for (int j = 0; j < ends[i].size(); j++)
        {
            int c = ends[i][j];
            upd(c, -1);
        }
    }
    clearTree();
    for (int i = n - 1; i > -1; i--)
    {
        if (i % 2 == 1) continue;
        ans += sum(min(n - 1, i + 2 * l[i]));
        upd(i, 1);
        for (int j = 0; j < ends[i].size(); j++)
        {
            int c = ends[i][j];
            upd(c, -1);
        }
    }
    return ans;
}


signed main()
{
    precalc[0] = 1;
    for (int i = 1; i < maxn; i++)
    {
        precalc[i] = precalc[i - 1] * base;
        precalc[i] %= MOD;
    }
    warp();
    int n;
    cin >> n;
    string s;
    cin >> s;
    for (int i = 0; i < n; i++) s[i] -= 'a';
    vector<int> normal(n);
    normal[0] = s[0];
    for (int i = 1; i < n; i++)
    {
        normal[i] = (normal[i - 1] * base) % MOD;
        normal[i] += s[i];
        s[i] %= MOD;
    }
    vector<int> rev(n);
    rev[0] = s.back();
    for (int i = 1; i < n; i++)
    {
        rev[i] = (rev[i - 1] * base) % MOD;
        rev[i] += s[n - 1 - i];
        rev[i] %= MOD;
    }
    vector<int> oddPalindromeLen(n);
    vector<int> evenPalindromeLen(n);
    for (int i = 0; i < n; i++)
    {
        int l = 0, r = min(i, n - 1 - i) + 1;
        while (r - l > 1)
        {
            int m = (l + r) / 2;
            if (isPalindrome(i - m, i + m, normal, rev)) l = m;
            else r = m;
        }
        oddPalindromeLen[i] = l;
    }
    for (int i = 0; i < n; i++)
    {
        if (i == n - 1) continue;
        int l = 0, r = min(i + 1, (n - 1) - (i)) + 1;
        while (r - l > 1)
        {
            int m = (l + r) / 2;
            if (isPalindrome(i - m + 1, i + m, normal, rev)) l = m;
            else r = m;
        }
        evenPalindromeLen[i] = l;
    }
    cout << countOddAnswer(oddPalindromeLen) + countEvenAnswer(evenPalindromeLen) << endl;
    return 0;
}
