#include <bits/stdc++.h>

#define fi first
#define se second
#define all(x) (x).begin(), (x).end()

using namespace std;

typedef vector<int> vi;
typedef pair<int, int> pii;

const int N = 500010;

int n;
string s;
long long ans;
int a[N], b[N];
int tree1[4 * N];
int tree2[4 * N];

int Get1(int l, int r, int L = 0, int R = n, int V = 0)
{
    if (r <= L || R <= l) return 0;
    if (l <= L && R <= r)
    {
        return tree1[V];
    }
    int M = (L + R) / 2;
    return Get1(l, r, L, M, 2 * V + 1) + Get1(l, r, M, R, 2 * V + 2);
}

void Add1(int p, int L = 0, int R = n, int V = 0)
{
    tree1[V]++;
    if (L + 1 == R)
    {
        return;
    }
    int M = (L + R) / 2;
    if (p < M)
    {
        Add1(p, L, M, 2 * V + 1);
    }
    else
    {
        Add1(p, M, R, 2 * V + 2);
    }
}

int Get2(int l, int r, int L = 0, int R = n, int V = 0)
{
    if (r <= L || R <= l) return 0;
    if (l <= L && R <= r)
    {
        return tree2[V];
    }
    int M = (L + R) / 2;
    return Get2(l, r, L, M, 2 * V + 1) + Get2(l, r, M, R, 2 * V + 2);
}

void Add2(int p, int L = 0, int R = n, int V = 0)
{
    tree2[V]++;
    if (L + 1 == R)
    {
        return;
    }
    int M = (L + R) / 2;
    if (p < M)
    {
        Add2(p, L, M, 2 * V + 1);
    }
    else
    {
        Add2(p, M, R, 2 * V + 2);
    }
}

void solve(vector<int> a)
{
    vector<pair<int, int> > b;
    for (int i = 0; i < a.size(); i++) b.push_back({a[i], i});
    sort(all(b));
    reverse(all(b));
    for (int i = 0; i < b.size(); i++)
    {
        int l = max(0, b[i].second - b[i].first);
        int r = min((int)b.size(), b[i].second + b[i].first + 1);
        ans += Get1(l, r);
        Add1(b[i].second);
    }
    fill(tree1, tree1 + 4 * N, 0);
}

int MOD1 = 1;
int MOD2 = 1;
int M1 = 1;
int M2 = 1;
long long deg1[N];
long long deg2[N];
long long h1[N];
long long h2[N];
long long rh1[N];
long long rh2[N];

pair<int, int> get_hash(int l, int r)
{
    int len = r - l + 1;
    int c1 = 0;
    if (l - 1 >= 0) c1 = h1[l - 1];
    c1 = 1LL * c1 * deg1[len] % MOD1;
    int c2 = 0;
    if (l - 1 >= 0) c2 = h2[l - 1];
    c2 = 1LL * c2 * deg2[len] % MOD2;
    return {(h1[r] - c1 + MOD1) % MOD1, (h2[r] - c2 + MOD2) % MOD2};
}

pair<int, int> get_rhash(int l, int r)
{
    int len = r - l + 1;
    int c1 = 0;
    if (r + 1 < s.size()) c1 = rh1[r + 1];
    c1 = 1LL * c1 * deg1[len] % MOD1;
    int c2 = 0;
    if (r + 1 < s.size()) c2 = rh2[r + 1];
    c2 = 1LL * c2 * deg2[len] % MOD2;
    return {(rh1[l] - c1 + MOD1) % MOD1, (rh2[l] - c2 + MOD2) % MOD2};
}

signed main()
{
    srand(time(NULL));
    int first_hash = rand() % 100 + 1;
    int second_hash = rand() % 100 + 1;
    int first_base = rand() % 100 + 1;
    int second_base = rand() % 100 + 1;
    while (second_hash == first_hash) second_hash = rand() % 100 + 1;
    for (int i = 500000000; ; i++)
    {
        int t = 1;
        for (int j = 2; j * j <= i; j++) if (i % j == 0)
        {
            t = 0;
            break;
        }
        if (t == 1)
        {
            first_hash--, second_hash--;
            if (first_hash == 0) MOD1 = i;
            if (second_hash == 0) MOD2 = i;
        }
        if (first_hash <= 0 && second_hash <= 0) break;
    }
    for (int i = 1000000; ; i++)
    {
        int t = 1;
        for (int j = 2; j * j <= i; j++) if (i % j == 0)
        {
            t = 0;
            break;
        }
        if (t == 1)
        {
            first_base--, second_base--;
            if (first_base == 0) M1 = i;
            if (second_base == 0) M2 = i;
        }
        if (first_base <= 0 && second_base <= 0) break;
    }
    deg1[0] = 1, deg2[0] = 1;
    //cout << MOD1 << " " << MOD2 << " " << M1 << " " << M2 << endl;
    for (int i = 1; i < N; i++) deg1[i] = deg1[i - 1] * M1 % MOD1, deg2[i] = deg2[i - 1] * M2 % MOD2;
    cin >> n;
    cin >> s;
    h1[0] = s[0];
    h2[0] = s[0];
    for (int i = 1; i < s.size(); i++)
    {
        h1[i] = (h1[i - 1] * M1 + s[i]) % MOD1;
        h2[i] = (h2[i - 1] * M2 + s[i]) % MOD2;
    }
    rh1[s.size() - 1] = s.back();
    rh2[s.size() - 1] = s.back();
    for (int i = (int)s.size() - 2; i >= 0; i--)
    {
        rh1[i] = (rh1[i + 1] * M1 + s[i]) % MOD1;
        rh2[i] = (rh2[i + 1] * M2 + s[i]) % MOD2;
    }
    for (int i = 1; i < s.size(); i++)
    {
        int l = 0, r = min(i, (int)s.size() - i) + 1;
        while (l + 1 < r)
        {
            int m = (l + r) / 2;
            if (get_hash(i - m, i - 1) == get_rhash(i, i + m - 1)) l = m;
            else r = m;
        }
        a[i] = l;
    }
    for (int i = 0; i < s.size(); i++)
    {
        int l = 0, r = min(i, (int)s.size() - i - 1) + 1;
        while (l + 1 < r)
        {
            int m = (l + r) / 2;
            if (get_hash(i - m, i) == get_rhash(i, i + m)) l = m;
            else r = m;
        }
        b[i] = l;
    }
    vector<int> x;
    vector<int> y;
    for (int i = 1; i < s.size(); i += 2) x.push_back(a[i]);
    for (int i = 2; i < s.size(); i += 2) y.push_back(a[i]);
    solve(x);
    solve(y);
    //cout << ans << "\n";

    vector<pair<int, int> > z;
    for (int i = 0; i < s.size(); i++) z.push_back({b[i], i});
    sort(all(z));
    reverse(all(z));

    for (int i = 0; i < z.size(); i++)
    {
        if (z[i].second % 2 == 0)
        {
            int l = max(0, z[i].second - 2 * z[i].first - 1);
            int r = min((int)s.size(), z[i].second + 2 * z[i].first + 2);
            //cout << "0 " << z[i].second << " " << l << " " << r << endl;
            ans += Get1(l, r);
            //cout << Get1(l, r) << endl;
            Add2(z[i].second);
        }
        else
        {
            int l = max(0, z[i].second - 2 * z[i].first - 1);
            int r = min((int)s.size(), z[i].second + 2 * z[i].first + 2);
            //cout << "1 " << z[i].second << " " << l << " " << r << endl;
            ans += Get2(l, r);
            //cout << Get2(l, r) << endl;
            Add1(z[i].second);
        }
    }
    cout << ans << "\n";
}

/*
8
aaabbaaa
*/
