#include <iostream>
#include <algorithm>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#include <map>

#define int long long

using namespace std;
using namespace __gnu_pbds;

const int N = 555555;

struct Tree {
    int t[N];
    Tree() {
        fill (t, t + N, 0);
    }
    void add(int pos, int val) {
        for (int i = pos; i < N;  i = (i | i + 1)) {
            t[i] += val;
        }
    }

    int get(int pos) {
        int res = 0;
        for (; pos >= 0; pos = (pos & pos - 1) - 1) {
            res += t[pos];
        }
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

int n;
vector<int> d, d0;
string s;

void build() {
    for (int i = 0; i < n; i++) {
        int l = i, r = i;
        while (l >= 0 && r < n && s[l] == s[r]) {
            l--;
            r++;
        }
        d[i] = r - i;
    }
    for (int i = 0; i < n; i++) {
        int l = i, r = i + 1;
        while (l >= 0 && r < n && s[l] == s[r]) {
            l--;
            r++;
        }
        d0[i] = r - i - 1;
    }
}

signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin.tie(0);


    cin >> n;
    d.resize(n);
    d0.resize(n);
    cin >> s;
    build();
    vector<int> a(n), a0(n);
    for (int i = 0; i < n; i++) {
        a[i] = 2 * d[i] + i - 1;
        a0[i] = 2 * d0[i] + i;
        //cout << d0[i] << '\n';
    }
    int ans = 0;
    for (int i = 0; i < n; i += 2) {
        for (int j = 1; j < i; j += 2) {
            if (i <= a[j] && j >= i + 1 - 2 * d[i]) {
                ans++;
            }
        }
    }
    for (int i = 0; i < n; i += 2) {
        for (int j = 0; j < i; j += 2) {
            if (i <= a0[j] && j >= i - 2 * d0[i]) ans++;
        }
    }
    for (int i = 1; i < n; i += 2) {
        for (int j = 0; j < i; j += 2) {
            if (a[j] >= i && j >= i + 1 - 2 * d[i]) {
                ans++;
            }
        }
    }
    for (int i = 1; i < n; i += 2) {
        for (int j = 1; j < i; j += 2) {
            if (i <= a0[j] && j >= i - 2 * d0[i]) ans++;
        }
    }
    cout << ans;
    return 0;
}