#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

//#define int ll

#define ALL(a) a.begin(), a.end()
#define RALL(a) a.rbegin(), a.rend()
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define sz(a) (int)a.size()

typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef vector<bool> vb;
typedef vector<char> vc;
typedef vector<double> vd;
typedef vector<pii> vpii;
typedef vector<pll> vpll;
typedef tuple<int, int, int> tiii;
typedef vector<tiii> vtiii;

const int INF = 1e9;
const ll INFLL = 1e18;
const int M = 1e9 + 7;

bool dp[5005][5005];

class Tree {
public:
    explicit Tree(int n_ = 0) {
        n = n_;
        t.resize(2 * n);
    }

    void set(int p, int x) {
        p += n;
        t[p] = {x};
    }

    void build() {
        for (int i = n - 1; i > 0; --i)
            merge(ALL(t[2 * i]), ALL(t[2 * i + 1]), back_inserter(t[i]));
    }

    int query(int l, int r, int x) {
        int ans = 0;
        l += n, r += n;
        while (l < r) {
            if (l & 1)
                ans += get(l, x), ++l;
            if (!(r & 1))
                ans += get(r, x), --r;
            l /= 2, r /= 2;
        }
        if (l == r)
            ans += get(l, x);
        return ans;
    }

private:
    int n;
    vector<vi> t;

    int get(int p, int x) {
        return upper_bound(ALL(t[p]), x) - t[p].begin();
    }
};

Tree tr[2][2];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    int n;
    cin >> n;
    string s;
    cin >> s;

    for (int i = 0; i < 2; ++i)
        for (int j = 0; j < 2; ++j)
            tr[i][j] = Tree(n);

    vector<vi> d(2, vi(n, 0));
    for (int z = 0; z < 2; ++z)
        for (int i = 0, l = 0, r = 0; i < n; ++i) {
            if (i < r)
                d[z][i] = min(r - i, d[z][l + r - i - z]);
            while (d[z][i] <= i && i + d[z][i] + z < n && s[i - d[z][i]] == s[i + d[z][i] + z])
                ++d[z][i];
            if (i + d[z][i] > r)
                l = i - d[z][i] + z, r = i + d[z][i];
            tr[z][i & 1].set(i, i - 2 * d[z][i]);
        }

    for (int i = 0; i < 2; ++i)
        for (int j = 0; j < 2; ++j)
            tr[i][j].build();

    ll ans = 0;
    for (int i = 0; i < n; ++i)
        for (int z = 0; z < 2; ++z) {
            int l = i + 1 + z, r = min(n - 1, i + 2 * d[z][i] - !z);
            ans += tr[z][(!(i & 1)) ^ (z)].query(l, r, i);
        }

    cout << ans << "\n";
}