#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <limits>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <tuple>
#include <complex>
#include <functional>

using namespace std;

//#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

constexpr ll MOD = 1e9 + 9, P = 1543;
constexpr int N = 5e5 + 123;
ll deg[N];

vector<ll> calc_hsh(string &s) {
    vector<ll> res(sz(s) + 1);
    for (int i = 0; i < sz(s); ++i) {
        res[i + 1] = (res[i] * P + (s[i] - 'a')) % MOD;
    }
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n = input();
    string str = input<string>();

    deg[0] = 1;
    for (int i = 0; i < n; ++i) {
        deg[i + 1] = deg[i] * P % MOD;
    }
    vector<ll> nh = calc_hsh(str);
    reverse(all(str));
    vector<ll> rh = calc_hsh(str);

    function<bool(int, int)> pol = [&](int l, int r) {
        int m1 = (l + r) / 2;
        int m2 = (l + r + 1) / 2;
        assert(r - m2 == m1 - l);
        ll nor = (nh[m1] - nh[l] * deg[m1 - l] % MOD + MOD) % MOD;
        ll rev = (rh[n - m2] - rh[n - r] * deg[r - m2] % MOD + MOD) % MOD;
        return nor == rev;
    };

    int cnt = 0;
    for (int l = 0; l < n; ++l) {
        for (int r = l + 2; r <= n; r += 2) {
            int m = (r + l) / 2;
            cnt += pol(l, m) && pol(m, r);
        }
    }
    cout << cnt << endl;
}
