#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include <queue>
#include <set>
#include <map>
#include <cassert>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <stack>

#define ll long long
#define ld long double
#define int ll
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define pii pair<int, int>
#define ff first
#define ss second
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define rep(i, n) for (int i = 0; i < (n); ++i)

using namespace std;

const int max_n = 5e5 + 5;

int p = 31, q = 1e9 + 7;

int pp[max_n];

void pp_build() {
    rep(i, max_n) {
        if (i == 0) pp[i] = 1;
        else pp[i] = pp[i - 1] * p;
        pp[i] %= q;
    }
}

vector<int> hash_build(string &s) {
    int n = s.size();
    vector<int> res(n);
    rep(i, n) {
        if (i == 0) res[0] = (s[0] - 'a' + 1);
        else res[i] = ((res[i - 1] * p) % q + (s[i] - 'a' + 1)) % q;
    }
    return res;
}

int seg_hash(vector<int> &h, int l, int r) {
    if (l == 0) return h[r];
    return (h[r] - ((h[l - 1] * pp[r - l + 1]) % q) + 2 * q) % q;
}

bool check(int l, int r, vector<int> &h, vector<int> &h_rev) {
    int norm = seg_hash(h, l, r);
    int n = h.size();
    int rev = seg_hash(h_rev, n - r - 1, n - l - 1);
    return norm == rev;
}

void solve() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    pp_build();
    vector<int> h = hash_build(s);
    reverse(all(s));
    vector<int> h_rev = hash_build(s);
    reverse(all(s));
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int len = 1; len <= n; ++len) {
            if (i + 2 * len - 1 >= n) continue;
            if (check(i, i + len - 1, h, h_rev) && check(i + len, i + 2 * len - 1, h, h_rev)) {
                ans++;
            }
        }
    }
    cout << ans;
}

signed main() {
    //files("input.txt", "output.txt");
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}