#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>
#include <map>
#include <tuple>
#include <deque>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_set;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    auto find_double_palindromes = [&](string s, bool even) {
        if (even) {
            string t;
            for (ll i = 0; i < (ll) s.size(); i++) {
                if (i != 0) {
                    t.push_back('#');
                }
                t.push_back(s[i]);
            }
            s = t;
        }
        ll n = s.size();
        vector<ll> a(n);
        ll l = -1, r = -1;
        for (ll i = 0; i < n; i++) {
            if (i <= r) {
                ll j = l + r - i;
                a[i] = min(a[j], r - i);
            }
            while (i - a[i] - 1 >= 0 && i + a[i] + 1 < n && s[i - a[i] - 1] == s[i + a[i] + 1]) {
                a[i]++;
            }
            if (i + a[i] > r) {
                l = i - a[i];
                r = i + a[i];
            }
        }
        if (even) {
            for (ll i = 0; i < n; i += 2) {
                if (a[i] % 2 != 0) {
                    a[i]--;
                }
            }
        }
        vector<ll> b(n);
        for (ll i = 0; i < n; i++) {
            b[i] = a[i] * 2 + (even ? 2 : 1) - i;
        }
        if (even) {
            for (ll i = 0; i < n; i += 2) {
                b[i] = -(ll) 1e9;
            }
        }
        for (ll i = 0; i < n; i++) {
            b[i] *= -1;
        }
        vector<vector<ll>> e(n);
        for (ll i = 0; i < n; i++) {
            if (b[i] < n) {
                e[max(b[i], (ll) 0)].push_back(i);
            }
        }
        vector<vector<ll>> g(4, vector<ll>(n + 1));
        auto bit_add = [&](ll u, ll x, ll y) {
            for (x++; x < (ll) g[u].size(); x += x & -x) {
                g[u][x] += y;
            }
        };
        auto bit_query = [&](ll u, ll x) {
            ll y = 0;
            for (x++; x > 0; x -= x & -x) {
                y += g[u][x];
            }
            return y;
        };
        auto f = [&](ll i, ll j, ll k, ll v) {
            if (j > k) {
                return (ll) 0;
            }
            j = clamp(j, (ll) 0, n - 1), k = clamp(k, (ll) 0, n - 1);
            return bit_query(i, k) - (j == 0 ? 0 : bit_query(i, j - 1));
        };
        ll o = 0;
        for (ll i = 0; i < n; i++) {
            for (ll j : e[i]) {
                bit_add(j % 4, j, 1);
            }
            if (even) {
                o += f(i % 4, i + 4, i * 2 - b[i], i);
            } else {
                o += f((i + 1) % 4, i + 1, i * 2 - b[i], i);
                o += f((i + 3) % 4, i + 3, i * 2 - b[i], i);
            }
        }
        return o;
    };
    ll n;
    cin >> n;
    string s;
    cin >> s;
    cout << find_double_palindromes(s, false) + find_double_palindromes(s, true) << endl;
    return 0;
}
