#include<bits/stdc++.h>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;

typedef long long ll;

const int MAXN = 5e5 + 5;

string s;
int n;
int pos[MAXN];
vector<int> eventree[4 * MAXN];
vector<int> oddtree[4 * MAXN];
vector<int> maxpal;

int lson(int v) {
	return 2 * v + 1;
}

int rson(int v) {
	return 2 * v + 2;
}

void build(bool flag, vector<int> tree[], int v = 0, int tl = 0, int tr = n - 1) {
	if (tl == tr) {
		tree[v].clear();
		if (tr % 2 == flag) {
			tree[v].push_back(pos[tl]);
		} 
		return;
	}
	int tm = (tl + tr) / 2;
	build(flag, tree, lson(v), tl, tm);
	build(flag, tree, rson(v), tm + 1, tr);
	tree[v].clear();
	merge(tree[lson(v)].begin(), tree[lson(v)].end(), tree[rson(v)].begin(), tree[rson(v)].end(), 
				back_inserter(tree[v]));
}

int ans(int v, int x, vector<int> tree[]) {
	if (tree[v].empty()) return 0;
	int ind = int(upper_bound(tree[v].begin(), tree[v].end(), x) - tree[v].begin());
	return ind;
}

int query(int l, int r, int x, vector<int> tree[], int v = 0, int tl = 0, int tr = n - 1) {
	if (tl > r || tr < l) return 0;
	if (tl >= l && tr <= r) {
		return ans(v, x, tree);
	}
	int tm = (tl + tr) / 2;
	return query(l, r, x, tree, lson(v), tl, tm) + query(l, r, x, tree, rson(v), tm + 1, tr);
}

void solve() {
	maxpal.resize(n, 1);
	int l = 0, r = -1;
	for (int i = 0; i < n; ++i) {
		if (i <= r) {
			maxpal[i] = min(maxpal[l + r - i], r - i + 1);
		}
		while (i - maxpal[i] >= 0 && i + maxpal[i] < n
			 && s[i - maxpal[i]] == s[i + maxpal[i]]) ++maxpal[i];
		if (i + maxpal[i] - 1 > r) {
			r = i + maxpal[i] - 1;
			l = i - maxpal[i] + 1;
		}
		//cout << "i: " << i << ' ' << maxpal[i] << endl;
	}
	for (int i = 0; i < n; ++i) {
		pos[i] = i - 2 * maxpal[i] + 1;
	}
	build(0, eventree);
	build(1, oddtree);
	ll counter = 0;
	for (int i = 0; i < n; ++i) {
		int lb = i + 1, rb = min(n - 1, i + 2 * maxpal[i] - 1);
		bool need = (i + 1) % 2;
		int adding = 0;
		if (need == 1) adding = query(lb, rb, i, oddtree);
		else adding = query(lb, rb, i, eventree);
		counter += adding;
		int adding1 = 0;
		for (int j = lb; j <= rb; j += 2) {
			if (pos[j] <= i) ++adding1;
		}
		//cout << "i: " << i << ' ' << adding << ' ' << adding1 << endl;
		//if (need == 1) counter += query(lb, rb, i, oddtree);
		//else counter += query(lb, rb, i, eventree);
		/*for (int j = i + 1; j <= min(n - 1, i + 2 * maxpal[i] - 1); j += 2) {
			if (pos[j] <= i) ++counter;
		}*/
	}
	// even palindromes
	maxpal.assign(n, 0);
	l = 0; r = -1;
	for (int i = 1; i < n; ++i)  {
		if (i <= r) {
			maxpal[i] = min(maxpal[l + r - i + 1], r - i + 1);
		}
		while (i - maxpal[i] - 1 >= 0 && i + maxpal[i] < n && 
				s[i - maxpal[i] - 1] == s[i + maxpal[i]]) ++maxpal[i];
		//cout << "i: " << i << ' ' << maxpal[i] << endl;
		if (i + maxpal[i] - 1 > r) {
			r = i + maxpal[i] - 1;
			l = i - maxpal[i];
		}
	}
	for (int i = 1; i < n; ++i) {
		pos[i] = i - 2 * maxpal[i];
	}
	build(0, eventree);
	build(1, oddtree);
	for (int i = 1; i < n; ++i) {
		int lb = i + 2, rb = min(n - 1, i + 2 * maxpal[i]);
		bool need = i % 2;
		if (need == 1) counter += query(lb, rb, i, oddtree);
		else counter += query(lb, rb, i, eventree);
		/*for (int j = i + 2; j <= min(n - 1, i + 2 * maxpal[i]); j += 2) {
			if (pos[j] <= i) ++counter;
		}*/
	}
	cout << counter << endl;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	cin >> s;
	solve();
	return 0;
}