#include <bits/stdc++.h>

using namespace std;

#define int long long
typedef long long ll;

bool check(int a){
    bool b = false;
    for(int i=2; i*i<=a; i++)
        if(a%i == 0)b = true;
    return b;
}

int inf = 1e9+7;

int p = 31;

int norm(int a){
    return (a%inf+inf)%inf;
}

struct node {
    int l, r, sumn, sumc;
    node *left, *right;
};

node *build(int l, int r){
    node *res = new node;
    res->l = l;
    res->r = r;
    res->sumc = res->sumn = 0;
    if(l == r){
        res->left = res->right = nullptr;
    }
    else {
        int mid = (l+r) / 2;
        res->left = build(l, mid);
        res->right = build(mid+1, r);
    }
    return res;
}

int query(node *root, int l, int r, bool b){
    if(root->l > r || root->r < l)return 0;
    if(root->l >= l && root->r <= r){
        if(!b)return root->sumc;
        else return root->sumn;
    }
    return query(root->left, l, r, b) + query(root->right, l, r, b);
}

void upd(node *root){
    root->sumc = root->left->sumc + root->right->sumc;
    root->sumn = root->left->sumn + root->right->sumn;
}

void update(node *root, int pos, int val){
    if(root->l > pos || root->r < pos)return;
    if(root->l == root->r){
        if(root->l&1)root->sumn += val;
        else root->sumc += val;
        return;
    }
    update(root->left, pos, val);
    update(root->right, pos, val);
    upd(root);
}

/*
const int maxn = 1000000;

int fen[maxn];

void add(int pos, int val){
    for(; pos<maxn; pos|=pos+1)
        fen[pos]+=val;
}

int sum(int pos){
    int res = 0;
    for(; pos>=0; pos = (pos&(pos+1)) - 1)
        res += fen[pos];
    return res;
}

int get(int l, int r){
    int re = sum(r);
    int dl = 0;
    if(l > 0)dl = sum(l-1);
    return re - dl;
}
*/
signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);cout.tie(0);

    srand(time(0));

    inf += rand();
    while(check(inf))
        inf++;

    int n;
    string s;
    cin >> n >> s;
    vector<int> dop(n+1);
    dop[0] = 1;
    for(int c=1; c<=n; c++){
        dop[c] = dop[c-1] * p;
        dop[c] %= inf;
    }

    vector<int> hs1(n+1), hs2(n+1);
    for(int c=1; c<=n; c++){
        hs1[c] = hs1[c-1]*p + (s[c-1]-'a'+1);
        hs1[c] %= inf;
    }
    for(int c=0; c<n; c++)
        hs1[c] = hs1[c+1];

    for(int c=n-1; c>=0; c--){
        hs2[c] = hs2[c+1]*p + (s[c]-'a'+1);
        hs2[c] %= inf;
    }
  /*
    for(auto i : hs1)
        cout << i << " ";
    cout << endl;
    for(auto i : dop)
        cout << i << " ";
    cout << endl;
*/
    vector<int> nech(n);
    for(int c=0; c<n; c++){
        int l = 0, r = min(n-c, c)+1;
        while(l+1 < r){
            int mid = (l+r) / 2;
            //int res1 = hs1[c+mid] - hs1[c]*dop[mid];
            //int res2 = norm(hs2[c-mid] - hs2[c]*dop[mid]);
            if(norm(hs1[c+mid] - hs1[c]*dop[mid]) == norm(hs2[c-mid] - hs2[c]*dop[mid]))l = mid;
            else r = mid;
        }
        nech[c] = l*2+1;
    }
/*
    for(auto i : nech)
        cout << i << " ";
cout << endl;
*/
    vector<int> chet(n);
    for(int c=0; c<n; c++){
        int l = 0, r = min(n-c, c)+2;
        while(l+1 < r){
            int mid = (l+r) / 2;
            int res1 = norm(hs1[c+mid] - hs1[c]*dop[mid]);
            int res2 = norm(hs2[c-mid+1] - hs2[c+1]*dop[mid]);
            if(norm(hs1[c+mid] - hs1[c]*dop[mid]) == norm(hs2[c-mid+1] - hs2[c+1]*dop[mid]))l = mid;
            else r = mid;
        }
        chet[c] = l*2;
    }
    /*
    for(auto i : chet)
        cout << i << " ";*/
    int ans = 0;

    node *root = build(0, n);
    node *root2 = build(0, n);

    vector<vector<int> > del(n+1);
    vector<vector<int> > del2(n+1);
    for(int c=0; c<n; c++){
        for(auto i : del[c])
            update(root, i, -1);
        ans += query(root, c-nech[c], c, !(c&1));
        update(root, c, 1);
        del[min(c+nech[c]+1, n)].push_back(c);

        for(auto i : del2[c])
            update(root2, i, -1);
        ans += query(root2, c-chet[c], c, c&1);
        update(root2, c, 1);
        del2[min(c+chet[c]+1, n)].push_back(c);
    }

    cout << ans;
    return 0;
}
