/*
 *   cCreated by Kazalika     for Zaoch 19-20
 */

#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef double db;
typedef long double ldb;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef vector<int> vint;
typedef vector<ll> vll;
#define all(x) x.begin(), x.end()
#define forn(a, i, n) for (int i = a; i < n; ++i)
#define sz(x) int(x.size())
const ll UNDEF = -1e15, INF = 1e15;
const int N = 5e5 + 10;
const ll MOD = 228228227, base = 257;


int n;
string s;
ll powers[N];

ll mup(ll x) {
    return ((x % MOD) + MOD) % MOD;
}

vector <ll> getH(string & s) {
    vector <ll> h(sz(s));
    h[0] = s[0] - 'a' + 1;
    for (int i = 1; i < sz(s); ++i)
        h[i] = (h[i - 1] * base + s[i] - 'a' + 1) % MOD;
    return h;
}

ll getHS(vector<ll>& h, int l, int r) {
    if (l == 0) return h[r];
    return mup(h[r] - h[l - 1] * powers[r - l + 1]);
}

struct Segment_Tree {
    int size;
    vector <ll> sum, add;
    Segment_Tree (int size) : size(size) {
        sum.resize(4 * size);
        add.resize(4 * size, 0);
    };

    void push(int t, int l, int r) {
        if (add[t] == 0) return;
        sum[t] += add[t] * (r - l);
        if (l + 1 != r) {
            add[t * 2 + 1] += add[t];
            add[t * 2 + 2] += add[t];
        }
        add[t] = 0;
    }

    ll getSum(int t, int l, int r, int x, int y) {
        push(t, l, r);
        if (l >= y || r <= x) return 0;
        if (l >= x && r <= y) return sum[t];
        int mid = r + l >> 1;
        return getSum(t * 2 + 1, l, mid, x, y) + getSum(t * 2 + 2, mid, r, x, y);
    }

    void addR(int t, int l, int r, int x, int y, ll val) {
        push(t, l, r);
        if (l >= y || r <= x) return;
        if (l >= x && r <= y) {
            add[t] += val;
            push(t, l, r);
            return;
        }
        int mid = r + l >> 1;
        addR(t * 2 + 1, l, mid, x, y, val);
        addR(t * 2 + 2, mid, r, x, y, val);
        sum[t] = sum[t * 2 + 1] + sum[t * 2 + 2];
    }

    ll getSum(int l, int r) {
        if (l > r) return 0;
        return getSum(0, 0, size, l, r + 1);
    }
    void addR(int l, int r, ll val) {
        addR(0, 0, size, l, r + 1, val);
    }
};

int len_one[N], len_two[N];

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    powers[0] = 1;
    for (int i = 1; i < N; ++i)
        powers[i] = (powers[i - 1] * base) % MOD;

    cin >> n >> s;

    Segment_Tree ST(n), SST(n);

    vector <ll> H = getH(s);
    string srev = s;
    reverse(all(srev));
    vector <ll> HR = getH(srev);

    for (int i = 0; i < n; ++i) {
        // 1 element

        int l = 0, r = min(i + 1, n - i) + 1;
        while (r - l > 1) {
            int mid = r + l >> 1;
            ll HLEFT = getHS(H, i - mid + 1, i);
            int revL = n - (i + mid - 1) - 1, revR = n - i - 1;
            ll HRIGHT = getHS(HR, revL, revR);
            if (HLEFT == HRIGHT)
                l = mid;
            else
                r = mid;
        }
        len_one[i] = l;
        ST.addR(i - l + 1, i, 1);
        SST.addR(i, i + l - 1, 1);

        // 2 element

        if (i == n - 1 || s[i] != s[i + 1]) continue;

        l = 0, r = min(i + 1, n - i) + 1;
        while (r - l > 1) {
            int mid = r + l >> 1;
            ll HLEFT = getHS(H, i - mid + 1, i);
            int revL = n - (i + mid) - 1, revR = n - (i + 1) - 1;
            if (revL < 0 || revR >= n) r = mid;
            else {
                ll HRIGHT = getHS(HR, revL, revR);
                if (HLEFT == HRIGHT)
                    l = mid;
                else
                    r = mid;
            }
        }
        len_two[i] = l;
        ST.addR(i - l + 1, i, 1);
        SST.addR(i + 1, i + l, 1);

    }

    ll res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (i + 1 != j) {
                if ((j - i) % 2 == 0 && len_two[i] >= (j - i) / 2 && len_two[j] >= (j - i) / 2) res++;
            }
            if (len_one[i] >= (j - i + 1) / 2 && len_one[j] >= (j - i + 1) / 2 && (j - i + 1) % 2 == 0) res++;
        }
    }

    cout << res;

}