#include <fstream>
#include <vector>
#include <algorithm>
#include <map>
#include <string>
using namespace std;

typedef long long ll;

const ll MAXN = 5e5;
ll h[MAXN], h2[MAXN], deg[MAXN], MOD = 1073676287, P = 1997;
int n;

int get(int l, int r) {
	if (!l) return h[r];
	int res = (h[r] - h[l - 1] * deg[r - l + 1] % MOD) % MOD;
	if (res < 0) res += MOD;
	return res;
}

int get2(int l, int r) {
	if (!l) return h2[r];
	int res = (h2[r] - h2[l - 1] * deg[r - l + 1] % MOD) % MOD;
	if (res < 0) res += MOD;
	return res;
}

bool Check(int l, int r) {
	int pos1 = l + (r - l) / 2, pos2 = l + (r + 1 - l) / 2;
	if (get(l, pos1) == get2(n - r - 1, n - pos2 - 1)) return true;
	return false;
}

int main() {
	
	fstream cin("input.txt");
	ofstream cout("output.txt");

	int ans = 0; cin >> n;
	if (!n) {
		cout << 0;
		return 0;
	}
	string s, rev; cin >> s;
	rev = s; reverse(rev.begin(), rev.end());

	h[0] = s[0], deg[0] = 1, h2[0] = rev[0];
	for (int i = 1; i < s.length(); i++) {
		h2[i] = (h2[i - 1] * P % MOD + rev[i]) % MOD;
		h[i] = (h[i - 1] * P % MOD + s[i]) % MOD;
		deg[i] = deg[i - 1] * P % MOD;
	}

	for (int i = 0; i < n; i++)
		for (int j = i + 1; j < n; j++) {
			if ((j - i) % 2 == 0) continue;
			int pos1 = i + (j - i) / 2, pos2 = j - (j - i) / 2;
			if (Check(i, pos1) && Check(pos2, j)) ans++;
		}

	cout << ans;

}

