#include <bits/stdc++.h>
#define int long long

using namespace std;


void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int maxn = 500005;
int mod = 1000000033;
int base = 47;
int p[maxn];
int h[maxn];
int rh[maxn];
int mas[maxn];
int inf = 1e9;
int len[maxn];
int le[maxn];
int n;
string s;

void count_hash() {
    int a, b, i, j;
    p[0] = 1;
    for (i = 1; i <= n; i++) {
        p[i] = p[i - 1] * base % mod;
    }
    h[0] = s[0] - 'a' + 1;
    for (i = 1; i < n; i++) {
        h[i] = (h[i - 1] * base + s[i] - 'a' + 1) % mod;
    }
    rh[n - 1] = s[n - 1] - 'a' + 1;
    for (i = n - 2; i >= 0; i--) {
        rh[i] = (rh[i + 1] * base + s[i] - 'a' + 1) % mod;
    }
}

bool chk(int i, int j) {
    int m1 = (i + j) / 2;
    int m2 = m1;
    if (m1 - i != j - m1)
        m2++;
    int h1 = h[m1];
    if (i > 0) {
        h1 = (h1 - h[i - 1] * p[m1 - i + 1] % mod + mod) % mod;
    }
    int h2 = rh[m2];
    if (j < n - 1) {
        h2 = (h2 - rh[j + 1] * p[j - m2 + 1] % mod + mod) % mod;
    }
    return h1 == h2;
}

vector <int> treech[4 * maxn];
vector <int> treenech[4 * maxn];

void merge(int v) {
    int i = 0, j = 0;
    while (i < treech[v * 2].size() && j < treech[v * 2 + 1].size()) {
        if (treech[v * 2][i] <= treech[v * 2 + 1][j]) {
            treech[v].push_back(treech[v * 2][i]);
            i++;
        } else {
            treech[v].push_back(treech[v * 2 + 1][j]);
            j++;
        }
    }
    i = 0, j = 0;
    while (i < treenech[v * 2].size() && j < treenech[v * 2 + 1].size()) {
        if (treenech[v * 2][i] <= treenech[v * 2 + 1][j]) {
            treenech[v].push_back(treenech[v * 2][i]);
            i++;
        } else {
            treenech[v].push_back(treenech[v * 2 + 1][j]);
            j++;
        }
    }
}

void build(int l, int r, int v) {
    treech[v].clear();
    treenech[v].clear();
    if (l == r) {
        if (r % 2 == 1) {
            treech[v].push_back(mas[r - 1]);
            treech[v].push_back(inf);
            treenech[v].push_back(inf);
        } else {
            treenech[v].push_back(mas[r - 1]);
            treenech[v].push_back(inf);
            treech[v].push_back(inf);
        }
    } else {
        int m = (r + l) / 2;
        build(l, m, v * 2);
        build(m + 1, r, v * 2 + 1);
        merge(v);
    }
}

int getch(int l, int r, int tl, int tr, int v, int x) {
    if (l == tl && r == tr) {
        int a = lower_bound(treech[v].begin(), treech[v].end(), x) - treech[v].begin();
        a = treech[v].size() - a - 1;
        return a;
    } else {
        int m = (r + l) / 2;
        if (tr <= m) {
            return getch(l, m, tl, tr, v * 2, x);
        } else if (tl > m) {
            return getch(m + 1, r, tl, tr, v * 2 + 1, x);
        } else {
            return getch(l, m, tl, m, v * 2, x) +
            getch(m + 1, r, m + 1, tr, v * 2 + 1, x);
        }
    }
}

int getnech(int l, int r, int tl, int tr, int v, int x) {
    if (l == tl && r == tr) {
        int a = lower_bound(treenech[v].begin(), treenech[v].end(), x) - treenech[v].begin();
        a = treenech[v].size() - a - 1;
        return a;
    } else {
        int m = (r + l) / 2;
        if (tr <= m) {
            return getnech(l, m, tl, tr, v * 2, x);
        } else if (tl > m) {
            return getnech(m + 1, r, tl, tr, v * 2 + 1, x);
        } else {
            return getnech(l, m, tl, m, v * 2, x) +
            getnech(m + 1, r, m + 1, tr, v * 2 + 1, x);
        }
    }
}

signed main() {
    fast();
    int m, a, b, i, j, k, x, y;
    cin >> n;
    cin >> s;
    count_hash();
    for (i = 0; i < n; i++) {
        int l = 0, r = min(i, n - i - 1) + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (chk(i - m, i + m)) {
                l = m;
            } else {
                r = m;
            }
        }
        len[i] = l;
    }
    for (i = 0; i < n - 1; i++) {
        int l = 0, r = min(i + 1, n - 1 - i) + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (chk(i - m + 1, i + m)) {
                l = m;
            } else {
                r = m;
            }
        }
        le[i] = l;
    }
    int ans = 0;
    for (i = 0; i < n; i++) {
        mas[i] = 2 * len[i] + i + 1;
    }
    build(1, n, 1);
    for (j = 0; j < n; j++) {
        if (max(0LL, j - 1 - 2 * len[j]) + 1 > j) continue;
        if (j % 2 == 1) {
            ans += getch(1, n, max(0LL, j - 1 - 2 * len[j]) + 1, j, 1, j);
        } else {
            ans += getnech(1, n, max(0LL, j - 1 - 2 * len[j]) + 1, j, 1, j);
        }
    }
    n--;
    for (i = 0; i < n; i++) {
        mas[i] = 2 * le[i] + i;
    }
    build(1, n, 1);
    for (j = 0; j < n; j++) {
        if (max(0LL, j - 2 * le[j]) + 1 > j) continue;
        if (j % 2 == 0) {
            ans += getch(1, n, max(0LL, j - 2 * le[j]) + 1, j, 1, j);
        } else {
            ans += getnech(1, n, max(0LL, j - 2 * le[j]) + 1, j, 1, j);
        }
    }
    /*for (i = 0; i < n - 1; i++) {
        for (j = i + 1; j < n - 1; j++) {
            a = (j - i) / 2;
            if ((j - i) % 2) continue;
            if (le[i] >= a && le[j] >= a) {
                ans++;
            }
        }
    }*/
    cout << ans;
    return 0;
}
