#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

struct hesh {
    int mod = int(1e9) + 7;
    int p = 31;

    int add(int a, int b) {
        return (1LL * a + b) % mod;
    }

    int radd(int a, int b) {
        return (1LL * a - b + mod) % mod;
    }

    int mul(int a, int b) {
        return (1LL * a * b) % mod;
    }

    int binpow(int a, int n) {
        int res = 1;
        while(n) {
            if (n & 1) {
                res = mul(res, a);
            }
            a = mul(a, a);
            n >>= 1;
        }

        return res;
    }

    vector <int> h, st, inv_st;

    void build(string s) {
        h.resize(s.size());
        st.resize(s.size());
        inv_st.resize(s.size());

        int now = 1, cur = 0;
        for(int i = 0; i < s.size(); i++) {
            cur = add(mul(s[i] - 'a' + 1, now), cur);

            h[i] = cur;

            st[i] = now;
            inv_st[i] = binpow(st[i], mod - 2);
            now = mul(now, p);
        }
    }

    int get(int l, int r) {
        int cur = h[r];

        if (l) {
            cur = radd(cur, h[l - 1]);
        }

        return mul(cur, inv_st[l]);
    }
};

int n;
hesh h, h1;

bool is_pal(int l, int r) {
    return h.get(l, r) == h1.get(n - r - 1, n - r - 1 + r - l);
}

int main() {
    cin.tie(0);
    ios::sync_with_stdio(0);

    cin >> n;

    string s;
    cin >> s;

    string st = s;
    reverse(st.begin(), st.end());

    h.build(s);
    h1.build(st);

    int ans = 0;
    for(int i = 0; i < n; i++) {
        for(int len = 1; len <= n; len++) {
            if (i + 2 * len - 1 < n) {
                if (is_pal(i, i + len - 1) && is_pal(i + len, i + len + len - 1)) {
                    ans++;
                }
            }
            else {
                break;
            }
        }
    }

    cout << ans << "\n";
    return 0;
}
/*
*/
