#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <time.h>
#include <assert.h>


#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back

using namespace std;

struct FenvickTree {
    vector<int> t;
    FenvickTree(int n) {
        t.resize(n + 1);
    }

    void update(int i, int v) {
        i++;
        for (; i < t.size(); i += (i & (-i))) {
            t[i] += v;
        }
    }

    int get(int i) {
        i++;
        int res = 0;
        for (; i > 0; i -= (i & (-i))) {
            res += t[i];
        }
        return res;
    }
};

void solve() {

    int n;
    cin >> n;
    string s;
    cin >> s;
    string t;
    t.pb('#');
    for (int i = 0; i < n; i++) {
        t.pb(s[i]);
        t.pb('#');
    }
    s = t;

    vector<int> a(s.size());
    int l = 0, r = 0;
    a[0] = 1;
    for (int i = 1; i < s.size(); i++) {
        if (i <= r) {
            a[i] = min(r - i + 1, a[r - i + l]);
        }
        while (i - a[i] >= 0 && i + a[i] < s.size() && s[i + a[i]] == s[i - a[i]]) {
            a[i]++;
        }
        if (i + a[i] - 1 > r) {
            r = i + a[i] - 1;
            l = i - a[i] + 1;
        }
    }

    for (int i = 0; i < s.size(); i++) {
        a[i] += a[i] - a[i] % 2;
    }

    vector<pair<int, int>> b(s.size());
    for (int i = 1; i < s.size(); i++) {
        b[i] = { a[i] - i, i };
    }
    sort(rall(b));

    vector<pair<int, pair<int, int>>> q;
    for (int i = 0; i < s.size(); i++) {
        int x = -i - 1;
        int l = i % 2 == 0 ? i + 4 : i + 2;
        int r = min((int) s.size() - 1, i + a[i] - 1);
        if(l <= r) q.pb({ x, {l, r} });
    }

    sort(rall(q));

    vector<FenvickTree> ost(4, FenvickTree(s.size()));
    int ans = 0;
    int id = 0;
    for (int i = 0; i < q.size(); i++) {
        int x = q[i].first;
        int l = q[i].second.first;
        int r = q[i].second.second;
        while (id < b.size() && b[id].first >= x) {
            ost[b[id].second % 4].update(b[id].second, 1);
            id++;
        }
        ans += ost[l % 4].get(r) - ost[l % 4].get(l - 1);
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //srand(time(0));
    solve();
}

/*
    Спокойствие, только спокойствие!
*/