#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

void fast_io() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	cerr.tie(NULL);
}

vector<int> z_function(string &s) {
	vector<int> z(s.size());
	int l = 0;
	int r = 0;

	for (int i = 1; i < s.size(); i++) {
		if (i <= r) {
			z[i] = min(z[i - l], r - i + 1LL);
		}

		while (i + z[i] < (int)s.size() && s[z[i]] == s[i + z[i]]) {
			z[i]++;
		}

		if (i + z[i] - 1 > r) {
			r = i + z[i] - 1;
			l = i;
		}
	}
	return z;
}

int B = 26;
int P = 1000000179LL;
int Bpow[500001];

void init() {
    Bpow[0] = 1;

    for (int i = 1; i <= 500000; i++) {
        Bpow[i] = Bpow[i - 1] * B;
        Bpow[i] %= P;
    }
}

vector<int> h(string &s) {
	vector<int> ans(s.size() + 1);
	ans[0] = 0;
	for (int i = 0; i < s.size(); i++) {
		ans[i + 1] = (ans[i] * B + (s[i] - 'a' + 1)) % P;
	}
	return ans;
}

int h_on_interval(vector<int> &arr, int l, int r) {
	return (arr[r] - (arr[l] * Bpow[r - l]) + P * P) % P;
}

signed main() {
	fast_io();
	init();
	int n;
	cin >> n;
	string s;
	cin >> s;
	vector<int> hash1 = h(s);
	string s1 = s;
	reverse(s1.begin(), s1.end());
	vector<int> hash2 = h(s1);

	vector<int> dp1(n);

	for (int i = 0; i < n; i++) {
		int l = 1;
		int r = min(i + 2, n - i + 1);

		while (r - l > 1) {
			int m = (l + r) / 2;
			int hash11 = h_on_interval(hash1, i, i + m);
			int hash12 = h_on_interval(hash2, n - 1 - i, n - 1 - i + m);

			//cout << i << " " << m << " " << hash11 << " " << hash12 << endl;
			if (hash11 == hash12) {
				l = m;
			} else {
				r = m;
			}
		}
		dp1[i] = l * 2 - 1;
		//cout << l << " ";
	}

	//cout << endl;

	vector<int> dp2(n - 1);

	for (int i = 0; i < n - 1; i++) {
        int l = 0;
        int r = min(i + 2, n - i);

        while (r - l > 1) {
        	int m = (l + r) / 2;
        	int hash11 = h_on_interval(hash1, i + 1, i + 1 + m);
        	int hash12 = h_on_interval(hash2, n - i - 1, n - 1 - i + m);
        	if (hash11 == hash12) {
				l = m;
			} else {
				r = m;
			}
        }
        dp2[i] = l * 2;
        //cout << l << " ";
    }

   // cout << endl;

	int ans = 0;

	for (int len = 2; len < n; len += 2) {
		for (int l = 0; l < n; l++) {
			int ind1 = l - 1 + len / 2;
			int ind2 = ind1 + len;

			if (ind2 >= n - 1) {
				continue;
			}
			if (dp2[ind1] >= len && dp2[ind2] >= len) {
				ans++;
			}
		}
	}

	//cout << ans << endl;
	for (int len = 1; len < n; len += 2) {
		for (int l = 0; l < n; l++) {
			int ind1 = l;
			int ind2 = ind1 + len;

			if (ind2 >= n) {
				continue;
			}

			if (dp1[ind1] >= len && dp1[ind2] >= len) {
				ans++;
			}
		}
	}

	cout << ans << endl;
    return 0;
}
