#include <bits/stdc++.h>

using namespace std;

#define ull unsigned long long
const int kN = 5e5 + 7;
const ull base = 29;
const ull phi = (1ull << 63ull);

ull fast_pow(ull base, ull exp){
    if(!exp)
        return 1;

    if(exp & 1)
        return fast_pow(base, exp - 1) * base;

    ull t = fast_pow(base, exp >> 1);
    return t * t;
}

const ull inv = fast_pow(base, phi - 1);

ull prefix[kN], suffix[kN], power[kN], power_inv[kN];
int a[kN], n;
int max_odd[kN], max_even[kN];

ull forward_hash(int l, int r){
    if(l == 0)
        return prefix[r];

    return (prefix[r] - prefix[l - 1]) * power_inv[l];
}

ull backwards_hash(int l, int r){
    if(r == n - 1)
        return suffix[l];

    return (suffix[l] - suffix[r + 1]) * power_inv[n - 1 - r];
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin >> n;
    string s;
    cin >> s;

    for(int i = 0; i < n; ++i)
        a[i] = s[i] - 'a' + 1;

    ull curr_power = 1, curr_power_inv = 1;
    for(int i = 0; i < n; ++i, curr_power *= base, curr_power_inv *= inv){
        power[i] = curr_power;
        power_inv[i] = curr_power_inv;
    }

    ull curr_hash = 0;
    for(int i = 0; i < n; ++i){
        curr_hash += a[i] * power[i];
        prefix[i] = curr_hash;
    }

    curr_hash = 0;
    for(int i = n - 1; i >= 0; --i){
        curr_hash += a[i] * power[n - i - 1];
        suffix[i] = curr_hash;
    }

    for(int i = 0; i < n; ++i){
        int l = 0, r = min(i, n - i - 1) + 1;
        while(l != r){
            int mid = (l + r + 1) >> 1;
            if(forward_hash(i - mid + 1, i) == backwards_hash(i, i + mid - 1))
                l = mid;
            else
                r = mid - 1;
        }
        max_odd[i] = l;
    }

    for(int i = 0; i < n - 1; ++i){
        int l = 0, r = min(i, n - i - 2) + 1;
        while(l != r){
            int mid = (l + r + 1) >> 1;
            if(forward_hash(i - mid + 1, i) == backwards_hash(i + 1, i + mid))
                l = mid;
            else
                r = mid - 1;
        }
        max_even[i] = l;
    }

    /*for(int i = 0; i < n; ++i)
        cout << max_odd[i] << " ";
    cout << "\n";
    for(int i = 0; i < n; ++i)
        cout << max_even[i] << " ";
    cout << "\n";*/

    long long ans = 0;
    for(int i = 0; i < n; ++i){
        for(int j = i + 1; j < n; j += 2){
            if(max_odd[i] >= (j - i + 1) / 2 && max_odd[j] >= (j - i + 1) / 2)
                ++ans;
        }
    }

    for(int i = 0; i < n - 1; ++i){
        for(int j = i + 2; j < n - 1; j += 2){
            if(max_even[i] >= (j - i) / 2 && max_even[j] >= (j - i) / 2)
                ++ans;
        }
    }

    cout << ans << "\n";
}
