#include <cassert>
#include <cctype>
#include <cerrno>
#include <cfloat>
#include <ciso646>
#include <climits>
#include <clocale>
#include <cmath>
#include <csetjmp>
#include <csignal>
#include <cstdarg>
#include <cstddef>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <ccomplex>
#include <cfenv>
#include <cinttypes>
#include <cstdalign>
#include <cstdbool>
#include <cstdint>
#include <ctgmath>
#include <cuchar>
#include <cwchar>
#include <cwctype>
#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define vi vector <int>
#define pb push_back
#define foru(i, n) for(int i = 0; i < n; ++i)
#define fori(i, j, n) for(int i = j; i < n; ++i)
#define mbort(a) sort(all(a))
#define cinm(a) foru(i, a.size()) cin >> a[i]
#define coutm(a) foru(i, a.size()) cout << a[i] << ' '; cout << '\n'
#define debug(x) cout << "DEBUG!!!  " << #x << "  " << x
#define ff first
#define ss second
#define sz(a) (a).size()

typedef long long ll;
typedef long double ld;

#define int ll

const int mod = 1e9 + 7;

string s;
int n;
vector <int> hashe;
vector <int> hasher;
vector <int> p;
int P = 31;

void build_p() {
    p.resize(n + 1);
    p[0] = 1;
    fori(i, 1, n + 1) {
        p[i] = p[i - 1] * P % mod;
    }
}


void build_hash() {
    hashe.resize(n);
    hashe[0] = p[n - 1] * (s[0] - 'a' + 1);
    fori(i, 1, n) {
        hashe[i] = hashe[i - 1] + p[n - i - 1] * (s[i] - 'a' + 1);
        hashe[i] %= mod;
    }
    string sr(rall(s));
    hasher.resize(n);
    hasher[0] = p[n - 1] * (sr[0] - 'a' + 1);
    fori(i, 1, n) {
        hasher[i] = hasher[i - 1] + p[n - i - 1] * (sr[i] - 'a' + 1);
        hasher[i] %= mod;
    }
}

int get_hash(int l, int r) {
    return ((hashe[r] - (l ? hashe[l - 1] : 0) + mod) % mod + mod) % mod;
}

int get_hashr(int l, int r) {
    return ((hasher[r] - (l ? hasher[l - 1] : 0) + mod) % mod + mod) % mod;
}

bool check(int l1, int r1, int l2, int r2) {
    if (l1 > l2) {
        swap(l1, l2);
        swap(r1, r2);
    }
    return (get_hash(l2, r2) * p[l2 - l1] % mod) == get_hash(l1, r1);
}

bool is_palindrome(int l, int r) {
    if (l == r)
        return 1;
    int len = r - l + 1;
    int l1, r1, l2, r2;
    if (len % 2 == 0) {
        l1 = l, r1 = r - (len / 2), l2 = (n - 1 - r), r2 = l2 + len / 2 - 1;
    }
    else {
        l1 = l, r1 = r - (len / 2 + 1), l2 = (n - 1 - r), r2 = l2 + len / 2 - 1;
    }
    if (l2 > l1) {
        return (get_hashr(l2, r2) * p[l2 - l1] % mod) == get_hash(l1, r1);
    }
    else {
        return (get_hash(l1, r1) * p[l1 - l2] % mod) == get_hashr(l2, r2);
    }
}

bool is_two_palindrome(int l, int r) {
    int len = r - l + 1;
    if (len % 2 == 1)
        return 0;
    len /= 2;
    return is_palindrome(l, l + len - 1) && is_palindrome(l + len, r);
}

void run() {
    cin >> n;
    cin >> s;
    build_p();
    build_hash();
    int ans = 0;
    for (int l = 0; l < n; ++l) {
        for (int r = l; r < n; ++r) {
            ans += is_two_palindrome(l, r);
        }
    }
    cout << ans;
}

signed main() {
    cin.tie(0);
    cout.tie(0);
    iostream::sync_with_stdio(0);
    run();
    return 0;
}
