#include <iostream>
#include <algorithm>
#include <vector>
#include <ext/pb_ds/assoc_container.hpp>
#include <map>

#define int long long

using namespace std;
using namespace __gnu_pbds;

const int N = 555555;

struct Tree {
    int t[N];
    Tree() {
        fill (t, t + N, 0);
    }
    void add(int pos, int val) {
        for (int i = pos; i < N;  i = (i | i + 1)) {
            t[i] += val;
        }
    }

    int get(int pos) {
        int res = 0;
        for (; pos >= 0; pos = (pos & pos - 1) - 1) {
            res += t[pos];
        }
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

int n;
vector<int> d, d0;
string s;

unsigned long long p[N], pr[N], mod = 31, dg[N];

void bld() {
    dg[0] = 1;
    for (int i = 0; i < n; i++) {
        dg[i + 1] = dg[i] * mod;
    }
    for (int i = 0; i < n; i++) {
        p[i + 1] = p[i] * mod + s[i] - 'a';
    }
    for (int i = n - 1; i >= 0; i--) {
        pr[i] = pr[i + 1] * mod + s[i] - 'a';
    }
}

int isp(int l, int r, int l1, int r1) {
    return (p[r + 1] - p[l]) * dg[n - 1 - r1] == (-pr[r1 + 1] + pr[l1]) * dg[l];
}

void build() {
    bld();
    //cerr << isp(2, 4, 4, 6);
    for (int i = 0; i < n; i++) {
        int rg = min(i, n - i - 1) + 1;
        int lg = 0;
        while (rg - lg > 1) {
            int m = (rg + lg) / 2;
            if (isp(i - m, i, i, i + m)) {
                lg = m;
            } else {
                rg = m;
            }
        }
        d[i] = lg + 1;
    }
    for (int i = 0; i < n; i++) {
        int rg = min(i, n - i - 2) + 1;
        int lg = 0;
        while (rg - lg > 1) {
            int m = (rg + lg) / 2;
            if (isp(i - m, i, i + 1, i + m + 1)) {
                lg = m;
            } else {
                rg = m;
            }
        }
        d0[i] = rg;
    }
}

signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin.tie(0);


    cin >> n;
    d.resize(n);
    d0.resize(n);
    cin >> s;
    build();
    vector<int> a(n), a0(n);
    for (int i = 0; i < n; i++) {
        a[i] = 2 * d[i] + i - 1;
        a0[i] = 2 * d0[i] + i;
        //cout << d0[i] << '\n';
    }
    int ans = 0;
    for (int i = 0; i < n; i += 2) {
        for (int j = 1; j < i; j += 2) {
            if (i <= a[j] && j >= i + 1 - 2 * d[i]) {
                ans++;
            }
        }
    }
    for (int i = 0; i < n; i += 2) {
        for (int j = 0; j < i; j += 2) {
            if (i <= a0[j] && j >= i - 2 * d0[i]) ans++;
        }
    }
    for (int i = 1; i < n; i += 2) {
        for (int j = 0; j < i; j += 2) {
            if (a[j] >= i && j >= i + 1 - 2 * d[i]) {
                ans++;
            }
        }
    }
    for (int i = 1; i < n; i += 2) {
        for (int j = 1; j < i; j += 2) {
            if (i <= a0[j] && j >= i - 2 * d0[i]) ans++;
        }
    }
    cout << ans;
    return 0;
}