#pragma GCC optimize("Ofast,fast-math,unroll-loops")

#include <bits/stdc++.h>

#define int ll
#define endl '\n'
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define pb emplace_back
#define mp make_pair
#define dbg(x) cerr << #x << " : " << x << endl

using namespace std;

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

/*
const int MAX_MEM = 2e8;
char MEM[MAX_MEM];
int CUR_MEM = 0;
void* operator new (size_t x)
{
    auto ret = CUR_MEM + MEM;
    CUR_MEM += x;
    assert(CUR_MEM < MAX_MEM);
    return ret;
}
void operator delete (void*) {}
*/

template <class T>
istream& operator >> (istream &in, vector <T> &a)
{
    for (auto &i : a)
        in >> i;
    return in;
}
template <class T>
ostream& operator << (ostream &out, vector <T> a)
{
    for (auto &i : a)
        out << i << " ";
    return out;
}
template <class T, class U>
istream& operator >> (istream &in, pair <T, U> &a)
{
    in >> a.first >> a.second;
    return in;
}
template <class T, class U>
ostream& operator << (ostream &out, pair <T, U> a)
{
    out << a.first << " " << a.second;
    return out;
}

inline void Start()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0), cout.tie(0);
    //freopen(".in", "r", stdin);
    //freopen(".out", "w", stdout);
}

const int P1 = 1e9 + 7, P2 = 1e9 + 9, p = 257;
int add(int a, int b, int P)
{
    return a + b >= P ? a + b - P : a + b;
}
int mul(int a, int b, int P)
{
    return (a * b) % P;
}
struct hsh
{
    int n;
    vector <int> h1, h2, pw1, pw2;
    hsh() {}
    hsh(string s)
    {
        n = s.size();
        pw1.resize(n + 1, 1);
        for (int i = 1; i <= n; ++i)
            pw1[i] = mul(pw1[i - 1], p, P1);
        pw2.resize(n + 1, 1);
        for (int i = 1; i <= n; ++i)
            pw2[i] = mul(pw2[i - 1], p, P2);
        h1.resize(n, 0);
        h1[0] = s[0];
        for (int i = 1; i < n; ++i)
            h1[i] = add(mul(h1[i - 1], p, P1), s[i], P1);
        h2.resize(n, 0);
        h2[0] = s[0];
        for (int i = 1; i < n; ++i)
            h2[i] = add(mul(h2[i - 1], p, P2), s[i], P2);
    }
    int get1(int l, int r)
    {
        int tr = h1[r], tl = (l ? h1[l - 1] : 0);
        tl = mul(tl, pw1[r - l + 1], P1);
        return add(tr, P1 - tl, P1);
    }
    int get2(int l, int r)
    {
        int tr = h2[r], tl = (l ? h2[l - 1] : 0);
        tl = mul(tl, pw2[r - l + 1], P2);
        return add(tr, P2 - tl, P2);
    }
};
int check(int l, int r, hsh &h, hsh &hr, int n)
{
    int rl = n - r - 1, rr = n - l - 1;
    return h.get1(l, r) == hr.get1(rl, rr) && h.get2(l, r) == hr.get2(rl, rr);
}

signed main()
{
    Start();
    int n;
    cin >> n;
    string s;
    cin >> s;
    hsh h(s);
    reverse(all(s));
    hsh hr(s);
    int ans = 0;
    for (int i = 0; i < n; ++i)
    {
        for (int len = 0; len < n; ++len)
        {
            if (i - len < 0 || i + len + 1 >= n)
                break;
            ans += check(i - len, i, h, hr, n) && check(i + 1, i + len + 1, h, hr, n);
        }
    }
    cout << ans;
    return 0;
}

