#include <bits/stdc++.h>

using namespace std;

struct my_hash{
    long long base;
    long long mod;
    string s;
    vector < long long > h;
    vector < long long > base_pow;
    my_hash() {}
    my_hash(string s, long long base, long long mod): s(s), base(base), mod(mod) {
        h.resize(s.size(), 0);
        base_pow.resize(s.size() + 1, 0);
        h[0] = s[0] - 'a' + 1;
        for (int i = 1; i < s.size(); i++) {
            h[i] = h[i - 1] * base + s[i] - 'a' + 1;
            h[i] %= mod;
        }
        base_pow[0] = 1;
        for (int i = 1; i <= s.size(); i++) {
            base_pow[i] = base_pow[i - 1] * base;
            base_pow[i] %= mod;
        }
    }
    long long get_lr(int l, int r) {
        if (l == 0) {
            return h[r];
        }
        return (h[r] - (h[l - 1] * base_pow[r - l + 1] % mod) + mod) % mod;
    }
};

int get1(int i, int n, my_hash& a, my_hash& b) {
    int l = 0;
    int r = min(i + 1, n - i) + 1;
    while (r - l > 1) {
        int m = (l + r) / 2;
        int j = i - m + 1;
        int x = i + 1;
        int y = x + m - 1;
        if (a.get_lr(j, i) == b.get_lr(n - y - 1, n - x - 1)) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}

int get2(int c, int n, my_hash& a, my_hash& b) {
    int l = 0;
    int r = min(c, n - c - 1) + 1;
    //cout << a.get_lr(0, 0) << " " << b.get_lr(1, 1) << endl;
    while (r - l > 1) {
        int m = (l + r) / 2;
        int i = c - 1;
        int j = i - m + 1;
        int x = c + 1;
        int y = x + m - 1;
        if (a.get_lr(j, i) == b.get_lr(n - y - 1, n - x - 1)) {
            l = m;
        } else {
            r = m;
        }
    }
    return l + 1;
}

const int MAX_N = 1e6 + 42;
int x[MAX_N];
int y[MAX_N];
long long tree[MAX_N * 4];

void build(int sz) {
    for (int i = sz; i < sz * 2; i++) {
        tree[i] = 0;
    }
    for (int i = sz - 1; i > 0; i--) {
        tree[i] = 0;
    }
}

void add(int x, int sz) {
    int v = sz + x;
    while (v > 0) {
        tree[v] += 1;
        v /= 2;
    }
}

long long get_sum(int v, int vl, int vr, int l, int r) {
    if (vl >= r || l >= vr) {
        return 0;
    }
    if (l <= vl && vr <= r) {
        return tree[v];
    }
    int vm = (vl + vr) / 2;
    return get_sum(v * 2, vl, vm, l, r) + get_sum(v * 2 + 1, vm, vr, l, r);
}

long long get1(int t, int n) {
    int sz = 1;
    while (sz <= n) {
        sz *= 2;
    }
    build(sz);
    vector < pair < int, int > > cnt[n];
    for (int i = t; i < n - 2; i += 2) {
        int j = i + 2 * x[i];
        if (j <= i) {
            continue;
        }
        if (j >= n) {
            j = n - 1;
        }
        //cout << i + 2 << " " << j << endl;
        cnt[j].push_back({1, i});
        cnt[i + 2].push_back({0, i});
    }
    //cout << "vnjdk" << endl;
    long long ans = 0;
    for (int i = t; i < n; i++) {
        for (auto k : cnt[i]) {
            if (k.first == 1) {
                continue;
            }
            //cout << "- " << get_sum(1, 0, sz, 0, k.second + 1) << endl;
            ans -= get_sum(1, 0, sz, 0, k.second + 1);
            //cout << ans << endl;
        }
        //cout << i << " " << max(0, i - 2 * x[i]) << endl;
        if (i % 2 == t) {
            add(max(0, i - 2 * x[i]), sz);
        }
        for (auto k : cnt[i]) {
            if (k.first == 0) {
                continue;
            }
            //cout << "+ " << get_sum(1, 0, sz, 0, k.second + 1) << endl;
            ans += get_sum(1, 0, sz, 0, k.second + 1);
        }
    }
    //cout << "vnjf" << endl;
    return ans;
}

long long get2(int t, int n) {
    int sz = 1;
    while (sz <= n) {
        sz *= 2;
    }
    build(sz);
    vector < pair < int, int > > cnt[n];
    for (int i = t; i < n - 1; i += 2) {
        int j = i + 2 * y[i] - 1;
        if (j <= i) {
            continue;
        }
        if (j >= n) {
            j = n - 1;
        }
        cnt[j].push_back({1, i});
        cnt[i + 1].push_back({0, i});
    }
    long long ans = 0;
    for (int i = t; i < n; i++) {
        for (auto k : cnt[i]) {
            if (k.first == 1) {
                continue;
            }
            ans -= get_sum(1, 0, sz, 0, k.second + 1);
        }
        if (i % 2 != t) {
            add(max(0, i - 2 * y[i] + 1), sz);
        }
        for (auto k : cnt[i]) {
            if (k.first == 0) {
                continue;
            }
            ans += get_sum(1, 0, sz, 0, k.second + 1);
        }
    }
    return ans;
}

int main() {
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    string s;
    cin >> s;
    long long base = 41;
    long long mod = 1e9 + 7;
    my_hash a(s, base, mod);
    reverse(s.begin(), s.end());
    my_hash b(s, base, mod);
    //cout << get2(1, n, a, b) << endl;
    for (int i = 0; i < n; i++) {
        x[i] = get1(i, n, a, b);
        y[i] = get2(i, n, a, b);
    }
    long long ans = 0;
    ans = get1(0, n);
    ans += get1(1, n);
    ans += get2(1, n);
    //cout << ans << endl;
    ans += get2(0, n);
   // cout << ans << endl;
//    ans = 0;
//    for (int i = 0; i < n; i++) {
//        for (int j = i + 1; j < n; j++) {
//            if (j % 2 == i % 2) {
//                continue;
//            }
//            if (j > 2 * y[i] - 1 + i) {
//                continue;
//            }
//            if (i >= j - 2 * y[j] + 1) {
//                ans++;
//            }
//        }
//    }
    cout << ans;
    return 0;
}
