#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>

#define ll long long
#define pii pair<int, int>

using namespace std;

const int mod = 1e9 + 9;
const int p = 167;
vector<ll> powers;

inline ll sub(int l, int r, vector<ll>& h) {
	int big = h[r];
	int small = 0;
	if (l > 0)
		small = h[l - 1] * powers[r - l + 1] % mod;
	return (big - small + mod) % mod;
}

inline void fill_hash(vector<ll>& h, string& s) {
	h[0] = s[0];
	for (int i = 1; i < s.length(); i++)
	{
		h[i] = (h[i - 1] * p + s[i]) % mod;
	}
}

inline bool check_pal(int l, int r, vector<ll>& h, vector<ll>& r_h) {
	if ((r - l + 1) % 2 == 0) {
		int len = h.size();
		int mid = (l + r) / 2;
		return sub(mid + 1, r, h) == sub(len - 1 - mid, len - 1 - l, r_h);
	}
	else
	{
		int len = h.size();
		int mid = (l + r) / 2;
		return sub(mid, r, h) == sub(len - 1 - mid, len - 1 - l, r_h);
	}
}

inline bool check(int l, int r, vector<ll>& h, vector<ll>& r_h) {
	if (check_pal(l, (l + r) / 2, h, r_h) && check_pal((l + r) / 2 + 1, r, h, r_h))
		return  true;
	return false;
}

int main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(false);

	int n;
	cin >> n;
	string s;
	cin >> s;

	powers.resize(s.length() + 1);
	powers[0] = 1;
	for (int i = 1; i < s.length() + 1; i++)
	{
		powers[i] = powers[i - 1] * p % mod;
	}

	vector<ll> h(n), r_h(n);
	fill_hash(h, s);
	reverse(s.begin(), s.end());
	fill_hash(r_h, s);
	reverse(s.begin(), s.end());

	int ans = 0;
	for (int len = 2; len <= s.length(); len += 2)
	{
		for (int i = 0; i + len - 1 < s.length(); i++)
		{
			ans += check(i, i + len - 1, h, r_h);
		}
	}
	cout << ans;
}