#include <bits/stdc++.h>

const int32_t MAX_N = 1e6 + 5;

const int32_t BASE = 137;
const int32_t MOD = 1e9 + 7;

const int32_t BASE2 = 129;

int32_t basePowers[MAX_N + 5], revBasePowers[MAX_N + 5];
int32_t basePowers2[MAX_N + 5], revBasePowers2[MAX_N + 5];

int32_t fast_pow(int32_t x, int32_t pw) {
	if(pw == 0) {
		return 1;
	}
	else if(pw % 2 == 0) {
		int32_t aux = fast_pow(x, pw / 2);
		return ((int64_t) aux * aux) % MOD;
	}
	else {
		return ((int64_t) x * fast_pow(x, pw - 1)) % MOD;
	}
}

struct Hash {
	std::vector< int32_t > v;

	Hash() {}
	Hash(const std::string &s) {
		v.resize(s.size());

		v[0] = (s[0] - 'a' + 1);
		for(int32_t i = 1; i < s.size(); i++) {
			v[i] = ((int64_t) basePowers[i] * (s[i] - 'a' + 1) + v[i - 1]) % MOD;
		}
	}

	int32_t get_subhash(int32_t low, int32_t high) {
		int32_t h = v[high];
		int32_t l = (low == 0 ? 0 : v[low - 1]);

		int32_t res = h - l;
		if(res < 0) {
			res += MOD;
		}

		return ((int64_t) res * revBasePowers[low]) % MOD;
	}
};

struct Hash2 {
	std::vector< int32_t > v;

	Hash2() {}
	Hash2(const std::string &s) {
		v.resize(s.size());

		v[0] = (s[0] - 'a' + 1);
		for(int32_t i = 1; i < s.size(); i++) {
			v[i] = ((int64_t) basePowers2[i] * (s[i] - 'a' + 1) + v[i - 1]) % MOD;
		}
	}

	int32_t get_subhash(int32_t low, int32_t high) {
		int32_t h = v[high];
		int32_t l = (low == 0 ? 0 : v[low - 1]);

		int32_t res = h - l;
		if(res < 0) {
			res += MOD;
		}

		return ((int64_t) res * revBasePowers2[low]) % MOD;
	}
};

struct Event {
	int32_t x, type, parity;

	Event() {}
	Event(int32_t _x, int32_t _type, int32_t _parity) : x(_x), type(_type), parity(_parity) {}

	bool operator< (const Event &o) const {
		if(x != o.x) {
			return x < o.x;
		}
		else {
			return type < o.type;
		}
	}
};

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	basePowers[0] = 1;
	basePowers2[0] = 1;
	revBasePowers[0] = fast_pow(basePowers[0], MOD - 2);
	revBasePowers2[0] = fast_pow(basePowers2[0], MOD - 2);
	for(int32_t i = 1; i <= MAX_N; i++) {
		basePowers[i] = ((int64_t) basePowers[i - 1] * BASE) % MOD;
		revBasePowers[i] = fast_pow(basePowers[i], MOD - 2);

		basePowers2[i] = ((int64_t) basePowers2[i - 1] * BASE2) % MOD;
		revBasePowers2[i] = fast_pow(basePowers2[i], MOD - 2);
	}

	int32_t n;
	std::cin >> n;

	std::string s;
	std::cin >> s;

	std::string revS = s;
	std::reverse(revS.begin(), revS.end());

	n = s.size();

	Hash h = Hash(s), revH = Hash(revS);
	Hash2 h2 = Hash2(s), revH2 = Hash2(revS);

	int32_t parity = 0;
	std::vector< Event > events;
	for(int32_t i = 0; i < n; i++) {
		//std::cout << i << std::endl;
		int32_t low = 1, high = std::min(i + 1, n - i);
		while(low <= high) {
			int32_t mid = (low + high) / 2;

			int32_t aux1 = h.get_subhash(i, i + mid - 1);
			int32_t aux2 = revH.get_subhash(n - 1 - i, n - 1 - i + mid - 1);

			int32_t aux3 = h2.get_subhash(i, i + mid - 1);
			int32_t aux4 = revH2.get_subhash(n - 1 - i, n - 1 - i + mid - 1);

			if(aux1 == aux2 && aux3 == aux4) {
				low = mid + 1;
			}
			else {
				high = mid - 1;
			}
		}

		int32_t len = low - 1;
		events.push_back(Event(i - len + 1, 0, parity));
		events.push_back(Event(i + len, 1, parity));
		parity ^= 1;
	}

	std::sort(events.begin(), events.end());

	int64_t ans = 0, cnt[2] = { 0, 0 };
	for(auto &x : events) {
		//std::cout << x.type << " " << x.parity << " " << cnt[0] << " " << cnt[1] << " " << ans << '\n';

		if(x.type == 0) {
			ans += cnt[(x.parity ^ 1)];
			cnt[x.parity]++;
		}
		else {
			cnt[x.parity]--;
		}
	}

	//std::cout << ans << '\n';

	events.clear();
	parity = 0;
	for(int32_t i = 0; i < n - 1; i++) {
		//std::cout << i << std::endl;
		int32_t low = 1, high = std::min(i + 1, n - 1 - i), p = -1;
		while(low <= high) {
			int32_t mid = (low + high) / 2;

			int32_t aux1 = h.get_subhash(i + 1, i + 1 + mid - 1);
			int32_t aux2 = revH.get_subhash(n - 1 - i, n - 1 - i + mid - 1);

			int32_t aux3 = h2.get_subhash(i + 1, i + 1 + mid - 1);
			int32_t aux4 = revH2.get_subhash(n - 1 - i, n - 1 - i + mid - 1);

			if(aux1 == aux2 && aux3 == aux4) {
				p = mid;
				low = mid + 1;
			}
			else {
				high = mid - 1;
			}
		}

		if(p != -1) {
			events.push_back(Event(i - p, 0, parity));
			events.push_back(Event(i + p + 2, 1, parity));
		}

		parity ^= 1;
	}

	std::sort(events.begin(), events.end());

	cnt[0] = 0;
	cnt[1] = 0;
	for(auto &x : events) {
		if(x.type == 0) {
			ans += cnt[x.parity];
			cnt[x.parity]++;
		}
		else {
			cnt[x.parity]--;
		}
	}

	std::cout << ans << '\n';
}