#include<bits/stdc++.h>                      

using namespace std;

#define int long long

const int N = 5e5 + 7;     
const int BASE = 239;
const int MOD = 1e9 + 7;

int add(int a, int b) {
	return (a + b) % MOD;
}

int sub(int a, int b) {
	return (a - b + MOD) % MOD;
}

int mul(int a, int b) {
	return (a * b) % MOD;
}

struct Fenw {
	int f[N];

	Fenw() {
		fill(f, f + N, 0);
	}

	void add(int pos) {
		for (int i = pos; i < N; i = (i | (i + 1))) {
			f[i]++;
		}
	}

	int sum(int r) {
		int ans = 0;
		for (int i = r; i >= 0; i = (i & (i + 1)) - 1) {
			ans += f[i];	
		}
		return ans;
	}
	             
	int sum(int l, int r) {
		if (l >= r) return 0;
		return sum(r - 1) - sum(l - 1);
	}    
};
        
string s;

int p[N];
int h[N];
int rh[N];

void init(int n) {
	p[0] = 1;
	h[0] = 0;
	for (int i = 0; i < n; i++) {
		h[i + 1] = mul(h[i], BASE);
		h[i + 1] = add(h[i + 1], s[i]);
		p[i + 1] = mul(p[i], BASE);
	}          
	reverse(s.begin(), s.end());
	rh[0] = 0;
	for (int i = 0; i < n; i++) {
		rh[i + 1] = mul(rh[i], BASE);
		rh[i + 1] = add(rh[i + 1], s[i]);
	}          
	reverse(s.begin(), s.end());
}

int gok(int l, int len) {
	return sub(h[l + len], mul(h[l], p[len]));
}

int grev(int l, int len) {
	return sub(rh[l + len], mul(rh[l], p[len]));	
}

int pal(int l, int r) {
	if (l < 0 || r > (int)s.size()) return 0;
	int we = (gok(l, r - l) == grev((int)s.size() - r, r - l));
	return we; 
}

int solve_f(int n) {
	vector<int> mid(n, -1);
	for (int i = 0; i < n; i++) {
		/*for (int lp = n / 2 + 1; lp >= 0; lp--) {
			if (pal(i - lp, i + lp + 1)) {
				mid[i] = lp;
				break;
			}
		}*/
		mid[i] = -1;
		for (int j = 20; j >= 0; j--) {
			int lp = mid[i] + (1 << j);
			if (pal(i - lp, i + lp + 1)) {
				mid[i] += (1 << j);
			}
		}   
	}
	int ans = 0;
	vector<int> ind(n);
	iota(ind.begin(), ind.end(), 0);
	sort(ind.rbegin(), ind.rend(), [&](int i, int j) {
		return mid[i] < mid[j];
	});
	Fenw c[2];
	for (auto t : ind) {
		c[t % 2].add(t);
		{
			int st = t - 2 * mid[t] - 1;
			st = max(st, (int)0);
			if (st % 2 == t % 2) st++;
			int en = t; 
			ans += c[st % 2].sum(st, en);
		}
		{
			int st = t + 1;
			if (st % 2 == t % 2) st++;
			int en = min(n, t + 2 * mid[t] + 2);
			ans += c[st % 2].sum(st, en);
		}
	}
	return ans;
}              

int solve_s(int n) {
	int ans = 0;
	vector<int> mid(n - 1, -1);
	for (int i = 0; i + 1 < n; i++) {
		/*for (int lp = n / 2 + 1; lp >= 0; lp--) {
			if (pal(i - lp + 1, i + lp + 1)) {
				mid[i] = lp;
				break;
			}
		}*/
		mid[i] = -1;
		for (int j = 20; j >= 0; j--) {
			int lp = mid[i] + (1 << j);
			if (pal(i - lp + 1, i + lp + 1)) {
				mid[i] += (1 << j);
			}
		} 
	}
	vector<int> ind(n - 1);
	iota(ind.begin(), ind.end(), 0);
	sort(ind.rbegin(), ind.rend(), [&](int i, int j) {
		return mid[i] < mid[j];
	});
	vector<int> tk(n - 1, 0);
	Fenw c[2];
	for (auto t : ind) {
		if (mid[t] == 0) break;
		c[t % 2].add(t);
		{
			int st = max(t % 2, t - 2 * mid[t]);
			if (st % 2 != t % 2) st++;
			int en = t;
			ans += c[st % 2].sum(st, en); 
		}
		{
			int st = t + 1;
			if (st % 2 != t % 2) st++;
			int en = min(n - 1, t + 2 * mid[t] + 1);
			ans += c[st % 2].sum(st, en);
		}
	}
	return ans;
}
                     
signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
        
	int n;
	cin >> n;
	cin >> s;
	init(n);
	cout << solve_f(n) + solve_s(n) << endl;
	//cout << pal(0, 3) << endl;
}                         