#include<bits/stdc++.h>


using std::vector;
using std::string;
using std::pair;
using std::cin;
using std::cout;
using std::cerr;

using ll = long long;
using ld = long double;

vector<int> hs, hsr;
vector<ll> base;
const ll X = 28;	
const int MOD = 1e9 + 7;

int getHash (int l, int r) {
	return ((hs[r] - hs[l] * base[r - l]) % MOD + MOD) % MOD;
}

int getHashR (int l, int r) {
	std::swap(l, r);
	l = hs.size() - 1 - l;
	r = hs.size() - 1 - r;
	return ((hsr[r] - hsr[l] * base[r - l]) % MOD + MOD) % MOD;
}


struct Tree {
	vector<vector<int>> tr;

	Tree (int n) {
		tr.resize(n);
	}

	void set (int v, int vl, int vr, int i, int x) {
		if (vl > i || i >= vr)
			return;
		if (vr - vl == 1) {
			tr[v] = {x};
			return;
		}
		int m = (vl + vr) / 2;
		set(v * 2 + 1, vl, m, i, x);
		set(v * 2 + 2, m, vr, i, x);
	}

	void build (int v, int vl, int vr) {
		if (vr - vl == 1)
			return;
		int m = (vl + vr) / 2;
		build(v * 2 + 1, vl, m);
		build(v * 2 + 2, m, vr);
		tr[v].resize(tr[v * 2 + 1].size() + tr[v * 2 + 2].size());	
		std::merge(tr[v * 2 + 1].begin(), tr[v * 2 + 1].end(), tr[v * 2 + 2].begin(), tr[v * 2 + 2].end(), tr[v].begin());
	}

	int get (int v, int vl, int vr, int l, int r, int x) {
		if (vr <= l || r <= vl)
			return 0;
		if (l <= vl && vr <= r) {
			return tr[v].end() - std::upper_bound(tr[v].begin(), tr[v].end(), x);
		}

		int m = (vl + vr) / 2;
		return get(v * 2 + 1, vl, m, l, r, x) + get(v * 2 + 2, m, vr, l, r, x);
	}
};
int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);


	int n;
	cin >> n;
	string s;
	cin >> s;

	hs.resize(n + 1);
	hsr.resize(n + 1);
	base.resize(n + 1);
	Tree odd(n * 4), even(n * 4);
	base[0] = 1;
	for (int i = 0; i < n; ++i) {
		base[i + 1] = base[i] * X % MOD;
	}

	for (int i = 0; i < n; ++i) {
		hs[i + 1] = (hs[i] * X + s[i] - 'a' + 1) % MOD;
	}

	std::reverse(s.begin(), s.end());

	for (int i = 0; i < n; ++i) {
		hsr[i + 1] = (hsr[i] * X + s[i] - 'a' + 1) % MOD;
	}

	vector<int> max(n);
	for (int i = 0; i < n; ++i) {
		int cnt = 0;
		//for (; cnt <= i && cnt + i < n && s[i - cnt] == s[i + cnt]; ++cnt) {};
		int l = 0, r = std::min(i, n - i - 1) + 1;
		while (r - l != 1) {
			int m = (r + l) / 2;
			if (getHash(i - m, i + 1) == getHashR(i, i + m + 1))
				l = m;
			else
				r = m;
			
		}
		max[i] = r;
		if (i % 2 == 0)
			even.set(0, 0, n, i, r * 2 - i);
		else
			odd.set(0, 0, n, i, r * 2 - i);
		
	}

	odd.build(0, 0, n);
	even.build(0, 0, n);

	ll ans = 0;
	for (int i = 0; i < n; ++i) {
		int maxj = std::min(max[i] - 1, (n - i) / 2 - 1);
		if (i % 2 == 0)
			ans += odd.get(0, 0, n, i + 1, i + 2 * maxj + 2, -i - 1);
		else
			ans += even.get(0, 0, n, i + 1, i + 2 * maxj + 2, -i - 1);

		// for (int j = 0; j < max[i] && i + 2 * j + 1 < n; ++j)
		// 	if (max[i + 2 * j + 1] > j)
		// 		++ans;
	}
	
	for (int i = 0; i < n; ++i) {
		int cnt = 0;
		//for (; cnt <= i + 1 && cnt + i < n && s[i - cnt + 1] == s[i + cnt]; ++cnt) {};
		int l = 0, r = std::min(i + 1, n - i - 1) + 1;
		while (r - l != 1) {
			int m = (r + l) / 2;
			if (getHash(i - m + 1, i + 1) == getHashR(i + 1, i + m + 1))
				l = m;
			else
				r = m;
			
		}
		max[i] = l;
		if (i % 2 == 0)
			even.set(0, 0, n, i, l * 2 - i);
		else
			odd.set(0, 0, n, i, l * 2 - i);
	}

	odd.build(0, 0, n);
	even.build(0, 0, n);

	for (int i = 0; i < n; ++i) {
		int maxj = std::min(max[i] - 1, (n - i - 1) / 2 - 1);
		if (i % 2 == 1)
			ans += odd.get(0, 0, n, i + 2, i + 2 * maxj + 3, -i - 2);
		else
			ans += even.get(0, 0, n, i + 2, i + 2 * maxj + 3, -i - 2);

		// for (int j = 0; j < max[i] && i + 2 * j + 2 < n; ++j)
		// 	if (max[i + 2 * j + 2] > j)
		// 		++ans;
	}

	cout << ans;

	return 0;
}