#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

const int MAX_N = 5e5 + 10;

const int BASE = 29, MOD = 1e9 + 7;

ll powers[MAX_N];

char str[MAX_N];

ll mod(ll x) {
	ll res = x % MOD;
	if (res < 0)
		return res + MOD;
	return res;
}

struct Hasher {
	ll hash;
	int len;

	Hasher() : hash(0), len(0) {}
	Hasher(ll hash_, int len_) : hash(hash_), len(len_) {}

	Hasher operator+(char c) {
		return {(hash * BASE + c - 'a') % MOD, len + 1};
	}

	bool operator==(const Hasher &h) {
		assert(h.len == len);
		return h.hash == hash;
	}

	Hasher operator-(const Hasher &h) {
		// assert(h.len < len);
		return {mod(hash - h.hash * powers[len - h.len]), len - h.len};
	}
};

Hasher forw[MAX_N], backw[MAX_N];

Hasher getf(int i, int j) {
	// cout << "askf " << i << " " << j << endl;
	return forw[j] - forw[i];
}

Hasher getb(int i, int j) {
	// cout << "ask " << i << " " << j << endl;
	return backw[i] - backw[j];
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n;
	cin >> n >> str;
	powers[0] = 1;
	for (int i = 1; i < MAX_N; ++i)
		powers[i] = powers[i - 1] * BASE % MOD;
	for (int i = 0; i < n; ++i)
		forw[i + 1] = forw[i] + str[i];
	for (int i = n; i--; )
		backw[i] = backw[i + 1] + str[i];
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = i + 2; j <= n; j += 2) {
			int mid = (i + j) / 2;
			if (getf(i, mid) == getb(i, mid) && getf(mid, j) == getb(mid, j))
				++ans;
		}
	}
	cout << ans << "\n";
	return 0;
}