#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <limits>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <tuple>
#include <complex>
#include <functional>

using namespace std;

#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

constexpr ll MOD = 1e9 + 9, P = 1543;
constexpr int N = 5e5 + 123;
ll deg[N];

vector<ll> calc_hsh(string &s) {
    vector<ll> res(sz(s) + 1);
    for (int i = 0; i < sz(s); ++i) {
        res[i + 1] = (res[i] * P + (s[i] - 'a')) % MOD;
    }
    return res;
}

vector<pii> ev[4];

struct Fen {
    int n;
    vector<int> t;

    Fen(int n) : n(n), t(n) {}

    void clear() {
        t.assign(n, 0);
    }

    void upd(int i, int v) {
        for (; i < n; i = (i | (i + 1))) {
            t[i] += v;
        }
    }

    int get(int i) {
        int res = 0;
        for (i = min(i, n - 1); i >= 0; i = (i & (i + 1)) - 1) {
            res += t[i];
        }
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n = input();
    string str = input<string>();
    string new_str = "z";
    for (int i = 0; i < n; ++i) {
        new_str += str[i];
        new_str += 'z';
    }
    str = move(new_str);
    n = sz(str);

    debug(str);

    deg[0] = 1;
    for (int i = 0; i < n; ++i) {
        deg[i + 1] = deg[i] * P % MOD;
    }
    vector<ll> nh = calc_hsh(str);
    reverse(all(str));
    vector<ll> rh = calc_hsh(str);

    function<bool(int, int)> pol = [&](int l, int r) {
        int m1 = (l + r) / 2;
        int m2 = (l + r + 1) / 2;
        ll nor = (nh[m1] - nh[l] * deg[m1 - l] % MOD + MOD) % MOD;
        ll rev = (rh[n - m2] - rh[n - r] * deg[r - m2] % MOD + MOD) % MOD;
        return nor == rev;
    };

    for (int i = 0; i < n; ++i) {
        int l = 0, r = n;
        while (r - l > 1) {
            int m = (r + l) / 2;
            int le = i - m, ri = i + m + 1;
            if (0 <= le && ri <= n && pol(le, ri)) {
                l = m;
            } else {
                r = m;
            }
        }
        ev[i % 2].emplace_back(l, i);
    }

    Fen odd(n), even(n);
    int ans = 0;

    sort(all(ev[0]), greater<>());
    sort(all(ev[1]), greater<>());

    for (auto[m, i] : ev[0]) {
//        cerr << m << ' ' << i << endl;
        int st = 2 * m;
        if (i & 2) {
            ans += even.get(i - st, i + st);
            even.upd(i, 1);
        } else {
            ans += odd.get(i - st, i + st);
            odd.upd(i, 1);
        }
    }

    odd.clear(), even.clear();

    for (auto[m, i] : ev[1]) {
//        cerr << m << ' ' << i << endl;
        int st = 2 * m;
        if (i & 2) {
            ans += even.get(i - st, i + st);
            odd.upd(i, 1);
        } else {
            ans += odd.get(i - st, i + st);
            even.upd(i, 1);
        }
    }

    cout << ans << endl;
}
