#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

vector<int64_t> hashh;
vector<int64_t> hashhr;
vector<int64_t> powp;

const int p = 37;

int64_t gethash(int r, int l)
{
	return hashh[r] - hashh[l] * powp[r - l];
}

int64_t gethashr(int r, int l)
{
	return hashhr[l] - hashhr[r] * powp[r - l];
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n;
	cin >> n;
	string s;
	cin >> s;
	powp = vector<int64_t>(n + 1, 1);
	hashh = vector<int64_t>(n + 1, 0);
	hashhr = vector<int64_t>(n + 1, 0);
	vector<vector<int>> ar(n + 1, vector<int>(0, 0));
	for (int i = 1; i <= n; ++i)
	{
		hashh[i] = s[i - 1] - 'a' + 1 + hashh[i - 1] * p;
	}
	for (int i = n - 1; i > -1; --i)
	{
		hashhr[i] = s[i] - 'a' + 1 + hashhr[i + 1] * p;
	}
	for (int i = 1; i <= n; ++i)
	{
		powp[i] = powp[i - 1] * p;
	}
	for (int i = 0; i < n; ++i)
	{
		int l = 0, r = min(i + 1, n - i);
		while (r - l > 1)
		{
			int m = (l + r) / 2;
			if (gethashr(i, i - m) == gethash(i + m + 1, i + 1))
				l = m;
			else
				r = m;
		}
		int cnt = l + 1;
		int k = 1;
		while (ar[i].size() < 3 + 2 * (cnt - 1))
			ar[i].push_back(0);
		for (int j = 0; j < cnt; ++j)
		{
			ar[i][k] += 1;
			k += 2;
		}
		l = 0, r = min(i + 2, n - i);
		while (r - l > 1)
		{
			int m = (l + r) / 2;
			if (gethashr(i + 1, i - m + 1) == gethash(i + 1 + m, i + 1))
				l = m;
			else
				r = m;
		}
		cnt = l;
		while (ar[i].size() < 3 + 2 * (cnt))
			ar[i].push_back(0);
		k = 2;
		for (int j = 0; j < cnt; ++j)
		{
			ar[i][k] += 1;
			k += 2;
		}
	}
	int ans = 0;
	for (int i = 0; i < n; ++i)
	{
		for (int j = 1; j < ar[i].size(); ++j)
		{
			if (ar[i][j] == 1)
			{
				if (i - j >= 0 && j < ar[i - j].size() && ar[i - j][j] == 1)
					ans++;
			}
		}
	}
	cout << ans << endl;
}