#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <unordered_map>
#include <algorithm>
#include <fstream>
#include <iomanip>
#include <string>
#include <math.h>
#include <map>
#include <set>
#include <cassert>

using namespace std;

typedef long long ll;

const int N = 500010;
const int INF = (int)1e9 + 10;

const ll MOD = (int)1e9 + 7;

const ll P = 31;

struct Hash {
	ll x;
	Hash() { x = 0; }
	Hash(ll nx) {
		nx %= MOD;
		while (nx < 0)
			nx += MOD;
		x = nx;
	}
	Hash operator+=(Hash& c) {
		x = Hash(x + c.x).x;
		return *this;
	}
	Hash operator+(Hash& c) {
		Hash t = *this;
		t += c;
		return t;
	}
	Hash operator-=(Hash& c) {
		x = Hash(x - c.x).x;
		return *this;
	}
	Hash operator-(Hash& c) {
		Hash t = *this;
		t -= c;
		return t;
	}
	Hash operator*=(ll mn) {
		x = Hash(x * mn).x;
		return *this;
	}
	Hash operator*(ll mn) {
		Hash t = *this;
		t *= mn;
		return t;
	}
	Hash operator+=(ll c) {
		x = Hash(x + c).x;
		return *this;
	}
	Hash operator+(ll c) {
		Hash t = *this;
		t += c;
		return t;
	}
	bool operator==(const Hash& c) {
		return (x == c.x);
	}
};

Hash pref[N], r_pref[N];

int lp_nech[N], rp_nech[N];
int len_nech[N];

int lp_ch[N], rp_ch[N];
int len_ch[N];

string s;

int n;

ll stp[N];

bool check(int l, int r) {

	return ((pref[r] - pref[l - 1]) * stp[n - l + 1] == (r_pref[n - l + 1] - r_pref[n - r]) * stp[r]);
}

int cntst[N], cnten[N];



int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif
	cin >> n;
	cin >> s;
	s = '0' + s;
	stp[0] = 1;
	for (int i = 1; i <= n; ++i) {
		stp[i] = (stp[i - 1] * P) % MOD;
		pref[i] = pref[i - 1] + stp[i] * (ll)(s[i] - 'a' + 1);
	}
	reverse(s.begin() + 1, s.end());
	for (int i = 1; i <= n; ++i) {
		r_pref[i] = r_pref[i - 1] + stp[i] * (ll)(s[i] - 'a' + 1);
	}
	for (int i = 1; i <= n; ++i) {
		int l = 1, r = min(i, n - i + 1) + 1;
		while (r - l > 1) {
			int mid = (l + r) >> 1;
			if (check(i - mid + 1, i + mid - 1))
				l = mid;
			else
				r = mid;
		}
		lp_nech[i] = i - l + 1;
		rp_nech[i] = i + l - 1;
		len_nech[i] = l;
		/*for (int j = lp_nech[i]; j <= i; ++j) {
			cntst[j]++;
		}
		for (int j = i; j <= rp_nech[i]; ++j) {
			cnten[j]++;
		}*/
	}
	for (int i = 1; i < n; ++i) {
		int l = 0, r = min(i, n - i) + 1;
		while (r - l > 1) {
			int mid = (l + r) >> 1;
			if (check(i - mid + 1, i + mid))
				l = mid;
			else
				r = mid;
		}
		len_ch[i] = l;
		lp_ch[i] = i - l + 1;
		rp_ch[i] = i + l - 1;
	}
	ll ans = 0;
	for (int i = 1; i <= n; ++i) {
		for (int j = i; j <= n; ++j) {
			int len = j - i + 1;
			if (len % 2)
				continue;
			if (check(i, i + len / 2 - 1) && check(i + len / 2, j))
				++ans;
		}
	}
	cout << ans;
}