//#pragma GCC target("avx2")

#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {/*
    ios_base::sync_with_stdio(0);
    cin.tie(0);*/
    solve();
}

const ll mod = 1e9 + 9;
const ll p = 37;

int n;
vector<ll> a;
vector<ll> h1, h2, pp;


ll calc(vector<ll> &h, int i, int j) {
    return (h[j + 1] - h[i] * pp[j - i + 1]) % mod;
}

void solve() {
    cin >> n;
    a.resize(n);
    h1.resize(n + 1);
    h2.resize(n + 1);
    pp.resize(n + 1);

    for (int i = 0; i < n; ++i) {
        char x;
        cin >> x;
        a[i] = x - 'a' + 1;
    }

    pp[0] = 1;
    for (int i = 1; i <= n; ++i) {
        pp[i] = (pp[i - 1] * p) % mod;
    }

    for (int i = 0; i < n; ++i) {
        h1[i + 1] = (h1[i] * p + a[i]) % mod;
    }

    for (int i = 0; i < n; ++i) {
        h2[i + 1] = (h2[i] * p + a[n - i - 1]) % mod;
    }

    int ans = 0;

    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; j += 2) {
            int k = (i + j) / 2;
            int len1 = k - i + 1;
            int len2 = j - k;
            ll r1, r2, r3, r4;
            if (len1 % 2) {
                r1 = calc(h1, i, (i + k) / 2);
                r2 = calc(h2, n - k - 1,  n - (i + k) / 2 - 1); /// [(i + k) / 2; k] => [n - k - 1; n - (i + k) / 2 - 1]
            } else {
                r1 = calc(h1, i, (i + k) / 2);
                r2 = calc(h2, n - k - 1, n - (i + k) / 2 - 1 - 1); /// [(i + k) / 2 + 1; k] => [n - k - 1; n - (i + k) / 2 - 1 - 1]
            }
            if (len2 % 2) { /// [k + 1, j] => [k + 1, (k + j + 1) / 2, j]
                int l = k + 1, r = j;
                r3 = calc(h1, l, (l + r) / 2);
                r4 = calc(h2, n - r - 1, n - (l + r) / 2 - 1);
            } else {
                int l = k + 1, r = j;
                r3 = calc(h1, l, (l + r) / 2);
                r4 = calc(h2, n - r - 1, n - (l + r) / 2 - 1 - 1);
            }
            ans += (r1 == r2 && r3 == r4);
            //cout << "l,r" sp i+1 sp j+1 nl;
            //cout << (r1 == r2) sp (r3 == r4) nl;
        }
    }

    cout << ans nl;
}
