#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (1 << 19);

void IOOptimize() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
}

vector <vector <int>> g;
vector <vector <int>> h;

vector <int> color;
bool ColorDfs(int u, int c = 0) {
	color[u] = c;
	bool ok = true;
	for (auto i : h[u]) {
		if (color[i] == -1) {
			ok &= ColorDfs(i, c ^ 1);
		}
		if (!(color[i] ^ color[u])) {
			return false;
		}
	}
	return ok;
}

void SolveSpider(int m, int k, int sp) {
	vector <int> c(g.size());
	color.resize(g.size(), -1);
	h.resize(g.size());
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		if (a != sp && b != sp) {
			h[a].push_back(b);
			h[b].push_back(a);
		}
	}
	for (int i = 0; i < g.size(); i++) {
		if (-1 == color[i]) {
			if (!ColorDfs(i)) {
				cout << -1;
				return;
			}
		}
	}
	c[sp] = 1 + (m != 0);
	for (int i = 0; i < g.size(); i++) {
		if (i != sp && color[i] == 0)
			c[i] = 1;
		if (i != sp && color[i] == 1)
			c[i] = 3;
	}
	cout << *max_element(c.begin(), c.end()) << endl;
	for (auto i : c)
		cout << i << " ";
}

void Solve() {
	int n, m, k;
	cin >> n >> m >> k;
	g.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	for (int i = 0; i < n; i++) {
		if (g[i].size() == n - 1) {
			SolveSpider(m, k, i);
			exit(0);
		}
	}
}

int main() {
	IOOptimize();
	Solve();
}