#include <iostream>
#include <algorithm>
#include <random>

using namespace std;

typedef long long ll;

mt19937 rnd(23);

const ll MOD = (int) 1e9 + 7;
uniform_int_distribution<int> d(30, MOD - 1);
ll BASE = d(rnd);
const int MAX_N = 5e5 + 10;
ll b[MAX_N];
ll h1[MAX_N];
ll h2[MAX_N];
int n;

inline ll getHash(ll *h, int l, int r) {
    int pow = r - l + 1;
    return ((h[r + 1] - h[l] * b[pow]) % MOD + MOD) % MOD;
}

bool isPal(int l, int r) {
    int newR = n - l - 1;
    int len = r - l + 1;
    int newL = newR - len + 1;
    return getHash(h1, l, r) == getHash(h2, newL, newR);
}


void calcHash(string &s, ll *h) {
    h[0] = 0;
    for (int i = 1; i <= (int) s.size(); i++) {
        h[i] = h[i - 1] * BASE + ((int)s[i - 1] - 'a' + 1);
        h[i] %= MOD;
    }
}

typedef long long ll;

bool check(int l, int r) {
    int n = (r - l + 1);
    int mN = n / 2;
    return isPal(l, l + mN - 1) && isPal(l + mN, r);
}

int main() {
#ifdef LOCAL
    freopen("D.in", "r", stdin);
#endif
    b[0] = 1;
    for (int i = 1; i < MAX_N; i++) {
        b[i] = b[i - 1] * BASE;
        b[i] %= MOD;
    }

    cin >> n;
    string s;
    cin >> s;
    ll ans = 0;
    string sRev = s;
    reverse(sRev.begin(), sRev.end());
    calcHash(s, h1);
    calcHash(sRev, h2);
    for (int l = 2; l  <= n; l += 2) {
        for (int st = 0; st <= n - l; st++) {
            if (check(st, st + l - 1)) {
                ans++;
            }
        }
    }
    cout << ans << "\n";
}