#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#pragma GCC optimize("Ofast")
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <random>
#include <queue>
using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmax(x, y) x = max(x, y)

int n;
string s;
ll ans = 0;
vector<int> odd, even;
void precal() {
  odd.resize(n), even.resize(n);
  for(int i = 0; i < n; i++) {
    while (i - odd[i] >= 0 && i + odd[i] < n) {
      if (s[i - odd[i]] == s[i + odd[i]]) {
        odd[i]++;
      } else break;
    }
    while (i - even[i] >= 0 && i + even[i] + 1 < n) {
      if (s[i - even[i]] == s[i + even[i] + 1]) {
        even[i]++;
      } else break;
    }
  }
}

struct Fen {
  vector<int> f;
  int N;
  Fen(int n) {
    f.resize(n + 1);
    N = n;
  }
  void inc(int x, int y) {
    for(; x < N; x |= (x + 1))
      f[x] += y;
  }
  int get(int x) {
    int ret = 0;
    for(; x >= 0; x = (x & (x + 1)) - 1)
      ret += f[x];
    return ret;
  }
  int get(int l, int r) {
    return get(min(N - 1, r)) - get(l - 1);
  }
};

bool cmpOdd(int x, int y) {
  return odd[x] > odd[y];
}

bool pal(int x, int y) {
  assert((y - x + 1) % 2);
  while (x <= y) {
    if (s[x] != s[y]) return 0;
    x++, y--;
  }
  return 1;
}

void workOdd() {
  vector<int> ord(n);
  iota(all(ord), 0);
  sort(all(ord), cmpOdd);
  Fen fodd(n), feven(n);
  for(int x : ord) {
    if (x % 2 == 1) {
      ans += feven.get(x - odd[x] * 2 + 1, x + odd[x] * 2 - 1);
      fodd.inc(x, 1);
    } else {
      ans += fodd.get(x - odd[x] * 2 + 1, x + odd[x] * 2 - 1);
      feven.inc(x, 1);
    }
  }
}

void workEven() {
  vector<int> ord(n);
  iota(all(ord), 0);
  sort(all(ord), cmpOdd);
  Fen fodd(n), feven(n);
  for(int x : ord) {
    if (x % 2 == 0) {
      ans += feven.get(x - even[x] * 2, x + even[x] * 2);
      feven.inc(x, 1);
    } else {
      ans += fodd.get(x - even[x] * 2, x + even[x] * 2);
      fodd.inc(x, 1);
    }
  }
}

void run() {
  cin >> n >> s;
  precal();
  workOdd();
  workEven();
  cout << ans;
}

int main()
{
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
// gene();

  run();
}
