#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}
ll time() {
    return chrono::steady_clock::now().time_since_epoch().count();
}

#define SPAR 0
#define FEN 1
#define SEG 0

#if SPAR
namespace SPARSE {
    bool run = false;
    const int N = 1e5;
    const int LOG = 17;

    int log[N];

    void init() {
        if (!run) {
            run = true;
            log[0] = 0;

            for (int i = 1; i < LOG; ++i) {
                for (int j = (1 << i); j < (1 << (i + 1)) && j < N; ++j)
                    log[j] = i;
            }
        }
    }
};
struct Sparse {
    int n, p = 0;
    int **t;

    Sparse(int _n) {
        SPARSE::init();
        n = _n;
        t = new int*[n];
        for (int i = 0; i < n; ++i)
            t[i] = new int[SPARSE::LOG];
    }

    void push(int x) {
        t[n - p - 1][0] = x;
        for (int i = 0; i < SPARSE::LOG - 1; ++i) {
            if (n - p - 1 + (1 << i) < n)
                t[n - p - 1][i + 1] = min(t[n - p - 1][i], t[n - p - 1 + (1 << i)][i]);
            else
                t[n - p - 1][i + 1] = t[n - p - 1][i];
        }
        p++;
    }

    int get(int l, int r) {
        int k = SPARSE::log[r - l];

        return min(t[l][k], t[r - (1 << k)][k]);
    }
};
#endif

#if FEN
struct Fen {
    ll *t;
    int n;
    Fen(int _n) {
        n = _n;
        t = new ll[n];

        memset(t, 0, sizeof(t[0]) * n);
    }

    void add(int i, ll x) {
        for (;i < n; i = i | (i + 1))
            t[i] += x;
    }

    ll get(int r) {
        r--;
        ll res = 0;
        for (;r >= 0; r = (r & (r + 1)) - 1)
            res += t[r];
        return res;
    }

    ll get(int l, int r) {
        r = max(r, 0);
        r = min(r, n);
        l = max(l, 0);
        l = min(l, n);
        return get(r) - get(l);
    }
};
#endif

#if SEG
struct SegTree {
    int n;
    ll *t, *d;

    SegTree(int _n) {
        n = _n;
        int sz = 1;
        while (sz < 2 * n) sz *= 2;
        t = new ll[sz];
        d = new ll[sz];

        for (int i = 0; i < sz; ++i)
            t[i] = d[i] = 0;
    }

    ll getV(int v, int vl, int vr) {
        return t[v] + d[v] * (vr - vl);
    }

    void push(int v, int vl, int vr) {
        d[2 * v + 1] += d[v];
        d[2 * v + 2] += d[v];
        t[v] = getV(2 * v + 1, vl, vr) + getV(2 * v + 2, vl, vr);
    }

    void upd(int v, int vl, int vr, int l, int r, ll x) {
        if (vl == l && vr == r) {
            d[v] += x;
        } else {
            push(v, vl, vr);
            int m = (vl + vr) / 2;

            if (r <= m)
                upd(2 * v + 1, vl, m, l, r, x);
            else if (m <= l)
                upd(2 * v + 2, m, vr, l, r, x);
            else
                upd(2 * v + 1, vl, m, l, m, x), upd(2 * v + 2, m, vr, m, r, x);

            t[v] = getV(2 * v + 1, vl, vr) + getV(2 * v + 2, vl, vr);
        }
    }

    void upd(int l, int r, ll x) {
        upd(0, 0, n, l, r, x);
    }

    ll get(int v, int vl, int vr, int l, int r) {
        if (vl == l && vr == r) {
            return getV(v, vl, vr);
        } else {
            int m = (vl + vr) / 2;
            push(v, vl, vr);

            if (r <= m)
                return get(2 * v + 1, vl, m, l, r);
            else if (m <= l)
                return get(2 * v + 2, m, vr, l, r);
            else
                return get(2 * v + 1, vl, m, l, m) + get(2 * v + 2, m, vr, m, r);
        }
    }

    ll get(int l, int r) {
        r = min(r, n);
        l = min(l, n);
        if (l == r) return 0;
        return get(0, 0, n, l, r);
    }
};
#endif

int median(int a, int b, int c) {
    vector<int> v = {a, b, c};

    sort(v.begin(), v.end());

    return v[1];
}

const int CNT = 1;

vector<int> mods = {(int)1e9 + 7, (int)1e9 + 9};
vector<int> base;

struct Hash {
    int n;
    int *t[CNT], *p[CNT];
    Hash(string &s) {
        n = s.length();

        for (int i = 0; i < CNT; ++i) {
            t[i] = new int[n];
            p[i] = new int[n];

            t[i][0] = s[0] - 'a' + 1;
            p[i][0] = 1;

            for (int j = 1; j < n; ++j) {
                t[i][j] = ((ll)t[i][j - 1] * (ll)base[i] + s[j] - 'a' + 1) % mods[i];
                p[i][j] = ((ll)p[i][j - 1] * base[i]) % mods[i];
            }
        }
    }

    vector<int> get(int l, int r) { // [l, r]
        vector<int> res;

        for (int i = 0; i < CNT; ++i) {
            int now = t[i][r];
            if (l)
                now -= ((ll)t[i][l - 1] * p[i][r - l + 1]) % mods[i];
            if (now < 0) now += mods[i];
            res.push_back(now);
        }

        return res;
    }
};

bool check_polindrom(int l, int r, Hash h, Hash rh) {
    if (l < 0 || r >= h.n)
        return false;
    if (l == r)
        return true;

    int n = h.n;

    auto a = h.get(l, r);
    auto b = rh.get(n - r - 1, n - l - 1);

    return a == b;
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    mt19937 rnd(time());
    for (int i = 0; i < CNT; ++i)
        base.push_back(rnd() % 30 + 20);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;
    string s, rs;
    cin >> s;
    rs = s;
    reverse(rs.begin(), rs.end());

    Hash h(s), rh(rs);

    int len_1[n], len_2[n];

    for (int i = 0; i < n; ++i) {
        int l = 0, r = n, m;
        while (l != r) {
            m = (l + r + 1) / 2;
            if (check_polindrom(i - m, i + m, h, rh))
                l = m;
            else
                r = m - 1;
        }
        len_1[i] = l;
    }

    for (int i = 0; i < n - 1; ++i) {
        if (s[i] == s[i + 1]) {
            int l = 0, r = n, m;
            while (l != r) {
                m = (l + r + 1) / 2;
                if (check_polindrom(i - m, i + m + 1, h, rh))
                    l = m;
                else
                    r = m - 1;
            }
            len_2[i] = l;
        } else {
            len_2[i] = -1;
        }
    }
//
//    SegTree cnt(n);
//
////    Fen cnt(n), ans(n);
////
////    for (int i = 0; i < n; ++i) {
////        cnt.add(i - len_1[i], 1);
////        ans.add(i - len_1[i], n - i + len_1[i]);
////    }
////
////    for (int i = 0; i < n - 1; ++i) {
////        if (len_2[i] != -1) {
////            cnt.add(i - len_2[i], 1);
////            ans.add(i - len_2[i], n - i + len_2[i]);
////        }
////    }
//
//    for (int i = 0; i < n; ++i) {
//        cnt.upd(i - len_1[i], i + 1, 1);
//    }
//
//    for (int i = 0; i < n - 1; ++i) {
//        if (len_2[i] != -1)
//            cnt.upd(i - len_2[i], i + 1, 1);
//    }
//
////
////    ll res = 0;
////
////    for (int i = 0; i < n; ++i) {
////        ll a = ans.get(i + 1, i + len_1[i] + 2), b = cnt.get(i + 1, i + len_1[i] + 2);
////        res += ans.get(i + 1, i + len_1[i] + 2) + cnt.get(i + 1, i + len_1[i] + 2) * (-n + i + len_1[i] + 2);
////    }
////
////    for (int i = 0; i < n - 1; ++i) {
////        if (len_2[i] != -1)
////            res += ans.get(i + 2, i + 1 + len_2[i] + 2) + cnt.get(i + 2, i + 1 + len_2[i] + 2) * (-n + i + 3 + len_2[i]);
////    }
////
////    cout << res;
//
//    ll res = 0;
//
//    for (int i = 0; i < n; ++i) {
//        res += cnt.get(i + 1, i + len_1[i] + 2);
//    }
//
//    for (int i = 0; i < n - 1; ++i) {
//        if (len_2[i] != -1) {
//            res += cnt.get(i + 2, i + 1 + len_2[i] + 2);
//        }
//    }
//
//    cout << res;

    vector<int> enable_1[n], enable_2[n];

    for (int i = 0; i < n; ++i) {
        enable_1[max(i - len_1[i] * 2 - 1, 0)].push_back(i);
    }

    for (int i = 0; i < n - 1; ++i) {
        if (len_2[i] != -1) {
            enable_2[max(i - len_2[i] * 2 - 2, 0)].push_back(i);
        }
    }

    Fen f_1(n), f_1n(n), f_2(n), f_2n(n);

    ll res = 0;

    for (int i = 0; i < n; ++i) {
        for (int j: enable_1[i]) {
            if (j % 2 == 0)
                f_1.add(j, 1);
            else
                f_1n.add(j, 1);
        }

        if (i % 2 == 0)
            res += f_1n.get(i + 1, i + len_1[i] * 2 + 2);
        else
            res += f_1.get(i + 1, i + len_1[i] * 2 + 2);
    }

    for (int i = 0; i < n - 1; ++i) {
        for (int j: enable_2[i]) {
            if (j % 2 == 0)
                f_2.add(j, 1);
            else
                f_2n.add(j, 1);
        }

        if (i % 2 == 0)
            res += f_2.get(i + 1, i + 1 + len_2[i] * 2 + 2);
        else
            res += f_2n.get(i + 1, i + 1 + len_2[i] * 2 + 2);
    }

    cout << res;

    return 0;
}

