#define _CRT_SECURE_NO_WARNINGS
#define REL

#pragma GCC optimize ("Ofast")

#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <iomanip>
#include <bitset>
#include <ctime>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <random>
#include <algorithm> 
#include <queue>
#include <deque>

using namespace std;

#define endl "\n"
#define mp make_pair
#define mt make_tuple
#define size(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long LL;
typedef long double LD;

template <typename T> 
bool uin(T& a, const T& b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template <typename T>
bool uax(T& a, const T& b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

mt19937_64 rnd;

const int LOG = 20;
const LL LINF = 1e18;
const int N = (int)1e6 + 7;
const int INF = (int)1e9 + 7;
const int MOD = (int)1e9 + 7;
const int MAXN = (int)1e6 + 7;

///////////////////////////////////////////////////////////////////////

string s, t;
int n, fen[4][N];

void add(int pos, int val, int ind) {
	for (int i = pos; i < N; i = (i | (i + 1))) 
		fen[ind][i] += val;
}

int sum(int pos, int ind) {
	int res = 0;
	for (int i = pos; i >= 0; i = (i & (i + 1)) - 1)
		res += fen[ind][i];
	return res;
}

int sum(int l, int r, int ind) {
	if (l > r)
		return 0;
	if (l == 0)
		return sum(r, ind);
	return sum(r, ind) - sum(l - 1, ind);
}

vector <int> get_pal() {
	vector <int> res(n);
	res[0] = 1;
	int l = 0, r = 0;
	for (int i = 1; i < n; i++) {
		if (i <= r)
			res[i] = min(r - i + 1, res[2 * l - i]);
		int lpos = i - res[i], rpos = i + res[i];
		while (lpos >= 0 && rpos < n && t[lpos] == t[rpos])
			res[i]++, lpos--, rpos++;
		if (i + res[i] - 1 > r)
			l = i, r = i + res[i] - 1;
	}
	return res;
}

int main() {
#ifdef _DEBUG 
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else 
	rnd.seed(time(0));
	cin.tie(0), cout.tie(0);
	ios_base::sync_with_stdio(0);
#endif 
	cin >> n >> s;
	for (int i = 0; i < n; i++) {
		t += s[i];
		t += '#';
	}
	t.pop_back();
	n = size(t);
	auto pal = get_pal();
	LL ans = 0;
	vector <pair<int, int>> act;
	for (int i = 0; i < n; i++) {
		act.push_back(mp(2 * pal[i] + i, i));
		if (i % 4 == 0)
			add(i, 1, 0);
		if (i % 4 == 1)
			add(i, 1, 1);
		if (i % 4 == 2)
			add(i, 1, 2);
		if (i % 4 == 3)
			add(i, 1, 3);
	}
	sort(all(act));
	int ind = 0;
	for (int i = 0; i < n; i++) {
		if (i % 4 == 0) 
			ans += sum(max(0, i - 2 * pal[i]), i - 1, 2);
		if (i % 4 == 1)
			ans += sum(max(0, i - 2 * pal[i]), i - 1, 1);
		if (i % 4 == 2)
			ans += sum(max(0, i - 2 * pal[i]), i - 1, 0);
		if (i % 4 == 3)
			ans += sum(max(0, i - 2 * pal[i]), i - 1, 3);
		while (ind < n && act[ind].first <= i) {
			int pos = act[ind].second;
			if (pos % 4 == 0)
				add(pos, -1, 0);
			if (pos % 4 == 1)
				add(pos, -1, 1);
			if (pos % 4 == 2)
				add(i, -1, 2);
			if (pos % 4 == 3)
				add(pos, -1, 3);
			ind++;
		}
	}
	cout << ans;
}