#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
#define pb push_back
#define all(arr) arr.begin(), arr.end()
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vi> vvi;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define forn1(i0, n0) for (int i0 = 1; i0 < n0; ++i0)
#define F first
#define S second

const int maxn = 5e5 + 3;
vll p1(maxn), p2(maxn);
const ll mod1 = 1e9 + 7, mod2 = 1e9 + 9;

vpll Hash(string s) {
    s = "#" + s;
    int n = s.length();
    vpll ans(n);
    ll h1 = 0, h2 = 0;
    forn(i, n) {
        ll x = s[i] - 'a' + 1;
        h1 = (h1 + p1[i] * x) % mod1;
        h2 = (h2 + p2[i] * x) % mod2;
        ans[i] = {h1, h2};
    }
    return ans;
}

pll get(vpll &h, int l, int r) {
    //cout << h.size() << endl;
    pll ans = h[r + 1];
    ans.F -= h[l].F;
    ans.S -= h[l].S;
    if (ans.F < 0) ans.F += mod1;
    if (ans.S < 0) ans.S += mod2;
    ans.F = (ans.F * p1[maxn - l - 1]) % mod1;
    ans.S = (ans.S * p2[maxn - l - 1]) % mod2;
    return ans;
}

bool palindrome(int n, vpll &h1, vpll &h2, int l, int r) {
    int l1 = l, r1 = (l + r) >> 1;
    int l2 = r1 + (r - l) % 2, r2 = r;
    l2 = n - l2 - 1, r2 = n - r2 - 1;
    swap(l2, r2);
    //cout << l << ' ' << r << ' ' << l1 << ' ' << r1 << ' ' << l2 << ' ' << r2 << endl;
    return (get(h1, l1, r1) == get(h2, l2, r2));
}

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int sz = 1 << 19;
vvi t(2 * sz);

int main() {
    p1[0] = p2[0] = 1;
    forn1(i, maxn) {
        p1[i] = (p1[i - 1] * 47) % mod1;
        p2[i] = (p2[i - 1] * 283) % mod2;
    }
    init();
    int n;
    string s;
    cin >> n >> s;
    string s1 = s;
    reverse(all(s1));
    vpll h1 = Hash(s), h2 = Hash(s1);
    vi l1(n), l2(n, -1);
    vvi f1(n, vi(n)), f2(n, vi(n));
    forn(i, n) {
        int maxlen = min(i, n - i - 1);
        int lt = 0, rt = maxlen;
        while (lt != rt) {
            int m = (lt + rt + 1) >> 1;
            if (palindrome(n, h1, h2, i - m, i + m)) lt = m; else rt = m - 1;
        }
        if (i > 0) f1[i] = f1[i - 1];
        for (int j = 0; j <= lt; ++j){
            if (i > 2 * j) f1[i][i - 2 * j - 1]++;
        }
        l1[i] = lt;
    }
    forn(i, n - 1){
        if (i > 0) f2[i] = f2[i - 1];
        if (s[i] == s[i + 1]){
            int maxlen = min(i, n - i - 2);
            int lt = 0, rt = maxlen;
            while (lt != rt) {
                int m = (lt + rt + 1) >> 1;
                if (palindrome(n, h1, h2, i - m, i + m)) lt = m; else rt = m - 1;
            }
            for (int j = 0; j <= lt; ++j){
                if (i >= 2 * j + 2){
                    f2[i][i - 2 * j - 2]++;
                }
            }
            l2[i] = lt;
        }
    }
    vector<set<int>> palindromes(n);
    forn(i, n){
        forn(j, 1 + l1[i]) palindromes[i].insert(2 * j + 1);
        forn(j, 1 + l2[i]) palindromes[i].insert(2 * j + 2);
    }
    int ans = 0;
    forn(i, n){
        //ans += f1[min(n - 1, i + 2 * l1[i] + 1)][i];
        //if (l2[i] != -1) ans += f2[min(n - 2, i + 2 * l2[i] + 2)][i];
        for (int p : palindromes[i]){
            if (i + p < n && palindromes[i + p].count(p)) ans++;
        }
    }
    cout << ans << '\n';
    return 0;
}