#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define endl "\n"
template<class T>bool chkmin(T &a, const T b) {return (a > b) ? a = b, 1 : 0;}
template<class T>bool chkmax(T &a, const T b) {return (a < b) ? a = b, 1 : 0;}
const ll mod = 1e9 + 7, base = 27;

void fix(ll &x) {
    if(x >= mod || x <= -mod) {x %= mod;}
    if(x < 0) {x += mod;}
}

const int MAX_N = 5e5 + 10;
ll pref1[MAX_N], pref2[MAX_N];
ll pw[MAX_N];
int n;
string in;

ll query1(int l, int r) {ll ans = pref1[r]; if(l > 0) {ans -= pref1[l - 1];} fix(ans); return ans;}
ll query2(int l, int r) {ll ans = pref2[r]; if(l > 0) {ans -= pref2[l - 1];} fix(ans); return ans;}

bool palin(int l, int r) {
    if(l < 0 || r >= n) {return false;}
    ll hash1 = query1(l, r) * pw[n - 1 - r]; fix(hash1);
    ll hash2 = query2(l, r) * pw[l]; fix(hash2);
    return hash1 == hash2;
}

int k[MAX_N], m[MAX_N];

ll fast() {
    ll ans = 0;
    for(int i = 0; i < n; i ++) {
        for(int j = i + 1; j < n; j ++) {
            if((i - j + 1) & 1) {continue;}
            if(k[i] * 2 >= (j - i + 1) && k[j] * 2 >= (j - i + 1)) {
                ans ++;
            }
        }
    }
    for(int i = 0; i < n; i ++) {
        for(int j = i + 1; j < n; j ++) {
            if((i - j + 2) & 1) {continue;}
            if(m[i] * 2 >= (j - i + 2) && m[j] * 2 >= (j - i + 2)) {
                ans ++;
            }
        }
    }
    return ans;
}

struct SegTree {
    ll tree[2 * MAX_N];
    void upd(int ind, int val) {
        ind += MAX_N; tree[ind] = val; ind /= 2;
        while(ind > 0) {
            tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
            ind /= 2;
        }
    }
    ll ans(int l, int r) {
        l += MAX_N; r += MAX_N + 1;
        ll ret = 0;
        while(l < r) {
            if(l & 1) {ret += tree[l]; l ++;}
            if(r & 1) {r --; ret += tree[r];}
            l /= 2; r /= 2;
        }
        return ret;
    }
};
SegTree st1, st2;

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);
    cin >> n >> in;
    pw[0] = 1;
    for(int i = 1; i < MAX_N; i ++) {
        pw[i] = pw[i - 1] * base;
        fix(pw[i]);
    }
    pref1[0] = in[0] - 'a';
    pref2[0] = pw[n - 1] * (in[0] - 'a'); fix(pref2[0]);
    for(int i = 1; i < n; i ++) {
        pref1[i] = pref1[i - 1] + (pw[i] * (in[i] - 'a')); fix(pref1[i]);
        pref2[i] = pref2[i - 1] + (pw[n - 1 - i] * (in[i] - 'a')); fix(pref2[i]);
    }
    for(int i = 0; i < n; i ++) {
        int l = 1, r = n;
        while(l < r - 1) {
            int m = (l + r) / 2;
            if(palin(i - m + 1, i + m - 1)) {
                l = m;
            } else {
                r = m;
            }
        }
        k[i] = l;
    }
    for(int i = 0; i < n; i ++) {
        int l = 0, r = n;
        while(l < r - 1) {
            int m = (l + r) / 2;
            if(palin(i - m + 1, i + m)) {
                l = m;
            } else {
                r = m;
            }
        }
        m[i] = l + 1;
    }
    priority_queue<pair<int, int> > pq;
    ll ret = 0;
    for(int i = 0; i < n; i ++) {
        while(!pq.empty() && -pq.top().first < i) {
            if(pq.top().second & 1) {
                st1.upd(pq.top().second, 0);
            } else {
                st2.upd(pq.top().second, 0);
            }
            pq.pop();
        }
        if(i & 1) {
            ret += st2.ans(i + 1 - 2 * k[i], i);
        } else {
            ret += st1.ans(i + 1 - 2 * k[i], i);
        }
        pq.push({-2 * k[i] - i + 1, i});
        if(i & 1) {
            st1.upd(i, 1);
        } else {
            st2.upd(i, 1);
        }
    }
    while(!pq.empty()) {
        if(pq.top().second & 1) {
            st1.upd(pq.top().second, 0);
        } else {
            st2.upd(pq.top().second, 0);
        }
        pq.pop();
    }
    for(int i = 0; i < n; i ++) {
        while(!pq.empty() && -pq.top().first < i) {
            if(pq.top().second & 1) {
                st1.upd(pq.top().second, 0);
            } else {
                st2.upd(pq.top().second, 0);
            }
            pq.pop();
        }
        if(i & 1) {
            ret += st1.ans(i + 2 - 2 * m[i], i);
        } else {
            ret += st2.ans(i + 2 - 2 * m[i], i);
        }
        pq.push({-2 * m[i] - i + 2, i});
        if(i & 1) {
            st1.upd(i, 1);
        } else {
            st2.upd(i, 1);
        }
    }
    cout << ret << endl;
    return 0;

}
