#include <bits/stdc++.h>

using namespace std;

#define endl "\n"

long long mod = 1791791791, p = 57;
string s;
int n;
vector<long long> hs, pw, rwhs;

void init() {
    hs.resize(n + 1);
    rwhs.resize(n + 1);
    pw.resize(n + 1);
    hs[0] = 0;
    rwhs[0] = 0;
    pw[0] = 1;
    for (int i = 1; i <= n; i++) {
        hs[i] = hs[i - 1] * p + s[i - 1];
        rwhs[i] = rwhs[i - 1] * p + s[n - i];
        pw[i] = pw[i - 1] * p;
        hs[i] %= mod;
        rwhs[i] %= mod;
        pw[i] %= mod;
    }
    return;
}

long long HS(int i, int j) {
    return (mod + hs[j + 1] - ((hs[i] * pw[j - i + 1]) % mod)) % mod;
}

long long rwHS(int i, int j) {
    return (mod + rwhs[n - i] - ((rwhs[n - j - 1] * pw[(n - i - 1) - (n - j - 1) + 1]) % mod)) % mod;
}


vector<int> rt;
vector<vector<vector<int>>> tt;

void build(int v, int l, int r, int arg) {
    if (l + 1 == r) {
        tt[arg][v].push_back(rt[2 * l + arg]);
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m, arg);
    build(2 * v + 1, m, r, arg);
    int i = 0, j = 0;
    while (i < tt[arg][2 * v].size() && j < tt[arg][2 * v + 1].size()) {
        if (tt[arg][2 * v][i] < tt[arg][2 * v + 1][j]) {
            tt[arg][v].push_back(tt[arg][2 * v][i]); i++;
        }
        else {
            tt[arg][v].push_back(tt[arg][2 * v + 1][j]); j++;
        }
    }
    for (; j < tt[arg][2 * v + 1].size(); j++) tt[arg][v].push_back(tt[arg][2 * v + 1][j]);
    for (; i < tt[arg][2 * v].size(); i++) tt[arg][v].push_back(tt[arg][2 * v][i]);
    return;
}


int get(int v, int l, int r, int ll, int rr, int arg, int key) {
    if (l >= rr || r <= ll) return 0;
    if (l >= ll && r <= rr) {
        int ind = lower_bound(tt[arg][v].begin(), tt[arg][v].end(), key) - tt[arg][v].begin();
        return (int)tt[arg][v].size() - ind;
    }
    int m = (l + r) / 2;
    return (get(2 * v, l, m, ll, rr, arg, key) +
            get(2 * v + 1, m, r, ll, rr, arg, key));
}



int main()
{
    cin >> n;
    cin >> s;
    if (n == 1) {
        cout << 0 << endl;
        return 0;
    }
    if (n == 2) {
        cout << 1 << endl;
        return 0;
    }
    init();
    vector<int> t(n);
    rt.resize(n);
    tt.resize(2, vector<vector<int>>(2 * n));
    for (int i = 0; i < n; i++) {
        int l = 0, r = min(i + 1, n - i);
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (HS(i - mid, i - 1) == rwHS(i + 1, i + mid)) l = mid;
            else r = mid;
        }
        t[i] = r;
        rt[i] = 2 * t[i] - i;
    }
    vector<int> nn;
    nn.push_back((n / 2) + (n % 2));
    nn.push_back((n / 2));
    build(1, 0, nn[0], 0);
    build(1, 0, nn[1], 1);
    long long ans = 0;
    for (int i = 0; i < n; i++) {
        int arg = (i + 1) % 2;
        int st = ((i + 1) / 2); int fn = min(nn[arg], st + t[i]);
        ans += get(1, 0, nn[arg], st, fn, arg, -i);
    }
    rt.clear();
    tt.clear();
    t.clear();
    nn.clear();
    t.resize(n - 1);
    rt.resize(n - 1);
    tt.resize(2, vector<vector<int>>(2 * n));
    for (int i = 0; i < n - 1; i++) {
        int l = 0, r = min(i + 2, n - i);
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (HS(i + 1 - mid, i) == rwHS(i + 1, i + mid)) l = mid;
            else r = mid;
        }
        t[i] = l;
        rt[i] = 2 * t[i] - i;
    }
    nn.push_back(((n - 1) / 2) + ((n - 1) % 2));
    nn.push_back(((n - 1) / 2));
    build(1, 0, nn[0], 0);
    build(1, 0, nn[1], 1);
    for (int i = 0; i < n - 1; i++) {
        int arg = i % 2;
        int st = ((i + 2) / 2); int fn = min(nn[arg], st + t[i]);
        ans += get(1, 0, nn[arg], st, fn, arg, -i);
    }
    cout << ans << endl;
    return 0;
}
