#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#pragma GCC optimize("Ofast")
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <random>
#include <queue>
using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmax(x, y) x = max(x, y)

int n;
string s;
ll ans = 0;
vector<int> odd, even;
mt19937 gen;

const ll m[] = {(ll)1e9 + 7, (ll)1e9 + 9};
const int N = 5e5 + 1;
const ll k = 1263167;
ll pw[2][N];

void precalPw() {
  for(int i = 0; i < 2; i++) {
    pw[i][0] = 1;
    for(int j = 1; j < N; j++) {
      pw[i][j] = pw[i][j - 1] * k % m[i];
    }
  }
}

struct Hash {
  string s;
  vector<ll> h[2];
  void build() {
    for(int i = 0; i < 2; i++) {
      h[i].resize(size(s) + 1);
      for(int j = 0; j < size(s); j++) {
        h[i][j + 1] = (h[i][j] * k + s[j]) % m[i];
      }
    }
  }
  pair<ll, ll> get(int l, int len) {
    return {(h[0][l + len] - h[0][l] * pw[0][len] + m[0] * m[0]) % m[0],
            (h[1][l + len] - h[1][l] * pw[1][len] + m[1] * m[1]) % m[1]};
  }
  Hash() {}
  Hash(string t) {
    s = t;
  }
};


Hash True, Inv;

inline bool is_pal(int l, int len, bool fl = 0) {
  if (!fl) {
    if (l - len + 1 < 0) return 0;
    if (l + len - 1 >= n) return 0;
  } else {
    if (l + len >= n) return 0;
    if (l - len + 1 < 0) return 0;
  }
  if (!fl)
    return True.get(l, len) == Inv.get(n - l - 1, len);
  else
    return True.get(l + 1 , len) == Inv.get(n - l - 1, len);
}

void precal() {
  True.s = s;
  Inv.s = s;
  reverse(all(Inv.s));
  True.build();
  Inv.build();
  odd.resize(n), even.resize(n);
  for(int i = 0; i < n; i++) {
    int l = 0, r = n + 1;
    while (r - l > 1) {
      int m = (l + r) / 2;
      if (is_pal(i, m)) l = m;
      else r = m;
    }
    odd[i] = l;

    if (i + 1 < n && s[i] == s[i + 1]) {
      l = 0, r = n + 1;
      while (r - l > 1) {
        int m = (l + r) / 2;
        if (is_pal(i, m, 1)) l = m;
        else r = m;
      }
      even[i] = l;
    }
  }
}

struct Fen {
  vector<int> f;
  int N;
  Fen(int n) {
    f.resize(n + 1);
    N = n;
  }
  void inc(int x, int y) {
    for(; x < N; x |= (x + 1))
      f[x] += y;
  }
  int get(int x) {
    int ret = 0;
    for(; x >= 0; x = (x & (x + 1)) - 1)
      ret += f[x];
    return ret;
  }
  int get(int l, int r) {
    return get(min(N - 1, r)) - get(l - 1);
  }
};

bool cmpOdd(int x, int y) {
  return odd[x] > odd[y];
}

bool pal(int x, int y) {
  while (x <= y) {
    if (s[x] != s[y]) return 0;
    x++, y--;
  }
  return 1;
}

void workOdd() {
  vector<int> ord(n);
  iota(all(ord), 0);
  sort(all(ord), cmpOdd);
  Fen fodd(n), feven(n);
  for(int x : ord) {
    if (x % 2 == 1) {
      ans += feven.get(x - odd[x] * 2 + 1, x + odd[x] * 2 - 1);
      fodd.inc(x, 1);
    } else {
      ans += fodd.get(x - odd[x] * 2 + 1, x + odd[x] * 2 - 1);
      feven.inc(x, 1);
    }
  }
}

bool cmpEven(int x, int y) {
  return even[x] > even[y];
}

void workEven() {
  vector<int> ord(n);
  iota(all(ord), 0);
  sort(all(ord), cmpEven);
  Fen fodd(n), feven(n);
  for(int x : ord) {
    if (x % 2 == 0) {
      ans += feven.get(x - even[x] * 2, x + even[x] * 2);
      feven.inc(x, 1);
    } else {
      ans += fodd.get(x - even[x] * 2, x + even[x] * 2);
      fodd.inc(x, 1);
    }
  }
}

void run() {
  cin >> n >> s;
  precalPw();
  precal();
  workEven();
  workOdd();
  cout << ans;
}

int main()
{
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
// gene();

  run();
}
