#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

void fast_io() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
	cout.tie(NULL);
	cerr.tie(NULL);
}

vector<int> z_function(string &s) {
	vector<int> z(s.size());
	int l = 0;
	int r = 0;

	for (int i = 1; i < s.size(); i++) {
		if (i <= r) {
			z[i] = min(z[i - l], r - i + 1LL);
		}

		while (i + z[i] < (int)s.size() && s[z[i]] == s[i + z[i]]) {
			z[i]++;
		}

		if (i + z[i] - 1 > r) {
			r = i + z[i] - 1;
			l = i;
		}
	}
	return z;
}

int B = 101;
int P = 1163428179LL;
int Bpow[500001];

void init() {
    Bpow[0] = 1;

    for (int i = 1; i <= 500000; i++) {
        Bpow[i] = Bpow[i - 1] * B;
        Bpow[i] %= P;
    }
}

vector<int> h(string &s) {
	vector<int> ans(s.size() + 1);
	ans[0] = 0;
	for (int i = 0; i < s.size(); i++) {
		ans[i + 1] = (ans[i] * B + (s[i] - 'a' + 1)) % P;
	}
	return ans;
}

int h_on_interval(vector<int> &arr, int l, int r) {
	return (arr[r] - (arr[l] * Bpow[r - l]) + P * P) % P;
}

vector<vector<int>> t1(2000000);

void build(vector<int> &arr, int v, int l, int r) {
	t1[v].clear();
	if (r - l == 1) {
		t1[v].push_back(l - arr[l]);
	} else {
		int m = (l + r) / 2;

		build(arr, v * 2 + 1, l, m);
		build(arr, v * 2 + 2, m, r);
		auto arr1 = t1[v * 2 + 1];
		auto arr2 = t1[v * 2 + 2];

		int x = 0;
		int y = 0;

		while (x != arr1.size() || y != arr2.size()) {
			if (x == arr1.size()) {
				t1[v].push_back(arr2[y]);
				y++;
				continue;
			}
			if (y == arr2.size()) {
				t1[v].push_back(arr1[x]);
				x++;
				continue;
			}

			if (arr1[x] < arr2[y]) {
				t1[v].push_back(arr1[x]);
				x++;
			} else {
				t1[v].push_back(arr2[y]);
				y++;
			}
		}
	}
}

int cnt(int v, int l, int r, int vl, int vr, int val) {
	if (l >= r) {
		return 0;
	}

	if (l == vl && r == vr) {
		auto it = lower_bound(t1[v].begin(), t1[v].end(), val);

		int sz = (it - t1[v].begin());
		return sz;
	}

	int vm = (vl + vr) / 2;

	int cnt1 = cnt(v * 2 + 1, l, min(r, vm), vl, vm, val);
	int cnt2 = cnt(v * 2 + 2, max(l, vm), r, vm, vr, val);

	return cnt1 + cnt2;
}

signed main() {
	fast_io();
	init();
	int n;
	cin >> n;
	string s;
	cin >> s;

	if (n == 1) {
        cout << 0;
        return 0;
	}
	vector<int> hash1 = h(s);
	string s1 = s;
	reverse(s1.begin(), s1.end());
	vector<int> hash2 = h(s1);

	vector<int> dp1(n);

	for (int i = 0; i < n; i++) {
		int l = 1;
		int r = min(i + 2, n - i + 1);

		while (r - l > 1) {
			int m = (l + r) / 2;
			int hash11 = h_on_interval(hash1, i, i + m);
			int hash12 = h_on_interval(hash2, n - 1 - i, n - 1 - i + m);

			//cout << i << " " << m << " " << hash11 << " " << hash12 << endl;
			if (hash11 == hash12) {
				l = m;
			} else {
				r = m;
			}
		}
		dp1[i] = l * 2 - 1;
		//cout << l << " ";
	}

	//cout << endl;

	vector<int> dp2(n - 1);

	for (int i = 0; i < n - 1; i++) {
        int l = 0;
        int r = min(i + 2, n - i);

        while (r - l > 1) {
        	int m = (l + r) / 2;
        	int hash11 = h_on_interval(hash1, i + 1, i + 1 + m);
        	int hash12 = h_on_interval(hash2, n - i - 1, n - 1 - i + m);
        	if (hash11 == hash12) {
				l = m;
			} else {
				r = m;
			}
        }
        dp2[i] = l * 2;
        //cout << l << " ";
    }

   // cout << endl;

	int ans = 0;

	for (int len = 2; len < n; len += 2) {
		for (int l = 0; l < n; l++) {
			int ind1 = l - 1 + len / 2;
			int ind2 = ind1 + len;

			if (ind2 >= n - 1) {
				continue;
			}
			if (dp2[ind1] >= len && dp2[ind2] >= len) {
				//ans++;
			}
		}
	}

	for (int i = 1; i < n - 1; i += 2) {
		dp2[i] -= 1000000000LL;
	}
	build(dp2, 0, 0, n - 1);

	//return 0;
	for (int i = 0; i < n - 1; i += 2) {
		int kek = dp2[i];
		//cout << i << "  " << i + 1 << " " << min(n - 1, i + 1 + kek) << " " << 1 + i << " " <<  cnt(0, i + 1, min(n, i + 1 + kek), 0, n, 1 + i) << endl;
		ans += cnt(0, i + 1, min(n - 1, i + 1 + kek), 0, n - 1, 1 + i);

	}

	for (int i = 1; i < n - 1; i += 2) {
		dp2[i] += 1000000000LL;
	}




	for (int i = 0; i < n - 1; i += 2) {
		dp2[i] -= 1000000000LL;
	}
	build(dp2, 0, 0, n - 1);

	//return 0;
	for (int i = 1; i < n - 1; i += 2) {
		int kek = dp2[i];
		//cout << i << "  " << i + 1 << " " << min(n - 1, i + 1 + kek) << " " << 1 + i << " " <<  cnt(0, i + 1, min(n, i + 1 + kek), 0, n, 1 + i) << endl;
		ans += cnt(0, i + 1, min(n - 1, i + 1 + kek), 0, n - 1, 1 + i);

	}

	//cout << ans << endl;













	for (int i = 1; i < n; i += 2) {
		dp1[i] -= 1000000000LL;
	}
	build(dp1, 0, 0, n);

	//return 0;
	for (int i = 1; i < n; i += 2) {
		int kek = dp1[i] + 1000000000LL;
		//cout << i << "  " << i + 1 << " " << min(n, i + 1 + kek) << " " << 1 + i << " " <<  cnt(0, i + 1, min(n, i + 1 + kek), 0, n, 1 + i) << endl;
		ans += cnt(0, i + 1, min(n, i + 1 + kek), 0, n, 1 + i);

	}

	for (int i = 1; i < n; i += 2) {
		dp1[i] += 1000000000LL;
	}




	for (int i = 0; i < n; i += 2) {
		dp1[i] -= 1000000000LL;
	}
	build(dp1, 0, 0, n);

	//return 0;
	for (int i = 0; i < n; i += 2) {
		int kek = dp1[i] + 1000000000LL;
		//cout << i << "  " << i + 1 << " " << min(n, i + 1 + kek) << " " << 1 + i << " " <<  cnt(0, i + 1, min(n, i + 1 + kek), 0, n, 1 + i) << endl;
		ans += cnt(0, i + 1, min(n, i + 1 + kek), 0, n, 1 + i);

	}
	cout << ans << endl;
    return 0;
}
