#include <bits/stdc++.h>

#define pii pair<long long, long long>

using namespace std;
const long long max_n = 5e5 + 1;
long long n;
string s;
long long len1[max_n], len2[max_n];

long long has[max_n], rev_hash[max_n], st[max_n];
long long p = 37, mod = 1e9 + 7;

bool check(long long l1, long long r1, long long l2, long long r2) {
    long long num1 = has[r1];
    if (l1 != 0) num1 = (num1 - has[l1 - 1] * st[r1 - l1 + 1] % mod + mod) % mod;

    long long num2 = rev_hash[l2];
    if (r2 != n - 1) num2 = (num2 - rev_hash[r2 + 1] * st[r2 - l2 + 1] % mod + mod) % mod;

    return num1 == num2;
}

void scan() {
    st[0] = 1;
    for(long long i  = 1;i < max_n;i++) st[i] = (st[i - 1] * p) % mod;

    cin >> n >> s;

    for(long long i = 0;i < n;i++) {
        has[i] = s[i] - 'a';
        if (i != 0) has[i] = (has[i] + has[i - 1] * p) % mod;
    }

    for(long long i = n - 1;i >= 0;i--) {
        rev_hash[i] = s[i] - 'a';
        if (i != n - 1) rev_hash[i] = (rev_hash[i] + rev_hash[i + 1] * p) % mod;
    }

    //cout << check(0, 0, 2, 2) << '\n';
    //for(long long i = 0;i < n;i++) cout << has[i] << " ";
    //cout << '\n';
    //for(long long i = 0;i < n;i++) cout << rev_hash[i] << " ";
    //cout << '\n';

    for(long long i = 0;i < n;i++) {
        long long l = 0;
        long long r = n + 1;
        while(r - l > 1) {
            long long mid = ((l + r) >> 1);
            if (i - mid < 0 || i + mid - 1 >= n || !check(i - mid, i - 1, i, i + mid - 1)) {
                r = mid;
            }else l = mid;
        }
        len1[i] = l;

        l = 0;
        r = n + 1;
        while(r - l > 1) {
            long long mid = ((l + r) >> 1);
            if (i - mid < 0 || i + mid >= n || !check(i - mid, i - 1, i + 1, i + mid)) {
                r = mid;
            }else l = mid;
        }

        len2[i] = l;
    }
}

/*struct segment_tree {
    vector<long long> sum;
    long long last;
    segment_tree() {}
    segment_tree(long long n) {
        sum.resize(4 * n, 0);
        last = n - 1;
        for(long long i = 0;i < n;i++) set(i, 1);
    }

    void set(long long v, long long l, long long r, long long id, long long x) {
        if (r < id || l > id) return;
        if (l == id && r == id) {
            sum[v] = x;
            return;
        }
        long long m = ((l + r) >> 1);
        set(v * 2 + 1, l, m, id, x);
        set(v * 2 + 2, m + 1, r, id, x);
        sum[v] = sum[v * 2 + 1] + sum[v * 2 + 2];
    }

    void set(long long id, long long x) {
        set(0, 0, last, id, x);
    }

    long long get(long long v, long long l, long long r, long long left, long long right) {
        if (l > right || r < left) return 0;
        if (l >= left && r <= right) return sum[v];
        long long m = ((l + r) >> 1);
        return get(v * 2 + 1, l, m, left, right) + get(v * 2 + 2, m + 1, r, left, right);
    }

    long long get(long long l, long long r) {
        return get(0, 0, last, max(l, 0LL), min(r, last));
    }
};*/

struct segment_tree {
    vector<long long> sum;

    segment_tree() {}

    segment_tree(long long n) {
        sum.resize(n, 0);
        for(long long i = 0;i < n;i++) set(i, 1);
    }

    long long f(long long x) {
        return (x & (x + 1));
    }

    long long h(long long x) {
        return (x | (x + 1));
    }

    void set(long long v, long long x) {
        if (x == 0) x = -1;
        while(v < sum.size()) {
            sum[v] += x;
            v = h(v);
        }
    }

    long long get(long long r) {
        r = min(r, (long long)sum.size() - 1);
        long long res = 0;
        while(r >= 0) {
            res += sum[r];
            r = f(r) - 1;
        }
        return res;
    }

    long long get(long long l, long long r) {
        return get(r) - get(l - 1);
    }
};


void solve() {
    scan();

    long long ans = 0;
    segment_tree te[2];
    te[1] = segment_tree(n / 2);
    te[0] = segment_tree((n + 1) / 2);

    vector<pii> o;
    for(long long i = 0;i < n;i++) o.emplace_back(len1[i], i);
    sort(o.begin(), o.end());

    for(long long q = 0;q < n;q++) {
        long long i = o[q].second;
        long long dist = o[q].first;
        /*for(long long j = i + 1;j < n;j++) {
            if ((j - i) % 2 == 0 && (j - i) / 2 <= min(len1[i], len1[j])) ans++;
            if ((j - i) % 2 == 1 && (j - i) / 2 <= min(len2[i], len2[j])) ans++;
        }*/
        te[i % 2].set(i / 2, 0);
        ans += te[i % 2].get(i / 2 - dist, i / 2 + dist);
    }



    te[1] = segment_tree(n / 2);
    te[0] = segment_tree((n + 1) / 2);
    o.clear();
    for(long long i = 0;i < n;i++) o.emplace_back(len2[i], i);
    sort(o.begin(), o.end());

    for(long long q = 0;q < n;q++) {
        long long i = o[q].second;
        long long dist = o[q].first;

        te[i % 2].set(i / 2, 0);

        if (i % 2 == 1) ans += te[0].get(i / 2 - dist, i / 2 + dist + 1);
        else ans += te[1].get(i / 2 - dist - 1, i / 2 + dist);
        //ans += te[1 - (i % 2)].get(i / 2 - dist + 1, i / 2 + dist);
    }


    cout << ans;
}




signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    solve();
}