#include <bits/stdc++.h>
#define int long long
#define pii pair<int, int>

using namespace std;
const int max_n = 5e5 + 1;
int n;
string s;
int len1[max_n], len2[max_n];

int has[max_n], rev_hash[max_n], st[max_n];
int p = 29, mod = 1e9 + 11;

bool check(int l1, int r1, int l2, int r2) {
    int num1 = has[r1];
    if (l1 != 0) num1 = (num1 - has[l1 - 1] * st[r1 - l1 + 1] % mod + mod) % mod;

    int num2 = rev_hash[l2];
    if (r2 != n - 1) num2 = (num2 - rev_hash[r2 + 1] * st[r2 - l2 + 1] % mod + mod) % mod;

    return num1 == num2;
}

void scan() {
    st[0] = 1;
    for(int i  = 1;i < max_n;i++) st[i] = (st[i - 1] * p) % mod;

    cin >> n >> s;

    for(int i = 0;i < n;i++) {
        has[i] = s[i] - 'a';
        if (i != 0) has[i] = (has[i] + has[i - 1] * p) % mod;
    }

    for(int i = n - 1;i >= 0;i--) {
        rev_hash[i] = s[i] - 'a';
        if (i != n - 1) rev_hash[i] = (rev_hash[i] + rev_hash[i + 1] * p) % mod;
    }

    //cout << check(0, 0, 2, 2) << '\n';
    //for(int i = 0;i < n;i++) cout << has[i] << " ";
    //cout << '\n';
    //for(int i = 0;i < n;i++) cout << rev_hash[i] << " ";
    //cout << '\n';

    for(int i = 0;i < n;i++) {
        int l = 0;
        int r = n + 1;
        while(r - l > 1) {
            int mid = ((l + r) >> 1);
            if (i - mid < 0 || i + mid - 1 >= n || !check(i - mid, i - 1, i, i + mid - 1)) {
                r = mid;
            }else l = mid;
        }
        len1[i] = l;

        l = 0;
        r = n + 1;
        while(r - l > 1) {
            int mid = ((l + r) >> 1);
            if (i - mid < 0 || i + mid >= n || !check(i - mid, i - 1, i + 1, i + mid)) {
                r = mid;
            }else l = mid;
        }

        len2[i] = l;
    }
}

/*struct segment_tree {
    vector<int> sum;
    int last;
    segment_tree() {}
    segment_tree(int n) {
        sum.resize(4 * n, 0);
        last = n - 1;
        for(int i = 0;i < n;i++) set(i, 1);
    }

    void set(int v, int l, int r, int id, int x) {
        if (r < id || l > id) return;
        if (l == id && r == id) {
            sum[v] = x;
            return;
        }
        int m = ((l + r) >> 1);
        set(v * 2 + 1, l, m, id, x);
        set(v * 2 + 2, m + 1, r, id, x);
        sum[v] = sum[v * 2 + 1] + sum[v * 2 + 2];
    }

    void set(int id, int x) {
        set(0, 0, last, id, x);
    }

    int get(int v, int l, int r, int left, int right) {
        if (l > right || r < left) return 0;
        if (l >= left && r <= right) return sum[v];
        int m = ((l + r) >> 1);
        return get(v * 2 + 1, l, m, left, right) + get(v * 2 + 2, m + 1, r, left, right);
    }

    int get(int l, int r) {
        return get(0, 0, last, max(l, 0LL), min(r, last));
    }
};*/

struct segment_tree {
    vector<int> sum;

    segment_tree() {}

    segment_tree(int n) {
        sum.resize(n, 0);
        for(int i = 0;i < n;i++) set(i, 1);
    }

    int f(int x) {
        return (x & (x + 1));
    }

    int h(int x) {
        return (x | (x + 1));
    }

    void set(int v, int x) {
        if (x == 0) x = -1;
        while(v < sum.size()) {
            sum[v] += x;
            v = h(v);
        }
    }

    int get(int r) {
        r = min(r, (int)sum.size() - 1);
        int res = 0;
        while(r >= 0) {
            res += sum[r];
            r = f(r) - 1;
        }
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};


void solve() {
    scan();

    int ans = 0;
    segment_tree te[2];
    te[1] = segment_tree(n / 2);
    te[0] = segment_tree((n + 1) / 2);

    vector<pii> o;
    for(int i = 0;i < n;i++) o.emplace_back(len1[i], i);
    sort(o.begin(), o.end());

    for(int q = 0;q < n;q++) {
        int i = o[q].second;
        int dist = o[q].first;
        /*for(int j = i + 1;j < n;j++) {
            if ((j - i) % 2 == 0 && (j - i) / 2 <= min(len1[i], len1[j])) ans++;
            if ((j - i) % 2 == 1 && (j - i) / 2 <= min(len2[i], len2[j])) ans++;
        }*/
        te[i % 2].set(i / 2, 0);
        ans += te[i % 2].get(i / 2 - dist, i / 2 + dist);
    }



    te[1] = segment_tree(n / 2);
    te[0] = segment_tree((n + 1) / 2);
    o.clear();
    for(int i = 0;i < n;i++) o.emplace_back(len2[i], i);
    sort(o.begin(), o.end());

    for(int q = 0;q < n;q++) {
        int i = o[q].second;
        int dist = o[q].first;

        te[i % 2].set(i / 2, 0);

        if (i % 2 == 1) ans += te[0].get(i / 2 - dist, i / 2 + dist + 1);
        else ans += te[1].get(i / 2 - dist - 1, i / 2 + dist);
        //ans += te[1 - (i % 2)].get(i / 2 - dist + 1, i / 2 + dist);
    }


    cout << ans;
}




signed main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    solve();
}