

#include <iostream>
#include <random>
#include <algorithm>

using namespace std;

template <typename T>
T *arr(int n) {
    return (T*) malloc(n * sizeof(T));
}

template <typename T>
T *arr(int n, T val) {
    auto res = arr<T>(n);
    fill(res, res + n, val);
    return res;
}

void run();

signed main() {
    ios::sync_with_stdio(false);
    cout.tie(0);
    run();
}

struct Hash {
    const int MOD = 1e9 + 21;
    const int BASE = 29;
    const int MOD1 = 1e9 + 7;
    int *h, *pw;
    int *h1, *pw1;
    explicit Hash(string &s) {
        int n = s.size();
        h = arr<int>(n + 1);
        h1 = arr<int>(n + 1);
        h[0] = 0;
        h1[0] = 0;
        for (int i = 1; i <= n; i++) {
            h[i] = ((long long) h[i - 1] * BASE + s[i - 1] - 'a') % MOD;
            h1[i] = ((long long) h1[i - 1] * BASE + s[i - 1] - 'a') % MOD1;
        }
        pw = arr<int>(n + 1);
        pw1 = arr<int>(n + 1);
        pw[0] = 1;
        pw1[0] = 1;
        for (int i = 1; i <= n; i++) {
            pw[i] = (long long) pw[i - 1] * BASE % MOD;
            pw1[i] = (long long) pw1[i - 1] * BASE % MOD1;
        }
    }
    pair<int, int> get(int l, int r) {
        int sub = (long long) h[l] * pw[r - l] % MOD;
        int res = (h[r] - sub + MOD) % MOD;
        int sub1 = (long long) h1[l] * pw1[r - l] % MOD1;
        int res1 = (h1[r] - sub1 + MOD1) % MOD1;
        return {res, res1};
    }
};

bool is_pal(Hash &h, Hash &rh, int n, int l, int r) {
    if ((r - l) % 2 == 0) {
        int k = (l + r) / 2;
        int rk = n - k - 1;
        int rr = n - (r - 1) - 1;
        return h.get(l, k) == rh.get(rr, rk + 1);
    } else {
        int k = (l + r) / 2;
        int rk = n - (k + 1) - 1;
        int rr = n - (r - 1) - 1;
        return h.get(l, k) == rh.get(rr, rk + 1);
    }
}

void run() {
    int n;
    cin >> n;
    string s;
    cin >> s;
    string rs = s;
    reverse(rs.begin(), rs.end());
    Hash h(s), rh(rs);
    long long ans = 0;
    for (int i = 1; i < n; i++) {
        for (int k = 1; i - k >= 0 && i + k <= n; k++) {
            int cur = is_pal(h, rh, n, i - k, i) && is_pal(h, rh, n, i, i + k);
            ans += cur;
            //cerr << i << ' ' << k << ' ' << cur << endl;
        }
    }
    cout << ans << endl;
}