#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

const unsigned long long t[5] = {100000007, 1000000007, 10000009, 1000009, 1000000007};
const unsigned long long m[5]{ 239, 39, 517, 1009, 259 };
unsigned long long h1[5][5003], h2[5][5003];
unsigned long long p[5][5003];
int n;

unsigned long long get1(int l, int r, int q) {
	return (t[q] + h1[q][r] - (h1[q][l - 1] * p[q][r - l + 1]) % t[q]) % t[q];
}

unsigned long long get2(int l, int r, int q) {
	l = n - l + 1;
	r = n - r + 1;
	swap(l, r);
	return (t[q] + h2[q][r] - (h2[q][l - 1] * p[q][r - l + 1]) % t[q]) % t[q];
}

int main() {
	cin >> n;
	string s;
	cin >> s;
	for (int q = 0; q < 5; ++q) {
		h1[q][0] = 0;
		p[q][0] = 1;
		h2[q][0] = 0;
	}
	for (int i = 0; i < n; ++i) {
		for (int q = 0; q < 5; ++q) {
			h1[q][i + 1] = (h1[q][i] * m[q] + s[i]) % t[q];
			p[q][i + 1] = p[q][i] * m[q] % t[q];
		}
	}
	for (int i = 0; i < n; ++i) {
		for (int q = 0; q < 5; ++q) {
			h2[q][i + 1] = (h2[q][i] * m[q] + s[n - i - 1]) % t[q];
		}
	}

	long long sum = 0;
	for (int i = 1; i < n; ++i) {
		int l, r;
		l = i;
		r = i + 1;
		while (l > 0 && r <= n) {
			bool ok = true;
			for (int q = 0; q < 5; ++q) {
				if (!(get1(l, i, q) == get2(l, i, q) && get1(i + 1, r, q) == get2(i + 1, r, q)))
					ok = false;
			}
			if (ok) {
				++sum;
			}
			--l;
			++r;
		}
	}
	cout << sum;
	return 0;
}
