#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
const ll p = 47;
const ll mod = 1e9 + 7;
vector<ll> powers;

int n;
string s;
vector<pair<int, int>> pals = {};

vector<ll> prefs;
vector<ll> prefrs;

void init_powers() {
	powers = vector<ll>(n * 2, 1);
	for ( int i = 0; i < n * 2 - 1; ++i ) powers[i+1] = ( powers[i] * p ) % mod;
}

vector<ll> get_hash(string x) {
	vector<ll> ans = {0};
	for ( char c : x ) {
		ans.push_back(( (ans.back() * p) % mod + (c - 'a' + 1) ) % mod);
	}
	return ans;
}

ll hsh(const vector<ll> & pref, const int & i, const int & j) {
	return ( mod + pref[j + 1] - (pref[i] * powers[j - i + 1]) % mod ) % mod;
}


bool check_pal(int i, int j) {
	if ( (i < 0) || (j >= n) ) return false;
	return hsh(prefs, i, j) == hsh(prefrs, n - 1 - j, n - 1 - i);
	// for ( int k = i; k <= j; ++k ) if ( s[k] != s[i + j - k] ) return false;
	// return true;
}

int xi;

bool cmp1(const int & j, const int & zuzz) {
	if ( !check_pal(xi - j + 1, xi + j - 1) ) return false;
	return true;
}

bool cmp2(const int & j, const int & zuz) {
	if ( !check_pal(xi - j + 1, xi + j) ) return false;
	return true;
}

void find_pals() {
	vector<int> nat(n * 2, 1);
	for ( int i = 0; i < n * 2; ++i ) nat[i] = i + 1;
	int ans;
	
	for ( int i = 0; i < n; ++i ) {
		xi = i;
		ans = lower_bound(nat.begin(), nat.begin() + min(i+1, n - i), 1, cmp1) - nat.begin();
		ans += 1;
		pals.push_back({i - ans + 2, i + ans - 2});
	}

	for ( int i = 0; i < n; ++i ) {
		xi = i;
		ans = lower_bound(nat.begin(), nat.begin() + min(i+1, n - i - 1), 1, cmp2) - nat.begin();
		ans += 1;
		if ( ans == 1 ) continue;
		pals.push_back({i - ans + 2, i + ans - 1});
	}
}



int main() {
	cin >> n;
	cin >> s;

	init_powers();
	prefs = get_hash(s);
	reverse(s.begin(), s.end());
	prefrs = get_hash(s);
	reverse(s.begin(), s.end());

	// cout << hsh(prefs, 0, 0) << endl;
	// cout << hsh(prefrs, n - 1, n - 1) << endl;

	find_pals();
	int ans = 0;

	// for ( int i = 0; i < pals.size(); ++i ) {
	// 	cout << pals[i].first << " " << pals[i].second << endl;
	// }

	for ( int i = 0; i < pals.size(); ++i ) {
		for ( int j = 0; j < pals.size(); ++j ) {
			if ( i == j ) continue;
			if ( (pals[i].first + pals[i].second) > (pals[j].first + pals[j].second) ) continue;
			int x = pals[i].first + pals[i].second + pals[j].first + pals[j].second - 2;
			if ( x % 4 != 0 ) continue;
			x = x >> 2;
			if ( !((pals[i].first <= x) && (pals[i].second >= x)) ) continue;
			if ( !((pals[j].first <= x+1) && (pals[j].second >= x+1)) ) continue;
			ans += 1;
		}
	}

	cout << ans << endl;
	return 0;
}