#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

struct hashs{
    int p;
    int MOD;
    vector<int> pw;
    vector<int> h;

    void init(string &s, int _p, int _MOD){
        p = _p;
        MOD = _MOD;
        int n = s.size();
        h.resize(n + 1);
        pw.resize(n + 1);
        pw[0] = 1;
        for (int i = 0; i < n; i++){
            pw[i + 1] = (pw[i] * p) % MOD;
            h[i + 1] = (h[i] * p + s[i]) % MOD;
        }
    }

    int mod(int a){
        a = a % MOD;
        if (a < 0){
            a += MOD;
        }
        return a;
    }

    int gethash(int l, int r){
        int ost = h[l] * pw[r - l] % MOD;
        return mod(h[r] - ost);
    }

};

bool is_equal(int l1, int r1, hashs &h1, int l2, int r2, hashs &h2){
    int res1 = h1.gethash(l1, r1);
    int res2 = h2.gethash(l2, r2);
    return res1 == res2;
}

int main2(int n, string & s){
    hashs h;
    h.init(s, 57, 2286661337);
    reverse(s.begin(), s.end());
    hashs hr;
    hr.init(s, 57, 2286661337);
    reverse(s.begin(), s.end());
    vector<int> ch(n - 1);
    vector<int> nc(n);
    int mx = 0;
    for (int i = 0; i < n; i++){
        int l = 0;
        int r = min(i, n - i - 1);
        if (is_equal(i - r, i + 1, h, n - i - r - 1, n - i, hr)){
            nc[i] = r;
        }else{
            int cnt = 0;
            while (r - l > 1){
                cnt++;
                int m = (r + l) / 2;
                int l1 = i - m;
                int r1 = i + 1;
                int l2 = n - i - m - 1;
                int r2 = n - i;
                if (is_equal(l1, r1, h, l2, r2, hr)){
                    l = m;
                }else{
                    r = m;
                }
            }
            mx = max(mx, cnt);
            nc[i] = l;
        }
    }
    for (int i = 0; i < n - 1; i++){
        int l = 0;
        int r = min(i + 1, n - i - 1);
        if (is_equal(i - r + 1, i + 1, h, n - i - r - 1, n - i - 1, hr)){
            ch[i] = r;
        }else{
            while (r - l > 1){
                int m = (r + l) / 2;
                if (is_equal(i - m + 1, i + 1, h, n - i - m - 1, n - i - 1, hr)){
                    l = m;
                }else{
                    r = m;
                }
            }
            ch[i] = l;
        }
    }
    /*for (auto i : nc){
        cout << i << ' ';
    }
    cout << endl;
    for (auto i : ch){
        cout << i << ' ';
    }
    cout << endl;*/
    int ans = 0;
    for (int i = 0; i < n; i++){
        for (int j = 0; j <= nc[i] && i + 2 * j + 1 < n; j++){
            ans += nc[i + 2 * j + 1] >= j;
        }
    }
    for (int i = 0; i < n - 1; i++){
        for (int j = 1; j <= ch[i] && i + 2 * j < n - 1; j++){
            ans += ch[i + 2 * j] >= j;
        }
    }
    return ans;
}

signed main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    string s;
    cin >> s;
    //int res1 = main1(n, s);
    int res2 = main2(n, s);
    cout << res2 << endl;
    return 0;
}
