#include <bits/stdc++.h>

#define ll long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define ld long double
#define mp make_pair
#define pb push_back

using namespace std;

const int maxn = 5e5 + 1000;
const ll alpha = 29;

void init() {
#ifdef ONPC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifdef TEST
    freopen("!inp", "r", stdin);
    freopen("!out", "w", stdout);
#endif

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

vector<ll> mod = {(ll) 1e9 + 7, (ll) 1e9 + 9};
ll deg[2][maxn];

struct String {
    vector<int> H[2];

    String(string &s) {
        for (int i = 0; i < 2; i++) {
            int n = s.size();
            H[i].resize(n + 1);
            for (int j = 0; j < n; j++) {
                H[i][j + 1] = (H[i][j] * alpha + s[j] - 'a' + 1) % mod[i];
            }
        }
    }

    pair<ll, ll> geth(int l, int r) {
        vector<ll> ans(2);
        for (int i = 0; i < 2; i++) {
            ans[i] = (H[i][r] - (H[i][l] * deg[i][r - l]) % mod[i] + mod[i]) % mod[i];
        }
        return {ans[0], ans[1]};
    }
};

ll myrand() {
    ll ran = rand();
    return (ran << 16) ^ rand();
}

void precalc() {
    for (int i = 0; i < 2; i++) {
        deg[i][0] = 1;
        for (int j = 1; j < maxn; j++) {
            deg[i][j] = (deg[i][j - 1] * alpha) % mod[i];
        }
    }
}

int n;

bool ispal(int l, int r, String &S, String &T) { // [..)
    auto hash = S.geth(l, r);
    auto revhash = T.geth(n - r, n - l);
    return hash == revhash;
}

int finder(vector<int> &foo, int l, int r, int k) {
    int ans = 0;
    for (int i = l; i < r; i++) {
        if (foo[i] >= k)
            ans++;
    }
    return ans;
}

int main() {
    init();
    precalc();

    cin >> n;
    string s;
    cin >> s;
    String S(s);
    reverse(all(s));
    String T(s);
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        int l = 1;
        int r = min(i + 1, n - i);
        while (l < r) {
            int m = (l + r + 1) / 2;
            if (ispal(i - m + 1, i + m, S, T))
                l = m;
            else
                r = m - 1;
        }
        a[i] = l;
    }
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        int l = 0;
        int r = min(i + 1, n - i - 1);
        while (l < r) {
            int m = (l + r + 1) / 2;
            if (ispal(i - m + 1, i + m + 1, S, T))
                l = m;
            else
                r = m - 1;
        }
        b[i] = l;
    }
    int ans = 0;

    vector<int> necha;
    vector<int> cha;
    for (int i = 0; i < n; i += 2) {
        cha.pb(a[i] - i / 2);
        if (i + 1 < n)
            necha.pb(a[i + 1] - i / 2);
    }
    vector<int> chb;
    vector<int> nechb;
    for (int i = 0; i < n; i += 2) {
        chb.pb(b[i] - i / 2);
        if (i + 1 < n)
            nechb.pb(b[i + 1] - i / 2);
    }

//    for (auto ev: cha)
//        cout << ev << " ";
//    cout << endl;
//    for (auto ev: necha)
//        cout << ev << " ";
//    cout << endl;

    for (int i = 0; 2 * i < n; i++) {
        int l = i;
        int r = min((int) necha.size(), i + a[2 * i]);
        ans += finder(necha, l, r, 1 - i);
    }

    for (int i = 0; 2 * i + 1 < n; i++) {
        int l = i + 1;
        int r = min((int) cha.size(), i + 1 + a[2 * i + 1]);
        ans += finder(cha, l, r, -i);
    }

//   cout << ans << endl;
//    for (int i = 0; i< n; i++)
//        cout << a[i] << " ";
//    cout << endl;
//    for (int i = 0 ;i < n; i++)
//        cout << b[i] << " ";
//    cout << endl;

    for (int i = 0; i < n; i++) {
        for (int j = i + 2, x = 0; x < b[i] && j < n; x++, j += 2) {
            if (b[j] > x)
                ans++;
        }
    }
    cout << ans << endl;
    return 0;
}