#include <bits/stdc++.h>

using namespace std;

vector<long long> UP, DOWN, pows;

const long long MOD = 1e9 + 21;

const long long P = 37;

int get_up(int l, int r) {
    return (UP[r] + (MOD - UP[l]) * pows[r - l]) % MOD;
}

int get_down(int l, int r) {
    return (DOWN[l] + (MOD - DOWN[r]) * pows[r - l]) % MOD;
}

bool pol(int l, int r) {
    return get_up(l, r) == get_down(l, r);
}

void solve() {
    int n;
    string s;
    cin >> n >> s;
    UP.resize(n + 1);
    DOWN.resize(n + 1);
    pows.resize(n + 1);
    pows[0] = 1;
    for (int i = 1; i <= n; ++i)
        pows[i] = (pows[i - 1] * P) % MOD;
    for (int i = 0; i < n; ++i) {
        UP[i + 1] = (UP[i] * P + (long long)(s[i] - 'a' + 1)) % MOD;
    }
    for (int i = n - 1; i >= 0; --i) {
        DOWN[i] = (DOWN[i + 1] * P + (long long)(s[i] - 'a' + 1)) % MOD;
    }
    int ans = 0;
    for (int l = 0; l < n; ++l) {
        for (int r = l + 1; r <= n; ++r) {
            if ((r - l) % 2)
                continue;
            int mid = (l + r) / 2;
            if (pol(l, mid) && pol(mid, r))
                ++ans;
        }
    }
    cout << ans << endl;
}

int main() {
    #ifdef DEBUG
        freopen("test1.cpp", "r", stdin);
    #else
        //cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}

