#define _CRT_SECURE_NO_WARNINGS
#define _USE_MATH_DEFINES
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <random>
#include <fstream>
#include <deque>
#include <numeric>
#include <iomanip>
#include <algorithm>
#include <cassert>
#include <bitset>
#include <cmath>
#include <deque>
using namespace std;
#define kekek ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

const int maxn = 5e5 + 4;
const int base = 197, mod = 1e15 + 7;
int n;
string s;
vector<int> h, revh;
int pw[maxn];

void precalc() {
	pw[0] = 1;
	for (int i = 1; i < maxn; i++) {
		pw[i] = (pw[i - 1] * base);
	}

	h.resize(n + 1);
	revh.resize(n + 1);
	for (int i = 1; i <= n; i++) {
		h[i] = (h[i - 1] * base + s[i - 1]);
		revh[i] = revh[i - 1] * base + s[n - i];
	}
}

int gethash(int L, int R, vector<int>& h) {
	return h[R] - h[L - 1] * pw[R - L + 1];
}

int rev(int x) {
	return (n - x + 1);
}

vector<int> cent, x;

void calc() {
	cent.resize(n);
	for (int i = 1; i <= n; i++) {
		int L = 0, R = min(i - 1, n - i) + 1;
		while (R - L > 1) {
			int M = (L + R) / 2;
			if (gethash(i - M, i - 1, h) == gethash(rev(i + M), rev(i + 1), revh)) {
				L = M;
			}
			else {
				R = M;
			}
		}
		cent[i - 1] = 1 + 2 * L;
	}

	x.resize(n);
	for (int i = 1; i <= n - 1; i++) {
		int L = 0, R = min(i, n - i) + 1;
		while (R - L > 1) {
			int M = (L + R) / 2;
			if (gethash(i - M + 1, i, h) == gethash(rev(i + M), rev(i + 1), revh)) {
				L = M;
			}
			else {
				R = M;
			}
		}
		x[i] = 2 * L;
	}
}

void info() {
	cout << "cent: ";
	for (auto i : cent) {
		cout << i << " ";
	}
	cout << "\nx: ";
	for (int i = 1; i < n; i++) {
		cout << x[i] << " ";
	}
	cout << '\n';
}

int stupid() {
	int ans = 0;
	vector<int> f;
	for (int i = 0; i < n; i++) {
		if (i % 2 == 0) {
			for (auto& j : f) {
				j -= 2;
			}
			f.push_back(cent[i] - 1);
		}
		else {
			for (int j = 0; j <= cent[i] / 2 && j + 1 <= f.size(); j++) {
				if (f[f.size() - 1 - j] >= 0) {
					ans++;
				}
			}
		}
	}
	cout << "ans1: " << ans << '\n';

	f.clear();
	for (int i = 0; i < n; i++) {
		if (i % 2 == 1) {
			for (auto& j : f) {
				j -= 2;
			}
			f.push_back(cent[i] - 1);
		}
		else {
			for (int j = 0; j <= cent[i] / 2 && j + 1 <= f.size(); j++) {
				if (f[f.size() - 1 - j] >= 0) {
					ans++;
				}
			}
		}
	}
	cout << "ans2: " << ans << '\n';
	f.clear();
	vector<int> s;
	for (int i = 1; i < n; i++) {
		if (i % 2 == 1) {
			for (auto& j : f) {
				j -= 2;
			}
			for (int j = 0; j < x[i] / 2 && j + 1 <= f.size(); j++) {
				if (f[f.size() - 1 - j] >= 0) {
					ans++;
				}
			}
			f.push_back(x[i]);
		}
		else {
			for (auto& j : s) {
				j -= 2;
			}
			for (int j = 0; j < x[i] / 2 && j + 1 <= s.size(); j++) {
				if (s[s.size() - 1 - j] >= 0) {
					ans++;
				}
			}
			s.push_back(x[i]);
		}
	}
	cout << "ans3: " << ans << '\n';

	return ans;
}

struct node {
	int x, prior, sz;
	node* L, * R;

	node(int x) : x(x) {
		sz = 1;
		prior = (rand() << 16) + rand();
		L = R = nullptr;
	}
};

int getsz(node* v) {
	return (v ? v->sz : 0);
}

void upd(node* v) {
	v->sz = getsz(v->L) + getsz(v->R) + 1;
}

node* merge(node* L, node* R) {
	if (L == nullptr) return R;
	if (R == nullptr) return L;

	if (L->prior > R->prior) {
		L->R = merge(L->R, R);
		upd(L);
		return L;
	}
	else {
		R->L = merge(L, R->L);
		upd(R);
		return R;
	}
}

pair<node*, node*> split1(node* v, int sz) {
	if (v == nullptr) return { nullptr, nullptr };
	int lsz = getsz(v->L);

	if (sz <= lsz) {
		auto kek = split1(v->L, sz);
		v->L = kek.second;
		upd(v);
		return { kek.first, v };
	}
	else {
		auto kek = split1(v->R, sz - lsz - 1);
		v->R = kek.first;
		upd(v);
		return { v, kek.second };
	}
}

pair<node*, node*> split2(node* v, int k) {
	if (v == nullptr) return { nullptr, nullptr };

	if (v->x <= k) {
		auto rrr = split2(v->R, k);
		v->R = rrr.first;
		upd(v);
		return { v, rrr.second };
	}
	else {
		auto rrr = split2(v->L, k);
		v->L = rrr.second;
		upd(v);
		return { rrr.first, v };
	}
}

node* trinsert(node* v, int x) {
	auto kk = split2(v, x);
	v = merge(kk.first, merge(new node(x), kk.second));
	return v;
}

int upper_bound(node* v, int x) {
	auto kk = split2(v, x - 1);
	int ans = getsz(kk.second);
	v = merge(kk.first, kk.second);
	return ans;
}

struct MST {
	int n, w, last;
	vector<node*> tr;

	MST(int n) : n(n) {
		w = 0;
		last = 0;
		tr.resize(4 * n + 5, nullptr);
	}

	void insert(int v, int l, int r, int val) {
		if (l == r) {
			tr[v] = new node(val);
			return;
		}

		int m = (l + r) / 2;
		if (m >= last) {
			insert(2 * v, l, m, val);
		}
		else {
			insert(2 * v + 1, m + 1, r, val);
		}
		tr[v] = trinsert(tr[v], val);
	}

	void push_back(int x) {
		x += w;
		insert(1, 0, n - 1, x);
		last++;
	}

	int get(int v, int L, int R, int ql, int qr) {
		if (L > qr || ql > R) return 0;
		if (ql <= L && qr >= R) {
			return upper_bound(tr[v], w);
		}

		int M = (L + R) / 2;
		return get(2 * v, L, M, ql, qr) + get(2 * v + 1, M + 1, R, ql, qr);
	}

	int get(int ql, int qr) {
		if (ql > qr || ql < 0) return 0;
		return get(1, 0, n - 1, ql, qr);
	}
};

int solve() {
	int ans = 0;
	MST kek1(n);
	for (int i = 0; i < n; i++) {
		if (i % 2 == 0) {
			kek1.w += 2;
			kek1.push_back(cent[i] - 1);
		}
		else {
			ans += kek1.get(max(0ll, kek1.last - cent[i] / 2 - 1), kek1.last - 1);
		}
	}
	//cout << "ans1: " << ans << '\n';

	MST kek2(n);
	for (int i = 0; i < n; i++) {
		if (i % 2 == 1) {
			kek2.w += 2;
			kek2.push_back(cent[i] - 1);
		}
		else {
			ans += kek2.get(max(0ll, kek2.last - cent[i] / 2 - 1), kek2.last - 1);
		}
	}
	//cout << "ans2: " << ans << '\n';

	MST kek3(n), kek4(n);
	for (int i = 1; i < n; i++) {
		if (i % 2 == 1) {
			kek3.w += 2;
			ans += kek3.get(max(0ll, kek3.last - x[i] / 2), kek3.last - 1);
			kek3.push_back(x[i]);
		}
		else {
			kek4.w += 2;
			ans += kek4.get(max(0ll, kek4.last - x[i] / 2), kek4.last - 1);
			kek4.push_back(x[i]);
		}
	}
	//cout << "ans3: " << ans << '\n';

	return ans;
}

signed main() {
	kekek;
	if (0) {
		n = 100;
		s.resize(n);
		int zxc = 0;
		while (1) {
			cout << "try number " << zxc++ << '\n';
			for (auto& i : s) {
				i = rand() % 20 + 'a';
			}
			precalc();
			calc();
			if (solve() != stupid()) {
				cout << s << '\n';
				cout << solve() << " " << stupid();
				system("pause");
			}
		}
	}
	else {
		cin >> n >> s;
		precalc();
		calc();
		//info();
		cout << solve();
	}

	return 0;
}