#include<iostream>
#include<string>
#include<vector>
using namespace std;

const long long Q = 1e9 + 293;
const long long p = 257;
int n;

vector<long long> hash1, hash1_r;
vector<long long> P(1e6);

long long get_hash(int i) {
	if (i == -1) return 0;
	else return hash1[i];
}
long long get_hash(int l, int r) {
	return (Q * Q + get_hash(r) - get_hash(l - 1) * P[r - l + 1]) % Q;
}
long long get_hash_r(int i) {
	if (i == n) return 0;
	else return hash1_r[i];
}
long long get_hash_r(int l, int r) {
	return (Q * Q + get_hash_r(l) - get_hash_r(r + 1) * P[r - l + 1]) % Q;
}

bool check1(int i, int m) {
	if ((i - m + 1 < 0) || (i + m > n)) {
		return false;
	}
	if (get_hash(i - m + 1, i) == get_hash_r(i, i + m - 1)) return true;
	return false;
}
bool check2(int i, int m) {
	if ((i - m + 1 < 0) || (i + m > n - 1)) {
		return false;
	}
	if (get_hash(i - m + 1, i) == get_hash_r(i + 1, i + m)) return true;
	return false;
}
int main() {
	
	cin >> n;
	string str;
	cin >> str;
	hash1.resize(str.size());
	hash1_r.resize(str.size());
	hash1[0] = str[0];
	P[0] = 1;
	for (int i = 1; i < 1e6; i++) {
		P[i] = (P[i -1] * p) % Q;
	}
	for (int i = 1; i < str.size(); i++) {
		hash1[i] = (hash1[i - 1] * p + str[i]) % Q;
	}
	hash1_r[str.size() - 1] = str[str.size() - 1];
	for (int i = str.size() - 2; i > -1; i--) {
		hash1_r[i] = (hash1_r[i + 1] * p + str[i]) % Q;
	}
	vector<int> ans1(n);
	for (int i = 0; i < n; i++) {
		int l = 0; 
		int r = n + 1;
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (check1(i, m)) {
				l = m;
			}
			else {
				r = m;
			}
		}
		ans1[i] = l;
	}
	vector<int> ans2(n);
	for (int i = 0; i < n; i++) {
		int l = 0;
		int r = n + 1;
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (check2(i, m)) {
				l = m;
			}
			else {
				r = m;
			}
		}
		ans2[i] = l;
	}
	long long ans = 0;
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			if ((j - i + 1) % 2 == 0) {
				if ((j - i + 1)/2 <= ans1[i] && (j - i + 1)/2 <= ans1[j]) {
					ans++;
				}
			}
		}
	}
	for (int i = 0; i < n; i++) {
		for (int j = i + 2; j < n; j++) {
			if ((j - i) % 2 == 0) {
				if ((j - i)/2 <= ans2[i] && (j - i)/2 <= ans2[j]) {
					ans++;
				}
			}
		}
	}
	cout << ans;
}