#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <iomanip>
#include <algorithm>
#include <utility>
#include <cmath>
using namespace std;
#define int long long

int b = 31, mod = 1000000007;
vector <int> powb;
int tsz = 1000000;

vector <int> get_hash(string s) {
	int n = s.size();
	vector <int> hash(n + 1);
	for (int i = 1; i <= n; ++i) {
		hash[i] = hash[i - 1] + (s[i - 1] - 'a' + 1) * powb[i - 1];
		hash[i] %= mod;
	}
	return hash;
}

int ispal(int l, int r, vector <int>& hash1, vector <int>& hash2) {
	int h1 = (hash1[r + 1] - hash1[l] + mod * mod) % mod;
	int l2 = hash1.size() - r - 2;
	int r2 = hash1.size() - l - 2;
	int h2 = (hash2[r2 + 1] - hash2[l2] + mod * mod) % mod;
	h1 = (h1 * powb[tsz - l - 1]) % mod;
	h2 = (h2 * powb[tsz - l2 - 1]) % mod;
	return h1 == h2;
}

vector <int> getc(string s) {
	int n = s.size();
	string sr = s;
	reverse(sr.begin(), sr.end());
	vector <int> hash1 = get_hash(s);
	vector <int> hash2 = get_hash(sr);
	vector <int> c(n);
	for (int i = 0; i < n; ++i) {
		int l = 0, r = n;
		while (r - l > 1) {
			int mid = (l + r) / 2;
			if (i - mid >= 0 && i + mid < n && ispal(i - mid, i + mid, hash1, hash2))
				l = mid;
			else r = mid;
		}
		c[i] = l + 1;
	}
	/*for (int i = 0; i < n; ++i) {
		while (i - c[i] >= 0 && i + c[i] < n && ispal(i - c[i], i + c[i], hash1, hash2)) {
			++c[i];
		}
	}*/
	return c;
}

vector <int> getoddc(string s) {
	string s2 = "";
	for (int i = 0; i < s.size(); ++i) {
		s2.push_back(s[i]);
		s2.push_back('#');
	}
	auto c = getc(s2);
	vector <int> mc;
	for (int i = 1; i < c.size(); i += 2) {
		mc.push_back(c[i] / 2);
	}
	return mc;
}

struct node {
	int l, r;
	node* cl, * cr;
	vector <int> val;
};

vector <int> merge(vector <int> a, vector <int> b) {
	while (b.size()) {
		a.push_back(b.back()); 
		b.pop_back();
	}
	sort(a.begin(), a.end());
	return a;
}

node* build(int l, int r, vector <int>& a) {
	node* root = new node;
	root->l = l, root->r = r;
	if (l != r) {
		int mid = (l + r) / 2;
		root->cl = build(l, mid, a);
		root->cr = build(mid + 1, r, a);
		root->val = merge(root->cl->val, root->cr->val);
	}
	else {
		root->val = { a[l] };
	}
	return root;
}

int query(node* root, int l, int r, int x) {
	if (l > root->r || r < root->l || l > r) return 0;
	if (l <= root->l && root->r <= r) {
		int ans = 0;
		for (auto& i : root->val) if (i >= x) ++ans;
		return ans;
	}
	return query(root->cl, l, r, x) + query(root->cr, l, r, x);
}

void solve() {
	int n;
	string s;
	cin >> n >> s;
	int ans = 0;
	auto c = getc(s);
	vector <int> val(n);
	for (int i = 0; i < n; ++i) {
		if (i % 2 == 1) val[i] = 2 * c[i] - i - 1;
		else val[i] = -1000000;
	}
	node* n1 = build(0, n - 1, val);
	for (int i = 0; i < n; i += 2) {
		ans += query(n1, i + 1, 2 * c[i] + i - 1, -i);
	}
	for (int i = 0; i < n; ++i) {
		if (i % 2 == 0) val[i] = 2 * c[i] - i - 1;
		else val[i] = -1000000;
	}
	node* n2 = build(0, n - 1, val);
	for (int i = 1; i < n; i += 2) {
		ans += query(n2, i + 1, 2 * c[i] + i - 1, -i);
	}

	c = getoddc(s);

	for (int i = 0; i < n; ++i) {
		if (i % 2 == 0) val[i] = 2 * c[i] - i;
		else val[i] = -1000000;
	}
	node* n3 = build(0, n - 1, val);
	for (int i = 0; i < n; i += 2) {
		ans += query(n3, i + 1, 2 * c[i] + i, -i);
	}
	for (int i = 0; i < n; ++i) {
		if (i % 2 == 1) val[i] = 2 * c[i] - i;
		else val[i] = -1000000;
	}
	node* n4 = build(0, n - 1, val);
	for (int i = 1; i < n; i += 2) {
		ans += query(n4, i + 1, 2 * c[i] + i, -i);
	}
	cout << ans << "\n";
}

int32_t main() {
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif // _LOCAL
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

	powb.resize(tsz);
	powb[0] = 1;
	for (int i = 1; i < tsz; ++i) {
		powb[i] = (powb[i - 1] * b) % mod;
	}

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << "\n";
	}
}