#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(1e9) + 7;
const ll maxn = ll(1e6) + 8;
const ll mod = ll(1e9) + 7;
const ll p = 31;

struct node {
    ll x, y, sz;
    ll nxt = 0;
    node *left, *right;
    node(ll x): x(x), y(10101 * rand() + rand()), sz(1) {
        left = right = nullptr;
        nxt = 0;
    }
};

ll get_sz(node* root) {
    if(root == nullptr) return 0;
    return root->sz;
}

void update(node* root) {
    if(root == nullptr) {
        return;
    }
    ll sz = 1;
    sz += get_sz(root->left);
    sz += get_sz(root->right);
    root->sz = sz;
}

void push(node* root) {
    if(root == nullptr) {
        return;
    }
    if(root->left != nullptr) {
        root->left->nxt += root->nxt;
    }
    if(root->right != nullptr) {
        root->right->nxt += root->nxt;
    }
    root->x += root->nxt;
    root->nxt = 0;
}

pair<node*, node*> split(node* root, ll x) {
    if(root == nullptr) {
        return {nullptr, nullptr};
    }
    push(root);
    if(root->x <= x) {
        auto res = split(root->right, x);
        root->right = res.first;
        update(root);
        return {root, res.second};
    } else {
        auto res = split(root->left, x);
        root->left = res.second;
        update(root);
        return {res.first, root};
    }
}

node* merge(node* root1, node* root2) {
    if(root1 == nullptr) {
        return root2;
    }
    if(root2 == nullptr) {
        return root1;
    }
    push(root1);
    push(root2);
    if(root1->y < root2->y) {
        auto res = merge(root1->right, root2);
        root1->right = res;
        update(root1);
        return root1;
    } else {
        auto res = merge(root1, root2->left);
        root2->left = res;
        update(root2);
        return root2;
    }
}

node* add_val(node* root, ll x) {
    auto res = split(root, x);
    root = merge(merge(res.first, new node(x)), res.second);
    return root;
}

ll get_ans(node* root, ll val) {
    auto res = split(root, val);
    ll ans = get_sz(res.first);
    root = merge(res.first, res.second);
    return ans;
}

node* erase(node* root, ll val) {
    auto res1 = split(root, val - 1);
    auto res2 = split(res1.second, val);
    root = merge(res1.first, res2.second);
    return root;
}

ll n;
string s = "";

ll degs[maxn], heh[maxn], revheh[maxn];

ll get_hash(ll l, ll r) {
    ll res = (heh[r] - heh[l - 1] * degs[r - l + 1]) % mod;
    if(res < 0) {
        res += mod;
    }
    return res;
}

ll get_rev_hash(ll l, ll r) {
    ll res = (revheh[l - 1] - revheh[r] * degs[r - l + 1]) % mod;
    if(res < 0) {
        res += mod;
    }
    return res;
}

vector<ll> torem[4][maxn];

void solve() {
    cin >> n;
    ll startn = n;
    string tmp;
    cin >> tmp;
    for(ll i = 0; i < n; i++) {
        s += tmp[i];
        if(i < n - 1) s += "#";
    }
    n = 2 * n - 1;
    for(ll i = 0; i < n; i++) {
        heh[i + 1] = (heh[i] * p + (s[i] - 'a' + 1)) % mod;
    }
    for(ll i = n - 1; i >= 0; i--) {
        revheh[i] = (revheh[i + 1] * p + (s[i] - 'a' + 1)) % mod;
    }
    degs[0] = 1;
    for(ll i = 0; i < n; i++) {
        degs[i + 1] = (degs[i] * p) % mod;
    }

    vector<ll> lens;
    for(ll i = 0; i < n; i++) {
        ll l = 0, r = min(i + 1, n - i);
        while(r - l > 1) {
            ll mid = (l + r) / 2;
            if(get_hash(i + 1, i + mid + 1) == get_rev_hash(i - mid + 1, i + 1)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if(i % 2 == 0) {
            l -= l % 2;
        }
        lens.pb(l);
        //cout << lens.back() << " ";
    }
    //cout << endl;

    ll ans = startn - 1;

    vector<node*> cnt(4, nullptr);

    for(ll o = 0; o < n / 4 + 4; o++) {
        for(ll c = 0; c < 4; c++) {
            ll i = o * 4 + c + 1;
            if(i >= n) break;
            if(lens[i] == 0 || (lens[i] == 1 && s[i] != '#')) continue;
            ll cur = i % 4;
            ll mem = cur;
            if(s[i] != '#') {
                mem = (mem + 2) % 4;
            }

            ll nw = get_ans(cnt[mem], lens[i]);
            ans += nw;
            //cout << i << " " << nw << endl;
        }
        for(ll c = 0; c < 4; c++) {
            ll i = o * 4 + c + 1;
            if(i >= n) break;
            ll cur = i % 4;
            for(ll j = 0; j < 4; j++) {
                for(auto el : torem[j][i]) {
                    cnt[j] = erase(cnt[j], el);
                }
            }

            if(cnt[cur] != nullptr) {
                cnt[cur]->nxt += 2;
            }

            if(lens[i] - (1 - i % 2) > 0) {
                ll to = i + (2 * lens[i] + 2);
                if(to < maxn) {
                    torem[cur][to].pb(lens[i]);
                }
                ll val = 2 - i % 2;
                if(cur == 0) val = 0;
                cnt[cur] = add_val(cnt[cur], val);
            }

            if(cur == 2 && lens[i - 2] > 0 && lens[i] > 0) {
                //cout << i << endl;
                ans--;
            }
        }
    }

    cout << ans << endl;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
