#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <random>

#define endl '\n'
#define rn(n) int n; cin >> n
#define mp make_pair
#define pb push_back
#define sqr(x) ((x) * (x))
#define fi(n) for(int i = 0; i < n; ++i)
#define fir(l, r) for(int i = l; i <= r; ++i)
#define fj(n) for(int j = 0; j < n; ++j)
#define fjr(l, r) for(int j = l; j <= r; ++j)
#define fv(i, n) for(int i = 0; i < n; ++i)
#define fvr(i, l, r) for(int i = l; i <= r; ++i)
#define int ll

#pragma warning (disable : 4996)
//#pragma comment (linker, "STACK:16777216")

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e6 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;
const int MOD1 = (int)1e9 + 9;
const int P = 47;

vii h, rh, p(N);
vi f(N);

pii hashh(int l, int r) {
	return { (h[r].first - h[l].first * p[r - l].first % MOD + MOD) % MOD, (h[r].second - h[l].second * p[r - l].second % MOD1 + MOD1) % MOD1 };
}

pii rev_hash(int l, int r) {
	return { (rh[l].first - rh[r].first * p[r - l].first % MOD + MOD) % MOD, (rh[l].second - rh[r].second * p[r - l].second % MOD1 + MOD1) % MOD1 };
}

void change(int i, int x) {
	while (i < N) {
		f[i] += x;
		i |= (i + 1);
	}
	return;
}

int pref(int i) {
	int ans = 0;
	while (i >= 0) {
		ans += f[i];
		i = (i & (i + 1)) - 1;
	}
	return ans;
}

void clear() {
	fi(N)
		f[i] = 0;
	return;
}

signed main() {
#ifdef LOCALFILE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	p[0] = { 1, 1 };
	for (int i = 1; i < N; ++i) {
		p[i].first = p[i - 1].first * P % MOD;
		p[i].second = p[i - 1].second * P % MOD1;
	}

	int n;
	cin >> n;
	string s;
	cin >> s;
	h.resize(n + 1);
	rh.resize(n + 1);
	for (int i = 0; i < n; ++i) {
		h[i + 1].first = (h[i].first * P + s[i]) % MOD;
		h[i + 1].second = (h[i].second * P + s[i]) % MOD1;
	}
	for (int i = n - 1; i >= 0; --i) {
		rh[i].first = (rh[i + 1].first * P + s[i]) % MOD;
		rh[i].second = (rh[i + 1].second * P + s[i]) % MOD1;
	}
	int ans = 0;
	set<pii> a;
	for (int i = n - 1; i >= 0; --i) {
		int l = 0, r = min(i, n - i - 1) + 1;
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (hashh(i - m, i + m + 1) == rev_hash(i - m, i + m + 1))
				l = m;
			else
				r = m;
		}
		if (i % 2) {
			while (!a.empty() && a.begin()->first < -i) {
				change(a.begin()->second, -1);
				a.erase(a.begin());
			}
			ans += pref(2 * l + 1 + i);
		}
		else {
			change(i, 1);
			a.insert({ 1 + 2 * l - i, i });
		}
	}
	clear();
	a.clear();
	for (int i = n - 1; i >= 0; --i) {
		int l = 0, r = min(i, n - i - 1) + 1;
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (hashh(i - m, i + m + 1) == rev_hash(i - m, i + m + 1))
				l = m;
			else
				r = m;
		}
		if (i % 2 == 0) {
			while (!a.empty() && a.begin()->first < -i) {
				change(a.begin()->second, -1);
				a.erase(a.begin());
			}
			ans += pref(2 * l + 1 + i);
		}
		else {
			change(i, 1);
			a.insert({ 1 + 2 * l - i, i });
		}
	}
	clear();
	a.clear();
	for (int i = n - 1; i > 0; i -= 2) {
		int l = 0, r = min(i, n - i) + 1;
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (hashh(i - m, i + m) == rev_hash(i - m, i + m))
				l = m;
			else
				r = m;
		}
		while (!a.empty() && a.begin()->first < -i) {
			change(a.begin()->second, -1);
			a.erase(a.begin());
		}
		ans += pref(2 * l + i);
		change(i, 1);
		a.insert({ 2 * l - i, i });
	}
	clear();
	a.clear();
	for (int i = n - 2; i > 0; i -= 2) {
		int l = 0, r = min(i, n - i) + 1;
		while (r - l > 1) {
			int m = (l + r) / 2;
			if (hashh(i - m, i + m) == rev_hash(i - m, i + m))
				l = m;
			else
				r = m;
		}
		while (!a.empty() && a.begin()->first < -i) {
			change(a.begin()->second, -1);
			a.erase(a.begin());
		}
		ans += pref(2 * l + i);
		change(i, 1);
		a.insert({ 2 * l - i, i });
	}
	cout << ans;

	return 0;
}