#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <climits>
#include <cassert>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <string>
#include <sstream>
#include <deque>
#include <queue>
#include <ctime>

using namespace std;

#define ll long long
#define ull unsigned ll
#define db double
#define ldb long double
#define ior(a) for (auto& i : a)
#define sbe(a) a.begin(), a.end()
#define srbe(a) a.rbegin(), a.rend()
#define pii pair<int, int>

const ll mod = 1e9 + 7;
const ll base = 54;

struct thash {
	ll x;

	thash() : x(0) {}
	thash(ll x) : x((x) % mod) {}

	thash operator+ (const thash& obj) const {
		return { x + obj.x };
	}

	thash operator* (const thash& obj) const {
		return { x * obj.x };
	}

	thash operator- (const thash& obj) const {
		return { x - obj.x + mod * mod };
	}

	bool operator== (const thash& obj) {
		return x == obj.x;
	}
};

int n;
vector<thash> powers;

thash line(int l, int r, const vector<thash>& hash) {
	return (hash[r] - (hash[l] * powers[r - l]));
}

bool is_p(int l, int r, const vector<thash>& hash, const vector<thash>& rhash) {
	return (line(l, r, hash) == line(n - r - 1, n - l - 1, rhash));
}

void solve() {
	cin >> n;
	string s, s1;
	cin >> s;
	vector<thash> hash(n + 1), rhash(n + 1);
	powers.resize(n + 1);
	powers[0] = 1;
	for (int i = 0; i < n; ++i) {
		hash[i + 1] = hash[i] * base + s[i];
		rhash[i + 1] = rhash[i] * base + s[n - i - 1];
		powers[i + 1] = powers[i] * base;
	}
	int ans = 0;
	for (int i = 0; i < 2 * n - 1; ++i) {
		if (i & 1) {
			int l = 0, r = n;
			while (r - l > 1) {
				int a = (l + r) / 2;
				if ((i / 2 - a < 0) || (n - 1 < i / 2 + a + 1)) {
					r = a;
					continue;
				}
				if (is_p(i / 2 - a, i / 2 + a + 1, hash, rhash))
					l = a;
				else
					r = a;
			}
			for (int j = 0; j <= l; ++j) {
				if (i / 2 - 3 * j - 2 < 0)
					break;
				if (is_p(i / 2 - 3 * j - 2, i / 2 - j - 1, hash, rhash))
					++ans;
			}
		}
		else {
			int l = 0, r = n;
			while (r - l > 1) {
				int a = (l + r) / 2;
				if ((i / 2 - a < 0) || (n - 1 < i / 2 + a)) {
					r = a;
					continue;
				}
				if (is_p(i / 2 - a, i / 2 + a, hash, rhash))
					l = a;
				else
					r = a;
			}
			for (int j = 0; j <= l; ++j) {
				if (i / 2 - 3 * j - 1 < 0)
					break;
				if (is_p(i / 2 - 3 * j - 1, i / 2 - j - 1, hash, rhash))
					++ans;
			}
		}
	}
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(NULL);
	cin.tie(NULL);
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}
	return 0;
}