#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#define endl "\n"
template<class T>bool chkmin(T &a, const T b) {return (a > b) ? a = b, 1 : 0;}
template<class T>bool chkmax(T &a, const T b) {return (a < b) ? a = b, 1 : 0;}
const ll mod = 1e9 + 9, base = 27;

const ll MAX_N = 5e5 + 10;
ull pref1[MAX_N], pref2[MAX_N];
ull pw[MAX_N];
ll n;
string in;

ull query1(ll l, ll r) {ll ans = pref1[r]; if(l > 0) {ans -= pref1[l - 1];} return ans;}
ull query2(ll l, ll r) {ll ans = pref2[r]; if(l > 0) {ans -= pref2[l - 1];} return ans;}

bool palin(ll l, ll r) {
    if(l < 0 || r >= n) {return false;}
    ll hash1 = query1(l, r) * pw[n - 1 - r];
    ll hash2 = query2(l, r) * pw[l];
    return hash1 == hash2;
}

ll k[MAX_N], m[MAX_N];

struct SegTree {
    ll tree[2 * MAX_N];
    SegTree() {fill_n(tree, 2 * MAX_N, 0);}
    void upd(ll ind, ll val) {
        ind += MAX_N; tree[ind] = val; ind /= 2;
        while(ind > 0) {
            tree[ind] = tree[ind * 2] + tree[ind * 2 + 1];
            ind /= 2;
        }
    }
    ll ans(ll l, ll r) {
        l += MAX_N; r += MAX_N + 1;
        ll ret = 0;
        while(l < r) {
            if(l & 1) {ret += tree[l]; l ++;}
            if(r & 1) {r --; ret += tree[r];}
            l /= 2; r /= 2;
        }
        return ret;
    }
};
SegTree st1, st2;

int main() {
    ios_base::sync_with_stdio(false); cin.tie(NULL);
    cin >> n >> in;
    pw[0] = 1;
    for(ll i = 1; i < MAX_N; i ++) {
        pw[i] = pw[i - 1] * base;
    }
    pref1[0] = in[0] - 'a' + 1ll;
    pref2[0] = pw[n - 1] * (ll)(in[0] - 'a' + 1ll);
    for(ll i = 1; i < n; i ++) {
        pref1[i] = pref1[i - 1] + (pw[i] * (ll)(in[i] - 'a' + 1ll));
        pref2[i] = pref2[i - 1] + (pw[n - 1 - i] * (ll)(in[i] - 'a' + 1ll));
    }
    for(int i = 0; i < n; i ++) {
        k[i] = m[i] = 0;
        while(true) {
            if(i >= k[i] && i + k[i] < n && in[i - k[i]] == in[i + k[i]]) {k[i] ++;} else {break;}
        }
        while(true) {
            if(i >= m[i] && i + m[i] + 1 < n && in[i - m[i]] == in[i + m[i] + 1]) {m[i] ++;} else {break;}
        }
        //cout << k[i] << " " << m[i] << endl;
        m[i] ++;
    }
    priority_queue<pair<ll, ll> > pq;
    ll ret = 0;
    for(ll i = 0; i < n; i ++) {
        while(!pq.empty() && -pq.top().first < i) {
            if(pq.top().second & 1) {
                st1.upd(pq.top().second, 0);
            } else {
                st2.upd(pq.top().second, 0);
            }
            pq.pop();
        }
        int nw;
        if(i & 1) {
            nw = st2.ans(i + 1 - 2 * k[i], i);
        } else {
            nw = st1.ans(i + 1 - 2 * k[i], i);
        }
        ret += nw;
        pq.push({-2 * k[i] - i + 1, i});
        if(i & 1) {
            st1.upd(i, 1);
        } else {
            st2.upd(i, 1);
        }
    }
    while(!pq.empty()) {
        if(pq.top().second & 1) {
            st1.upd(pq.top().second, 0);
        } else {
            st2.upd(pq.top().second, 0);
        }
        pq.pop();
    }
    for(ll i = 0; i < n; i ++) {
        while(!pq.empty() && -pq.top().first < i) {
            if(pq.top().second & 1) {
                st1.upd(pq.top().second, 0);
            } else {
                st2.upd(pq.top().second, 0);
            }
            pq.pop();
        }
        ll nw;
        if(i & 1) {
            nw = st1.ans(i + 2 - 2 * m[i], i);
        } else {
            nw = st2.ans(i + 2 - 2 * m[i], i);
        }
        ret += nw;
        pq.push({-2 * m[i] - i + 2, i});
        if(i & 1) {
            st1.upd(i, 1);
        } else {
            st2.upd(i, 1);
        }
    }
    if(n & 1) {
        cout << (n / 2) * ((n + 1) / 2) << endl;
    } else {
        cout << (n / 2) * (n / 2) << endl;
    }
    cout << ret << endl;
    return 0;

}
