#include <algorithm>
#include <iostream>
#include <vector>
#include <string>

using namespace std;

typedef int64_t ll;

const ll MOD = 2286661337;

struct Hash {
	ll n;
	vector<ll> hs;
	vector<ll> d;

	Hash() {}

	Hash(string s) {
		n = (ll)s.size();
		hs.resize(n);
		d.resize(n);
		d[0] = 1;
		hs[0] = s[0] - 'a' + 1;
		for (ll i = 1; i < n; ++i) {
			d[i] = d[i - 1] * 47 % MOD;
			hs[i] = (hs[i - 1] + (s[i] - 'a' + 1) * d[i]) % MOD;
		}
	}

	inline ll get(ll left, ll right) {
		if (left == 0) {
			return hs[right] * d[n - 1] % MOD;
		}
		return (hs[right] - hs[left - 1] + MOD) * d[n - 1 - left] % MOD;
	}
};

ll n;
Hash hs;
Hash rhs;

bool is_pal(ll left, ll right) {
	return hs.get(left, right) == rhs.get(n - right - 1, n - left - 1);
}

int main() {
	cin >> n;
	string s;
	cin >> s;
	hs = Hash(s);
	reverse(s.begin(), s.end());
	rhs = Hash(s);
	ll result = 0;
	for (ll len = 1; len * 2 <= n; ++len) {
		for (ll i = 0; i + 2 * len - 1 < n; ++i) {
			if (!is_pal(i, i + len - 1)) {
				continue;
			}
			if (!is_pal(i + len, i + 2 * len - 1)) {
				continue;
			}
			++result;
		}
	}
	cout << result << endl;
	return 0;
}
