#include <iostream>
#include <vector>
#include <string>
#define int long long

using namespace std;

vector<int> hasha, hashr, xp;
int x = 3360;
int p = 1000 * 1000 * 1000 + 7;
int n;


int gethash(int a, int b)
{
    return ((hasha[b] - hasha[a]) + p) % p * xp[n - a] % p;
}


int gethashr(int a, int b)
{
    return ((hashr[b] - hashr[a]) + p) % p * xp[a] % p;
}


int32_t main()
{
    cin >> n;
    string s;
    cin >> s;
    hasha.resize(n + 1);
    hashr.resize(n + 1);
    xp.resize(n + 1);
    xp[0] = 1;
    for (int i(1); i < n + 1; ++i)
    {
        hasha[i] = (hasha[i - 1] + xp[i - 1] * s[i - 1]) % p;
        hashr[n - i] = (hashr[n - i + 1] + xp[i - 1] * s[n - i]) % p;
        xp[i] = xp[i - 1] * x % p;
    }
    vector<int> v(n);
    for (int i(0); i < n; ++i)
    {
        int L = 0;
        int R = min(i + 1, n - i);
        while (R - L > 1)
        {
            int M = (L + R) / 2;
            if (gethash(i - M, i) == gethashr(i + M + 1, i + 1)) L = M;
            else R = M;
        }
        v[i] = L + 1;
    }
    int result = 0;
    for (int i(0); i < n - 1; ++i)
    {
        int uL = i;
        int uR = i + 1;
        while (uL > -1 && uR < n)
        {
            if (v[uL] >= i - uL + 1 && v[uR] >= uR - i) result++;
            uL--;
            uR++;
        }
    }
    v.assign(n, 0);
    for (int i(0); i < n - 1; ++i)
    {
        int L = 0;
        int R = min(i + 2, n - i);
        while (R - L > 1)
        {
            int M = (L + R) / 2;
            if (gethash(i - M + 1, i + 1) == gethashr(i + M + 1, i + 1)) L = M;
            else R = M;
        }
        v[i] = L;
    }
    for (int i(0); i < n - 1; ++i)
    {
        int uL = i - 1;
        int uR = i + 1;
        while (uL > -1 && uR < n)
        {
            if (v[uL] >= i - uL && v[uR] >= uR - i) result++;
            uL--;
            uR++;
        }
    }
    cout << result << endl;
    return 0;
}
