#include <iostream>
#define endl '\n'

using namespace std;

const int MAXN = 5e5;
const int mod = 1e9+7;
const int p = 31;

int n;
string s;
long long p_pow[MAXN+10];
long long pref[MAXN+10], suf[MAXN+10];
int mx_odd[MAXN+10], mx_even[MAXN+10];
long long cnt = 0;

void input()
{
    cin>>n;
    cin>>s;
}

void printArray(const int a[], const int n)
{
    for (int i=0; i<n; i++)
    {
        cout<<a[i]<<' ';
    }
    cout<<endl;
}

void output()
{
    cout<<cnt<<endl;
}

void calcPow()
{
    p_pow[0] = 1;
    for (int i=1; i<n; i++)
    {
        p_pow[i] = p_pow[i-1]*p % mod;
    }
}

void calcPrefix()
{
    pref[0] = s[0] - 'a' + 1;
    for (int i=1; i<n; i++)
    {
        pref[i] = (long long)(pref[i-1] + (s[i]-'a'+1)*p_pow[i]) % mod;
        //cerr<<pref[i]<<' ';
    }
    //cerr<<endl;
}

void calcSuffix()
{
    suf[n-1] = s[n-1] - 'a' + 1;
    for (int i=n-2; i>=0; i--)
    {
        suf[i] = (long long)(suf[i+1] + (s[i]-'a'+1)*p_pow[n-i-1]) % mod;
        //cerr<<suf[i]<<' ';
    }
    //cerr<<endl;
}

bool checkPal(int from1, int to1, int from2, int to2)
{
    //cerr<<from1<<' '<<to1<<' '<<from2<<' '<<to2<<endl;
    long long past = 1, next = 1;

    past = (pref[to1] + mod - pref[from1-1]) % mod;
    next = (suf[to2] + mod - suf[from2+1]) % mod;

    past = (past * p_pow[n-1-from2]) % mod;
    next = (next * p_pow[from1]) % mod;

    //cerr<<past<<' '<<next<<endl;
    if (next == past)
    {
        //cerr<<from1<<' '<<to1<<' '<<from2<<' '<<to2<<endl;
        return 1;
    }
    else return 0;
}

void calcMaxPal()
{
    for (int i=1; i<n-1; i++)
    {
        int mx = min(min(i, n-i-1), n/4+1);
        int mn = 0;
        while (mx != mn)
        {
            int mid = (mx + mn)/2;
            if (checkPal(i-mid, i, i+mid, i))
            {
                mx_odd[i] = mid;
                mn = mid+1;
            }
            else mx = mid;
        }
        if (checkPal(i-mx, i, i+mx, i)) mx_odd[i] = mx;
    }
    //printArray(mx_odd, n);

    //cerr<<checkPal(0, 1, 2, 1);

    for (int i=0; i<n-1; i++)
    {
        int mx = min(min(i, n-i-1), n/4+1);
        int mn = 0;
        while (mx != mn)
        {
            int mid = (mx + mn)/2;
            if (checkPal(i-mid, i, i+mid+1, i+1))
            {
                mx_even[i] = mid+1;
                mn = mid+1;
            }
            else mx = mid;
        }
        if (checkPal(i-mx, i, i+mx+1, i+1)) mx_even[i] = mx+1;
    }
    //printArray(mx_even, n-1);
}

void countAns()
{
    cnt = n-1;
    for (int i=0; i<n-1; i++)
    {
        int h = i+2*mx_odd[i]+1;
        if (h > n - 1)
        {
            if ((h - n)%2) h = n - 1;
            else h = n - 2;
        }
        for (int j=h; j>i+1; j-=2)
        {
            if (mx_odd[j] >= (j-i-1)/2)
            {
                //cerr<<i<<' '<<j<<endl;
                cnt++;
            }
        }
    }

    for (int i=0; i<n-1; i++)
    {
        int h = i+2*mx_even[i];
        if (h > n-1)
        {
            if ((h - n)%2) h = n - 1;
            else h = n - 2;
        }
        for (int j=h; j>i; j-=2)
        {
            if (mx_even[j] >= (j-i)/2)
            {
                //cerr<<i<<' '<<j<<endl;
                cnt++;
            }
        }
    }
}

void solve()
{
    calcPow();
    calcPrefix();
    calcSuffix();
    calcMaxPal();
    countAns();
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}

/*
6
abacac
*/

