#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
const ll p = 47;
const ll mod = 1e9 + 7;
vector<ll> powers;

int n;
string s;
vector<pair<int, int>> pals = {};

vector<ll> prefs;
vector<ll> prefrs;

void init_powers() {
	powers = vector<ll>(n * 2, 1);
	for ( int i = 0; i < n * 2 - 1; ++i ) powers[i+1] = ( powers[i] * p ) % mod;
}

vector<ll> get_hash(string x) {
	vector<ll> ans = {0};
	for ( char c : x ) {
		ans.push_back(( (ans.back() * p) % mod + (c - 'a' + 1) ) % mod);
	}
	return ans;
}

ll hsh(const vector<ll> & pref, const int & i, const int & j) {
	return ( mod + pref[j + 1] - (pref[i] * powers[j - i + 1]) % mod ) % mod;
}


bool check_pal(int i, int j) {
	if ( (i < 0) || (j >= n) ) return false;
	return hsh(prefs, i, j) == hsh(prefrs, n - 1 - j, n - 1 - i);
}

int xi;

bool cmp1(const int & j, const int & zuzz) {
	if ( !check_pal(xi - j + 1, xi + j - 1) ) return false;
	return true;
}

bool cmp2(const int & j, const int & zuz) {
	if ( !check_pal(xi - j + 1, xi + j) ) return false;
	return true;
}

void find_pals() {
	vector<int> nat(n * 2, 1);
	for ( int i = 0; i < n * 2; ++i ) nat[i] = i + 1;
	int ans;
	
	for ( int i = 0; i < n; ++i ) {
		xi = i;
		ans = lower_bound(nat.begin(), nat.begin() + min(i+1, n - i), 1, cmp1) - nat.begin();
		ans += 1;
		pals.push_back({i - ans + 2, i + ans - 2});
	}

	for ( int i = 0; i < n; ++i ) {
		xi = i;
		ans = lower_bound(nat.begin(), nat.begin() + min(i+1, n - i - 1), 1, cmp2) - nat.begin();
		ans += 1;
		if ( ans == 1 ) continue;
		pals.push_back({i - ans + 2, i + ans - 1});
	}
}



int main() {
	cin >> n;
	cin >> s;

	init_powers();
	prefs = get_hash(s);
	reverse(s.begin(), s.end());
	prefrs = get_hash(s);
	reverse(s.begin(), s.end());

	find_pals();
	int ans = 0;

	vector<pair<int, int>> leni(pals.size());
	for ( int i = 0; i < pals.size(); ++i ) leni[i] = {pals[i].first + pals[i].second, i};
	sort(leni.begin(), leni.end());
	
	vector<pair<int, int>> new_pals(pals.size());
	for ( int i = 0; i < pals.size(); ++i ) new_pals[i] = pals[leni[i].second];
	pals = new_pals;
	
	vector<vector<pair<int, int>>> palsmod(4, vector<pair<int, int>>(0));
	for ( int i = 0; i < pals.size(); ++i ) {
		palsmod[(pals[i].first + pals[i].second) % 4].push_back(pals[i]);
	}

	vector<vector<int>> palsmods(4, vector<int>(0));
	for ( int i = 0; i < pals.size(); ++i ) {
		palsmods[(pals[i].first + pals[i].second) % 4].push_back(pals[i].first + pals[i].second);
	}



	int l, r;
	int l1, r1;
	int leftsum, rightsum;
	for ( int i = 0; i < pals.size(); ++i ) {
		l = pals[i].first; r = pals[i].second;
		leftsum = max(l + r + 1, max(3 * l - r + 2, 0));
		rightsum = 3 * r - l + 2;

		int k = (10 - (l + r) % 4) % 4;
		if ( palsmods[k].size() == 0 ) continue;

		int lft = lower_bound(palsmods[k].begin(), palsmods[k].end(), leftsum) - palsmods[k].begin();
		int rgt = lower_bound(palsmods[k].begin(), palsmods[k].end(), rightsum) - palsmods[k].begin();

		if ( rgt >= palsmods[k].size() ) rgt = palsmods[k].size() - 1;
		else if ( palsmods[k][rgt] > rightsum ) rgt--;

		for ( int j = lft; j <= rgt; ++j ) {
			l1 = palsmod[k][j].first; r1 = palsmod[k][j].second;
			if ( (3 * l1 - r1 - 2) <= (l + r) && (3 * r1 - l1 - 2) >= (l + r ) ) ans++;
		}
	}

	// for ( int i = 0; i < pals.size(); ++i ) {
	// 	for ( int j = 0; j < pals.size(); ++j ) {
	// 		if ( i == j ) continue;
	// 		if ( (pals[i].first + pals[i].second) >= (pals[j].first + pals[j].second) ) continue;

	// 		int x = pals[i].first + pals[i].second + pals[j].first + pals[j].second - 2;
	// 		if ( x % 4 != 0 ) continue;
	// 		x = x >> 2;

	// 		if ( !((pals[i].first <= x) && (pals[i].second >= x)) ) continue;
	// 		if ( !((pals[j].first <= x+1) && (pals[j].second >= x+1)) ) continue;

	// 		ans += 1;
	// 	}
	// }

	cout << ans << endl;
	return 0;
}