#include <bits/stdc++.h>
#define pb push_back
#define mp make_pair
#define ll long long
#define pii pair <int, int>
using namespace std;
const int N = 5e5 + 5;
const int p = 37;
const pii MOD = mp(1e9 + 7, 1e9 + 9);

int n;
string s;

int fen[3 * N][2], ub_fen;
void upd(int id, int x, int par)
{
    id++;
    for(; id <= ub_fen; id += (id & (-id)))
        fen[id][par] += x;
}

int ask(int id, int par)
{
    id++;
    int res = 0;
    for(; id > 0; id -= (id & (-id)))
        res += fen[id][par];
    return res;
}

int query(int l, int r, int par)
{
    if(l > r)
        return 0;
    return ask(r, par) - ask(l - 1, par);
}

pii pref[N], suff[N], pw[N];
int code(char ch)
{
    return ((int)ch - (int)'a');
}

pii calc_hash(int l, int r)
{
    if(l <= r)
    {
        if(l == 0)
            return pref[r];

        pii res = pref[r];
        res.first = (0LL + res.first + MOD.first -
                     ((1LL * pw[r - l + 1].first * pref[l - 1].first) % MOD.first)) % MOD.first;
        res.second = (0LL + res.second + MOD.second -
                      ((1LL * pw[r - l + 1].second * pref[l - 1].second) % MOD.second)) % MOD.second;

        return res;
    }
    else
    {
        swap(l, r);
        if(r == n - 1)
            return suff[l];

        pii res = suff[l];
        res.first = (0LL + res.first + MOD.first -
                     ((1LL * pw[r - l + 1].first * suff[r + 1].first) % MOD.first)) % MOD.first;
        res.second = (0LL + res.second + MOD.second -
                      ((1LL * pw[r - l + 1].second * suff[r + 1].second) % MOD.second)) % MOD.second;

        return res;
    }
}

ll ans;

int odd_pali(int center)
{
    int low = 0, high = min(center, n - 1 - center);

    while(low <= high)
    {
        int mid = (low + high) / 2;
        if(calc_hash(center - mid, center) == calc_hash(center + mid, center))
            low = mid + 1;
        else
            high = mid - 1;
    }

    return low - 1;
}

int even_pali(int center)
{
    int low = 0, high = min(center, n - 2 - center);
    int res = 0;

    while(low <= high)
    {
        int mid = (low + high) / 2;
        if(calc_hash(center - mid, center) == calc_hash(center + mid + 1, center + 1))
        {
            res = mid + 1;
            low = mid + 1;
        }
        else
            high = mid - 1;
    }

    return res;
}

void solve_odd()
{
    memset(fen, 0, sizeof(fen));
    vector <pii> v(n);
    for(int i = 0; i < n; i++)
    {
        v[i].first = -odd_pali(i);
        v[i].second = i;
    }

    sort(v.begin(), v.end());
    int last_upd = -1;
    for(int i = 0; i < n; i++)
    {
//        while(last_upd + 1 < n && v[last_upd + 1].first <= v[i].first)
//        {
//            last_upd++;
//            int par = (v[last_upd].second % 2);
//            upd(v[last_upd].second, 1, par);
//        }

        int par = (v[i].second % 2);
        upd(v[i].second, 1, par);
        int l = max(0, v[i].second + 2 * v[i].first - 1), r = v[i].second - 1;
        ans += query(l, r, par ^ 1);
        r = min(n - 1, v[i].second - 2 * v[i].first + 1), l = v[i].second + 1;
        ans += query(l, r, par ^ 1);

       // cerr << v[i].second << " " << l << " " << r << " " << ans << endl;
    }
}

void solve_even()
{
    memset(fen, 0, sizeof(fen));
    vector <pii> v(n);
    for(int i = 0; i < n; i++)
    {
        v[i].first = -even_pali(i);
        v[i].second = i;
    }

    sort(v.begin(), v.end());

    int last_upd = -1;
    for(int i = 0; i < n; i++)
    {
        if(v[i].first == 0)
            break;
//        while(last_upd + 1 < n && v[last_upd + 1].first <= v[i].first)
//        {
//            last_upd++;
//            int par = (v[last_upd].second % 2);
//            upd(v[last_upd].second, 1, par);
//        }

        int par = (v[i].second % 2);
        upd(v[i].second, 1, par);
        int l = max(0, v[i].second + 2 * v[i].first - 1), r = v[i].second - 1;
        ans += query(l, r, par);

        //cerr << l << " " << r << " " << ans << " " << v[i].second << endl;

        r = min(n - 1, v[i].second - 2 * v[i].first + 1), l = v[i].second + 1;
        ans += query(l, r, par);

       // cerr << l << " " << r << " " << ans << " " << v[i].second << endl;

       // cerr << v[i].second << " " << l << " " << r << " " << ans << endl;
    }
}

bool pali(int l, int r)
{
    while(l < r)
    {
        if(s[l] != s[r])
            return false;
        l++;
        r--;
    }
    return true;
}

int brute()
{
    int res = 0;
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
            int mid = i + j + 1;
            if(mid + j > n - 1)
                break;

            if(pali(i, mid - 1) && pali(mid, mid + j))
                res++;
        }
    }

    return res;
}

mt19937 mt(313);
int rng(int l, int r)
{
    return mt() % (r - l + 1) + l;
}
void gen_test()
{
    n = rng(7, 10);
    s = "";
    for(int i = 0; i < n; i++)
        s.pb(char((int)'a' + rng(0, 4)));
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    cin >> s;
//
//    while(1)
//    {
//        ans = 0;
//        gen_test();
//
//        pw[0] = mp(1, 1);
//        for(int i = 1; i <= n; i++)
//        {
//            pw[i].first = (1LL * pw[i - 1].first * p) % MOD.first;
//            pw[i].second = (1LL * pw[i - 1].second * p) % MOD.second;
//        }
//
//        pref[0] = mp(code(s[0]), code(s[0]));
//        for(int i = 1; i < n; i++)
//        {
//            pref[i].first = (1LL * pref[i - 1].first * p + code(s[i])) % MOD.first;
//            pref[i].second = (1LL * pref[i - 1].second * p + code(s[i])) % MOD.second;
//        }
//
//        suff[n - 1] = mp(code(s[n - 1]), code(s[n - 1]));
//        for(int i = n - 2; i >= 0; i--)
//        {
//            suff[i].first = (1LL * suff[i + 1].first * p + code(s[i])) % MOD.first;
//            suff[i].second = (1LL * suff[i + 1].second * p + code(s[i])) % MOD.second;
//        }
//
//        ub_fen = 3 * n;
//        solve_odd();
//        solve_even();
//
//
//        cerr << ans << " " << brute() << endl;
//        cerr << s << endl;
//        if(ans != brute())
//        {
//            cout << n << endl;
//            cout << s << endl;
//            return 0;
//        }
//    }



        pw[0] = mp(1, 1);
        for(int i = 1; i <= n; i++)
        {
            pw[i].first = (1LL * pw[i - 1].first * p) % MOD.first;
            pw[i].second = (1LL * pw[i - 1].second * p) % MOD.second;
        }

        pref[0] = mp(code(s[0]), code(s[0]));
        for(int i = 1; i < n; i++)
        {
            pref[i].first = (1LL * pref[i - 1].first * p + code(s[i])) % MOD.first;
            pref[i].second = (1LL * pref[i - 1].second * p + code(s[i])) % MOD.second;
        }

        suff[n - 1] = mp(code(s[n - 1]), code(s[n - 1]));
        for(int i = n - 2; i >= 0; i--)
        {
            suff[i].first = (1LL * suff[i + 1].first * p + code(s[i])) % MOD.first;
            suff[i].second = (1LL * suff[i + 1].second * p + code(s[i])) % MOD.second;
        }

        ub_fen = 3 * n;
        solve_odd();
        solve_even();

    cout << ans << endl;
    //cerr << brute() << endl;

    return 0;
}

/*

7
aaacbbc

8
becadddd

*/
