#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <algorithm>
#include <vector>
using namespace std;
#define fs first
#define sc second
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
const int maxn = 5e5 + 100;
const int mod = 1e9 + 7;
#define dbg(x) cout<<#x<<" "<<x<<endl; 

const int ps1 = 33, ps2 = 71, mod1 = 1e9 + 7, mod2 = 1e9 + 9;

int p1[maxn], p2[maxn];

struct huct {
	int h1[maxn], h2[maxn];

	void build(string &s) {
		h1[0] = h2[0] = s[0] - 'a' + 1;
		for (int i = 1; i < s.size(); ++i) {
			h1[i] = (h1[i - 1] + 1ll * p1[i] * (s[i] - 'a' + 1)) % mod1;
			h2[i] = (h2[i - 1] + 1ll * p2[i] * (s[i] - 'a' + 1)) % mod2;
		}
	}

	pii gethash(int l, int r) {
		pii res = { h1[r], h2[r] };
		if (l) {
			res.fs = (res.fs - h1[l - 1] + mod1) % mod1;
			res.sc = (res.sc - h2[l - 1] + mod2) % mod2;
		}
		return res;
	}

} hd, hr;

int n;

bool check(int l, int r) {
	int l2 = n - r - 1;
	int r2 = n - l - 1;
	pii hash1 = hd.gethash(l, r);
	pii hash2 = hr.gethash(l2, r2);
	if (l < l2) {
		hash1.fs = 1ll * hash1.fs * p1[l2 - l] % mod1;
		hash1.sc = 1ll * hash1.sc * p2[l2 - l] % mod2;
	}
	else if (l > l2) {
		hash2.fs = 1ll * hash2.fs * p1[l - l2] % mod1;
		hash2.sc = 1ll * hash2.sc * p2[l - l2] % mod2;
	}
	return hash1 == hash2;
}


struct segtree {
	vector<int> t[maxn * 2];
	int n;

	void build(int v, int tl, int tr, vector<int> &a) {
		if (tl == tr) {
			t[v] = { a[tl] };
		}
		else {
			int tm = (tl + tr) / 2;
			build(v * 2, tl, tm, a);
			build(v * 2 + 1, tm + 1, tr, a);
			t[v].resize(t[v * 2].size() + t[v * 2 + 1].size());
			merge(t[v * 2].begin(), t[v * 2].end(), t[v * 2 + 1].begin(), t[v * 2 + 1].end(), t[v].begin());
		}
	}

	void build(vector<int> &a) {
		n = a.size();
		if (!n) return;
		build(1, 0, n - 1, a);
	}

	int get(int v, int tl, int tr, int l, int r, int k) {
		if (l > r) return 0;
		if (tl == l && tr == r) {
			return t[v].size() - (lower_bound(t[v].begin(), t[v].end(), k) - t[v].begin());
		}
		int tm = (tl + tr) / 2;
		return get(v * 2, tl, tm, l, min(tm, r), k) + get(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r, k);
	}

	int get(int l, int r, int k) {
		return get(1, 0, n - 1, l, r, k);
	}
} t1, t2, t3, t4;

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	cin >> n;
	string s;
	cin >> s;
	
	p1[0] = 1;
	p2[0] = 1;
	for (int i = 1; i < s.size(); ++i) {
		p1[i] = 1ll * p1[i - 1] * ps1 % mod1;
		p2[i] = 1ll * p2[i - 1] * ps2 % mod2;
	}
	
	hd.build(s);
	reverse(s.begin(), s.end());
	hr.build(s);
	reverse(s.begin(), s.end());

	vector<int> mxl1(n), mxl2(n);
	for (int i = 0; i < n; ++i) {
		int l = 0, r = min(i, n - i - 1) + 1;
		while (l + 1 < r) {
			int m = (l + r) / 2;
			if (check(i - m, i + m)) l = m;
			else r = m;
		}
		mxl1[i] = l;
	}
	for (int i = 0; i < n-1; ++i) {
		int l = 0, r = min(i, n - i - 2) + 1;
		while (l + 1 < r) {
			int m = (l + r / 2);
			if (check(i - m, i + m + 1)) l = m;
			else r = m;
		}
		if (!check(i, i + 1)) mxl2[i] = -1;
		else mxl2[i] = l;
	}

	vector<int> v1, v2, v3, v4;
	for (int i = 0; i < n; ++i) {
		if (i % 2 == 0) {
			v2.push_back(v2.size() + mxl1[i]);
		}
		else {
			v1.push_back(v1.size() + mxl1[i]);
		}
	}
	for (int i = 0; i < n; ++i) {
		if (i % 2 == 0) {
			v4.push_back(v4.size() + mxl2[i]);
		} else {
			v3.push_back(v3.size() + mxl2[i]);
		}
	}


	t1.build(v1);
	t2.build(v2);
	t3.build(v3);
	t4.build(v4);

	ll ans = 0;

	for (int i = 0; i < n; ++i) {
		if (i % 2 == 1) {
			ans += t2.get(max(0, i / 2 - mxl1[i]), i / 2, i / 2);
		}
		else {
			ans += t1.get(max(0,i/2-1-mxl1[i]), i/2-1, i / 2 - 1);
		}
	}

	for (int i = 0; i < n-1; ++i) {
		if (i % 2 == 0) {
			ans += t4.get(max(0, i / 2 - 1 - mxl2[i]), i / 2 - 1, i / 2 - 1);
		}
		else {
			ans += t3.get(max(0, i / 2 - 1 - mxl2[i]), i / 2 - 1, i / 2 - 1);
		}
	}
	cout << ans;
	return 0;
}