// lolkekstl.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <sstream>
#include <queue>
#include <deque>
#include <iomanip>
#include <fstream>
#include <bitset>
#include <stack>
//#include <xhash>

using namespace std;

unsigned long long MODE = 1000000241;

unsigned long long osn = 33;

vector<unsigned long long> hashh;
vector<unsigned long long> reversehash;

unsigned long long stepen(unsigned long long a, unsigned long long n, unsigned long long p) {
    if (n == 0) {
        return 1;
    }
    if (n == 1) {
        return a;
    }
    if (n & 1) {
        return a * stepen(a * a % p, (n >> 1), p) % p;
    }
    else {
        return stepen(a * a % p, (n >> 1), p);
    }
}
unsigned long long pluss(unsigned long long a, unsigned long long b) {
    if (a + b > MODE) {
        return a + b - MODE;
    }
    return a + b;
}

unsigned long long minuss(unsigned long long a, unsigned long long b) {
    if (b > a) {
        return a - b + MODE;
    }
    return a - b;
}


unsigned long long get_hash(int l, int r) {
    return minuss(hashh[r], hashh[l - 1] * stepen(osn, r - l + 1, MODE) % MODE);
}

unsigned long long get_revhash(int l, int r) {
    return minuss(reversehash[l], reversehash[r + 1] * stepen(osn, r - l + 1, MODE) % MODE);
}


int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    string s;
    int n = 0;
    cin >> n;
    cin >> s;
    hashh = vector<unsigned long long>(n+1, 0);
    reversehash= vector<unsigned long long>(n+1, 0);
    for (int i = 0; i < n; i++) {
        if (i == 0) {
            hashh[i+1] = s[i] - char(96);
        }
        else {
            hashh[i+1] = pluss(hashh[i] * osn % MODE, s[i] - char(96));
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        if (i == n - 1) {
            reversehash[i] = s[i] - char(96);
        }
        else {
            reversehash[i] = pluss(reversehash[i + 1] * osn % MODE, s[i] - char(96));
        }
    }
    vector<map<int, int> > lol(n);
    /*for (int i = 0; i < n-1; i++) {
        cout << get_hash(i + 1, i + 2) << " ";
    }
    cout << endl;
    for(int i = 0; i < n-1; i++) {
        cout << get_revhash(i, i+1) << " ";
    }*/
    for (int i = 0; i < n; i++) {
        lol[i][1] = 1;
        for (int j = i + 1; j < n; j++) {
            if (get_hash(j - (j - i) / 2 + 1, j + 1) == get_revhash(i, i + (j - i) / 2)) {
                lol[i][j - i + 1] = 1;
                //cout << i << " "<<j << endl;
            }
        }
    }
    long long ans = 0;
    for (int i = 0; i < n; i++) {
        for (auto it = lol[i].begin(); it != lol[i].end(); it++) {
            if (i + it->first < n) {
                if (lol[i + it->first][it->first] != 0) {
                    ans++;
                }
            }
        }
    }
    cout << ans;
    return 0;
}