#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

const int MAXN = 5e5, P = 31, MOD = 1e9 + 7;

long long h[MAXN + 1], p[MAXN + 1], rh[MAXN + 1], sz;

inline void build(const string &s) {
    p[0] = 1;
    sz = s.size();
    for (int i = 0; i < sz; i++) {
        h[i + 1] = (h[i] * P + s[i]) % MOD;
        rh[i + 1] = (rh[i] * P + s[sz - 1 - i]) % MOD;
        p[i + 1] = (p[i] * P) % MOD;
    }
}

inline int get_hash(int l, int r) {
    return ((h[r] - h[l] * p[r - l]) % MOD + MOD) % MOD;
}

inline int get_rev_hash(int l, int r) {
    return ((rh[sz - l] - rh[sz - r] * p[r - l]) % MOD + MOD) % MOD;
}

vector<int> del_odd[MAXN * 4], del_even[MAXN * 4];

int fenwick[MAXN + 1][4];

inline void inc(int i, int delta, int pos) {
    i++;
    while (i <= MAXN) {
        fenwick[i][pos] += delta;
        i += i & (-i);
    }
}

inline int get_sum(int i, int pos) {
    int ans = 0;
    while (i > 0) {
        ans += fenwick[i][pos];
        i -= i & (-i);
    }
    return ans;
}

inline int get_sum(int l, int r, int pos) {
    return get_sum(r, pos) - get_sum(l, pos);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    string s;
    cin >> s;
    build(s);
    vector<int> alive_odd(n, 1), alive_even(n, 1);
    for (int i = 0; i < n; i++) {
        int l = 0, r = 2 * n;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (i - m + 1 < 0 || i + m - 1 >= n || get_hash(i - m + 1, i + 1) != get_rev_hash(i, i + m)) {
                r = m;
            } else {
                l = m;
            }
        }
        del_odd[r * 2 - 1].emplace_back(i);
        l = -1, r = 2 * n;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (i - m < 0 || i + m + 1 >= n || get_hash(i - m, i + 1) != get_rev_hash(i + 1, i + m + 2)) {
                r = m;
            } else {
                l = m;
            }
        }
        del_even[r * 2 + 2].emplace_back(i);
    }
    for (int i = 0; i < n; i += 2) {
        inc(i, 1, 0);
        inc(i, 1, 2);
    }
    for (int i = 1; i < n; i += 2) {
        inc(i, 1, 1);
        inc(i, 1, 3);
    }
    long long ans = 0;
    for (int l = 1; l < n; l++) {
        ans += n - l;
        for (auto &x : del_odd[l]) {
            int j;
            if (x % 2 == 0) {
                j = 1;
            } else {
                j = 0;
            }
            ans -= get_sum(x + l, n, j);
            ans -= get_sum(0, x - l + 1, j);
            inc(x, -1, j ^ 1);
        }
        for (auto &x : del_even[l]) {
            int j;
            if (x % 2 == 0) {
                j = 2;
            } else {
                j = 3;
            }
            ans -= get_sum(x + l, n, j);
            ans -= get_sum(0, x - l + 1, j);
            inc(x, -1, j);
        }
    }
    cout << ans;
    return 0;
}