#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

ll p = 31;
ll mod = 200720077;
vector<ll> power;

void calcp(int n) {
    power.resize(n + 1);
    power[0] = 1;
    for (int i = 0; i < n; ++i) {
        power[i + 1] = power[i] * p % mod;
    }
}

void calc(string &s, int n, vector<ll> &hash) {
    for (int i = 0; i < n; ++i) {
        hash[i + 1] = (hash[i] * p + (s[i] - 'a' + 1)) % mod;
    }
}

ll get_hash(int l, int r, vector<ll> &hash) {
    return (hash[r + 1] - hash[l] * power[r - l + 1] % mod + mod) % mod;
}

ll solve(vector<pair<int, int>> &v) {
    int n = v.size();
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            int mid = (v[i].first + v[j].first) / 2;
            if (abs(v[i].first - mid) <= v[i].second && abs(v[j].first - mid) <= v[j].second) {
                res++;
            }
        }
    }
    return res;
}

ll solve2(vector<pair<int, int>> &v) {
    int n = v.size();
    ll res = 0;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 1; j < n; ++j) {
            if (v[i].first % 2 == v[j].first % 2) {
                continue;
            }
            int mid = (v[i].first + v[j].first) / 2;
            if (abs(v[i].first - mid) <= v[i].second && abs(v[j].first - mid) - 1 <= v[j].second) {
                res++;
            }
        }
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    string s;
    cin >> s;
    calcp(n);
    vector<ll> pref(n + 1), suf(n + 1);
    calc(s, n, pref);
    reverse(s.begin(), s.end());
    calc(s, n, suf);

    ll ans = 0;

    vector<pair<int, int>> v1, v2;
    for (int i = 0; i < n - 1; ++i) {
        int l = 0, r = min(i + 1, n - i - 1) + 1;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            if (get_hash(i - mid + 1, i + mid, pref) ==
            get_hash(n - (i + mid) - 1, n - (i - mid + 1) - 1, suf)) {
                l = mid;
            } else {
                r = mid;
            }
        }
        if (l == 0) {
            continue;
        }
        if (i % 2) {
            v1.push_back({i, l});
        } else {
            v2.push_back({i, l});
        }
    }
    ans += solve(v1) + solve(v2);

    vector<pair<int, int>> v12;
    for (int i = 0; i < n; ++i) {
        int l = 0, r = min(i, n - i - 1) + 1;
        while (l + 1 < r) {
            int mid = (l + r) / 2;
            ll a = get_hash(i - mid, i + mid, pref);
            ll b = get_hash(n - (i + mid) - 1, n - (i - mid) - 1, suf);
            if (a == b) {
                l = mid;
            } else {
                r = mid;
            }
        }
        v12.push_back({i, l});
    }
    ans += solve2(v12);


    cout << ans << endl;
}