#pragma region Include
#include<algorithm>
#include<iostream>
#include<assert.h>
#include<utility>
#include<fstream>
#include<vector>
#include<random>
#include<map>
using namespace std;
#pragma endregion
#pragma region Constant
const int N = 2e5, INF = 1e9, MOD = 1e9 + 7;
const long long llINF = 1e18;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (T& el : vec) {
		in >> el;
	}
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> const& vec) {
	for (T const& el : vec) {
		out << el << ' ';
	}
	return out;
}

template<typename T, typename P>
istream& operator >> (istream& in, pair<T, P>& p) {
	in >> p.first >> p.second;
	return in;
}

template<typename T, typename P>
ostream& operator << (ostream& out, pair<T, P> const& p) {
	out << p.first << ' ' << p.second;
}
#pragma endregion

int main() {
	//ifstream cin("input.txt");
	//ofstream cout("output.txt");
	
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, cur_bal = 0;
	char c;
	cin >> n;

	int lst_0_pos = -1, ans = 0;
	bool add = false;

	for (int i = 0; i < n; i++) {
		cin >> c;
		if (c == '(') {
			++cur_bal;
		}
		else
		{
			--cur_bal;
		}

		if (cur_bal < 0)
		{
			add = true;
		}
		else if (cur_bal == 0) {
			if (add) {
				ans += i - lst_0_pos;
			}
			lst_0_pos = i;
			add = false;
		}
	}

	if (cur_bal != 0) {
		cout << "-1\n";
	}
	else
	{
		cout << ans << '\n';
	}
}