#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}
ll time() {
    return chrono::steady_clock::now().time_since_epoch().count();
}

#define SPAR 0
#define FEN 0

#ifdef SPAR
namespace SPARSE {
    bool run = false;
    const int N = 1e5;
    const int LOG = 17;

    int log[N];

    void init() {
        if (!run) {
            run = true;
            log[0] = 0;

            for (int i = 1; i < LOG; ++i) {
                for (int j = (1 << i); j < (1 << (i + 1)) && j < N; ++j)
                    log[j] = i;
            }
        }
    }
};
struct Sparse {
    int n, p = 0;
    int **t;

    Sparse(int _n) {
        SPARSE::init();
        n = _n;
        t = new int*[n];
        for (int i = 0; i < n; ++i)
            t[i] = new int[SPARSE::LOG];
    }

    void push(int x) {
        t[n - p - 1][0] = x;
        for (int i = 0; i < SPARSE::LOG - 1; ++i) {
            if (n - p - 1 + (1 << i) < n)
                t[n - p - 1][i + 1] = min(t[n - p - 1][i], t[n - p - 1 + (1 << i)][i]);
            else
                t[n - p - 1][i + 1] = t[n - p - 1][i];
        }
        p++;
    }

    int get(int l, int r) {
        int k = SPARSE::log[r - l];

        return min(t[l][k], t[r - (1 << k)][k]);
    }
};
#endif

#ifdef FEN
struct Fen {
    int *t, n;
    Fen(int _n) {
        n = _n;
        t = new int[n];

        memset(t, 0, t[0] * n);
    }

    void add(int i, int x) {
        for (;i < n; i = i | (i + 1))
            t[i] += x;
    }

    int get(int r) {
        r--;
        int res = 0;
        for (;r >= 0; r = (r & (r - 1)) - 1)
            res += t[r];
        return res;
    }
};
#endif

int median(int a, int b, int c) {
    vector<int> v = {a, b, c};

    sort(v.begin(), v.end());

    return v[1];
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;
    string s;
    cin >> s;

    int cnt0 = 0;
    for (int i = 0; i < n; ++i)
        cnt0 += s[i] == '(';
    if (n != 2 * cnt0) {
        cout << -1 << endl;
        return 0;
    }

    int now = 0;
    int res = 0;
    for (int i = 0, cnt = 0, l = -1; i < n; ++i) {
        if (s[i] == '(') now++;
        else {
            if (now) now--;
            else if (cnt) cnt++;
            else l = i, cnt++;
        }

        if (cnt && now == cnt) res += i - l + 1, cnt = 0, now = 0;
    }

    cout << res;

    return 0;
}
