#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(a) cout << #a << " := " << a << '\n'

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif // LOCAL

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(2e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & a, int size_, T value = 0) { a.assign(size_, value); }

void solve();
void boot_up() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}



int n;
string s;

inline bool is_good(int l, int r);

signed main() {
    boot_up();

    while (cin >> n >> s) {
        solve();
    }
}

void solve() {
    int open = 0, close = 0;
    for (int i = 0; i < n; ++i) {
        if (s[i] == '(') {
            ++open;
        }
        else {
            ++close;
        }
    }

    if (open != close) {
        cout << -1 << '\n';
    }
    else {
        int ans = 0;
        int last = 0;
        int bal = 0;
        for (int i = 0; i < n; ++i) {
            if (s[i] == '(') {
                ++bal;
            }
            else {
                --bal;
            }

            if (bal == 0) {
                if (!is_good(last, i)) {
                    ans += (i - last + 1);
                }
                last = i + 1;
                bal = 0;
            }
        }

        if (n - 1 - last + 1 > 1) {
            if (!is_good(last, n - 1)) {
                ans += (n - 1 - last + 1);
            }
        }

        cout << ans << '\n';
    }
}

inline bool is_good(int l, int r) {
    int bal = 0;
    for (int i = l; i <= r; ++i) {
        if (s[i] == '(') {
            ++bal;
        }
        else {
            --bal;
        }

        if (bal < 0) {
            return false;
        }
    }

    return bal == 0;
}