#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pb push_back
#define pll pair<ll, ll>

const ll inf = ll(1e9) + 7;
const ll maxn = ll(1e6) + 3;

ll n;
string s;
vector<ll> pref(1, 0);

struct node {
    ll l, mid, r;
    ll mn;
    ll nxt;
    node *left, *right;
    node(ll l, ll r): l(l), r(r) {
        left = right = nullptr;
        nxt = 0;
        mn = inf;
        mid = (l + r) / 2;
    }
};

void build(node* root) {
    if(root->l == root->r) {
        root->mn = root->l;
        if(pref[root->l + 1] < 0) {
            root->mn = inf;
        }
        return;
    }
    root->left = new node(root->l, root->mid);
    root->right = new node(root->mid + 1, root->r);
    build(root->left);
    build(root->right);
    root->mn = min(root->left->mn, root->right->mn);
}

ll get_mn(node* root, ll ql, ll qr) {
    if(root->l > qr || root->r < ql) {
        return inf;
    }
    if(ql <= root->l && root->r <= qr) {
        return root->mn;
    }
    ll res = min(get_mn(root->left, ql, qr),
                 get_mn(root->right, ql, qr));
    return res;
}

void solve() {
    cin >> n;
    cin >> s;
    ll tmp = 0;
    for(ll i = 0; i < n; i++) {
        if(s[i] == '(') {
            tmp++;
        } else {
            tmp--;
        }
        pref.pb(tmp);
    }
    if(pref.back() != 0) {
        cout << -1 << endl;
        return;
    }

    ll ans = 0;
    node* root = new node(0, n - 1);
    build(root);
    for(ll i = 0; i < n; i++) {
        if(pref[i + 1] < 0) {
            ll pos = get_mn(root, i + 1, n - 1);
            ans += (pos - i + 1);
            i = pos;
        }
    }
    cout << ans << endl;
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);

    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();

    return 0;
}
