#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>
#include <map>
#include <tuple>
#include <deque>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_set;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n;
    cin >> n;
    string s;
    cin >> s;
    if (count(s.begin(), s.end(), '(') != count(s.begin(), s.end(), ')')) {
        cout << -1 << endl;
        return 0;
    }
    vector<ll> a(n);
    for (ll i = 0; i < n; i++) {
        a[i] = i == 0 ? 0 : a[i - 1];
        if (s[i] == '(') {
            a[i]++;
        }
        if (s[i] == ')') {
            a[i]--;
        }
    }
    deque<ll> x, y;
    for (ll i = 0; i < n; i++) {
        if (a[i] == -1) {
            x.push_back(i);
        }
        if (a[i] == 0) {
            y.push_back(i);
        }
    }
    ll o = 0;
    while (!x.empty()) {
        ll i = x.front();
        ll j = *lower_bound(y.begin(), y.end(), i);
        o += j - i + 1;
        while (!x.empty() && x.front() <= j) {
            x.pop_front();
        }
        while (!y.empty() && y.front() <= j) {
            y.pop_front();
        }
    }
    cout << o << endl;
    return 0;
}
