#include <iostream>
#include <math.h>
#include <vector>
#include <map>
#include <algorithm>
#include <random>
#include <chrono>
#include <set>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,popcnt")

#define ll long long
#define vll vector<ll>
#define pb push_back
#define pll pair<ll, ll>
#define vii vector<int>
#define pii pair<int, int>
#define vpll vector<pll>
#define f first
#define s second

#define MOD (ll)(1e9 + 7)

vll parent;

ll find_union(ll v)
{
    if(parent[v] == v)
        return v;
    else
        return parent[v] = find_union(parent[v]);
}

void merge_unions(ll a, ll b)
{
    a = find_union(a);
    b = find_union(b);

    parent[b] = a;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n;
    cin >> n;
    string st;
    cin >> st;

    parent.resize(n + 1);
    for(int i = 0; i < n + 1; i++)
    {
        parent[i] = i;
    }
    vll nxtOpen(n);
    ll curNxt = n;
    for(int i = n - 1; i >= 0; i--)
    {
        nxtOpen[i] = curNxt;
        if(st[i] == '(')
            curNxt = i;
        else
            merge_unions(curNxt, i);
    }

  //  cerr << "nxtOpen ";
  //  for(int i = 0; i < nxtOpen.size(); i++)
   //     cerr << nxtOpen[i] << " ";
   // cerr << endl;
   // cerr << "counted new part" << endl;

    ll cur = 0;
    vpll segs;
    for(int i = 0; i < st.size(); i++)
    {
        if(st[i] == '(')
            cur++;
        else
            cur--;

        if(cur < 0)
        {
            ll nxt = find_union(i);
        //    cerr << "nxt " << nxt << " i " << i << endl;
            if(nxt == n)
            {
                cout << -1 << endl;
                return 0;
            }

            merge_unions(nxtOpen[nxt], nxt);
            swap(st[i], st[nxt]);
            cur += 2;

            segs.pb({i, nxt});
        }
    }
    if(cur != 0)
    {
        cout << -1 << endl;
        return 0;
    }

    ll answ = 0;
    sort(segs.begin(), segs.end());

    for(int i = 0; i < segs.size(); i++)
    {
        pll x = segs[i];
        for(int j = i + 1; j < segs.size() && segs[j].f <= x.s; j++)
        {
            i = max(i, j);
            x.s = max(x.s, segs[j].s);
        }
        answ += x.s - x.f + 1;
    }
    cout << answ << endl;
    return 0;
}