#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << ' ' << x << endl

using namespace std;

struct Tree {
    vector<int> tree;

    void build(int node, int low, int high, string s) {
        if (low == high) {
            this->tree[node] = (s[low] == '(') ? 1 : -1;
            return;
        }

        int mid = (low + high) >> 1;
        this->build(node << 1, low, mid, s);
        this->build(node << 1 | 1, mid + 1, high, s);

        this->tree[node] = this->tree[node << 1] + this->tree[node << 1 | 1];
    }

    int query(int node, int low, int high, int ql, int qr) {
        if (high < ql || low > qr) {
            return 0;
        }

        if (low >= ql && high <= qr) {
            return this->tree[node];
        }

        int mid = (low + high) >> 1;
        return this->query(node << 1, low, mid, ql, qr) + this->query(node << 1 | 1, mid + 1, high, ql, qr);
    }

    void build(string s) {
        int n = (int)s.size();
        this->tree.resize(n << 2);
        this->build(1, 0, n - 1, s);
    }
};

int n;
string s;
Tree tree;

bool isProper(int l, int r) {
    stack<char> st;
    for (int i = l; i <= r; i++) {
        if (s[i] == '(') {
            st.emplace('(');
        } else if (st.empty()) {
            return false;
        } else {
            st.pop();
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;
    cin >> s;

    tree.build(s);

    vector<int> dp(n, -1);
    vector<int> activeDp = {-1};

    for (int i = 1; i < n; i++) {
        for (int j : activeDp) {
            int prevDp = (j == -1) ? 0 : dp[j];
            if (tree.query(1, 0, n - 1, j + 1, i) == 0) {
                int cost = isProper(j + 1, i) ? 0 : i - (j + 1) + 1;
                if (dp[i] == -1) {
                    dp[i] = prevDp + cost;
                } else {
                    dp[i] = min(dp[i], prevDp + cost);
                }
            }
        }
        if (dp[i] != -1) {
            activeDp.emplace_back(i);
        }
    }

    cout << dp.back() << endl;

    return EXIT_SUCCESS;
}
