#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

template<class T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template<class T, class U> using ordered_map = tree<T, U, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = 5e5, MAXLOG = 22;

vector<int> g[MAXN];
int up[MAXN], type[MAXN], jump[MAXN][MAXLOG], depth[MAXN];

void lca_precalc(int v, int p = -1) {
    if (p == -1) {
        depth[v] = 0;
        jump[v][0] = v;
    } else {
        depth[v] = depth[p] + 1;
        jump[v][0] = p;
    }
    for (int i = 1; i < MAXLOG; i++) {
        jump[v][i] = jump[jump[v][i - 1]][i - 1];
    }
    for (auto &u : g[v]) {
        if (u != p) {
            lca_precalc(u, v);
        }
    }
}

inline int lca(int v, int u) {
    if (depth[v] < depth[u]) {
        swap(v, u);
    }
    for (int i = MAXLOG - 1; i >= 0; i--) {
        if (depth[jump[v][i]] >= depth[u]) {
            v = jump[v][i];
        }
    }
    if (v == u) {
        return v;
    }
    for (int i = MAXLOG - 1; i >= 0; i--) {
        if (jump[v][i] != jump[u][i]) {
            v = jump[v][i];
            u = jump[u][i];
        }
    }
    return jump[v][0];
}

void dfs(int v, int p = -1) {
    for (auto &u : g[v]) {
        if (u != p) {
            dfs(u, v);
            if (type[v] != 0 && up[u] != u && type[v] != type[u]) {
                cout << -1;
                exit(0);
            }
            type[v] = type[u];
            if (depth[up[v]] > depth[up[u]]) {
                up[v] = up[u];
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, t;
    cin >> n >> m >> t;
    for (int i = 0; i < n; i++) {
        up[i] = i;
    }
    for (int i = 1; i < n; i++) {
        int v, u;
        cin >> v >> u;
        g[v - 1].emplace_back(u - 1);
        g[u - 1].emplace_back(v - 1);
    }
    lca_precalc(0);
    while (m--) {
        int a, b;
        cin >> a >> b;
        int c = lca(--a, --b);
        if (a != c) {
            if (type[a] == -1) {
                cout << -1;
                return 0;
            }
            type[a] = 1;
            if (depth[up[a]] > depth[c]) {
                up[a] = c;
            }
        }
        if (b != c) {
            if (type[b] == 1) {
                cout << -1;
                return 0;
            }
            type[b] = -1;
            if (depth[up[b]] > depth[c]) {
                up[b] = c;
            }
        }
    }
    dfs(0);
    cout << 10000000;
    return 0;
}