#include <bits/stdc++.h>
#define int long long
using namespace std;

struct Stupid {
    int n, m, t;
    vector<vector<int>> g;
    vector<pair<int, int>> w;
    vector<vector<int>> ways;

    Stupid(auto g, auto w, int t): g(g), w(w), t(t) {
        n = g.size(), m = w.size();
    }

    int dfs(int v, int f, int p, vector<int>& arr) {
        if(v == f) {
            arr.push_back(v);
            return 1;
        }

        for(int u : g[v]) {
            if(u == p) continue;
            if(dfs(u, f, v, arr)) {
                arr.push_back(v);
                return 1;
            }
        }

        return 0;
    }

    vector<int> get_c(int mask) {
        vector<int> c(n, 0);
        for(int i = 0; i < n; ++i) {
            c[i] = (mask % n) + 1;
            mask /= n;
        }

        return c;
    }

    int check(vector<int> c) {
        for(int i = 0; i < m; ++i) {
            int flag = 1;
            for(int j = 0; j+1 < ways[i].size(); ++j)
                if(c[ways[i][j]] >= c[ways[i][j+1]]) flag = 0;
            if(flag) continue;

            for(int j = 0 ; j+1 < ways[i].size(); ++j)
                if(c[ways[i][j]] <= c[ways[i][j+1]]) flag = 0;
            if(flag) continue;

            return 0;
        }

        return 1;
    }

    vector<int> solve() {
        ways.resize(m);
        for(int i = 0; i < m; ++i) {
            dfs(w[i].first, w[i].second, -1, ways[i]);
        }

        for(int i = 0; i < pow(n, n); ++i) {
            vector<int> c = get_c(i);
            if(check(c)) return c;
        }

        return {};
    }
};

const int local = 0, stress = 0;
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    if(local) freopen("input.txt", "r", stdin);

    ///---------///
    ///---------///

    int tests = 1;
    if((local) && (!stress)) cin >> tests;

    while(tests--) {
        if(!stress) {
            int n, m, t;
            cin >> n >> m >> t;

            vector<vector<int>> g(n);
            for(int i = 0; i < n-1; ++i) {
                int u, v;
                cin >> u >> v;
                u--; v--;

                g[u].push_back(v);
                g[v].push_back(u);
            }

            vector<pair<int, int>> w(m);
            for(int i = 0; i < m; ++i) {
                cin >> w[i].first >> w[i].second;
                w[i].first--; w[i].second--;
            }

            Stupid solver(g, w, t);
            vector<int> res = solver.solve();

            if(res.empty()) {
                cout << "-1\n";
            } else {
                int mx = -1;
                for(int i : res)
                    mx = max(mx, i);
                for(int i : res)
                    cout << i << " ";
                cout << "\n";
            }

        } else {}
    }

    return 0;
}
