#include <iostream>
#include <vector>

using namespace std;

const int MAX_N = 5e5 + 10;
vector<int> g[MAX_N];

int n, routes, t;

int par[MAX_N];
int c[MAX_N];
int h[MAX_N];

void dfs(int v, int p = -1, int curH = 0) {
    par[v] = p;
    h[v] = curH;
    for (int u : g[v]) {
        if (u == p) {
            continue;
        }
        dfs(u, v, curH + 1);
    }
}

int lca(int a, int b) {
    if (h[a] < h[b]) {
        swap(a, b);
    }
    while (h[a] > h[b]) {
        a = par[a];
    }
    while (a != b) {
        a = par[a];
        b = par[b];
    }
    return a;
}

int main() {
#ifdef LOCAL
    freopen("C.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> routes >> t;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(1, 1);
    for (int i = 1; i <= n; i++) {
        c[i] = 1;
    }
    for (int i = 0; i < routes; i++) {
        int a, b;
        cin >> a >> b;
        int curC = 1;
        int lc = lca(a, b);
        while (a != lc) {
            c[a] = curC++;
            a = par[a];
        }
        c[lc] = curC++;
        while (b != lc) {
            c[b] = curC++;
            b = par[b];
        }
    }
    int ans = 1;
    for (int i = 1; i <= n; i++) {
        ans = max(ans, c[i]);
    }
    cout << ans << "\n";
    for (int i = 1; i <= n; i++) {
        cout << c[i] << " ";
    }
    cout << "\n";

    return 0;
}