#include <bits/stdc++.h>

#define len(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define dbg(a) cout << #a << " := " << a << '\n'

#ifdef LOCAL
    #define NEW_TEST cout << "-----------TEST-----------\n";
#else
    #define NEW_TEST
#endif // LOCAL

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAX = (int)(5e5) + 7;
const int INF_INT = (int)(1e9) + 7;
const int MOD = (int)(1e9) + 7;
const ll INF_LL = (ll)(1e18) + 7;

template<typename T> inline void info(T & v) { for (const auto & it : v) { cout << it << ' '; } cout << '\n'; }

template<typename T1, typename T2> inline bool chkmin(T1 & a, T2 & b) { if (a > b) { a = b; return true; } return false; }

template<typename T1, typename T2> inline bool chkmax(T1 & a, T2 & b) { if (a < b) { a = b; return true; } return false; }

template<typename T> inline void init(vector<T> & a, int size_, T value = 0) { a.assign(size_, value); }

void solve();
void boot_up() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios::sync_with_stdio(false);
}


const int LOGN = 24;

int n, m, t;
vector<pair<int, int>> paths;
vector<int> gph[MAX];
vector<int> depth;
vector<int> ancestor;
int up[LOGN][MAX];

inline int dist(int v, int u);
inline int lca(int v, int u);
inline vector<int> get_path(int v, int u);
void dfs(int v, int anc, int curr_depth);

signed main() {
    boot_up();

    while (cin >> n >> m >> t) {
        solve();
    }
}

void solve() {
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;

        gph[v].emplace_back(u);
        gph[u].emplace_back(v);
    }

    paths.reserve(m);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;

        paths.emplace_back(v, u);
    }


    init(depth, n + 1);
    init(ancestor, n + 1);
    dfs(1, 1, 0);

    vector<int> ans(n + 1);
    for (const auto & [v, u] : paths) {
        if (ans[v] == 1 && ans[u] == 1) {
            cout << -1 << '\n';
            return;
        }

        vector<int> path;

        if (ans[v] <= 1) {
            path = get_path(v, u);
        }
        else {
            path = get_path(u, v);
        }

        int curr = 1;
        for (const auto & vert : path) {
            ans[vert] = curr++;
        }
    }

    for (int i = 1; i <= n; ++i) {
        if (!ans[i]) {
            ans[i] = 1;
        }
    }
 
    cout << *max_element(all(ans)) << '\n';
    for (int i = 1; i <= n; ++i) {
        cout << ans[i] << ' ';
    }
    cout << '\n';
}

inline int dist(int v, int u) {
    return depth[u] + depth[v] - 2 * depth[lca(v, u)];
}

void dfs(int v, int anc, int curr_depth) {
    depth[v] = curr_depth;
    ancestor[v] = anc;

    up[0][v] = (anc == -1 ? 1 : anc);
    for (int k = 1; k < LOGN; ++k) {
        up[k][v] = up[k - 1][up[k - 1][v]];
    }

    for (const auto & u : gph[v]) {
        if (u != anc) {
            dfs(u, v, curr_depth + 1);
        }
    }
}

inline int lca(int v, int u) {
    if (depth[v] < depth[u]) {
        swap(v, u);
    }

    for (int k = LOGN - 1; k >= 0; --k) {
        if (depth[up[k][v]] >= depth[u]) {
            v = up[k][v];
        }
    }

    if (u == v) {
        return u;
    }

    for (int k = LOGN - 1; k >= 0; --k) {
        if  (up[k][v] != up[k][u]) {
            v = up[k][v];
            u = up[k][u];
        }
    }

    return up[0][v];
}

inline vector<int> get_path(int v, int u) {
    int _lca = lca(v, u);
    vector<int> path;

    for (int vert = v; vert != _lca; vert = ancestor[vert]) {
        path.emplace_back(vert);
    }
    path.emplace_back(_lca);

    vector<int> rev_path;
    for (int vert = u; vert != _lca; vert = ancestor[vert]) {
        rev_path.emplace_back(vert);
    }

    reverse(all(rev_path));
    for (const auto & it : rev_path) {
        path.emplace_back(it);
    }

    for (int i = 0; i < len(path) - 1; ++i) {
        assert(path[i] != path[i + 1]);
    }

    return path;
}