#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(a) a.begin(), a.end()

template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;}
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;}

struct event{
	int a, b;
	event() {}
};

const int MAXN = 5e5 + 10;

int n, m, t;
vector<int> g[MAXN];
vector<event> have;

void read() {
	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	have.resize(m);
	for (auto &i : have) {
		cin >> i.a >> i.b;
		i.a--;
		i.b--;
	}
}

const int INF = 1e9 + 10;

int ans;
vector<int> fans;

bool check_group_1_2() {
	return n <= 15 && m <= 15;
}

vector<int> c;
vector<vector<int>> path;

void colored(int ind, int type) {
	if (type == 0) {
		for (int i = 1; i < path[ind].size(); i++) {
			chkmax(c[path[ind][i]], c[path[ind][i - 1]] + 1);
		}
	}
	else {
		for (int i = path[ind].size() - 2; i >= 0; i--) {
			chkmax(c[path[ind][i]], c[path[ind][i + 1]] + 1);
		}
	}
}

bool check(int ind, int type) {
	if (type == 0) {
		for (int i = 1; i < path[ind].size(); i++) {
			if (c[path[ind][i]] <= c[path[ind][i - 1]]) return false;
		}
	}
	else {
		for (int i = path[ind].size() - 2; i >= 0; i--) {
			if (c[path[ind][i]] <= c[path[ind][i + 1]]) return false;
		}
	}
	return true;
}

vector<int> calc(int mask) {
	c.assign(n, 1);
	for (int i = 0; i < m; i++) {
		colored(i, (mask >> i) & 1);
	}
	for (int i = 0; i < m; i++) {
		if (!check(i, (mask >> i) & 1)) {
			c.assign(n, INF);
			return c;
		}
	}
	return c;

}

vector<int> now;
bool flag = false;

void dfs(int v, int p, int need) {
	now.push_back(v);
	if (v == need) {
		flag = true;
		return;
	}
	for (auto i : g[v]) {
		if (i == p) continue;
		if (flag) return;
		dfs(i, v, need);
		if (flag) return;
	}
	now.pop_back();
}

vector<int> make_path(int a, int b) {
	flag = false;
	now.clear();
	dfs(a, -1, b);
	return now;
}

void make_path() {
	path.clear();
	for (auto i : have) {
		path.push_back(make_path(i.a, i.b));
	}
}

void solve_group_1_2() {
	ans = INF;
	make_path();
	/*cout << "path = " << endl;
	for (auto i : path) {
		cout << "now = ";
		for (auto j : i) {
			cout << j << " ";
		}
		cout << endl;
	}
	cout << "end" << endl;*/
	fans = {};
	for (int i = 0; i < (1 << m); i++) {
		vector<int> have = calc(i);
		int my_ans = 0;
		for (auto j : have) chkmax(my_ans, j);
		if (my_ans < ans) {
			ans = my_ans;
			fans = have;
		}
	}
	if (ans == INF) {
		cout << -1 << endl;
		exit(0);
	}
}

void run() {
	if (check_group_1_2()) solve_group_1_2();
}

void write() {
	cout << ans << endl;
	for (auto i : fans) {
		cout << i << " ";
	}
	cout << endl;
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}