//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("sse,sse2,sse3,popcnt,tune=native")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define db(x) cout << #x << " = " << x << "  ";

const ld pi = acos(-1);
const ld eps = 1e-9;

class Point
{
    friend istream &operator>>(istream &in, Point &p)
    {
        in >> p.x >> p.y;
        return in;
    }
    friend ostream &operator<<(ostream &out, Point p)
    {
        out << p.x << " " << p.y;
        return out;
    }
public:
    ld x, y;
    Point(ld x1 = 0, ld y1 = 0)
    {
        x = x1;
        y = y1;
    }
    Point operator+(Point a)
    {
        return Point(x + a.x, y + a.y);
    }
    Point operator-(Point a)
    {
        return Point(x - a.x, y - a.y);
    }
    Point operator*(ld a)
    {
        return Point(x * a, y * a);
    }
    Point operator/(ld a)
    {
        return Point(x / a, y / a);
    }
    ld operator*(Point a)
    {
        return x * a.y - y * a.x;
    }
    ld operator%(Point a)
    {
        return x * a.x + y * a.y;
    }
    bool operator==(Point a)
    {
        return (abs(x - a.x) < eps && abs(y - a.y) < eps);
    }
    bool operator<(const Point a) const
    {
        if (x < a.x)
            return true;
        if (x > a.x)
            return false;
        if (y < a.y)
            return true;
        if (y > a.y)
            return false;
        return false;
    }
};

void fast()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

vector<vector<ll> > g;
vector<ll> tin;
vector<ll> tout;
ll T = 0;

vector<vector<ll> > up;
vector<ll> h;

void dfs(ll v, ll pr = -1, ll ha = 0)
{
    tin[v] = T++;
    up[v][0] = pr;
    h[v] = ha;
    for (int i = 0; i < g[v].size(); i++)
    {
        ll to = g[v][i];
        if (to == pr)
            continue;
        dfs(to, v, ha + 1);
    }
    for (int i = 1; i < 24; i++)
    {
        ll to1 = up[v][i - 1];
        if (to1 == -1)
            continue;
        up[v][i] = up[to1][i - 1];
    }
    tout[v] = T++;
}

bool pre(ll v, ll to)
{
    if (tin[v] < tin[to] && tout[v] > tout[to])
        return true;
    return false;
}

ll lca(ll v, ll to)
{
    if (v == to)
        return v;
    if (pre(v, to))
        return v;
    if (pre(to, v))
        return to;
    for (int i = 23; i >= 0; i--)
    {
        ll v1 = up[v][i];
        if (v1 == -1)
            continue;
        if (pre(v1, to))
            continue;
        v = v1;
    }
    return up[v][0];
}

vector<ll> c;

ll X;

void go(ll v, ll z)
{
    c[v] = X++;
    while (v != z)
    {
        v = up[v][0];
        c[v] = X++;
    }
}

void go1(ll ce, ll to, ll X1)
{
    c[to] = X1--;
    while (ce != to)
    {
        to = up[to][0];
        c[to] = X1--;
    }
}

int main()
{
    ll n, m, t;
    cin >> n >> m >> t;
    h.resize(n);
    up.resize(n, vector<ll> (24, -1));
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    for (int i = 1; i < n; i++)
    {
        ll a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(0);
    vector<pair<ll, ll> > ma;
    ma.resize(m);
    for (int i = 0; i < m; i++)
    {
        cin >> ma[i].first >> ma[i].second;
        ma[i].first--;
        ma[i].second--;
    }
    c.resize(n, 1);
    for (int i = 0; i < m; i++)
    {
        ll v = ma[i].first;
        ll to = ma[i].second;
        ll ce = lca(v, to);
        X = 1;
        go(v, ce);
        ll del = h[to] - h[ce];
        ll X1 = X + del - 1;
        go1(ce, to, X1);
    }
    ll mx = *max_element(all(c));
    cout << mx << "\n";
    for (int i = 0; i < n; i++)
        cout << c[i] << " ";
}
