#include <iostream>
#include <cstring>
#include <vector>
#include <map>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

bool used[MAXN + 5];
map< pair<int, int>, bool> M;
vector<int> G[MAXN + 5];
vector<int> G1[MAXN + 5], G2[MAXN + 5];
int top_sort[MAXN + 5], c[MAXN + 5];

bool DFS(int u, int v)
{
    if (u == v) return true;
    used[u] = true;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        if (!used[G[u][i]])
        {
            if (DFS(G[u][i], v))
            {
                if (M[make_pair(G[u][i], u)])
                {
                    cout << -1 << endl;
                    exit(0);
                }
                else
                {
                    M[make_pair(u, G[u][i])] = true;
                    G1[G[u][i]].push_back(u);
                    G2[u].push_back(G[u][i]);
                }
                return true;
            }
        }
    }
    return false;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m, t;
    cin >> n >> m >> t;

    int u, v;
    for (int i = 1; i < n; ++ i)
    {
        cin >> u >> v;
        G[u].push_back(v);
        G[v].push_back(u);
    }

    for (int i = 0; i < m; ++ i)
    {
        cin >> u >> v;
        DFS(u, v);
        memset(used, false, sizeof(used));
    }

    int k = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (G1[i].size() == 0)
        {
            c[i] = 1;
            used[i] = true;
            top_sort[k++] = i;
        }
    }

    int ans = 0;
    for (int i = 0; i < k; ++ i)
    {
        for (int j = 0; j < G2[top_sort[i]].size(); ++ j)
        {
            if (!used[G2[top_sort[i]][j]])
            {
                used[G2[top_sort[i]][j]] = true;
                top_sort[k++] = G2[top_sort[i]][j];
                c[G2[top_sort[i]][j]] = c[top_sort[i]] + 1;
                ans = max(ans, c[G2[top_sort[i]][j]]);
            }
        }
    }

    cout << ans << endl;
    for (int i = 1; i <= n; ++ i)
        cout << c[i] << " ";
    cout << endl;

    return 0;
}
