#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>
using namespace std;

const int LOG = 20;
int it = 0;
vector<int> h, tin, tout;
vector<vector<int> > g, pr;

void dfs(int v, int P = -1){
    tin[v] = it++;
    if(P==-1)
        pr[0][v] = v;
    else
        pr[0][v] = P;
    for(int i = 0; i<g[v].size(); i++){
        if(g[v][i]==P)
            continue;
        h[g[v][i]] = h[v]+1;
        dfs(g[v][i], v);
    }
    tout[v] = it++;
}

bool up(int a, int b){
    return (tin[a]<=tin[b]&&tout[b]<=tout[a]);
}

int lca(int a, int b){
    if(up(a, b))
        return a;
    if(up(b, a))
        return b;
    for(int i = LOG-1; i>=0; i--){
        if(up(pr[i][a], b))
            continue;
        a = pr[i][a];
    }
    return pr[0][a];
}

int len(int a, int b){
    return h[a]+h[b]-2*h[lca(a, b)];
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, t;
    cin >> n >> m >> t;
    g.resize(n);
    h.resize(n);
    tin.resize(n);
    tout.resize(n);
    pr.resize(LOG, vector<int>(n));
    for(int i = 1; i<n; i++){
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    h[0] = 0;
    dfs(0);
    for(int i = 1; i<LOG; i++)
        for(int j = 0; j<n; j++)
            pr[i][j] = pr[i-1][pr[i-1][j]];
    vector<int> c(n, -1);
    vector<pair<int, int> > jij(m);
    for(int i = 0; i<m; i++){
        cin >> jij[i].first >> jij[i].second;
        jij[i].first--;
        jij[i].second--;
    }
    sort(jij.begin(), jij.end(), [&](pair<int, int> a, pair<int, int> b)->bool{return len(a.first, a.second)>len(b.first, b.second);});
    vector<bool> u(m);
    for(int i = 0; i<m; i++){
        if(u[i])
            continue;
        //cout << jij[i].first << ':' << jij[i].second << endl;
        //cout << len(jij[i].second, jij[i].second) << "FDSFDSF" << endl;
        u[i] = true;
        int it = 1, ln = len(jij[i].first, jij[i].second);
        //cout << i << endl;
        for(int v = jij[i].first;;){
            //cout << v << ' ' << lca(v, jij[i].second) << ' ' << len(v, jij[i].second) << endl;
            //cout << v << '/' << jij[i].second << ':' << ln << endl;
            c[v] = it++;
            if(v==jij[i].second)
                break;
            for(int j = 0; j<g[v].size(); j++){
                int k = len(g[v][j], jij[i].second);
                //cout << '[' << g[v][i] << ';' << jij[i].second << ']' << " = " << k << endl;
                //cout << v << "->" << g[v][i] << ' ' << k << '/' << ln << endl;
                if(k<ln){
                    ln = k;
                    v = g[v][j];
                    break;
                }
            }
        }
        int lc = lca(jij[i].first, jij[i].second);
        while(true){
            bool kek = true;
            for(int j = i+1; j<m; j++){
                if(u[j])
                    continue;
                int lc1 = lca(jij[j].first, jij[j].second);
                if(up(lc, lc1)){
                    //cout << up(lc1, jij[i].first) << endl;
                    if(!up(lc1, jij[i].first)&&!up(lc1, jij[i].second))
                        continue;
                }
                else if(up(lc1, lc)){
                    if(!up(lc, jij[j].first)&&!up(lc, jij[j].second))
                        continue;
                }
                else
                    continue;
                kek = false;
                u[j] = true;
                int dl = 0;
                int ln = len(lc1, jij[j].first);
                for(int i = 0; i<g[lc1].size(); i++){
                    int k = len(g[lc1][i], jij[j].first);
                    if(ln>k){
                        if(c[g[lc1][i]]!=-1){
                            if(c[g[lc1][i]]<c[lc1])
                                dl = 1;
                            else
                                dl = -1;
                            break;
                        }
                    }
                }
                ln = len(lc1, jij[j].second);
                int dl1 = 0;
                for(int i = 0; i<g[lc1].size(); i++){
                    int k = len(g[lc1][i], jij[j].second);
                    if(ln>k){
                        if(c[g[lc1][i]]!=-1){
                            if(c[g[lc1][i]]>c[lc1])
                                dl1 = 1;
                            else
                                dl1 = -1;
                            break;
                        }
                    }
                }
                //cout << jij[j].first << ':' << jij[j].second << ' ' << dl << ':' << dl1 << endl;
                if(dl!=0&&dl1!=0&&dl!=dl1){
                    cout << -1;
                    return 0;
                }
                if(dl==0)
                    dl = dl1;
                if(dl==0)
                    dl = 1;
                int it = c[lc1]-dl*len(lc1, jij[j].first);
                ln = len(jij[j].first, jij[j].second);
                for(int v = jij[j].first;;){
                    c[v] = it;
                    if(v==jij[j].second)
                        break;
                    it += dl;
                    for(int i = 0; i<g[v].size(); i++){
                        int k = len(g[v][i], jij[j].second);
                        if(ln>k){
                            v = g[v][i];
                            ln = k;
                            break;
                        }
                    }
                }
            }
            if(kek)
                break;
        }
    }
    int mx = 1;
    for(int i = 0; i<n; i++)
        mx = max(mx, c[i]);
    cout << mx << '\n';
    for(int i = 0; i<n; i++){
        if(c[i]==-1)
            c[i] = 1;
        cout << c[i] << ' ';
    }

    return 0;
}
