#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << ' ' << x << endl

using namespace std;

int n, m, t;
vector<vector<int>> adjList;

vector<vector<int>> requirementsList;
vector<vector<int>> requirementsMatrix;
vector<int> parents;

void dfs(int node, int parent = -1) {
    parents[node] = parent;
    for (int adjNode : adjList[node]) {
        if (adjNode != parent) {
            dfs(adjNode, node);
        }
    }
}

vector<int> costs;

int getCost(int node) {
    if (costs[node] != -1) {
        return costs[node];
    }
    int cost = 0;
    for (int adjNode : requirementsList[node]) {
        cost = max(cost, getCost(adjNode));
    }
    return costs[node] = cost + 1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m >> t;
    adjList.resize(n + 1);
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        adjList[u].emplace_back(v);
        adjList[v].emplace_back(u);
    }

    requirementsList.resize(n + 1);
    requirementsMatrix.resize(n + 1, vector<int>(n + 1, 0));
    parents.resize(n + 1);
    for (int i = 1; i <= m; i++) {
        int u, v;
        cin >> u >> v;
        dfs(u);
        vector<int> path;
        int currNode = v;
        while (currNode != -1) {
            path.emplace_back(currNode);
            currNode = parents[currNode];
        }
        reverse(path.begin(), path.end());
        for (int j = 1; j < (int)path.size(); j++) {
            requirementsList[path[j]].emplace_back(path[j - 1]);
            requirementsMatrix[path[j]][path[j - 1]] = 1;
        }
    }

    bool ok = true;
    for (int i = 1; i <= n; i++) {
        for (int j = i + 1; j <= n; j++) {
            if (requirementsMatrix[i][j] && requirementsMatrix[j][i]) {
                ok = false;
                break;
            }
        }
        if (!ok) {
            break;
        }
    }

    if (!ok) {
        cout << -1 << endl;
        return EXIT_SUCCESS;
    }

    costs.resize(n + 1, -1);
    for (int i = 1; i <= n; i++) {
        if (costs[i] == -1) {
            getCost(i);
        }
    }

    cout << (*max_element(costs.begin(), costs.end())) << endl;
    for (int i = 1; i <= n; i++) {
        cout << costs[i] << " \n"[i == n];
    }

    return EXIT_SUCCESS;
}
