#include <iostream>
#include <vector>
#include <algorithm>

#define int long long

using namespace std;

struct hashs{
    int p;
    int MOD;
    vector<int> pw;
    vector<int> h;

    void init(string &s, int _p, int _MOD){
        p = _p;
        MOD = _MOD;
        int n = s.size();
        h.resize(n + 1);
        pw.resize(n + 1);
        pw[0] = 1;
        for (int i = 0; i < n; i++){
            pw[i + 1] = (pw[i] * p) % MOD;
            h[i + 1] = (h[i] * p + s[i]) % MOD;
        }
    }

    int mod(int a){
        a = a % MOD;
        if (a < 0){
            a += MOD;
        }
        return a;
    }

    int gethash(int l, int r){
        int ost = h[l] * pw[r - l] % MOD;
        return mod(h[r] - ost);
    }

};

bool is_equal(int l1, int r1, hashs h1, int l2, int r2, hashs h2){
    int res1 = h1.gethash(l1, r1);
    int res2 = h2.gethash(l2, r2);
    return res1 == res2;
}

int main1(int n, string & s){
    hashs h;
    h.init(s, 57, 2286661337);
    reverse(s.begin(), s.end());
    hashs hr;
    hr.init(s, 57, 2286661337);
    reverse(s.begin(), s.end());
    int ans = 0;
    for (int i = 0; i < n; i++){
        for (int j = i + 2; j < n; j+=2){
            int l = (j - i) / 2;
            if (i - l < 0 || j + l >= n){
                break;
            }
            if (is_equal(i - l + 1, i + l + 1, h, n - i - 1 - l, n - i - 1 + l, hr) && is_equal(j - l + 1, j + l + 1, h, n - j - 1 - l, n - j - 1 + l, hr) ){
                ans++;
            }
        }
        for (int j = i + 1; j < n; j+=2){
            int l = (j - i) / 2;
            if (i - l < 0 || j + l >= n){
                break;
            }
            if (is_equal(i - l, i + l + 1, h, n - i - 1 - l, n - i - 1 + l + 1, hr) && is_equal(j - l, j + l + 1, h, n - j - 1 - l, n - j - 1 + l + 1, hr) ){
                ans++;
            }
        }
    }
    return ans;
}

int main2(int n, string & s){
    hashs h;
    h.init(s, 57, 2286661337);
    reverse(s.begin(), s.end());
    hashs hr;
    hr.init(s, 57, 2286661337);
    reverse(s.begin(), s.end());
    //cout << "hashs\n";
    vector<int> ch(n - 1);
    vector<int> nc(n);
    for (int i = 0; i < n; i++){
        int l = 0;
        int r = min(i, n - i - 1);
        if (is_equal(i - r, i + 1, h, n - i - r - 1, n - i, hr)){
            nc[i] = r;
        }else{
            while (r - l > 1){
                int m = (r + l) / 2;
                if (is_equal(i - m, i + 1, h, n - i - m - 1, n - i, hr)){
                    l = m;
                }else{
                    r = m;
                }
            }
        }
    }
    for (int i = 0; i < n - 1; i++){
        int l = 0;
        int r = min(i + 1, n - i - 1);
        if (is_equal(i - r + 1, i + 1, h, n - i - r - 1, n - i - 1, hr)){
            ch[i] = r;
        }else{
            while (r - l > 1){
                int m = (r + l) / 2;
                if (is_equal(i - m + 1, i + 1, h, n - i - m - 1, n - i - 1, hr)){
                    l = m;
                }else{
                    r = m;
                }
            }
            ch[i] = l;
        }
    }
    int ans = 0;
    for (int i = 0; i < n; i++){
        for (int j = 0; j <= nc[i] && i + 2 * j + 1 < n; j++){
            ans += nc[i + 2 * j + 1] >= j;
        }
    }
    for (int i = 0; i < n - 1; i++){
        for (int j = 1; j <= ch[i] && i + 2 * j < n - 1; j++){
            ans += ch[i + 2 * j] >= j;
        }
    }

    return ans;
}

signed main()
{
    freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    string s;
    cin >> s;
    cout << main1(n, s) << endl;
    return 0;
}
