#ifdef _DEV
#define DEV 1
#else
#define DEV 0
#endif
#define $ if (DEV)

#include <iostream>
#include <set>
//#include <map>
#include <vector>
//#include <unordered_set>
//#include <unordered_map>
//#include <cmath>
#include <algorithm>
#include <cstdio>
#include <cassert>
//#include <cstdlib>
//#include <queue>
//#include <utility>

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

void _tmain(int test_id);

int main() {
    int test_count;
    if (DEV) {
        test_count = 100;
        assert(freopen("input.txt", "r", stdin));
    } else {
        // freopen("input.txt", "r", stdin);
        // freopen("output.txt", "w", stdout);
        test_count = 1;
        ios::sync_with_stdio(false);
        cin.tie(nullptr);
    }
    for (int t = 0; t < test_count; ++t) {
        $ printf("--- TEST CASE %d ---\n", t);
        _tmain(t);
        int ch = -1;
        while (DEV) {
            ch = fgetc(stdin);
            if (ch == -1 || !isspace(ch)) { break; }
        }
        if (ch == -1) { break; }
        ungetc(ch, stdin);
    }
    return 0;
}

size_t const ALLOC_MEM_CNT = 216 * 1024 * 1024;
char ALLOC_MEM[ALLOC_MEM_CNT];
size_t ALLOC_POS = ALLOC_MEM_CNT;

using ll = long long;
#define all(c) c.begin(),c.end()

int n;
vector<vector<int>> g;
vector<pair<int, int>> p;
vector<int> find_path_stack;

void find_path(int v, int target, int p, vector<int> &out) {
    find_path_stack.push_back(v);
    if (v == target) {
        out = find_path_stack;
    }
    for (int w : g[v]) {
        if (w == p) { continue; }
        find_path(w, target, v, out);
    }
    find_path_stack.pop_back();
}

vector<vector<int>> zone_data;
vector<int> topsort;
vector<bool> used;
void dfs(int v) {
    used[v] = true;
    for (int w : zone_data[v]) {
        if (!used[w]) {
            dfs(w);
        }
    }
    topsort.push_back(v);
}
// using xll = __int128;
void _tmain([[maybe_unused]] int test_id) {
    $ {
        g.clear();
        p.clear();
    }
    int t, m;
    cin >> n >> m >> t;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        p.emplace_back(u, v);
    }

    vector<vector<int>> paths;
    for (int i = 0; i < m; ++i) {
        paths.emplace_back();
        find_path(p[i].first, p[i].second, -1, paths.back());
        $ printf("found path: ");
        $ for (int x : paths.back()) {
                printf("%d ", x);
            }
        $ printf("\n");
    }

    set<pair<int, int>> enabled_edges;
    for (int i = 0; i < m; ++i) {
        bool must_rev = false;
        for (int j = 0; j + 1 < paths[i].size(); ++j) {
            auto e = make_pair(paths[i][j + 1], paths[i][j]);
            if (enabled_edges.count(e)) {
                must_rev = true;
                break;
            }
        }
        if (must_rev) {
            reverse(all(paths[i]));
        }

        for (int j = 0; j + 1 < paths[i].size(); ++j) {
            auto e = make_pair(paths[i][j + 1], paths[i][j]);
            if (enabled_edges.count(e)) {
                cout << "-1\n";
                return;
            }
            enabled_edges.emplace(paths[i][j], paths[i][j + 1]);
        }
    }
    $ printf("succ\n");
    zone_data.clear();
    zone_data.resize(n);
    for (auto[u, v] : enabled_edges) {
        zone_data[u].push_back(v);
    }
    topsort.clear();
    used.clear();
    used.resize(n);
    for (int v = 0; v < n; ++v) {
        if (!used[v]) {
            dfs(v);
        }
    }
    vector<int> ans(n);
    for (int v : topsort) {
        int res = 0;
        for (int w: zone_data[v]) {
            res = max(res, ans[w]);
        }
        ans[v] = res + 1;
    }
    cout << *max_element(all(ans)) << "\n";
    for (auto x : ans) {
        cout << x << " ";
    }
    cout << "\n";
}