#define _CRT_SECURE_NO_WARNINGS
#define pb push_back

#include <iostream>
#include <cstdio>
#include <iomanip>
#include <cassert>

#include <algorithm>
#include <functional>

#include <cmath>
#include <climits>

#include <vector>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <string>
#include <bitset>
#include <unordered_map>
#include <stack>
#include <cctype>

using namespace std;

#define int long long
typedef long long ll;
typedef pair<int, int> pii;

const int N = 5005;

set<int> path[N];
vector<int> g[N];
int c[N];
int n, m, t;

void go(int v, int p, set<int> colors) {
	c[v] = c[p] + 1;
	for (auto& to : g[v]) {
		if (to == p) continue;
		for (auto& j : colors) {
			if (path[to].find(j) != path[to].end()) {
				go(to, v, colors);
			}
		}
	}
}

void dfs(int v, int p) {
	c[v] = 1;
	map<int, bool> colors;
	set<int> ce;
	for (auto& to : g[v]) {
		if (to == p) continue;
		bool kk = 1;
		for (auto& j : path[to]) {
			if (colors[j]) {
				ce.insert(j);
				kk = 0;
			}
		}
		if (kk) {
			if (!c[to]) dfs(to, v);
			c[v] = max(c[v], c[to] + 1);
			for (auto& j : path[to]) {
				colors[j] = true;
			}
		}
	}


	for (auto& to : g[v]) {
		if (to == p) continue;
		for (auto& j : path[to]) {
			if (ce.find(j) != ce.end()) {
				go(to, v, ce);
			}
		}
	}
}
int sz = 1;
bool make_paths(int v, int p, int nx) {
	if (v == nx) {
		path[v].insert(sz);
		c[v] = 1;
		return 1;
	}
	bool ok = 0;
	for (auto& to : g[v]) {
		if (to == p) continue;
		bool res = make_paths(to, v, nx);
		ok |= res;
		if (res) c[v] = max(c[to] + 1, c[v]);
	}
	if (ok) {
		path[v].insert(sz);
	}
	return ok;
}
bool check_if_ok() {
	for (int i = 1; i <= n; ++i) {
		map<int, int> colors;
		for (auto& to : g[i]) {
			for (auto& j : path[to]) {
				colors[j]++;
			}
		}
		int cnt = 0;
		for (auto j : colors) {
			if (j.second >= 2) cnt++;
		}
		if (cnt >= 3) {
			cout << -1;
			exit(0);
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	freopen("input.txt", "r", stdin);


	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; ++i) {
		int x, y;
		cin >> x >> y;
		g[x].pb(y);
		g[y].pb(x);
	}
	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		make_paths(x, 0, y);
		sz++;
	}
	check_if_ok();
	//dfs(1, 0);
	for (int i = 1; i <= n; ++i) {
		cout << c[i] << ' ';
	}
}