#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(int &a, const int &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(int &a, const int &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 5e5 + 228;
const int lg = 20;
int n, m, t;
vector<vector<int> > g, children;
int tin[mx], tout[mx], timer, p[mx], up[mx][lg], h[mx];

void hang(int v, int pv) {
	tin[v] = timer++;
	up[v][0] = p[v] = pv;
	for (int i = 1; i < lg; ++i) {
		up[v][i] = up[up[v][i - 1]][i - 1];
	}
	for (auto v1 : g[v]) {
		if (v1 != pv) {
			children[v].push_back(v1);
			h[v1] = h[v] + 1;
			hang(v1, v);
		}
	}
	tout[v] = timer - 1;
}

int upper(int u, int v) {
	return (tin[u] <= tin[v] && tout[v] <= tout[u]);
}

int lca(int u, int v) {
	if (upper(u, v)) return u;
	if (upper(v, u)) return v;
	for (int i = lg - 1; i >= 0; --i) {
		if (!upper(up[u][i], v)) {
			u = up[u][i];
		}
	}
	return up[u][0];
}

int la(int u, int k) {
	for (int i = lg - 1; i >= 0; --i) {
		if (k >= (1 << i)) {
			u = up[u][i];
			k -= (1 << i);
		}
	}
	return u;
}

vector<vector<pair<int, int> > > gg;

void add_gg_edge(int u, int v, int sign) {
	// cerr << "add_gg_edge " << u << " " << v << " " << sign << endl;
	gg[u].emplace_back(v, sign);
	gg[v].emplace_back(u, sign);
}

int same_cmp[mx], clr[mx], cmp[mx];

void process_vertical(int u, int v) {
	if (u == v) {
		return;
	}
	int cur = u;
	// cerr << cur << " " << v << endl;
	while (p[cur] != v) {
		// if (same_cmp[cur]) {
		// 	break;
		// }
		same_cmp[cur] = 1;
		add_gg_edge(cur, p[cur], 1);
		cur = p[cur];
	}
	cur = u;
	while (cur != v) {
		// if (cmp[cur] == -1) {
		// 	break;
		// }
		cmp[cur] = -1;
		cur = p[cur];
	}
}

void process(int u, int v) {
	int e = lca(u, v);
	process_vertical(u, e);
	process_vertical(v, e);
	if (u != e && v != e) {
		u = la(u, h[u] - h[e] - 1);
		v = la(v, h[v] - h[e] - 1);
		add_gg_edge(u, v, -1);
	}
}

int used[mx], cmp_ptr;

int ggfs(int v) {
	cmp[v] = cmp_ptr;
	used[v] = 1;
	for (auto pp : gg[v]) {
		int v1 = pp.first;
		if (used[v1] == 0) {
			clr[v1] = clr[v] * pp.second;
			if (ggfs(v1)) {
				return 1;
			}
		} else {
			if (clr[v1] != clr[v] * pp.second) {
				return 1;
			}
		}
	}
	return 0;
}

int sum[mx];

void sum_dfs(int v) {
	for (auto v1 : children[v]) {
		sum[v1] = sum[v] + clr[v1];
		sum_dfs(v1);
	}
}

signed main() {
	fast_io();
	cin >> n >> m >> t;
	g.resize(n);
	children.resize(n);
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	hang(0, 0);
	fill(cmp, cmp + n, -2);
	gg.resize(n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		process(u, v);
	}
	for (int i = 0; i < n; ++i) {
		if (cmp[i] != -2) {
			clr[i] = 1;
			if (ggfs(i)) {
				cout << -1 << endl;
				exit(0);
			}
			cmp_ptr++;
		}
	}
	sum_dfs(0);
	int val = (*min_element(sum, sum + n));
	for (int i = 0; i < n; ++i) {
		sum[i] -= val;
	}
	int k = (*max_element(sum, sum + n));
	cout << k + 1 << endl;
	for (int i = 0; i < n; ++i) {
		cout << sum[i] + 1 << " ";
	}
	cout << endl;
}
