#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;

#define size(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()

const ll P = 31;
const ll MOD = 1e9 + 7;
const ll INF = 100 + 1;

void bye() {
    cout << "\n";
    exit(0);
}

struct Solution {

    int n, m, t;

    bool BAD = 0;
    vector<vector<int> > path;
    vector<vector<int> > g;
    vector<vector<int> > gp;
    vector<int> used;
    vector<int> ord;
    vector<int> dp;
    vector<int> nowpath;

    void dfs(int id, int t, int v, int p = -1) {
        nowpath.push_back(v);
        if (v == t) {
            for (auto u : nowpath) {
                path[id].push_back(u);
            }
            return;
        }
        for (auto to : g[v]) {
            if (to != p) {
                dfs(id, t, to, v);
            }
        }
        nowpath.pop_back();
    }

    void top_sort(int v) {
        used[v] = 1;
        for (auto to : gp[v]) {
            if (!used[to]) {
                top_sort(to);
            } else if (used[to] == 1) {
                BAD = 1;
            }
        }
        used[v] = 2;
        ord.push_back(v);
    }

    int get_ans(int mask) {
        for (int i = 0; i < n; i++) {
            gp[i].clear();
        }
        fill(all(dp), INF);
        for (int i = 0; i < m; i++) {
            if (mask & (1 << i)) {
                for (int ind = 0; ind < size(path[i]) - 1; ind++) {
                    gp[path[i][ind]].push_back(path[i][ind + 1]);
                }
            } else {
                for (int ind = size(path[i]) - 1; ind > 0; ind--) {
                    gp[path[i][ind]].push_back(path[i][ind - 1]);
                }
            }
        }
        fill(all(used), 0);
        ord.clear();
        BAD = 0;
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                top_sort(i);
            }
        }
        if (BAD) {
            return INF;
        }
        for (auto v : ord) {
            dp[v] = 1;
            for (auto to : gp[v]) {
                dp[v] = max(dp[v], dp[to] + 1);
            }
        }
        return *max_element(all(dp));
    }

    void solve() {
        cin >> n >> m >> t;
        g.resize(n);
        path.resize(m);
        gp.resize(n);
        dp.resize(n);
        used.resize(n);
        for (int i = 1; i < n; i++) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            g[u].push_back(v);
            g[v].push_back(u);
        }
        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;
            --u, --v;
            nowpath.clear();
            dfs(i, v, u);
        }
        int optmask = -1;
        int ans = INF;
        for (int mask = 0; mask < (1 << m); mask++) {
            int now = get_ans(mask);
            if (now < ans) {
                ans = now;
                optmask = mask;
            }
        }
        if (ans == INF) {
            cout << -1;
            return;
        }
        cout << ans << "\n";
        get_ans(optmask);
        for (auto v : dp) {
            cout << v << " ";
        }
    }
};

signed main() {
    #ifdef _TIM
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // _TIM
    ll TEST_COUNT = 1;
//    cin >> TEST_COUNT;
    while (TEST_COUNT--) {
        Solution now;
        now.solve();
    }
    bye();
}
