#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

ll INF = (ll) 1e20;
int iINF = (int) 1e20;
ll mod = (ll) 1e9 + 7;

ll dp[20][500000];

void precalc(ll v, vector<vector<ll>> &nodes, vector<ll> &d, vector<ll> &p, ll was) {
    for (auto i : nodes[v]) {
        if (i != was) {
            d[i] = d[v] + 1;
            p[i] = v;
            precalc(i, nodes, d, p, v);
        }
    }
}

ll lca(ll a, ll b, vector<ll> &d) {
    if (d[a] < d[b])
        swap(a, b);
    for (int st = 19; st >= 0; --st) {
        if (d[dp[st][a]] >= d[b])
            a = dp[st][a];
    }
    if (a == b)
        return a;
    for (int st = 19; st >= 0; --st) {
        if (dp[st][a] != dp[st][b]) {
            a = dp[st][a], b = dp[st][b];
        }
    }
    return dp[0][a];
}

void get_dirs(ll v, ll fin, vector<ll> &dir, bool &up, bool &down) {
    if (v == fin)
        return;
    if (dir[v] == 0) {
        down = true;
    } else if (dir[v] == 1)
        up = true;
    get_dirs(dp[0][v], fin, dir, up, down);
}

void make_dir(ll v, ll fin, vector<ll> &dir, bool up, bool down) {
//    cout << v << ' ' << fin << ' ' << dp[0][v] << '\n';
    if (v == fin)
        return;
    if (up) {
        dir[v] = 1;
    } else {
        dir[v] = 0;
    }
    make_dir(dp[0][v], fin, dir, up, down);
}

void make_cost(ll v, vector <vector <ll>> &nodes, vector <ll> &dir, vector <ll> &c) {
    if(dir[v] == 1) {
        c[dp[0][v]] = max(c[dp[0][v]], c[v] + 1);
        make_cost(dp[0][v], nodes, dir, c);
    }
    for(auto i : nodes[v]) {
        if(i != dp[0][v]) {
            if(dir[i] == 0) {
                c[i] = max(c[i], c[v] + 1);
                make_cost(i, nodes, dir, c);
            }
        }
    }
}

signed main() {
    ll n, m, t;
    cin >> n >> m >> t;
    vector<vector<ll>> nodes(n);
    vector<ll> dir(n, -1); // 0 == DOWN, 1 == UP
    for (int i = 0; i < n - 1; ++i) {
        ll u, v;
        cin >> u >> v;
        nodes[u - 1].push_back(v - 1);
        nodes[v - 1].push_back(u - 1);
    }
    vector<pair<ll, ll>> v(m);
    for (int i = 0; i < m; ++i) {
        cin >> v[i].first >> v[i].second;
        --v[i].first, --v[i].second;
    }
    vector<ll> p(n, 0), d(n, 0);
    precalc(0, nodes, d, p, 0);
    for (int i = 0; i < n; ++i) {
        dp[0][i] = p[i];
    }
    for (int st = 1; st < 20; ++st) {
        for (int i = 0; i < n; ++i) {
            dp[st][i] = dp[st - 1][dp[st - 1][i]];
        }
    }
    vector<ll> lc(m);
    for (int i = 0; i < m; ++i) {
        lc[i] = lca(v[i].first, v[i].second, d);
    }
    for (int i = 0; i < m; ++i) {
        bool up1 = false, down1 = false;
        bool up2 = false, down2 = false;
        get_dirs(v[i].first, lc[i], dir, up1, down1);
        get_dirs(v[i].second, lc[i], dir, up2, down2);
//        cout << i << ' ' << v[i].first << ' ' << v[i].second << ' ' << lc[i] << ' ' << up1 << ' ' << down1 << ' ' << up2 << ' ' << down2 << '\n';
//        for(auto j : dir) {
//            cout << j << ' ';
//        }
//        cout << '\n';
        if ((up1 && down1) || (up2 && down2) || (up1 && up2) || (down1 && down2)) {
            cout << -1;
            return 0;
        }
        if (up1) {
            make_dir(v[i].first, lc[i], dir, true, false);
            make_dir(v[i].second, lc[i], dir, false, true);
        } else {
            make_dir(v[i].first, lc[i], dir, false, true);
            make_dir(v[i].second, lc[i], dir, true, false);
        }
    }
    vector<ll> c(n, 1);
    vector<ll> in(n, 0);
    for (int i = 0; i < n; ++i) {
//        cout << dir[i] << '\n';
        if(dir[i] == 0) {
            ++in[i];
        }
        else if(dir[i] == 1) {
            ++in[dp[0][i]];
        }
    }
    for(int i = 0; i < n; ++i) {
        if(in[i] == 0) {
            make_cost(i, nodes, dir, c);
        }
    }
    ll maxim = 1;
    for(auto i : c)
        maxim = max(maxim, i);
    cout << maxim << '\n';
    for(auto i : c) {
        cout << i << ' ';
    }
}