// #pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}
#define ld long double
#define left left228
#define right right228

const int N = 500 * 1000 + 228;

namespace DSU
{
	int p[2 * N], sz[2 * N];

	void init(int n) {
		for (int i = 0; i <= n; ++i) {
			p[i] = i;
			sz[i] = 1;
		}
	}
	int getp(int v) {
		if (v == p[v]) return v;
		p[v] = getp(p[v]);
		return p[v];
	}
	void join(int u, int v) {
		u = getp(u);
		v = getp(v);
		if (u != v) {
			if (sz[u] > sz[v]) swap(u, v);
			p[u] = v;
			sz[v] += sz[u];
		}
	}
};

int n, m, t;
int p[N][20];
vector<int> g[N], G[N];
vector< pair<int, int> > edges;
int tin[N], tout[N], timer = 0;

void dfs(int v, int par) {
	p[v][0] = par;
	for (int k = 1; k < 20; ++k) {
		p[v][k] = p[p[v][k - 1]][k - 1];
	}
	tin[v] = timer++;
	for (int to : g[v]) {
		if (to != par) {
			dfs(to, v);
		}
	}
	tout[v] = timer++;
}
bool anc(int u, int v) {
	return tin[u] <= tin[v] && tout[u] >= tout[v];
}
int get_lca(int u, int v) {
	if (anc(u, v)) return u;
	if (anc(v, u)) return v;
	for (int k = 19; k + 1; --k) {
		if (!anc(p[u][k], v)) u = p[u][k];
	}
	return p[u][0];
}

int color[N];
bool used_type[N], used[2 * N];

void JFS(int v) {
	used[v] = 1;
	if (v < n - 1) {
		used_type[v] = 1;
		g[edges[v].first].emplace_back(edges[v].second);
	} else {
		used_type[v - n] = 1;
		g[edges[v - n].second].emplace_back(edges[v - n].first);
	}
	for (int to : G[v]) {
		if (!used[to]) {
			JFS(to);
		}
	}
}

int DP(int v) {
	if (color[v]) return color[v];
	int mx = 0;
	for (int to : g[v]) {
		uax(mx, DP(to));
	}
	color[v] = mx + 1;
	return color[v];
}

signed main() {
	// ios_base::sync_with_stdio(false);
	// cin.tie(0);
	cin >> n >> m >> t;
	map< pair<int, int>, int> num;
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		edges.emplace_back(u, v);
		g[u].push_back(v);
		g[v].push_back(u);
		num[{u, v}] = i;
		num[{v, u}] = n + i;
	}
	dfs(1, 1);
	DSU::init(2 * n);
	for (int oao = 0; oao < m; ++oao) {
		int a, b;
		cin >> a >> b;
		int _a = a, _b = b;
		int c = get_lca(a, b);
		vector<int> v1, v2;
		while (a != c) {
			v1.push_back(a);
			a = p[a][0];
		}
		while (b != c) {
			v2.push_back(b);
			b = p[b][0];
		}
		vector<int> path;
		for (int i : v1) {
			path.emplace_back(i);
		}
		path.emplace_back(c);
		for (int i = (int)v2.size() - 1; i + 1; --i) {
			path.emplace_back(v2[i]);
		}
		vector<int> e1, e2;
		for (int i = 0; i < (int)path.size() - 1; ++i) {
			e1.push_back(num[{path[i], path[i + 1]}]);
			e2.push_back(num[{path[i + 1], path[i]}]);
		}
		for (int i = 1; i < (int)e1.size(); ++i) {
			DSU::join(e1[i], e1[i - 1]);
			G[e1[i]].emplace_back(e1[i - 1]);
			G[e1[i - 1]].emplace_back(e1[i]);
		}
		for (int i = 1; i < (int)e2.size(); ++i) {
			DSU::join(e2[i], e2[i - 1]);
			G[e2[i]].emplace_back(e2[i - 1]);
			G[e2[i - 1]].emplace_back(e2[i]);
		}
	}
	for (int i = 0; i < n - 1; ++i) {
		if (DSU::getp(i) == DSU::getp(n + i)) {
			cout << -1 << '\n';
			return  0;
		}
	}
	for (int i = 1; i <= n; ++i) {
		g[i].clear();
	}
	for (int i = 0; i < n - 1; ++i) {
		if (!used_type[i]) {
			JFS(i);
		}
	}
	int answer = 0;
	for (int i = 1; i <= n; ++i) {
		uax(answer, DP(i));
	}
	cout << answer << '\n';
	for (int i = 1; i <= n; ++i) {
		cout << color[i] << ' ';
	}
	cout << '\n';
	return 0;
}
