#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <algorithm>
#include <vector>
using namespace std;
#define fs first
#define sc second
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
const int maxn = 5e5 + 100;
const int mod = 1e9 + 7;
#define dbg(x) cout<<#x<<" "<<x<<endl; 

vector<int> g[maxn], g2[maxn], gr2[maxn];
int tin[maxn], tout[maxn], up[maxn], p[maxn], tmr = 0, tmr2 = 0, c[maxn];
bool u[maxn];

struct mintree {
	int t[maxn * 4], p[maxn * 4], n;

	void push(int v) {
		if (p[v] != 0) {
			t[v * 2] = p[v];
			t[v * 2 + 1] = p[v];
			p[v * 2] = p[v];
			p[v * 2 + 1] = p[v];
		}
		p[v] = 0;
	}

	void update(int v, int tl, int tr, int l, int r, int nv) {
		if (l > r) return;
		if (tl == l && tr == r) {
			t[v] = nv;
			p[v] = nv;
		}
		else {
			int tm = (tl + tr) / 2;
			push(v);
			update(v * 2, tl, tm, l, min(tm, r), nv);
			update(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r, nv);
			t[v] = min(t[v*2], t[v*2+1]);
		}
	}

	void update(int l, int r, int nv) {
		update(1, 0, n - 1, l, r, nv);
	}

	int mn(int v, int tl, int tr, int l, int r) {
		if (l > r) return 100;
		if (tl == l && tr == r) return t[v];
		int tm = (tl + tr) / 2;
		push(v);
		return min(mn(v * 2, tl, tm, l, min(r, tm)), mn(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r));
	}

	int mn(int l, int r) {
		return mn(1, 0, n - 1, l, r);
	}
} tmin;

struct maxtree {
	int t[maxn * 4], p[maxn * 4], n;

	void push(int v) {
		if (p[v] != 0) {
			t[v * 2] = p[v];
			t[v * 2 + 1] = p[v];
			p[v * 2] = p[v];
			p[v * 2 + 1] = p[v];
		}
		p[v] = 0;
	}

	void update(int v, int tl, int tr, int l, int r, int nv) {
		if (l > r) return;
		if (tl == l && tr == r) {
			t[v] = nv;
			p[v] = nv;
		}
		else {
			int tm = (tl + tr) / 2;
			push(v);
			update(v * 2, tl, tm, l, min(tm, r), nv);
			update(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r, nv);
			t[v] = max(t[v * 2], t[v * 2 + 1]);
		}
	}

	void update(int l, int r, int nv) {
		update(1, 0, n - 1, l, r, nv);
	}

	int mx(int v, int tl, int tr, int l, int r) {
		if (l > r) return -100;
		if (tl == l && tr == r) return t[v];
		int tm = (tl + tr) / 2;
		push(v);
		return max(mx(v * 2, tl, tm, l, min(r, tm)), mx(v * 2 + 1, tm + 1, tr, max(tm + 1, l), r));
	}

	int mx(int l, int r) {
		return mx(1, 0, n - 1, l, r);
	}
} tmax;

int dfs1(int v, int pr) {
	int sm = 1;
	p[v] = pr;
	vector<pair<int,int> > ng;
	for (int i : g[v]) {
		if (i == pr) continue;
		int cur = dfs1(i, v);
		ng.push_back({ cur, i });
		sm += cur;
	}
	sort(ng.rbegin(), ng.rend());
	g[v].clear();
	for (auto i : ng) g[v].push_back(i.sc);
	return sm;
}

void dfs2(int v, int upv) {
	tin[v] = tmr++;
	up[v] = upv;
	bool f = 1;
	for (int i : g[v]) {
		if (f) {
			dfs2(i, upv);
			f = 0;
		}
		else {
			dfs2(i, i);
		}
	}
	tout[v] = tmr2++;
}

bool upper(int a, int b) {
	return tin[a] <= tin[b] && tout[b] <= tout[a];
}

struct Z {
	int v, u, rev, mn, mx;
};

vector<int> order;

void dfs3(int v) {
	u[v] = 1;
	for (int i : g2[v])
		if (!u[i]) dfs3(i);
	order.push_back(v);
}

bool step(int a, int b) {
	int na = a, nb = b;
	vector<Z> segs, segs2;
	while (!upper(na, b)) {
		Z seg = {na, up[na], 0, 0, 0};
		na = p[up[na]];
		segs.push_back(seg);
	}
	while (!upper(nb, a)) {
		Z seg = { up[nb], nb, 0, 0, 0 };
		nb = p[up[nb]];
		segs2.push_back(seg);
	}
	int lca;
	if (upper(na, nb)) lca = nb;
	else lca = na;
	if (upper(na, nb)) {
		if (!segs.empty()) segs.back().u = g[lca][0];
	}
	else {
		if (!segs2.empty()) segs2.back().v = g[lca][0];
	}
	reverse(segs2.begin(), segs2.end());
	for (auto i : segs2) {
		segs.push_back(i);
		segs.back().rev = 1;
	}

	for (auto& i : segs) {
		if (i.v == 0) i.v = g[0][0];
		else if (i.u == 0) i.v = g[0][0];
		i.mn = tmin.mn(min(tin[i.v], tin[i.u]), max(tin[i.v], tin[i.u]));
		i.mx = tmax.mx(min(tin[i.v], tin[i.u]), max(tin[i.v], tin[i.u]));
	}

	bool np = 0, nm = 0;

	for (auto i : segs) {
		if (i.mx == 1 && !i.rev) np = 1;
		if (i.mx == 1 && i.rev) nm = 1;
		if (i.mn == -1 && !i.rev) nm = 1;
		if (i.mn == -1 && i.rev) np = 1;
	}
	if (np && nm) return 0;


	for (auto i : segs) {
		if (np ^ i.rev) {
			tmin.update(min(tin[i.v], tin[i.u]), max(tin[i.v], tin[i.u]), 1);
			tmax.update(min(tin[i.v], tin[i.u]), max(tin[i.v], tin[i.u]), 1);
		}
		else {
			tmin.update(min(tin[i.v], tin[i.u]), max(tin[i.v], tin[i.u]), -1);
			tmax.update(min(tin[i.v], tin[i.u]), max(tin[i.v], tin[i.u]), -1);
		}
	}

	return 1;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, m, t;
	cin >> n >> m >> t;
	for (int i = 0; i < n-1; ++i) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	vector<pii> tns;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		tns.push_back({ a - 1,b - 1 });
	}
	dfs1(0, 0);
	dfs2(0, 0);
	tmin.n = n;
	tmax.n = n;
	for (auto i : tns) {
		if (!step(i.fs, i.sc)) return cout << -1, 0;
	}
	for (int i = 1; i < n; ++i) {
		int mx = tmax.mx(min(tin[i], tin[i]), max(tin[i], tin[i]));
		int mn = tmin.mn(min(tin[i], tin[i]), max(tin[i], tin[i]));
		if (mx == 1) {
			g2[i].push_back(p[i]);
		}
		else if (mn == -1) {
			g2[p[i]].push_back(i);
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j : g2[i]) gr2[j].push_back(i);
	}

	for (int i = 0; i < n; ++i) {
		if (!u[i]) {
			dfs3(i);
		}
	}
	reverse(order.begin(), order.end());
	for (int i : order) {
		if (c[i] == 0) c[i] = 1;
		for (int j : g2[i]) c[j] = c[i] + 1;
	}
	int k = 0;
	for (int i = 0; i < n; ++i) k = max(k, c[i]);
	cout << k << endl;
	for (int i = 0; i < n; ++i) cout << c[i] << " ";
	
	return 0;
}