#include <bits/stdc++.h>

using namespace std;

const int MAXN = 20, INF = 1e9;

int anc[MAXN], h[MAXN];

vector<int> g[MAXN];

void dfs(int v = 0, int p = 0, int deep = 0) {
    anc[v] = p;
    h[v] = deep;
    for (auto x : g[v])
        if (x != p)
            dfs(x, v, deep + 1);
}

void build_way_from_to (vector<vector<int>> &ga, int a, int b) {
    if (a == b)
        return;
    if (h[a] > h[b]) {
        ga[a].push_back(anc[a]);
        build_way_from_to(ga, anc[a], b);
    } else {
        ga[anc[b]].push_back(b);
        build_way_from_to(ga, a, anc[b]);
    }
}

bool dfs_cycle(vector<vector<int>> &ga, vector<int> &used, int v) {
    used[v] = 1;
    bool res = false;
    for (auto x : ga[v])
        if (!used[x])
            res |= dfs_cycle(ga, used, x);
        else if (used[x] == 1)
            res = true;
    used[v] = 2;
    return res;
}

void dfs_top_sort(vector<vector<int>> &ga, vector<int> &used, vector<int> &top_sort, int v) {
    used[v] = 0;
    for (auto x : ga[v])
        if (used[x])
            dfs_top_sort(ga, used, top_sort, x);
    top_sort.push_back(v);
}

void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs();
    vector<pair<int, int>> metro(m);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        metro[i] = {a, b};
    }
    int Kmin = INF;
    vector<int> opt_dp;
    for (int mask = 0; mask < (1 << m); ++mask) {
        vector<vector<int>> ga(n);
        for (int i = 0; i < m; ++i)
            if ((1 << i) & mask)
                build_way_from_to(ga, metro[i].first, metro[i].second);
            else
                build_way_from_to(ga, metro[i].second, metro[i].first);
        vector<int> used(n);
        bool kikashka = false;
        for (int i = 0; i < n; ++i)
            if (!used[i])
                kikashka |= dfs_cycle(ga, used, i);
        if (kikashka)
            continue;
        vector<int> top_sort;
        for (int i = 0; i < n; ++i)
            if (used[i] == 2)
                dfs_top_sort(ga, used, top_sort, i);
        vector<int> dp(n, 1);
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            int maxe = 0;
            for (auto x : ga[top_sort[i]])
                if (dp[x] > maxe)
                    maxe = dp[x];
            dp[top_sort[i]] = maxe + 1;
            ans = max(ans, maxe + 1);
        }
        if (ans < Kmin) {
            opt_dp = dp;
            Kmin = ans;
        }
    }
    if (Kmin == INF)
        cout << "-1\n";
    else {
        cout << Kmin << '\n';
        for (auto x : opt_dp)
            cout << x << ' ';
        cout << '\n';
    }
}
#define DEBUGs
int main() {
    #ifdef DEBUG
        freopen("test1.cpp", "r", stdin);
    #else
        cin.tie(nullptr);
        cout.tie(nullptr);
        ios_base::sync_with_stdio(false);
    #endif // DEBUG
    solve();
    return 0;
}

