#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>

using namespace std;

const int N = 101;
vector<int> g[N];
set<int> child[N];
vector<pair<int, int>> lines;
int pre[N];
set<int> todo;
set<int> bigger[N];
map <pair <int, int>, set <int>> way;

vector<int> find_way(int a, int b) {
    vector<int> w = {a};
    while (!child[a].count(b)) {
        a = pre[a];
        w.push_back(a);
    }
    while (a != b) {
        for (int j : g[a]) {
            if (child[j].count(b) && j != pre[a]) {
                a = j;
                w.push_back(a);
                break;
            }
        }
    }
    return w;
}


void child_dfs(int v, int p = -1) {
    pre[v] = p;
    set<int> chil = {v};
    for (auto i : g[v]) {
        if (i == p)
            continue;
        child_dfs(i, v);
        for (int j : child[i])
            chil.insert(j);
    }
    child[v] = chil;
}

void way_dfs(int v, vector<bool> &used) {
    used[v] = true;
    vector<int> w = find_way(lines[v].first, lines[v].second);

    set<int> types;

    for (int i = 1; i < (int) w.size(); i++) {
        for (int j : way[{w[0], w[1]}])
            todo.insert(j);
    }

    for (int i = 1; i < (int) w.size(); i++) {
        int o = w[i - 1], p = w[i];
        if (bigger[o].count(p))
            types.insert(0);
        else if (bigger[p].count(o))
            types.insert(1);
    }

    if ((int) types.size() == 2) {
        cout << -1 << endl;
        exit(0);
    }

    for (int i = 1; i < (int) w.size(); i++) {
        int o = w[i - 1], p = w[i];
        if (types.count(0)) {
            bigger[o].insert(p);
        } else {
            bigger[p].insert(o);
        }
    }

    while (!todo.empty()) {
        int q = *todo.begin();
        todo.erase(todo.begin());
        if (!used[q]) {
            way_dfs(q, used);
        }
    }
}


void ans_dfs(int v, vector<int> &ans) {
    int mx = 0;
    for (int i : bigger[v]) {
        if (ans[i] == -1)
            ans_dfs(i, ans);
        mx = max(mx, ans[i]);
    }
    ans[v] = mx + 1;
}


int main() {
    int n, m, t;
    cin >> n >> m >> t;

    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        g[--a].push_back(--b);
        g[b].push_back(a);
    }

    child_dfs(0);

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        lines.emplace_back(--a, --b);
        auto w = find_way(a, b);
        for (int j = 0; j < (int) w.size() - 1; j++) {
            way[{w[j], w[j + 1]}].insert(i);
            way[{w[j + 1], w[j]}].insert(i);
        }
    }

    vector<bool> used(m);
    for (int i = 0; i < m; i++) {
        if (!used[i])
            way_dfs(i, used);
    }

    vector<int> ans(n, -1);
    for (int i = 0; i < n; i++) {
        if (ans[i] == -1)
            ans_dfs(i, ans);
    }

    cout << *max_element(ans.begin(), ans.end()) << endl;
    for (int i : ans)
        cout << i << " ";
    cout << endl;
    return 0;
}
