#define _CRT_SECURE_NO_WARNINGS
#define USE_MATH_DEFINES
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cassert>
#include <string>
#include <random>
#include <set>

#define pb push_back
#define mp make_pair
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

mt19937 gen(34);

int n, m, d[500000], col[500000];
bool t;
vector <char> used;
pair <int, int> ed[500000];
vector <vector <int>> gr;
set <int> unused;

void dfs(int v, vector <vector <int>>& gr, int dep) 
{
	d[v] = 0;
	used[v] = 1;
	for (int i = 0; i < gr[v].size(); i++)
		if (used[gr[v][i]] == 1 && (d[v] - d[gr[v][i]]) % 2 == 0)
		{
			cout << -1;
			exit(0);
		} 
		else
			if (used[gr[v][i]] == 0)
				dfs(gr[v][i], gr, dep + 1);
}

void start_dfs(int v, vector <vector <int>>& gr, int c) {
	col[v] = c;
	unused.erase(v);
	for (int i = 0; i < gr[v].size(); i++)
		if (unused.find(gr[v][i]) != unused.end())
			start_dfs(gr[v][i], gr, (c + 2) % 4);
}

void stupid_solve_for_same_end(int x) 
{
	vector <vector <int>> gr;
	gr.resize(n);
	bool added = false;
	for (int i = 0; i < m; i++) 
	{
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		if (u != x && v != x) 
		{
			added = true;
			gr[u].pb(v);
			gr[v].pb(u);
		}
	}
	if (!added) 
	{
		cout << "2\n";
		if(t)
			for (int i = 0; i < n; i++)
				if (i == x)
					cout << "2 ";
				else
					cout << "1 ";
		exit(0);
	}
	used.resize(n);
	for (int i = 0; i < n; i++)
		used[i] = false;
	for (int i = 0; i < n; i++)
		if (!used[i])
			dfs(i, gr, 0);
	for (int i = 0; i < n; i++)
		unused.insert(i);
	col[x] = 2;
	while (unused.size() > 0) {
		int v = *unused.begin();
		unused.erase(unused.begin());
		start_dfs(v, gr, 1);
	}
	cout << "3\n";
	if(t)
		for (int i = 0; i < n; i++)
			cout << col[i] << ' ';
	exit(0);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n >> m >> t;
	gr.resize(n);
	for (int i = 1; i < n; i++) 
	{
		cin >> ed[i].first >> ed[i].second;
		ed[i].first--;
		ed[i].second--;
		gr[ed[i].first].pb(ed[i].second);
		gr[ed[i].second].pb(ed[i].first);
	}
	bool ch_same_end = true;
	int same_end = -1;
	if (ed[0].first == ed[1].first || ed[0].first == ed[1].second)
		same_end = ed[0].first;
	else
		if (ed[0].second == ed[1].first || ed[0].second == ed[1].second)
			same_end = ed[0].second;
		else
			ch_same_end = false;
	if (ch_same_end) 
		stupid_solve_for_same_end(same_end);

	
	return 0;
}
