#ifndef LOCAL
#pragma GCC optimize("Ofast,fast-math,unroll-loops,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

using namespace std;

//#define int long long

const int MAXN = 15;

int n;
bool graph[MAXN][MAXN];
bool agraph[MAXN][MAXN];
bool vis1[MAXN], vis2[MAXN];

pair<int, int> dfs(int v, bool rev, bool *vis) {
  vis[v] = true;
  int d = 1, w = v;
  for (int u = 0; u < n; ++u) {
    if (vis[u] || !(graph[v][u] ^ rev))
      continue;
    auto[dd, ww] = dfs(u, rev, vis);
    if (dd + 1 > d)
      d = dd + 1, w = ww;
  }
  return {d, w};
}

bool paint1(int v, int f, int d, int p, vector<int> &ver, vector<int> &color) {
  if (v == f) {
    color[v] = d;
    ver.push_back(v);
    return true;
  }
  for (int u = 0; u < n; ++u) {
    if (!graph[v][u] || u == p)
      continue;
    if (paint1(u, f, d + 1, v, ver, color)) {
      color[v] = d;
      ver.push_back(v);
      return true;
    }
  }
  return false;
}

void paint2(int v, int d, vector<int> &color) {
  color[v] = d;
  for (int u = 0; u < n; ++u) {
    if (color[u] != 0)
      continue;
    if (graph[v][u])
      paint2(u, d + 1, color);
    else
      paint2(u, d - 1, color);
  }
}

int findk(vector<int> &color) {
  int k = 0;
//  memset(vis2, 0, n);
  for (int i = 0; i < n; ++i) {
//    if (vis2[i])
//      continue;
    memset(vis1, 0, n);
    auto[d1, u] = dfs(i, false, vis1);
    memset(vis1, 0, n);
    auto[d2, v] = dfs(u, true, vis1);
    if (color[v] != 0)
      continue;
    memset(vis1, 0, n);
    auto[d3, w] = dfs(v, false, vis1);
    vector<int> verts;
    paint1(v, w, 1, -1, verts, color);
    for (int j : verts)
      paint2(j, color[j], color);
    k = max(k, d3);
  }
  return k;
}

bool setnapr(int v, int f, int p) {
  if (v == f)
    return true;
  for (int u = 0; u < n; ++u) {
    if (!agraph[v][u] || u == p)
      continue;
    if (setnapr(u, f, v)) {
      graph[v][u] = true;
      graph[u][v] = false;
      return true;
    }
  }
  return false;
}

bool checkiscan(int v, int f, int p) {
  if (v == f)
    return true;
  for (int u = 0; u < n; ++u) {
    if (!graph[v][u] || u == p)
      continue;
    if (checkiscan(u, f, v))
      return true;
  }
  return false;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int m, t;
  cin >> n >> m >> t;
  for (int i = 0; i < n - 1; ++i) {
    int a, b;
    cin >> a >> b;
    a--, b--;
    agraph[a][b] = true;
    agraph[b][a] = true;
  }
  vector<pair<int, int>> bran(m);
  for (auto &el : bran) {
    cin >> el.first >> el.second;
    el.first--, el.second--;
  }
  int finmask = (1<<m);
  int k = INT_MAX;
  vector<int> kcolor(n);
  for (int mask = 0; mask < finmask; ++mask) {
    for (int i = 0; i < m; ++i) {
      if ((mask>>i) & 1)
        setnapr(bran[i].first, bran[i].second, -1);
      else
        setnapr(bran[i].second, bran[i].first, -1);
    }
    bool isok = true;
    for (int i = 0; i < m && isok; ++i) {
      if ((mask>>i) & 1)
        isok &= checkiscan(bran[i].first, bran[i].second, -1);
      else
        isok &= checkiscan(bran[i].second, bran[i].first, -1);
    }
    if (!isok)
      continue;
    vector<int> color(n, 0);
    int kk = findk(color);
    if (kk < k) {
      k = kk;
      kcolor.swap(color);
    }
  }
  if (k == INT_MAX) {
    cout << -1;
    return 0;
  }
  cout << k << '\n';
  if (k <= 1e7) {
    for (int &el : kcolor)
      cout << el << ' ';
  }
  return 0;
}