#include <bits/stdc++.h>

#define int long long
#define endl '\n'
using namespace std;

const int MAXN = 100500;
vector<int> g[MAXN];
vector<pair<int, int>> lines;

map<pair<int, int>, vector<int>> paths;

vector<int> get_path(int u, int v) {
    if (paths.find({u, v}) != paths.end()) {
        return paths[{u, v}];
    }
    vector<int> pred(10, -1);
    deque<int> q = {u};
    while (!q.empty()) {
        int v1 = q.front();
        q.pop_front();
        for (int u1 : g[v1]) {
            if (pred[u1] == -1) {
                pred[u1] = v1;
                q.push_back(u1);
            }
        }
    }
    vector<int> path;
    while (v != u) {
        path.push_back(v);
        v = pred[v];
    }
    path.push_back(u);
    paths[{u, v}] = path;
    return path;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, t;
    cin >> n >> m >> t;
    int u1, v1;
    for (int i = 0; i < n - 1; i++) {
        cin >> u1 >> v1;
        g[u1].push_back(v1);
        g[v1].push_back(u1);
    }
    for (int i = 0; i < m; i++) {
        cin >> u1 >> v1;
        lines.emplace_back(u1, v1);
    }
    int mn = (int) 1e9;
    vector<int> ans;
    for (int i = 0; i < (int) pow(n, n); i++) {
        int k = i;
        vector<int> now;
        int now_m = (int) -1e9;
        for (int j = 0; j < n; j++) {
            now.push_back(k % n + 1);
            now_m = max(now_m, now.back());
            k /= n;
        }
        bool flag = true;
        for (auto &x : lines) {
            vector<int> path = get_path(x.first, x.second);
            vector<int> kek;
            for (auto el : path) {
                kek.push_back(now[el - 1]);
            }
            for (int j = 1; j < kek.size() - 1; j++) {
                if (kek[j] == kek[j - 1] || kek[j] == kek[j + 1]) {
                    flag = false;
                    break;
                }
                if (kek[j] < kek[j + 1] && kek[j] < kek[j - 1]) {
                    flag = false;
                    break;
                }
                if (kek[j] > kek[j + 1] && kek[j] > kek[j - 1]) {
                    flag = false;
                    break;
                }
            }
            if (!flag) {
                break;
            }
        }
        if (flag) {
            if (now_m < mn) {
                mn = now_m;
                ans = now;
            }
        }
    }
    if (mn == (int) 1e9) {
        cout << -1 << endl;
        return 0;
    }
    cout << mn << endl;
    for (auto x : ans) {
        cout << x << " ";
    }
    cout << endl;
}