#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <math.h>
#include <deque>
#define ll long long
#define ld long double

using namespace std;

const int MAXN = 5e5 + 5;
int tin[MAXN];
int tout[MAXN];
int bat[MAXN];
int tim = 0;

void dfs(int u, int par, vector<vector<int> > &graph) {
    bat[u] = par;
    tin[u] = tim;
    tim++;
    for (int v : graph[u]) {
        if (v == par)
            continue;
        dfs(v, u, graph);
    }
    tout[u] = tim;
    tim++;
}

bool ispar(int u, int v) {
    if (tin[u] <= tin[v] && tout[u] >= tout[v])
        return 1;
    return 0;
}

void get_path(int u, int v, vector<int> &path1, vector<int> &path2) {
    if (u == v)
        return;
    while (!ispar(u, v)) {
        path1.push_back(u);
        u = bat[u];
    }
    while (u != v) {
        path2.push_back(v);
        v = bat[v];
    }
}

bool dfs2(int u, vector<int> &used, vector<int> &tp, vector<vector<int> > &graph) {
    used[u] = 1;
    for (int v : graph[u]) {
        if (used[v] == 2)
            continue;
        if (used[v] == 1)
            return 0;
        bool res = dfs2(v, used, tp, graph);
        if (!res)
            return 0;
    }
    tp.push_back(u);
    used[u] = 2;
    return 1;
}

int main() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<vector<int> > graph(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }
    dfs(0, -1, graph);
    vector<vector<int> > path1(m), path2(m);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        get_path(u - 1, v - 1, path1[i], path2[i]);
    }
    int ans = n + 1;
    vector<int> colour(n);
    for (int mask = 0; mask < (1 << m); mask++) {
        vector<vector<int> > G(n);
        for (int i = 0; i < m; i++) { 
            for (int u : path1[i]) {
                if (mask & (1 << i))
                    G[u].push_back(bat[u]);
                else
                    G[bat[u]].push_back(u);
            }
            for (int u : path2[i]) {
                if (mask & (1 << i))
                    G[bat[u]].push_back(u);
                else
                    G[u].push_back(bat[u]);
            }
        }
        vector<int> used(n);
        vector<int> tp;
        bool flag = 1;
        for (int i = 0; i < n; i++) {
            if (used[i])
                continue;
            flag = dfs2(i, used, tp, G);
            if (!flag)
                break;
        }
        if (!flag)
            continue;
        reverse(tp.begin(), tp.end());
        vector<int> col(n);
        int mx = 0;
        for (int u : tp) {
            mx = max(mx, col[u]);
            for (int v : G[u]) {
                col[v] = max(col[v], col[u] + 1);
            }
        }
        if (ans > mx) {
            ans = mx;
            colour = col;
        }
    }
    if (ans == n + 1) {
        cout << -1 << endl;
        return 0;
    }
    cout << ans + 1 << endl;
    for (auto elem : colour)
        cout << elem + 1 << " ";
    cout << endl;
} 
//*/