#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

int c[500005], d[500005];
int p[500005][20];
int tin[500005], tout[500005];
vector <vector <int> > G;
int l;
int t = 0;

void dfs(int v, int p0) {
	d[v] = d[p0] + 1;
	tin[v] = t++;
	p[v][0] = p0;
	for (int i = 1; i <= l; ++i)
		p[v][i] = p[p[v][i - 1]][i - 1];
	for (int u : G[v]) {
		if (u != p0)
			dfs(u, v);
	}
	tout[v] = t++;
}

bool is_anc(int a, int b) {
	if (a == b)
		return true;
	if (tin[a] < tin[b] && tout[a] > tout[b])
		return true;
	return false;
}

int lca(int a, int b) {
	if (is_anc(a, b))
		return a;
	if (is_anc(b, a))
		return b;
	if (d[a] < d[b])
		swap(a, b);
	for (int i = l; i >= 0; --i) {
		if (p[a][i] == -1)
			continue;
		if (d[p[a][i]] >= d[b])
			a = p[a][i];
	}
	for (int i = l; i >= 0; --i) {
		if (p[a][i] != p[b][i]) {
			a = p[a][i];
			b = p[b][i];
		}
	}
	return p[a][0];
}

int log2(int n) {
	int x = 0;
	while ((1 << x) < n)
		++x;
	return x;
}

void dfs1(int v, int l, int x) {
	c[v] = x;
	if (v == l)
		return;
	dfs1(p[v][0], l, x + 1);
}

void dfs2(int v, int l, int x) {
	c[v] = x;
	if (v == l)
		return;
	dfs2(p[v][0], l, x - 1);
}

int main() {
	int n, m, t;
	cin >> n >> m >> t;
	l = log2(n);
	G.resize(n + 1);
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		G[a].push_back(b);
		G[b].push_back(a);
	}
	for (int i = 1; i <= n; ++i) {
		c[i] = 1;
		for (int j = 0; j <= l; ++j)
			p[i][j] = -1;
	}
	d[1] = 0;
	dfs(1, -1);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		int l = lca(a, b);
		dfs1(a, l, 1);
		dfs2(b, l, d[a] + d[b] - d[l] * 2 + 1);
	}
	int mc = 1;
	for (int i = 1; i <= n; ++i)
		mc = max(c[i], mc);
	cout << mc << '\n';
	for (int i = 1; i <= n; ++i)
		cout << c[i] << ' ';
	return 0;
}
