#include<iostream>
#include<vector>
#include<algorithm>

using namespace std;

vector<vector<int>> G;
vector<int> T;
vector<pair<int, int>> line;
vector<int> used;
vector<int> colour;

vector<int> tin;
vector<int> tout;
vector<pair<int, int>> stack1;
vector<int> cnt_up;
vector<int> cnt_down;
vector<vector<int>> up;

void dfs(int v, int& t, int p) {
	t++;
	tin[v] = t;
	up[v][0] = p;
	for (int u : G[v]) {
		if (u != p) {
			dfs(u, t, v);
		}
	}
	t++;
	tout[v] = t;
}
bool good_lines = true;
int dfs1(int v, int p, int cnt_down_t) {
	int cnt_up_t = cnt_up[v];
	for (int u : G[v]) {
		if (u != p) {
			cnt_up_t += dfs1(u, v, cnt_down_t + cnt_down[v]);
		}
	}
	if (cnt_up_t  && cnt_down_t ) {
		good_lines = false;
	}
	if (cnt_up_t) T[v] = 1;
	if (cnt_down_t) T[v] = 2;
	return cnt_up_t;
}
vector<long long> ans;
long long dfs_get(int v, int p, int c) {
	long long min_t = c;
	for (int u : G[v]) {
		if (u != p && T[u] == 1) {
			min_t = max(min_t, dfs_get(u, v, 0));
		}
	}
	min_t++;
	for (int u : G[v]) {
		if (u != p && T[u] == 2) {
			dfs_get(u, v, min_t);
		}
	}
	ans[v] = min_t;
	return min_t;
}
int is_parent(int v, int u) {
	if (tin[v] <= tin[u] && tout[u] <= tin[v]) return true;
	return false;
}
int lca(int v, int u) {
	if (is_parent(v, u)) return v;
	if (is_parent(u, v)) return u;
	int p = v;
	for (int i = 19; i > -1; i--) {
		if (!is_parent(up[i][p], u)) {
			p = up[i][p];
		}
	}
	return up[p][0];
}
int main() {
	int n, m, t;
	cin >> n >> m >> t;
	line.resize(m);
	G.resize(n + 1);
	T.resize(n + 1);
	used.resize(n + 1);
	colour.resize(n + 1);
	ans.resize(n + 1);
	tin.resize(n + 1);
	tout.resize(n + 1);
	cnt_up.resize(n + 1);
	cnt_down.resize(n + 1);
	up.resize(20, vector<int>(n + 1, 1));
	for (int i = 1; i < n; i++) {
		int v, u;
		cin >> v >> u;
		G[v].push_back(u);
		G[u].push_back(v);
	}
	for (int i = 0; i < m; i++) {
		cin >> line[i].first >> line[i].second;
	}
	int temp = 0;
	dfs(1, temp, 1);
	for (int i = 1; i < 20; i++) {
		for (int j = 0; j <= n; j++) {
			up[i][j] = up[i - 1][up[i - 1][j]];
		}
	}
	
	for (int i = 0; i < m; i++) {
		int q = lca(line[i].first, line[i].second);
		cnt_up[line[i].first]++;
		cnt_up[q]--;
		cnt_down[q]++;
		cnt_down[line[i].second]--;
	}
	dfs1(1, 1, 0);
	if (!good_lines) {
		cout << "-1";
	}
	else {
		dfs_get(1, 1, 0);
		long long k = 0;
		for (int i = 1; i <= n; i++) {
			k = max(k, ans[i]);
		}
		cout << k << endl;
		for (int i = 1; i <= n; i++) {
			cout << ans[i] << " ";
		}
	}
} 