#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ll long long
#define pb push_back
#define sc second
#define fs first
#define pii pair<int, int>
#define mp make_pair
#define ld long double
#define fast_io ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

typedef tree<int,null_type,less<int>,rb_tree_tag,tree_order_statistics_node_update> ordered_set;

const int N = 500000 + 50;
const int INF = 2000000000 + 7;

int pr[N], dsu[N], c[N], nc[N], h[N], dir[N], a[N], b[N], dp[N][20], n, m, t, ans = INF, curans = 0;
vector<int> g[N], dag[N];
vector<pii> rule[N];
bool vis[N], touched[N];

void dfs(int v, int p) {
    dp[v][0] = p;
    pr[v] = p;
    dsu[v] = v;
    dir[v] = -1;
    for (int j = 1; j < 20; j++) {
        dp[v][j] = dp[dp[v][j - 1]][j - 1];
    }

    for (int i = 0; i < g[v].size(); i++) {
        int to = g[v][i];
        if (to == p)
            continue;
        h[to] = h[v] + 1;
        dfs(to, v);
    }
}

inline int upper(int v, int d) {
    for (int j = 19; j >= 0; j--) {
        if (d&(1 << j)) {
            v = dp[v][j];
            d -= (1 << j);
        }
    }
    return v;
}
inline int lca(int u, int v) {
    if (h[u] < h[v])
        swap(u, v);
    u = upper(u, h[u] - h[v]);
    if (u == v)
        return u;

    for (int j = 19; j >= 0; j--) {
        if (dp[u][j] != dp[v][j]) {
            u = dp[u][j];
            v = dp[v][j];
        }
    }
    return dp[u][0];
}

int find_set(int v) {
    if (dsu[v] == v)
        return v;
    dsu[v] = find_set(dsu[v]);
    return dsu[v];
}

int getNext(int v) {
    if (v == 0)
        return 0;
    if (find_set(v) != find_set(pr[v]))
        return pr[v];
    pr[v] = getNext(pr[v]);
    return pr[v];
}

inline void union_set(int u, int v) {
    if (rand()&1)
        swap(u, v);
    dsu[find_set(u)] = find_set(v);
}

inline void unite(int v, int lc) {
    int cur = v;
    while(h[getNext(v)] >= h[lc]) {
        touched[getNext(v)] = true;
        union_set(v, getNext(v));
    }
}

bool makeColor(int v, int d) {
    if (vis[v]) {
        return dir[v] == d;
    }

    dir[v] = d;
    vis[v] = true;

    for (int i = 0; i < rule[v].size(); i++) {
        if (!makeColor(rule[v][i].fs, d ^ rule[v][i].sc))
            return false;
    }
    return true;
}

void dfsAns(int v) {
    if (vis[v])
        return;
    vis[v] = true;
    nc[v] = 0;
    for (int i = 0; i < dag[v].size(); i++) {
        int to = dag[v][i];
        dfsAns(to);
        nc[v] = max(nc[v], nc[to]);
    }
    nc[v]++;
    curans = max(curans, nc[v]);
}

clock_t tim = clock();
inline bool tooLate() {
    return (double)(clock() - tim) / (double)CLOCKS_PER_SEC > 5.2;
}

signed main()
{
    fast_io;

    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].pb(v);
        g[v].pb(u);
    }
    dfs(0, 0);

    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        if (u == v)
            continue;
        int lc = lca(u, v);
        if (lc == u || lc == v) {
            if (u != lc)
                swap(u, v);

            unite(v, upper(v, h[v] - h[u] - 1));
            touched[v] = true;
        }
        else {
            unite(v, upper(v, h[v] - h[lc] - 1));
            unite(u, upper(u, h[u] - h[lc] - 1));
            touched[v] = touched[u] = true;
        }
        a[i] = u, b[i] = v;
    }

    for (int i = 0; i < n; i++) {
        rule[i].pb(mp(find_set(i), 0));
        rule[find_set(i)].pb(mp(i, 0));
    }
    for (int i = 0; i < m; i++) {
        int u = a[i], v = b[i];
        int lc = lca(u, v);
        if (lc != u && lc != v) {
            rule[u].pb(mp(v, 1));
            rule[v].pb(mp(u, 1));
        }
    }

    int am = 1;
    if (n <= 100)
        am = 100000;
    if (n <= 15)
        am = 1000000;
    while(!tooLate()) {

    curans = 0;
    for (int i = 0; i < n; i++) {
        vis[i] = false;
        dir[i] = -1;
    }

    for (int i = 1; i < n; i++) {
        if (vis[i])
            continue;
        if (!touched[i]) {
            continue;
        }
        if (!makeColor(i, rand() % 2)) {
            cout << -1;
            return 0;
        }
    }
    for (int i = 0; i < n; i++)
        dag[i].clear();

    for (int i = 1; i < n; i++) {
        if (dir[i] == -1)
            continue;
        if (dir[i] == 0)
            dag[i].pb(dp[i][0]);
        else
            dag[dp[i][0]].pb(i);
    }

    for (int i = 0; i < n; i++)
        vis[i] = false;
    for (int i = 0; i < n; i++) {
        dfsAns(i);
    }

    if (curans < ans) {

        ans = curans;
        for (int i = 0; i < n; i++)
            c[i] = nc[i];

    }

    }

    cout << ans << endl;
    for (int i = 0; i < n; i++)
        cout << c[i] << " ";

    return 0;
}

/*
3 1 1
1 2
2 3
1 3

4 3 0
1 2
1 3
1 4
2 3
2 4
3 4
*/
