#include <iostream>
#include <vector>

using namespace std;

void dfs(int v, vector<vector<int> > & g, vector<int> & p){
    for (auto i : g[v]){
        if (i != p[v]){
            p[i] = v;
            dfs(i, g, p);
        }
    }
}

vector<vector<int> > mor;
vector<int> a, b;

void paint(int v, int c, int t, vector<vector<int> > & nx, vector<bool> &used){
    used[c] = 1;
    if (nx[c][v] != -1){
        if (t){
            mor[v].push_back(nx[c][v]);
        }else{
            mor[nx[c][v]].push_back(v);
        }
    }
    for (int i = 0; i < nx.size(); i++){
        if (!used[i] && nx[i][v] == nx[c][v]){
            paint(a[i], i, t, nx, used);
        }
        if (!used[i] && nx[i][nx[c][v]] == v){
            paint(a[i], i, 1 - t, nx, used);
        }
    }
    if (nx[c][v] != -1){
        paint(nx[c][v], c, t, nx, used);
    }
}

bool good = true;
vector<int> ts;

void topsort(int v, vector<bool> &used){
    used[v] = true;
    for (auto i : mor[v]){
        if (used[i]){
            good = false;
        }else{
            topsort(i, used);
        }
    }
    ts.push_back(v);
}

int main()
{
    freopen("input.txt", "r", stdin);
    int n, m, t;
    cin >> n >> m >> t;
    vector<vector<int> > g(n);
    for (int i = 0; i < n - 1; i++){
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    a.resize(m);
    b.resize(m);
    for (int i = 0; i < m; i++){
        cin >> a[i] >> b[i];
        a[i]--;
        b[i]--;
    }
    vector<vector<int> > nx(m, vector<int>(n, -1));
    vector<vector<int> > pr(m, vector<int>(n, -1));
    for (int i = 0; i < m; i++){
        vector<int> prev(n, -1);
        dfs(a[i], g, prev);
        int now = b[i];
        while (prev[now] != -1){
            pr[i][now] = prev[now];
            nx[i][prev[now]] = now;
            now = prev[now];
        }
    }
    mor.resize(n);
    vector<bool> used(m);
    for (int i = 0; i < m; i++){
        if (!used[i]){
            paint(a[i], i, 1, nx, used);
        }
    }
    vector<bool> u(n);
    for (int i = 0; i < n; i++){
        if (!u[i]){
            topsort(i, u);
        }
    }
    vector<int> ans(n, 1);
    int answer = 0;
    for (int i = 0; i < n; i++){
        int q = ts[i];
        for (auto v : mor[q]){
            ans[q] = max(ans[q], ans[v] + 1);
            answer =max(ans[q], answer);
        }
    }
    cout << answer << endl;
    for (auto i : ans){
        cout << i << ' ';
    }
    cout << endl;
    return 0;
}
