//#define _GLIBcxx_DEBUG

#pragma GCC optimaze("unroll-loops")
//#pragma GCC optimaze("fast-math")
//#pragma GCC optimaze("Ofast,no-stack-protector")

#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <deque>
#include <random>
#include <time.h>

using namespace std;

#define I i
#define all(v) (v).begin(), (v).end()
#define rev(v) reverse((v).begin(), (v).end())
#define rall(v) (v).rbegin(), (v).redn()
#define sort stable_sort
#define endl "\n"
#define fastio() cin.tie()->sync_with_stdio(0); cout.tie()->sync_with_stdio(0); srand(time(NULL))
typedef long long ll;
typedef unsigned long long ull;
const int inf = 1e9 + 1329;

int n;

vector<vector<int>> g;
vector<int> hld;
vector<int> tin;
vector<int> up;
vector<int> l;
vector<int> sz;
vector<int> num;
vector<int> h;

int currNum = 0;

int t = 0;

int dfs_sz(int v, int p) {
	sz[v] = 1;
	tin[v] = t++;
	hld.push_back(v);
	for (int u : g[v]) {
		if (u != p) {
			h[u] = h[v] + 1;
			sz[v] += dfs_sz(u, v);
		}
	}
	return sz[v];
}

void dfs(int v, int p) {
	num[v] = currNum;
	int first = -1;
	for (int u : g[v]) {
		if (u != p) {
			l[u] = l[v];
			up[u] = up[v];
			dfs(u, v);
			first = u;
			break;
		}
	}
	for (int u : g[v]) {
		if (u != p && u != first) {
			l[u] = u;
			up[u] = v;
			++currNum;
			dfs(u, v);
		}
	}
}

/* Segment tree starts here */

struct Node {
	int sum = 0;
	int edit = 0;
	bool has1 = false;
	bool has2 = false;
};

vector<Node> tree;

void push(int L, int R, int i) {
	if (tree[i].edit != 0) {
		tree[i].has1 = (tree[i].edit == 1);
		tree[i].has2 = (tree[i].edit == 2);
		tree[i].sum = tree[i].edit * (R - L);
		if (R - L > 1) {
			tree[2 * i + 1].edit = tree[i].edit;
			tree[2 * i + 2].edit = tree[i].edit;
		}
		tree[i].edit = 0;
	}
}

void updNode(int L, int R, int i) {
	if (L + 1 < R) {
		tree[i].sum = tree[2 * i + 1].sum + tree[2 * i + 2].sum;
		tree[i].has1 = tree[2 * i + 1].has1 || tree[2 * i + 2].has1;
		tree[i].has2 = tree[2 * i + 1].has2 || tree[2 * i + 2].has2;
	}
	else {
		if (tree[i].sum == 1) {
			tree[i].has1 = true;
			tree[i].has2 = false;
		}
		else {
			tree[i].has1 = false;
			tree[i].has2 = true;
		}
	}
	push(L, R, i);
}

bool upd(int qL, int qR, int qD, int L = 0, int R = n, int i = 0) {
	updNode(L, R, i);
	if (qL <= L && R <= qR) {
		tree[i].edit = qD;
		bool ok = ((tree[i].has1 == false && qD == 2) || (tree[i].has2 == false && qD == 1));
		updNode(L, R, i);
		return ok;
	}
	if (qL >= R || qR <= L) {
		return true;
	}
	int m = (L + R) / 2;
	bool ok = upd(qL, qR, qD, L, m, 2 * i + 1) && upd(qL, qR, qD, m, R, 2 * i + 2);
	updNode(L, R, i);
	return ok;
}

vector<int> ans;
void total_push(int L = 0, int R = n, int i = 0) {
	if (R - L == 1) {
		push(L, R, i);
		ans[L] = tree[i].sum;
		return;
	}
	push(L, R, i);
	int m = (L + R) / 2;
	total_push(L, m, 2 * i + 1);
	total_push(m, R, 2 * i + 2);
	updNode(L, R, i);
}

/*  Segment tree ends here  */

bool cmp(const int& a, const int& b) {
	return sz[a] > sz[b];
}

signed main() {
	fastio();
	int  m, t; cin >> n >> m >> t;
	g = vector<vector<int>>(n + 1);
	tin = up = l = sz = num = h = ans = vector<int>(n + 1, 0);
	up = l = vector<int>(n + 1, 1);
	for (int i = 0; i < n - 1; ++i) {
		int a, b; cin >> a >> b;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	dfs_sz(1, -1);
	for (int i = 0; i < n; ++i) {
		sort(all(g[i]), cmp);
	}
	dfs(1, -1);
	tree = vector<Node>(4 * n);
	for (int qwerty = 0; qwerty < m; ++qwerty) {
		int u, v; cin >> u >> v;
		bool x = true;
		while (num[u] != num[v]) {
			if (h[up[v]] > h[up[u]] || u == 1) {
				x &= upd(tin[l[v]], tin[v] + 1, 1); // edge state = 1 if pointing up
				v = up[v];
			}
			else {
				x &= upd(tin[l[u]], tin[u] + 1, 2); // edge state = 2 if pointing down
				u = up[u];
			}
		}
		if (h[v] < h[u]) {
			x &= upd(tin[v] + 1, tin[u] + 1, 2);
		}
		else {
			x &= upd(tin[u] + 1, tin[v] + 1, 1);
		}
		if (!x) {
			cout << -1 << endl;
			return 0;
		}
	}
	total_push();
	if (!t) {
		cout << 1000000 << endl;
	}
}