#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define out(t, a) copy(all(a), ostream_iterator<t>(cout, " ")); cout << "\n";
// #define DEBUG

// #pragma GCC optimize("O3")
// #pragma GCC optimize("Ofast")
// #pragma GCC optimize("unroll-loops")
// #pragma GCC target("avx,avx2,sse,sse2,sse3,sse4")

using namespace std;

void set_program() {
	#ifdef DEBUG
		freopen("test.in", "r", stdin);
		freopen("test.out", "w", stdout);
	#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
}

mt19937 rnd(1);

typedef long long ll;
typedef long double ld;

const ld EPS = 1e-8;
const int ALF = 26;
const int MOD = 1e9 + 7;
const int INF = 1e9 + 7;
const int MAXN = 5e5;

vector <int> gr[MAXN];
vector <int> ngr[MAXN];

int bit(int mask, int i) {
	return ((mask >> i) & 1);
}

bool dfs(int u, int parent, int f) {
	// cout << "u = " << u << ", f = " << f << "\n";
	if (u == f) {
		return 1;
	}
	for (int v : gr[u]) {
		if (v != parent && dfs(v, u, f)) {
			// cout << "\t" << u << " " << v << "\n";
			ngr[v].push_back(u);
			return 1;
		}
	}
	return 0;
}

vector <int> col, coll;
bool cycle;

void paint(int u, int parent) {
	coll[u] = 1;
	for (int v : ngr[u]) {
		if (coll[v] == 1) {
			cycle = 1;
		}
		if (coll[v] == 0) {
			paint(v, u);
		}
	}
	coll[u] = 2;
}

int max_dfs(int u, int depth) {
	col[u] = 1;
	int res = depth;
	for (int v : ngr[u]) {
		if (col[v] == 0) {
			res = max(res, max_dfs(v, depth + 1));
		}
	}
	return res;
}

int get_res(int n, int m, vector <pair <int, int>>& q, vector <int>& c) {
	for (int i = 0; i < n; ++i) {
		ngr[i].clear();
	}
	for (auto i : q) {
		dfs(i.fi, -1, i.se);
	}
	coll.assign(n, 0);
	for (int u = 0; u < n; ++u) {
		if (coll[u] == 0) {
			cycle = 0;
			paint(u, -1);
			if (cycle) {
				return -1;
			}
		}
	}
	c.assign(n, -1);
	for (int i = 0; i < n; ++i) {
		col.assign(n, 0);
		c[i] = max_dfs(i, 0) + 1;
	}
	return *max_element(all(c));
}

void solve() {
	int n, m, t;
	cin >> n >> m >> t;
	for (int i = 0; i < n; ++i) {
		gr[i].clear();
	}
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		gr[a].push_back(b);
		gr[b].push_back(a);
	}
	vector <pair <int, int>> q(m);
	for (auto& i : q) {
		cin >> i.fi >> i.se;
		--i.fi, --i.se;
	}
	int ans = -1;
	vector <int> ansc;
	for (int mask = 0; mask < (1 << m); ++mask) {
		vector <pair <int, int>> qq = q;
		for (int i = 0; i < m; ++i) {
			if (bit(mask, i)) {
				swap(q[i].fi, q[i].se);
			}
		}
		int res;
		vector <int> c;
		res = get_res(n, m, q, c);
		if (res != -1 && (res < ans || ans == -1)) {
			ans = res;
			ansc = c;
		}
		q = qq;
	}
	cout << ans << "\n";
	if (ans != -1) {
		out(int, ansc);
	}
}

main() {
	set_program();
	int t;
	#ifdef DEBUG
		t = 2;
	#else
		t = 1;
	#endif
	for (; t--; ) {
		solve();
		cout << "\n";
	}
	return 0;
}