//#pragma GCC target("avx2")

#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {/*
    ios_base::sync_with_stdio(0);
    cin.tie(0);*/
    solve();
}

int n, m, t, timer = 0;
vector<vector<int>> g;
vector<pair<int, int>> a;

vector<set<pair<int, int>>> m_paths_set;
vector<vector<int>> m_paths;
vector<int> c;

set<pair<int, int>> proved;

bool dfs_prove(int v, int p, int f, bool &tchd_prove, bool &tchd_prove_inv) {
    //cout << "dfs prove" sp v+1 nl;
    if (v == f) {
        return true;
    }
    for (auto &i: g[v]) {
        if (i == p) continue;
        if (dfs_prove(i, v, f, tchd_prove, tchd_prove_inv)) {
            tchd_prove |= proved.count({v, i});
            tchd_prove_inv |= proved.count({i, v});
            return true;
        }
    }

    return false;
}

void prove(int v, int u) {
    bool straight = false;
    bool inv = false;

    //cout << "prove" sp v+1 sp u+1 nl;

    for (int i = 0; i < m; ++i) {
        bool tchd_proved = false;
        bool tchd_proved_inv = false;
        //cout << "way id" sp i+1 nl;
        if (m_paths_set[i].count({v, u})) {
            dfs_prove(a[i].first, -1, a[i].second, tchd_proved, tchd_proved_inv);
        } else if (m_paths_set[i].count({u, v})) {
            dfs_prove(a[i].second, -1, a[i].first, tchd_proved, tchd_proved_inv);
        }
        if (tchd_proved && tchd_proved_inv) {
            cout << -1 nl;
            exit(0);
        }
        straight |= tchd_proved;
        inv |= tchd_proved_inv;
    }

    if (straight && inv) {
        /// PANIC
        cout << -1 nl;
        exit(0);
    }

    if (straight) {
        proved.insert({v, u});
        //cout << "straight" nl;
    } else if (inv) {
        //cout << "inv" nl;
        proved.insert({u, v});
    } else {
        /// RANDOM???
        //cout << "straight rand" nl;
        proved.insert({v, u});
    }
}

void dfs_main(int v, int p) {
    for (auto &i: g[v]) {
        if (i != p) {
            if (!proved.count({v, i})) prove(v, i);
            dfs_main(i, v);
        }
    }
}

bool dfs_precalc(int v, int p, int f, int id) {
    if (v == f) {
        m_paths[id].push_back(v);
        return true;
    }

    for (auto &i: g[v]) {
        if (i == p) continue;
        if (dfs_precalc(i, v, f, id)) {
            m_paths_set[id].insert({v, i});
            m_paths[id].push_back(v);
            return true;
        }
    }

    return false;
}

bool dfs_calc(int v, int p, int f, int ) {
    if (v == f) return true;

    for (auto &i: g[v]) {

    }

    return false;
}

void solve() {
    cin >> n >> m >> t;
    g.resize(n);
    c.resize(n, 1);
    a.resize(m);
    m_paths.resize(m);
    m_paths_set.resize(m);

    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    for (auto &i: a) (cin >> i.first >> i.second), i.first--, i.second--;

    for (int i = 0; i < m; ++i) {
        dfs_precalc(a[i].first, -1, a[i].second, i);
        reverse(m_paths[i].begin(), m_paths[i].end());
        for (int j = 1; j < m_paths[i].size(); ++j) {
            proved.insert({m_paths[i][j - 1], m_paths[i][j]});
        }
    }

    dfs_main(0, -1);

    for (int i = 0; i < m; ++i) {
        if (!proved.count({m_paths[i][0], m_paths[i][1]})) {
            reverse(m_paths[i].begin(), m_paths[i].end());
        }

        for (int j = 1; j < m_paths[i].size(); ++j) {
            if (c[m_paths[i][j - 1]] >= c[m_paths[i][j]]) {
                c[m_paths[i][j]] = c[m_paths[i][j - 1]] + 1;
            }
        }
    }

    int k = 0;
    for (auto &i: c) k = max(k, i);

    cout << k nl;
    for (auto &i: c) {
        cout << i sq;
    } cout nl;
}
