#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


#define MAXN 100000
#define MAX_LOG 23
vector<int> g[MAXN];
int pre[MAXN];

int up[MAXN][MAX_LOG];
int tin[MAXN];
int tout[MAXN];
int dep[MAXN];
int timer = 0;

void dfs(int v, int p, int d) {
    pre[v] = p;
    dep[v] = d;
    tin[v] = timer++;
    for (int u:g[v]) {
        if (u != p) {
            dfs(u, v, d + 1);
        }
    }
    up[v][0] = p;
    for (int i = 1; i < MAX_LOG; ++i) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    tout[v] = timer++;
}

bool is_ancestor(int u, int v) {
    return tin[u] < tin[v] && tout[u] > tout[v];
}

int lca(int u, int v) {
    if (is_ancestor(u, v)) {
        return u;
    }
    if (is_ancestor(v, u)) {
        return v;
    }
    for (int i = MAX_LOG - 1; i >= 0; ++i) {
        if (!is_ancestor(up[u][i], v)) {
            u = up[u][i];
        }
    }
    return up[u][1];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, t;
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0, 0, 0);
    int ans[n];
    memset(ans, 0, sizeof(ans));
    int mx = 1;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        int l = lca(a, b);
        int len = -2 * dep[l] + dep[a] + dep[b];
        len++;
        mx = max(mx, len);

        ans[a] = 1;
        while (a != l) {
            if (ans[pre[a]]) {
                cout << -1;
            }
            ans[pre[a]] = ans[a] + 1;
            a = pre[a];
        }
        int last = len;
        while (b != l) {
            if (ans[b]) {
                cout << -1;
            }
            ans[b] = last--;
            b = pre[b];
        }
    }
    cout << mx << "\n";
    for (int i = 0; i < n; ++i) {
        if (ans[i] == 0) {
            ans[i] = 1;
        }
        cout << ans[i] << " ";
    }
    return 0;
}