#include <iostream>
#include <cstring>
#include <vector>
#include <map>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

bool used[MAXN + 5];
map< pair<int, int>, bool> M;
int top_sort[MAXN + 5], c[MAXN + 5];
vector<int> G[MAXN + 5], G1[MAXN + 5];

bool DFS(int u, int v)
{
    used[u] = true;
    if (u == v) return true;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        if (!used[G[u][i]])
        {
            if (DFS(G[u][i], v))
            {
                if (M.find({G[u][i], u}) != M.end())
                {
                    cout << -1 << endl;
                    exit(0);
                }
                else if (!(M.find({u, G[u][i]}) != M.end()))
                {
                    M[{u, G[u][i]}] = true;
                    G1[u].push_back(G[u][i]);
                }
                return true;
            }
        }
    }
    return false;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m, t;
    cin >> n >> m >> t;

    int u, v;
    for (int i = 1; i < n; ++ i)
    {
        cin >> u >> v;
        G[u].push_back(v);
        G[v].push_back(u);
    }

    for (int i = 0; i < m; ++ i)
    {
        cin >> u >> v;
        DFS(u, v);
        memset(used, false, sizeof(used));
    }

    int k = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (G[i].size() == G1[i].size())
        {
            c[i] = 1;
            used[i] = true;
            top_sort[k++] = i;
        }
    }

    int ans = 0;
    for (int i = 0; i < k; ++ i)
    {
        int u = top_sort[i];
        for (int j = 0; j < G1[u].size(); ++ j)
        {
            if (!used[G1[u][j]])
            {
                used[G1[u][j]] = true;
                top_sort[k++] = G1[u][j];
                c[G1[u][j]] = c[u] + 1;
                ans = max(ans, c[G1[u][j]]);
            }
        }
    }

    cout << ans << endl;
    for (int i = 1; i <= n; ++ i)
        cout << c[i] << " ";
    cout << endl;

    return 0;
}
