#include<iostream>
#include<vector>
#include<map>
#include<set>
#include<algorithm>
#include<cmath>
#include<queue>
#include<string>

using namespace std;

vector<vector<int>> g;

map<pair<int, int>, int> mp;

int val = 1;

vector<int> used;

vector<int> ans;

void dfs(int v) {
	used[v] = 1;
	for (auto u : g[v]) {
		if (used[u]) {
			continue;
		}
		if (mp[{u, v}] && mp[{v, u}]) {
			val = 0;
			return;
		}
		if (mp[{u, v}]) {
			ans[u] = ans[v] - 1;
			dfs(u);
		}
		else if (mp[{v, u}]) {
			ans[u] = ans[v] + 1;
			dfs(u);
		}
		else {
			ans[u] = 0;
			dfs(u);
		}
	}
}

signed main() {
	int n, m, t;
	cin >> n >> m >> t;
	if (n <= 100 && m <= 100) {
		g.resize(n);
		used.resize(n);
		ans.resize(n);
		for (int i = 1; i < n; i++) {
			int a, b;
			cin >> a >> b;
			g[a - 1].push_back(b - 1);
			g[b - 1].push_back(a - 1);
		}
		for (int i = 0; i < m; i++) {
			int a, b;
			cin >> a >> b;
			a--;
			b--;
			queue<int> q;
			q.push(a);
			vector<int> p(n);
			vector<int> dist(n, 1e9);
			dist[a] = 0;
			while (q.size()) {
				int v = q.front();
				q.pop();
				for (auto u : g[v]) {
					if (dist[v] + 1 < dist[u]) {
						q.push(u);
						dist[u] = dist[v] + 1;
						p[u] = v;
					}
				}
			}
			vector<int> path;
			int v = b;
			while (v != a) {
				path.push_back(v);
				v = p[v];
			}
			path.push_back(a);
			while (path.size() > 1) {
				int v = path.back();
				path.pop_back();
				mp[{v, path.back()}] = 1;
			}
		}
		ans[0] = 0;
		dfs(0);
		if (val == 0) {
			cout << -1;
			return 0;
		}
		int mn = 0;
		for (int i = 0; i < n; i++) {
			mn = min(mn, ans[i]);
		}
		int mx = 0;
		for (int i = 0; i < n; i++) {
			ans[i] += (1 - mn);
			mx = max(mx, ans[i]);
		}
		cout << mx << "\n";
		if (t == 1) {
			for (int i = 0; i < n; i++) {
				cout << ans[i] << " ";
			}
		}
	}
}