#include <bits/stdc++.h>

using namespace std;

bool way_dfs(int v, int prev_v, int e, int prev_e, int u,
        const vector<vector<pair<int, int>>>& adjList,
        vector<vector<pair<int, int>>>& way) {
    if (v == u) {
        way[e].emplace_back(prev_e, -1);
        return true;
    }
    for (auto[to_v, to_e] : adjList[v])
        if (prev_v != to_v && way_dfs(to_v, v, to_e, e, u, adjList, way)) {
            if (e != -1)
                way[e].emplace_back(prev_e, to_e);
            return true;
        }
    return false;
}

int getMajor(const pair<int, int>& e1, const pair<int, int>& e2, int v) {
    int c = e1.second;
    if (e1.first == e2.first || e1.first == e2.second)
        c = e1.first;
    if (c == v)
        return e1.first + e1.second - c;
    return c;
}

void build_dfs(int e, int v, const vector<vector<pair<int, int>>>& way,
        const vector<pair<int, int>>& edgeList, vector<vector<int>>& dirgra,
        vector<char>& used) {
    used[e] = 1;
    int u = edgeList[e].first + edgeList[e].second - v;
    dirgra[v].push_back(u);
    for (auto[prev, next] : way[e]) {
        if (prev != -1 && !used[prev]) {
            build_dfs(prev, getMajor(edgeList[prev], edgeList[e], v), way,
                    edgeList, dirgra, used);
        }
        if (next != -1 && !used[next]) {
            build_dfs(next, getMajor(edgeList[next], edgeList[e], v), way,
                      edgeList, dirgra, used);
        }
    }
}

void dfs_paint(int v, const vector<vector<int>>& dirgra, vector<int>& c) {
    int val = 1;
    for (int to : dirgra[v]) {
        if (!c[to])
            dfs_paint(to, dirgra, c);
        val = max(val, c[to] + 1);
    }
    c[v] = val;
}

bool check_dfs(int v, int u, const vector<vector<int>>& dirgra) {
    if (v == u)
        return true;
    for (int to : dirgra[v])
        if (check_dfs(to, u, dirgra))
            return true;
    return false;
}

int main() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<pair<int, int>> edgeList(n - 1);
    vector<vector<pair<int, int>>> adjList(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        edgeList[i] = {v, u};
        adjList[v].emplace_back(u, i);
        adjList[u].emplace_back(v, i);
    }
    vector<vector<pair<int, int>>> way(n - 1);
    vector<pair<int, int>> line(m);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        line[i] = {v, u};
        way_dfs(v, -1, -1, -1, u, adjList, way);
    }
    vector<vector<int>> dirgra(n);
    vector<char> used(n - 1);
    for (int e = 0; e < n - 1; ++e)
        if (!used[e] && !way[e].empty())
            build_dfs(e, edgeList[e].first, way, edgeList, dirgra, used);
    vector<char> onlyOut(n, 1);
    for (int v = 0; v < n; ++v)
        for (int to : dirgra[v])
            onlyOut[to] = 0;
    vector<int> c(n);
    for (int v = 0; v < n; ++v)
        if (onlyOut[v])
            dfs_paint(v, dirgra, c);
    int ans = 0;
    for (int v = 0; v < n; ++v)
        if (!c[v]) {
            cout << "-1\n";
            exit(0);
        }
        else
            ans = max(ans, c[v]);
    for (int i = 0; i < m; ++i)
        if (!check_dfs(line[i].first, line[i].second, dirgra) &&
            !check_dfs(line[i].second, line[i].first, dirgra)) {
            cout << "-1\n";
            exit(0);
        }
    cout << ans << "\n";
    for (int e : c)
        cout << e << " ";
    return 0;
}
