#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <cmath>
#include <random>
#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

random_device rd;
mt19937 rnd(rd());

vector <vector <ll>> gr;
vector <ll> h;
vector <bool> u;

void bfs(ll v) {
    ll hi = 1;
    queue <pair <ll, ll>> q;
    q.push({ v, hi });
    u[v] = true;
    h[v] = hi;
    while (!q.empty()) {
        auto to = q.front();
        q.pop();
        h[to.first] = to.second;
        for (auto t : gr[to.first]) {
            if (!u[t]) {
                q.push({ t, to.second + 1 });
                u[t] = true;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n, m, t;
    cin >> n >> m >> t;
    h.resize(n);
    gr.resize(n);
    u.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll a, b;
        cin >> a >> b, a--, b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    vector <ll> us(n);
    for (ll i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b, a--, b--;
        us[a]++;
        us[b]++;
    }
    ll st;
    for (ll i = 0; i < n; i++) {
        if (us[i] == m) {
            st = i;
            break;
        }
    }
    bfs(st);
    cout << *max_element(h.begin(), h.end()) << '\n';
    if (t == 1) {
        for (ll i = 0; i < n; i++)
            cout << h[i] << " ";
    }
    return 0;
}