#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 5e5 + 25;

vector<vector<int>> g(MAXN);

const int INF = 1e9 + 27;

int used[MAXN];
int p[MAXN][20];

int timer = 0;

int tin[MAXN];
int tout[MAXN];

void dfs(int u)
{
    tin[u] = timer++;
    used[u] = true;
    for (auto v : g[u])
    {
        if (!used[v])
        {
            p[v][0] = u;
            dfs(v);
        }
    }
    tout[u] = timer++;
}

int lca(int u, int v)
{
    if (tin[u] <= tin[v] && tout[v] <= tout[u])
    {
        return u;
    }
    if (tin[v] <= tin[u] && tout[u] <= tout[v])
    {
        return v;
    }
    int ans = u;
    for (int i = 19; i >= 0; i--)
    {
        int cur = p[ans][i];
        if (!(tin[cur] <= tin[v] && tout[v] <= tout[cur]))
        {
            ans = cur;
        }
    }
    return p[ans][0];
}

vector<vector<int>> h(MAXN);

int us[MAXN];

vector<int> ord;

void dfs2(int u)
{
    us[u] = true;
    for (auto v : h[u])
    {
        if (!us[v])
        {
            dfs2(v);
        }
    }
    ord.push_back(u);
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m, t;
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; ++i)
    {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0);
    p[0][0] = 0;
    for (int j = 1; j < 20; ++j)
    {
        for (int i = 0; i < n; ++i)
        {
            p[i][j] = p[p[i][j - 1]][j - 1];
        }
    }
    vector<int> a(m);
    vector<int> b(m);
    for (int i = 0; i < m; ++i)
    {
        cin >> a[i] >> b[i];
        --a[i]; --b[i];
    }
    int ans = INF;
    vector<int> ans2(n);
    for (int msk = 0; msk < (1 << m); ++msk)
    {
        for (int i = 0; i < m; ++i)
        {
            if (msk & (1 << i))
            {
                swap(a[i], b[i]);
            }
        }
        for (int i = 0; i < n; ++i)
        {
            us[i] = false;
            h[i] = {};
        }
        ord = {};
        for (int i = 0; i < m; ++i)
        {
            int lc = lca(a[i], b[i]);
            int u = a[i];
            while (u != lc)
            {
                h[u].push_back(p[u][0]);
                u = p[u][0];
            }
            int v = b[i];
            while (v != lc)
            {
                h[p[v][0]].push_back(v);
                v = p[v][0];
            }
        }
        for (int i = 0; i < n; ++i)
        {
            if (!us[i])
            {
                dfs2(i);
            }
        }
        vector<int> res(n, INF);
        int sum = 0;
        for (auto u : ord)
        {
            int cur = 0;
            for (auto v : h[u])
            {
                cur = max(cur, res[v]);
            }
            res[u] = cur + 1;
            sum = max(sum, res[u]);
        }
        if (sum < ans)
        {
            ans = sum;
            for (int i = 0; i < n; ++i)
            {
                ans2[i] = res[i];
            }
        }
        for (int i = 0; i < m; ++i)
        {
            if (msk & (1 << i))
            {
                swap(a[i], b[i]);
            }
        }
    }
    if (ans == INF)
    {
        cout << -1 << endl;
        return 0;
    }
    cout << ans << endl;
    for (int i = 0; i < n; ++i)
    {
        cout << ans2[i] << " ";
    }
    cout << endl;
    return 0;
}
