#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <ctime>
#include <random>
#include <queue>
#include <stack>
#include <deque>
#include <string>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#pragma GCC target("sse")

using namespace std;

using ll = long long;
using ld = long double;
using itn = int;

#define endl '\n'

mt19937 gen(41);
mt19937_64 genl(41);

const int N = 500'000;

int n, m, t;

vector<int> g[N];
int a[N], b[N];

int check_ezh() {
    unordered_map<int, int> cnt;
    for (int i = 0; i < n; i++) {
        if (g[i].size() == n - 1)
            return i;
    }
    return -1;
}

vector<int> c;

map<pair<int, int>, bool> bolshe;

vector<int> G[N];

bool kek_dfs(int v) {
    for (auto to : G[v]) {
        if (c[to] == -1) {
            if (c[v] == 1)
                c[to] = 3;
            else
                c[to] = 1;
            if (!kek_dfs(to))
                return false;
        }
        else {
            if (c[to] == c[v])
                return false;
        }
    }
    return true;
}

void ezh() {
    int v = check_ezh();
    int cntv = 0;
    for (int i = 0; i < m; i++) {
        if (a[i] == v || b[i] == v)
            cntv++;
    }
    if (cntv == m) {
        cout << 2 << endl;
        for (int i = 0; i < n; i++) {
            if (i == v)
                cout << 1 << " ";
            else
                cout << 2 << " ";
        }
        exit(0);
    }
    fill(c.begin(), c.end(), -1);
    for (int i = 0; i < m; i++) {
        if (a[i] != v && b[i] != v) {
            G[a[i]].push_back(b[i]);
            G[b[i]].push_back(a[i]);
        }
    }
    for (int i = 0; i < n; i++) {
        if (v != i) {
            c[i] = 1;
            if (!kek_dfs(i)) {
                cout << -1;
                exit(0);
            }
            break;
        }
    }
    c[v] = 2;
    cout << 3 << endl;
    for (int i = 0; i < n; i++) {
        if (c[i] == -1)
            cout << 1 << " ";
        else
            cout << c[i] << " ";
    }
    exit(0);
}

bool used[N];

vector<vector<int>> paths;

bool find_path(int v, int q) {
    paths.back().push_back(v);
    if (v == q)
        return true;
    used[v] = true;
    for (auto to : g[v]) {
        if (!used[to])
            if (find_path(to, q)) {
                return true;
            }
    }
    paths.back().pop_back();
    return false;
}

int minc = 0;
void get_c(int v) {
    minc = min(minc, c[v]);
    for (auto to : g[v]) {
        if (c[to] == -1) {
            if (bolshe[{v, to}])
                c[to] = c[v] - 1;
            else
                c[to] = c[v] + 1;
            get_c(to);
        }
    }
}

void solve2() {
    vector<pair<int, int>> edges;
    for (int i = 0; i < n; i++) {
        for (auto to : g[i]) {
            if (to < i)
                edges.emplace_back(to, i);
        }
    }
    for (int i = 0; i < m; i++) {
        paths.push_back({});
        fill(used, used + n, false);
        find_path(a[i], b[i]);
    }
    int cnt = n + 1000;
    vector<int> res(n, n + 1000);
    int ans = n + 1000;
    c.resize(n);
    for (int mask = 0; mask < (1 << edges.size()); mask++) {
        for (int i = 0; i < n - 1; i++) {
            if (mask & (1 << i)) {
                bolshe[{edges[i].first, edges[i].second}] = true;
                bolshe[{edges[i].second, edges[i].first}] = false;
            } else {
                bolshe[{edges[i].first, edges[i].second}] = false;
                bolshe[{edges[i].second, edges[i].first}] = true;
            }
        }
        bool f = true;
        for (auto v : paths) {
            bool bol = bolshe[{v[0], v[1]}];
            for (int i = 1; i < v.size() - 1; i++) {
                if (bol != bolshe[{v[i], v[i + 1]}])
                    f = false;
            }
        }
        if (f) {
            fill(c.begin(), c.end(), -1);
            c[0] = 1;
            minc = 1;
            get_c(0);
            for (int i = 0; i < n; i++)
                c[i] += 1 - minc;
            int maxc = 1;
            for (auto i : c)
                maxc = max(maxc, i);
            if (maxc < ans) {
                swap(res, c);
                ans = maxc;
            }
        }
    }
    if (ans == n + 1000) {
        cout << -1;
        exit(0);
    }
    cout << ans << endl;
    for (auto i : res) {
        cout << i << " ";
    }
    exit(0);
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // _DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout << fixed << setprecision(10);
    ///--------------------------------------------------------///
    cin >> n >> m >> t;
    c.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        g[l].push_back(r);
        g[r].push_back(l);
    }
    for (int i = 0; i < m; i++) {
        cin >> a[i] >> b[i];
        a[i]--;
        b[i]--;
    }
    ezh();
    if (n <= 15 && m <= 15) {
        solve2();
    }
    ///--------------------------------------------------------///
}