#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define f first
#define s second

typedef long long ll;
typedef long double ld;
typedef vector <int> vi;
typedef pair <int, int> pii;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	#ifdef LOCAL
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif  
}

const int MAXN = 1e6 + 10;
const ll INF = 1e9 + 10;
const int MOD = 1e9 + 7;


int n, m, t;
vector <vi> gr;
vector <pii> tun;
bool was[MAXN];
vector <vi> paths;

void dfs(int u, vi &path, int ver) {
	was[u] = 1;
	if (path.size() == 0 || path.back() != ver)
		path.pb(u);
	for (auto to : gr[u]) {
		if (was[to] == 0)
			dfs(to, path, ver);
	}
	if (path.back() != ver)
		path.pop_back();
}

int can_find(int num, int x, int y) {
	for (int i = 0; i < paths[num].size() - 1; i++) {
		if (paths[num][i] == x && paths[num][i + 1] == y)
			return 1;
		if (paths[num][i] == y && paths[num][i + 1] == x)
			return 2;	
	}
	return -1;
}

int gg[MAXN], newgg[MAXN];

void calc(int u, int dist) {
	newgg[u] = max(newgg[u], dist);
	was[u] = 1;
	for (auto to : gr[u]) {
		if (was[to] == 0)
			calc(to, dist + 1);
	}
}

void colour() { 
	fill(newgg, newgg + n, 1);
	for (int i = 0; i < n; i++) {
		fill(was, was + n, 0);
		calc(i, 1);
	}
	int mx1 = 0, mx2 = 0;
	for (int i = 0; i < n; i++) {
		mx1 = max(mx1, gg[i]);
		mx2 = max(mx2, newgg[i]);
	}
	if (mx1 > mx2) {
		for (int i = 0; i < n; i++)
			gg[i] = newgg[i];
	}
}


int main() {
	fastIO();
	cin >> n >> m >> t;
	gr.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int x, y;
		cin >> x >> y;
		gr[x - 1].pb(y - 1);
		gr[y - 1].pb(x - 1);
	}
	tun.resize(m);
	for (int i = 0; i < m; i++) {
		cin >> tun[i].f >> tun[i].s;
		tun[i].f--;
		tun[i].s--;
	}
	paths.resize(m);
	for (int i = 0; i < m; i++) {
		dfs(tun[i].f, paths[i], tun[i].s);
		fill(was, was + n, 0);
	}
	fill(gg, gg + n, INF);
	for (int mask = 0; mask < (1 << m); mask++) {
		gr.clear();
		gr.resize(n);
		map <pii, bool> mapa;
		bool bad = 0;
		for (int i = 0; i < m; i++) {
			if ((mask >> i) & 1) {
				for (int j = 0; j < paths[i].size() - 1; j++) {
					if (mapa[{paths[i][j + 1], paths[i][j]}])
						bad = 1;
					mapa[{paths[i][j], paths[i][j + 1]}] = 1;
					gr[paths[i][j]].pb(paths[i][j + 1]);
				}
			}
			else {
				for (int j = 0; j < paths[i].size() - 1; j++) {
					if (mapa[{paths[i][j], paths[i][j + 1]}])
						bad = 1;
					mapa[{paths[i][j + 1], paths[i][j]}] = 1;
					gr[paths[i][j + 1]].pb(paths[i][j]);
				}
			}
		}
		if (!bad) {
			colour();
			/*for (int i = 0; i < n; i++)
				cerr << gg[i] << ' ';
			cerr << endl;
			return 0;*/
		}
	}
	
	
	
	int ans = 0;
	for (int i = 0; i < n; i++)
		ans = max(ans, gg[i]);
	if (ans == INF) {
		cout << -1;
		return 0;
	}
	cout << ans << endl;
	if (t) {
		for (int i = 0; i < n; i++)
			cout << gg[i] << ' ';
	}
	
	
	return 0;

}