#include <bits/stdc++.h>

using namespace std;

#define fi first
#define se second
#define mp make_pair
#define pb push_back
#define all(a) a.begin(), a.end()
#define debug(x) cerr << #x << ": " << x << endl

typedef long long ll;
typedef unsigned long long ull;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;
typedef double dbl;

template<typename T1, typename T2> bool chkmin(T1 &x, T2 y) { return y < x ? (x = y, true) : false; };
template<typename T1, typename T2> bool chkmax(T1 &x, T2 y) { return y > x ? (x = y, true) : false; };

void die()
{
    cout << "-1\n";
    exit(0);
}

const int maxN = 500005;
vector<int> G[maxN];
pii path[maxN];
int depth[maxN];
int par[maxN];
map<pii, int> ed;

vector<int> H[maxN];
int col[maxN];

void dfs1(int v, int p = -1, int h = 0)
{
    par[v] = p;
    for (int u : G[v])
        if (u != p)
            dfs1(u, v, h + 1);
}

vector<int> st;
void dfs_find(int v, int b, int p, vector<int> &q)
{
    st.push_back(v);
    if (v == b)
        q = vector<int>(all(st));
    else
        for (int u : G[v])
            if (u != p)
                dfs_find(u, b, v, q);
    st.pop_back();
}

bool cfs(int v, int c = 0)
{
    col[v] = c;
    for (int u : H[v])
    {
        if (col[u] == -1)
        {
            if (!cfs(u, c ^ 1))
            {
                return false;
            }
        }
        else if (col[u] == col[v])
        {
            return false;
        }
    }        
    return true;
}

signed main()
{
#ifdef DEBUG
    freopen("in", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, TASK;
    cin >> n >> m >> TASK;
    for (int i = 0; i < n - 1; ++i)
    {
        int a, b;
        cin >> a >> b;
        G[a].pb(b);
        G[b].pb(a);
        ed[mp(a, b)] = ed[mp(b, a)] = i;
    }
    for (int j = 0; j < m; ++j)
    {
        cin >> path[j].fi >> path[j].se;
    }
    if (TASK == 0)
    {
        int root = 1;
        dfs1(root);
        for (int j = 0; j < m; ++j)
        {
            int a = path[j].fi;
            int b = path[j].se;
            vector<int> p;
            dfs_find(a, b, -1, p);
            for (int i = 0; i + 2 < p.size(); ++i)
            {
                int x = p[i];
                int y = p[i + 1];
                int z = p[i + 2];
                int e1 = ed[mp(x, y)];
                int e2 = ed[mp(y, z)];
                H[e1].push_back(e2);
            }
        }
        memset(col, 255, sizeof(col));
        for (int i = 0; i < n - 1; ++i)
            if (col[i] == -1)
                if (!cfs(i))
                    die();
        cout << n << '\n';
        exit(0);
    }

    return 0;
}

