#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <time.h>
#include <assert.h>


#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back

const int INF = 2e9;

using namespace std;

vector<int> res, p, h;
vector<vector<int>> g;
vector<pair<pair<int, int>, int>> q;
int n, m, t;
int getlca(int a, int b) {
    if (h[a] < h[b]) swap(a, b);
    while (h[a] > h[b]) a = p[a];
    while(a != b) {
        a = p[a];
        b = p[b];
    }
    return a;
}

void dfs(int v) {
    for (int u : g[v]) {
        if (u != p[v]) {
            p[u] = v;
            h[u] = h[v] + 1;
            dfs(u);
        }
    }
}

vector<vector<bool>> ng;
vector<int> dp;

void dfs1(int v) {
    dp[v] = 1;
    for (int i = 0; i < n; i++) {
        if (ng[v][i]) {
            dfs1(i);
            dp[v] = max(dp[v], dp[i] + 1);
        }
    }
}

int get(int mask) {
    for (int i = 0; i < n; i++) fill(all(ng[i]), false);
    for (int i = 0; i < m; i++) {
        int from = q[i].first.first;
        int to = q[i].first.second;
        int lca = q[i].second;
        if ((mask >> i) & 1) {
            while (from != lca && p[from] != -1) {
                ng[from][p[from]] = true;
                from = p[from];
            }
            while (to != lca && p[to] != -1) {
                ng[p[to]][to] = true;
                to = p[to];
            }
        }
        else {
            while (to != lca && p[to] != -1) {
                ng[to][p[to]] = true;
                to = p[to];
            }
            while (from != lca && p[from] != -1) {
                ng[p[from]][from] = true;
                from = p[from];
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (ng[i][j] && ng[j][i]) return INF;
        }
    }

    fill(all(dp), 0);
    for (int i = 0; i < n; i++) {
        if (!dp[i]) dfs1(i);
    }
    return *max_element(all(dp));
}

void solve() {
   
    cin >> n >> m >> t;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int from, to;
        cin >> from >> to;
        from--; to--;
        g[from].pb(to);
        g[to].pb(from);
    }

    p.resize(n, -1);
    h.resize(n);
    q.resize(m);
    res.resize(n);
    ng.resize(n, vector<bool>(n));
    dfs(0);
    for (int i = 0; i < m; i++) {
        int from, to;
        cin >> from >> to;
        from--; to--;
        int lca = getlca(from, to);
        q[i] = { {from, to}, lca };
    }
    
    int ans = INF;
    ng.resize(n, vector<bool>(n));
    dp.resize(n);
    for (int mask = 0; mask < (1LL << m); mask++){
        int x = get(mask);
        if (ans > x) {
            ans = x;
            swap(res, dp);
        }
    }
    if (ans == INF) {
        cout << -1;
        return;
    }

    cout << ans << '\n';
    if (t) {
        for (int i : res) cout << i << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //srand(time(0));
    solve();
}

/*
    Спокойствие, только спокойствие!
*/