#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("sse4")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <numeric>
#include <cmath>
#include <ctime>
#include <chrono>
#include <random>

using namespace std;
using ll = long long;
using ld = long double;
using ull = unsigned long long;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const ll INF = 1e15;
const ll P = 179, Q = 239;
const ll mod = 1e9 + 7;

bool maxi(ll& a, ll b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}

bool mini(ll& a, ll b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}

ll mmax(ll a, ll b) {
	if (a > b) return a;
	return b;
}

ll mmin(ll a, ll b) {
	if (a < b) return a;
	return b;
}

ll add(ll a, ll b) {
	a += b;
	if (a >= mod) {
		a -= mod;
	}
	return a;
}

ll sub(ll a, ll b) {
	a -= b;
	if (a < 0) {
		a += mod;
	}
	return a;
}

ll mul(ll a, ll b) {
	return (a * b) % mod;
}

ll n, m, k;
vector <bool> used;
vector <vector <ll>> g, ng;
vector <vector <ll>> lines;

bool dfs(int v, int i, int target, int p = -1) {
	if (v == target) {
		lines[i].push_back(v);
		return true;
	}
	for (auto& u : g[v]) {
		if (u == p) continue;
		if (dfs(u, i, target, v)) {
			lines[i].push_back(v);
			return true;
		}
	}
	return false;
}

bool cycle = false;
vector <ll> color;

void cdfs(int v) {
	color[v] = 1;
	for (auto& u : ng[v]) {
		if (color[u] == 1) {
			cycle = true;
			return;
		}
		if (!color[u]) {
			cdfs(u);
		}
		if (cycle) {
			return;
		}
	}
	color[v] = 2;
}

vector <ll> ts;

void tdfs(int v) {
	used[v] = true;
	for (auto& u : ng[v]) {
		if (!used[u]) {
			tdfs(u);
		}
	}
	ts.push_back(v);
}

vector <ll> pa;

void pdfs(int v, int p = -1) {
	pa[v] = 1;
	used[v] = true;
	for (auto& x : ng[v]) {
		if (!used[x]) {
			pdfs(x, v);
		}
		maxi(pa[v], pa[x] + 1);
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	ll t;
	cin >> n >> m >> t;
	g.resize(n);
	ng.resize(n);
	for (int i = 0; i < n - 1; ++i) {
		ll v, u;
		cin >> v >> u;
		--v; --u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	lines.resize(m);
	for (int i = 0; i < m; ++i) {
		ll v, u;
		cin >> v >> u;
		--v; --u;
		dfs(v, i, u);
	}
	ll minans = INF, neededmask = -1;
	color.resize(n);
	used.resize(n, false);
	pa.resize(n);
	for (ll mask = 0; mask < (1 << m); ++mask) {
		//		cout << mask << '\n';
		ng.assign(n, vector <ll>());
		//		cout << "Cleared everything\n";
		for (int i = 0; i < m; ++i) {
			if (mask & (1 << i)) {
				for (int j = 1; j < lines[i].size(); ++j) {
					ng[lines[i][j]].push_back(lines[i][j - 1]);
				}
			}
			else {
				for (int j = 1; j < lines[i].size(); ++j) {
					ng[lines[i][j - 1]].push_back(lines[i][j]);
				}
			}
		}
		//		cout << "Generated graph\n";
		color.assign(n, 0);
		cycle = false;
		bool bad = false;
		for (int j = 0; j < n; ++j) {
			if (!color[j]) {
				cdfs(j);
			}
			if (cycle) {
				bad = true;
				break;
			}
		}
		if (bad) {
			//			cout << "Cycle, sorry\n";
			continue;
		}
		used.assign(n, false);
		ts.clear();
		for (int i = 0; i < n; ++i) {
			if (!used[i]) {
				tdfs(i);
			}
		}
		//		cout << "Topsorted\n";
		used.assign(n, false);
		pa.assign(n, 0);
		for (int j = ts.size() - 1; j >= 0; --j) {
			if (!used[ts[j]]) {
				pdfs(ts[j]);
			}
		}
		//		cout << "Painted\n";
		//		cout << "Mask " << mask << '\n';
		//		for (auto& x : pa) {
		//			cout << x << ' ';
		//		}
		ll cure = -INF;
		for (auto& x : pa) {
			maxi(cure, x);
		}
		if (mini(minans, cure)) {
			neededmask = mask;
		}
		//		cout << '\n';
	}
	if (neededmask == -1) {
		cout << -1 << '\n';
	}
	else {
		ll mask = neededmask;
		ng.assign(n, vector <ll>());
		for (int i = 0; i < m; ++i) {
			if (mask & (1 << i)) {
				for (int j = 1; j < lines[i].size(); ++j) {
					ng[lines[i][j]].push_back(lines[i][j - 1]);
				}
			}
			else {
				for (int j = 1; j < lines[i].size(); ++j) {
					ng[lines[i][j - 1]].push_back(lines[i][j]);
				}
			}
		}
		color.assign(n, 0);
		cycle = false;
		bool bad = false;
		for (int j = 0; j < n; ++j) {
			if (!color[j]) {
				cdfs(j);
			}
			if (cycle) {
				bad = true;
				break;
			}
		}
		used.assign(n, false);
		ts.clear();
		for (int i = 0; i < n; ++i) {
			if (!used[i]) {
				tdfs(i);
			}
		}
		used.assign(n, false);
		pa.assign(n, 0);
		for (int j = ts.size() - 1; j >= 0; --j) {
			if (!used[ts[j]]) {
				pdfs(ts[j]);
			}
		}
		cout << minans << '\n';
		for (auto& x : pa) {
			cout << x << ' ';
		}
	}
	return 0;
}