#include <bits/stdc++.h>
#define FOR(i, n) for (int i = 0; i < (int)(n); ++i)
#define debug(x) std::cout << #x << ": " << x << '\n';
#define pb push_back
typedef long long ll;
const int N = 5e5 + 10, LG = 19, P = 31, mod = 1e9 + 7;
std::vector<std::pair<int,int>> g1[N], g2[N];
std::vector<int> g3[N];
int tin[N], tout[N], predI[N], pred[N], h[N];
int LCA[N][LG];
int timer = 0;
void dfs(int v, int p = 0) {
	LCA[v][0] = p;
	FOR(i, LG - 1) {
		LCA[v][i + 1] = LCA[LCA[v][i]][i];
	}
	tin[v] = timer++;
	for (auto e : g1[v]) {
		if (e.first == p) continue;
		predI[e.first] = e.second;
		pred[e.first] = v;
		h[e.first] = h[v] + 1;
		dfs(e.first, v);
	}
	tout[v] = timer++;
}
bool is_pred(int a, int b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}
int up[N];
int get(int v) {
	if (up[v] == v) return v;
	return up[v] = get(up[v]);
}
int not_lca(int a, int b) {
	assert(!is_pred(a, b));
	for (int i = LG - 1; i >= 0; --i) {
		if (!is_pred(LCA[a][i], b)) {
			a = LCA[a][i];
		}
	}
	return a;
}
int lca(int a, int b) {
	if (is_pred(a, b)) return pred[not_lca(b, a)];
	return pred[not_lca(a, b)];
}
int clr[N], answ[N];
void dfs2(int v, int c) {
	clr[v] = c;
	for (auto e : g2[v]) {
		if (clr[e.first] == -1) {
			dfs2(e.first, (c + e.second) % 2);
		}
		if (clr[e.first] != (c + e.second) % 2) {
			std::cout << -1;
			exit(0);
		}
	}
}
int used[N];
std::vector<int> order;
void dfs3(int v) {
	used[v] = 1;
	for (auto e : g3[v]) {
		if (!used[e]) {
			dfs3(e);
		}
	}
	order.pb(v);
}

int main() {
	std::ios::sync_with_stdio(false); std::cin.tie(0); std::cout.tie(0);
	int n, m, t;
	std::cin >> n >> m >> t;
	std::vector<std::pair<int,int>> edges;
	FOR(i, n - 1) {
		int a, b;
		std::cin >> a >> b;
		--a; --b;
		g1[a].pb({b, i});
		g1[b].pb({a, i});
		edges.pb({a, b});
	}
	FOR(i, n) {
		up[i] = i;
	}
	dfs(0);
	FOR(i, m) {
		int a, b;
		std::cin >> a >> b;
		--a; --b;
		int kekA = get(a), kekB = get(b);
		int l = lca(a, b);
		// debug(h[kekA] << ' ' << h[l] << ' ' << pred[kekA])
		// return 0;
		while (h[kekA] - 1 > h[l]) {
			g2[predI[kekA]].pb({predI[pred[kekA]], 0});
			up[kekA] = pred[kekA];
			kekA = get(kekA);
		}
		while (h[kekB] - 1 > h[l]) {
			g2[predI[kekB]].pb({predI[pred[kekB]], 0});
			up[kekB] = pred[kekB];
			kekB = get(kekB);
		}
		if (!is_pred(a, b) && !is_pred(b, a)) {
			kekA = not_lca(a, b);
			kekB = not_lca(a, b);
			g2[predI[kekA]].pb({predI[kekB], 1});
		}
	}
	memset(clr, -1, sizeof(clr));
	FOR(i, n - 1) {
		if (clr[i] == -1) {
			dfs2(i, 0);
		}
	}
	FOR(i, n - 1) {
		if (clr[i] == 0) {
			g3[edges[i].first].pb(edges[i].second);
		}
		else {
			g3[edges[i].second].pb(edges[i].first);
		}
	}
	FOR(i, n) {
		if (!used[i]) {
			dfs3(i);
		}
	}
	FOR(i, n) {
		answ[i] = 1;
	}
	int k = 1;
	for (auto v : order) {
		for (auto to : g3[v]) {
			answ[v] = std::max(answ[v], answ[to] + 1);
		}
		k = std::max(k, answ[v]);
	}
	std::cout << k << '\n';
	FOR(i, n) {
		std::cout << answ[i] << ' ';
	}

}