#define _CRT_SECURE_NO_WARNINGS
#define mp make_pair
#define rep(n, i) for (int i = 0; i < n; ++i)
#define per(n, i) for (int i = n - 1; i >= 0; --i)
#define allv(a) a.begin(), a.end()
#define allar(a, n) a, a + n
#define fastio ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)

#include <functional>
#include <algorithm>
#include <iostream>
#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>
#include <queue>
#include <map>
#include <set>

using namespace std;

typedef long long ll;
typedef double db;
typedef pair <int, int> pii;
typedef pair <ll, ll> pll;

const int INF = (int)1e9 + 7;
const ll MOD = (ll)1e9 + 7;
const db EPS = 1e-7;

const int N = (int)5e5;
const int POW = 19;

int n, m, t, tin[N], tout[N], tm, p[N], up[N][POW], c, color[N], color_cycle[N], color_neib[N], c1;
vector <int> G[N], G1[N], G2[N], G3[N];
set <int> num_neib[N];
bool used[N];
vector <pii> ways;

void make_tin(int v, int pr = -1) {
    p[v] = pr;
    tin[v] = tm++;
    for (int u : G[v]) {
        if (u == pr) {
            continue;
        }
        make_tin(u, v);
    }
    tout[v] = tm++;
}

void make_up() {
    rep(POW, pow) {
        rep(n, v) {
            if (pow == 0) {
                up[v][pow] = p[v];
            } else {
                up[v][pow] = up[v][pow - 1];
                if (up[v][pow] != -1) {
                    up[v][pow] = up[up[v][pow]][pow - 1];
                }
            }
        }
    }
}

bool is_parent(int v, int u) {
    return tin[v] <= tin[u] && tout[v] >= tout[u];
}

int LCA(int v, int u) {
    per(POW, pow) {
        if (up[v][pow] != -1 && !is_parent(up[v][pow], u)) {
            v = up[v][pow];
        }
    }
    if (!is_parent(v, u)) {
        v = p[v];
    }
    return v;
}

bool is_intersect(int ind1, int ind2) {
    fill(allar(used, n), false);
    int v = ways[ind1].first, u = ways[ind1].second;
    while (v != u) {
        used[v] = true;
        v = p[v];
    }
    used[v] = true;
    v = ways[ind2].first, u = ways[ind2].second;
    while (v != u) {
        if (used[v] && used[p[v]]) {
            return true;
        }
        v = p[v];
    }
    return false;
}

bool make_edge_comp() {
    rep(ways.size(), i) {
        bool f = false;
        rep(i, j) {
            if (is_intersect(i, j)) {
                color[i] = color[j];
                f = true;
                break;
            }
        }
        if (!f) {
            color[i] = c++;
        }
    }
    rep(ways.size(), i) {
        for (int u : G1[i]) {
            if (color[i] == color[u]) {
                return false;
            }
            G2[color[i]].push_back(color[u]);
        }
    }
    return true;
}

bool odd_cycle(int v, int c) {
    if (color_cycle[v]) {
        if (color_cycle[v] != c) {
            return false;
        }
        return true;
    }
    color_cycle[v] = c;
    for (int u : G2[v]) {
        if (!odd_cycle(v, 3 - c)) {
            return false;
        }
    }
    return true;
}

void dfs_neib(int v, int c) {
    if (used[v]) {
        return;
    }
    used[v] = true;
    color_neib[v] = c;
    for (int u : G2[v]) {
        dfs_neib(u, c);
    }
}

void make_neib() {
    fill(allar(used, c), false);
    rep(c, i) {
        if (!used[i]) {
            dfs_neib(i, c1);
            ++c1;
        }
    }
    rep(ways.size(), i) {
        int v = ways[i].first, u = ways[i].second;
        while (v != u) {
            num_neib[v].insert(color_neib[color[i]]);
            v = p[v];
        }
        num_neib[v].insert(color_neib[color[i]]);
    }
    rep(n, i) {
        if (num_neib[i].size() == 2) {

        }
    }
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
    scanf("%d%d%d", &n, &m, &t);
    rep(n - 1, i) {
        int v, u;
        scanf("%d%d", &v, &u);
        --v, --u;
        G[v].push_back(u);
        G[u].push_back(v);
    }
    make_tin(0);
    make_up();
    rep(m, i) {
        int a, b;
        scanf("%d%d", &a, &b);
        --a, --b;
        if (tin[a] > tin[b]) {
            swap(a, b);
        }
        int lca = LCA(a, b);
        if (lca == a) {
            ways.push_back(mp(b, a));
        } else {
            int ind = ways.size();
            G1[ind].push_back(ind + 1);
            G1[ind + 1].push_back(ind);
            ways.push_back(mp(a, lca));
            ways.push_back(mp(b, lca));
        }
    }
    if (!make_edge_comp()) {
        printf("-1");
        return 0;
    }
    rep(c, i) {
        if (color_cycle[i]) {
            continue;
        }
        if (!odd_cycle(i, 1)) {
            printf("-1");
            return 0;
        }
    }
    printf("%d", n);
    return 0;
}