#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define int long long
#define ll long long
#define all(a) (int) (a).begin(), (a).end()

using namespace std;

const int MAXN = 500000;
int n, m, t;
vector<int> graph[MAXN];

vector<int> cmn_g[MAXN];
int color[MAXN];
bool visited[MAXN];

void cmn_dfs(int u) {
    if (visited[u]) {
        return;
    }
    visited[u] = true;
    if (color[u] == 0) {
        color[u] = 1;
    }
    for (auto v : cmn_g[u]) {
        color[v] = -1 * color[u];
        cmn_dfs(v);
    }
}

void solve_cmn(int root) {
    if (n < 3) {
        cout << 2 << '\n';
        if (t) {
            cout << "1 2\n";
        }
        return;
    }
    bool is_2 = true;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        if (a != root && b != root) {
            cmn_g[a].push_back(b);
            cmn_g[b].push_back(a);
            is_2 = false;
        }
    }
    if (is_2) {
        cout << "2\n";
        if (t) {
            for (int i = 0; i < n; ++i) {
                cout << ((i == root) ? (1) : (2)) << ' ';
            }
        }
        return;
    }
    for (int i = 0; i < n; ++i) {
        cmn_dfs(i);
    }
    for (int i = 0; i < n; ++i) {
        for (auto v : cmn_g[i]) {
            if (color[i] == color[v]) {
                cout << -1;
                return;
            }
        }
    }
    color[root] = 0;
    cout << "3\n";
    if (t) {
        for (int i = 0; i < n; ++i) {
            cout << color[i] + 2 << ' ';
        }
    }
}

void solve_little() {

}

signed main() {
    cin.tie(0);
    cin.sync_with_stdio(0);
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        if (graph[i].size() == n - 1) {
            solve_cmn(i);
            return 0;
        }
    }
    if (n <= 100) {
        solve_little();
        return 0;
    }
    return 0;
}