#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <map>
#include <set>

using namespace std;

int c[500005], d[500005];
int p[500005][20];
int tin[500005], tout[500005];
vector <vector <int> > G;
vector <pair <pair <int, int>, int > > q;
int l;
int t = 0;
bool ok = true;

void dfs(int v, int p0) {
	d[v] = d[p0] + 1;
	tin[v] = t++;
	p[v][0] = p0;
	for (int i = 1; i <= l; ++i)
		p[v][i] = p[p[v][i - 1]][i - 1];
	for (int u : G[v]) {
		if (u != p0)
			dfs(u, v);
	}
	tout[v] = t++;
}

bool is_anc(int a, int b) {
	if (a == b)
		return true;
	if (tin[a] < tin[b] && tout[a] > tout[b])
		return true;
	return false;
}

int lca(int a, int b) {
	if (is_anc(a, b))
		return a;
	if (is_anc(b, a))
		return b;
	if (d[a] < d[b])
		swap(a, b);
	for (int i = l; i >= 0; --i) {
		if (p[a][i] == -1)
			continue;
		if (d[p[a][i]] >= d[b])
			a = p[a][i];
	}
	for (int i = l; i >= 0; --i) {
		if (p[a][i] != p[b][i]) {
			a = p[a][i];
			b = p[b][i];
		}
	}
	return p[a][0];
}

int log2(int n) {
	int x = 0;
	while ((1 << x) < n)
		++x;
	return x;
}

int pow_n(int n) {
	int x = 1;
	for (int i = 0; i < n; ++i)
		x = x * n;
	return x;
}

bool dfs1(int v, int l, int d) {
	if (v == l)
		return true;
	int p0 = p[v][0];
	if (d * (c[v] - c[p0]) >= 0)
		return false;
	return dfs1(p0, l, d);
}

int main() {
	int n, m, t;
	cin >> n >> m >> t;
	l = log2(n);
	G.resize(n + 1);
	q.resize(m);
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		G[a].push_back(b);
		G[b].push_back(a);
	}
	for (int i = 1; i <= n; ++i) {
		c[i] = 1;
		for (int j = 0; j <= l; ++j)
			p[i][j] = -1;
	}
	d[1] = 0;
	dfs(1, -1);

	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		if (d[a] < d[b])
			swap(a, b);
		q[i].first = { a, b };
		q[i].second = lca(a, b);
	}

	int mc = n + 1;
	int m_mask = 0;
	for (int mask = 0; mask < pow_n(n); ++mask) {
		int mask2 = mask;
		int mc0 = 1;
		for (int i = 1; i <= n; ++i) {
			c[i] = 1 + mask2 % n;
			mc0 = max(mc0, c[i]);
			mask2 /= n;
		}
		if (mc0 > mc)
			continue;
		ok = true;
		for (int i = 0; i < m; ++i) {
			int a, b, l;
			a = q[i].first.first;
			b = q[i].first.second;
			l = q[i].second;
			int d = 1;
			if (c[a] > c[p[a][0]])
				d = -1;
			if (!dfs1(a, l, d))
				ok = false;
			if (!dfs1(b, l, -d))
				ok = false;
		}
		if (ok && mc > mc0) {
			m_mask = mask;
			mc = mc0;
		}
	}
	int mask2 = m_mask;
	for (int i = 1; i <= n; ++i) {
		c[i] = 1 + mask2 % n;
		mask2 /= n;
	}
	if (mc > n) {
		cout << -1;
	} else {
		cout << mc << '\n';
		for (int i = 1; i <= n; ++i)
			cout << c[i] << ' ';
	}
	return 0;
}
