#include <bits/stdc++.h>

#define ll long long
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define ld long double
#define mp make_pair
#define pb push_back

using namespace std;

const int inf = 1e9;

void init() {
#ifdef ONPC
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
#ifdef TEST
    freopen("!inp", "r", stdin);
    freopen("!out", "w", stdout);
#endif

    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

void dfs(int v, vector<vector<int>> &g, vector<int> &level, vector<int> &par, int p = -1){
    if (p == -1)
        level[v] = 0;
    par[v] = p;
    for (auto ev: g[v]){
        if (ev == p)
            continue;
        level[ev] = level[v] +1;
        dfs(ev, g, level, par, v);
    }
}

vector<int> getway(int a, int b, vector<vector<int>> &g, vector<int> &level, vector<int> &par){
    vector<int> ansa;
    vector<int> ansb;
    while(a != b){
        if (level[a] >= level[b]){
            ansa.pb(a);
            a = par[a];
            continue;
        }
        if (level[b] >= level[a]){
            ansb.pb(b);
            b = par[b];
            continue;
        }
    }
    ansa.pb(a);
    reverse(all(ansb));
    for (auto ev: ansb)
        ansa.pb(ev);
    return ansa;
}

int finddep(int v, vector<unordered_set<int>> &g, int p = -1){
    int ans = 1;
    for (auto ev: g[v]){
        if (ev == p)
            continue;
        ans = max(ans, finddep(ev, g, v) + 1);
    }
    return ans;
}

int main() {
    init();

    int n, m, t;
    cin >> n >> m >> t;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        g[u].pb(v);
        g[v].pb(u);
    }
    vector<int> level(n);
    vector<int> par(n);
    dfs(0, g, level, par);

    vector<vector<int>> ways;

    for (int i = 0 ; i < m; i++){
        int a, b;
        cin >> a  >> b;
        a--, b--;
        auto res = getway(a, b, g, level, par);
        ways.pb(res);
    }

    vector<int> result;
    int ans = inf;

    for (int mask = 0; mask < (1 << m); mask++){
        vector<bool> isrev(m, false);
        for (int i = 0; i <m; i++){
            if (((1 << i) & mask) > 0)
                isrev[i] = true;
            else
                isrev[i] = false;
        }
        vector<unordered_set<int>> ng(n);
        for (int i = 0; i< m; i++){
            auto &way = ways[i];
            if (isrev[i]){
                for (int j = way.size() - 1; j > 0; j--){
                    ng[way[j]].insert(way[j - 1]);
                }
            }
            else {
                for (int j = 0; j <way.size() - 1; j++){
                    ng[way[j]].insert(way[j + 1]);
                }
            }
        }
        bool usp = true;
        for (int i = 0; i < n; i++){
            if (!usp)
                break;
            for (int j = i + 1; j < n; j++){
                if (ng[i].count(j) && ng[j].count(i)){
                    usp = false;
                    break;
                }
            }
        }
        if (!usp)
            continue;
        vector<int> curresult(n);

        for (int i = 0; i < n; i++){
            curresult[i] = finddep(i, ng);
        }

        int curmax = 0;
        for (auto ev: curresult)
            curmax= max(curmax, ev);
        if (curmax < ans){
            ans = curmax;
            result = curresult;
        }
    }
    if (ans == inf){
        cout << -1;
        return 0;
    }
    cout << ans << endl;
    for (auto ev: result)
        cout << ev << " ";

    return 0;
}