#define _CRT_SECURE_NO_WARNINGS
#define USE_MATH_DEFINES
#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <cassert>
#include <string>
#include <random>
#include <set>

#define pb push_back
#define mp make_pair
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

mt19937 gen(34);

int n, m, d[500000], col[500000];
bool t;
vector <char> used;
pair <int, int> ed[500000];
vector <vector <int>> gr;
set <int> unused;

void dfs(int v, vector <vector <int>>& gr, int dep) 
{
	d[v] = dep;
	used[v] = 1;
	for (int i = 0; i < gr[v].size(); i++)
		if (used[gr[v][i]] == 1 && (d[v] - d[gr[v][i]]) % 2 == 0)
		{
			cout << -1;
			exit(0);
		} 
		else
			if (used[gr[v][i]] == 0)
				dfs(gr[v][i], gr, dep + 1);
}

void start_dfs(int v, vector <vector <int>>& gr, int c) {
	col[v] = c;
	unused.erase(v);
	for (int i = 0; i < gr[v].size(); i++)
		if (unused.find(gr[v][i]) != unused.end())
			start_dfs(gr[v][i], gr, (c + 2) % 4);
}

void stupid_solve_for_same_end(int x) 
{
	vector <vector <int>> gr;
	gr.resize(n);
	bool added = false;
	for (int i = 0; i < m; i++) 
	{
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		if (u != x && v != x) 
		{
			added = true;
			gr[u].pb(v);
			gr[v].pb(u);
		}
	}
	if (!added) 
	{
		cout << "2\n";
		if(t)
			for (int i = 0; i < n; i++)
				if (i == x)
					cout << "2 ";
				else
					cout << "1 ";
		exit(0);
	}
	used.resize(n);
	for (int i = 0; i < n; i++)
		used[i] = false;
	for (int i = 0; i < n; i++)
		if (!used[i])
			dfs(i, gr, 0);
	for (int i = 0; i < n; i++)
		if(i != x)
			unused.insert(i);
	col[x] = 2;
	while (unused.size() > 0) {
		int v = *unused.begin();
		unused.erase(unused.begin());
		start_dfs(v, gr, 1);
	}
	cout << "3\n";
	if(t)
		for (int i = 0; i < n; i++)
			cout << col[i] << ' ';
	exit(0);
}

bool find_dfs(int v, int to, int pr, vector <int>& way) 	
{
	way.pb(v);
	if (v == to)
		return true;
	for (int i = 0; i < gr[v].size(); i++)
		if (gr[v][i] != pr && find_dfs(gr[v][i], to, v, way))
			return true;
	way.pop_back();
	return false;
}

vector <vector <int>> paths0, paths1;
bool graph[100][100];
int use[100], colors[100];

void my_dfs(int v, vector <vector <int>>& gr) 	
{
	int v_col = 0;
	for (int i = 0; i < gr[v].size(); i++){
		if (!use[gr[v][i]]) 
			my_dfs(gr[v][i], gr);
		v_col = max(v_col, colors[gr[v][i]]);
	}
	use[v] = true;
	colors[v] = v_col + 1;
}

int check(int mask) {
	vector <vector <int>> new_gr(n);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			graph[i][j] = false;
	for (int i = 0; i < m; i++) 
	{
		vector <int> way;
		if (mask & (1 << i))
			way = paths0[i];
		else
			way = paths1[i];
		for (int i = 0; i + 1 < way.size(); i++) 
		{
			new_gr[way[i]].pb(way[i + 1]);
			graph[way[i]][way[i + 1]] = true;
			if (graph[way[i + 1]][way[i]])
				return 1e9;
		}
	}
	for (int i = 0; i < n; i++)
		use[i] = false;
	for (int i = 0; i < n; i++)
		if (use[i] == 0)
			my_dfs(i, new_gr);
	int ans = 0;
	for (int i = 0; i < n; i++)
		ans = max(ans, colors[i]);
	return ans;
}

void stupid_solve_for_m_15() {
	for (int i = 0; i < m; i++)	{
		vector <int> way;
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		find_dfs(u, v, -1, way);
		paths0.pb(way);
		reverse(way.begin(), way.end());
		paths1.pb(way);
	}
	int ans = 1e9, ansmask = -1;
	for (int mask = 0; mask < (1 << (m)); mask++) {
		int p = check(mask);
		if (ans > p) 			
		{
			ans = p;
			ansmask = mask;
		}
	}
	if (ans != 1e9)
	{
		assert(check(ansmask) == ans);
		cout << ans << '\n';
		if (t)
			for (int i = 0; i < n; i++) 
			{
				assert(colors[i] <= ans && colors[i] >= 1);
				cout << colors[i] << ' ';
			}
	}
	else
		cout << -1;
	exit(0);
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin >> n >> m >> t;
	gr.resize(n);
	for (int i = 0; i < n - 1; i++) 
	{
		cin >> ed[i].first >> ed[i].second;
		ed[i].first--;
		ed[i].second--;
		gr[ed[i].first].pb(ed[i].second);
		gr[ed[i].second].pb(ed[i].first);
	}
	bool ch_same_end = true;
	int same_end = -1;
	if (ed[0].first == ed[1].first || ed[0].first == ed[1].second)
		same_end = ed[0].first;
	else
		if (ed[0].second == ed[1].first || ed[0].second == ed[1].second)
			same_end = ed[0].second;
		else
			ch_same_end = false;
	for (int i = 2; i + 1 < n; i++)
		if (same_end != ed[i].first && same_end != ed[i].second)
			ch_same_end = false;
	if (m <= 15)
		stupid_solve_for_m_15();
	if (ch_same_end)
		stupid_solve_for_same_end(same_end);
	cout << "1\n";
	for (int i = 0; i < n; i++)
		cout << "1 ";
	return 0;
}
