#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
#define pb push_back
#define all(arr) arr.begin(), arr.end()
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vi> vvi;
#define forn(i0, n0) for (int i0 = 0; i0 < n0; ++i0)
#define forn1(i0, n0) for (int i0 = 1; i0 < n0; ++i0)
#define F first
#define S second

void init() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int timer = 0;

void dfs(int v, vvi &g, vi &tin, vi &tout, vi &p) {
    tin[v] = timer++;
    for (int u : g[v]) {
        if (u == p[v]) continue;
        p[u] = v;
        dfs(u, g, tin, tout, p);
    }
    tout[v] = timer++;
}

bool son(int v, int u, vi &tin, vi &tout) {
    return (tin[v] <= tin[u] && tout[v] >= tout[u]);
}

int lca(int v, int u, vvi &up, vi &tin, vi &tout) {
    for (int i = 19; i >= 0; --i) {
        int j = up[i][v];
        if (j == -1) continue;
        if (!son(j, u, tin, tout)) v = j;
    }
    if (son(v, u, tin, tout)) return v;
    return up[0][v];
}

const int maxn = 5e5 + 2;

int main() {
    int n, m, t;
    cin >> n >> m >> t;
    vvi g(n);
    forn(i, n - 1) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].pb(u);
        g[u].pb(v);
    }
    vi tin(n), tout(n), p(n, -1);
    dfs(0, g, tin, tout, p);
    vvi up(20, vi(maxn));
    forn(i, n) up[0][i] = p[i];
    forn1(i, 20) {
        forn(j, maxn) {
            if (up[i - 1][j] == -1) up[i][j] = -1; else up[i][j] = up[i - 1][up[i - 1][j]];
        }
    }
    vi ans(n);
    forn(i, m) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        int l = lca(v, u, up, tin, tout);
        int j = v;
        ans[j] = 1;
        int c = 2;
        while (j != l) {
            j = up[0][j];
            ans[j] = c++;
        }
        j = u;
        vi I;
        I.pb(j);
        while (j != l) {
            j = up[0][j];
            I.pb(j);
        }
        I.pop_back();
        reverse(all(I));
        for (int j : I) ans[j] = c++;
    }
    cout << *max_element(all(ans)) << '\n';
    if (t) {
        forn(i, n) cout << ans[i] << ' ';
        cout << '\n';
    }
    return 0;
}