#include <iostream>
#include <vector>

#define int long long

using namespace std;

void dfs(int v, vector<vector<int> > & g, vector<int> & p){
    for (auto i : g[v]){
        if (i != p[v]){
            p[i] = v;
            dfs(i, g, p);
        }
    }
}

vector<vector<int> > mor;
vector<int> a, b;

void paint(int v, int t, vector<int> & nx){
    if (nx[v] != -1){
        if (t){
            mor[v].push_back(nx[v]);
        }else{
            mor[nx[v]].push_back(v);
        }
        paint(nx[v], t, nx);
    }
}

bool good = true;
vector<int> ts;

void topsort(int v, vector<int> &used, int col){
    used[v] = col;
    for (auto i : mor[v]){
        if (used[i] == col){
            good = false;
        }else if (used[i] == 0){
            topsort(i, used, col);
        }
    }
    ts.push_back(v);
}

signed main()
{
    freopen("input.txt", "r", stdin);
    int n, m, t;
    cin >> n >> m >> t;
    vector<vector<int> > g(n);
    for (int i = 0; i < n - 1; i++){
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    a.resize(m);
    b.resize(m);
    for (int i = 0; i < m; i++){
        cin >> a[i] >> b[i];
        a[i]--;
        b[i]--;
    }
    vector<vector<int> > nx(m, vector<int>(n, -1));
    vector<vector<int> > pr(m, vector<int>(n, -1));
    for (int i = 0; i < m; i++){
        vector<int> prev(n, -1);
        dfs(a[i], g, prev);
        int now = b[i];
        while (prev[now] != -1){
            pr[i][now] = prev[now];
            nx[i][prev[now]] = now;
            now = prev[now];
        }
    }
    int answer = 1e9;
    vector<int> ans(n);
    bool ok = false;
    for (int mask = 0; mask < (1 << m); mask++){
        good = 1;
        int cur = 0;
        vector<int> c(n, 1);
        mor.resize(0);
        mor.resize(n);
        for (int i = 0; i < m; i++){
            paint(a[i], ((mask >> i) & 1), nx[i]);
        }
        vector<int> used(n);
        ts.resize(0);
        int col = 1;
        for (int i = 0; i < n; i++){
            if (!used[i]){
                topsort(i, used, col);
                col++;
            }
        }
        for (auto i : ts){
            for (auto v : mor[i]){
                c[i] = max(c[v] + 1, c[i]);
            }
            cur = max(cur, c[i]);
        }
        if (good){
            ok = 1;
            if (cur < answer){
                answer = cur;
                ans = c;
            }
        }
    }
    if (!ok){
        cout << -1 << endl;
    }else{
        if (n == 2){
            cout << 5 / 0;
        }
        cout << answer << endl;
        for (auto i : ans){
            cout << i << ' ';
        }
        cout << endl;
    }
    return 0;
}
