#include <iostream>
#include <vector>
#define fi first
#define se second
using namespace std;

const int MAXN = 500005;

struct edge
{
    int u, v, d;
};

int n, m, t;
vector<int> g[MAXN];
edge e[MAXN];

int vis[MAXN];
pair<int, int> route[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m >> t;
    for (int i = 1; i < n; ++ i)
    {
        int u, v;
        cin >> e[i].u >> e[i].v;
        u = e[i].u;
        v = e[i].v;
        g[u].push_back(i);
        g[v].push_back(i);
        e[i].d = -1;
    }
}

bool DFS1(int u, int s, int dep = 1)
{
    if (u == s)
    {
        vis[u] = max(vis[u], dep);
        return true;
    }

    for (int adj : g[u])
    {
        int v, r;
        if (e[adj].u == u) {v = e[adj].v; r = 0;}
        else {v = e[adj].u; r = 1;}

        if (e[adj].d == -1)
        {
            e[adj].d = r;
            bool res = DFS1(v, s, dep + 1);
            if (res)
            {
                vis[u] = max(vis[u], dep);
                return true;
            }
            else e[adj].d = -1;
        }
        else if (e[adj].d == r)
        {
            e[adj].d = r;
            bool res = DFS1(v, s, dep + 1);
            if (res)
            {
                vis[u] = max(vis[u], dep);
                return true;
            }
        }
    }

    return false;
}

bool DFS2(int u, int s, int dep = 1)
{
    if (u == s)
    {
        vis[u] = max(vis[u], dep);
        return true;
    }

    dep = max(dep, vis[u]);

    for (int adj : g[u])
    {
        int v, r;
        if (e[adj].u == u) {v = e[adj].v; r = 0;}
        else {v = e[adj].u; r = 1;}

        if (e[adj].d == -1)
        {
            e[adj].d = r;
            bool res = DFS2(v, s, dep + 1);
            if (res)
            {
                vis[u] = max(vis[u], dep);
                return true;
            }
            else e[adj].d = -1;
        }
        else if (e[adj].d == r)
        {
            e[adj].d = r;
            bool res = DFS2(v, s, dep + 1);
            if (res)
            {
                vis[u] = max(vis[u], dep);
                return true;
            }
        }
    }

    return false;
}

int main()
{
    Init();

    // cout << "inp 1 comp" << endl;

    for (int i = 1; i <= m; ++ i)
    {
        int s, e;
        cin >> route[i].fi >> route[i].se;
        s = route[i].fi;
        e = route[i].se;

        if (!DFS1(s, e))
        {
            cout <<  -1 << endl;
            return 0;
        }
    }

    for (int j = 1; j <= 100; ++ j)for (int i = 1; i <= m; ++ i)
    {
        int s, e;
        s = route[i].fi;
        e = route[i].se;

        DFS2(s, e);
    }

    int ans = 0;
    for (int i = 1; i <= n; ++ i)
    {
        vis[i] = max(vis[i], 1);
        ans = max(ans, vis[i]);
    }

    cout << ans << endl;
    if (t == 1)
    {
        for (int i = 1; i <= n; ++ i)
        {
            cout << vis[i] << ' ';
        }
        cout << endl;
    }

    return 0;
}
