#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void dfs1(int u, int f, vector <bool> &used, vector <vector <int>> &g, vector <vector <int>>& p, vector <vector <int>>& d) {
	used[u] = true;
	for (int v : g[u]) 
		if (!used[v]) {
			d[f][v] = d[f][u] + 1;
			p[f][v] = u;
			dfs1(v, f, used, g, p, d);
		}
}

void dfs2(int u, vector <bool>& used, vector <vector <int>>& g, vector <int>& order) {
	used[u] = true;
	for (int v : g[u])
		if (!used[v])
			dfs2(v, used, g, order);
	order.push_back(u);
}

void dfs3(int u, vector <bool>& used, vector <vector <int>>& g) {
	used[u] = true;
	for (int v : g[u])
		if (!used[v])
			dfs3(v, used, g);
}

void dfs4(int u, vector <bool>& used, vector <int>& color, vector <vector <int>>& g) {
	used[u] = true;
	for (int v : g[u]) {
		if (!used[v])
			dfs4(v, used, color, g);
		color[u] = max(color[u], color[v] + 1);
	}
}
int main() {
	int n, m, t;
	cin >> n >> m >> t;
	vector <bool> used(n);
	vector <vector <int>> g(n), d(n, vector <int>(n)), p(n, vector <int>(n)), gg(n), _gg(n);
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	for (int i = 0; i < n; i++) {
		used.assign(n, false);
		d[i][i] = 0;
		dfs1(i, i, used, g, p, d);
	}
	vector <pair <int, int>> b(m);
	for (int i = 0; i < m; i++) {
		cin >> b[i].first >> b[i].second;
		b[i].first--;
		b[i].second--;
	}
	for (int i = 0; i < m; i++) {
		int u = b[i].first;
		int v = b[i].second;
		while (u != v) {
			gg[p[u][v]].push_back(v);
			_gg[v].push_back(p[u][v]);
			v = p[u][v];
		}
	}
	used.assign(n, false);
	vector <int> order;
	for (int i = 0; i < n; i++)  
		if (!used[i]) 
			dfs2(i, used, gg, order);
	used.assign(n, false);
	for (int i = 0; i < n; i++) {
		int v = order[n - i - 1];
		if (used[v]) {
			cout << "-1";
			return 0;
		}
		dfs3(v, used, _gg);
	}
	vector <int> color(n, 1);
	used.assign(n, false);
	for (int i = 0; i < n; i++) {
		int v = order[n - i - 1];
		if (!used[v])
			dfs4(v, used, color, gg);
	}
	int k = 0;
	for (int i = 0; i < n; i++)
		k = max(k, color[i] + 1);
	cout << k - 1 << endl;
	for (int i = 0; i < n; i++)
		cout << k - color[i] << " ";
	return 0;
}