#define _GLIBCXX_DEBUG


#include <bits/stdc++.h>


#define ll long long


#define ld long double
#define all(v) v.begin(), v.end()
#define trace(x) cout << #x"=" << x << endl


using namespace std;

const ll inf = 1e9;
const ll mod = 1e9 + 7;
const double eps = 1e-7;

const int maxn = 20;

vector<int> graph[maxn];
int dir[maxn][maxn];

vector<int> paths[maxn];

bool was[maxn];

vector<int> get_path(int v, int to) {
    if (v == to) {
        return {to};
    }
    was[v] = true;
    vector<int> ans;
    for (int u: graph[v]) {
        if (!was[u]) {
            vector<int> res = get_path(u, to);
            if (!res.empty()) {
                ans = {v};
                ans.insert(ans.end(), res.begin(), res.end());
                break;
            }
        }
    }
    return ans;
}

int res[maxn];

void check(int v, int depth = 1) {
    was[v] = true;
    res[v] = max(res[v], depth);
    for (int u: graph[v]) {
        if (!was[u] && dir[v][u] == 1) {
            check(u, depth + 1);
        }
    }
}


int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int n, m, t;
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        graph[a].emplace_back(b);
        graph[b].emplace_back(a);
    }
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a, --b;
        memset(was, 0, sizeof(was));
        paths[i] = get_path(a, b);
    }
    int mx = inf;
    int best[n];
    for (int mask = 0; mask < (1 << m); ++mask) {
        bool good = true;
        memset(dir, 0, sizeof(dir));
        for (int i = 0; i < m; ++i) {
            if ((mask >> i) & 1) {
                for (int j = 0; j < ((int) paths[i].size()) - 1; ++j) {
                    int it = dir[paths[i][j]][paths[i][j + 1]];
                    if (it == -1) {
                        good = false;
                    }
                    dir[paths[i][j]][paths[i][j + 1]] = 1;
                    dir[paths[i][j + 1]][paths[i][j]] = -1;
                }
            } else {
                for (int j = 0; j < ((int) paths[i].size()) - 1; ++j) {
                    int it = dir[paths[i][j + 1]][paths[i][j]];
                    if (it == -1) {
                        good = false;
                    }
                    dir[paths[i][j + 1]][paths[i][j]] = 1;
                    dir[paths[i][j]][paths[i][j + 1]] = -1;
                }
            }
        }
        if (!good) continue;
        memset(res, 0, sizeof(res));
        for (int i = 0; i < n; ++i) {
            memset(was, 0, sizeof(was));
            check(i);
        }
        int now = -1;
        for (int i = 0; i < n; ++i) {
            now = max(now, res[i]);
        }
        if (now < mx) {
            mx = now;
            copy(res, res + n, best);
        }
    }
    if (mx == inf) {
        cout << -1;
    } else {
        cout << mx << "\n";
        for (int i = 0; i < n; ++i) {
            best[i] = max(1, best[i]);
            cout << best[i] << " ";
        }
    }
}