#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <cmath>
#include <random>
#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

random_device rd;
mt19937 rnd(rd());

vector <vector <ll>> gr;
vector <vector <ll>> gr2;
vector <ll> p;
vector <bool> u;

void bfs(ll v, ll fin) {
    queue <ll> q;
    q.push(v);
    u[v] = true;
    while (!q.empty()) {
        ll t = q.front();
        q.pop();
        for (auto to : gr[t]) {
            if (!u[to]) {
                q.push(to);
                p[to] = t;
                u[t] = true;
                if (to == fin)
                    return;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n, m, t;
    cin >> n >> m >> t;
    gr.resize(n);
    gr2.resize(n);
    u.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll a, b;
        cin >> a >> b, a--, b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    vector <ll> ans(n, 1);
    for (ll i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b, a--, b--;
        p.assign(n, -1);
        u.assign(n, false);
        bfs(a, b);
        ll temp = b;
        while (p[temp] != -1) {
            ans[p[temp]] = ans[temp] + 1;
            temp = p[temp];
        }
    }
    cout << *max_element(ans.begin(), ans.end()) << '\n';
    if (t == 1){
        for (ll i = 0; i < n; i++)
            cout << ans[i] << " ";
    }
    return 0;
}