#include <algorithm>
#include <iostream>
#include <vector>
#include <bitset>
#include <queue>
#include <set>
#include <map>
using namespace std;

const int LOG = 20;
int it = 0;
vector<pair<int, int> > e;
vector<int> c, h, tin, tout;
vector<vector<int> > g, pr;
vector<vector<vector<int> > > l;

void dfs(int v, int P = -1){
    tin[v] = it++;
    if(P==-1)
        pr[0][v] = v;
    else
        pr[0][v] = P;
    for(int i = 0; i<g[v].size(); i++){
        if(g[v][i]==P)
            continue;
        e.push_back({v, g[v][i]});
        h[g[v][i]] = h[v]+1;
        dfs(g[v][i], v);
    }
    tout[v] = it++;
}

bool up(int a, int b){
    return (tin[a]<=tin[b]&&tout[b]<=tout[a]);
}

int lca(int a, int b){
    if(up(a, b))
        return a;
    if(up(b, a))
        return b;
    for(int i = LOG-1; i>=0; i--){
        if(up(pr[i][a], b))
            continue;
        a = pr[i][a];
    }
    return pr[0][a];
}

int len(int a, int b){
    return h[a]+h[b]-2*h[lca(a, b)];
}

void dfs1(int v, int pr = -1){
    cout << v << ':' << c[v] << endl;
    vector<bool> u(g[v].size());
    queue<int> q;
    for(int i = 0; i<g[v].size(); i++){
        if(c[g[v][i]]!=0){
            u[i] = true;
            q.push(i);
        }
    }
    while(!q.empty()){
        int it = q.front();
        q.pop();
        int dl = c[g[v][it]]-c[v];
        for(int i = 0; i<l[v][it].size(); i++){
            if(u[l[v][it][i]]){
                if(c[g[v][l[v][it][i]]]!=c[v]-dl){
                    cout << -1;
                    exit(0);
                }
                continue;
            }
            cout << g[v][it] << "->" << g[v][l[v][it][i]] << ' ' << c[v]-dl << '/' << c[g[v][it]] << endl;
            c[g[v][l[v][it][i]]] = c[v]-dl;
            u[l[v][it][i]] = true;
            q.push(l[v][it][i]);
        }
    }
    for(int it = 0; it<g[v].size(); it++){
        if(u[it])
            continue;
        c[g[v][it]] = c[v]+1;
        u[it] = true;
        q.push(it);
        while(!q.empty()){
            int it = q.front();
            q.pop();
            int dl = c[g[v][it]]-c[v];
            for(int i = 0; i<l[v][it].size(); i++){
                if(u[l[v][it][i]]){
                    if(c[g[v][l[v][it][i]]]!=c[v]-dl){
                        cout << -1;
                        //for(int i = 0; i<1000'000; i++)
                            //cout << endl;
                        exit(0);
                    }
                    continue;
                }
                cout << g[v][it] << "->" << g[v][l[v][it][i]] << ' ' << c[v]-dl << '/' << c[g[v][it]] << endl;
                c[g[v][l[v][it][i]]] = c[v]-dl;
                u[l[v][it][i]] = true;
                q.push(l[v][it][i]);
            }
        }
    }
    for(int i = 0; i<g[v].size(); i++){
        if(g[v][i]==pr)
            continue;
        dfs1(g[v][i], v);
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, t;
    cin >> n >> m >> t;
    g.resize(n);
    h.resize(n);
    tin.resize(n);
    tout.resize(n);
    pr.resize(LOG, vector<int>(n));
    for(int i = 1; i<n; i++){
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    c.resize(n, 1);
    l.resize(n);
    for(int i = 0; i<n; i++)
        l[i].resize(g[i].size());
    h[0] = 0;
    dfs(0);
    for(int i = 1; i<LOG; i++)
        for(int j = 0; j<n; j++)
            pr[i][j] = pr[i-1][pr[i-1][j]];
    vector<pair<int, int> > jij(m);
    vector<vector<int> > jija(m);
    vector<vector<int> > jj(n);
    for(int i = 0; i<m; i++){
        cin >> jij[i].first >> jij[i].second;
        jij[i].first--;
        jij[i].second--;
        jj[jij[i].first].push_back(jij[i].second);
        jj[jij[i].second].push_back(jij[i].first);
        int ln = len(jij[i].first, jij[i].second), fn = jij[i].second, st = jij[i].first, ln1 = 0;
        for(int v = jij[i].first;;){
            jija[i].push_back(v);
            //cout << st << "->" << v << "->" << fn << endl;
            int pr = -1, nx = -1;
            if(v==fn)
                break;
            for(int i = 0; i<g[v].size(); i++){
                int k = len(g[v][i], fn), k1 = len(g[v][i], st);
                if(k==ln-1)
                    nx = i;
                if(k1==ln1-1)
                    pr = i;
            }
             if(pr!=-1&&nx!=-1){
                l[v][nx].push_back(pr);
                l[v][pr].push_back(nx);
            }
            ln--;
            ln1++;
            v = g[v][nx];
        }
    }
    if(false){
        int ans = 1'000'000'000;
        for(int i = 0; i<(1<<(n-1)); i++){
            bitset<15> it = i;
            vector<int> c1(n);
            c1[0] = 1;
            for(int j = 0; j<n-1; j++){
                if(it[j])
                    c1[e[j].second] = c1[e[j].first]+1;
                else
                    c1[e[j].second] = c1[e[j].first]-1;
            }
            int mn = 1, mx = 1;
            for(int i = 0; i<n; i++)
                mn = min(mn, c1[i]);
            for(int i = 0; i<n; i++){
                c1[i] = c1[i]-mn+1;
                mx = max(mx, c1[i]);
            }
            bool kek = false;
            for(int i = 0; i<m; i++){
                for(int j = 1; j<jija[i].size()-1; j++){
                    //cout << c1[jija[i][j]]-c1[jija[i][j-1]] << "!=" << c1[jija[i][j+1]]-c1[jija[i][j]] << endl;
                    if(c1[jija[i][j]]-c1[jija[i][j-1]]!=c1[jija[i][j+1]]-c1[jija[i][j]]){
                        kek = true;
                        break;
                    }
                }
                if(kek)
                    break;
            }
            if(kek)
                continue;
            if(mx<ans){
                ans = mx, c.swap(c1);
            }
        }
        if(ans>n){
            cout << -1;
            return 0;
        }
        cout << ans << '\n';
        for(int i = 0; i<n; i++)
            cout << c[i] << ' ';
        return 0;
    }
    int rt = 0;
    for(int i = 0; i<n; i++){
        if(g[i].size()>0){
            rt = i;
            break;
        }
    }
    c[rt] = 2;
    vector<bool> u(n, false);
    for(int i = 0; i<n; i++){
        if(u[i]||i==rt)
            continue;
        queue<int> q;
        u[i] = true;
        q.push(i);
        while(!q.empty()){
            int v = q.front();
            q.pop();
            for(int i = 0; i<jj[v].size(); i++){
                if(jj[v][i]==rt)
                    continue;
                if(u[jj[v][i]]){
                    if(c[jj[v][i]]!=4-c[v]){
                        cout << -1;
                        return 0;
                    }
                    continue;
                }
                c[jj[v][i]] = 4-c[v];
                q.push(jj[v][i]);
                u[jj[v][i]] = true;
            }
        }
    }
    int mx = 1;
    for(int i = 0; i<n; i++)
        mx = max(mx, c[i]);
    cout << mx << '\n';
    for(int i = 0; i<n; i++)
        cout << c[i] << ' ';
    /*for(int v = 0; v<n; v++){
        cout << v << ") ";
        for(int it = 0; it<l[v].size(); it++){
            cout << g[v][it] << '|';
            for(int i = 0; i<l[v][it].size(); i++)
                cout << g[v][l[v][it][i]] << ':';
            cout << ' ';
        }
        cout << '\n';
    }*/
    /*c[0] = 1;
    dfs1(0);
    int mn = 1;
    for(int i = 0; i<n; i++)
        mn = min(mn, c[i]);
    int mx = 1;
    for(int i = 0; i<n; i++){
        c[i] = c[i]-mn+1;
        mx = max(mx, c[i]);
    }
    cout << mx << '\n';
    for(int i = 0; i<n; i++)
        cout << c[i] << ' ';
    /*sort(jij.begin(), jij.end(), [&](pair<int, int> a, pair<int, int> b)->bool{return len(a.first, a.second)>len(b.first, b.second);});
    vector<bool> u(m);
    for(int i = 0; i<m; i++){
        if(u[i])
            continue;
        //cout << jij[i].first << ':' << jij[i].second << endl;
        //cout << len(jij[i].second, jij[i].second) << "FDSFDSF" << endl;
        u[i] = true;
        int it = 1, ln = len(jij[i].first, jij[i].second);
        //cout << i << endl;
        for(int v = jij[i].first;;){
            //cout << v << ' ' << lca(v, jij[i].second) << ' ' << len(v, jij[i].second) << endl;
            //cout << v << '/' << jij[i].second << ':' << ln << endl;
            c[v] = it++;
            if(v==jij[i].second)
                break;
            for(int j = 0; j<g[v].size(); j++){
                int k = len(g[v][j], jij[i].second);
                //cout << '[' << g[v][i] << ';' << jij[i].second << ']' << " = " << k << endl;
                //cout << v << "->" << g[v][i] << ' ' << k << '/' << ln << endl;
                if(k<ln){
                    ln = k;
                    v = g[v][j];
                    break;
                }
            }
        }
        int lc = lca(jij[i].first, jij[i].second);
        while(true){
            bool kek = true;
            for(int j = i+1; j<m; j++){
                if(u[j])
                    continue;
                int lc1 = lca(jij[j].first, jij[j].second);
                if(up(lc, lc1)){
                    //cout << up(lc1, jij[i].first) << endl;
                    if(!up(lc1, jij[i].first)&&!up(lc1, jij[i].second))
                        continue;
                }
                else if(up(lc1, lc)){
                    if(!up(lc, jij[j].first)&&!up(lc, jij[j].second))
                        continue;
                }
                else
                    continue;
                kek = false;
                u[j] = true;
                int dl = 0;
                int ln = len(lc1, jij[j].first);
                for(int i = 0; i<g[lc1].size(); i++){
                    int k = len(g[lc1][i], jij[j].first);
                    if(ln>k){
                        if(c[g[lc1][i]]!=-1){
                            if(c[g[lc1][i]]<c[lc1])
                                dl = 1;
                            else
                                dl = -1;
                            break;
                        }
                    }
                }
                ln = len(lc1, jij[j].second);
                int dl1 = 0;
                for(int i = 0; i<g[lc1].size(); i++){
                    int k = len(g[lc1][i], jij[j].second);
                    if(ln>k){
                        if(c[g[lc1][i]]!=-1){
                            if(c[g[lc1][i]]>c[lc1])
                                dl1 = 1;
                            else
                                dl1 = -1;
                            break;
                        }
                    }
                }
                //cout << jij[j].first << ':' << jij[j].second << ' ' << dl << ':' << dl1 << endl;
                if(dl!=0&&dl1!=0&&dl!=dl1){
                    cout << -1;
                    return 0;
                }
                if(dl==0)
                    dl = dl1;
                if(dl==0)
                    dl = 1;
                int it = c[lc1]-dl*len(lc1, jij[j].first);
                ln = len(jij[j].first, jij[j].second);
                for(int v = jij[j].first;;){
                    c[v] = it;
                    if(v==jij[j].second)
                        break;
                    it += dl;
                    for(int i = 0; i<g[v].size(); i++){
                        int k = len(g[v][i], jij[j].second);
                        if(ln>k){
                            v = g[v][i];
                            ln = k;
                            break;
                        }
                    }
                }
            }
            if(kek)
                break;
        }
    }
    int mx = 1;
    for(int i = 0; i<n; i++)
        mx = max(mx, c[i]);
    cout << mx << '\n';
    for(int i = 0; i<n; i++){
        if(c[i]==-1)
            c[i] = 1;
        cout << c[i] << ' ';
    }*/

    return 0;
}
/*
5 2 1
1 2
1 3
1 4
1 5
2 3
4 5

6 2 1
1 2
3 2
2 4
4 5
4 6
1 5
3 6
*/
