#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstring>
#include <ctime>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stdio.h>
#include <string>
#include <vector>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 0

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, int> pli;
typedef pair<ll, ll> pll;

void solve();

const ll MAXN = 3e5 + 7;
const ll INF = 2e9 + 11;
const ll MOD = 1e9 + 9;
const ll INF1 = 9e18;
const ld EPS = 1e-8;

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    if (multi_test) cin >> q;
    while (q--) solve();
}

/*----------------------------------------------------------------------------*/

void bfs(int s, vector<int> &par, const vector<vector<int>> &g) {
    par[s] = -1;
    vector<bool> used(g.size());
    used[s] = true;
    queue<int> q;
    q.push(s);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int to : g[v]) {
            if (!used[to]) {
                used[to] = true;
                par[to] = v;
                q.push(to);
            }
        }
    }
}

int f(const vector<int> &path, const vector<int> &cnt) {
    int res = 0;
    for (int i : path) {
        res += cnt[i] > 1;
    }
    return res;
}

void f0(int &a, int &b, const vector<int> &path, const vector<vector<pii>> &cnt, const vector<vector<int>> &vf) {
    a = b = 0;
    for (int i = 1; i < path.size(); ++i) {
        a += cnt[path[i]].size() > 0;
        for (pii j : cnt[path[i]]) {
            b += vf[j.first][j.second];
        }
    }
}

void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    vector<vector<vector<int>>> paths(n, vector <vector<int>>(n));
    for (int i = 0; i < n; ++i) {
        vector<int> par(n);
        bfs(i, par, g);
        for (int j = 0; j < n; ++j) {
            if (i == j)
                continue;
            vector<int> path;
            for (int k = j; k != -1; k = par[k])
                path.push_back(k);
            reverse(all(path));
            paths[i][j] = path;
        }
    }
    vector<pii> vm(m);
    vector<vector<int>> cnt(n, vector<int>(n));
    vector<int> cnt2(n);
    vector<vector<pii>> cnt3(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        vm[i] = mp(a, b);
        cnt3[a].push_back(mp(a, b));
        for (int i = 0; i < paths[a][b].size() - 1; ++i) {
            ++cnt2[paths[a][b][i]];
            ++cnt[paths[a][b][i]][paths[a][b][i + 1]];
            if (cnt[paths[a][b][i + 1]][paths[a][b][i]] >= cnt[paths[a][b][i]][paths[a][b][i + 1]]) {
                cout << "-1\n";
                exit(0);
            }
        }
    }
    vector<vector<int>> vf(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j)
                continue;
            vf[i][j] = f(paths[i][j], cnt2);
        }
    }
    vector<vector<int>> vf0(n, vector<int>(n));
    vector<vector<int>> vf1(n, vector<int>(n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j)
                continue;
            f0(vf0[i][j], vf1[i][j], paths[i][j], cnt3, vf);
        }
    }
    sort(vm.begin(), vm.end(), [=](const pii &a, const pii &b) { return vf0[a.first][a.second] > vf0[b.first][b.second] ||
        vf0[a.first][a.second] == vf0[b.first][b.second] && vf1[a.first][a.second] > vf1[b.first][b.second]; });
    vector<int> vres(n, 1);
    int ans = 0;
    for (int i = 0; i < m; ++i) {
        //vres[paths[vm[i].first][vm[i].second][0]] = max(vres[paths[vm[i].first][vm[i].second][0]], 1);
        for (int j = 1; j < paths[vm[i].first][vm[i].second].size(); ++j) {
            vres[paths[vm[i].first][vm[i].second][j]] = max(vres[paths[vm[i].first][vm[i].second][j]],
                vres[paths[vm[i].first][vm[i].second][j - 1]] + 1);
            ans = max(ans, vres[paths[vm[i].first][vm[i].second][j]]);
        }
    }
    cout << ans << '\n';
    for (int i : vres)
        cout << i << ' ';
    cout << '\n';
}