#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <ctime>
#include <cmath>
#include <map>
#include <set>
#include <algorithm>
#include <vector>
using namespace std;
#define fs first
#define sc second
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
const int maxn = 5e5 + 100;
const int mod = 1e9 + 7;
#define dbg(x) cout<<#x<<" "<<x<<endl; 

vector<int> g[maxn];
set<int> g2[maxn];
int p[maxn];
vector<int> order;
bool u[maxn];

void dfs(int v, int pr) {
	p[v] = pr;
	for (int i : g[v]) 
		if (i != pr) dfs(i, v);
}

void dfs2(int v) {
	u[v] = 1;
	for (int i : g2[v]) {
		if (!u[i]) dfs2(i);
	}
	order.push_back(v);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n, m, t;
	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		a--; b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	vector<pii> tns;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		tns.push_back({ a - 1,b - 1 });
	}

	int best = 1e9;
	vector<int> ans;
	for (int ti = 0; ti < (1 << m); ++ti) {
		for (int j = 0; j < n; ++j) g2[j].clear();
		bool fail = 0;
		for (int j = 0; j < m; ++j) {
			int v = tns[j].fs, u = tns[j].sc;
			if (ti & (1 << j)) swap(v, u);
			dfs(v, -1);
			for (; p[u] != -1; u = p[u]) {
				if (g2[u].find(p[u]) != g2[u].end()) fail = 1;
				g2[p[u]].insert(u);
			}
		}
		if (fail) continue;
		vector<int> c(n);

		for (int i = 0; i < n; ++i) u[i] = 0;
		order.clear();
		for (int i = 0; i < n; ++i) {
			if (!u[i]) {
				dfs2(i);
			}
		}
		reverse(order.begin(), order.end());
		for (int i : order) {
			if (c[i] == 0) c[i] = 1;
			for (int j : g2[i]) c[j] = c[i] + 1;
		}
		int k = 0;
		for (int i = 0; i < n; ++i) k = max(k, c[i]);
		if (k < best) {
			best = k;
			ans = c;
		}
	}
	if (best == 1e9) return cout << -1, 0;
	cout << best << endl;
	for (int i : ans) cout << i << " ";
	return 0;
}