#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <deque>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long
int LOG = 21, tm = 0;

vector<vector<int>> a;
vector<vector<int>> pp(LOG);
vector<int> tin, tout;

void dfs(int v, int par = -1)
{
	tin[v] = tm++;
	pp[v][0] = par;
	for (auto i : a[v])
	{
		if (i == par) continue;
		dfs(i, v);
	}
	tout[v] = tm++;
}

bool isPar(int u, int v)
{
	return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}

int lca(int x, int y)
{
	if (isPar(x, y)) return x;
	if (isPar(y, x)) return y;
	for (int i = LOG - 1; i >= 0; i--)
	{
		if (!isPar(pp[x][i], y)) x = pp[x][i];
	}
	return pp[x][0];
}

vector<int> ans;
vector<char> usd;
bool dfs2(int v, int par)
{
	bool flag = usd[v];
	for (auto i : a[v])
	{
		if (i == par) continue;
		if (dfs2(i, v))
		{
			ans[v] = max(ans[v], ans[i] + 1);
			flag = true;
		}
	}
	return flag;
}

vector<vector<int>> kolvo;

int32_t main()
{
	int n, m, ttt;
	cin >> n >> m >> ttt;
	a.resize(n, vector<int>(0));
	kolvo.resize(n, vector<int>(0));
	for (int i = 1; i < n; i++)
	{
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		a[x].push_back(y);
		a[y].push_back(x);
	}
	pp.resize(n, vector<int>(0));
	tin.resize(n);
	tout.resize(n);
	ans.resize(n, 1);
	usd.resize(n, false);

	vector<pair<int, int>> read(m);
	for (int i = 0; i < m; i++)
	{
		cin >> read[i].x >> read[i].y;
		read[i].x--;
		read[i].y--;
		kolvo[read[i].x].push_back(read[i].y);
		kolvo[read[i].y].push_back(read[i].x);
		usd[read[i].x] = true;
		usd[read[i].y] = true;
	}


	for (int i = 0; i < n; i++)
	{
		if (kolvo[i].size() == m)
		{
			usd[i] = false;
			dfs2(i, i);
			cout << ans[i] << '\n';
			for (auto i : ans) cout << i << " ";
			return 0;
		}
	}
	
	return 2;


	/*dfs(0, 0);
	
	vector<vector<int>> path(m, vector<int>(0));
	int mx = 0;
	for (int i = 0; i < m; i++)
	{
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		int u = lca(x, y);
		while (x != u)
		{
			path[i].push_back(x);
			x = pp[x][0];
		}
		path[i].push_back(x);
		vector<int> tmp;
		while (y != u)
		{
			tmp.push_back(y);
			y = pp[y][0];
		}
		for (int i = tmp.size() - 1; i >= 0; i--) path[i].push_back(tmp[i]);
		mx = max(mx, (int)path[i].size());
	}
	vector<int> ans(n, 1);*/
	return 0;
}