#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <string>
#include <set>
#include <map>
#include <random>

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pa;
typedef pair<ll, ll> pall;
typedef pair<ld, ld> pald;

mt19937 rnd(228228);

void die() {
	int i = 0;
	while (true) {
		++i;
	}
}

struct go {
	int to, id;
};

const int N = 5e5, LG = 22;
int n, m, t, ans = 1;

int lca[N][LG];
vector<go> g[N];
int pS[N], szS[N], deep[N], parid[N], up[N];


int valans[N];
int used[N];
int mor[N];

map<int, vector<int>> ng[N];

void warp() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	for (int i = 0; i < N; ++i) {
		pS[i] = i, szS[i] = 1;
	}
}


void dfs(int v, int p) {
	if (p != -1) {
		lca[v][0] = p;
		for (int h = 1; h < LG; ++h) {
			lca[v][h] = lca[lca[v][h - 1]][h - 1];
		}
		deep[v] = deep[p] + 1;
		up[v] = p;
	}
	for (go e : g[v]) {
		if (e.to != p) {
			parid[e.to] = e.id;
			dfs(e.to, v);
		}
	}

}

vector<pa> arr;

int getlca(int v, int u) {
	if (deep[v] < deep[u])
		swap(v, u);
	for (int h = LG - 1; h >= 0; --h) {
		if (deep[lca[v][h]] >= deep[u])
			v = lca[v][h];
	}
	if (v == u)
		return v;
	for (int h = LG - 1; h >= 0; --h) {
		if (lca[v][h] != lca[u][h])
			v = lca[v][h], u = lca[u][h];
	}
	return lca[v][0];
}

pa palca(int v, int u) {
	if (deep[v] < deep[u])
		swap(v, u);
	for (int h = LG - 1; h >= 0; --h) {
		if (deep[lca[v][h]] >= deep[u])
			v = lca[v][h];
	}
	if (v == u)
		return { v, v };
	for (int h = LG - 1; h >= 0; --h) {
		if (lca[v][h] != lca[u][h])
			v = lca[v][h], u = lca[u][h];
	}
	return { v, u };
}

int getnx(int v, int deepnw) {
	if (deep[v] <= deepnw)
		return v;
	return up[v] = getnx(up[v], deepnw);
}

int get(int u) {
	if (u == pS[u])
		return u;
	return pS[u] = get(pS[u]);
}

void merge(int u, int v) {
	u = get(u), v = get(v);
	if (u == v) return;
	if (szS[v] < szS[u]) swap(u, v);
	szS[v] += szS[u];
	pS[u] = v;
}

void crtop(int v, int p) {
	int pr = -1;
	while (deep[v] > deep[p]) {
		if (pr != -1) {
			merge(pr, parid[v]);
		}
		pr = parid[v];
		v = getnx(v, deep[p]);
	}
	if (pr != -1) {
		merge(pr, parid[v]);
	}
}

void crass(int v, int u) {
	int p = getlca(v, u);

	crtop(v, p);
	crtop(u, p);
}

int mn = 1, mx = 1;
vector<int> V;

int notnw(int nw) {
	if (nw == 0)
		assert(0);
	if (nw == -1)
		return 1;
	return -1;
}

void dfsid(int v, int id) {
	used[v] = 1;
	mn = min(mn, valans[v]), mx = max(mx, valans[v]);
	for (int to : ng[v][id]) {
		if (!used[to]) {
			if (to == lca[v][0]) {
				valans[to] = valans[v] + mor[v];
				mor[to] = mor[v];
				dfsid(to, id);
			} else {
				mor[to] = notnw(mor[v]);
				valans[to] = valans[v] + mor[to];
				dfsid(to, id);
			}
		}
	}
}

int ccc(int v, int id, int val) {
	mn = 1, mx = 1;
	V.clear();
	mor[v] = val;
	dfsid(v, id);
	int pl = 1 - mn;
	mx += pl;
	int FF = mx;

	for (int vnw : V) {
		used[vnw] = 0;
		mor[vnw] = 0;
		valans[vnw] = 0;
	}
	return mx;
}

void solve(int v, int id) {
	
	int FF = ccc(v, id, 1), SS = ccc(v, id, -1);

	mn = 1, mx = 1;
	V.clear();
	if (FF < SS) {
		mor[v] = 1;
		dfsid(v, id);
		int pl = 1 - mn;
		for (int vnw : V) {
			valans[vnw] += pl;
		}
	} else {
		mor[v] = -1;
		dfsid(v, id);
		int pl = 1 - mn;
		for (int vnw : V) {
			valans[vnw] += pl;
		}
	}
}

signed main() {
	warp();

	cin >> n >> m >> t;
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		go FF = { u, i }, SS = { v, i };
		g[v].push_back(FF);
		g[u].push_back(SS);
	}

	dfs(0, -1);
	arr.resize(m);
	for (int i = 0; i < m; ++i) {
		cin >> arr[i].first >> arr[i].second;
		--arr[i].first, --arr[i].second;
		crass(arr[i].first, arr[i].second);
	}

	for (int i = 0; i < N; ++i) {
		for (go e : g[i]) {
			ng[i][e.id].push_back(e.to);
		}
	}

	for (int i = 0; i < N; ++i) {
		if (used[i] == 0) {
			for (pair<int, vector<int>> nw : ng[i]) {

				solve(i, nw.first);

			}
		}
	}

	for (pa I : arr) {
		int u = I.first, v = I.second;
		pa gg = palca(u, v);
		u = gg.first, v = gg.second;
		if (u == v) {
			continue;
		}
		if (mor[u] == mor[v]) {
			cout << -1;
			return 0;
		}
	}

	int nwans = 0;
	for (int i = 0; i < n; ++i) {
		if (valans[i] == 0)
			valans[i] = 1;
		nwans = max(nwans, valans[i]);
	}
	cout << nwans << " ";
	for (int i = 0; i < n; ++i) {
		cout << valans[i] << '\n';
	}
}