#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

struct edge
{
    int from, to, idx;
};

int n, m;
vector<vector<edge>> g;
vector<vector<pair<int, int>>> paths_on_edge;
vector<pair<int, int>> paths;
vector<edge> cur;
vector<vector<pair<int, int>>> gc;
vector<int> color;
bool flag = false;
vector<int> price;

void dfs(int u, int prev, int pnum)
{
    if (!cur.empty())
    {
        int start = cur[0].from;
        int end = u;
        if (start == paths[pnum].first && end == paths[pnum].second)
        {
            for (auto p : cur)
            {
                if (p.from < p.to)
                    paths_on_edge[p.idx].push_back({pnum, 0});
                else
                    paths_on_edge[p.idx].push_back({pnum, 1});
            }
        }
        else if (end == paths[pnum].first && start == paths[pnum].second)
        {
            for (auto p : cur)
            {
                if (p.from < p.to)
                    paths_on_edge[p.idx].push_back({pnum, 1});
                else
                    paths_on_edge[p.idx].push_back({pnum, 0});
            }
        }
    }

    for (auto e : g[u])
    {
        if (e.to != prev)
        {
            cur.push_back(e);
            dfs(e.to, u, pnum);
            cur.pop_back();
        }
    }
}

void dfs_color(int u)
{
    for (auto v : gc[u])
    {
        if (color[v.first] == -1)
        {
            if (v.second == 0)
                color[v.first] = color[u];
            else
                color[v.first] = 1 - color[u];

            dfs_color(v.first);
        }
        else
        {
            if ((v.second == 0 && color[v.first] != color[u]) ||
                (v.second == 1 && color[v.first] == color[u]))
                flag = true;
        }
    }
}

void dfs_price(int u, int prev)
{
    for (auto e : g[u])
    {
        if (e.to == prev)
            continue;

        if (paths_on_edge[e.idx].empty())
            price[e.to] = price[u];
        else
        {
            if ((paths_on_edge[e.idx][0].second +
                 color[paths_on_edge[e.idx][0].first] +
                 (e.from > e.to)) % 2 == 0)
                price[e.to] = price[u] + 1;
            else
                price[e.to] = price[u] - 1;
        }

        dfs_price(e.to, u);
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> n >> m >> t;

    g.resize(n);
    for (int i = 0; i < n - 1; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;

        g[a].push_back({a, b, i});
        g[b].push_back({b, a, i});
    }

    paths.resize(m);
    for (int i = 0; i < m; i++)
    {
        cin >> paths[i].first >> paths[i].second;
        paths[i].first--;
        paths[i].second--;
    }

    paths_on_edge.resize(n - 1);
    for (int i = 0; i < m; i++)
        dfs(paths[i].first, -1, i);

    gc.resize(m);
    for (int i = 0; i < n - 1; i++)
    {
        for (int j = 0; j < paths_on_edge[i].size(); j++)
        {
            for (int k = j + 1; k < paths_on_edge[i].size(); k++)
            {
                if (paths_on_edge[i][j].second == paths_on_edge[i][k].second)
                {
                    gc[paths_on_edge[i][j].first].push_back({
                        paths_on_edge[i][k].first, 0});
                    gc[paths_on_edge[i][k].first].push_back({
                        paths_on_edge[i][j].first, 0});
                }
                else
                {
                    gc[paths_on_edge[i][j].first].push_back({
                        paths_on_edge[i][k].first, 1});
                    gc[paths_on_edge[i][k].first].push_back({
                        paths_on_edge[i][j].first, 1});
                }
            }
        }
    }

    color.resize(m, -1);
    for (int i = 0; i < m; i++)
    {
        if (color[i] == -1)
        {
            color[i] = 0;
            dfs_color(i);
            if (flag)
                return cout << "-1" << endl, 0;
        }
    }

    price.resize(n);
    price[0] = 300;
    dfs_price(0, -1);

    vector<pair<int, int>> vec(n);
    for (int i = 0; i < n; i++)
        vec[i] = {price[i], i};

    sort(vec.begin(), vec.end());
    price[vec[0].second] = 1;
    for (int i = 1; i < n; i++)
    {
        if (vec[i].first == vec[i - 1].first)
            price[vec[i].second] = price[vec[i - 1].second];
        else
            price[vec[i].second] = price[vec[i - 1].second] + 1;
    }

    cout << *max_element(price.begin(), price.end()) << endl;
    for (int x : price)
        cout << x << " ";

    return 0;
}