#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


#define MAXN 10
#define MAX_LOG 23
vector<int> g[MAXN];
int pre[MAXN];

int up[MAXN][MAX_LOG];
int tin[MAXN];
int tout[MAXN];
int dep[MAXN];
int timer = 0;
#define INF 100000000

void dfs(int v, int p, int d) {
    pre[v] = p;
    dep[v] = d;
    tin[v] = timer++;
    for (int u:g[v]) {
        if (u != p) {
            dfs(u, v, d + 1);
        }
    }
    up[v][0] = p;
    for (int i = 1; i < MAX_LOG; ++i) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    tout[v] = timer++;
}

bool is_ancestor(int u, int v) {
    return tin[u] < tin[v] && tout[u] > tout[v];
}

int lca(int u, int v) {
    if (is_ancestor(u, v)) {
        return u;
    }
    if (is_ancestor(v, u)) {
        return v;
    }
    for (int i = MAX_LOG - 1; i >= 0; --i) {
        if (!is_ancestor(up[u][i], v)) {
            u = up[u][i];
        }
    }
    return up[u][1];
}

pair<int, int> edges[MAXN];

vector<int> paths[MAXN];
int n, m, t;

int orient[MAXN];
set<int> cur[MAXN];
int ans_mx = INF;
int ans[MAXN];
int cur_ans[MAXN];

void dfs_ans(int v) {
    if (cur_ans[v]) {
        return;
    }
    int mx = 0;
    for (auto u:cur[v]) {
        dfs_ans(u);
        mx = max(mx, cur_ans[u]);
    }
    cur_ans[v] = mx + 1;
}

void done() {
    for (int i = 0; i < n; ++i) {
        cur[i].clear();
    }
    for (int i = 0; i < n - 1; ++i) {
        int u = edges[i].first;
        int v = edges[i].second;
        if (orient[i]) {
            swap(u, v);
        }
        cur[u].insert(v);
    }
    for (int i = 0; i < m; ++i) {
        int magic = 0;
        for (int j = 0; j < paths[i].size() - 1; ++j) {
            if (cur[paths[i][j]].count(paths[i][j + 1])) {
                magic |= 1;
            }
            if (cur[paths[i][j + 1]].count(paths[i][j])) {
                magic |= 2;
            }
        }
        if (magic == 3) {
            return;
        }
    }
    memset(cur_ans, 0, sizeof(cur_ans));
    int mx = 0;
    for (int k = 0; k < n; ++k) {
        if (!cur_ans[k]) {
            dfs_ans(k);
        }
        mx = max(mx, cur_ans[k]);
    }
    if (mx < ans_mx) {
        ans_mx = mx;
        for (int i = 0; i < n; ++i) {
            ans[i] = cur_ans[i];
        }
    }

}

void gen(int x) {
    if (x == n - 1) {
        done();
    } else {
        for (int i = 0; i < 2; ++i) {
            orient[x] = i;
            gen(x + 1);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        if (u > v) {
            swap(u, v);
        }
        edges[i] = {u, v};
        g[u].push_back(v);
        g[v].push_back(u);
    }
    dfs(0, 0, 0);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        int l = lca(a, b);
        vector<int> &path = paths[i];
        while (a != l) {
            path.push_back(a);
            a = pre[a];
        }
        path.push_back(l);
        int sz = path.size();
        while (b != l) {
            path.push_back(b);
            b = pre[b];
        }
        reverse(path.begin() + sz, path.end());
    }
    for (int i = 0; i < n; ++i) {
        ans[i] = INF;
    }
    gen(0);
    if (ans_mx == INF) {
        cout << -1;
        return 0;
    }
    cout << ans_mx << "\n";
    for (int i = 0; i < n; ++i) {
        cout << ans[i] << " ";
    }
    return 0;
}