#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <map>
#include <set>
#include <deque>
#include <chrono>
#include <ctime>
#include <random>
#include <stack>
#include <string>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;
#define pii pair<int, int>
#define pil pair<int, ll>
#define pli pair<ll, int>
#define pll pair<ll, ll>

const int INF = (int)(1e9) + (int)(1e3);
const ll LINF = (ll)(1e18) + (ll)(1e3);
const ld pi = acos(-1);
const int MAXN = 0;
const int MAXQ = 0;

auto tstart = chrono::high_resolution_clock::now();
#define tend chrono::high_resolution_clock::now()
#define exec_t chrono::duration_cast<chrono::milliseconds>(tend - tstart).count()

vector<pii> edges;
vector<vector<int> > gr;
map<pii, int> ltm;
vector<int> amount;
vector<int> answer;
int n, m, t;

void solve6(int root) {
    for (int u = 1; u <= n; ++u) {
        if (ltm.count({u, root}) == 0) {
            ltm[{u, root}] = ltm[{root, u}] = root;
            for (int v : gr[u]) {
                if (ltm.count({v, root}) != 0 && ltm[{v, root}] != v) {
                    cout << -1;
                    exit(0);
                }
                ltm[{v, root}] = ltm[{root, v}] = v;
                ltm[{u, v}] = ltm[{v, u}] = v;
            }
        } else {
            if (ltm[{u, root}] == u) {
                ltm[{u, root}] = ltm[{root, u}] = u;
                for (int v : gr[u]) {
                    if (ltm.count({v, root}) != 0 && ltm[{v, root}] != root) {
                        cout << -1;
                        exit(0);
                    }
                    ltm[{v, root}] = ltm[{root, v}] = root;
                    ltm[{u, v}] = ltm[{v, u}] = u;
                }
            } else {
                ltm[{u, root}] = ltm[{root, u}] = root;
                for (int v : gr[u]) {
                    if (ltm.count({v, root}) != 0 && ltm[{v, root}] != v) {
                        cout << -1;
                        exit(0);
                    }
                    ltm[{v, root}] = ltm[{root, v}] = v;
                    ltm[{u, v}] = ltm[{v, u}] = v;
                }
            }
        }
    }
    bool f1 = (!gr[root].empty());
    for (int u = 1; u <= n; ++u) {
        for (int v : gr[u]) {
            if (u != root && v != root) {
                f1 = false;
            }
        }
    }
    for (int i = 1; i <= n; ++i) {
        answer[i] = 1;
    }
    if (f1) {
        for (int u : gr[root]) {
            answer[u] = 2;
        }
    } else {
       answer[root] = 2;
       for (auto p : ltm) {
           if (p.second != root) {
               answer[p.second] = 3;
           }
       }
    }
    int mx = 0;
    for (int i = 1; i <= n; ++i) {
        mx = max(mx, answer[i]);
    }
    cout << mx << '\n';
    for (int i = 1; i <= n; ++i) {
        cout << answer[i] << ' ';
    }
    exit(0);
}

void solve() {
    cin >> n >> m >> t;
    amount.resize(n + 1);
    gr.resize(n + 1);
    answer.resize(n + 1);
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        amount[u]++;
        amount[v]++;
        edges.emplace_back(u, v);
    }
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        gr[u].push_back(v);
        gr[v].push_back(u);
    }
    for (int i = 1; i <= n; ++i) {
        if (amount[i] == edges.size()) {
            solve6(i);
            break;
        }
    }
    assert(1);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    srand(time(nullptr));
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
}