#include<bits/stdc++.h>

using namespace std;

const int MAXN = 5e5 + 5;
const int LOG = 21;

int up[LOG][MAXN];
int n, m, t;
vector<int> g[MAXN];
pair<int, int> ways[MAXN];
vector<pair<int, int>> edges[MAXN];
int len[MAXN];
int answer = int(1e9);
vector<int> remem;
vector<pair<int, int>> curway;

void dfs(int v, int dest, int ind, int p) {
	if (v == dest) {
		edges[ind] = curway;
	}
	for (auto to : g[v]) {
		if (to == p) continue;
		curway.push_back({v, to});
		dfs(to, dest, ind, v);
		curway.pop_back();
	}
}

bool check_bit(int mask, int bit) {
	return mask & (1 << bit);
}

bool turn[MAXN];
vector<int> newg[MAXN];
int used[MAXN];
bool cycle = false;
vector<int> order;

void topsort(int v) {
	used[v] = 1;
	for (auto to : newg[v]) {
		if (used[to] == 1) {
			cycle = true;
		}
		if (used[to]) continue;
		topsort(to);
	}
	used[v] = 2;
	order.push_back(v);
}

void relax(int mask) {
	for (int i = 0; i < m; ++i) {
		if (check_bit(mask, i)) {
			turn[i] = true;
		} else {
			turn[i] = false;
		}
	}
	for (int i = 0; i < n; ++i) newg[i] = {};
	for (int i = 0; i < m; ++i) {
		if (turn[i]) {
			for (auto e : edges[i]) {
				newg[e.second].push_back(e.first);
			}
		} else {
			for (auto e : edges[i]) {
				newg[e.first].push_back(e.second);
			}
		}
	}
	order.clear();
	memset(used, 0, sizeof used);
	vector<int> dp(n, 1);
	cycle = false;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			topsort(i);
		}
	}
	if (cycle) return;
	int ans = 1;
	for (int i = 0; i < n; ++i) {
		int curv = order[i];
		int maxi = 0;
		for (auto to : newg[curv]) {
			maxi = max(maxi, dp[to]);
		}
		dp[curv] = maxi + 1;
		ans = max(ans, dp[curv]);
	}
	if (answer > ans) {
		answer = ans;
		remem = dp;
	}
}

void solve() {
	for (int mask = 0; mask < (1 << m); ++mask) {
		relax(mask);
	}	
	if (answer == int(1e9)) {
		cout << -1 << endl;
		return;
	}
	cout << answer << endl;
	for (int i = 0; i < n; ++i) {
		cout << remem[i] << ' ';
	}
	cout << endl;
}

int main() {
	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v; --u; --v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b; --a; --b;
		ways[i] = {a, b};
		curway.clear();
		dfs(a, b, i, a);
	}
	solve();
	return 0;
}