#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 1e3 + 42;
vector < int > gr[MAX_N];
int tin[MAX_N];
int tout[MAX_N];
int t = 1;
int h[MAX_N];
int p[MAX_N];

void dfs(int v, int par) {
    p[v] = par;
    h[v] = h[par] + 1;
    tin[v] = t;
    t++;
    for (auto u : gr[v]) {
        if (u == par) {
            continue;
        }
        dfs(u, v);
    }
    tout[v] = t;
    t++;
}

const int LOG = 20;
int bin[LOG][MAX_N];

void build(int n) {
    for (int i = 0; i < n; i++) {
        bin[0][i] = p[i];
    }
    for (int i = 1; i < LOG; i++) {
        for (int j = 0; j < n; j++) {
            bin[i][j] = bin[i - 1][bin[i - 1][j]];
        }
    }
}

bool check(int P, int v) {
    if (tin[P] <= tin[v] && tout[v] <= tout[P]) {
        return 1;
    }
    return 0;
}

int get_LCA(int v, int u) {
    if (check(v, u)) {
        return v;
    }
    if (check(u, v)) {
        return u;
    }
    int c = LOG - 1;
    while (c > 0) {
        if (check(bin[c][v], u)) {
            c--;
        }
        v = bin[c][v];
        c--;
    }
    return p[v];
}

int get_dist(int a, int b) {
    int v = get_LCA(a, b);
    return h[a] + h[b] - 2 * h[v];
}

pair < int, int > st[MAX_N];
bool start[MAX_N];
pair < int, int > d[MAX_N];
int w[MAX_N];
bool finish[MAX_N];

int dfs1(int a, int b, int x) {
    //cout << a << " " << b << " " << x << endl;
    int v = get_LCA(a, b);
    while (a != v) {
        w[a] = min(w[a], x);
        x = w[a] - 1;
        a = p[a];
    }
    vector < int > cnt;
    while (b != v) {
        cnt.push_back(b);
        b = p[b];
    }
    cnt.push_back(v);
    reverse(cnt.begin(), cnt.end());
    for (auto b : cnt) {
        w[b] = min(w[b], x);
        x = w[b] - 1;
    }
}

int main() {
    //freopen("input.txt", "r", stdin);
    int n, m;
    cin >> n >> m;
    for (int i = 1; i < n; i++) {
        int v, u;
        cin >> v >> u;
        v--;
        u--;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }
    h[0] = -1;
    dfs(0, 0);
    //cout << h[0] << " " << h[1] << " " << h[2] << " " << h[3] << endl;
    build(n);
    int ans = 0;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        st[i] = {a, b};
        int x = get_dist(a, b) + 1;
        ans = max(ans, x);
        d[i] = {x, i};
    }
    cout << ans << endl;
    sort(d, d + m);
    reverse(d, d + m);
    fill(w, w + n, (int)1e9);
    for (int i = 0; i < m; i++) {
        int a = st[d[i].second].first;
        int b = st[d[i].second].second;
        if (start[a] || finish[b]) {
            dfs1(a, b, d[i].first);
            continue;
        }
        if (start[b] || finish[a]) {
            dfs1(b, a, d[i].first);
            continue;
        }
        start[a] = 1;
        finish[b] = 1;
        dfs1(a, b, d[i].first);
    }
    for (int i = 0; i < n; i++) {
        if (w[i] == 1e9) {
            w[i] = 1;
        }
        cout << w[i] << " ";
    }
    return 0;
}
