#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <map>
#include <set>
#include <vector>
#include <algorithm>
using namespace std;

#define nl '\n'
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

//comments
/*
	1) Дано дерево с неор.ребрами
	2) Каждой вершине ci - тарифная  зона станции
	3) Стоимость проезда между i-j: cj - ci;
	4) Мэр не хочет чтобы cj - ci < 0
	5) Следовательно надо сделвать чтобы cj - ci > 0 по направлению поездов
*/


vector<set<int>> g;
int k = 2;

void dfs(int x, int pred, const int& finish, vector<int>& travel, bool& flag)
{
	if (!flag)
		return;

	travel.push_back(x);
	if (x == finish)
	{
		flag = false;
		return;
	}
	
	for (auto& u : g[x])
	{
		if (!flag)
			return;
		if (u != pred)
		{
			dfs(u, x, finish, travel, flag);
		}
	}

	if (!flag)
		return;

	travel.pop_back();
}

signed main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	//freopen("input.txt", "r", stdin);
	int n, m, t;
	cin >> n >> m >> t;

	g.resize(n + 1);
	for (int i = 1; i < n; ++i)
	{
		int x, y;
		cin >> x >> y;
		g[x].insert(y);
		g[y].insert(x);
	}

	vector<int> ans(n + 1, 1);
	for (int i = 0; i < m; ++i)
	{
		int x, y;
		cin >> x >> y;

		vector<int> travel;
		bool flag = true;

		dfs(x, 0, y, travel, flag);
		if (travel.size() == 0)
			return cout << -1, 0;
		for (int i = 1; i < travel.size(); ++i)
		{
			auto it = g[travel[i]].find(travel[i - 1]);
			if (it != g[travel[i]].end())
				g[travel[i]].erase(it);
		}
		for (int i = 0; i < travel.size(); ++i)
		{
			if (!ans[travel[i]])
				ans[travel[i]] = k++;
		}
	}
	cout << k - 1 << nl;
	for (int i = 1; i <= n; ++i)
		cout << ans[i] << ' ';
	return 0;
}