#define FASTIO ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

#ifndef BZ
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

#ifdef Debug
#define LOG(v) cout << #v << ": " << v << "\n";
#else
#define LOG(v) ;
#endif

#define F first
#define S second
#define forEach(c) for (auto &it : c)
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define pb push_back

template <class T>
void chMax(T &a, T b) {
    if (a < b) a = b;
}

template <class T>
void chMin(T &a, T b) {
    if (b < a) a = b;
}

inline ll divUp(ll a, ll b) {
    return (a + b - 1) / b;
}

void dfsMark(ll v, const vector<vector<ll>> &adj, vector<ll> &cost, ll d) {
    cost[v] = d;
    forEach(adj[v]) {
        if (cost[it] != -1) continue;
        dfsMark(it, adj, cost, d + 1);
    }
}

void solve() {
    /// no shared tunnels
    ll n, m, t;
    cin >> n >> m >> t;
    assert(t == 0);
    vector<vector<ll>> adj(n, vector<ll>());
    map<ll, ll> cnt;
    for (ll i = 0; i < n - 1; i++) {
        ll a, b;
        cin >> a >> b;
        a--, b--;
        adj[a].pb(b);
        adj[b].pb(a);
    }
    for (ll i = 0; i < m; i++) {
        pll it;
        cin >> it.F >> it.S;
        it.F--, it.S--;
        cnt[it.F]++;
        cnt[it.S]++;
    }
    ll s = -1;
    for (ll i = 0; i < n; i++) if (cnt[i] == m) s = i;
    assert(s != -1);
    vector<ll> ans(n, -1);
    dfsMark(s, adj, ans, 1);
    cout << *max_element(all(ans)) << "\n";
    forEach(ans) cout << it << " ";
}

int main() {
    FASTIO
    solve();
    return 0;
}