#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

const int MAX_N = 5e5 + 10;

vector<int> edges[MAX_N];
pair<int, int> paths[MAX_N];

int cnts[MAX_N], color[MAX_N];

void cnt_dfs(int u, int p = -1) {
	for (int v : edges[u]) {
		if (v == p)
			continue;
		cnt_dfs(v, u);
		cnts[u] += cnts[v];
	}
}

void color_dfs(int u, int p = -1) {
	if (p == -1 || cnts[u] == 0)
		color[u] = 1;
	else
		color[u] = color[p] + 1;
	for (int v : edges[u])
		if (v != p)
			color_dfs(v, u);
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m, t;
	cin >> n >> m >> t;
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		edges[--u].push_back(--v);
		edges[v].push_back(u);
	}
	for (int i = 0; i < m; ++i) {
		cin >> paths[i].x >> paths[i].y;
		--paths[i].x;
		--paths[i].y;
	}
	int checkx = 1, checky = 1;
	for (int i = 0; i < m; ++i) {
		if (paths[i].x != paths[0].x && paths[i].y != paths[0].x)
			checkx = 0;
		if (paths[i].x != paths[0].y && paths[i].y != paths[0].y)
			checky = 0;
	}
	if (!checkx && !checky) {
		assert(0);
	} else {
		if (checky == 1)
			swap(paths[0].x, paths[0].y);
		int root = paths[0].x;
		for (int i = 0; i < m; ++i) {
			if (paths[i].y == root)
				swap(paths[i].x, paths[i].y);
			++cnts[paths[i].y];
		}
		cnt_dfs(root);;
		assert(cnts[root] == m);
		color_dfs(root);
		cout << *max_element(color, color + n) << "\n";
		for (int i = 0; i < n; ++i)
			cout << color[i] << " ";
	}
	return 0;
}