#include <iostream>
#include <vector>

#define int long long

using namespace std;

void dfs(int v, vector<vector<int> > &g, vector<int> &pr){
    for (auto i : g[v]){
        if (pr[v] != i){
            pr[i] = v;
            dfs(i, g, pr);
        }
    }
}

void paint(int v, int dir, vector<int> &nx, vector<vector<int> > &ng){
    if (nx[v] == -1){
        return;
    }
    if (dir){
        ng[v].push_back(nx[v]);
    }else{
        ng[nx[v]].push_back(v);
    }
    paint(nx[v], dir, nx, ng);
}

bool topsort(int v, vector<vector<int> > &g, vector<int> & used, vector<int> & ans){
    used[v] = 1;
    bool answ = 0;
    for (auto i : g[v]){
        if (used[i] == 1){
            answ = 1;
        }
        if (used[i] == 0){
            answ = answ | topsort(i, g, used, ans);
        }
    }
    used[v] = 2;
    ans.push_back(v);
    return answ;
}

signed main()
{
    freopen("input.txt", "r", stdin);
    int n, m, t;
    cin >> n >> m >> t;
    vector<vector<int> > g(n);
    for (int i = 0; i < n - 1; i++){
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> a(n);
    vector<int> b(n);
    for (int i = 0; i < m; i++){
        cin >> a[i] >> b[i];
        a[i]--;
        b[i]--;
    }
    vector<vector<int> > nx(m, vector<int>(n, -1));
    for (int i = 0; i < m; i++){
        vector<int> pr(n, -1);
        dfs(a[i], g, pr);
        int now = b[i];
        while (now != a[i]){
            nx[i][pr[now]] = now;
            now = pr[now];
        }
    }
    int ok = false;
    int answer = 1e9;
    vector<int> ans(n);
    for (int mask = 0; mask < (1 << m); mask++){
        vector<vector<int> > ng(n);
        for (int i = 0; i < m; i++){
            paint(a[i], ((mask >> i) & 1), nx[i], ng);
        }
        vector<int> used(n);
        int good = 0;
        int cur = 0;
        vector<int> c(n, 1);
        vector<int> ts;
        for (int i = 0; i < n; i++){
            if (!used[i]){
                good = good || topsort(i, ng, used, ts);
            }
        }
        for (auto i : ts){
            for (auto v : ng[i]){
                c[i] = max(c[i], c[v] + 1);
            }
            cur = max(cur, c[i]);
        }
        if (!good){
            ok = 1;
            if (cur < answer){
                answer = cur;
                ans = c;
            }
        }
    }
    if (ok){
        cout << answer << endl;
        for (auto i : ans){
            cout << i << ' ';
        }
        cout << endl;
    }else{
        cout << -1 << endl;
    }
    return 0;
}
