#include <iostream>
#include <vector>
#define fi first
#define se second
using namespace std;

const int MAXN = 500005;

struct edge
{
    int u, v, d;
};

int n, m, t;
vector<int> g[MAXN];
edge e[MAXN];

int vis[MAXN];
pair<int, int> route[MAXN];

int root = 0;

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m >> t;
    for (int i = 1; i < n; ++ i)
    {
        int u, v;
        cin >> e[i].u >> e[i].v;
        u = e[i].u;
        v = e[i].v;
        g[u].push_back(i);
        g[v].push_back(i);
        e[i].d = -1;
    }

    if (e[1].u == e[2].u) root = e[1].u;
    if (e[1].u == e[2].v) root = e[1].u;
    if (e[1].v == e[2].u) root = e[1].v;
    if (e[1].v == e[2].v) root = e[1].v;
}

int main()
{
    Init();

    int from = 0, to = 0;

    for (int i = 1; i <= m; ++ i)
    {
        int s, e;
        cin >> route[i].fi >> route[i].se;
        s = route[i].fi;
        e = route[i].se;

        if (e == root) to = 1;
        else if (s == root) from = 1;
        else from = to = 1;
    }

    // cout << root << ' ' << from << ' ' << to << endl;

    if (from * to == 0)
    {
        if (from)
        {
            vis[root] = 1;
        }
        if (to)
        {
            vis[root] = 2;
        }
    }
    else
    {
        vis[root] = 2;
    }

    int ans = 0;
    for (int i = 1; i <= m; ++ i)
    {
        int s, e;
        s = route[i].fi;
        e = route[i].se;

        if (s != root)
        {
            if (vis[s] != 0 and vis[s] != vis[root] - 1)
            {
                cout << -1 << endl;
                return 0;
            }
            vis[s] = vis[root] - 1;
        }
        if (e != root)
        {
            if (vis[e] != 0 and vis[e] != vis[root] + 1)
            {
                cout << -1 << endl;
                return 0;
            }
            vis[e] = vis[root] + 1;
        }

        ans = max(ans, max(vis[e], vis[s]));
    }

    cout << max(1, ans) << endl;
    if (t == 1)
    {
        for (int i = 1; i <= n; ++ i)
        {
            cout << max(1, vis[i]) << ' ';
        }
        cout << endl;
    }

    return 0;
}

/*

9 3 1
1 2
3 2
4 2
4 5
6 5
5 9
9 8
7 8
3 1
7 4
6 2

*/

