#include <iostream>
#include <algorithm>
#include <vector>
#include <cassert>

using namespace std;

const int MAX_N = 5e5 + 10;
vector<int> g[MAX_N];

int n, routes, t;

int par[MAX_N];
int c[MAX_N];
int h[MAX_N];

void dfs(int v, int p = -1, int curH = 0) {
    par[v] = p;
    h[v] = curH;
    for (int u : g[v]) {
        if (u == p) {
            continue;
        }
        dfs(u, v, curH + 1);
    }
}

int lca(int a, int b) {
    if (h[a] < h[b]) {
        swap(a, b);
    }
    while (h[a] > h[b]) {
        a = par[a];
    }
    while (a != b) {
        a = par[a];
        b = par[b];
    }
    return a;
}

bool check(vector<int> &v){
    for (int i = 1; i < n; i++) {
        if (v[i] <= v[i - 1]) {
            return false;
        }
    }
    return true;
}

int main() {
#ifdef LOCAL
    freopen("C.in", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> routes >> t;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(1, 1);
    for (int i = 1; i <= n; i++) {
        c[i] = 1;
    }
    vector<pair<int, int>> r;
    for (int i = 0; i < routes; i++) {
        int a, b;
        cin >> a >> b;
        r.emplace_back(a, b);
        int curC = 1;
        int lc = lca(a, b);
        int dA = h[a] - h[lc];
        int dB = h[b] - h[lc];
        if (dA < dB) {
            swap(a, b);
        }
        while (a != lc) {
            c[a] = max(c[a], curC++);
            a = par[a];
        }
        c[lc] = max(c[lc], curC++);
    }
    bool chg = true;
    while(chg) {
        chg = false;
        for (int i = 0; i < routes; i++) {
            auto[a, b] = r[i];
            int lc = lca(a, b);
            int dA = h[a] - h[lc];
            int dB = h[b] - h[lc];
            if (dA < dB) {
                swap(a, b);
            }
            int add = h[b] - h[lc] - 1;
            while (b != lc) {
                int newCB =  c[lc] + 1 + add;
                if (newCB > c[b]) {
                    c[b] = newCB;
                    chg = true;
                }
                add--;
                b = par[b];
            }
        }
    }
    for (int i = 0; i < routes; i++) {
        auto[a, b] = r[i];
        int lc = lca(a, b);
        vector<int> v;
        while (a != lc) {
            v.push_back(c[a]);
            a = par[a];
        }
        v.push_back(c[lc]);
        vector<int> add;
        while (b != lc) {
            add.push_back(c[b]);
            b = par[b];
        }
        reverse(add.begin(), add.end());
        for (int x : add) {
            v.push_back(x);
        }
        vector<int> v2 = v;
        reverse(v2.begin(), v2.end());
        if(!check(v) && !check(v2)) {
             assert(false);
        }
    }
    int ans = 1;
    for (int i = 1; i <= n; i++) {
        ans = max(ans, c[i]);
    }
    cout << ans << "\n";
    for (int i = 1; i <= n; i++) {
        cout << c[i] << " ";
    }
    cout << "\n";

    return 0;
}