#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

int tt = 1;
vector<int> tin, tout, anc;

void dfs(int v, const vector<vector<int> > &g) {
    tin[v] = tt++;
    for (auto u : g[v]) {
        if (!tin[u]) {
            dfs(u, g);
            anc[u] = v;
        }
    }
    tout[v] = tt++;
    return;
}

const int INF = 1e9;

bool check(int u, int v) {
    if (tin[u] <= tin[v] && tout[v] <= tout[u]) {
        return true;
    }
    return false;
}

bool dfs1(int v, const vector<vector<int> > &g, vector<int> &used, vector<int> &ans) {
    used[v] = 1;
    ans[v] = 1;
    for (auto u : g[v]) {
        if (used[u] == 1) {
            return false;
        }
        if (used[u] != 2) {
            if (!dfs1(u, g, used, ans)) {
                return false;
            }
        }
        ans[v] = max(ans[v], ans[u] + 1);
    }
    used[v] = 2;
    return true;
}

void dfs2(int v, const vector<vector<int> > &g, vector<int> &d, int dd) {
    d[v] = dd;
    for (auto u : g[v]) {
        if (d[u] == -1) {
            dfs2(u, g, d, dd + 1);
        }
    }
    return;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
    int n, m, t;
    cin >> n >> m >> t;
    tin.resize(n + 1);
    tout.resize(n + 1);
    anc.resize(n + 1, -1);
    vector<vector<int> > g(n + 1);
    vector<int> kol(n + 1);
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<pair<int, int> > ed(m);
    for (int i = 0; i < m; i++) {
        cin >> ed[i].first >> ed[i].second;
        kol[ed[i].first]++;
        kol[ed[i].second]++;
    }
    int beg = 1;
    for (int i = 1; i <= n; i++) {
        if (kol[i] >= m) {
            beg = i;
        }
    }
    dfs(beg, g);
    int cost = INF;
    vector<int> ans(n + 1, 1);
    /*if (n <= 15 && m <= 15) {
        for (int i = 0; i < (1 << m); i++) {
            vector<vector<int> > gg(n + 1);
            for (int j = 0; j < m; j++) {
                if (i & (1 << j)) {
                    int u = ed[j].first, v = ed[j].second;
                    while (!check(u, v)) {
                        gg[anc[u]].push_back(u);
                        u = anc[u];
                    }
                    while (!check(v, u)) {
                        gg[v].push_back(anc[v]);
                        v = anc[v];
                    }
                } else {
                    int v = ed[j].first, u = ed[j].second;
                    while (!check(u, v)) {
                        gg[anc[u]].push_back(u);
                        u = anc[u];
                    }
                    while (!check(v, u)) {
                        gg[v].push_back(anc[v]);
                        v = anc[v];
                    }
                }
            }
            vector<int> tmp(n + 1), used(n + 1);
            bool flag = true;
            for (int k = 1; k <= n; k++) {
                if (!used[k]) {
                    if (!dfs1(k, gg, used, tmp)) {
                        flag = false;
                        break;
                    }
                }
            }
            if (flag) {
                int mx = 0;
                for (int k = 1; k <= n; k++) {
                    mx = max(mx, tmp[k]);
                }
                if (mx < cost) {
                    cost = mx;
                    for (int k = 1; k <= n; k++) {
                        ans[k] = tmp[k];
                    }
                }
            }
        }
    } else {*/
        vector<int> depth(n + 1, -1);
        dfs2(beg, g, depth, 1);
        for (int i = 0; i < m; i++) {
            int u = ed[i].first, v = ed[i].second;
            ans[u] = depth[u];
            ans[v] = depth[v];
            while (!check(u, v)) {
                u = anc[u];
                ans[u] = depth[u];
            }
            while (!check(v, u)) {
                v = anc[v];
                ans[v] = depth[v];
            }
        }
        cost = 1;
        for (int i = 1; i <= n; i++) {
            cost = max(cost, ans[i]);
        }
    //}
    if (cost == INF) {
        cout << -1;
    } else {
        cout << cost << '\n';
        for (int i = 1; i <= n; i++) {
            cout << ans[i] << ' ';
        }
    }
    return 0;
}
