//#pragma GCC optimize "-O3"
#include "bits/stdc++.h"

#define le(v) ((int)v.size())
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define x first
#define y second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v)
		os << x << " ";
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &pp) {
	os << pp.x << " " << pp.y << " ";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v)
		is >> x;
	return is;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &pp) {
	is >> pp.x >> pp.y;
	return is;
}

#define next sathesnaothea

int n, m, type;
vector<vector<int>> g;

vector<int> up;
vector<int> orient;
vector<int> next;
vector<int> pref;
vector<int> depth;
vector<int> tour;

void dfs0(int v, int _p) {
	pref[v] = _p;
	tour.pb(v);
	for (int sub : g[v]) {
		if (sub == _p) continue;
		depth[sub] = depth[v] + 1;
		dfs0(sub, v);
	}
}

int lca(int a, int b) {
	if (a == b) return a;
	if (depth[a] > depth[b]) return lca(pref[a], b);
	return lca(a, pref[b]);
}

void run() {
	cin >> n >> m >> type; g.resize(n);
	pref.resize(n, -1);
	up.resize(n); iota(up.begin(), up.end(), 0);
	orient.resize(n, 1);
	depth.resize(n);
	next.resize(n); iota(next.begin(), next.end(), 0);
	for (int i = 0; i < n - 1; i++) {
		int a, b; cin >> a >> b; a--;b--;
		g[a].pb(b);
		g[b].pb(a);
	}
	dfs0(0, -1);
	vector<pii> routes;
	for (int i = 0; i < m; i++) {
		int a, b; cin >> a >> b; a--; b--;
		routes.emplace_back(a, b);
	}
	vector<int> best(n, 1e9);
	for (int mask = 0; mask < (1 << n); mask++) {
		bool fail = false;
		for (pii route : routes) {
			vector<int> dirs;
			int c = lca(route.x, route.y);
			int sgn = 1;
			for (int x : vector<int>{route.x, route.y}) {
				while (x != c) {
					dirs.pb((mask & (1 << x)) ? sgn : -sgn);
					x = pref[x];
				}
				sgn *= -1;
			}
			if (*max_element(dirs.begin(), dirs.end()) != *min_element(dirs.begin(), dirs.end())) {
				fail = true;
				break;	
			}
		}
		if (!fail) {
			vector<int> col(n);
			col[0] = 0;
			for (int i : tour) {
				if (pref[i] == -1) continue;
				if (mask & (1 << i)) {
					col[i] = col[pref[i]] - 1;
				} else {
					col[i] = col[pref[i]] + 1;
				}
			}
			int d = *min_element(col.begin(), col.end());
			for (int &x : col) x -= d - 1;
			if (*max_element(col.begin(), col.end()) < *max_element(best.begin(), best.end())) {
				best = col;
			}
		}
	}
	if (*max_element(best.begin(), best.end()) > 1e7) {
		cout << -1 << endl;
	} else {
		cout << *max_element(best.begin(), best.end()) << endl;
		cout << best << endl;
	}
}

signed main(int argc, char const *argv[]) {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	// freopen("test.in", "r", stdin);
	run();
}