//#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <iomanip>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <deque>
#include <stack>
#include <cmath>
#include <sstream>
#include <random>
#include <bitset>
#include <time.h>

using namespace std;

#define en '\n'
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
typedef long long ll;
//#define int ll
typedef double db;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const int INF = 1e9 + 7;
const ll LINF = 1e18;
const db EPS = 1e-9;

struct fenwick {
    int n;
    vector<int> f;
    fenwick (int _n) {
        n = _n;
        f.assign(n,0);
    }
    void update(int i, int v) {
        for (; i <= n; i += i & (-i)) {
            f[i] += v;
        }
    }
    int get_sum(int i) {
        int s = 0;
        for (; i > 0; i -= i & (-i)) {
            s += f[i];
        }
        return s;
    }
    int get(int L, int R) {
        return get_sum(R) - get_sum(L - 1);
    }
};

void solve() {
    int n, m, t, vert, mx = 0;
    cin >> n >> m >> t;
    vector<vector<int>> g(n + 1);
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
        if (g[v].size() > mx) {
            vert = v;
            mx = g[v].size();
        }
        if (g[u].size() > mx) {
            vert = u;
            mx = g[u].size();
        }
    }
    vector<pii> r(m);
    map<int, vector<int>> R;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        if (b == vert) swap(a, b);
        R[a].push_back(b);
    }
    vector<int> ans(n + 1, 0);
    ans[vert] = 2;
    for (auto& i: R[vert]) {
        ans[i] = 1;
    }
    for (auto& p: R) {
        if (p.first == vert) continue;
        if (ans[p.first] == 0) {
            ans[p.first] = 1;
        }
        for (auto& i: p.second) {
            if (ans[i] == 0) {
                ans[i] = (ans[p.first] > 2 ? 1 : 3);
                continue;
            }
            if (ans[i] == ans[p.first]) {
                ans[i] = 4;
                continue;
            }
        }
    }
    int k = 0;
    for (int i = 1; i <= n; ++i) {
        if (ans[i] == 0) ans[i] = 1;
        k = max(k, ans[i]);
    }
    cout << k << en;
    for (int i = 1; i <= n; ++i) {
        cout << ans[i] << ' ';
    }
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    srand(time(0));
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}