#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <ctime>

using namespace std;

typedef long long ll;
typedef long double ld;

const int N = (1 << 19);

void IOOptimize() {
	ios_base::sync_with_stdio(false);
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
}

vector <vector <int>> g;
vector <vector <int>> h;

vector <int> color;
bool ColorDfs(int u, int c = 0) {
	color[u] = c;
	bool ok = true;
	for (auto i : h[u]) {
		if (color[i] == -1) {
			ok &= ColorDfs(i, c ^ 1);
		}
		if (!(color[i] ^ color[u])) {
			return false;
		}
	}
	return ok;
}

void SolveSpider(int m, int k, int sp) {
	vector <int> c(g.size());
	color.resize(g.size(), -1);
	h.resize(g.size());
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		if (a != sp && b != sp) {
			h[a].push_back(b);
			h[b].push_back(a);
		}
	}
	for (int i = 0; i < g.size(); i++) {
		if (-1 == color[i]) {
			if (!ColorDfs(i)) {
				cout << -1;
				return;
			}
		}
	}
	c[sp] = 1 + (m != 0);
	for (int i = 0; i < g.size(); i++) {
		if (i != sp && color[i] == 0)
			c[i] = 1;
		if (i != sp && color[i] == 1)
			c[i] = 3;
	}
	cout << *max_element(c.begin(), c.end()) << endl;
	for (auto i : c)
		cout << i << " ";
}

vector <int> ts;
vector <bool> used;

void TopSortDfs(int u) {
	used[u] = true;
	for (auto i : h[u])
		if (!used[i])
			TopSortDfs(i);
	ts.push_back(u);
}

pair <int, vector <int>> SolveForMask(vector<vector <int>> p, int mask) {
	h.clear();
	h.resize(g.size());
	ts.clear();
	used.clear();
	used.resize(g.size());
	for (int i = 0; i < p.size(); ++i) {
		if ((1 << i) & mask) {
			for (int j = 1; j < p[i].size(); j++)
				h[p[i][j - 1]].push_back(p[i][j]);
		}
		else {
			for (int j = 1; j < p[i].size(); j++)
				h[p[i][p[i].size() - j]].push_back(p[i][p[i].size() - j - 1]);
		}
	}
	for (int i = 0; i < g.size(); i++)
		if (!used[i])
			TopSortDfs(i);
	//reverse(ts.begin(), ts.end());
	vector <int> c(g.size());
	for (int i : ts) {
		c[i] = 1;
		for (auto j : h[i])
			c[i] = max(c[i], c[j] + 1);
	}
	for (int i = 0; i < h.size(); i++) {
		for (int j : h[i])
			if (c[j] >= c[i])
				return { (int)1e9, {} };
	}
	int u = *max_element(c.begin(), c.end());
	for (auto& i : c)
		i = (i == 0 ? 1 : u - i + 1);
	return { u, c };
}

void PathDfs(int st, int* e, int p, vector <int>* result) {
	for (auto i : g[st])
		if (i != p)
			PathDfs(i, e, st, result);
	if (st == *e) {
		result->push_back(*e);
		*e = p;
	}
}

void Small(int n, int m, int k) {
	vector <vector <int>> r(m);
	pair <int, vector <int>> ans = { (int)1e9, {} };
	for (int i = 0; i < m; i++) {
		vector <int> res;
		int a, b;
		cin >> a >> b;
		a--, b--;
		PathDfs(a, &b, -1, &res);
		r[i] = res;
	}
	for (int i = 0; i < (1 << m); i++)
		ans = min(ans, SolveForMask(r, i));
	if (ans.first == 1e9)
		cout << -1;
	else {
		cout << ans.first << endl;
		for (auto i : ans.second)
			cout << i << " ";
	}
}

void Solve() {
	int n, m, k;
	cin >> n >> m >> k;
	g.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int a, b;
		cin >> a >> b;
		a--, b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	if (n <= 15) {
		Small(n, m, k);
		exit(0);
	}
	for (int i = 0; i < n; i++) {
		if (g[i].size() == n - 1) {
			SolveSpider(m, k, i);
			exit(0);
		}
	}
}

int main() {
	IOOptimize();
	Solve();
}