#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

vector<vector<int> > way;
vector<vector<int> > spar;
vector<int> deep;
vector<int> tin, tout;

int t = 0;

void dfs(int v, int p, int d) {
    if (p == -1) {
        spar[v][0] = v;
        spar[v][1] = v;
    } else {
        spar[v][0] = v;
        spar[v][1] = p;
    }
    deep[v] = d;
    tin[v] = t;
    t++;
    for (int u : way[v]) {
        if (u != p) {
            dfs(u, v, d + 1);
        }
    }
    tout[v] = t;
    t++;
}

struct train{
    int lca;
    int u;
    int v;
};

bool operator<(train a, train b) {
    if (deep[a.lca] == deep[b.lca]) {
        return a.lca < b.lca;
    }
    return deep[a.lca] < deep[b.lca];
}

bool check(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int make_lca(int a, int b) {
    for (int i = 19; i > 0; i--) {
        int x = spar[a][i];
        if (!check(x, b)) {
            a = x;
        }
    }
    return spar[a][1];
}

map<pii, int> mapi;

bool up(train a) {
    int x = a.u;
    int c = 0, d = 0;
    while (x != a.lca) {
        int y = spar[x][1];
        if (mapi[{x, y}] == 1) {
            c++;
        } else if (mapi[{x, y}] == 2) {
            d++;
        }
        x = y;
    }
    if (c > 0 && d > 0) {
        return false;
    }
    x = a.u;
    while (x != a.lca) {
        int y = spar[x][1];
        if (d > 0) {
            mapi[{x, y}] = 2;
        } else {
            mapi[{x, y}] = 1;
        }
        x = y;
    }
    x = a.v;
    int c1 = 0, d1 = 0;
    while (x != a.lca) {
        int y = spar[x][1];
        if (mapi[{x, y}] == 1) {
            c1++;
        } else if (mapi[{x, y}] == 2) {
            d1++;
        }
        x = y;
    }
    if (c1 > 0 && d1 > 0) {
        return false;
    }
    //cout << c << " " << d << " - " << c1 << " " << d1 << "\n";
    if ((c1 > 0 && c > 0) || (d1 > 0 && d > 0)) {
        //cout << "!!!";
        return false;
    }
    int color = 1;
    if (c > 0 || (c == 0 && d == 0)) {
        color = 2;
    }
    //cout << "color " << color << "\n";
    x = a.v;
    while (x != a.lca) {
        int y = spar[x][1];
        mapi[{x, y}] = color;
        x = y;
    }
    return true;
}

vector<int> ans;

void dfs2(int v, int p, int k) {
    //cout << v + 1 << " - " << p + 1 << " " << mapi[{v, p}] << " : " << k << "\n";
    if (mapi[{v, p}] == 2) {
        ans[v] = k;
    }
    //cout << v << " - " << mapi[{v, p}] << "\n";
    int x = 0;
    for (int u : way[v]) {
        if (u != p && mapi[{u, v}] == 1) {
            dfs2(u, v, 1);
            x = max(x, ans[u]);
        }
    }
    for (int u : way[v]) {
        if (u != p && mapi[{u, v}] == 2) {
            dfs2(u, v, max(x + 2, k + 1));
        }
    }
    if ((ans[v] == 0 && x != 0) || mapi[{v, p}] == 1) {
        ans[v] = x + 1;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, t;
    cin >> n >> m >> t;
    way.resize(n);

    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        way[x].push_back(y);
        way[y].push_back(x);
    }
    tin.resize(n);
    tout.resize(n);
    deep.resize(n);
    spar.resize(n, vector<int>(20));
    dfs(0, -1, 0);


    for (int i = 2; i < 20; i++) {
        for (int j = 0; j < n; j++) {
            spar[j][i] = spar[spar[j][i - 1]][i - 1];
        }
    }

    vector<train> all(m);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        all[i] = {make_lca(a, b), a, b};
    }

    sort(all.begin(), all.end());

    for (int i = 0; i < m; i++) {
        if (!up(all[i])) {
            //cout << all[i].lca << " " << all[i].u << " " << all[i].v << "\n";
            cout << -1;
            return 0;
        }
    }

    ans.resize(n);
    dfs2(0, -1, 1);
    int k = 0;
    for (int i = 0; i < n; i++) {
        if (ans[i] == 0) {
            ans[i] = 1;
        }
        k = max(k, ans[i]);
    }
    cout << k << "\n";
    for (int i : ans) {
        cout << i << " ";
    }


    return 0;
}
/*
7 3 1
1 2
1 5
2 3
2 4
5 6
5 7
4 5
6 7
4 7

*/
