#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstring>
#include <ctime>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stdio.h>
#include <string>
#include <vector>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 0

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, int> pli;
typedef pair<ll, ll> pll;

void solve();

const ll MAXN = 3e5 + 7;
const ll INF = 2e9 + 11;
const ll MOD = 1e9 + 9;
const ll INF1 = 9e18;
const ld EPS = 1e-8;

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    if (multi_test) cin >> q;
    while (q--) solve();
}

/*----------------------------------------------------------------------------*/

void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<vector<int>> g(n);
    vector<int> res(n, 1);
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
        if (g[a - 1].size() > 1)
            res[a - 1] = 2;
        if (g[b - 1].size() > 1)
            res[b - 1] = 2;
    }
    int ans = 1;
    vector<bool> in(n), out(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        in[a] = true;
        out[b] = true;
        if (in[a] == out[a] || in[b] == out[b]) {
            cout << "-1\n";
            exit(0);
        }
        if (g[b].size() > 1)
            res[b] = 2;
        else
            res[b] = 3;
        ans = max(ans, res[b]);
    }
    cout << ans << '\n';
    for (int i : res)
        cout << i << ' ';
    cout << '\n';
}