#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <algorithm>
#include <random>
#include <cassert>
#include <cmath>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <map>
#include <string>
#include <cstdlib>
#include <cstdio>
#include <iomanip>
#include <bitset>
#include <stack>
#include <list>

#pragma warning (disable : 4996)
using namespace std;

#define all(a) (a).begin(), (a).end()
#define allr(a) (a).rbegin(), (a).rend()
#define nl '\n'
#define sz(a) (int)(a).size()
#define maxeq(a, b) (a) = max(a, b);
#define mineq(a, b) (a) = min(a, b);

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;

const int INF = numeric_limits<int>::max();
const ll LINF = numeric_limits<ll>::max();
const dl EPS = 1e-8;
const dl PI = acos(-1);
mt19937 rnd(5625445);
mt19937_64 rnd64(3465467567);

template <typename T, typename D>
istream& operator >> (istream& in, pair<T, D>& a) {
	in >> a.first >> a.second;
	return in;
}

template <typename T, typename D>
ostream& operator << (ostream& out, pair<T, D>& a) {
	out << a.first << " " << a.second;
	return out;
}

template <typename T>
istream& operator >> (istream& in, vector<T>& a) {
	for (auto& i : a)
		in >> i;
	return in;
}

void IO() {
#ifdef _SEVA
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif // _SEVA
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cout.setf(ios::fixed);
	cout.precision(10);
}

const int N = (int)5e5 + 10;
const int M = 19;

vector<int> g[N];
int depth[N];
int par[N][M];
int tin[N], tout[N];
int timer;
int val[N];
bool used[N];

void dfs(int v, int p, int d = 0) {
	depth[v] = d;
	par[v][0] = p;
	tin[v] = ++timer;
	for (int i = 1; i < M; i++) {
		par[v][i] = par[par[v][i - 1]][i - 1];
	}
	for (auto& to : g[v]) {
		if (to == p)
			continue;
		dfs(to, v, d + 1);
	}
	tout[v] = ++timer;
}

bool isParent(int a, int b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
	if (isParent(a, b))
		return a;
	if (isParent(b, a))
		return b;

	for (int i = M - 1; i >= 0; i--) {
		if (!isParent(par[a][i], b))
			a = par[a][i];
	}
	return par[a][0];
}

int dist(int a, int b) {
	return depth[a] + depth[b] - 2 * depth[lca(a, b)];
}

vector<int> g2[N];

void solve() {
	int n, m, t;
	cin >> n >> m >> t;
	int s1 = 0, s2 = 0;
	for (int i = 1; i < n; i++) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
		if (s1 == 0) {
			s1 = u;
			s2 = v;
		}
		else {
			if (s1 != u && s1 != v)
				s1 = -1;
			if (s2 != u && s2 != v)
				s2 = -1;
		}
	}
	int s;
	if (s1 != -1)
		s = s1;
	else
		s = s2;
	val[s] = 2;
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}

	for (int v = 1; v <= n; v++) {
		for (auto& u : g[v]) {
			if (u == s || v == s)
				continue;
			if (val[v] == 2 || val[u] == 2)
				continue;
			if (val[u] == 0 && val[v] == 0) {
				val[u] = 1;
				val[v] = 3;
			}
			else if ((val[u] == 1 && val[v] == 1) || (val[v] == 3 && val[u] == 3)) {
				cout << -1 << nl;
				return;
			}
			else if (val[v] != 0) {
				val[u] = 4 - val[v];
			}
			else
				val[v] = 4 - val[u];
		}
	}

	cout << *max_element(val + 1, val + 1 + n) << nl;
	for (int i = 1; i <= n && t == 1; i++) {
		cout << max(1, val[i]) << " ";
	}
}

int main() {
	IO();

	solve();
	return 0;
}
