#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <deque>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long

vector<int> ans;
vector<bool> usd;

int LOG = 21, tm = 0;

vector<vector<int>> a;
vector<vector<int>> pp;
vector<int> tin, tout;

void dfs(int v, int par = -1)
{
	tin[v] = tm++;
	pp[v][0] = par;
	for (auto i : a[v])
	{
		if (i == par) continue;
		dfs(i, v);
	}
	tout[v] = tm++;
}

bool isPar(int u, int v)
{
	return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}

int lca(int x, int y)
{
	if (isPar(x, y)) return x;
	if (isPar(y, x)) return y;
	for (int i = LOG - 1; i >= 0; i--)
	{
		if (!isPar(pp[x][i], y)) x = pp[x][i];
	}
	return pp[x][0];
}

bool dfs2(int v, int par)
{
	bool flag = usd[v];
	for (auto i : a[v])
	{
		if (i == par) continue;
		if (dfs2(i, v))
		{
			ans[v] = max(ans[v], ans[i] + 1);
			flag = true;
		}
	}
	return flag;
}

vector<vector<int>> kolvo;

int32_t main()
{
	int n, m, ttt;
	cin >> n >> m >> ttt;
	a.resize(n, vector<int>(0));
	kolvo.resize(n, vector<int>(0));
	ans.resize(n, 1);
	usd.resize(n, false);
	tin.resize(n);
	tout.resize(n);
	pp.resize(n, vector<int>(LOG));

	for (int i = 1; i < n; i++)
	{
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		a[x].push_back(y);
		a[y].push_back(x);
	}

	
	dfs(0, 0);

	vector<vector<int>> path(0);
	
	for (int i = 0; i < m; i++)
	{
		vector<int> pth;
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		int u = lca(x, y);
		while (x != u)
		{
			pth.push_back(x);
			x = pp[x][0];
		}
		pth.push_back(x);
		vector<int> tmp;
		while (y != u)
		{
			tmp.push_back(y);
			y = pp[y][0];
		}
		for (int i = tmp.size() - 1; i >= 0; i--) pth.push_back(tmp[i]);
		if (pth.size() > 2) path.push_back(pth);
	}

	vector<int> ans(n, 1);
	m = path.size();
	if (m == 0)
	{
		cout << 2 << '\n';
		for (int i = 0; i < n; i++)
		{
			if (a[i].size() == n - 1)
			{
				ans[i] = 2;
				break;
			}
		}
		for (auto i : ans) cout << i << " ";
		return 0;
	}
	vector<char> usd(n, false);
	

	for (int i = 0; i < m; i++)
	{
		ans[path[i][1]] = 2;
		if (ans[path[i][0]] == 3 && ans[path[i][1]] == 3)
		{
			cout << -1;
			return 0;
		}
		if ((ans[path[i][0]] < ans[path[i][1]] && ans[path[i][1]] < ans[path[i][2]]) || (ans[path[i][0]] > ans[path[i][1]] && ans[path[i][1]] > ans[path[i][2]]))
		{
			usd[path[i][0]] = usd[path[i][1]] = usd[path[i][2]] = true;
			continue;
		}
		if (!usd[path[i][0]])
		{
			usd[path[i][0]] = usd[path[i][1]] = usd[path[i][2]] = true;
			ans[path[i][0]] = 3;
			continue;
		}
		if (!usd[path[i][1]])
		{
			usd[path[i][0]] = usd[path[i][1]] = usd[path[i][2]] = true;
			ans[path[i][1]] = 3;
			continue;
		}
		cout << -1;
		return 0;
	}

	cout << 3 << '\n';
	for (auto i : ans)
	{
		cout << i << " ";
	}
	
	return 0;
}


/**/


/*
*/