#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,sse3,sse4,avx,avx2,popcnt")
#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
#define rep(i, n) for (int i = 0; i < (n); ++i)
#define all(x) (x).begin(), (x).end()
#define f first
#define s second

const int MAXN = 5e5 + 5;
int n, m, t;
vector<int> g[MAXN];
vector<int> gr[MAXN];
vector<int> path[MAXN];
int p[MAXN];

void dfs(int v, int pp) {
    p[v] = pp;
    for (auto to : g[v]) {
        if (to != pp) dfs(to, v);
    }
}

vector<int> find_path(int u, int v) {
    dfs(u, -1);
    vector<int> res;
    while (v != u) {
        res.push_back(v);
        v = p[v];
    }
    res.push_back(u);
    reverse(all(res));
    return res;
}

const int inf = 1e9 + 7;
int res = inf;
int ans[MAXN];
int col[MAXN];
vector<int> vv;

bool cfs(int v) {
    vv.push_back(v);
    for (auto to : g[v]) {
        if (col[to] == inf) {
            col[to] = col[v] + 1;
            if (!cfs(to)) return false;
        } else {
            if (col[to] != col[v] + 1) {
                return false;
            }
        }
    }

    for (auto to : gr[v]) {
        if (col[to] == inf) {
            col[to] = col[v] - 1;
            if (!cfs(to)) return false;
        } else {
            if (col[to] != col[v] - 1) {
                return false;
            }
        }
    }
    return true;
}

bool colorize() {
    // cout << "colorize()" << endl;
    fill(col, col + n, inf);
    rep(i, n) {
        if (col[i] != inf) continue;
        vv.clear();
        col[i] = 0;
        if (!cfs(i)) return false;
        int mn = inf;
        for (auto it : vv) {
            mn = min(mn, col[it]);
        }
        for (auto it : vv) {
            col[it] += mn + 1;
        }
    }
    return true;
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n >> m >> t;
    rep(i, n - 1) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }

    rep(i, m) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        path[i] = find_path(u, v);
    }

    // cout << "path[]:" << endl;
    // rep(i, m) {
    //     cout << "    path[" << i << "] = {";
    //     rep(j, path[i].size()) {
    //         if (j) cout << ' ' ;
    //         cout << path[i][j];
    //     }
    //     cout << "}" << endl;
    // }

    for (int mask = 0; mask < (1 << m); ++mask) {
        rep(i, m) {
            if (mask & (1 << i)) {
                reverse(all(path[i]));
            }
        }

        rep(i, n) {
            g[i].clear();
            gr[i].clear();
        }

        rep(i, m) {
            for (int j = 0; j + 1 < path[i].size(); ++j) {
                g[path[i][j]].push_back(path[i][j + 1]);
                gr[path[i][j + 1]].push_back(path[i][j]);
            }
        }

        // cout << "g[]: " << endl;
        // rep(i, n) {
        //     cout << "    g[" << i << "] = {";
        //     rep(j, g[i].size()) {
        //         if (j) cout << ' ';
        //         cout << g[i][j];
        //     }
        //     cout << "}" << endl;
        // }
        // cout << "gr[]: " << endl;
        // rep(i, n) {
        //     cout << "    gr[" << i << "] = {";
        //     rep(j, gr[i].size()) {
        //         if (j) cout << ' ';
        //         cout << gr[i][j];
        //     }
        //     cout << "}" << endl;
        // }

        if (colorize()) {
            int cur = *max_element(col, col + n);
            // cout << "colorized: " << cur << endl;
            if (cur < res) {
                res = cur;
                rep(i, n) {
                    ans[i] = col[i];
                }
            }
        }

        rep(i, m) {
            if (mask & (1 << i)) {
                reverse(all(path[i]));
            }
        }
    }

    if (res == inf) {
        cout << -1 << endl;
    } else {
        cout << res << endl;
        rep(i, n) {
            cout << ans[i] << ' ';
        }
        cout << endl;
    }
}
