#include <bits/stdc++.h>


using namespace std;


#define int long long


void warp()
{
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
}


void dfs(int v, vector<vector<int> > &g, vector<int> &p, vector<int> &h)
{
    for (int i = 0; i < g[v].size(); i++)
    {
        int u = g[v][i];
        if (u == p[v]) continue;
        p[u] = v;
        h[u] = h[v] + 1;
        dfs(u, g, p, h);
    }
}


int lca(int a, int b, vector<int> h, vector<int> p)
{
    while (h[a] > h[b]) a = p[a];
    while (h[b] > h[a]) b = p[b];
    while (a != b)
    {
        a = p[a];
        b = p[b];
    }
    return a;
}


bool isAncestor(int v, int up, vector<int> &p)
{
    if (v == up) return true;
    else return isAncestor(p[v], up, p);
}


bool in(set<pair<int, int> > &a, pair<int, int> b)
{
    return a.find(b) != a.end();
}


pair<int, int> opposite(pair<int, int> a, vector<pair<int, int> > &q)
{
    int v = a.first, i = a.second;
    return make_pair(q[i].first + q[i].second - v, i);
}


void mark(int v, vector<vector<int> > &g, vector<int> &dp)
{
    int top = 0;
    for (int i = 0; i < g[v].size(); i++)
    {
        int u = g[v][i];
        if (dp[u] == 0) mark(u, g, dp);
        top = max(top, dp[u]);
    }
    dp[v] = top + 1;
}


void dumbSolve(int n, int m, int t, vector<vector<int> > g, vector<pair<int, int> > q)
{
    vector<int> p(n, -1);
    vector<int> orient(n, -1);
    vector<int> h(n);
    dfs(0, g, p, h);
    vector<vector<pair<int, int> > > contain(n);
    for (int i = 0; i < m; i++)
    {
        int a = q[i].first, b = q[i].second;
        int l = a, r = b;
        int c = lca(a, b, h, p);
        while (a != c)
        {
            contain[a].push_back(make_pair(l, i));
            a = p[a];
        }
        while (b != c)
        {
            contain[b].push_back(make_pair(r, i));
            b = p[b];
        }
    }
    set<pair<int, int> > accept;
    vector<pair<int, int> > order;
    while (accept.size() != m || order.size())
    {
        if (order.size() == 0)
        {
            for (int i = 0; i < m; i++)
            {
                if (in(accept, make_pair(q[i].first, i)) || in(accept, make_pair(q[i].second, i)))
                {
                    continue;
                }
                order.push_back(make_pair(q[i].first, i));
                accept.insert(order.back());
                break;
            }
        }
        pair<int, int> cur = order.back();
        order.pop_back();
        int a = cur.first, numb = cur.second;
        int b = q[numb].first + q[numb].second - a;
        int c = lca(a, b, h, p);
        while (a != c)
        {
            if (orient[a] == 0)
            {
                cout << -1 << endl;
                return;
            }
            orient[a] = 1;
            for (int i = 0; i < contain[a].size(); i++)
            {
                pair<int, int> temp = contain[a][i];
                if (in(accept, opposite(temp, q)))
                {
                    cout << -1 << endl;
                    return;
                }
                if (!in(accept, temp)){
                    accept.insert(temp);
                    order.push_back(temp);
                }
            }
            a = p[a];
        }
        while (b != c)
        {
            if (orient[b] == 1)
            {
                cout << -1 << endl;
                return;
            }
            orient[b] = 0;
            for (int i = 0; i < contain[b].size(); i++)
            {
                pair<int, int> temp = contain[b][i];
                if (in(accept, temp))
                {
                    cout << -1 << endl;
                    return;
                }
                temp = opposite(temp, q);
                if (!in(accept, temp))
                {
                    accept.insert(temp);
                    order.push_back(temp);
                }
            }
            b = p[b];
        }
    }
    vector<vector<int> > newg(n);
    for (int i = 0; i < n; i++)
    {
        if (orient[i] == 1)
        {
            newg[i].push_back(p[i]);
        }
        if (orient[i] == 0) newg[p[i]].push_back(i);
    }
    vector<int> dp(n);
    for (int i = 0; i < n; i++)
    {
        if (dp[i]) continue;
        mark(i, newg, dp);
    }
    int k = 0;
    for (int i = 0; i < n; i++) k = max(k, dp[i]);
    cout << k << endl;
    for (int i = 0; i < n; i++) cout << dp[i] << " ";
    cout << endl;
}


signed main()
{
    warp();
    int n, m;
    cin >> n >> m;
    int t;
    cin >> t;
    vector<vector<int> > g(n);
    for (int i = 0; i < n - 1; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<pair<int, int> > q(m);
    for (int i = 0; i < m; i++)
    {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        q[i] = make_pair(a, b);
    }
    if (n <= 100 && m <= 100)
    {
        dumbSolve(n, m, t, g, q);
        return 0;
    }
    return 0;
}
