#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

//vector<unordered_map<int>> g;

void dfs(int cv, vector<unordered_set<int>> &g, vector<bool> &used, vector<int> &topsort) {
    used[cv] = true;
    for (int nv : g[cv]) {
        if (!used[nv]) {
            dfs(nv, g, used, topsort);
        }
    }
    topsort.push_back(cv);
}

bool go(int cv, int t, vector<unordered_set<int>> &g, vector<bool> &used) {
    used[cv] = true;
    if (cv == t) {
        return true;
    }
    for (int nv : g[cv]) {
        if (!used[nv] && go(nv, t, g, used)) {
            g[nv].erase(cv);
            return true;
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m, t;
    cin >> n >> m >> t;
    vector<pair<int, int>> edges(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        cin >> edges[i].first >> edges[i].second;
        edges[i].first--;
        edges[i].second--;
    }
    vector<pair<int, int>> paths(m);
    for (int i = 0; i < m; ++i) {
        cin >> paths[i].first >> paths[i].second;
        paths[i].first--;
        paths[i].second--;
    }
    int ansm = 2 * n;
    vector<int> ansc(n, -1);
    for (int mask = 0; mask < (1 << m); ++mask) {
        vector<unordered_set<int>> g(n);
        for (auto e : edges) {
            g[e.first].insert(e.second);
            g[e.second].insert(e.first);
        }
        bool flag = true;
        vector<bool> used1(n);
        for (int i = 0; i < m; ++i) {
            if (mask & (1 << i)) {
                if (!go(paths[i].first, paths[i].second, g, used1)) {
                    flag = false;
                    break;
                }
            } else {
                if (!go(paths[i].second, paths[i].first, g, used1)) {
                    flag = false;
                    break;
                }
            }
        }
        if (!flag) {
            continue;
        }
        vector<pair<int, int>> fordel;
        for (auto e : edges) {
            if (g[e.first].count(e.second) && g[e.second].count(e.first)) {
                fordel.push_back(e);
            }
        }
        for (auto e : fordel) {
            g[e.first].erase(e.second);
            g[e.second].erase(e.first);
        }
        vector<bool> used(n);
        vector<int> topsort;
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                dfs(i, g, used, topsort);
            }
        }
        vector<int> dp(n, 1);
        for (int i = n - 1; i >= 0; --i) {
            int cv = topsort[i];
            for (int j : g[cv]) {
                dp[j] = max(dp[j], dp[cv] + 1);
            }
        }
        if (*max_element(dp.begin(), dp.end()) < ansm) {
            ansm = *max_element(dp.begin(), dp.end());
            ansc.swap(dp);
        }
    }
    if (ansm > n) {
        cout << -1 << endl;
        return 0;
    }
    cout << ansm << endl;
    for (int i : ansc) {
        cout << i << " ";
    }
    cout << endl;
}