#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int maxn = 5e5 + 5;

vector <int> e[maxn];
bool used[maxn];
vector <int> chs[maxn];
int p[maxn];
int tin[maxn], tout[maxn], ctim = 1;

void dfs_init(int v) {
    used[v] = true;
    tin[v] = ctim++;
    for (int u : e[v]) {
        if (!used[u]) {
            chs[v].push_back(u);
            p[u] = v;
            dfs_init(u);
        }
    }
    tout[v] = ctim++;
}

inline bool isp(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

int lca(int a, int b) {
    while (!isp(a, b))
        a = p[a];
    return a;
}

int dinp[maxn];
vector <int> same[maxn];
vector <pair <int, int> > diff[maxn];

inline int put_dinp(int v, int w) {
    assert(v != w);
    for (int t = v; t != w; t = p[t])
        dinp[t] = true;
    int lst = v;
    for (int t = v; p[t] != w; t = p[t]) {
        same[p[t]].push_back(t);
        lst = p[t];
    }
    return lst;
}

int chnof[maxn];
bool typ[maxn]; /// true - greater than parent
vector <vector <int> > ed;
vector <int> cv;
vector <int> cused;
bool bad = false;
int cres[maxn];
int n, m, T;

void cdfs(int v) {
    //cerr << "cdfs " << v << endl;
    cused[v] = true;
    for (int u : ed[v]) {
        //cerr << "-> " << u << "\n";
        if (cv[u] == cv[v]) {
            bad = true;
        }
        if (!cused[u]) {
            cv[u] = 3 - cv[v];
            cdfs(u);
        }
    }
}

void dfs_put(int v) {
    //cerr << "dfs_put " << v << " (typ = " << typ[v] << ", k = " << chs[v].size() << endl;
    int k = chs[v].size();
    for (int i = 0; i < k; i++) {
        chnof[chs[v][i]] = i;
    }
    ed.clear();
    ed.resize(k);
    cv.clear();
    cv.resize(k);
    cused.clear();
    cused.resize(k);
    for (int u : same[v]) {
        cv[chnof[u]] = (typ[v] ? 2 : 1);
        //cerr << "auto c " << chnof[u] << " " << cv[chnof[u]] << "\n";
    }
    for (pair <int, int> t : diff[v]) {
        int cv = t.first, cu = t.second;
        //cerr << "diff " << cv << " " << cu << "\n";
        ed[chnof[cv]].push_back(chnof[cu]);
        ed[chnof[cu]].push_back(chnof[cv]);
    }
    //cerr << "starting cdfs" << endl;
    for (int i = 0; i < k; i++) {
        if (cv[i] && !cused[i]) {
            cdfs(i);
        }
    }
    for (int i = 0; i < k; i++) {
        if (!cused[i]) {
            cv[i] = 1;
            cdfs(i);
        }
    }
    for (int i = 0; i < k; i++) {
        //cerr << "assign typ " << chs[v][i] << " " << typ[chs[v][i]] << "\n";
        typ[chs[v][i]] = (cv[i] == 1 ? false : true);
        cres[chs[v][i]] = (cv[i] == 1 ? cres[v] - 1 : cres[v] + 1);
    }
    for (int i = 0; i < k; i++) {
        dfs_put(chs[v][i]);
    }
}

void dfs_rec(int v) {
    for (int u : chs[v]) {
        if (!dinp[u]) {
            cres[u] = cres[v];
        }
        else {
            cres[u] = (typ[u] ? cres[v] + 1 : cres[v] - 1);
        }
        dfs_rec(u);
    }
}

int recres[maxn];
int opt = 1e9;

void rec(int v) {
    if (v == n + 1) {
        for (int i = 1; i <= n; i++) {
            for (int x : same[i]) {
                if (typ[i] != typ[x])
                    return;
            }
            for (pair <int, int> x : diff[i])
                if (typ[x.first] != typ[x.second])
                    return;
        }
        cres[1] = 0;
        dfs_rec(1);
        int mx = -1e9, mn = 1e9;
        for (int i = 1; i <= n; i++) {
            mx = max(mx, cres[i]);
            mn = min(mn, cres[i]);
        }
        if (mx - mn + 1 < opt) {
            opt = mx - mn + 1;
            for (int i = 1; i <= n; i++) {
                recres[i] = cres[i] - mn + 1;
            }
        }
        return;
    }
    typ[v] = false;
    rec(v + 1);
    typ[v] = true;
    rec(v + 1);
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
#endif // DEBUG
    cin >> n >> m >> T;
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        e[v].push_back(u);
        e[u].push_back(v);
    }
    int SV = 1;
    if (n > 15 || m > 15) {
        for (int i = 1; i <= n; i++) {
            if (e[i].size() > e[SV].size())
                SV = i;
        }
    }
    dfs_init(SV);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        int w = lca(v, u);
        int v1, u1;
        if (v != w)
            v1 = put_dinp(v, w);
        if (u != w)
            u1 = put_dinp(u, w);
        if (v != w && u != w) {
            diff[w].push_back({v1, u1});
        }
    }
    if (n <= 15 && m <= 15) {
        rec(1);
        if (opt == 1e9) {
            cout << -1;
            return 0;
        }
        cout << opt << "\n";
        for (int i = 1; i <= n; i++)
            cout << recres[i] << " ";
        return 0;
    }

    //assert(T == 0);
    typ[1] = true;
    dfs_put(SV);
    if (bad) {
        cout << -1;
        return 0;
    }
    /*for (int i = 1; i <= n; i++) {
        cerr << cres[i] << " ";
    }
    cerr << "\n";*/
    int mn = 1;
    for (int i = 1; i <= n; i++)
        mn = min(mn, cres[i]);
    for (int i = 1; i <= n; i++) {
        cres[i] += max(0, 1 - mn);
    }
    int mx = 0;
    for (int i = 1; i <= n; i++)
        mx = max(mx, cres[i]);
    cout << mx << "\n";
    for (int i = 1; i <= n; i++) {
        cout << cres[i] << " ";
    }
    return 0;
}
