#ifndef LOCAL
#pragma GCC optimize("Ofast,fast-math,unroll-loops,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#endif

#include <bits/stdc++.h>

using namespace std;

//#define int long long

const int MAXN = 15;

int n;
bool graph[MAXN][MAXN];
bool agraph[MAXN][MAXN];
bool vis1[MAXN], vis2[MAXN];

pair<int, int> dfs(int v, bool rev, bool *vis) {
  vis[v] = true;
  int d = 1, w = v;
  for (int u = 0; u < n; ++u) {
    if (vis[u])
      continue;
    if (!rev && !graph[v][u])
      continue;
    if (rev && !graph[u][v])
      continue;
    auto[dd, ww] = dfs(u, rev, vis);
    if (dd + 1 > d)
      d = dd + 1, w = ww;
  }
  return {d, w};
}

bool paint1(int v, int f, int d, int p, vector<int> &color) {
  if (v == f) {
    color[v] = d;
    return true;
  }
  for (int u = 0; u < n; ++u) {
    if (!graph[v][u] || u == p)
      continue;
    if (paint1(u, f, d + 1, v, color)) {
      color[v] = d;
      return true;
    }
  }
  return false;
}

void paint2(int v, int d, vector<int> &color) {
  color[v] = d;
  for (int u = 0; u < n; ++u) {
    if (color[u] != 0)
      continue;
    if (graph[v][u])
      paint2(u, d + 1, color);
    else if (graph[u][v])
      paint2(u, d - 1, color);
  }
}

int findk(vector<int> &color) {
  int k = 0;
//  memset(vis2, 0, n);
  for (int i = 0; i < n; ++i) {
//    if (vis2[i])
//      continue;
    memset(vis1, 0, n);
    auto[d1, u] = dfs(i, false, vis1);
    memset(vis1, 0, n);
    auto[d2, v] = dfs(u, true, vis1);
    paint1(v, u, 1, -1, color);
    k = max(k, d2);
  }
  for (int i = 0; i < n; ++i) {
    if (color[i] != 0)
      paint2(i, color[i], color);
  }
  return k;
}

bool setnapr(int v, int f, int p) {
  if (v == f)
    return true;
  for (int u = 0; u < n; ++u) {
    if (!agraph[v][u] || u == p)
      continue;
    if (setnapr(u, f, v)) {
      graph[v][u] = true;
      graph[u][v] = false;
      return true;
    }
  }
  return false;
}

bool checkiscan(int v, int f, int p) {
  if (v == f)
    return true;
  for (int u = 0; u < n; ++u) {
    if (!graph[v][u] || u == p)
      continue;
    if (checkiscan(u, f, v))
      return true;
  }
  return false;
}

bool paintall(int v, int d, int p, vector<int> &color, vector<vector<int>> &ngraph, vector<char> &isbr) {
  bool iscl = isbr[v];
  for (int u : ngraph[v]) {
    if (u == p)
      continue;
    iscl |= paintall(u, d + 1, v, color, ngraph, isbr);
  }
  if (iscl)
    color[v] = d;
  return iscl;
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.tie(nullptr);
  int m, t;
  cin >> n >> m >> t;
  if (m <= 15) {
    for (int i = 0; i < n - 1; ++i) {
      int a, b;
      cin >> a >> b;
      a--, b--;
      agraph[a][b] = true;
      agraph[b][a] = true;
    }
    vector<pair<int, int>> bran(m);
    for (auto &el : bran) {
      cin >> el.first >> el.second;
      el.first--, el.second--;
    }
    int finmask = (1<<m);
    int k = INT_MAX;
    vector<int> kcolor(n);
    for (int mask = 0; mask < finmask; ++mask) {
      for (int i = 0; i < m; ++i) {
        if ((mask>>i) & 1)
          setnapr(bran[i].first, bran[i].second, -1);
        else
          setnapr(bran[i].second, bran[i].first, -1);
      }
      bool isok = true;
      for (int i = 0; i < m && isok; ++i) {
        if ((mask>>i) & 1)
          isok &= checkiscan(bran[i].first, bran[i].second, -1);
        else
          isok &= checkiscan(bran[i].second, bran[i].first, -1);
      }
      if (!isok)
        continue;
      vector<int> color(n, 0);
      int kk = findk(color);
      if (kk < k) {
        k = kk;
        kcolor.swap(color);
      }
    }
    if (k == INT_MAX) {
      cout << -1;
      return 0;
    }
    cout << k << '\n';
    if (k <= 1e7) {
      for (int &el : kcolor)
        cout << el << ' ';
    }
  } else {
    vector<vector<int>> ngraph(n);
    for (int i = 0; i < n - 1; ++i) {
      int a, b;
      cin >> a >> b;
      a--, b--;
      ngraph[a].push_back(b);
      ngraph[b].push_back(a);
    }
    vector<char> isbr(n, 0);
    int kek1, kek2;
    cin >> kek1 >> kek2;
    kek1--, kek2--;
    isbr[kek1] = 1;
    isbr[kek2] = 1;
    for (int i = 1; i < m; ++i) {
      int a, b;
      cin >> a >> b;
      a--, b--;
      isbr[a] = 1;
      isbr[b] = 1;
      if (a != kek1 && b != kek1)
        kek1 = -1;
      if (a != kek2 && b != kek2)
        kek2 = -1;
    }
    if (kek1 == -1)
      swap(kek1, kek2);
    vector<int> color(n, 1);
    paintall(kek1, 1, -1, color, ngraph, isbr);
    int k = *max_element(color.begin(), color.end());
    cout << k << '\n';
    for (int  &el : color)
      cout << el << ' ';
  }
  return 0;
}