#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

ll gcd(ll a, ll b) {
    return b ? gcd(b, a % b) : a;
}
ll time() {
    return chrono::steady_clock::now().time_since_epoch().count();
}

#define SPAR 0
#define FEN 0
#define SEG 0

#if SPAR
namespace SPARSE {
    bool run = false;
    const int N = 1e5;
    const int LOG = 17;

    int log[N];

    void init() {
        if (!run) {
            run = true;
            log[0] = 0;

            for (int i = 1; i < LOG; ++i) {
                for (int j = (1 << i); j < (1 << (i + 1)) && j < N; ++j)
                    log[j] = i;
            }
        }
    }
};
struct Sparse {
    int n, p = 0;
    int **t;

    Sparse(int _n) {
        SPARSE::init();
        n = _n;
        t = new int*[n];
        for (int i = 0; i < n; ++i)
            t[i] = new int[SPARSE::LOG];
    }

    void push(int x) {
        t[n - p - 1][0] = x;
        for (int i = 0; i < SPARSE::LOG - 1; ++i) {
            if (n - p - 1 + (1 << i) < n)
                t[n - p - 1][i + 1] = min(t[n - p - 1][i], t[n - p - 1 + (1 << i)][i]);
            else
                t[n - p - 1][i + 1] = t[n - p - 1][i];
        }
        p++;
    }

    int get(int l, int r) {
        int k = SPARSE::log[r - l];

        return min(t[l][k], t[r - (1 << k)][k]);
    }
};
#endif

#if FEN
struct Fen {
    ll *t;
    int n;
    Fen(int _n) {
        n = _n;
        t = new ll[n];

        memset(t, 0, sizeof(t[0]) * n);
    }

    void add(int i, ll x) {
        for (;i < n; i = i | (i + 1))
            t[i] += x;
    }

    ll get(int r) {
        r--;
        ll res = 0;
        for (;r >= 0; r = (r & (r + 1)) - 1)
            res += t[r];
        return res;
    }

    ll get(int l, int r) {
        r = max(r, 0);
        r = min(r, n);
        l = max(l, 0);
        l = min(l, n);
        return get(r) - get(l);
    }
};
#endif

#if SEG
struct SegTree {
    int n;
    ll *t, *d;

    SegTree(int _n) {
        n = _n;
        int sz = 1;
        while (sz < 2 * n) sz *= 2;
        t = new ll[sz];
        d = new ll[sz];

        for (int i = 0; i < sz; ++i)
            t[i] = d[i] = 0;
    }

    ll getV(int v, int vl, int vr) {
        return t[v] + d[v] * (vr - vl);
    }

    void push(int v, int vl, int vr) {
        d[2 * v + 1] += d[v];
        d[2 * v + 2] += d[v];
        t[v] = getV(2 * v + 1, vl, vr) + getV(2 * v + 2, vl, vr);
    }

    void upd(int v, int vl, int vr, int l, int r, ll x) {
        if (vl == l && vr == r) {
            d[v] += x;
        } else {
            push(v, vl, vr);
            int m = (vl + vr) / 2;

            if (r <= m)
                upd(2 * v + 1, vl, m, l, r, x);
            else if (m <= l)
                upd(2 * v + 2, m, vr, l, r, x);
            else
                upd(2 * v + 1, vl, m, l, m, x), upd(2 * v + 2, m, vr, m, r, x);

            t[v] = getV(2 * v + 1, vl, vr) + getV(2 * v + 2, vl, vr);
        }
    }

    void upd(int l, int r, ll x) {
        upd(0, 0, n, l, r, x);
    }

    ll get(int v, int vl, int vr, int l, int r) {
        if (vl == l && vr == r) {
            return getV(v, vl, vr);
        } else {
            int m = (vl + vr) / 2;
            push(v, vl, vr);

            if (r <= m)
                return get(2 * v + 1, vl, m, l, r);
            else if (m <= l)
                return get(2 * v + 2, m, vr, l, r);
            else
                return get(2 * v + 1, vl, m, l, m) + get(2 * v + 2, m, vr, m, r);
        }
    }

    ll get(int l, int r) {
        r = min(r, n);
        l = min(l, n);
        if (l == r) return 0;
        return get(0, 0, n, l, r);
    }
};
#endif

const int N = 1e5 + 7;
const int LOG = 17;
vector<int> g[N];

int t = 0;
int up[N][LOG];
int tin[N];
int d[N];
int pr[N];

void dfs_lca(int v = 0, int p = 0, int D = 0) {
    pr[v] = p;

    tin[v] = t++;
    d[v] = D;
    up[v][0] = p;
    for (int i = 1; i < LOG; ++i)
        up[v][i] = up[up[v][i - 1]][i - 1];
    for (int to: g[v]) {
        if (to == p) continue;
        dfs_lca(to, v, D + 1);
    }
}

int lca(int u, int v) {
    if (u == v) return u;
    if (tin[u] > tin[v])
        swap(u, v);

    for (int i = LOG - 1; i >= 0; --i) {
        if (tin[up[v][i]] > tin[u])
            v = up[v][i];
    }
    return up[v][0];
}

int len_lca(int u, int v) {
    int l = lca(u, v);
    return d[u] + d[v] - 2 * d[l];
}

void paint(int in, int to, int *res) {
    int l = lca(in, to);
    int len = len_lca(in, to) + 1;

    int p = 1;

    while (true) {
        res[in] = p++;
        if (in == l) break;
        in = pr[in];
    }

    while (to != l)
        res[to] = len--, to = pr[to];
}

int main() {
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m, T;
    cin >> n >> m >> T;

    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;

        g[u].push_back(v);
        g[v].push_back(u);
    }

    dfs_lca();

    int ans = 0;
    int res[n];

    for (int i = 0; i < n; ++i)
        res[i] = 1;

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        ans = max(ans, len_lca(u, v) + 1);
        paint(u, v, res);
    }

    cout << ans << "\n";

    if (T) {
        for (int i = 0; i < n; ++i)
            cout << res[i] << " ";
    }

    return 0;
}

