#include <iostream>
#include <vector>
#define fi first
#define se second
using namespace std;

const int MAXN = 500005;

struct edge
{
    int u, v, d;
};

int n, m, t;
vector<int> g[MAXN];
edge e[MAXN];

int vis[MAXN];
pair<int, int> route[MAXN];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m >> t;
    for (int i = 1; i < n; ++ i)
    {
        int u, v;
        cin >> e[i].u >> e[i].v;
        u = e[i].u;
        v = e[i].v;
        g[u].push_back(i);
        g[v].push_back(i);
        e[i].d = -1;
    }
}

bool DFS1(int u, int s, int dep = 1)
{
    if (u == s)
    {
        vis[u] = max(vis[u], dep);
        return true;
    }

    for (int adj : g[u])
    {
        int v, r;
        if (e[adj].u == u) {v = e[adj].v; r = 0;}
        else {v = e[adj].u; r = 1;}

        if (e[adj].d == -1)
        {
            e[adj].d = r;
            bool res = DFS1(v, s, dep + 1);
            if (res)
            {
                vis[u] = max(vis[u], dep);
                return true;
            }
            else e[adj].d = -1;
        }
        else if (e[adj].d == r)
        {
            e[adj].d = r;
            bool res = DFS1(v, s, dep + 1);
            if (res)
            {
                vis[u] = max(vis[u], dep);
                return true;
            }
        }
    }

    return false;
}

bool DFS2(int u, int s, int dep = 1)
{
    if (u == s)
    {
        vis[u] = max(vis[u], dep);
        return true;
    }

    dep = max(dep, vis[u]);

    for (int adj : g[u])
    {
        int v, r;
        if (e[adj].u == u) {v = e[adj].v; r = 0;}
        else {v = e[adj].u; r = 1;}

        if (e[adj].d == -1)
        {
            e[adj].d = r;
            bool res = DFS2(v, s, dep + 1);
            if (res)
            {
                vis[u] = max(vis[u], dep);
                return true;
            }
            else e[adj].d = -1;
        }
        else if (e[adj].d == r)
        {
            e[adj].d = r;
            bool res = DFS2(v, s, dep + 1);
            if (res)
            {
                vis[u] = max(vis[u], dep);
                return true;
            }
        }
    }

    return false;
}

int mainprim(int bitmask, int tt =  0)
{
    for (int i = 0; i <= n; ++ i) vis[i] = 0;

    for (int i = 1; i <= m; ++ i)
    {
        int s, e;
        s = route[i].fi;
        e = route[i].se;

        if (bitmask & (1 << (i - 1))) swap(s, e);

        if (!DFS1(s, e))
        {
            return -1;
        }
    }

    for (int j = 1; j <= 1000; ++ j)
    for (int i = 1; i <= m; ++ i)
    {
        int s, e;
        s = route[i].fi;
        e = route[i].se;
        if (bitmask & (1 << (i - 1))) swap(s, e);


        DFS2(s, e);
    }

    int ans = 0;
    for (int i = 1; i <= n; ++ i)
    {
        vis[i] = max(vis[i], 1);
        ans = max(ans, vis[i]);
    }

    if (tt == 0) return ans;


    cout << max(1, ans) << endl;
    if (t == 1)
    {
        for (int i = 1; i <= n; ++ i)
        {
            cout << max(1, vis[i]) << ' ';
        }
        cout << endl;
    }

    return 0;
}

int main()
{
    Init();

    for (int i = 1; i <= m; ++ i)
    {
        int s, e;
        cin >> route[i].fi >> route[i].se;
    }

    int mmask = -1, mans = 1 << 30;
    for (int i = 0; i < (1 << m); ++ i)
    {
        int res = mainprim(i);
        if (res != -1 and res < mans)
        {
            mans = res;
            mmask = i;
        }
    }

    if (mans == 1 << 30)
    {
        cout << -1 << endl;
        return 0;
    }
    mainprim(mmask, 1);

    return 0;
}

/*

9 3 1
1 2
3 2
4 2
4 5
6 5
5 9
9 8
7 8
3 1
7 4
6 2

*/
