#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <cmath>
#include <random>
#pragma GCC optimize("Ofast")

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

random_device rd;
mt19937 rnd(rd());

ll n, m;
vector <vector <ll>> gr, g(101, vector <ll>(101));
vector <vector <ll>> ap;
vector <ll> p, otv, ans;
vector <bool> u;

void bfs(ll v) {
    queue <ll> q;
    q.push(v);
    u[v] = true;
    while (!q.empty()) {
        ll t = q.front();
        q.pop();
        for (auto to : gr[t]) {
            if (!u[to]) {
                q.push(to);
                ans[to] = ans[t] + 1;
                u[t] = true;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    ll t;
    cin >> n >> m >> t;
    gr.resize(n);
    u.resize(n);
    for (ll i = 0; i < n - 1; i++) {
        ll a, b;
        cin >> a >> b, a--, b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    for (ll i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b, a--, b--;
    }
    ll st = -1;
    for (ll i = 0; i < n; i++)
        if (gr[i].size() == n - 1) {
            st = i;
            break;
        }
    if (st == -1) {
        cout << -1;
        return 0;
    }
    ans.assign(n, 1);
    bfs(st);
    cout << *max_element(ans.begin(), ans.end()) << '\n';
    if (t == 1)
        for (ll i = 0; i < n; i++)
            cout << ans[i] << " ";
    return 0;
}