#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>


using namespace std;


struct E {
    int a, b;

    E() {};

    E(int _a, int _b) : a(_a), b(_b) {};

    int cn(int v) {
        return a ^ b ^ v;
    }

    bool from(int v) {
        return v == a;
    }
};


vector<vector<int>> graph;
vector<int> pe, h;
vector<E> es;
vector<vector<int>> pgraph;
vector<int> pused, eorient, porient, comps;
vector<set<pair<int, int>>> pes;
vector<vector<int>> ngraph;
vector<int> c;


void sdfs(int v) {
    for (int e : graph[v]) {
        if (e == pe[v]) {
            continue;
        }

        int u = es[e].cn(v);

        pe[u] = e;
        h[u] = h[v] + 1;

        sdfs(u);
    }
}


int parent(int v) {
    return es[pe[v]].cn(v);
}


int lca(int a, int b) {
    while (h[a] > h[b]) {
        a = parent(a);
    }

    while (h[b] > h[a]) {
        b = parent(b);
    }

    while (a != b) {
        a = parent(a);
        b = parent(b);
    }

    return a;
}


int ccomp = 0;


bool pdfs(int v) {
    pused[v] = 1;

    int cr = -1;
    for (auto cp : pes[v]) {
        int eor = eorient[cp.first];
        if (eor != -1) {
            if (cr == -1) {
                cr = eor ^ cp.second;
            } else {
                int por = cr ^ cp.second;

                if (eor != por) {
                    return false;
                }
            }
        }
    }

    if (cr == -1) {
        cr = 0;
    }

    for (auto cp : pes[v]) {
        int eor = eorient[cp.first];
        if (eor == -1) {
            eorient[cp.first] = cr ^ cp.second;
            comps[cp.first] = ccomp;
        }
    }

    porient[v] = cr;

    for (int u : pgraph[v]) {
        if (pused[u]) {
            continue;
        }

        if (!pdfs(u)) {
            return false;
        }
    }

    return true;
}


void cdfs(int v) {
    int res = 0;
    for (int u : ngraph[v]) {
        if (c[u] == -1) {
            cdfs(u);
        }

        res = max(res, c[u] + 1);
    }

    c[v] = res;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, m, t;
    cin >> n >> m >> t;

    graph.resize(n);

    int u, v;
    for (int i = 0; i < n - 1; ++i) {
        cin >> u >> v;

        --u;
        --v;

        graph[u].push_back(es.size());
        graph[v].push_back(es.size());

        es.emplace_back(u, v);
    }

    pe.resize(n, -1);
    h.resize(n);

    sdfs(0);

    vector<int> as(m), bs(m);
    for (int i = 0; i < m; ++i) {
        cin >> as[i] >> bs[i];

        --as[i];
        --bs[i];
    }

    pes.resize(m);

    for (int i = 0; i < m; ++i) {
        int a = as[i], b = bs[i];
        int c = lca(a, b);

        while (a != c) {
            pes[i].emplace(pe[a], !es[pe[a]].from(a));
            a = parent(a);
        }

        while (b != c) {
            pes[i].emplace(pe[b], es[pe[b]].from(b));
            b = parent(b);
        }
    }

    pgraph.resize(m);
    for (int i = 0; i < m; ++i) {
        for (int j = i + 1; j < m; ++j) {
            for (auto cp : pes[i]) {
                if (pes[j].find(cp) != pes[j].end()) {
                    pgraph[i].push_back(j);
                    pgraph[j].push_back(i);

                    break;
                }

                cp.second ^= 1;

                if (pes[j].find(cp) != pes[j].end()) {
                    pgraph[i].push_back(j);
                    pgraph[j].push_back(i);

                    break;
                }
            }
        }
    }

    pused.resize(m);
    eorient.resize(n - 1, -1);
    porient.resize(m, -1);
    comps.resize(n - 1, -1);

    for (int i = 0; i < m; ++i) {
        if (pused[i]) {
            continue;
        }

        if (!pdfs(i)) {
            cout << -1;

            return 0;
        }

        ++ccomp;
    }

    int answ = n + 1;
    vector<int> answcs;

    for (int mask = 0; mask < (1 << m); ++mask) {
        vector<int> flip(m);
        int cm = mask;
        for (int i = 0; i < m; ++i) {
            flip[i] = cm % 2;
            cm /= 2;
        }

        ngraph.clear();
        ngraph.resize(n);

        for (int i = 0; i < n - 1; ++i) {
            int cor = eorient[i];
            if (flip[comps[i]]) {
                cor ^= 1;
            }

            if (cor == 0) {
                ngraph[es[i].a].push_back(es[i].b);
            } else {
                ngraph[es[i].b].push_back(es[i].a);
            }
        }

        c.assign(n, -1);

        for (int i = 0; i < n; ++i) {
            if (c[i] != -1) {
                continue;
            }

            cdfs(i);
        }

        int cmaxc = 0;
        for (int i = 0; i < n; ++i) {
            cmaxc = max(cmaxc, c[i]);
        }

        if (cmaxc < answ) {
            answ = cmaxc;
            answcs = c;
        }
    }

    cout << answ + 1 << '\n';
    for (int x : answcs) {
        cout << x + 1 << ' ';
    }

    return 0;
}
