#include <bits/stdc++.h>

#define int long long
#define endl "\n"
#define pii pair<int, int>
#define B begin
#define E end
#define F first
#define S second

typedef long long ll;

const int INF = 1e9 + 1;
const int P = 1e9 + 7;

using namespace std;

void hello()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    // freopen("input.txt", "r", stdin);
}

void show(vector <int>& arr)
{
    for (auto i : arr)
        cout << i << " ";
    cout << endl;
}
void show(vector<vector<int>>& arr)
{
    for (auto i : arr)
        show(i);
    cout << endl;
}

const int MAXN = 2e5 * 4 + 1;
int tree[MAXN];

void build(int v, int cl, int cr, vector <int>& data)
{
    if (cl == cr)
    {
        tree[v] = data[cl];
        return;
    }
    int cm = (cl + cr) / 2;
    build(2 * v, cl, cm, data);
    build(2 * v + 1, cm + 1, cr, data);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

void change(int v, int cl, int cr, int ind, int val)
{
    if (cl > ind || cr < ind)
        return;
    if (cl == cr)
    {
        tree[v] = val;
        return;
    }
    int cm = (cl + cr) / 2;
    change(2 * v, cl, cm, ind, val);
    change(2 * v + 1, cm + 1, cr, ind, val);
    tree[v] = tree[2 * v] + tree[2 * v + 1];
}

int query(int v, int cl, int cr, int l, int r)
{
    if (cl >= l && cr <= r)
        return tree[v];
    if (cl > r || l > cr)
        return 0;
    int cm = (cl + cr) / 2;
    return query(2 * v, cl, cm, l, r) + query(2 * v + 1, cm + 1, cr, l, r);
}

vector <int> tin, tout;
vector <int> up;
int times = 0;

void prec(int v, int p, vector<vector <int>>& graph)
{
    tin[v] = ++times;
    up[v] = p;
    for (auto to : graph[v])
    {
        if (to != p)
            prec(to, v, graph);
    }
    tout[v] = ++times;
}

signed main()
{
    hello();

    int n, m, t;
    cin >> n >> m >> t;
    vector <vector <int>> graph(n);
    vector <pii> edges;
    for (int i = 0; i < n - 1; ++i)
    {
        int x, y;
        cin >> x >> y;
        graph[x - 1].push_back(y - 1);
        graph[y - 1].push_back(x - 1);
        edges.push_back({min(x - 1, y - 1), max(y - 1, x - 1)});
    }

    vector <vector <int>> rds(m);

    tin.resize(n);
    tout.resize(n);
    up.resize(n);
    prec(0, -1, graph);

    for (int i = 0; i < m; ++i)
    {
        int st, fin;
        cin >> st >> fin;
        --st; --fin;
        int v = st, u = fin;
        vector <int> tmp;
        while (!(tin[v] <= tout[u] && tout[v] >= tout[u]))
        {
            rds[i].push_back(v);
            v = up[v];
        }
        rds[i].push_back(v);
        while (v != u)
        {
            tmp.push_back(u);
            u = up[u];
        }
        reverse(tmp.B(), tmp.E());
        for (auto val : tmp)
            rds[i].push_back(val);
    }

    int res = INF;
    vector <int> ares;
    for (int mask = 0; mask < (1 << m); ++mask)
    {
        map <pii, int> check;
        bool flag = 0;
        for (int i = 0; i < m; ++i)
        {
            int val = 0;
            if (mask & (1 << i))
                val = 1;
            for (int j = 0; j < rds[i].size() - 1; ++j)
            {
                bool c1 = 0;
                if (min(rds[i][j], rds[i][j + 1]) == rds[i][j + 1])
                    c1 = 1;
                int v = min(rds[i][j], rds[i][j + 1]);
                int u = max(rds[i][j], rds[i][j + 1]);
                if (check.count({v, u}) && check[{v, u}] != (val ^ c1))
                    flag = 1;
                else
                    check[{v, u}] = (val ^ c1);
            }
        }
        if (flag)
            continue;

        vector <vector <int>> ngraph(n);
        vector <int> tares(n, -1);
        int tres = 0;
        for (auto val : check)
            if (val.S == 1)
                ngraph[val.F.S].push_back(val.F.F);
            else
                ngraph[val.F.F].push_back(val.F.S);


        while (true)
        {
            bool flag = 0;
            for (int i = 0; i < n; ++i)
            {
                if (tares[i] != -1)
                    continue;
                int maxv = 0, minv = INF;
                for (int j = 0; j < n; ++j)
                    for (auto to : ngraph[j])
                        if (to == i && i != j)
                        {
                            //cout << j << endl;
                            maxv = max(maxv, tares[j]);
                            minv = min(minv, tares[j]);
                        }
                //cout << i << " " << minv << " " << maxv << endl;
                if (minv != -1)
                {
                    tares[i] = maxv + 1;
                    tres = max(tres, maxv + 1);
                    flag = 1;
                    break;
                }
            }
            if (!flag)
                break;
        }
        show(tares);
        if (tres < res)
        {
            res = tres;
            ares = tares;
        }
    }

    if (res == INF)
    {
        cout << -1 << endl;
    }
    else
    {
        cout << res << endl;
        show(ares);
    }

}
