#include <iostream>
#include <assert.h>
#include <math.h>
#include <vector>
#include <map>
#include <algorithm>
#include <random>
#include <chrono>
#include <queue>
#include <set>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse,popcnt")

#define ll long long
#define vll vector<ll>
#define pb push_back
#define pll pair<ll, ll>
#define vii vector<int>
#define pii pair<int, int>
#define vpll vector<pll>
#define f first
#define s second

#define MOD (ll)(1e9 + 7)

ll n, m, t;
vector<vll > nodes;

bool dfs(ll v, ll prev, ll goal)
{
   // cerr << "dfs " << v << endl;
    if(v == goal)
        return 1;

    for(int to = 0; to < nodes[v].size(); to++)
    {
        if(to == prev || nodes[v][to] <= 0)
            continue;

        ll prevTo = nodes[v][to];
        ll prevFrom = nodes[to][v];
        nodes[v][to] = 1;
        nodes[to][v] = -1;
        if(dfs(to, v, goal))
            return 1;
        nodes[to][v] = prevFrom;
        nodes[v][to] = prevTo;
    }
    return 0;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    cin >> n >> m >> t;
    nodes.resize(n, vll(n));

    for(int i = 0; i < n - 1; i++)
    {
        ll u, v;
        cin >> u >> v;
        u--;
        v--;
        nodes[u][v] = 2;
        nodes[v][u] = 2;
    }

    vpll ways(m);
    for(int i = 0; i < m; i++)
    {
     /*   cerr << "nodes" << endl;
        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < n; j++)
                cerr << nodes[i][j] << " ";
            cerr << endl;
        }
*/
        cin >> ways[i].f >> ways[i].s;
        ways[i].f--;
        ways[i].s--;

        bool try1 = dfs(ways[i].f, -1, ways[i].s);
       // cerr << "try1 " << try1 << endl;
        if(try1)
            continue;
        try1 = dfs(ways[i].s, -1, ways[i].f);
        if(try1)
            continue;
        assert(0);
        cout << -1 << endl;
        return 0;
    }

    vll color(n);

    queue<ll> q;
    vll c(n, 1);
    for(int i = 0; i < n; i++)
    {
        bool flag = 0;
        for(int j = 0; j < n; j++)
        {
            if(nodes[i][j] == -1)
                flag = 1;
        }
        if(flag)
            continue;
        q.push(i);
    }

    while(q.size() != 0)
    {
        int cur = q.front();
        q.pop();

        for(int i = 0; i < n; i++)
        {
            if(nodes[i][cur] == -1)
            {
                c[i] = max(c[i], c[cur] + 1);
                nodes[i][cur] = 0;
                bool flag = 0;
                for(int j = 0; j < n; j++)
                {
                    if(nodes[i][j] == -1)
                        flag = 1;
                }
                if(flag)
                    continue;
                q.push(i);
            }
        }
    }

    ll k = (ll)(0);
    for(int i = 0; i < c.size(); i++)
        k = max(k, c[i]);
    cout << k << endl;
    for(int i = 0; i < c.size(); i++)
        cout << c[i] << " ";
    return 0;
}