#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <iomanip>
#include <algorithm>
#include <math.h>

using namespace std;

#define nl '\n'
#define all(a) a.begin(), a.end()
#define z(n) fixed << setprecision(n)

typedef long long ll;
typedef int T;

const int INF = 1e9;
const double EPS = 1e-5;
const double PI = cos(-1);

inline void IO() {
#ifdef Dmitry07
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

//#define int ll

vector<vector<int>> g, nxt, prv;
int n, m, qqqqq;

vector<int> bfs(int v, vector<int>& par) {
	vector<int> d(n, -INF);
	d[v] = 0;
	queue<int> q;
	q.push(v);
	while (q.size()) {
		v = q.front();
		q.pop();
		for (auto to : g[v]) {
			if (d[to] == -INF) {
				d[to] = d[v] + 1;
				par[to] = v;
				q.push(to);
			}
		}
	}
	return d;
}

void calc_path(int a, int b) {
	vector<int> par(n, -1);
	bfs(a, par);
	vector<int> path;
	while (b != a) {
		path.push_back(b);
		b = par[b];
	}
	path.push_back(a);
	reverse(all(path));
	for (int i = 0; i + 1 < path.size(); i++) {
		nxt[path[i]].push_back(path[i + 1]);
		prv[path[i + 1]].push_back(path[i]);
	}
}

vector<int> ans, ans1;
int minn = 1000;

bool check() {
	for (int i = 0; i < n; i++) {
		for (auto to : nxt[i]) {
			if (ans[to] <= ans[i]) {
				return 0;
			}
		}
	}
	return 1;
}

void rec(int pos) {
	if (pos == n) {
		if (!check()) {
			return;
		}
		if (*max_element(all(ans)) < minn) {
			minn = *max_element(all(ans));
			ans1 = ans;
		}
		return;
	}
	int r = 20, l = 1;
	for (auto t : nxt[pos]) {
		if (t < pos)
			r = min(r, ans[t] - 1);
	}
	for (auto t : prv[pos]) {
		if (t < pos)
			l = max(l, ans[t] + 1);
	}
	for (int i = l; i <= r; i++) {
		ans[pos] = i;
		rec(pos + 1);
	}
}

inline void solve() {
	cin >> n >> m >> qqqqq;
	g.resize(n);
	nxt.resize(n);
	prv.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int q, w;
		cin >> q >> w;
		q--;
		w--;
		g[q].push_back(w);
		g[w].push_back(q);
	}
	vector<pair<int, int>> lines(m);
	for (int i = 0; i < m; i++) {
		int q, w;
		cin >> q >> w;
		q--;
		w--;
		lines[i] = { q, w };
		calc_path(q, w);
	}
	ans.resize(n, -1);
	rec(0);
	if (minn == 1000) {
		cout << -1;
		return;
	}
	cout << minn << nl;
	if (qqqqq) {
		for (auto t : ans1) {
			cout << t << ' ';
		}
	}
}

signed main() {
	IO();
	int t;
	t = 1;
	while (t--)
		solve();
}