#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

#define int long long
#define double long double
#define ff first
#define ss second
#define pb push_back
#define pf push_front
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define TIME ((clock() - start_time) / CLOCKS_PER_SEC)

//using namespace __gnu_pbds;
using namespace std;

const int inf = 1e18;
const double eps = 1e-6;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count() + rand());

const int maxn = 5e5 + 100;
const int lg = 25;

vector<int> g[maxn];
int tin[maxn], tout[maxn];
int p[lg][maxn], d[maxn];
int t = 0;

void dfs_lca(int v, int pr, int di)
{
    tin[v] = t++;
    d[v] = di;
    p[0][v] = pr;
    for (int i = 1; i < lg; ++i)
        p[i][v] = p[i - 1][p[i - 1][v]];
    for (int u : g[v])
    {
        if (u == pr) continue;
        dfs_lca(u, v, di + 1);
    }
    tout[v] = t++;
}

bool check(int a, int b)
{
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int lca(int a, int b)
{
    if (check(a, b)) return a;
    if (check(b, a)) return b;
    for (int i = lg - 1; i >= 0; --i)
    {
        if (!check(p[a][i], b))
            a = p[a][i];
    }
    return p[a][0];
}

int dist(int a, int b)
{
    return d[a] + d[b] - 2 * d[lca(a, b)];
}

vector<int> path[maxn];
vector<pair<int, int>> ev;

vector<vector<int>> gs;
vector<int> used, s;

void dfs(int v)
{
    used[v] = 1;
    s.pb(v);
    for (int u : gs[v])
    {
        if (used[u]) continue;
        dfs(u);
    }
}

signed main()
{
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    double start_time = clock();
    int n, m, tp;
    cin >> n >> m >> tp;
    for (int i = 0; i < n - 1; ++i)
    {
        int a, b;
        cin >> a >> b, --a, --b;
        g[a].pb(b);
        g[b].pb(a);
    }
    t = 0;
    dfs_lca(0, 0, 0);
    for (int qi = 0; qi < m; ++qi)
    {
        int a, b;
        cin >> a >> b, --a, --b;
        ev.pb({a, b});
        int plc = lca(a, b);
        int v = b;
        while (b != plc)
        {
            path[qi].pb(b);
            b = p[0][b];
        }
        path[qi].pb(plc);
        vector<int> add_path;
        while (a != plc)
        {
            add_path.pb(a);
            a = p[0][a];
        }
        reverse(all(add_path));
        for (int v : add_path) path[qi].pb(v);
        reverse(all(path[qi]));
    }
    vector<int> ans;
    int ans_res = inf;
    for (int mask = 0; mask < (1LL << m); ++mask)
    {
        for (int i = 0; i < m; ++i)
        {
            if ((mask >> i) & 1)
                reverse(all(path[i]));
        }
        vector<int> c(n, 1);
        gs.clear();
        gs.resize(n);
        vector<vector<int>> gsr(n), mat(n, vector<int>(n, 0));
        for (int i = 0; i < m; ++i)
        {
            for (int j = 0; j + 1 < sz(path[i]); ++j)
            {
                gs[path[i][j]].pb(path[i][j + 1]);
                mat[path[i][j]][path[i][j + 1]] = 1;
                gsr[path[i][j + 1]].pb(path[i][j]);
            }
        }
        bool flg_br = false;
        for (int i = 0; i < n; ++i)
        {
            for (int j = 0; j < n; ++j)
            {
                if (mat[i][j] && mat[j][i])
                {
                    flg_br = true;
                    break;
                }
            }
        }
        if (flg_br)
        {
            for (int i = 0; i < m; ++i)
            {
                if ((mask >> i) & 1)
                    reverse(all(path[i]));
            }
            continue;
        }
        used.assign(n, 0);
        s.clear();
        for (int i = 0; i < n; ++i)
        {
            if (used[i] || !sz(gs[i])) continue;
            dfs(i);
        }
        for (int v : s)
        {
            for (int u : gsr[v])
            {
                c[v] = max(c[v], c[u] + 1);
            }
        }
        int res = 0;
        for (int x : c) res = max(res, x);
        if (res < ans_res)
        {
            ans_res = res;
            ans = c;
        }
        for (int i = 0; i < m; ++i)
        {
            if ((mask >> i) & 1)
                reverse(all(path[i]));
        }
    }
    if (ans_res >= inf) cout << -1;
    else
    {
        cout << ans_res << "\n";
        for (int x : ans) cout << x << " ";
    }
    return 0;
}

/*
4 3 0
1 2
1 3
1 4
2 3
2 4
3 4

*/