#include <iostream>
#include <algorithm>
#include <iomanip>
#include <cassert>
#include <random>
#include <string>
#include <algorithm>
#include <queue>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <bitset>
#include <vector>

// #define !!!
#define all(x) x.begin(), x.end()
#define int long long

using namespace std;
typedef pair<int,int> pii;
inline void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

const int maxN = 5e5 + 123;
const int logN = 20;
vector <int> g[maxN];
map < pair<int,int>, int > num;
vector <int> d;
vector <int> tin, tout;
int up[maxN][logN];




int Timer = 0;

void dfs(int v, int p = -1) {
    up[v][0] = p;
    tin[v] = Timer++;
    for(auto u : g[v]) {
        if(u == p) continue;
        d[u] = d[v] + 1;
        dfs(u, v);
    }
    tout[v] = Timer++;
}

void bld(int n) {
    dfs(0 ,0);
    for(int j = 0; j < logN - 1; ++j) {
        for(int i = 0; i < n; ++i) {
            up[i][j + 1] = up[up[i][j]][j];
        }
    }
}

bool parrent(int a, int b) {
    return (tin[a] < tin[b] && tout[a] > tout[b]);
}

int lca(int v, int u) {
    if(d[v] > d[u]) swap(u, v);
    for(int i = logN - 1; i >= 0; --i) {
        if(!parrent(up[v][i], u)) v = up[v][i];
    }
    return up[v][0];
}


vector <int> get_path(int a, int b) {
    if(a == b) return {a};
    if(d[a] < d[b]) swap(a, b);
    vector <int> ret;
    while(a != b) {
        ret.push_back(a);
        a = up[a][0];
    }
    ret.push_back(b);
    return ret;
}

void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    d.assign(n, 0);
    tin.assign(n, 0);
    tout.assign(n, 0);
    for(int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    bld(n);
    vector <int> answer(n, 1);
    int ans = 0;
    while(m--) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        int LCA = lca(a, b);
//        cout << "LCA = " << LCA + 1 << '\n';
        ans = max(ans, d[a] + d[b] - 2 * d[LCA] + 1);
        vector <int> p1 = get_path(a, LCA);
        vector <int> p2 = get_path(b, LCA);
        int cnt = 1;
        for(int i = 0; i < p1.size(); ++i) {
//            cout << p1[i] + 1 << ' ';
            answer[p1[i]] = cnt++;
        }
        reverse(all(p2));
        for(int i = 1; i < p2.size(); ++i) {
//            cout << p2[i] + 1 << ' ';
            answer[p2[i]] = cnt++;
        }
//        cout << '\n';
    }
    cout << ans << '\n';
    if(t == 0) {
        return;
    }
    for(auto i : answer) {
        cout << i << ' ';
    }

}

signed main() {
#ifdef lolipop
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    solve();
    return 0;
}