#include <bits/stdc++.h>

using namespace std;

bool way_dfs(int v, int prev_v, int u,
        const vector<vector<int>>& adjList,
        vector<vector<int>>& dirgra) {
    if (v == u)
        return true;
    for (int to : adjList[v])
        if (prev_v != to && way_dfs(to, v, u, adjList, dirgra)) {
            dirgra[v].push_back(to);
            return true;
        }
    return false;
}

void dfs_paint(int v, const vector<vector<int>>& dirgra, vector<int>& c) {
    int val = 1;
    for (int to : dirgra[v]) {
        if (!c[to])
            dfs_paint(to, dirgra, c);
        val = max(val, c[to] + 1);
    }
    c[v] = val;
}

bool check_dfs(int v, int u, const vector<vector<int>>& dirgra) {
    if (v == u)
        return true;
    for (int to : dirgra[v])
        if (check_dfs(to, u, dirgra))
            return true;
    return false;
}

int main() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<vector<int>> adjList(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        adjList[v].push_back(u);
        adjList[u].push_back(v);
    }
    vector<pair<int, int>> line(m);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v;
        --u;
        line[i] = {v, u};
    }
    for (int mask = 0; mask < (1 << m); ++mask) {
        bool good = true;
        vector<vector<int>> dirgra(n);
        for (int i = 0; i < m; ++i) {
            int v = line[i].first, u = line[i].second;
            if ((mask >> i) & 1)
                swap(v, u);
            way_dfs(v, -1, u, adjList, dirgra);
        }
        vector<vector<char>> dirgraMat(n, vector<char>(n));
        for (int v = 0; v < n; ++v)
            for (int to : dirgra[v])
                dirgraMat[v][to] = 1;
        for (int v = 0; v < n; ++v)
            for (int u = 0; u < n; ++u)
                if (dirgraMat[v][v] || (dirgraMat[v][u] && (dirgraMat[u][v])))
                    good = false;
        if (!good)
            continue;
        for (int i = 0; i < m; ++i)
            if (!check_dfs(line[i].first, line[i].second, dirgra) &&
                !check_dfs(line[i].second, line[i].first, dirgra)) {
                good = false;
            }
        if (!good)
            continue;
        vector<char> onlyOut(n, 1);
        for (int v = 0; v < n; ++v)
            for (int to : dirgra[v])
                onlyOut[to] = 0;
        vector<int> c(n);
        for (int v = 0; v < n; ++v)
            if (onlyOut[v])
                dfs_paint(v, dirgra, c);
        int ans = 0;
        for (int v = 0; v < n; ++v)
            if (!c[v])
                good = false;
            else
                ans = max(ans, c[v]);
        if (good) {
            cout << ans << "\n";
            for (int e : c)
                cout << e << " ";
            return 0;
        }
    }
    cout << -1;
    return 0;
}
