//#pragma GCC optimize "-O3"
#include "bits/stdc++.h"

#define le(v) ((int)v.size())
#define pb push_back
#define mp make_pair
#define mt make_tuple
#define x first
#define y second

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

template<class T>
ostream &operator<<(ostream &os, const vector<T> &v) {
	for (const T &x : v)
		os << x << " ";
	return os;
}

template<class A, class B>
ostream &operator<<(ostream &os, const pair<A, B> &pp) {
	os << pp.x << " " << pp.y << " ";
	return os;
}

template<class T>
istream &operator>>(istream &is, vector<T> &v) {
	for (T &x : v)
		is >> x;
	return is;
}

template<class A, class B>
istream &operator>>(istream &is, pair<A, B> &pp) {
	is >> pp.x >> pp.y;
	return is;
}

#define next sathesnaothea

int n, m, type;
vector<vector<int>> g;

vector<int> up;
vector<int> orient;
vector<int> next;
vector<int> pref;
vector<int> depth;
vector<int> tour;

void dfs0(int v, int _p) {
	pref[v] = _p;
	tour.pb(v);
	for (int sub : g[v]) {
		if (sub == _p) continue;
		depth[sub] = depth[v] + 1;
		dfs0(sub, v);
	}
}

vector<int> dir;

int lca(int a, int b) {
	if (a == b) return a;
	if (depth[a] > depth[b]) return lca(pref[a], b);
	return lca(a, pref[b]);
}

pair<bool, bool> get_dirs(int a, int c) {
	bool up = false, down = false;
	while (a != c) {
		if (dir[a] == 1) up = true;
		else if (dir[a] == -1) down = true; 
		a = pref[a];
	}
	return mp(up, down);
}

void color(int a, int c, int col) {
	while (a != c) {
		dir[a] = col;
		a = pref[a];
	}
}

vector<int> rez;
void dfs1(int v, int up) {
	for (int sub : g[v]) {
		if (sub == pref[v]) continue;
		if (dir[sub] == 0) {
			dfs1(sub, 1);
		}
	}
	int _max = up;
	for (int sub : g[v]) {
		if (sub == pref[v]) continue;
		if (dir[sub] == 1) {
			dfs1(sub, 1);
			_max = max(_max, rez[sub] + 1);
		}
	}
	rez[v] = _max;
	for (int sub : g[v]) {
		if (sub == pref[v]) continue;
		if (dir[sub] == -1) {
			dfs1(sub, _max + 1);
		}
	}
}

void run() {
	cin >> n >> m >> type; g.resize(n);
	pref.resize(n, -1);
	up.resize(n); iota(up.begin(), up.end(), 0);
	dir.resize(n, 0);
	depth.resize(n);
	next.resize(n); iota(next.begin(), next.end(), 0);
	for (int i = 0; i < n - 1; i++) {
		int a, b; cin >> a >> b; a--;b--;
		g[a].pb(b);
		g[b].pb(a);
	}
	dfs0(0, -1);
	vector<pii> routes;
	for (int i = 0; i < m; i++) {
		int a, b; cin >> a >> b; a--; b--;
		routes.emplace_back(a, b);
	}
	for (int i = 0; i < m; i++) {
		int a = routes[i].x, b = routes[i].y;
		int c = lca(a, b);
		auto A = get_dirs(a, c);
		auto B = get_dirs(b, c);
		int sgn = 0;
		if (!A.x && !B.y) {
			sgn = -1;
		}
		if (!A.y && !B.x) {
			sgn = 1;
		}
		if (sgn == 0) {
			cout << -1 << endl;
			return;
		}
		color(a, c, sgn);
		color(b, c, -sgn);
	}
	rez.resize(n);
	for (int i : tour) {
		if (pref[i] == -1) continue;
		if (dir[i] == 1) {
			rez[i] = rez[pref[i]] - 1;
		} else {
			rez[i] = rez[pref[i]] + 1;
		}
	}
	int d = *min_element(rez.begin(), rez.end());
	for (int &x : rez) x -= d - 1;
	// if (*max_element(rez.begin(), rez.end()) < *max_element(best.begin(), best.end())) {
	// 	best = rez;
	// }
	// dfs1(0, 1);
	cout << *max_element(rez.begin(), rez.end()) << endl;
	cout << rez << endl;
}

signed main(int argc, char const *argv[]) {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	// freopen("test.in", "r", stdin);
	run();
}