#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define mp make_pair
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#ifndef MY
    #define endl '\n'
#endif // MY

typedef pair < int, int > pii;
typedef long double db;

#ifdef MY
const int N = 100;
#else
const int N = 5e5 + 5;
#endif // MY
const int D = 20;
int dp[N][D];
vector < int > gr[N];
int lev[N];
int lca[N];
pii way[N];
int ans[N];
bool kek[N];
bool used[N];
int prv[N];
int par[N];
int cur[N];

void dfs(int v, int p = -1, int l = 0) {
    prv[v] = v;
    par[v] = p;
    lev[v] = l;
    dp[v][0] = p;
    for (int i = 1; i < D; i++) {
        dp[v][i] = dp[dp[v][i - 1]][i - 1];
    }
    for (auto u : gr[v]) {
        if (u != p) {
            dfs(u, v, l + 1);
        }
    }
}

int get_lca(int v, int u) {
    if (lev[v] < lev[u]) {
        swap(v, u);
    }
    for (int i = D - 1; lev[v] > lev[u]; i--) {
        if (lev[v] - (1 << i) < lev[u]) {
            continue;
        }
        v = dp[v][i];
    }
    int t = D - 1;
    while (v != u) {
        if (dp[v][t] != dp[u][t]) {
            v = dp[v][t];
            u = dp[u][t];
        }
        t--;
    }
    if (v != u) {
        v = dp[v][0];
    }
    return v;
}

int get_prv(int v) {
    if (v == prv[v]) {
        return v;
    }
    return prv[v] = get_prv(prv[v]);
}

int join(int v, int u) {
    u = get_prv(u);
    return prv[v] = u;
}

void update(int v, int w) {
    int u = get_prv(v);
    if (lev[u] <= lev[w]) {
        return;
    }
    v = join(u, par[u]);
    update(v, w);
}

pii res;
vector < int > agr[N];

pii depth(int v, int p = -1) {
    used[v] = 1;
    pii a = {-1, -1};
    pii b = {-1, -1};
    for (auto u : agr[v]) {
        if (u == p) {
            continue;
        }
        pii k = depth(u, v);
        k.F++;
        if (a < k) {
            b = a, a = k;
        } else if (b < k) {
            b = k;
        }
    }
    if (b.F != -1) {
        res = max(res, {a.F + b.F, a.S});
    }
    if (a.F == -1) {
        return {0, v};
    }
    res = max(res, a);
    return a;
}

void clr(int v, int c, int p = -1) {
    ans[v] = c;
    for (auto u : agr[v]) {
        if (u != p) {
            clr(u, c - 1, v);
        }
    }
}

signed main() {
#ifdef MY
    freopen("f.in", "r", stdin);
#endif // MY
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int tt;
    int n, m;
    cin >> n >> m >> tt;
    for (int i = 1; i < n; i++) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        gr[v].pb(u);
        gr[u].pb(v);
    }
    dfs(0);
    for (int i = 0; i < m; i++) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        int w = get_lca(v, u);
        update(v, w);
        update(u, w);
    }
    for (int i = 1; i < n; i++) {
        int v = i;
        if (get_prv(v) == get_prv(par[v])) {
            agr[par[v]].pb(v);
            agr[v].pb(par[v]);
        }
    }
    fill(ans, ans + n, 1);
    int k = 1;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            continue;
        }
        res = {0, i};
        depth(i);
        k = max(k, res.F + 1);
        clr(res.S, res.F + 1);
    }
    cout << k << endl;
    for (int i = 0; i < n; i++) {
        cout << ans[i] << ' ';
    }
    return 0;
}
