#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <cmath>


#define x first
#define y second
//#define int long long

typedef long long ll;
typedef long double ld;

using namespace std;


struct Edge{
    int u, v, num;
    Edge(int u2, int v2, int num2) {
        u = u2;
        v = v2;
        num = num2;
    }
    Edge() {};
};


vector<vector<Edge>> g;
vector<vector<int>> h;
vector<vector<int>> hr;
set<pair<int, int>> mm;
vector<int> used;
bool f = 1;

bool dfs(int v, int p, int u) {
    if (v == u)
        return 1;
    for (auto el : g[v]) {
        if (el.v != p)
            if (dfs(el.v, v, u)) {
                mm.insert({v, el.v});
                return 1;
            }
    }
    return 0;
}


bool dfscyc(int v) {
    used[v] = 1;
    for (int u : h[v]) {
        if (used[u] == 1)
            return 1;
        if (used[u] == 0)
            if (dfscyc(u))
                return 1;
    }
    used[v] = 2;
    return 0;
}

vector<int> path;
vector<int> dep;

void dfst(int v) {
    used[v] = 1;
    for (int u : h[v]) {
        if (!used[u]) {
            dfst(u);
        }
    }
    path.push_back(v);
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n, m, t, u, v;
	cin >> n >> m >> t;
	g.resize(n);
	pair<int, vector<int>> ans = {1e9, {}};
	for (int i = 0; i < n - 1; i++) {
        cin >> u >> v;
        u--;
        v--;
        g[u].push_back(Edge(u, v, i));
        g[v].push_back(Edge(v, u, i));
	}
	vector<pair<int, int>> edg(m);
	for (int i = 0; i < m; i++) {
        cin >> edg[i].x >> edg[i].y;
        edg[i].x--;
        edg[i].y--;
	}
	for (int mask = 0; mask < (1 << m); mask++) {
        mm.clear();
        h.clear();
        hr.clear();
        used.clear();
        dep.clear();
        f = 1;
        used.resize(n);
        h.resize(n);
        hr.resize(n);
        dep.resize(n);
        path.clear();
        for (int j = 0; j < m; j++) {
            if ((mask >> j) & 1) {
                dfs(edg[j].x, -1, edg[j].y);
            }
            else {
                dfs(edg[j].y, -1, edg[j].x);
            }
        }
        if (!f)
            continue;
        for (auto el : mm) {
            //cout << el.x << ' '<< el.y << endl;
            h[el.x].push_back(el.y);
            hr[el.y].push_back(el.x);
        }
        for (int j = 0; j < n; j++) {
            if (used[j] == 0) {
                if (dfscyc(j)) {
                    f = 0;
                }
            }
        }
        if (!f)
            continue;
        used.clear();
        used.resize(n);
        for (int i = 0; i < n; i++) {
            if (!used[i])
                dfst(i);
        }
        reverse(path.begin(), path.end());
        for (int x : path) {
            for (int y : hr[x]) {
                dep[x] = max(dep[x], dep[y] + 1);
            }
        }
        pair<int, vector<int>> cur = {0, {}};
        for (int i = 0; i < n; i++) {
            cur.x = max(cur.x, dep[i] + 1);
            cur.y.push_back(dep[i] + 1);
        }
        ans = min(ans, cur);
	}
	if (ans.x == 1e9) {
        cout << -1;
	}
	else {
        cout << ans.x << endl;
        for (int x : ans.y) {
            cout << x << ' ';
        }
	}
	return 0;
}
