#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <set>

using namespace std;

vector<vector<int>> g;
vector<int> tin;
vector<int> tout;
vector<int> dep;
vector<vector<int>> prep;
vector<int> kld;
int tim = 1;

void dfs(int v, int p, int depth)
{
	tin[v] = tim;
	tim++;
	prep[v][0] = max(0, p);
	for (int i = 1; i < 20; ++i)
	{
		prep[v][i] = prep[prep[v][i - 1]][i - 1];
	}
	dep[v] = depth;
	for (int i = 0; i < g[v].size(); ++i)
	{
		if (g[v][i] != p)
			dfs(g[v][i], v, depth + 1);
	}
	tout[v] = tim;
	tim++;
}

int lca(int v, int u)
{
	for (int i = 19; i > -1; --i)
	{
		if (tin[prep[v][i]] <= tin[u] && tout[prep[v][i]] >= tout[u])
			continue;
		v = prep[v][i];
	}
	return prep[v][0];
}

int main()
{
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	int n, m, t;
	cin >> n >> m >> t;
	g = vector<vector<int>>(n, vector<int>());
	prep = vector<vector<int>>(n, vector<int>(20, 0));
	tin = vector<int>(n, 0);
	tout = vector<int>(n, 0);
	dep = vector<int>(n, 0);
	kld = vector<int>(m, 0);
	for (int i = 0; i < n - 1; ++i)
	{
		int a, b;
		cin >> a >> b;
		a--, b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	int ans = 0;
	dfs(0, -1, 0);
	vector<pair<int, int> > que;
	vector<int> ar(n, 1);
	vector<int> rev;
	for (int i = 0; i < m; ++i)
	{
		int a, b;
		cin >> a >> b;
		a--, b--;
		int c = lca(a, b);
		ans = max(ans, -dep[c] + dep[a] - dep[c] + dep[b]);
		int qwer = 1;
		while (a != c)
		{
			ar[a] = qwer;
			a = prep[a][0];
			qwer++;
		}
		ar[c] = qwer;
		qwer++;
		rev.resize(0);
		while (b != c)
		{
			rev.push_back(b);
			b = prep[b][0];
		}
		reverse(rev.begin(), rev.end());
		for (int j = 0; j < rev.size(); ++j)
		{
			ar[rev[j]] = qwer;
			qwer++;
		}
	}
	cout << ans + 1 << endl;
	if (t == 1)
	{
		for (int i = 0; i < n; ++i)
			cout << ar[i] << " ";
	}
}