#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <bitset>
#include <deque>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#include <cmath>
#include <numeric>
#include <random>
#define ll long long
#define ld long double
#define null NULL
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

template<class iterator> void output(iterator begin, iterator end, ostream &out = cerr) {
	while (begin != end) {
		out << (*begin) << " ";
		begin++;
	}
	out << endl;
}

template<class T> void output(const T &x, ostream &out = cerr) {
	output(all(x), out);
}

template<class T> int chkmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int chkmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

void fast_io() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int mx = 5e5 + 228;
const int lg = 20;
int n, m, t;
vector<vector<int> > g, children;
int tin[mx], tout[mx], timer, p[mx], up[mx][lg], h[mx];

void hang(int v, int pv) {
	tin[v] = timer++;
	up[v][0] = p[v] = pv;
	for (int i = 1; i < lg; ++i) {
		up[v][i] = up[up[v][i - 1]][i - 1];
	}
	for (auto v1 : g[v]) {
		if (v1 != pv) {
			children[v].push_back(v1);
			h[v1] = h[v] + 1;
			hang(v1, v);
		}
	}
	tout[v] = timer - 1;
}

int upper(int u, int v) {
	return (tin[u] <= tin[v] && tout[v] <= tout[u]);
}

int lca(int u, int v) {
	if (upper(u, v)) return u;
	if (upper(v, u)) return v;
	for (int i = lg - 1; i >= 0; --i) {
		if (!upper(up[u][i], v)) {
			u = up[u][i];
		}
	}
	return up[u][0];
}

int la(int u, int k) {
	for (int i = lg - 1; i >= 0; --i) {
		if (k >= (1 << i)) {
			u = up[u][i];
			k -= (1 << i);
		}
	}
	return u;
}

vector<vector<pair<int, int> > > gg;

void add_gg_edge(int u, int v, int sign) {
	// cerr << "add_gg_edge " << u << " " << v << " " << sign << endl;
	gg[u].emplace_back(v, sign);
	gg[v].emplace_back(u, sign);
}

int same_cmp[mx], clr[mx], cmp[mx];

void process_vertical(int u, int v) {
	if (u == v) {
		return;
	}
	int cur = u;
	// cerr << cur << " " << v << endl;
	while (p[cur] != v) {
		// if (same_cmp[cur]) {
		// 	break;
		// }
		same_cmp[cur] = 1;
		add_gg_edge(cur, p[cur], 0);
		cur = p[cur];
	}
	cur = u;
	while (cur != v) {
		// if (cmp[cur] == -1) {
		// 	break;
		// }
		cmp[cur] = -1;
		cur = p[cur];
	}
}

void process(int u, int v) {
	int e = lca(u, v);
	process_vertical(u, e);
	process_vertical(v, e);
	if (u != e && v != e) {
		u = la(u, h[u] - h[e] - 1);
		v = la(v, h[v] - h[e] - 1);
		add_gg_edge(u, v, 1);
	}
}

int used[mx], cmp_ptr;

int ggfs(int v) {
	// cerr << "ggfs " << v << endl;
	cmp[v] = cmp_ptr;
	used[v] = 1;
	for (auto pp : gg[v]) {
		int v1 = pp.first;
		if (used[v1] == 0) {
			clr[v1] = (clr[v] ^ pp.second);
			// cerr << "clr " << v1 << " " << clr[v1] << endl;
			// cerr << "to " << v1 << endl;
			if (ggfs(v1)) {
				return 1;
			}
		} else {
			if (clr[v1] != (clr[v] ^ pp.second)) {
				// cerr << "bad " << v << " " << v1 << " " << clr[v] << " " << clr[v1] << " " << pp.second << endl;
				return 1;
			}
		}
	}
	return 0;
}

int sum[mx];

void sum_dfs(int v) {
	for (auto v1 : children[v]) {
		sum[v1] = sum[v] + clr[v1];
		sum_dfs(v1);
	}
}

int search_path(int target, int v, int pv, vector<int> &res) {
	if (v == target) {
		res.push_back(v);
		return 1;
	}
	for (auto v1 : g[v]) {
		if (v1 != pv && search_path(target, v1, v, res)) {
			res.push_back(v);
			return 1;
		}
	}
	return 0;
}

vector<int> get_path(int u, int v) {
	vector<int> res;
	search_path(v, u, u, res);
	return res;
}

vector<pair<int, int> > lines;

void check_ans() {
	for (auto pp : lines) {
		vector<int> path = get_path(pp.first, pp.second);
		int ok1 = 1, ok2 = 1;
		for (int i = 0; i < (int)path.size() - 1; i++) {
			if (sum[path[i + 1]] > sum[path[i]]) {
				ok1 = 0;
			} else {
				ok2 = 0;
			}
		}
		assert(ok1 || ok2);
	}
}

vector<vector<pair<int, vector<int> > > > cmp_g;

void build_cmp_g() {
	cmp_g.resize(n);
	for (int i = 0; i < n; ++i) {
		map<int, vector<int> > mp;
		for (auto v : children[i]) {
			if (cmp[v] != -2) {
				mp[cmp[v]].push_back(v);
			}
		}
		cmp_g[i] = vector<pair<int, vector<int> > > (all(mp));
	}
}

const int INF = 1e9;
int dp[mx][2], go[mx][2], k;
vector<pair<int, int> > ev;

vector<int> get_seg(vector<int> a, int tg_min) {
	if (k - a[tg_min ^ 1] < a[tg_min]) {
		return {-1, -2};
	} else {
		return {a[tg_min], k - a[tg_min ^ 1]};
	}
}

void add_seg(int l, int r) {
	// cerr << "add_seg " << l << " " << r << endl;
	if (l <= r) {
		ev.emplace_back(l, 1);
		ev.emplace_back(r + 1, -1);
	}
}

int scanline(int target) {
	if (target == 0) {
		return 0;
	}
	sort(all(ev));
	// cerr << "scanline " << target << endl;
	int sum = 0;
	for (int i = 0; i < ev.size(); ++i) {
		sum += ev[i].second;
		// cerr << "sum = " << sum << endl;
		if (i < (int)ev.size() - 1 && ev[i].first < ev[i + 1].first && sum == target) {
			return ev[i].first;
		}
	}
	return -1;
}

void calc_dp(int v) {
	for (auto v1 : children[v]) {
		if (cmp[v1] != -2) {
			calc_dp(v1);
		}
	}
	// cerr << "calc_dp " << v << endl;
	for (int up_edge = 0; up_edge < 2; ++up_edge) {
		// cerr << "-----------------up_edge = " << up_edge << endl;
		int ch = (up_edge ^ clr[v]);
		ev.clear();
		for (auto pp : cmp_g[v]) {
			// cerr << "check cmp " << pp.first << endl;
			int cmp_id = pp.first;
			vector<vector<int> > cmp_res = {{0, 0}, {0, 0}};
			if (cmp_id == cmp[v]) {
				cmp_res[ch ^ 1] = {INF, INF};
			}
			for (auto v1 : pp.second) {
				for (int it = 0; it < 2; ++it) {
					chkmax(cmp_res[it][clr[v1] ^ it], (int)dp[v1][clr[v1] ^ it]);
				}
			}
			// cerr << "cmp_res:" << endl;
			// for (int i = 0; i < 2; ++i) {
			// 	for (int j = 0; j < 2; ++j) {
			// 		cerr << cmp_res[i][j] << " ";
			// 	}
			// 	cerr << endl;
			// }
			vector<vector<int> > seg(2);
			for (int it = 0; it < 2; ++it) {
				seg[it] = get_seg(cmp_res[it], up_edge);
			}
			int L = max(seg[0][0], seg[1][0]);
			int R = min(seg[0][1], seg[1][1]);
			if (L <= R) {
				add_seg(min(seg[0][0], seg[1][0]), max(seg[0][1], seg[1][1]));
			} else {
				for (int it = 0; it < 2; ++it) {
					add_seg(seg[it][0], seg[it][1]);
				}
			}
		}
		int res = scanline(cmp_g[v].size());
		go[v][up_edge] = res;
		if (res == -1) {
			dp[v][up_edge] = INF;
		} else {
			if (cmp[v] == -2) {
				dp[v][up_edge] = res;
			} else {
				dp[v][up_edge] = res + 1;
			}
		}
		// cerr << "dp " << v << " " << up_edge << " = " << dp[v][up_edge] << endl;
	}
}

int restored[mx];

void restore_dp(int v, int up_edge) {
	// sassert(go[v][up_edge] != -1);
	if (go[v][up_edge] == -1) {
		exit(0);
	}
	int ch = up_edge ^ clr[v];
	for (auto pp : cmp_g[v]) {
		int cmp_id = pp.first;
		vector<vector<int> > cmp_res = {{0, 0}, {0, 0}};
		if (cmp_id == cmp[v]) {
			cmp_res[ch ^ 1] = {INF, INF};
		}
		for (auto v1 : pp.second) {
			for (int it = 0; it < 2; ++it) {
				chkmax(cmp_res[it][clr[v1] ^ it], (int)dp[v1][clr[v1] ^ it]);
			}
		}
		int need_change = -1;
		for (int it = 0; it < 2; ++it) {
			if (cmp_res[it][up_edge] <= go[v][up_edge] && cmp_res[it][up_edge ^ 1] <= k - go[v][up_edge]) {
				need_change = it;
			}
		}
		restored[cmp_id] = need_change;
		assert(need_change != -1);
		for (auto v1 : pp.second) {
			restore_dp(v1, clr[v1] ^ need_change);
		}
	}
}

int check(int _k, int rest = 0) {
	k = _k;
	// cerr << "!!!!!!!!!!!!!!!!!!!!!!!!check " << k << endl;
	for (int i = 0; i < n; ++i) {
		if (cmp[i] == -2) {
			calc_dp(i);
			if (dp[i][0] > k && dp[i][1] > k) {
				return 0;
			}
			if (rest) {
				restore_dp(i, 0);
			}
		}
	}
	return 1;
}

vector<vector<int> > dir_g;
int ans[mx], calced_ans[mx];;

void ans_dfs(int v) {
	calced_ans[v] = 1;
	ans[v] = 0;
	for (auto v1 : dir_g[v]) {
		if (calced_ans[v1] == 0) {
			ans_dfs(v1);
		}
		chkmax(ans[v], ans[v1] + 1);
	}
}

void hard() {
	build_cmp_g();
	int l = 0, r = n;
	while (l < r) {
		int mid = (l + r) >> 1;
		if (check(mid)) {
			r = mid;
		} else {
			l = mid + 1;
		}
	}
	fill(restored, restored + cmp_ptr, -1);
	check(l, 1);
}

signed main() {
	fast_io();
	cin >> n >> m >> t;
	g.resize(n);
	children.resize(n);
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	hang(0, 0);
	fill(cmp, cmp + n, -2);
	gg.resize(n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		lines.emplace_back(u, v);
		process(u, v);
	}
	fill(clr, clr + n, -1);
	for (int i = 0; i < n; ++i) {
		if (cmp[i] != -2 && clr[i] == -1) {
			clr[i] = 0;
			if (ggfs(i)) {
				cout << -1 << endl;
				exit(0);
			}
			cmp_ptr++;
		}
	}

	if (n > 100000 || m > 100000) {
		fill(restored, restored + cmp_ptr, 0);
	} else {
 		hard();
	}

	dir_g.resize(n);
	for (int i = 0; i < n; ++i) {
		if (cmp[i] != -2) {
			clr[i] ^= restored[cmp[i]];
			if (clr[i] == 0) {
				dir_g[p[i]].push_back(i);
			} else {
				dir_g[i].push_back(p[i]);
			}
		}
	}
	for (int i = 0; i < n; ++i) {
		if (calced_ans[i] == 0) {
			ans_dfs(i);
		}
	}
	check_ans();
	cout << (*max_element(ans, ans + n)) + 1 << endl;
	for (int i = 0; i < n; ++i) {
		cout << ans[i] + 1 << " ";
	}
	cout << endl;
}
