#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>

#define int long long
#define ll long long
#define all(a) (int) (a).begin(), (a).end()

using namespace std;

const int MAXN = 500000;
int n, m, t;
vector<int> graph[MAXN];

vector<int> cmn_g[MAXN];
int color[MAXN];
bool visited[MAXN];

void cmn_dfs(int u) {
    if (visited[u]) {
        return;
    }
    visited[u] = true;
    if (color[u] == 0) {
        color[u] = 1;
    }
    for (auto v : cmn_g[u]) {
        color[v] = -1 * color[u];
        cmn_dfs(v);
    }
}

void solve_cmn(int root) {
    if (n < 3) {
        cout << 2 << '\n';
        if (t) {
            cout << "1 2\n";
        }
        return;
    }
    bool is_2 = true;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        if (a != root && b != root) {
            cmn_g[a].push_back(b);
            cmn_g[b].push_back(a);
            is_2 = false;
        }
    }
    if (is_2) {
        cout << "2\n";
        if (t) {
            for (int i = 0; i < n; ++i) {
                cout << ((i == root) ? (1) : (2)) << ' ';
            }
        }
        return;
    }
    for (int i = 0; i < n; ++i) {
        cmn_dfs(i);
    }
    for (int i = 0; i < n; ++i) {
        for (auto v : cmn_g[i]) {
            if (color[i] == color[v]) {
                cout << -1;
                return;
            }
        }
    }
    color[root] = 0;
    cout << "3\n";
    if (t) {
        for (int i = 0; i < n; ++i) {
            cout << color[i] + 2 << ' ';
        }
    }
}

vector<int> ways[15];
int w = 0;
int w_visited[15];
int w_goal;
bool w_dfs(int u) {
    if (w_visited[u]) {
        return false;
    }
    w_visited[u] = true;
    if (u == w_goal) {
        return true;
    }
    for (auto v : graph[u]) {
        if (w_dfs(v)) {
            ways[w].push_back(v);
            return true;
        }
    }
    return false;
}

void add_way(int a, int b){
    for (int i = 0; i < n; ++i) {
        w_visited[i] = false;
    }
    w_goal = b;
    w_dfs(a);
    ways[w].push_back(a);
    ++w;
}

void rev(int mask) {
    for (int i = 0; i < w; ++i) {
        if ((mask >> 1) & 1) {
            reverse(ways[i].begin(), ways[i].end());
        }
    }
}

int ans = 10000000000;
int ans_c[17];
int cur_c[17];

bool try_inc() {
    bool ans = false;
    for (int i = 0; i < w; ++i) {
        for (int j = 0; j + 1 < ways[i].size(); ++j) {
            if (cur_c[ways[i][j + 1]] < cur_c[ways[i][j]] + 1) {
                ans = true;
                cur_c[ways[i][j + 1]] = cur_c[ways[i][j]] + 1;
            }
        }
    }
    return ans;
}

void solve_little() {
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        add_way(a, b);
    }
    for (int mask = 0; mask < 1 << w; ++mask) {
        rev(mask);
        for (int i = 0; i < n; ++i) {
            cur_c[i] = 1;
        }
        for (int i = 0; i < 3 * n; ++i) {
            try_inc();
        }
        if (try_inc()) {
            continue;
        }
        int cur_ans = -10000000000;
        for (int i = 0; i < w; ++i) {
            cur_ans = max(cur_ans, cur_c[ways[i].back()]);
        }
        if (cur_ans < ans) {
            ans = cur_ans;
            for (int i = 0; i < n; ++i) {
                ans_c[i] = cur_c[i];
            }
        }
        rev(mask);
    }
    if (ans == 10000000000) {
        cout << -1;
        return;
    }
    cout << ans << '\n';
    for (int i = 0; i < n; ++i) {
        cout << ans_c[i] << ' ';
    }
}

signed main() {
    cin.tie(0);
    cin.sync_with_stdio(0);
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }
    if (n <= 15) {
        solve_little();
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        if (graph[i].size() == n - 1) {
            solve_cmn(i);
            return 0;
        }
    }

    return 0;
}
