#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <set>
#include <iterator>
#include <iomanip>
#include <utility>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <climits>
#include <numeric>
#include <string>
#include <algorithm>
#include <queue>
#include <deque>
#include <random>
#include <bitset>
#include <cassert>
using namespace std;
//#define int long long
vector<vector<int>> g;
struct fenwick {
	int n;
	vector<int> f;
	fenwick(int _n) {
		n = _n;
		f.assign(n, 0);
	}
	void add(int i, int val) {
		for (; i < n; i |= (i + 1))
			f[i] += val;
	}
	int getsum(int i) {
		int ans = 0;
		for (; i >= 0; i &= (i + 1), --i)
			ans += f[i];
		return ans;
	}
	int get(int L, int R) {
		return getsum(R) - getsum(L - 1);
	}
};
struct stick {
	int v, u;
	stick() : v(0), u(0) {};
};
int start, nd, f = false;
vector<int> path, used, ansex;
void dfs(int v, int p = -1) {
	path.push_back(v);
	if (v == nd) {
		f = true;
		return;
	}
	for (auto x : g[v]) {
		if (x == p) continue;
		dfs(x, v);
		if (f) return;
	}
	if (!path.empty())
	path.pop_back();
}
bool f1 = false;
vector<unordered_set<int>> g2;
void dfs2(int v, int d = 1) {
	used[v] = 1;
	ansex[v] = max(ansex[v], d);
	for (auto x : g2[v]) {
		if (used[x] == 2) continue;
		if (used[x] == 1) {
			f1 = true;
			continue;
		}
		dfs2(x, d + 1);
	}
	used[v] = 2;
}
signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#endif
	int n,m, t;
	cin >> n >> m >> t;
	g.resize(n);
	for (int i = 0; i < n - 1; ++i) {
		int q, w;
		cin >> q >> w;
		--q, --w;
		g[q].push_back(w);
		g[w].push_back(q);
	}
	vector<stick> s(m);
	map<pair<int, int>, int> kek;
	for (int i = 0; i < m; ++i) {
		cin >> s[i].u >> s[i].v;
		s[i].u--;
		s[i].v--;
	}
	if (t == 1) {
		int goodmask = -1, ans = 1e9;
		for (int mask = 0; mask < ((int)1 << m); ++mask) {
			g2.clear();
			g2.assign(n, {});
			vector<int> stock(n, 0);
			for (int i = 0; i < m; ++i) {
				start = s[i].u, nd = s[i].v;
				if (mask & (1 << i)) swap(start, nd);
				path.clear();
				f = false;
				dfs(start);
				for (int i = 1; i < path.size(); ++i) {
					g2[path[i - 1]].insert(path[i]);
					stock[path[i]]++;
				}
			}
			f1 = false;
			ansex.assign(n, 0);
			for (int i = 0; i < n; ++i) {
				if (stock[i] == 0) {
					used.assign(n, 0);
					dfs2(i);
				}
			}
			if (find(ansex.begin(), ansex.end(), 0) != ansex.end() || f1) continue;
			int ma = 0;
			for (auto x : ansex) ma = max(x, ma);
			if (ma < ans) {
				goodmask = mask;
				ans = ma;
			}
		}
		if (goodmask == -1) { cout << -1; return 0; }
		else {
			g2.clear();
			g2.assign(n, {});
			vector<int> stock(n, 0);
			for (int i = 0; i < m; ++i) {
				start = s[i].u, nd = s[i].v;
				if (goodmask & (1 << i)) swap(start, nd);
				path.clear();
				f = false;
				dfs(start);
				for (int i = 1; i < path.size(); ++i) {
					g2[path[i - 1]].insert(path[i]);
					stock[path[i]]++;
				}
			}
			f1 = false;
			ansex.assign(n, 0);
			for (int i = 0; i < n; ++i) {
				if (stock[i] == 0) {
					used.assign(n, 0);
					dfs2(i);
				}
			}
			int ma = 0;
			for (auto x : ansex) ma = max(x, ma);
			cout << ma << '\n';
			for (auto x : ansex) cout << x << ' ';
			return 0;
		}
	}
	g2.clear();
	g2.assign(n, {});
	vector<int> stock(n, 0);
	for (int i = 0; i < m; ++i) {
		start = s[i].u, nd = s[i].v;
		path.clear();
		f = false;
		dfs(start);
		for (int i = 1; i < path.size(); ++i) {
			g2[path[i - 1]].insert(path[i]);
			stock[path[i]]++;
		}
	}
	f1 = false;
	ansex.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		if (stock[i] == 0) {
			used.assign(n, 0);
			dfs2(i);
		}
	}
	if (f1) {
		cout << -1;
		return 0;
	}
	int ma = 0;
	for (auto x : ansex) ma = max(ma, x);
	assert(ma <= 1e7);
	cout << ma << '\n';
	for (auto x : ansex) cout << x << ' ';
	return 0;
}