#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1e6;
vector<int> g[MAXN], e[MAXN];
array<int, 2> pt[MAXN];
int dir[MAXN], tin[MAXN], tout[MAXN], p[MAXN];
int t = 0;

void dfs(int v) {
    tin[v] = t++;
    for (auto u : g[v]) {
        if (u != p[v]) {
            p[u] = v;
            dfs(u);
        }
    }
    tout[v] = t++;
}

bool is_pr(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int ans[MAXN];
int res[MAXN], used[MAXN];
vector<int> top;

void build(int v) {
    used[v] = 1;
    for (auto u : e[v]) {
        build(u);
    }
    top.push_back(v);
}

int pr[MAXN], sz[MAXN];

int get(int v) {
    if (v == pr[v]) {
        return v;
    }
    pr[v] = get(pr[v]);
    return pr[v];
}

void join(int u, int v) {
    u = get(u); v = get(v);
    if (u == v) {
        return;
    }
    if (sz[u] < sz[v]) {
        swap(u, v);
    }
    pr[v] = u;
    sz[u] += sz[v];
}

int col[MAXN], nd[MAXN];
bool f = true;

void bip(int v, int c) {
    col[v] = c;
    used[v] = true;
    for (auto u : e[v]) {
        if (!used[u]) {
            bip(u, c ^ 1);
        } else if (col[u] == c) {
            f = false;
        }
    }
}

main() {
    int n, m, t;
    cin >> n >> m >> t;
    for (int i = 1; i < n; ++i) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    p[0] = 0;
    dfs(0);
    for (int i = 0; i < m; ++i) {
        cin >> pt[i][0] >> pt[i][1];
        pt[i][0]--; pt[i][1]--;
    }
    int k = 1e9;
    if (n <= 15 && m <= 15 && t == 1) {
        for (int mask = 0; mask < (1 << m); ++mask) {
            fill(dir, dir + n, 0);
            bool f = false;
            for (int i = 0; i < m; ++i) {
                int u = pt[i][0];
                int v = pt[i][1];
                if (mask & (1 << i)) {
                    swap(u, v);
                }
                while (!is_pr(u, v)) {
                    if (dir[u] == 2) {
                        f = true;
                    }
                    dir[u] = 1;
                    u = p[u];
                }
                while (v != u) {
                    if (dir[v] == 1) {
                        f = true;
                    }
                    dir[v] = 2;
                    v = p[v];
                }
            }
            if (f) {
                continue;
            }
            for (int i = 0; i < n; ++i) {
                e[i].clear();
            }
            for (int i = 1; i < n; ++i) {
                if (dir[i] == 1) {
                    e[i].push_back(p[i]);
                } else if (dir[i] == 2) {
                    e[p[i]].push_back(i);
                }
            }
            fill(res, res + n, 1);
            top.clear();
            fill(used, used + n, 0);
            for (int i = 0; i < n; ++i) {
                if (!used[i]) {
                    build(i);
                }
            }
            int cur = 1;
            for (auto u : top) {
                for (auto v : e[u]) {
                    res[u] = max(res[u], res[v] + 1);
                }
                cur = max(res[u], cur);
            }
            if (cur < k) {
                k = cur;
                for (int i = 0; i < n; ++i) {
                    ans[i] = res[i];
                }
            }
        }
        if (k == 1e9) {
            cout << -1;
            return 0;
        }
        cout << k << endl;
        for (int i = 0; i < n; ++i) {
            cout << ans[i] << " ";
        }
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        pr[i] = i; sz[i] = 1;
    }
    for (int i = 0; i < m; ++i) {
        int u = pt[i][0], v = pt[i][1];
        while (!is_pr(p[u], v)) {
            nd[u] = 1;
            nd[p[u]] = 1;
            join(u, p[u]);
            u = p[u];
        }
        while (!is_pr(p[v], u)) {
            nd[v] = 1;
            nd[p[v]] = 1;
            join(v, p[v]);
            v = p[v];
        }
    }
    for (int i = 0; i < m; ++i) {
        int u = pt[i][0], v = pt[i][1];
        if ((!is_pr(u, v)) && (!is_pr(v, u))) {
            e[get(u)].push_back(get(v));
            e[get(v)].push_back(get(u));
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[get(i)]) {
            bip(get(i), 0);
        }
    }
    if (!f) {
        cout << -1;
        return 0;
    }
    for (int i = 0; i < n; ++i) {
        if (!nd[i]) {
            continue;
        }
        if (col[get(i)]) {
            dir[i] = 1;
        } else {
            dir[i] = 2;
        }
    }
    for (int i = 0; i < n; ++i) {
        e[i].clear();
    }
    for (int i = 1; i < n; ++i) {
        if (dir[i] == 1) {
            e[i].push_back(p[i]);
        } else if (dir[i] == 2) {
            e[p[i]].push_back(i);
        }
    }
    fill(res, res + n, 1);
    top.clear();
    fill(used, used + n, 0);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            build(i);
        }
    }
    int cur = 1;
    for (auto u : top) {
        for (auto v : e[u]) {
            res[u] = max(res[u], res[v] + 1);
        }
        cur = max(res[u], cur);
    }
    cout << cur << endl;
    for (int i = 0; i < n; ++i) {
        cout << res[i] << " ";
    }
    return 0;
}
