#include <bits/stdc++.h>

using namespace std;

const int maxn = 16;

int n, m, t;
vector <int> adj[maxn];
pair <int, int> tunnels[maxn];
void read()
{
    cin >> n >> m >> t;
    for (int i = 1; i <= n-1; i++)
    {
        int a, b;
        cin >> a >> b;

        adj[a].push_back(b);
        adj[b].push_back(a);
    }

    for (int i = 1; i <= m; i++)
        cin >> tunnels[i].first >> tunnels[i].second;
}

vector <int> v;
vector <int> path[maxn][maxn];
void dfs(int start, int ver, int par)
{
    path[start][ver] = v;
    for (auto i: adj[ver])
        if (i != par)
        {
            v.push_back(i);
            dfs(start, i, ver);
            v.pop_back();
        }
}

vector <int> adj1[maxn];
bool topsort()
{
    int deg[maxn];
    memset(deg, 0, sizeof(deg));
    for (int i = 1; i <= n; i++)
    for (auto j: adj1[i])
    deg[j]++;

    int cnt = 0;
    queue <int> q;
    for (int i = 1; i <= n; i++)
        if (deg[i] == 0)
        q.push(i);

    while (!q.empty())
    {
        int curr = q.front();
        q.pop();
        cnt++;

        for (auto i: adj1[curr])
        {
            deg[i]--;
            if (deg[i] == 0)
                q.push(i);
        }
    }

    if (cnt == n)
        return true;

    return false;
}

int curr_values[maxn];
int calc(int ver)
{
    if (curr_values[ver] != 0)
        return curr_values[ver];

        int maxs = 0;
    for (auto i: adj1[ver])
        maxs = max(maxs, calc(i));

    return curr_values[ver] = maxs + 1;
}

int ans = -1, ans_val[maxn];
void solve()
{
    for (int i = 1; i <= n; i++)
    {
        v.push_back(i);
        dfs(i, i, -1);
        v.pop_back();
    }

    for (int i = 0; i < (1 << m); i++)
    {
        for (int j = 1; j <= n; j++)
            adj1[j].clear();

        for (int j = 1; j <= m; j++)
        {
            vector <int> curr = path[tunnels[j].first][tunnels[j].second];
            if (i & (1 << (j-1)))
                reverse(curr.begin(), curr.end());

            int sz = curr.size();
            for (int k = 1; k < sz; k++)
                adj1[curr[k]].push_back(curr[k-1]);
        }

        if (topsort())
        {
            memset(curr_values, 0, sizeof(curr_values));
            int curr_ans = 0;
            for (int i = 1; i <= n; i++)
            {
                curr_values[i] = calc(i);
                curr_ans = max(ans, curr_values[i]);
            }

            if (ans == -1 || curr_ans < ans)
            {
                ans = curr_ans;
                for (int i = 1; i <= n; i++)
                    ans_val[i] = curr_values[i];
            }
        }
    }

    //if (ans == -1)
     //   cout << ans << endl;

   // else
    //{
        cout << ans << endl;
        for (int i = 1; i <= n; i++)
            cout << ans_val[i] << " ";

            cout << endl;
   // }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();
}
