// task C

#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;

vector<vector<int>> g, ways, g1;
vector<int> visited, out, totalAns;

bool totalDfs(int u, int col)
{
	totalAns[u] = col;
	for (auto v : g1[u])
	{
		if (!totalAns[v])
		{
			if (!totalDfs(v, (col + 2) % 4))
				return false;
		}			
		if (totalAns[v] == totalAns[u])
			return false;
	}
	return true;
}

//---------------------- 1,2 groups

bool dfs(int u, int goal, vector<int>& res)
{
	visited[u] = 1;
	res.push_back(u);

	if (u == goal)
		return true;

	bool ans = 0;
	for (auto v : g[u])
		if (!visited[v] && dfs(v, goal, res))
			return true;

	res.pop_back();
	return false;
}

void dfs1(int u, vector<int>& h)
{
	visited[u] = 1;
	h[u] = 1;

	for (auto v : g1[u])
	{
		if (!visited[v])
			dfs1(v, h);
		h[u] = max(h[u], h[v] + 1);
	}
}

bool dfsCheck(int u)
{
	visited[u] = 1;
	for (auto v : g1[u])
	{
		if (visited[v] && !out[v])
			return false;
		else if (!visited[v] && !dfsCheck(v))
			return false;
	}

	out[u] = 1;
	return true;
}

bool check()
{
	visited.assign(g1.size(), 0);
	out.assign(g1.size(), 0);

	for (int i = 0; i < g1.size(); ++i)
		if (!visited[i] && !dfsCheck(i))
			return false;

	return true;
};

int getOptimal(vector<int>& res)
{
	if (!check())
		return -1;

	visited.assign(res.size(), 0);
	for (int i = 0; i < res.size(); ++i)
		if (!visited[i])
			dfs1(i, res);

	return *max_element(res.begin(), res.end());
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n = 0, m = 0, t = 0;
	cin >> n >> m >> t;

	g.resize(n);
	int u = 0, v = 0;
	for (int i = 0; i < n - 1; ++i)
	{
		cin >> u >> v;
		g[u - 1].push_back(v - 1);
		g[v - 1].push_back(u - 1);
	}

	if (n <= 0)
	{
		vector<pair<int, int>> w(m);
		ways.resize(m);
		for (int i = 0; i < m; ++i)
		{
			cin >> w[i].first >> w[i].second;
			--w[i].first, --w[i].second;
			visited.assign(n, 0);
			dfs(w[i].first, w[i].second, ways[i]);
		}

		int minAns = n + 57;
		vector<int> minRes(n);
		for (int mask = 0; mask < (1 << m); ++mask)
		{
			g1.assign(n, vector<int>());
			for (int i = 0; i < m; ++i)
			{
				if (mask & (1 << i))
					for (int j = 0; j < ways[i].size() - 1; ++j)
						g1[ways[i][j]].push_back(ways[i][j + 1]);
				else
					for (int j = ways[i].size() - 1; j > 0; --j)
						g1[ways[i][j]].push_back(ways[i][j - 1]);
			}

			vector<int> res(n);
			int ans = getOptimal(res);
			if (ans != -1 && ans < minAns)
				minAns = ans, swap(minRes, res);
		}

		if (minAns == n + 57)
			cout << -1 << endl;
		else
		{
			cout << minAns << endl;
			for (auto x : minRes)
				cout << x << " ";
		}
	}
	else
	{
		vector<pair<int, int>> w(m);
		for (int i = 0; i < m; ++i)
		{
			cin >> w[i].first >> w[i].second;
			--w[i].first, --w[i].second;
		}

		vector<int> dir(n);

		int center = 0;
		for (int i = 0; i < n; ++i)
		{
			if (g[i].size() > 1)
			{
				center = i;
				break;
			}
		}
		
		g1.resize(n);
		for (int i = 0; i < m; ++i)
		{
			if (w[i].first != center && w[i].second != center)
			{
				g1[w[i].first].push_back(w[i].second);
				g1[w[i].second].push_back(w[i].first);
			}
		}
	
		totalAns.resize(n, 0);
		bool ok = true;
		for (int i = 0; i < n; ++i)
		{
			if (i != center && !totalAns[i] && !totalDfs(i, 1))
				ok = false;
		}

		if (!ok)
			cout << -1 << endl;
		else
		{
			int ans = 0;
			totalAns[center] = 2;
			for (auto x : totalAns)
				ans = max(ans, x);

			cout << ans << "\n";
			if (t)
			{
				for (auto x : totalAns)
					cout << x << " ";
			}			
		}
	}


	return 0;
}