#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <time.h>
#include <assert.h>


#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back

const int INF = 2e9;
const int MB = 20;

using namespace std;

vector<int> res, p, h, a, link;
vector<vector<int>> g;
vector<pair<pair<int, int>, int>> q;
int n, m, t;

struct SparseTable {
    vector<vector<int>> t;
    vector<int> log;
    void build(int n, vector<int> ver) {
        t.resize(MB, vector<int>(n));
        for (int i = 0; i < n; i++) {
            t[0][i] = ver[i];
        }

        for (int bit = 0; bit < MB - 1; bit++) {
            for (int i = 0, s = (1 << bit), j = i + s; j + s <= n; i++, j++) {
                t[bit + 1][i] = h[t[bit][i]] < h[t[bit][j]] ? t[bit][i] : t[bit][j];
            }
        }
        
        log.resize(n + 1);
        for (int i = 2; i <= n; i++) {
            log[i] = log[i / 2] + 1;
        }
    }

    int get(int l, int r) {
        int b = log[r - l + 1];
        r = r - (1 << b) + 1;
        return h[t[b][l]] < h[t[b][r]] ? t[b][l] : t[b][r];
    }
};

SparseTable sparse;

int getlca(int a, int b) {
    int l = link[a];
    int r = link[b];
    if (l > r) swap(l, r);
    return sparse.get(l, r);
}

void dfs(int v) {
    link[v] = a.size();
    a.pb(v);
    for (int u : g[v]) {
        if (u != p[v]) {
            p[u] = v;
            h[u] = h[v] + 1;
            dfs(u);
            a.pb(v);
        }
    }
}

vector<vector<bool>> ng;
vector<int> dp;

void dfs1(int v) {
    dp[v] = 1;
    for (int i = 0; i < n; i++) {
        if (ng[v][i]) {
            dfs1(i);
            dp[v] = max(dp[v], dp[i] + 1);
        }
    }
}

int get(int mask) {
    for (int i = 0; i < n; i++) fill(all(ng[i]), false);
    for (int i = 0; i < m; i++) {
        int from = q[i].first.first;
        int to = q[i].first.second;
        int lca = q[i].second;
        if ((mask >> i) & 1) {
            while (from != lca && p[from] != -1) {
                ng[from][p[from]] = true;
                from = p[from];
            }
            while (to != lca && p[to] != -1) {
                ng[p[to]][to] = true;
                to = p[to];
            }
        }
        else {
            while (to != lca && p[to] != -1) {
                ng[to][p[to]] = true;
                to = p[to];
            }
            while (from != lca && p[from] != -1) {
                ng[p[from]][from] = true;
                from = p[from];
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (ng[i][j] && ng[j][i]) return INF;
        }
    }

    fill(all(dp), 0);
    for (int i = 0; i < n; i++) {
        if (!dp[i]) dfs1(i);
    }
    return *max_element(all(dp));
}

void dfs2(int v, int mx, int now = 1, int pr = -1) {
    res[v] = now;
    for (int u : g[v]) {
        if (u != pr) {
            dfs2(u, mx, min(mx, now + 1), v);
        }
    }
}

void go1(int start) {
    int mx = 0;
    for (auto& pr : q) {
        int from = pr.first.first;
        int to = pr.first.second;
        int lca = pr.second;
        mx = max(mx, h[from] + h[to] - 2 * h[lca] + 1);
    }
    
    dfs2(start, mx);
    cout << mx << '\n';
    for (int i : res) cout << i << " ";
}

void solve() {
    cin >> n >> m >> t;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int from, to;
        cin >> from >> to;
        from--; to--;
        g[from].pb(to);
        g[to].pb(from);
    }

    p.resize(n, -1);
    h.resize(n);
    q.resize(m);
    link.resize(n);
    res.resize(n);
    ng.resize(n, vector<bool>(n));
    dfs(0);
    sparse.build(a.size(), a);
    vector<int> d(n);
    for (int i = 0; i < m; i++) {
        int from, to;
        cin >> from >> to;
        from--; to--;
        int lca = getlca(from, to);
        q[i] = { {from, to}, lca };
        d[from]++; d[to]++;
    }

    if (*max_element(all(d)) == m) {
        for (int i = 0; i < n; i++) {
            if (d[i] == m) {
                go1(i);
                return;
            }
        }
    }

    int ans = INF;
    ng.resize(n, vector<bool>(n));
    dp.resize(n);
    for (int mask = 0; mask < (1LL << m); mask++) {
        int x = get(mask);
        if (ans > x) {
            ans = x;
            swap(res, dp);
        }
    }
    if (ans == INF) {
        cout << -1;
        return;
    }

    cout << ans << '\n';

    for (int i : res) cout << i << " ";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //srand(time(0));
    solve();
}

/*
    Спокойствие, только спокойствие!
*/