#include <bits/stdc++.h>

using namespace std;

#define endl "\n"
#define int long long

int logn = 20, n;
vector<int> pw(logn, 1);
vector<vector<int>> lg(logn);
vector<bool> used;
vector<int> h;
vector<vector<int>> g;
vector<int> way;

void dfs(int v, int p, int depth) {
    used[v] = true;
    lg[0][v] = p;
    h[v] = depth;
    for (auto elem : g[v]) {
        if (!used[elem]) {
            dfs(elem, v, depth + 1);
        }
    }
    return;
}

void init() {
    for (int i = 1; i < logn; i++) {
        pw[i] = pw[i - 1] * 2;
        lg[i].resize(n, -1);
        for (int j = 0; j < n; j++) {
            if (lg[i - 1][j] != -1) lg[i][j] = lg[i - 1][lg[i - 1][j]];
        }
    }
}

int go_up(int a, int k) {
    for (int i = logn - 1; i >= 0; i--) {
        if (lg[i][a] != -1 && h[lg[i][a]] >= k) a = lg[i][a];
    }
    return a;
}

int lca(int a, int b) {
    if (h[a] < h[b]) swap(a, b);
    a = go_up(a, h[b]);
    for (int i = logn - 1; i >= 0; i--) {
        if (lg[i][a] != lg[i][b]) {
            a = lg[i][a];
            b = lg[i][b];
        }
    }
    if (a == b) return a;
    return lg[0][a];
}

void go(int u, int v) {
    int c = lca(u, v);
    int curr = u;
    vector<int> a1, a2;
    while (curr != c) {
        a1.push_back(curr);
        curr = lg[0][curr];
    }
    curr = v;
    while (curr != c) {
        a2.push_back(curr);
        curr = lg[0][curr];
    }
    reverse(a2.begin(), a2.end());
    for (auto elem : a1) way.push_back(elem);
    way.push_back(c);
    for (auto elem : a2) way.push_back(elem);
}


bool cmp(vector<int> a, vector<int> b) {
    if (a[0] < b[0]) return true;
    if (a[0] > b[0]) return false;
    if (a[1] < b[1]) return true;
    return false;
}

int32_t main()
{
    int m, t;
    cin >> n >> m >> t;
    g.resize(n);
    used.resize(n);
    lg[0].resize(n);
    h.resize(n);
    for (int i = 1; i < n; i++) {
        int x, y; cin >> x >> y; x--; y--;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dfs(0, -1, 0);
    init();
    vector<vector<int>> was;
    map<int, vector<int>> mp;
    for (int i = 0; i < m; i++) {
        int a, b; cin >> a >> b; a--; b--;
        if (a > b) swap(a, b);
        way.clear();
        go(a, b);
        was.push_back(way);
        for (auto elem : way)
            mp[elem].push_back(i);

    }
    sort(was.begin(), was.end(), cmp);
    int ans = 1;
    vector<int> w(n, -1);
    for (int i = 0; i < m; i++) {
        int cnt = 1;
        for (int j = 0; j < was[i].size(); j++) {
            w[was[i][j]] = max(w[was[i][j]], j + cnt);
            cnt = w[was[i][j]] - j;
        }
        ans = max(ans, (long long)was[i].size());
    }
    for (int i = 0; i < n; i++) {
        if (w[i] == -1) w[i] = 1;
    }
    cout << ans << endl;
    for (auto elem : w) {
        cout << elem << " ";
    }
    cout << endl;
    return 0;
}
