#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>
#include <map>
#include <tuple>
#include <deque>
#include <chrono>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef int ll;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_set;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m, t;
    cin >> n >> m >> t;
    vector<vector<ll>> adj(n);
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }
    vector<pair<ll, ll>> branch(m);
    for (ll i = 0; i < m; i++) {
        cin >> branch[i].first >> branch[i].second;
        branch[i].first--, branch[i].second--;
    }
    vector<ll> b;
    for (ll i = 0; i < (ll) pow(n, n); i++) {
        vector<ll> a(n);
        for (ll j = 0, k = i; j < n; j++, k /= n) {
            a[j] = k % n + 1;
        }
        vector<ll> stack;
        function<bool(ll, ll, ll)> visit_second = [&](ll u, ll v, ll d) {
            stack.push_back(v);
            if (v == d) {
                return true;
            }
            for (ll w : adj[v]) {
                if (w != u) {
                    if (visit_second(v, w, d)) {
                        return true;
                    }
                }
            }
            stack.pop_back();
            return false;
        };
        bool f = false;
        for (ll i = 0; i < m; i++) {
            visit_second(-1, branch[i].first, branch[i].second);
            bool x = true, y = true;
            for (ll j = 0; j < (ll) stack.size() - 1; j++) {
                if (a[stack[j + 1]] >= a[stack[j]]) {
                    x = false;
                }
                if (a[stack[j + 1]] <= a[stack[j]]) {
                    y = false;
                }
            }
            if (!x && !y) {
                f = true;
            }
        }
        if (!f) {
            if (b.empty() || *max_element(a.begin(), a.end()) < *max_element(b.begin(), b.end())) {
                b = a;
            }
        }
    }
    if (b.empty()) {
        cout << -1 << endl;
    } else {
        cout << *max_element(b.begin(), b.end()) << endl;
        for (ll i : b) {
            cout << i << " ";
        }
        cout << endl;
    }
    return 0;
}
