#include <iostream>
#include <algorithm>
#include <string>
#include <utility>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <cmath>
#include <random>
#include <ctime>
#include <cstdlib>
#include <stack>
#include <bitset>
#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define ALL(x) (x).begin(),(x).end()
#define RALL(x) (x).rbegin(),(x).rend()

using namespace std;

using ld = long double;
using ll = long long;

const ld PI = acosl(-1);
const int N = 5e5+5, INF = 1e9;

mt19937 rnd(time(0));

int n, m, t, a, b, binups[20][N], tin[N], tout[N], vtime = 0;
ll d[N];
vector<pair<int,pair<int,int>>> vth;
vector<vector<int>> g;
stack<int> flexxx;


void tdfs(int v, int p = 0){
    tin[v] = ++vtime;
    for(int to: g[v]){
        if(to==p) continue;
        tdfs(to);
    }
    tout[v] = ++vtime;
}

inline void precalc_binups(){
    queue<pair<int,int>> q;
    q.push({1,0});
    tin[0] = 0;
    tout[0] = INF;
    tdfs(1);
    while(!q.empty()){
        int v = q.front().F, p = q.front().S;
        binups[0][v] = p;
        for(int i = 1; i < 20; ++i){
            if(binups[i-1][binups[i-1][v]]){
                binups[i][v] = binups[i-1][binups[i-1][v]];
            }
        }
        q.pop();
        for(int to: g[v]){
            if(to==p) continue;
            q.push({to,v});
        }
    }
}



bool prd(int prd, int ptm){
    return tin[prd]<=tin[ptm] && tout[prd]>=tin[ptm];
}

int lca(int a, int b){
    for(int i = 19; i >= 0; --i){
        if(!prd(binups[i][b],a)){
            b = binups[i][b];
        }
    }
    return binups[0][b];
}

int ras(int v, int fin, int len = 0, int p = 0){
    if(v==fin){
        return len;
    }
    for(int to: g[v]){
        if(to==p) continue;
        int rss = ras(to,fin,len+1,v);
        if(rss!=-1){
            return rss;
        }
    }
    return -1;
}

inline void read(){
    cin >> n >> m >> t;
    g.resize(n+1);
    vth.resize(m);
    for(int i = 0; i < n-1; ++i){
        cin >> a >> b;
        g[a].pb(b);
        g[b].pb(a);
    }
    for(auto& i: vth){
        cin >> i.S.F >> i.S.S;
        i.F = ras(i.S.F,i.S.S);
    }
}


bool finder(int v, int fin, ll len = 1, int p = 0){
    if(v==fin){
        d[v] = max(len*1LL,d[v]);
        return true;
    }
    for(int to: g[v]){
        if(to==p) continue;
        if(finder(to,fin,len+1,v)){
            if(find(ALL(g[to]),v)!=g[to].end()) g[to].erase(find(ALL(g[to]),v));
            d[v] = max(len*1LL,d[v]);
            return true;
        }
    }
    return false;
}

bool normer(int v, int fin, ll len = 1, int p = 0){
    len = max(len*1LL,d[v]);
    if(v==fin){
        d[v] = max(d[v],len);
        return true;
    }
    for(int to: g[v]){
        if(to==p) continue;
        if(normer(to,fin,len+1,v)){
            d[v] = len;
            return true;
        }
    }
    return false;
}

inline void gg(){
    cout << -1;
    exit(0);

}
inline void solve_nm100(){
    sort(RALL(vth));
    for(const auto& i: vth){
        if(!finder(i.S.F,i.S.S)){
            gg();
        }
    }
    for(const auto& i: vth){
        normer(i.S.F,i.S.S);
    }
}

inline void goritsolve(){
    precalc_binups();
    for(const auto& to: vth){
        int a = to.S.F, b = to.S.S, c = lca(a,b), l = a, r = b, sch = 1;
        while(l!=c){
            d[l] = sch++;
            l = binups[0][l];
        }
        d[c] = sch++;
        while(r!=c){
            flexxx.push(r);
            r = binups[0][r];
        }
        while(!flexxx.empty()){
            d[flexxx.top()] = sch++;
            flexxx.pop();
        }
    }
}

inline void print(){
    cout << *max_element(d+1,d+1+n) << "\n";
    for(int i = 1; i <= n; ++i)
        cout << (d[i]?d[i]:1) << " " ;
}

inline void test(){
    vector<int> a{1,4,2};
    cout << (find(ALL(a),3)==a.end());
    exit(0);
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ///test();
    read();
    if(1){
        goritsolve();
    }
    print();

    return 0;
}
