#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("-O3")

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define double long double
#define For(i,z) for(int i=0;i<(z);i++)
#define _ <<' '<<
#define sqr(a) ((a)*(a))

#define pii pair<int,int>
#define pdd pair<double,double>
#define f first
#define s second
template<typename T>
using orset = tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
template<typename T,typename K>
using ormap = tree<T,K,less<T>,rb_tree_tag,tree_order_statistics_node_update>;

template<typename T,typename K> inline void umax(T &a, const K b) {a=max(a,(T)b);}
template<typename T,typename K> inline void umin(T &a, const K b) {a=min(a,(T)b);}

const int N = 16;
const int64_t INF = 1e15;
const pair<int64_t,int64_t> PINF = make_pair(INF,INF);
const double EPS = 1e-7;
const int64_t MOD = 1e9+9;
const int64_t AMOD = 99194853094755497;

int pr[N][4], dep[N];
vector<int> val(N), bstval(N);
list <int> gr[N];
void setlca(int v, int p = -1) {
    for (int i : gr[v])
        if (i != p){
            dep[i] = dep[v] + 1;
            int cc = v, idx = 0;
            while (cc != -1) {
                pr[i][idx] = cc;
                cc = pr[cc][idx];
                idx++;
            }
            setlca(i, v);
        }
}

pii getlca(int a, int b) {
    if (dep[a] > dep[b]) swap(a, b);
    int len = dep[b] - dep[a];
    while (dep[a] < dep[b]) {
        int rzn = (int)log2(dep[b] - dep[a]);
        b = pr[b][rzn];
    }
    for (int i = 3; i >= 0; i--)
        if (pr[a][i] != pr[b][i]) {
            a = pr[a][i];
            b = pr[b][i];
            len += (1 << i);
        }
    if (a != b) {
        a = pr[a][0]; b = pr[b][0];
        len += 2;
    }
    return make_pair(a, len);
}

vector <int> way[N][N];
void setway(int v) {
    queue<int> q;
    q.push(v);
    way[v][v] = {v};
    while (q.size()) {
        int c = q.front(); q.pop();
        for (int i : gr[c]) {
            if (way[v][i].empty()) {
                way[v][i] = way[v][c];
                way[v][i].push_back(i);
                q.push(i);
            }
        }
    }
}

int state[N][N];
vector <int> frr[N];

bool FLG = false;
void fl(int v, int u, int lvl) {
    int c = v;
    for (int i = 1; i < way[v][u].size(); i++) {
        int nxt = way[v][u][i];
        if (state[c][nxt] && state[c][nxt] != lvl) {
            FLG = true; return;
        }

        umax(val[nxt], val[c]+1);
        state[c][nxt] = state[nxt][c] = lvl;
        c = nxt;
    }
}

void dfs(int v, int p = -1) {
    for (int i : frr[v]) {
        umax(val[v], 1);
        fl(v, i, 2);
    }
    for (int i : gr[v])
        if (i != p)
            dfs(i,v);
}


int32_t main()
{
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    For (i, N) For (j, 20) pr[i][j] = -1;
    int n, m, t; cin >> n >> m >> t;
    For (i, n-1) {
        int a, b; cin >> a >> b; a--; b--;
        gr[a].push_back(b);
        gr[b].push_back(a);
    }
    setlca(0);
    For (i, n) setway(i);

    vector <pii> wasreq(m);
    vector<pii> reqtor;
    For (i, m) {
        int a, b; cin >> a >> b; a--; b--;
        wasreq[i] = make_pair(a, b);
    }
    int ansval = INF;
    For (msk, 1<<(m-1)) {
        FLG = false;
        reqtor.clear();
        For (i, N) {
            val[i] = 0;
            For (j, N)
                state[i][j] = 0;
            frr[i].clear();
        }
        int zmsk = msk;
        for (auto &i : wasreq) {
            int a, b;
            if (zmsk & 1)
                a = i.s, b = i.f;
            else
                a = i.f, b = i.s;
            zmsk >>= 1;
            int lc = getlca(a, b).f;
            reqtor.emplace_back(a, lc);
            frr[lc].push_back(b);
        }
        sort(reqtor.begin(), reqtor.end(), [&](pii a, pii b) {
            return (dep[a.f] > dep[b.f]);
        });
        for (auto &i : reqtor) {
            umax(val[i.f], 1);
            fl(i.f, i.s, 1);
        }
        dfs(0);
        if (!FLG) {
            int zzz = 0;
            For (i, n) {
                umax(val[i], 1);
                umax(zzz, val[i]);
            }
            if (zzz < ansval)
                bstval = val,
                ansval = zzz;
        }
    }

    if (ansval == INF) {
        cout << "-1"; return 0;
    }
    cout << ansval << '\n';
    For (i, n)
        cout << bstval[i] << ' ';
}
