#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <iomanip>
#include <fstream>
#include <sstream>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <cassert>
#include <stack>
#include <deque>
#include <climits>
#include <queue>
#include <ctime>
#include <cstdlib>
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
#pragma warning(disable : 4996)


vector<vector<int>> g;
vector<vector<int>> pred;
void dfs(int v, int i, int p = -1) {
	pred[v][i] = p;
	for (auto u : g[v]) {
		if (u != p) {
			dfs(u, i, v);
		}
	}
}


void random_solve(int n, int m, int t, vector<pair<int, int>> need) {
	pred.resize(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		dfs(i, i);
	}
	srand(time(0));
	vector<int> best(n);
	int maxx = n + 1;
	for (int i = 0; i <= 2000002; i++) {
		vector<int> w(n);
		map<pair<int, int>, int> dir;
		int cur_max = 0;
		for (int j = 0; j < n; j++) {
			w[j] = rand() % n + 1;
			cur_max = max(cur_max, w[j]);
		}
		bool is_good = true;
		for (auto j : need) {
			if (w[j.first] > w[j.second]) {
				int cur = j.second;
				int p = pred[cur][j.first];
				while (p != -1) {
					if (dir[{p, cur}] == 0 && w[cur] < w[p]) {
						dir[{cur, p}] = 1;
						cur = p;
						p = pred[cur][j.first];
					}
					else {
						is_good = false;
						break;
					}
				}
			}
			else if (w[j.first] < w[j.second]) {
				int cur = j.first;
				int p = pred[cur][j.second];
				while (p != -1) {
					if (dir[{p, cur}] == 0 && w[cur] < w[p]) {
						dir[{cur, p}] = 1;
						cur = p;
						p = pred[cur][j.second];
					}
					else {
						is_good = false;
						break;
					}
				}
			}
			else {
				is_good = false;
				break;
			}
		}
		if (is_good) {
			if (cur_max < maxx) {
				maxx = cur_max;
				best = w;
			}
		}
		if (is_good && t == 0) {
			cout << cur_max << "\n";
			for (auto i : best)cout << i << " ";
			return;
		}
	}
	if (maxx == n + 1) {
		cout << -1;
	}
	else {
		cout << maxx << "\n";
		for (auto i : best)cout << i << " ";
	}
}


const int MAXN = 5e5 + 10, logn = 21;
int up[MAXN][logn], tin[MAXN], tout[MAXN], dist[MAXN];
int timer = 0;

void dfs1(int v, int p = -1) {
	tin[v] = timer++;
	dist[v] = 1;
	if (p != -1)dist[v] += dist[p];
	for (int i = 1; i < logn; i++) {
		up[v][i] = up[up[v][i - 1]][i - 1];
	}
	for (auto u : g[v]) {
		if (u != p) {
			up[u][0] = v;
			dfs1(u, v);
		}
	}
	tout[v] = timer++;
}


bool a(int v, int u) {
	return tin[v] <= tin[u] && tout[v] >= tin[u];
}


int lca(int v, int u) {
	if (a(u, v))return u;
	if (a(v, u))return v;
	for (int i = 0; i < logn; i++) {
		if (!a(up[v][i], u))v = up[v][i];
	}
	return up[v][0];
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	int n, m, t;
	cin >> n >> m >> t;
	g.resize(n);
	for (int i = 0; i < n - 1; i++) {
		int from, to;
		cin >> from >> to;
		from--;
		to--;
		g[from].push_back(to);
		g[to].push_back(from);
	}
	vector<pair<int, int>> need(m);
	for (int i = 0; i < m; i++) {
		cin >> need[i].first >> need[i].second;
		need[i].first--;
		need[i].second--;
	}
	if (n <= 15) {
		random_solve(n, m, t, need);
		return 0;
	}
	pred.resize(n, vector<int>(n));
	for (int i = 0; i < n; i++) {
		dfs(i, i);
	}
	srand(time(0));
	vector<int> best(n);
	int maxx = n + 1;
	for (int i = 0; i <= 10000000; i++) {
		vector<int> w(n);
		map<pair<int, int>, int> dir;
		int cur_max = 0;
		for (int j = 0; j < n; j++) {
			w[j] = rand() % n + 1;
			cur_max = max(cur_max, w[j]);
		}
		bool is_good = true;
		for (auto j : need) {
			if (w[j.first] > w[j.second]) {
				int cur = j.second;
				int p = pred[cur][j.first];
				while (p != -1) {
					if (dir[{p, cur}] == 0 && w[cur] < w[p]) {
						dir[{cur, p}] = 1;
						cur = p;
						p = pred[cur][j.first];
					}
					else {
						is_good = false;
						break;
					}
				}
			}
			else if (w[j.first] < w[j.second]) {
				int cur = j.first;
				int p = pred[cur][j.second];
				while (p != -1) {
					if (dir[{p, cur}] == 0 && w[cur] < w[p]) {
						dir[{cur, p}] = 1;
						cur = p;
						p = pred[cur][j.second];
					}
					else {
						is_good = false;
						break;
					}
				}
			}
			else {
				is_good = false;
				break;
			}
		}
		if (is_good) {
			if (cur_max < maxx) {
				maxx = cur_max;
				best = w;
			}
		}
		if (is_good && t == 0) {
			cout << cur_max << "\n";
			for (auto i : best)cout << i << " ";
			return 0;
		}
	}
	if (maxx == n + 1) {
		cout << -1;
	}
	else {
		cout << maxx << "\n";
		for (auto i : best)cout << i << " ";
	}
}