#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(a) a.begin(), a.end()

template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;}
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;}

struct event{
	int a, b;
	event() {}
};

const int MAXN = 5e5 + 10;

struct edge{
	int to, ind;
	edge() {}
	edge(int _to, int _ind) {
		to = _to, ind = _ind;
	}
};

int n, m, t;
vector<edge> g[MAXN];
vector<event> have;
int ind;

void read() {
	cin >> n >> m >> t;
	ind = 0;
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back({v, ind});
		g[v].push_back({u, ind});
		ind++;
	}
	have.resize(m);
	for (auto &i : have) {
		cin >> i.a >> i.b;
		i.a--;
		i.b--;
	}
}

const int MAXLOG = 20;

int tin[MAXN], tout[MAXN], dp[MAXN][MAXLOG], timer = 0, h[MAXN];
int Ind[MAXN];

void dfs_lca(int v, int p, int len) {
	tin[v] = timer++;
	h[v] = len++;
	dp[v][0] = p;
	for (int i = 1; i < MAXLOG; i++)
		dp[v][i] = dp[dp[v][i - 1]][i - 1];
	for (auto i : g[v]) {
		if (i.to != p) {
			dfs_lca(i.to, v, len);
		}
		else {
			Ind[v] = i.ind;
		}
	}
	tout[v] = timer++;
}

bool is_upper(int v, int u) {
	return tin[v] <= tin[u] && tout[v] >= tout[u];
}

int lca(int v, int u) {
	if (is_upper(v, u)) return v;
	if (is_upper(u, v)) return u;
	for (int i = MAXLOG - 1; i >= 0; i--)
		if (!is_upper(dp[v][i], u))
			v = dp[v][i];
	return dp[v][0];
}

bool check_group_7_8() {
	// ALERT!!!!!
	//return t == 0;
	return true;
}

int ans;
vector<int> fans;

int par[MAXN], sz[MAXN];

void make() {
	for (int i = 0; i < n; i++)
		par[i] = i, sz[i] = 1;
}

int get_par(int v) {
	if (v == par[v]) return v;
	return par[v] = get_par(par[v]);
}

void uni(int a, int b) {
	a = get_par(a);
	b = get_par(b);
	if (a == b) return;
	if (sz[a] < sz[b]) swap(a, b);
	par[b] = a;
	sz[a] += sz[b];
}

bool need_add[MAXN];
int make(int v, int LCA) {
	if (v == LCA) return -1;
	int ind = Ind[v];
	need_add[ind] = true;
	while (dp[v][0] != LCA) {
		v = dp[v][0];
		int n_ind = Ind[v];
		uni(ind, n_ind);
		ind = n_ind;
		need_add[ind] = true;
	}
	return ind; 
}

vector<int> g_check[MAXN];

int color[MAXN];

void dfs_check(int v, int p, int c) {
	color[v] = c;
	for (auto i : g_check[v]) {
		if (i == p) continue;
		if (!color[i]) {
			dfs_check(i, v, 3 - c);
		}
		else if (color[i] != 3 - c) {
			cout << -1 << endl;
			exit(0);
		}
	}
}

void check() {
	for (int i = 0; i < n; i++) {
		if (!color[i]) {
			dfs_check(i, -1, 1);
		}
	}
}

void dfs_down(int v, int p) {
	for (auto i : g[v]) {
		if (i.to != p) {
			dfs_down(i.to, v);
		}
	}
	if (p == -1) return;
	if (!need_add[Ind[v]]) return;
	if (color[get_par(Ind[v])] == 2) return;
	chkmax(fans[p], fans[v] + 1);
}

void dfs_up(int v, int p) {
	for (auto i : g[v]) {
		if (i.to != p) {
			if (need_add[i.ind]) {
				if (color[get_par(Ind[v])] == 2) {
					chkmax(fans[i.to], fans[v] + 1);
				}
			}
			dfs_up(i.to, v);
		} 
	}
}

void make_ans() {
	dfs_down(0, -1);
	dfs_up(0, -1);
	dfs_down(0, -1);
	dfs_up(0, -1);
	dfs_down(0, -1);
	dfs_up(0, -1);
	dfs_down(0, -1);
	dfs_up(0, -1);
	dfs_down(0, -1);
	dfs_up(0, -1);
	dfs_down(0, -1);
	dfs_up(0, -1);
	dfs_down(0, -1);
	dfs_up(0, -1);
	dfs_down(0, -1);
	dfs_up(0, -1);
	dfs_down(0, -1);
	dfs_up(0, -1);
	ans = 0;
	for (auto i : fans)
		chkmax(ans, i);

	int Min = ans;
	for (auto i : fans)
		chkmin(Min, i);
	Min--;
	ans -= Min;
	for (auto &i : fans)
		i -= Min;
	/*

	int can = ans;
	vector<int> fcan = fans;
	
	for (int i = 0; i < n; i++)
		color[i] ^= 1;
	fans.assign(n, 1);
	dfs_down(0, -1);
	dfs_up(0, -1);
	ans = 0;
	for (auto i : fans)
		chkmax(ans, i);

	Min = ans;
	for (auto i : fans)
		chkmin(Min, i);
	Min--;
	ans -= Min;
	for (auto &i : fans)
		i -= Min;
	if (ans < can) return;
	ans = can;
	fans = fcan;*/
}

void no() {
	cout << -1 << endl;
	exit(0);
}

void check(int v, int p) {
	for (auto i : g[v]) {
		if (i.to == p) continue;
		if (!need_add[i.ind]) continue;
		if (color[get_par(i.ind)] == 1) {
			if (fans[i.to] >= fans[v]) {
				no();
			}
		}
		else {
			if (fans[i.to] <= fans[v]) {
				no();
			}
		}
	}
	for (auto i : g[v]) {
		if (i.to != p) {
			check(i.to, v);
		}
	}
}

void check_ans() {
	check(0, -1);
}

void solve_group_7_8() {
	dfs_lca(0, 0, 0);
	make();
	vector<pair<int, int>> help;
	for (auto i : have) {
		int l = lca(i.a, i.b);
		help.push_back({make(i.a, l), make(i.b, l)});
	}
	/*cout << "par = " << endl;
	for (int i = 0; i < n - 1; i++) {
		cout << get_par(i) << " ";
	}
	cout << endl;*/
	
	for (int i = 0; i < m; i++) {
		int l = lca(have[i].a, have[i].b);
		if (have[i].a == l || have[i].b == l) continue;
		int u = get_par(help[i].first);
		int v = get_par(help[i].second);
		g_check[u].push_back(v);
		g_check[v].push_back(u);
		//cout << "edge = " << u << " " << v << endl;
	}
	check();
	/*cout << "need_add = " << endl;
	for (int i = 0; i < n - 1; i++) {
		cout << need_add[i] << " ";
	}
	cout << endl;
	cout << "color = " << endl;
	for (int i = 0; i < n - 1; i++) {
		cout << color[get_par(i)] << " ";
	}
	cout << endl;*/
	fans.assign(n, 1);
	make_ans();
	check_ans();
}

void run() {
	if (check_group_7_8()) solve_group_7_8();
}

void write() {
	cout << ans << endl;
	assert(ans <= 1e7);
	for (auto i : fans) {
		cout << i << " ";
	}
	cout << endl;
}

signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	read();
	run();
	write();
	return 0;
}


/*
8 8 0
2 1
3 1
4 2
5 1
6 4
7 5
8 1

3 5
7 2
7 5
1 2
2 4
8 2
5 7
7 6


*/