#include <bits/stdc++.h>

const int32_t MAX_N = 100;

struct Vertex {
	int32_t val;
	std::vector< int32_t > v;
};

int32_t n, m, t;
int32_t u[MAX_N + 5], v[MAX_N + 5], a[MAX_N + 5], b[MAX_N + 5];
Vertex g[MAX_N + 5];

void add_edge(int32_t x, int32_t y) {
	g[x].v.push_back(y);
}

void init() {
	for(int32_t i = 1; i <= n; i++) {
		g[i].v.clear();
	}
}

void dfs(int32_t x, std::vector< bool > &vis) {
	vis[x] = true;

	for(auto &y : g[x].v) {
		dfs(y, vis);
	}
}

bool check(int32_t x, int32_t y) {
	std::vector< bool > vis(n + 1, false);
	dfs(x, vis);
	return vis[y];
}

void dfs_vals(int32_t x, std::stack< int32_t > &st, std::vector< bool > &vis) {
	vis[x] = true;

	for(auto &y : g[x].v) {
		dfs_vals(y, st, vis);
	}

	st.push(x);
}

void init_values() {
	std::vector< bool > vis(n + 1, false);
	std::stack< int32_t > st;
	for(int32_t i = 1; i <= n; i++) {
		if(!vis[i]) {
			dfs_vals(i, st, vis);
		}
	}

	std::stack< int32_t > st1;
	while(!st.empty()) {
		st1.push(st.top());
		st.pop();
	}

	while(!st1.empty()) {
		int32_t x = st1.top();
		st1.pop();

		int32_t nxt = 1;
		for(auto &y : g[x].v) {
			nxt = std::max(nxt, g[y].val + 1);
		}

		g[x].val = nxt;
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> n >> m >> t;

	for(int32_t i = 0; i < n - 1; i++) {
		std::cin >> u[i] >> v[i];
	}

	for(int32_t i = 0; i < m; i++) {
		std::cin >> a[i] >> b[i];
	}

	int32_t best = -1;
	std::vector< int32_t > ans(n + 1);
	for(int32_t mask = 0; mask < (1 << (n - 1)); mask++) {
		init();
		for(int32_t i = 0; i < n - 1; i++) {
			if((mask & (1 << i)) != 0) {
				add_edge(v[i], u[i]);
			}
			else {
				add_edge(u[i], v[i]);
			}
		}

		bool ok = true;
		for(int32_t i = 0; i < m; i++) {
			if(!check(a[i], b[i]) && !check(b[i], a[i])) {
				ok = false;
				break;
			}
		}

		if(ok) {
			init_values();

			int32_t curr = 0;
			for(int32_t i = 1; i <= n; i++) {
				curr = std::max(curr, g[i].val);
			}

			if(curr < best || best == -1) {
				best = curr;

				for(int32_t i = 1; i <= n; i++) {
					ans[i] = g[i].val;
				}
			}
		}
	}

	std::cout << best << '\n';

	if(best != -1) {
		for(int32_t i = 1; i <= n; i++) {
			std::cout << ans[i] << " ";
		}
		std::cout << '\n';
	}
}