#include <iostream>
#include <iomanip>
#include <algorithm>
#include <cstdlib>
#include <random>
#include <vector>
#include <set>
#include <map>
#include <deque>
#include <queue>
#include <bitset>
#include <cassert>
#include <cstdlib>
#include <cstring>
#define len(X) ((int)(X).size())
#ifdef __LOCAL
#define DBG(X) cout << "[DBG] " #X << ": " << (X) << '\n';
#else
#define DBG(X) 42;
#endif
using namespace std;
using ll = long long int;
using ull = unsigned long long int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
const int INT_INF = (int)2e9;
const ll  LL_INF  = (ll)2e18;
const int NIL     = -1;
template<class T> ostream& operator<<(ostream& os, const vector<T>& vec) {
	for(auto& el: vec) os << el << ' ';
	return os;
}
void fastIO() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
}
const int MAXN = 5e5; //(int)5e5 + 7;
vector<int> G[MAXN];
int n, m, t;
pii paths[MAXN];
vector<int> H[MAXN];
int dfsH(int v, int prv, int goal) {
	if(v == goal) return 1;
	for(auto& u: G[v]) if(u != prv) {
		int re = dfsH(u, v, goal);
		if(re) {
			H[v].emplace_back(u);
			return re;
		}
	}
	return 0;
}
int used[MAXN], good = 1;
void dfsC(int v) {
	used[v] = 1;
	for(auto& u: H[v]) {
		if(used[u] == 1) {
			good = 0;
		} else if(used[u] == 0) {
			dfsC(u);
		}
	}
	used[v] = 2;
}
int dp[MAXN];
void calc(int v) {
	used[v] = 1;
	for(auto& u: H[v]) {
		if(!used[u]) calc(u);
		dp[v] = max(dp[v], dp[u] + 1);
	}
}
int build(int msk) {
	for(int v = 0; v < n; ++v) H[v].clear();
	for(int i = 0; i < m; ++i) {
		if((msk>>i)&1) {
			dfsH(paths[i].first, NIL, paths[i].second);
		} else {
			dfsH(paths[i].second, NIL, paths[i].first);
		}
	}
	for(int v = 0; v < n; ++v) used[v] = 0;
	good = 1;
	for(int v = 0; v < n; ++v) {
		if(!used[v]) dfsC(v);
	}
	if(!good) return INT_INF;
	for(int v = 0; v < n; ++v) dp[v] = used[v] = 0;
	int rez = 0;
	for(int v = 0; v < n; ++v) {
		if(!used[v]) calc(v);
		rez = max(rez, dp[v]);
	}
	return rez;
}
void bruteSolve() {
	int bestAnsw = INT_INF, bestMsk = NIL;
	for(int msk = 0; msk < (1 << m); ++msk) {
		int curAnsw = build(msk);
		if(curAnsw < bestAnsw) {
			bestAnsw = curAnsw;
			bestMsk = msk;
		}
	}
	if(bestMsk == NIL) {
		cout << "-1\n";
		return;
	}
	int re = build(bestMsk);
	cout << re + 1 << '\n';
	for(int v = 0; v < n; ++v) cout << dp[v] + 1 << ' ';
	cout << '\n';
}
int deg[MAXN], answ[MAXN];
int col[MAXN], bipart = 1;
void dfsB(int v, int c) {
	if(used[v]) {
		if(c != col[v]) bipart = 0;
		return;
	}
	used[v] = 1;
	col[v] = c;
	for(auto& u: H[v]) dfsB(u, c^1);
}
int hedgehog() {
	DBG("HHH");
	for(int v = 0; v < n; ++v) deg[v] = len(G[v]);
	int Z = 0;
	for(int v = 1; v < n; ++v) {
		if(deg[v] > deg[Z]) Z = v;
	}
	if(deg[Z] != n - 1) return 0;
	answ[Z] = 1;
	DBG(Z + 1);
	for(int i = 0; i < m; ++i) {
		int v = paths[i].first;
		int u = paths[i].second;
		if(v != Z && u != Z) {
			H[v].emplace_back(u);
			H[u].emplace_back(v);
		}
	}
	for(int v = 0; v < n; ++v) {
		if(!used[v]) dfsB(v, 0);
	}
	if(bipart) {
		for(int v = 0; v < n; ++v) if(v != Z) answ[v] = col[v] * 2;
		int mx = 0;
		for(int v = 0; v < n; ++v) mx = max(mx, answ[v]);
		cout << mx + 1 << '\n';
		for(int v = 0; v < n; ++v) cout << answ[v] + 1 << ' ';
		cout << '\n';
	} else {
		cout << "-1\n";
	}
	return 1;
}
vector<pii> GG[MAXN], X[MAXN];
int sz;
void add(int v, int u, int c) {
	X[v].emplace_back(u, c);
	X[u].emplace_back(v, c);
}
int pa[MAXN], pa2[MAXN], depth[MAXN];
void dfs(int v, int prv) {
	for(auto& ed: GG[v]) {
		int u = ed.first;
		int id = ed.second;
		if(u == prv) continue;
		pa[u] = id;
		pa2[u] = v;
		depth[u] = depth[v] + 1;
		dfs(u, v);
	}
}
vector<int> getPath(int v, int u) {
	vector<int> L, R;
	while(v != u) {
		if(depth[v] > depth[u]) {
			L.emplace_back(pa[v]);
			v = pa2[v];
		} else {
			R.emplace_back(pa[u]);
			u = pa2[u];
		}
	}
	reverse(R.begin(), R.end());
	for(auto& el: R) el ^= 1;
	vector<int> p;
	for(auto& el: L) p.emplace_back(el);
	for(auto& el: R) p.emplace_back(el);
	return p;
}
void check(int v, int c) {
	if(used[v]) {
		if(col[v] != c) bipart = 0;
		return;
	}
	used[v] = 1;
	col[v] = c;
	for(auto& ed: X[v]) {
		check(ed.first, c ^ ed.second);
	}
}
vector<int> Y[MAXN];
int VVV[MAXN], UUU[MAXN];
void kalk(int v) {
	used[v] = 1;
	for(auto& u: Y[v]) {
		if(!used[u]) kalk(u);
		//cout << v + 1 << " -> " << u + 1 << '\n';
		dp[v] = max(dp[v], dp[u] + 1);
	}
}
void t0() {
	sz = 2 * (n - 1);
	for(int i = 0; i < n - 1; ++i) {
		int v, u;
		cin >> v >> u;
		--v, --u;
		VVV[i] = v;
		UUU[i] = u;
		GG[v].emplace_back(u, 2 * i);
		GG[u].emplace_back(v, 2 * i + 1);
		add(2 * i, 2 * i + 1, 1);
	}
	memset(pa, NIL, sizeof(pa));
	dfs(0, NIL);
	for(int i = 0; i < m; ++i) {
		int v, u;
		cin >> v >> u;
		--v, --u;
		auto p = getPath(v, u);
		int cnt = len(p);
		for(int i = 0; i < cnt - 1; ++i) {
			add(p[i], p[i + 1], 0);
		}
	}
	for(int v = 0; v < sz; ++v) if(!used[v]) check(v, 0);
	if(!bipart) {
		cout << "-1\n";
		DBG("CAN NOT");
	} else {
		DBG("CAN");
		for(int i = 0; i < m; ++i) {
			int v = VVV[i];
			int u = UUU[i];
			if(col[2 * i]) {
				Y[v].emplace_back(u);
			} else {
				Y[u].emplace_back(v);
			}
		}
		int mx = 0;
		for(int v = 0; v < n; ++v) used[v] = 0;
		for(int v = 0; v < n; ++v) {
			if(!used[v]) kalk(v);
			mx = max(mx, dp[v]);
		}
		cout << mx + 1 << '\n';
		for(int v = 0; v < n; ++v) cout << dp[v] + 1 << ' ';
		cout << '\n';
	}
}
void solve() {
	cin >> n >> m >> t;
	if(t == 0) {
		t0();
		return;
	}
	for(int i = 0; i < n - 1; ++i) {
		int v, u;
		cin >> v >> u;
		--v;
		--u;
		VVV[i] = v;
		UUU[i] = u;
		G[v].emplace_back(u);
		G[u].emplace_back(v);
	}
	for(int i = 0; i < m; ++i) {
		cin >> paths[i].first >> paths[i].second;
		--paths[i].first, --paths[i].second;
	}
	if(hedgehog()) {
		return;
	}
	if(m <= 15) {
		bruteSolve();
		return;
	}
	assert(false);
}
int main() {
	fastIO();
	solve();
	return 0;
}
