#include <bits/stdc++.h>
using namespace std;

int n;

vector<vector<int>> g;
vector<vector<int>> ch;
vector<int> sz;
vector<int> tin, tout;
vector<int> order;
vector<int> head;
vector<int> depth;
vector<int> par;
int cur_time;

void dfsSize(int v, int p) {
	par[v] = p;
	sz[v] = 1;
	tin[v] = cur_time++;
	for (int u : g[v]) {
		if (u != p) {
			depth[u] = depth[v] + 1;
			dfsSize(u, v);
			sz[v] += sz[u];
			ch[v].push_back(u);
		}
	}
	tout[v] = cur_time;
}

void dfsHLD(int v, int p, int hed) {
	head[v] = hed;	
	order[cur_time] = v;
	tin[v] = cur_time++;
	for (int i = 1; i < (int) ch[v].size(); i++) {
		if (sz[ch[v][i]] > sz[ch[v][0]]) {
			swap(ch[v][i], ch[v][0]);
		}
	}
	if (!ch[v].empty())
		dfsHLD(ch[v][0], v, hed);
	for (int i = 1; i < (int) ch[v].size(); i++) {
		dfsHLD(ch[v][i], v, ch[v][i]);
	}
	tout[v] = cur_time;
}

vector<set<int>> tree1;
vector<int> tree2;

void turnoff(int v, int l, int r, int ind) {
	if (ind < l || ind >= r)
		return;
	tree2[v] -= 1;
	if (l + 1 == r)
		return;
	int m = l + (r - l) / 2;
	turnoff(2 * v + 1, l, m, ind);
	turnoff(2 * v + 2, m, r, ind);
}

void turnon(int v, int l, int r, int ind) {
	if (ind < l || ind >= r)
		return;
	tree2[v] += 1;
	if (l + 1 == r)
		return;
	int m = l + (r - l) / 2;
	turnon(2 * v + 1, l, m, ind);
	turnon(2 * v + 2, m, r, ind);
}

int get(int v, int l, int r, int ql, int qr) {
	if (ql >= r || qr <= l) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		return tree2[v];
	}
	int m = l + (r - l) / 2;
	int a = get(2 * v + 1, l, m, ql, qr);
	int b = get(2 * v + 2, m, r, ql, qr);
	return a + b;
}

int get(int u, int v) {
	int ans = 0;
	while (head[u] != head[v]) {
		if (depth[head[u]] < depth[head[v]]) {
			swap(u, v);
		}
		ans += get(0, 0, n, tin[head[u]], tin[u] + 1);
		u = par[head[u]];
	}
	if (tin[v] < tin[u])
		swap(u, v);
	ans += get(0, 0, n, tin[u], tin[v] + 1);
	return ans;
}

void add(int v, int l, int r, int ql, int qr, int x) {
	if (ql >= r || qr <= l) {
		return;
	}
	if (ql <= l && r <= qr) {
		tree1[v].insert(x);
		return;
	}
	int m = l + (r - l) / 2;
	add(2 * v + 1, l, m, ql, qr, x);
	add(2 * v + 2, m, r, ql, qr, x);
}

void add(int u, int v, int x) {
	while (head[u] != head[v]) {
		if (depth[head[u]] < depth[head[v]]) {
			swap(u, v);
		}
		add(0, 0, n, tin[head[u]], tin[u] + 1, x);
		u = par[head[u]];
	}
	if (tin[v] < tin[u])
		swap(u, v);
	add(0, 0, n, tin[u] + 1, tin[v] + 1, x);
}

void rem(int v, int l, int r, int ql, int qr, int x) {
	if (ql >= r || qr <= l) {
		return;
	}
	if (ql <= l && r <= qr) {
		tree1[v].erase(x);
		return;
	}
	int m = l + (r - l) / 2;
	rem(2 * v + 1, l, m, ql, qr, x);
	rem(2 * v + 2, m, r, ql, qr, x);
}

void rem(int u, int v, int x) {
	while (head[u] != head[v]) {
		if (depth[head[u]] < depth[head[v]]) {
			swap(u, v);
		}
		rem(0, 0, n, tin[head[u]], tin[u] + 1, x);
		u = par[head[u]];
	}
	if (tin[v] < tin[u])
		swap(u, v);
	rem(0, 0, n, tin[u] + 1, tin[v] + 1, x);
}

set<int> usedEdges;

void findUsedEdges(int v, int l, int r, bool was = 0) {
	if (!tree1[v].empty()) {
		was = 1;
	}
	if (l + 1 == r) {
		if (was)
			usedEdges.insert(order[l]);
	} else {
		int m = l + (r - l) / 2;
		findUsedEdges(2 * v + 1, l, m, was);
		findUsedEdges(2 * v + 2, m, r, was);
	}
}

set<int> kek;

void query(int v, int l, int r, int p) {
	if (p < l || p >= r) {
		return;
	}
	for (int el : tree1[v]) {
		kek.insert(el);
	}
	if (l + 1 == r) {
		return;
	}
	int m = l + (r - l) / 2;
	query(2 * v + 1, l, m, p);
	query(2 * v + 2, m, r, p);
}

set<int> kek2;

void query2(int v, int l, int r, int ql, int qr) {
	if (ql >= r || qr <= l)
		return;
	if (tree2[v] == 0)
		return;
	if (l + 1 == r) {
		kek2.insert(order[l]);
	} else {
		int m = l + (r - l) / 2;
		query2(2 * v + 1, l, m, ql, qr);
		query2(2 * v + 2, m, r, ql, qr);
	}
}

void query2(int u, int v) {
	while (head[u] != head[v]) {
		if (depth[head[u]] < depth[head[v]]) {
			swap(u, v);
		}
		query2(0, 0, n, tin[head[u]], tin[u] + 1);
		u = par[head[u]];
	}
	if (tin[v] < tin[u])
		swap(u, v);
	query2(0, 0, n, tin[u] + 1, tin[v] + 1);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int m, t;
	cin >> n;
	cin >> m >> t;
	g.resize(n);
	sz.resize(n);
	order.resize(n);
	tin.resize(n);
	tout.resize(n);
	head.resize(n);
	ch.resize(n);
	depth.resize(n);
	par.resize(n);
	for (int i = 1; i < n; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		g[a].push_back(b);
		g[b].push_back(a);
	}
	cur_time = 0;
	dfsSize(0, -1);
	cur_time = 0;
	dfsHLD(0, -1, 0);
	vector<pair<int, int>> arr(m);
	tree1.resize(4 * n);
	tree2.resize(4 * n);
	for (int i = 0; i < m; i++) {
		cin >> arr[i].first >> arr[i].second;
		arr[i].first--;
		arr[i].second--;
		add(arr[i].first, arr[i].second, i);
	}
	findUsedEdges(0, 0, n);
	for (int el : usedEdges) {
		turnon(0, 0, n, tin[el]);
	}
	deque<int> q;
	if (usedEdges.empty()) {
		assert(m == 0);
		cout << 1 << endl;
		for (int i = 0; i < n; i++) {
			cout << 1 << " ";
		}
		cout << endl;
		return 0;
	}
	auto usedEdges2 = usedEdges;
	vector<int> edgeor(n, -1), pathor(m, -1);
	while (!q.empty() || !usedEdges.empty()) {
		if (q.empty()) {
			q.push_back(*usedEdges.begin());
			usedEdges.erase(usedEdges.begin());
			turnoff(0, 0, n, tin[q.back()]);
			edgeor[q.back()] = 0;
		}
		int v = q.front();
		q.pop_front();
		kek.clear();
		query(0, 0, n, tin[v]);
		for (int el : kek) {
			rem(arr[el].first, arr[el].second, el);
			kek2.clear();
			query2(arr[el].first, arr[el].second);
			if (tin[v] <= tin[arr[el].first] && tout[arr[el].first] <= tout[v]) {
				pathor[el] = edgeor[v];
			} else {
				pathor[el] = 1 - edgeor[v];
			}
			for (int el2 : kek2) {
				usedEdges.erase(el2);
				q.push_back(el2);
				turnoff(0, 0, n, tin[el2]);
				if (tin[el2] <= tin[arr[el].first] && tout[arr[el].first] <= tout[el2]) {
					edgeor[el2] = pathor[el];
				} else {
					edgeor[el2] = 1 - pathor[el];
				}
			}
		}
	}
	vector<vector<int>> g2(n);
	vector<int> cntin(n);
	for (int i = 1; i < n; i++) {
		if (edgeor[i] == -1)
			continue;
		if (edgeor[i] == 0) {
			cntin[par[i]]++;
			g2[i].push_back(par[i]);
		} else {
			cntin[i]++;
			g2[par[i]].push_back(i);
		}
	}
	assert(q.empty());
	vector<int> c(n, 1);
	for (int i = 0; i < n; i++) {
		if (cntin[i] == 0) {
			q.push_back(i);
			c[i] = 1;
		}
	}
	while (!q.empty()) {
		int v = q.front();
		q.pop_front();
		for (int u : g2[v]) {
			cntin[u]--;
			if (cntin[u] == 0) {
				c[u] = c[v] + 1;
				q.push_back(u);
			}
		}
	}
	tree2.assign(4 * n, 0);
	for (int i = 0; i < n; i++) {
		turnon(0, 0, n, i);
	}
	for (int i = 0; i < m; i++) {
		int a = arr[i].first;
		int b = arr[i].second;
		int cnt = get(a, b);
		if (cnt - 1 != abs(c[a] - c[b])) {
			cout << -1 << endl;
			return 0;
		}
	}
	cout << *max_element(c.begin(), c.end()) << endl;
	for (int i = 0; i < n; i++) {
		cout << c[i] << " ";
	}
	cout << endl;
}

