#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff first
#define ss second

using namespace std;

int n, m, t;

constexpr int MAXN = 5e5 + 228;
constexpr int INF = 1e9;

vector<int> g[MAXN];
vector<pair<int, int>> W, E;
int tin[MAXN], tout[MAXN], pr[MAXN];
int dfs_timer = 0;

void dfs(int v, int p) {
    pr[v] = p;
    tin[v] = dfs_timer++;
    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    tout[v] = dfs_timer++;
}

bool is_pr(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

vector<int> get_way(int u, int v) {
    vector<int> ans{u};
    while (!is_pr(u, v)) {
        u = pr[u];
        ans.push_back(u);
    }
    while (u != v) {
        for (auto w : g[u]) {
            if (w != pr[u] && is_pr(w, v)) {
                ans.push_back(w);
                u = w;
                break;
            }
        }
    }
    return ans;
}

bool fcyc(int v, vector<int> &usd, vector<vector<int>> &g, vector<int> &tsort) {
    usd[v] = 1;
    for (auto u : g[v]) {
        if (usd[u] == 1) {
            return true;
        }
        if (!usd[u]) {
            bool f = fcyc(u, usd, g, tsort);
            if (f) return f;
        }
    }
    usd[v] = 2;
    tsort.push_back(v);
    return false;
}

void solve15() {
    dfs(0, 0);
    int sans = INF;
    vector<vector<int>> ways(m);
    for (int i = 0; i < m; i++) {
        ways[i] = get_way(W[i].ff, W[i].ss);
    }
    vector<int> c;
    for (int msk = 0; msk < (1 << m); msk++) {
        auto ws = ways;
        vector<vector<int>> gn(n);
        vector<int> cc(n);
        int cans = 1;
        for (int i = 0; i < m; i++) {
            if (msk & (1 << i)) {
                reverse(all(ws[i]));
            }
        }
        for (auto &way : ws) {
            for (int i = 0; i < way.size() - 1; i++) {
                gn[way[i]].push_back(way[i + 1]);
            }
        }
        vector<int> usd(n);
        vector<int> tsort;
        bool f = false;
        for (int i = 0; i < n; i++) {
            if (!usd[i]) {
                bool k = fcyc(i, usd, gn, tsort);
                if (k) {
                    f = true;
                    break;
                }
            }
        }
        if (f) continue;
        reverse(all(tsort));
        for (int v : tsort) {
            if (cc[v] == 0) {
                cc[v] = 1;
            }
            for (auto el : gn[v]) {
                cc[el] = max(cc[el], cc[v] + 1);
                cans = max(cans, cc[el]);
            }
        }
        if (cans < sans) {
            sans =cans;
            c =cc;
        }
    }
    if (sans == INF) {
        cout << "-1\n";
        exit(0);
    } else {
        cout << sans << '\n';
        for (int i : c) {
            cout << i << ' ';
        }
        cout << '\n';
    }
}

void solve0() {
    dfs(0, 0);
    assert(false);
}

int cnt[MAXN], st[MAXN];
int ccc[MAXN];
int deg[MAXN];

void dfs2(int v, int p) {
    for (auto u : g[v]) {
        if (u != p) {
            dfs2(u, v);
            st[v] += st[u];
        }
    }
}

int mdep = 0;

void dfs3(int v, int p, int dep) {
    if(st[v])
    {
        mdep = max(mdep, dep);
        ccc[v] = dep;
    }
    else ccc[v] = 1;
    for (auto u : g[v]) {
        if (u != p) dfs3(u, v, dep + 1);
    }
}

void solve8() {
    int rt = 0;
    for (int i = 0; i < n; i++) {
        if (deg[i] == n - 1) {
            rt = i;
        }
    }
    int crt = 0;
    for (auto [u, v] : W) {
        if (u == rt || v == rt) {
            crt++;
        }
    }
    if (crt == m) {
        cout << "2\n";
        {
            for (int i = 0; i < n; i++) {
                if (i == rt) cout << "2 ";
                else cout << "1 ";
            }
        }
    } else {
        for (auto [u, v] : W) {
            ccc[rt] = 2;
            int ku = ccc[u], kv = ccc[v];
            if (ccc[u] == 0 && ccc[v] == 0) {
                ccc[u] = 1;
                ccc[v] = 3;
            } else if (ccc[u] == ccc[v]) {
                cout << "-1\n";
                exit(0);
            } else if (u == rt || v == rt) {
                continue;
            } else if (ccc[u] == 0){
                ccc[u] = 4 - ccc[v];
            } else {
                ccc[v] = 4 - ccc[u];
            }
        }
        cout << "3\n";
        for (int i = 0; i < n; i++) {
            cout << max(ccc[i], 1LL) << ' ';
        }
        cout << '\n';
    }
    exit(0);
}

void run() {
    cin >> n >> m >> t;
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        g[u].push_back(v);
        g[v].push_back(u);
        deg[u]++;
        deg[v]++;
        E.emplace_back(u, v);
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;
        W.emplace_back(u, v);
    }
    if (n <= 15 && m <= 15) solve15();
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    run();
    return 0;
}