//#pragma GCC target("avx2")

#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

typedef long long ll;
typedef long double ld;

#define sp << ' ' <<
#define nl << '\n'
#define sq << ' '

void solve();

int main() {/*
    ios_base::sync_with_stdio(0);
    cin.tie(0);*/
    solve();
}

int n, m, t, timer = 0;
vector<vector<int>> g;
vector<pair<int, int>> a;
set<pair<int, int>> edges;
vector<int> c;

bool dfs_mark(int v, int p, int f, int prev) {
    if (v == f) {
        return true;
    }
    for (auto &i: g[v]) {
        if (i == p) continue;
        if (dfs_mark(i, v, f, prev + 1)) {
            edges.insert({v, i});
            c[i] = max(c[i], prev + 1);
            return true;
        }
    }
    return false;
}

bool calc(int mask) {
    //vector<int> res(n);
    fill(c.begin(), c.end(), 1);
    edges.clear();

    for (int i = 0; i < m; ++i) {
        int inv = (mask >> i) & 1;
        int v = a[i].first;
        int u = a[i].second;
        if (inv) swap(v, u);
        dfs_mark(v, -1, u, c[v]);
    }

    for (auto &i: edges) {
        if (edges.count({i.second, i.first})) {
            return false;
        }
    }

    return true;
}

void solve() {
    cin >> n >> m >> t;
    g.resize(n);
    c.resize(n, 1);
    a.resize(m);

    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        v--, u--;
        g[v].push_back(u);
        g[u].push_back(v);
    }

    for (auto &i: a) (cin >> i.first >> i.second), i.first--, i.second--;

    int mask_end = 1 << m;
    bool flag = false;

    vector<int> best_c;
    int best_k = 1e9;

    for (int i = 0; i < mask_end; ++i) {
        if (calc(i)) {
            int k = 0;
            for (auto &i: c) k = max(k, i);
            if (k < best_k) {
                best_k = k;
                best_c = c;
            }
            flag = true;
        }
    }

    if (!flag) {
        cout << -1 nl;
        return;
    }

    cout << best_k nl;
    for (auto &i: best_c) {
        cout << i sq;
    } cout nl;
}
