#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <climits>

using namespace std;

const int N = 16;
vector <int> g[N];
int pre[N];
set <int> child[N];
vector <vector <int>> gr;

int n, m, t;

vector<int> find_way(int a, int b) {
    vector<int> w = {a};
    while (!child[a].count(b)) {
        a = pre[a];
        w.push_back(a);
    }
    while (a != b) {
        for (int j : g[a]) {
            if (child[j].count(b) && j != pre[a]) {
                a = j;
                w.push_back(a);
                break;
            }
        }
    }
    return w;
}

void child_dfs(int v, int p = -1) {
    pre[v] = p;
    set<int> chil = {v};
    for (auto i : g[v]) {
        if (i == p)
            continue;
        child_dfs(i, v);
        for (int j : child[i])
            chil.insert(j);
    }
    child[v] = chil;
}

vector <int> top;

void top_sort(int v, vector <bool>& used) {
    used[v] = true;
    for (int i : gr[v])
        top_sort(i, used);
    top.push_back(v);
}

void ans_dfs(int v, vector<int> &ans) {
    int mx = 0;
    for (int i : gr[v]) {
        if (ans[i] == -1)
            ans_dfs(i, ans);
        mx = max(mx, ans[i]);
    }
    ans[v] = mx + 1;
}

vector <int> minim() {
    vector <bool> used(n, false);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            top_sort(i, used);
        }
    }

    vector <int> ans(n, -1);
    for (int i : top) {
        ans_dfs(i, ans);
    }

    return ans;
}

signed main() {
    cin >> n >> m >> t;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }

    child_dfs(0);

    vector <vector <int>> ways;
    set <pair <int, int>> usee;
    map <pair <int, int>, int> ind;

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--, b--;
        vector <int> w = find_way(a, b);
        ways.push_back(w);
        for (int i = 0; i < (int) ways.back().size() - 1; i++) {
            usee.insert({min(w[i], w[i + 1]), max(w[i], w[i + 1])});
            ind[{w[i], w[i + 1]}] = i;
            ind[{w[i + 1], w[i]}] = i;
        }
    }

    vector <pair <int, int>> use;

    for (auto i : usee)
        use.push_back(i);

    int glob_ans = INT_MAX;
    vector <int> glob_vec;

    for (unsigned int mask = 0; mask < (1u << use.size()); mask++) {
        gr.assign(n, vector <int> ());
        vector <set <int>> gr_set(n);

        for (unsigned int i = 0; i < use.size(); i++) {
            if ((mask >> i) & 1) {
                gr[use[i].first].push_back(use[i].second);
                gr_set[use[i].first].insert(use[i].second);
            } else {
                gr[use[i].second].push_back(use[i].first);
                gr_set[use[i].second].insert(use[i].first);
            }
        }

        bool ok = true;
        for (auto q : ways) {
            set <int> types;
            for (int j = 0; j < (int) q.size() - 1; j++) {
                types.insert(gr_set[q[j]].count(q[j + 1]));
            }
            if (types.size() == 2) {
                ok = false;
                break;
            }
        }
        if (!ok)
            continue;

        vector <int> price = minim();
        if (*max_element(price.begin(), price.end()) < glob_ans) {
            glob_ans = *max_element(price.begin(), price.end());
            glob_vec = price;
        }
    }

    if (glob_ans == INT_MAX)
        cout << -1 << endl;
    else {
        cout << glob_ans << endl;
        if (t == 1) {
            for (int &i : glob_vec)
                cout << i << " ";
        }
        cout << endl;
    }
    return 0;
}
