#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <cassert>

using namespace std;

const int N = 5e5 + 1;

int n, m;
vector<int> g[N];

int t = 0, tin[N], tout[N];
int ind[N], lvl[N], sz[N], pr[N];
vector<int> d, vs;

bool in(int v, int u) {
	return tin[v] >= tin[u] && tout[v] <= tout[u];
}

int dfs_lca(int v, int last = -1, int cur_d = 0) {
	tin[v] = t++;
	pr[v] = last;
	ind[v] = d.size();
	d.push_back(cur_d);
	vs.push_back(v);
	lvl[v] = cur_d;
	sz[v] = 1;
	for (int u : g[v]) {
		if (u != last) {
			sz[v] += dfs_lca(u, v, cur_d + 1);
			d.push_back(cur_d);
			vs.push_back(v);
		}
	}
	tout[v] = t++;
	return sz[v];
}

const int K = 20;

pair<int, int> st[N][K];

void build_st() {
	for (int i = 0; i < d.size(); ++i) {
		st[i][0] = { d[i], i };
	}
	for (int k = 1; k < K; ++k) {
		for (int i = 0; i + (1 << k) <= d.size(); ++i) {
			st[i][k] = min(st[i][k - 1], st[i + (1 << k - 1)][k - 1]);
		}
	}
}

int lg[N];

void build_lg() {
	lg[0] = -1;
	for (int x = 1; x < N; ++x) {
		lg[x] = lg[x / 2] + 1;
	}
}

pair<int, int> get_st(int i, int j) {
	int k = lg[j - i + 1];
	return min(st[i][k], st[j - (1 << k) + 1][k]);
}

int lca(int v, int u) {
	if (v == u) {
		return v;
	}
	if (ind[v] > ind[u]) {
		swap(v, u);
	}
	return vs[get_st(ind[v], ind[u]).second];
}

int ans[N];

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	build_lg();
	int t;
	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; ++i) {
		int v, u;
		cin >> v >> u;
		--v, --u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	dfs_lca(0);
	//build_st();
	for (int i = 0; i < m; ++i) {
		int v, u;
		cin >> v >> u;
		--v, --u;
		//int p = lca(v, u);
		int cur = 1;
		while (!in(u, v)) {
			ans[v] = cur++;
			v = pr[v];
		}
		ans[v] = cur++;
		cur = cur + lvl[u] - lvl[v] - 1;
		while (v != u) {
			ans[u] = cur--;
			u = pr[u];
		}
	}
	int mx = 0;
	for (int v = 0; v < n; ++v) {
		if (ans[v] == 0) {
			ans[v] = 1;
		}
		mx = max(mx, ans[v]);
	}
	cout << mx << '\n';
	for (int v = 0; v < n; ++v) {
		cout << ans[v] << ' ';
	}
	cout << '\n';
	return 0;
}