#define FASTIO ios::sync_with_stdio(false), cin.tie(0), cout.tie(0);

#ifndef BZ
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
using pll = pair<ll, ll>;

#ifdef Debug
#define LOG(v) cout << #v << ": " << v << "\n";
#else
#define LOG(v) ;
#endif

#define F first
#define S second
#define forEach(c) for (auto &it : c)
#define all(c) c.begin(), c.end()
#define rall(c) c.rbegin(), c.rend()
#define pb push_back

template <class T>
void chMax(T &a, T b) {
    if (a < b) a = b;
}

template <class T>
void chMin(T &a, T b) {
    if (b < a) a = b;
}

inline ll divUp(ll a, ll b) {
    return (a + b - 1) / b;
}

void dfsMark(ll v, const vector<vector<ll>> &adj, vector<ll> &cost, ll d) {
    cost[v] = d;
    forEach(adj[v]) {
        if (cost[it] != -1) continue;
        dfsMark(it, adj, cost, d + 1);
    }
}

void bfsMark(ll v, const vector<vector<ll>> &pr, vector<ll> &ans) {
    ans[v] = 1;
    deque<ll> q{v};
    while (!q.empty()) {
        ll v = q.front(); q.pop_front();
        forEach(pr[v]) {
            if (ans[v] == ans[it]) {
                cout << "-1\n";
                exit(0);
            }
            if (ans[it] != -1) continue;
            ans[it] = 4 - ans[v];
            q.pb(it);
        }
    }
}

void solve() {
    /// no shared tunnels
    ll n, m, t;
    cin >> n >> m >> t;
    vector<vector<ll>> adj(n, vector<ll>());
    for (ll i = 0; i < n - 1; i++) {
        ll a, b;
        cin >> a >> b;
        a--, b--;
        adj[a].pb(b);
        adj[b].pb(a);
    }
    ll root = 0;
    for (ll i = 0; i < n; i++) if (adj[root].size() < adj[i].size()) root = i;
    assert(adj[root].size() == n - 1);
    ll cntRoot = 0;
    vector<vector<ll>> pt(n, vector<ll>());
    for (ll i = 0; i < m; i++) {
        pll it;
        cin >> it.F >> it.S;
        it.F--, it.S--;
        if (it.F == root || it.S == root) cntRoot++;
        pt[it.F].pb(it.S);
        pt[it.S].pb(it.F);
    }
    if (cntRoot == m) {
        vector<ll> ans(n, 1);
        ans[root] = 2;
        cout << "2\n";
        forEach(ans) cout << it << " ";
    } else {
        vector<ll> ans(n, -1);
        ans[root] = 2;
        for (ll i = 0; i < n; i++) {
            if (ans[i] == -1) bfsMark(i, pt, ans);
        }
        for (ll i = 0; i < n; i++) {
            forEach(pt[i]) {
                assert(ans[it] != ans[i]);
            }
        }
        cout << *max_element(all(ans)) << "\n";
        forEach(ans) cout << it << " ";
    }
}

int main() {
    FASTIO
    solve();
    return 0;
}