#pragma GCC target("sse,sse2,ssse3,sse4.1,sse4.2,avx,avx2")

#include <bits/stdc++.h>
#include <immintrin.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;

#define x first
#define y second
#define all(x) begin(x), end(x)

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

typedef long long ll;
typedef long double ld;

const int MAX_N_G2 = 15, MAX_N = 5e5 + 10;

vector<int> edges[MAX_N];
pair<int, int> paths[MAX_N];

vector<int> g2_paths[MAX_N_G2][MAX_N_G2];
vector<int> g2_edges[MAX_N_G2];

vector<int> g6_edges[MAX_N];
char g6_color[MAX_N], g2_color[MAX_N];

bool g6_dfs(int u, int cc = 0) {
	if (g6_color[u] != -1)
		return g6_color[u] == cc;
	g6_color[u] = cc;
	for (int v : g6_edges[u]) 
		if (!g6_dfs(v, 1 - cc))
			return false;
	return true;
}

void g2_dfs(int start, int u, int p = -1) {
	if (p != -1)
		g2_paths[start][u] = g2_paths[start][p];
	g2_paths[start][u].push_back(u);
	for (int v : edges[u]) {
		if (v == p)
			continue;
		g2_dfs(start, v, u);
	}
}

char g2_used[MAX_N];

bool g2_color_dfs(int u) {
	if (g2_used[u] == 1)
		return false;
	if (g6_color[u] != -1)
		return true;
	g2_used[u] = 1;
	g6_color[u] = 0;
	// cout << "in v" << u << endl;
	for (int v : g2_edges[u]) {
		if (!g2_color_dfs(v))
			return false;
		g6_color[u] = max(g6_color[v], g6_color[u]);
	}
	g2_used[u] = 2;
	++g6_color[u];
	return true;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int n, m, t;
	cin >> n >> m >> t;
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		edges[--u].push_back(--v);
		edges[v].push_back(u);
	}
	for (int i = 0; i < m; ++i) {
		cin >> paths[i].x >> paths[i].y;
		--paths[i].x;
		--paths[i].y;
	}
	if (m == 0) {
		cout << "1\n";
		for (int i = 0; i < n; ++i)
			cout << "1 ";
		return 0;
	}
	if (n == 2) {
		cout << "2\n1 2";
		return 0;
	}
	bool check_6 = 1;
	int root = 0;
	if (edges[root].size() == 1)
		root = edges[root][0];
	for (int i = 0; i < n && check_6; ++i) {
		if (i == root)
			continue;
		if (edges[i].size() != 1 || edges[i][0] != root)
			check_6 = 0;
	}
	if (check_6) {
		bool at_least = 0;
		for (int i = 0; i < m; ++i)
			if (paths[i].x != root && paths[i].y != root)
				at_least = 1;
		if (at_least) {
			for (int i = 0; i < m; ++i)
				if (paths[i].x != root && paths[i].y != root)
					g6_edges[paths[i].x].push_back(paths[i].y),
					g6_edges[paths[i].y].push_back(paths[i].x);
			fill(g6_color, g6_color + n, -1);
			for (int i = 0; i < n; ++i)
				if (g6_color[i] == -1)
					if (!g6_dfs(i))
						return cout << "-1\n", 0;
			cout << "3\n";
			for (int i = 0; i < n; ++i) {
				if (i == root)
					cout << "2 ";
				else if (g6_color[i] == 0)
					cout << "1 ";
				else
					cout << "3 ";
			}
		} else {
			cout << "2\n";
			for (int i = 0; i < n; ++i) {
				if (i == root)
					cout << "1 ";
				else
					cout << "2 ";
			}
		}
	} else if (m <= 15) {
		for (int i = 0; i < n; ++i)
			g2_dfs(i, i);
		int max_mask = 1 << (m - 1);
		int best_ans = n + 1;
		for (int u = 0; u < max_mask; ++u) {
			for (int i = 0; i < n; ++i)
				g2_edges[i].clear();
			for (int i = 0; i < m; ++i) {
				int start = paths[i].x, end = paths[i].y;
				if ((u >> i) & 1)
					swap(start, end);
				int prev = -1;
				for (int u : g2_paths[start][end]) {
					if (prev != -1) {
						g2_edges[u].push_back(prev);
					}
					prev = u;
				}
			}
			bool bad = 0;
			fill(g6_color, g6_color + n, -1);
			fill(g2_used, g2_used + n, 0);
			for (int i = 0; i < n && !bad; ++i) {
				if (g6_color[i] == -1) {
					if (!g2_color_dfs(i)) {
						bad = 1;
					}
				}
			}
			if (bad)
				continue;
			int curr_ans = *max_element(g6_color, g6_color + n);
			// cout << bitset<3>(u) << " " << curr_ans << "\n";
			if (best_ans > curr_ans) {
				best_ans = curr_ans;
				for (int i = 0; i < n; ++i)
					g2_color[i] = g6_color[i];
			}
		}
		if (best_ans != n + 1) {
			cout << best_ans << "\n";
			for (int i = 0; i < n; ++i)
				cout << g2_color[i] + 0 << " ";
		} else {
			cout << "-1\n";
		}
	}
	return 0;
}