#include <iostream>
#include <algorithm>
#include <cstdint>
#include <cstdlib>
#include <vector>
using namespace std;

uint16_t t;
vector< vector< uint32_t > > ss;
vector<uint32_t> pred, depth, tar_zone;
vector< pair<uint32_t, uint32_t> > lines;
uint64_t res=0;

void calc_pred_depth (uint32_t cur=0, uint32_t cur_pred=0, uint32_t cur_depth=0)
{
    if(pred[cur]!=UINT32_MAX)
        return;
    pred[cur]=cur_pred;
    depth[cur]=cur_depth;

    for(auto x:ss[cur])
    {
        calc_pred_depth(x, cur, cur_depth+1);
    }
}

void init()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    uint32_t n, m;
    cin>>n>>m>>t;

    ss.resize(n);
    pred.resize(n, UINT32_MAX);
    depth.resize(n);
    tar_zone.resize(n, UINT32_MAX);

    for(uint32_t i=0; i<n-1; i++)
    {
        uint32_t u, v;
        cin>>u>>v;
        u--; v--;

        ss[u].push_back(v);
        ss[v].push_back(u);
    }

    lines.resize(m);
    for(uint32_t i=0; i<m; i++)
    {
        cin>>lines[i].first>>lines[i].second;
        lines[i].first--;
        lines[i].second--;
    }

    calc_pred_depth();

//    asm volatile ("nop");
}

void get_path (uint32_t u, uint32_t v, vector<uint32_t> &path)
{
    path.clear();
    vector<uint32_t> rpath;
    while (u!=v)
    {
        if(depth[u]>depth[v])
        {
            path.push_back(u);
            u=pred[u];
        }
        else if(depth[u]<depth[v])
        {
            rpath.push_back(v);
            v=pred[v];
        }
        else
        {
            path.push_back(u);
            u=pred[u];
            rpath.push_back(v);
            v=pred[v];
        }
    }
    path.push_back(u);
    reverse(rpath.begin(), rpath.end());
    path.insert(path.end(), rpath.begin(), rpath.end());
}

void solve()
{
    vector<uint32_t> tmp;

    for(uint32_t i=0; i<lines.size(); i++)
    {
        tmp.clear();
        get_path(lines[i].first, lines[i].second, tmp);

//        for(auto x:tmp)
//        {
//            cout<<x<<' ';
//        }
//        cout<<endl;

        res = max<uint64_t>(res, tmp.size());


        for(uint32_t i=1; i<=tmp.size(); i++)
            tar_zone[tmp[i-1]]=i;
    }

    for(uint32_t i=0; i<tar_zone.size(); i++)
    {
        if(tar_zone[i]==UINT32_MAX)
            tar_zone[i]=1;
    }
}

int main()
{
    init();

    solve();

    cout<<res<<'\n';
    for(auto x:tar_zone)
        cout<<x<<' ';
    cout<<'\n';

    return 0;
}