#include<bits/stdc++.h>

using namespace std;

const int MAXN = 5e5 + 5;
const int LOG = 21;

int up[LOG][MAXN];
int n, m, t;
vector<pair<int, int>> g[MAXN];
pair<int, int> ways[MAXN];
pair<int, int> edges[MAXN];
int answer = int(1e9);
vector<int> remem;
int dist[MAXN];
int par[MAXN];
int tin[MAXN], tout[MAXN];
int timer = 0;
int paredge[MAXN];

void dfs(int v, int p, int ind, int d) {
	par[v] = p;
	paredge[v] = ind;
	dist[v] = d;
	up[0][v] = p;
	tin[v] = timer++;
	for (int i = 1; i < LOG; ++i) {
		up[i][v] = up[i - 1][up[i - 1][v]];
	}
	for (auto to : g[v]) {
		if (to.first == p) continue;
		dfs(to.first, v, to.second, d + 1);
	}
	tout[v] = timer++;
}

bool is_par(int u, int v) {
	return (tin[u] <= tin[v] && tout[v] <= tout[u]);
}

int find_lca(int u, int v) {
	if (is_par(u, v)) return u;
	if (is_par(v, u)) return v;
	for (int i = LOG - 1; i >= 0; --i) {
		int curv = up[i][v];
		if (!is_par(curv, u)) {
			v = curv;
		}
	}
	return par[v];
}

bool turn[MAXN];
int used[MAXN];
bool cycle = false;
vector<int> order;

void topsort(int v, vector<int> neigh[]) {
	used[v] = 1;
	for (auto to : neigh[v]) {
		if (used[to] == 2) cycle = true;
		if (used[to]) continue;
		topsort(to, neigh);
	}
	order.push_back(v);
}

vector<pair<int, int>> check_g[MAXN];
vector<int> newedges;
bool globok = true;
vector<vector<int>> comp;

void check_good(int v, int toset, int col) {
	//cout << "v: " << v << ' ' << toset << ' ' << col << endl;
	turn[v] = toset;
	used[v] = 1;
	comp[col].push_back(v);
	for (auto to : check_g[v]) {
		if (used[to.first]) {
			if (toset + to.second != turn[to.first]) globok = false;
			continue;
		}
		assert(used[to.first] == 0);
		check_good(to.first, toset + to.second, col);
	}	
}

vector<int> curg[MAXN];

int check_comp(int col, bool type, bool relax) {
	for (int i = 0; i < n; ++i) curg[i] = {};
	if (col == -1) {
		for (int i = 0; i < n - 1; ++i) {
			int newtype = turn[i];
			if (newtype) {
				curg[edges[i].first].push_back(edges[i].second);
				//cout << "edge: " << edges[i].first << ' ' << edges[i].second << endl;
			} else {
				curg[edges[i].second].push_back(edges[i].first);
				//cout << "edge: " << edges[i].second << ' ' << edges[i].first << endl;
			}
		}
	} else {
		for (auto e : comp[col]) {
			int newtype = turn[e] ^ type;
			if (newtype) {
				curg[edges[e].first].push_back(edges[e].second);
			} else {
				curg[edges[e].second].push_back(edges[e].second);
			}
		}
	}
	cycle = false;
	memset(used, 0, sizeof used);
	order.clear();
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			topsort(i, curg);
		}
	}
	if (cycle) return int(1e9);
	vector<int> dp(n, 1);
	int ans = 1;
	for (int i = 0; i < n; ++i) {
		int curv = order[i];
		//if (col == -1) cout << "curv: " << curv << endl;
		int maxi = 0;
		for (auto to : curg[curv]) {
			//if (col == -1) cout << "to: " << to << endl;
			maxi = max(maxi, dp[to]);
		}
		dp[curv] = maxi + 1;
		//if (col == -1) cout << "dp: " << dp[curv] << endl;
		ans = max(ans, dp[curv]);
	}
	if (col == -1) {
		answer = ans;
		remem = dp;
	}
	return ans;
}

void solve() {
	// TODO 
	for (int q = 0; q < m; ++q) {
		int u = ways[q].first, v = ways[q].second;
		int lca = find_lca(u, v);
		//cout << "uv: " << u << ' ' << v << ' ' << lca << endl;
		vector<int> edges1, edges2;
		while (u != lca && u != v) {
			edges1.push_back(paredge[u]);
			//cout << "e1: " << paredge[u] << endl;
			u = par[u];
		}
		while (v != lca && v != u) {
			edges2.push_back(paredge[v]);
			//cout << "e2: " << paredge[v] << endl;
			v = par[v];
		}
		for (auto e1 : edges1) {
			for (auto e2 : edges2) {
				check_g[e1].push_back({e2, 1});
				check_g[e2].push_back({e1, 1});
				//cout << "1: " << e1 << ' ' << e2 << endl;
			}
		}
		for (int i = 0; i < edges1.size(); ++i) {
			for (int j = 0; j < edges1.size(); ++j) {
				if (i == j) continue;
				check_g[edges1[i]].push_back({edges1[j], 0});
				//cout << "0: " << edges1[i] << ' ' << edges1[j] << endl;
			}
		}
		for (int i = 0; i < edges2.size(); ++i) {
			for (int j = 0; j < edges2.size(); ++j) {
				if (i == j) continue;
				check_g[edges2[i]].push_back({edges2[j], 0});
			}
		}
	}
	memset(used, 0, sizeof used);
	int counter = 0;
	for (int i = 0; i < n - 1; ++i) {
		if (!used[i]) {
			comp.push_back(vector<int>());
			check_good(i, 0, counter);
			++counter;
			//continue;
			int num1 = check_comp(counter - 1, 0, 0), num2 = check_comp(counter - 1, 1, 0);
			if (num2 < num1) {
				for (auto e : comp[counter - 1]) {
					turn[e] ^= 1;
				}
			}
		}
	}
	check_comp(-1, 0, 1);
	if (answer == int(1e9) || !globok) {
		cout << -1 << endl;
		return;
	}
	cout << answer << endl;
	for (int i = 0; i < n; ++i) {
		cout << remem[i] << ' ';
	}
	cout << endl;
}

int main() {
	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; ++i) {
		int u, v;
		cin >> u >> v; --u; --v;
		edges[i] = {u, v};
		g[u].push_back({v, i});
		g[v].push_back({u, i});
	}
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b; --a; --b;
		ways[i] = {a, b};
	}
	dfs(0, 0, -1, 0);
	solve();
	return 0;
}