#include<bits/stdc++.h>

//#define int long long
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 105, M = 105;

int n, m;
vector<int> g[N];
pii lines[M];

int from[N], tin[N], tout[N], timer = 0;

void dfs0(int v, int pr) {
    tin[v] = timer++;
    for (int &u : g[v]) if (u != pr) {
        from[u] = v;
        dfs0(u, v);
    }
    tout[v] = timer++;
}

bool is_anc(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

vector<int> get_path(int v, int u, int idx) {
    vector<int> path = {v};
    while (!is_anc(v, u)) {
        v = from[v];
        path.pb(v);
    }
    vector<int> up;
    while (v != u) {
        up.pb(u);
        u = from[u];
    }
    for (int i = sz(up) - 1; i > -1; --i) {
        path.pb(up[i]);
    }
    return path;
}

vector<int> path[M];

vector<int> G[N];
int used[N], deep[N];
bool cycle;

void dfs(int v) {
    used[v] = 1;
    for (int &u : G[v]) {
        if (!used[u]) {
            dfs(u);
        } else if (used[u] == 1) {
            cycle = true;
        }
        deep[v] = max(deep[v], deep[u] + 1);
    }
    used[v] = 2;
}

bool check() {
    cycle = false;
    fill(used + 1, used + n + 1, 0);
    fill(deep + 1, deep + n + 1, 1);
    for (int v = 1; v <= n; ++v) {
        if (!used[v]) {
            dfs(v);
            if (cycle) {
                return false;
            }
        }
    }
    return true;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
    freopen(TASK".in", "r", stdin),
    freopen(TASK".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int type;
    cin >> n >> m >> type;
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        g[v].pb(u);
        g[u].pb(v);
    }
    dfs0(1, 1);
    for (int i = 1; i <= m; ++i) {
        cin >> lines[i].x >> lines[i].y;
        path[i] = get_path(lines[i].x, lines[i].y, i);
    }
    const int inf = 1e9;
    pii ans = mp(inf, inf);
    for (int mask = 0; mask < (1 << m); ++mask) {
        for (int i = 1; i <= n; ++i) {
            G[i].clear();
        }
        for (int i = 1; i <= m; ++i) {
            if ((mask >> (i - 1)) & 1) {
                for (int j = 1; j < sz(path[i]); ++j) {
                    G[path[i][j]].pb(path[i][j - 1]);
                }
            } else {
                for (int j = 1; j < sz(path[i]); ++j) {
                    G[path[i][j - 1]].pb(path[i][j]);
                }
            }
        }
        if (check()) {
            ans = min(ans, mp(*max_element(deep + 1, deep + n + 1), mask));
        }
    }
    if (ans.x == inf) {
        cout << "-1\n";
        return 0;
    }
    cout << ans.x << "\n";
    if (type == 1) {
        for (int i = 1; i <= n; ++i) {
            G[i].clear();
        }
        for (int i = 1; i <= m; ++i) {
            if ((ans.y >> (i - 1)) & 1) {
                for (int j = 1; j < sz(path[i]); ++j) {
                    G[path[i][j]].pb(path[i][j - 1]);
                }
            } else {
                for (int j = 1; j < sz(path[i]); ++j) {
                    G[path[i][j - 1]].pb(path[i][j]);
                }
            }
        }
        assert(check());
        for (int i = 1; i <= n; ++i) {
            cout << deep[i] << " ";
        }
        cout << "\n";
    }

    return 0;
}
