#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double

#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")

ll INF = (ll) 1e20;
int iINF = (int) 1e20;
ll mod = (ll) 1e9 + 7;

ll dp[20][500000];

void precalc(ll v, vector<vector<ll>> &nodes, vector<ll> &d, vector<ll> &p, ll was) {
    for (auto i : nodes[v]) {
        if (i != was) {
            d[i] = d[v] + 1;
            p[i] = v;
            precalc(i, nodes, d, p, v);
        }
    }
}

ll lca(ll a, ll b, vector<ll> &d) {
    if (d[a] < d[b])
        swap(a, b);
    for (int st = 19; st >= 0; --st) {
        if (d[dp[st][a]] >= d[b])
            a = dp[st][a];
    }
    if (a == b)
        return a;
    for (int st = 19; st >= 0; --st) {
        if (dp[st][a] != dp[st][b]) {
            a = dp[st][a], b = dp[st][b];
        }
    }
    return dp[0][a];
}

void get_dirs(ll v, ll fin, vector<ll> &dir, bool &up, bool &down) {
    if (v == fin)
        return;
    if (dir[v] == 0) {
        down = true;
    } else if (dir[v] == 1)
        up = true;
    get_dirs(dp[0][v], fin, dir, up, down);
}

void make_dir(ll v, ll fin, vector<ll> &dir, bool up, bool down) {
//    cout << v << ' ' << fin << ' ' << dp[0][v] << '\n';
    if (v == fin)
        return;
    if (up) {
        dir[v] = 1;
    } else {
        dir[v] = 0;
    }
    make_dir(dp[0][v], fin, dir, up, down);
}

void make_cost(ll v, vector <vector <ll>> &nodes, vector <ll> &dir, vector <ll> &c) {
    if(dir[v] == 1) {
        c[dp[0][v]] = max(c[dp[0][v]], c[v] + 1);
        make_cost(dp[0][v], nodes, dir, c);
    }
    for(auto i : nodes[v]) {
        if(i != dp[0][v]) {
            if(dir[i] == 0) {
                c[i] = max(c[i], c[v] + 1);
                make_cost(i, nodes, dir, c);
            }
        }
    }
}

bool f(ll mask, ll i) {
    return (mask & (1 << i));
}

void solvelittle(ll n, ll m, vector <vector <ll>> &nodes, vector <pair <ll, ll>> &v, vector <ll> &lc, ll t) {
    ll ans = INF;
    vector <ll> vv;
    for(int i = 0; i < (1 << m); ++i) {
        bool ok = true;
        vector <ll> dir(n, -1);
        for(int j = 0; j < m; ++j) {
            if(f(i, j)) {
                ll now = v[j].first;
                while(now != lc[j]) {
                    if(dir[now] == 0)
                        ok = false;
                    dir[now] = 1;
                    now = dp[0][now];
                }
                now = v[j].second;
                while(now != lc[j]) {
                    if(dir[now] == 1)
                        ok = false;
                    dir[now] = 0;
                    now = dp[0][now];
                }
            }
            else {
                ll now = v[j].second;
                while(now != lc[j]) {
                    if(dir[now] == 0)
                        ok = false;
                    dir[now] = 1;
                    now = dp[0][now];
                }
                now = v[j].first;
                while(now != lc[j]) {
                    if(dir[now] == 1)
                        ok = false;
                    dir[now] = 0;
                    now = dp[0][now];
                }
            }
        }
        vector<ll> c(n, 1);
        vector<ll> in(n, 0);
        for (int j = 0; j < n; ++j) {
//        cout << dir[i] << '\n';
            if(dir[j] == 0) {
                ++in[j];
            }
            else if(dir[j] == 1) {
                ++in[dp[0][j]];
            }
        }
        for(int j = 0; j < n; ++j) {
            if(in[j] == 0) {
                make_cost(j, nodes, dir, c);
            }
        }
        if(!ok)
            continue;
        ll maxim = 1;
        for(auto j : c)
            maxim = max(maxim, j);
//        if(maxim == 1) {
//            cout << i << '\n';
//            for(auto j : dir)
//                cout << j << ' ';
//            cout << '\n';
//            for(auto j : in)
//                cout << j << ' ';
//            cout << '\n';
//            for(auto j : c)
//                cout << j << ' ';
//            cout << '\n';
//        }
        if(ans > maxim) {
            ans = maxim;
            vv = c;
        }
    }
    if(ans == INF)
        cout << -1;
    else {
        cout << ans << '\n';
        for(auto i : vv) {
            cout << i << ' ';
        }
    }
}

bool ok(ll v, map <ll, vector <ll>> &mp, vector <ll> &dir, ll vertex) {
    bool ret = true;
    for(auto i : mp[v]) {
        if(i == vertex)
            continue;
        if(dir[i] == -1) {
            if(dir[v] == 0) {
                dir[i] = 1;
                ret &= ok(i, mp, dir, vertex);
            }
            else {
                dir[i] = 0;
                ret &= ok(i, mp, dir, vertex);
            }
        }
        else if(dir[i] == dir[v]) {
            cout << -1;
            exit(0);
        }
    }
    return true;
}

signed main() {
    ll n, m, t;
    cin >> n >> m >> t;
    vector<vector<ll>> nodes(n);
    vector <pair <ll, ll>> a(n - 1);
    vector<ll> dir(n, -1); // 0 == DOWN, 1 == UP
    for (int i = 0; i < n - 1; ++i) {
        ll u, v;
        cin >> u >> v;
        a[i] = {u - 1, v - 1};
        nodes[u - 1].push_back(v - 1);
        nodes[v - 1].push_back(u - 1);
    }
    vector<pair<ll, ll>> v(m);
    for (int i = 0; i < m; ++i) {
        cin >> v[i].first >> v[i].second;
        --v[i].first, --v[i].second;
    }
    vector<ll> p(n, 0), d(n, 0);
    precalc(0, nodes, d, p, 0);
    for (int i = 0; i < n; ++i) {
        dp[0][i] = p[i];
    }
    for (int st = 1; st < 20; ++st) {
        for (int i = 0; i < n; ++i) {
            dp[st][i] = dp[st - 1][dp[st - 1][i]];
        }
    }
    vector<ll> lc(m);
    for (int i = 0; i < m; ++i) {
        lc[i] = lca(v[i].first, v[i].second, d);
    }
    if(n <= 15 && m <= 15) {
        solvelittle(n, m, nodes, v, lc, t);
        return 0;
    }
    set <ll> st;
    st.insert(a[0].first);
    st.insert(a[0].second);
    for(int i = 1; i < n - 1; ++i) {
        vector <ll> kek;
        for(auto j : st) {
            if(j != a[i].first && j != a[i].second)
                kek.push_back(j);
        }
        for(auto j : kek)
            st.erase(j);
    }
    ll vertex = (*st.begin());
    map <ll, vector <ll>> mp;
    for(int i = 0; i < m; ++i) {
        if(v[i].first != vertex)
            mp[v[i].first].push_back(v[i].second);
        if(v[i].second != vertex)
            mp[v[i].second].push_back(v[i].first);
    }
    bool axax = false;
    for(auto i : v) {
        if(i.first == vertex || i.second == vertex)
            continue;
        axax = true;
    }
    if(axax) {
        vector<ll> predok(n, -1);
        for (int i = 0; i < n; ++i) {
            if (i == vertex)
                continue;
            if (dir[i] == -1) {
                dir[i] = 1;
                ok(i, mp, dir, vertex);
            }
        }
        vector<ll> c(n);
        c[vertex] = 2;
        for (int i = 0; i < n; ++i) {
            if (i == vertex)
                continue;
            if (dir[i] == 1 || dir[i] == -1)
                c[i] = 1;
            if (dir[i] == 0)
                c[i] = 3;
        }
        cout << 3 << '\n';
        for(auto i : c) {
            cout << i << ' ';
        }
    }
    else {
        vector <ll> c(n, 1);
        c[vertex] = 2;
        cout << 2 << '\n';
        for(auto i : c) {
            cout << i << ' ';
        }
    }
}