#include <iostream>
#include <map>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <cmath>
#include <time.h>
#include <assert.h>
#include <queue>


#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back

const int INF = 2e9;
const int MB = 20;

using namespace std;

vector<int> res, p, h, a, link;
vector<vector<int>> g;
vector<pair<pair<int, int>, int>> q;
int n, m, t;

struct SparseTable {
    vector<vector<int>> t;
    vector<int> log;
    void build(int n, vector<int> ver) {
        t.resize(MB, vector<int>(n));
        for (int i = 0; i < n; i++) {
            t[0][i] = ver[i];
        }

        for (int bit = 0; bit < MB - 1; bit++) {
            for (int i = 0, s = (1 << bit), j = i + s; j + s <= n; i++, j++) {
                t[bit + 1][i] = h[t[bit][i]] < h[t[bit][j]] ? t[bit][i] : t[bit][j];
            }
        }
        
        log.resize(n + 1);
        for (int i = 2; i <= n; i++) {
            log[i] = log[i / 2] + 1;
        }
    }

    int get(int l, int r) {
        int b = log[r - l + 1];
        r = r - (1LL << b) + 1;
        return h[t[b][l]] < h[t[b][r]] ? t[b][l] : t[b][r];
    }
};

SparseTable sparse;

int getlca(int a, int b) {
    int l = link[a];
    int r = link[b];
    if (l > r) swap(l, r);
    return sparse.get(l, r);
}

void dfs(int v) {
    link[v] = a.size();
    a.pb(v);
    for (int u : g[v]) {
        if (u != p[v]) {
            p[u] = v;
            h[u] = h[v] + 1;
            dfs(u);
            a.pb(v);
        }
    }
}

vector<vector<bool>> ng;
vector<int> dp;

void dfs1(int v) {
    dp[v] = 1;
    for (int i = 0; i < n; i++) {
        if (ng[v][i]) {
            dfs1(i);
            dp[v] = max(dp[v], dp[i] + 1);
        }
    }
}

int get(int mask) {
    for (int i = 0; i < n; i++) fill(all(ng[i]), false);
    for (int i = 0; i < m; i++) {
        int from = q[i].first.first;
        int to = q[i].first.second;
        int lca = q[i].second;
        if ((mask >> i) & 1) {
            while (from != lca && p[from] != -1) {
                ng[from][p[from]] = true;
                from = p[from];
            }
            while (to != lca && p[to] != -1) {
                ng[p[to]][to] = true;
                to = p[to];
            }
        }
        else {
            while (to != lca && p[to] != -1) {
                ng[to][p[to]] = true;
                to = p[to];
            }
            while (from != lca && p[from] != -1) {
                ng[p[from]][from] = true;
                from = p[from];
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (ng[i][j] && ng[j][i]) return INF;
        }
    }

    fill(all(dp), 0);
    for (int i = 0; i < n; i++) {
        if (!dp[i]) dfs1(i);
    }
    return *max_element(all(dp));
}

void go1(int start) {
    vector<bool> used(n);
    fill(all(res), 1);
    if (!m) {
        cout << "1\n";
        for (int i : res) cout << i << " ";
        return;
    }
    bool good = false;
    for (auto& p : q) {
        int from = p.first.first;
        int to = p.first.second;
        int lca = p.second;
        if (from != start && to != start) good = true;
    }
    res[start] = 2;
    if (!good) {
        cout << "2\n";
        for (int i : res) cout << i << " ";
        return;
    }

    vector<vector<int>> w(n);
    for (auto& p : q) {
        int from = p.first.first;
        int to = p.first.second;
        int lca = p.second;
        if (from != start && to != start) {
            w[from].pb(to);
            w[to].pb(from);
        }
    }
    
    int st = start ? 0 : 1;
    for (int i = 0; i < n; i++) {
        if (w[i].size() > 1) st = i;
    }

    fill(all(res), -1);
    res[st] = 1;
    res[start] = 2;
    queue<int> qq;
    qq.push(st);
    while (!qq.empty()) {
        int v = qq.front();
        qq.pop();
        for (int u : w[v]) {
            if (res[u] == res[v]) {
                cout << -1;
                return;
            }
            if (res[u] == -1) {
                qq.push(u);
                res[u] = res[v] == 1 ? 3 : 1;
            }
        }
    }
    cout << "3\n";
    for (int i : res) cout << i << " ";
}

void solve() {
    cin >> n >> m >> t;
    g.resize(n);
    vector<int> d(n);
    for (int i = 0; i < n - 1; i++) {
        int from, to;
        cin >> from >> to;
        from--; to--;
        g[from].pb(to);
        g[to].pb(from);
        d[from]++; d[to]++;
    }

    p.resize(n, -1);
    h.resize(n);
    q.resize(m);
    link.resize(n);
    res.resize(n);
   
    dfs(0);
    sparse.build(a.size(), a);
    
    for (int i = 0; i < m; i++) {
        int from, to;
        cin >> from >> to;
        from--; to--;
        int lca = getlca(from, to);
        q[i] = { {from, to}, lca };
       
    }

    if (*max_element(all(d)) == n) {
        for (int i = 0; i < n; i++) {
            if (d[i] == n) {
                go1(i);
                return;
            }
        }
    }

    int ans = INF;
    ng.resize(n, vector<bool>(n));
    dp.resize(n);
    for (int mask = 0; mask < (1LL << m); mask++) {
        int x = get(mask);
        if (ans > x) {
            ans = x;
            swap(res, dp);
        }
    }
    if (ans == INF) {
        cout << -1;
        return;
    }

    cout << ans << '\n';

    for (int i : res) cout << i << " ";

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    //srand(time(0));
    solve();
}

/*
    Спокойствие, только спокойствие!
*/