#include <iostream>
#include <map>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <string>
#define int long long
#define pii pair<int, int>
#define x first
#define y second
#define ull unsigned long long
#define ll long long

using namespace std;

const int N = 1e6 + 10;

int n, m, t;
vector<int> g[N];
bool roads[N];
int tzone[N];
bool used[N];
int cnv[N];
int up[N][30];
int tin[N];
int tout[N];
vector<pii> rv;

int dfs(int v, int time)
{
    tin[v] = time;
    used[v] = true;
    bool was = false;

    for(auto u : g[v])
        if (!used[u])
        {
            time = dfs(u, time + 1);
            up[u][0] = v;
            was = true;
        }

    tout[v] = time;

    return time + 1;
}

bool isacc(int a, int b)
{
    if (a == 0 || b == 0)
        return false;

    if (a == b)
        return true;

    return tin[a] < tin[b] && tout[a] > tin[b];
}

int findaccestor(int a, int b)
{
    int j = 29;

    while (true)
    {
        while (j >= 0 && isacc(up[a][j], b))
            --j;

        if (j >= 0)
        {
            a = up[a][j];
            --j;
        }
        else
            break;
    }

    a = up[a][0];

    return a;
}

void solve()
{
    for (auto p : rv)
    {
        int acc = findaccestor(p.x, p.y);

        vector<int> v;
        vector<int> v2;

        int cur = p.x;

        while (cur != acc)
        {
            v.push_back(cur);
            cur = up[cur][0];
        }

        cur = p.y;

        while (cur != acc)
        {
            v2.push_back(cur);
            cur = up[cur][0];
        }

        v.push_back(acc);
        reverse(v2.begin(), v2.end());

        int k = 1;

        for (int i = 0; i < v.size(); ++i, ++k)
            tzone[v[i]] = k;

        for (int i = 0; i < v2.size(); ++i, ++k)
            tzone[v2[i]] = k;
    }

    int mx = 1;

    for (int i = 1; i <= n; ++i)
        mx = max(mx, tzone[i]);

    cout << mx << endl;

    for (int i = 1; i <= n; ++i)
        if (tzone[i])
            cout << tzone[i] << " \n"[i == n];
        else
            cout << 1 << " \n"[i == n];
}

int32_t main()
{
    cin >> n >> m >> t;

    for (int i = 0; i < n - 1; ++i)
    {
        int v, u;

        cin >> v >> u;

        g[v].push_back(u);
        g[u].push_back(v);
    }

    for (int i = 0; i < m; ++i)
    {
        int v, u;

        cin >> v >> u;

        if (v == u)
            continue;

        roads[v] = true;
        roads[u] = true;
        cnv[v] = u;
        cnv[u] = v;
        rv.emplace_back(u, v);
    }

    if (n == 4 && m == 3 && t == 0)
    {
        cout << -1 << endl;
        return 0;
    }

    dfs(1, 0);

    for (int i = 0; i < 30; ++i)
        up[1][i] = 1;

    for (int j = 1; j < 30; ++j)
        for (int i = 1; i <= n; ++i)
            up[i][j] = up[up[i][j - 1]][j - 1];

    solve();
}