#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <map>
#include <cassert>

using namespace std;

const int N = 5e5 + 1;

int n, m;
vector<int> g[N];

int t = 0, tin[N], tout[N];
int lvl[N], sz[N], pr[N];

int dfs(int v, int last = -1, int cur_d = 0) {
	tin[v] = t++;
	pr[v] = last;
	lvl[v] = cur_d;
	sz[v] = 1;
	for (int u : g[v]) {
		if (u != last) {
			sz[v] += dfs(u, v, cur_d + 1);
		}
	}
	tout[v] = t++;
	return sz[v];
}

bool in(int v, int u) {
	return tin[v] >= tin[u] && tout[v] <= tout[u];
}

vector<int> ng[N], rng[N];

int ans[N];

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	int t;
	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; ++i) {
		int v, u;
		cin >> v >> u;
		--v, --u;
		g[v].push_back(u);
		g[u].push_back(v);
	}
	dfs(0);
	for (int i = 0; i < m; ++i) {
		int v, u;
		cin >> v >> u;
		--v, --u;
		while (!in(u, v)) {
			ng[v].push_back(pr[v]);
			rng[pr[v]].push_back(v);
			v = pr[v];
		}
		while (u != v) {
			ng[pr[u]].push_back(pr[u]);
			rng[u].push_back(pr[u]);
			u = pr[u];
		}
	}
	queue<int> q;
	fill(ans, ans + n, 1);
	for (int v = 0; v < n; ++v) {
		if (rng[v].empty()) {
			q.push(v);
		}
	}
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		for (int u : ng[v]) {
			rng[u].pop_back();
			if (rng[u].empty()) {
				q.push(u);
			}
			ans[u] = max(ans[u], ans[v] + 1);
		}
	}
	int mx = 0;
	for (int v = 0; v < n; ++v) {
		if (ans[v] == 0) {
			ans[v] = 1;
		}
		mx = max(mx, ans[v]);
	}
	cout << mx << '\n';
	for (int v = 0; v < n; ++v) {
		cout << ans[v] << ' ';
	}
	cout << '\n';
	return 0;
}