#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <limits>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <tuple>
#include <complex>

using namespace std;

//#define int ll
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#ifdef LOCAL
#define debug(x) cerr << #x << " = " << (x) << endl
#else
#define debug(x) 0
#endif

template <typename T = int>
T input() {
    T res;
    cin >> res;
    return res;
}

constexpr int N = 5e5 + 1543;
vector<int> g[N];
int dep[N], et[2 * N], ls[N], col[N], iter = 0;
int a[N], b[N], lca[N];
pii tr[4 * N], val[2 * N];

void dfs(int v, int p) {
    ls[v] = iter;
    et[iter++] = v;
    for (int u : g[v]) {
        if (u != p) {
            dep[u] = dep[v] + 1;
            dfs(u, v);
            et[iter++] = v;
        }
    }
}


pii calc(int v, int p) {
    pii cur = val[v], tmp;
    int cnt = bool(val[v].second);
    for (int u : g[v]) {
        if (u != p && (tmp = calc(u, v)).second) {
            ++cnt;
            cur = {tmp.first + tmp.second, tmp.second};
        }
    }
    col[v] = cur.first;
    assert(cnt <= 2);
    if (cnt == 1) {
        return cur;
    }
    return {0, 0};
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int n = input(), m = input(), t = input();
    for (int i = 1; i < n; ++i) {
        int v = input() - 1;
        int u = input() - 1;
        g[v].emplace_back(u);
        g[u].emplace_back(v);
    }
    dfs(0, -1);
    for (int i = 0; i < 2 * N; ++i) {
        tr[2 * N + i] = {dep[et[i]], et[i]};
    }
    for (int i = 2 * N - 1; i > 0; --i) {
        tr[i] = min(tr[2 * i], tr[2 * i + 1]);
    }
    for (int i = 0; i < m; ++i) {
        a[i] = input() - 1;
        b[i] = input() - 1;
        int l = min(ls[a[i]], ls[b[i]]);
        int r = max(ls[a[i]], ls[b[i]]) + 1;
        pii res = {1e9, 1};
        for (l += 2 * N, r += 2 * N; l < r; l /= 2, r /= 2) {
            if (l % 2) {
                res = min(res, tr[l++]);
            }
            if (r % 2) {
                res = min(res, tr[--r]);
            }
        }
        lca[i] = res.second;
//        cerr << a[i] << ' ' << b[i] << endl;
//        cerr << lca[i] << endl;
        val[a[i]] = {1, 1};
        val[b[i]] = {dep[a[i]] + dep[b[i]] - 2 * dep[lca[i]] + 1, -1};
    }
    calc(0, -1);

    cout << *max_element(col, col + n) << endl;
    for (int i = 0; i < n; ++i) {
        cout << (col[i] ? col[i] : 1) << ' ';
    }
    cout << endl;
}
