#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 30;
const int lg = 20;
const int inf = 1e9 + 7;

int n, m, abacaba;
vector <int> g[N];
int par[N][lg];
int go[N];
int timer = 0;
int tin[N], tout[N];
int val[N];
vector <vector <int> > path;
bool used[N];

void dfs(int v, int pr) {
  go[v] = pr;
  tin[v] = timer++;
  par[v][0] = pr;
  for (int i = 1; i < lg; i++) {
    par[v][i] = par[par[v][i - 1]][i - 1];
  }
  for (int to : g[v]) {
    if (to != pr) {
      dfs(to, v);
    }
  }
  tout[v] = timer++;
}

bool upper(int a, int b) {
  return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
   if (upper(a, b)) return a;
   if (upper(b, a)) return b;
   for (int i = lg - 1; i >= 0; i--) {
      if (upper(par[a][i], b)) {
        a = par[a][i];
      }
   }
   return a;
}

map <pair <int, int>, int> id;

int get_id(int a, int b) {
  if (a > b) swap(a, b);
  return id[{a, b}];
}

vector <int> kek[N];
bool added[N];
int color[N];
vector <int> psg[N];

bool cycle(int v) {
  color[v] = 1;
  for (int to : psg[v]) {
    if (color[to] == 0) {
      if (cycle(to)) {
        return true;
      }
    } else if (color[to] == 1) {
      return true;
    }
  }
  color[v] = 2;
  return false;
}

vector <int> ord;

void topsort(int v) {
  if (used[v]) return;
  used[v] = true;
  for (int to : psg[v]) {
    topsort(to);
  }
  ord.push_back(v);
}

int main() {
  ios::sync_with_stdio(0);
  cin.tie(0);
  cin >> n >> m >> abacaba;
  int index = 0;
  for (int i = 0; i < n - 1; i++) {
    int u, v;
    cin >> u >> v;
    if (u > v) swap(u, v);
    id[{u, v}] = index++;
    g[u].push_back(v);
    g[v].push_back(u);
  }
  dfs(1, 1);
  vector <pair <int, int> > wt;
  for (int i = 0; i < m; i++) {
    int a, b;
    cin >> a >> b;
    wt.push_back({a, b});
    vector <int> l_path, r_path;
    int x1 = a;
    int l = lca(a, b);
    while (x1 != l) {
      l_path.push_back(x1);
      x1 = go[x1];
    }
    int x2 = b;
    while (x2 != l) {
      r_path.push_back(x2);
      x2 = go[x2];
    }
    vector <int> way;
    for (int to : l_path) {
      way.push_back(to);
    }
    way.push_back(l);
    reverse(r_path.begin(), r_path.end());
    for (int to : r_path) {
      way.push_back(to);
    }
    path.push_back(way);
  }
  bool pdr = false;
  int mn = inf;
  for (int msk = 0; msk < (1 << m); msk++) {
    for (int i = 0; i < 20; i++) {
      psg[i].clear();
    }
    map <pair <int, int>, int> have;
    for (int i = 0; i < m; i++) {
      if (msk >> i & 1) {
        for (int j = 0; j + 1 < path[i].size(); j++) {
          int a = path[i][j], b = path[i][j + 1];
          if (have[{a, b}]) {
            continue;
          }
          have[{a, b}] = true;
          psg[a].push_back(b);
        }
      } else {
        for (int j = (int) path[i].size() - 1; j > 0; j--) {
          int a = path[i][j], b = path[i][j - 1];
          if (have[{a, b}]) {
            continue;
          }
          have[{a, b}] = true;
          psg[a].push_back(b);
        }
      }
    }
    bool bad = false;
    for (int i = 1; i <= n; i++) color[i] = 0;
    for (int i = 1; i <= n; i++) {
      if (cycle(i)) bad = true;
    }
    if (bad) continue;
    ord.clear();
    memset(used, 0, sizeof used);
    for (int i = 1; i <= n; i++) {
      if (!used[i]) topsort(i);
    }
    reverse(ord.begin(), ord.end());
    vector <int> nw_val(n + 7, 0);
    for (int i = 0; i < ord.size(); i++) {
      int v = ord[i];
      if (!nw_val[v]) nw_val[v] = 1;
      for (int to : psg[v]) {
        nw_val[to] = max(nw_val[to], nw_val[v] + 1);
      }
    }
    pdr = true;
    int cur_mx = 1;
    for (int i = 1; i <= n; i++) {
      cur_mx = max(cur_mx, nw_val[i]);
    }
    if (cur_mx < mn) {
      mn = cur_mx;
      for (int i = 1; i <= n; i++) {
        val[i] = nw_val[i];
      }
    }
  }
  if (!pdr) {
    cout << -1 << endl;
    return 0;
  }
  int mx = 1;
  for (int i = 1; i <= n; i++) {
    mx = max(mx, val[i]);
  }
  cout << mx << endl;
  if (abacaba) {
    for (int i = 1; i <= n; i++) {
      if (!val[i]) cout << 1 << ' ';
      else cout << val[i] << ' ';
    }
    cout << endl;
  }
  return 0;
}
