#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <numeric>
#include <map>
#include <tuple>
#include <deque>
#include <chrono>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef int ll;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> os_set;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll n, m, t;
    cin >> n >> m >> t;
    vector<vector<ll>> adj(n);
    vector<pair<ll, ll>> edges(n - 1);
    for (ll i = 0; i < n - 1; i++) {
        ll u, v;
        cin >> u >> v;
        u--, v--;
        adj[u].push_back(v);
        adj[v].push_back(u);
        edges[i] = {min(u, v), max(u, v)};
    }
    vector<pair<ll, ll>> branch(m);
    for (ll i = 0; i < m; i++) {
        cin >> branch[i].first >> branch[i].second;
        branch[i].first--, branch[i].second--;
        if (branch[i].first > branch[i].second) {
            swap(branch[i].first, branch[i].second);
        }
    }
    vector<ll> b;
    if (n <= 8 && m <= 8) {
        vector<vector<ll>> c(m);
        for (ll i = 0; i < m; i++) {
            vector<ll> stack;
            function<bool(ll, ll, ll)> visit_second = [&](ll u, ll v, ll d) {
                stack.push_back(v);
                if (v == d) {
                    return true;
                }
                for (ll w : adj[v]) {
                    if (w != u) {
                        if (visit_second(v, w, d)) {
                            return true;
                        }
                    }
                }
                stack.pop_back();
                return false;
            };
            visit_second(-1, branch[i].first, branch[i].second);
            c[i] = stack;
        }
        for (ll i = 0; i < (ll) pow(n, n); i++) {
            vector<ll> a(n);
            for (ll j = 0, k = i; j < n; j++, k /= n) {
                a[j] = k % n + 1;
            }
            bool f = false;
            for (ll i = 0; i < m; i++) {
                bool x = true, y = true;
                for (ll j = 0; j < (ll) c[i].size() - 1; j++) {
                    if (a[c[i][j + 1]] >= a[c[i][j]]) {
                        x = false;
                    }
                    if (a[c[i][j + 1]] <= a[c[i][j]]) {
                        y = false;
                    }
                }
                if (!x && !y) {
                    f = true;
                }
            }
            if (!f) {
                if (b.empty() || *max_element(a.begin(), a.end()) < *max_element(b.begin(), b.end())) {
                    b = a;
                }
            }
        }
    } else {
        ll root = edges[0].first == edges[1].first ? edges[0].first : edges[0].second;
        vector<ll> freq(n);
        for (ll i = 0; i < m; i++) {
            freq[branch[i].first]++;
            freq[branch[i].second]++;
        }
        for (ll i = 0; i < n; i++) {
            if (freq[i] == m) {
                root = i;
            }
        }
        set<ll> s;
        for (ll i = 0; i < m; i++) {
            s.insert(branch[i].first);
            s.insert(branch[i].second);
        }
        vector<ll> a(n, 1);
        function<bool(ll, ll, ll)> visit_first = [&](ll u, ll v, ll d) {
            bool o = s.find(v) != s.end();
            for (ll w : adj[v]) {
                if (w != u) {
                    o |= visit_first(v, w, d + 1);
                }
            }
            if (o) {
                a[v] = d;
            }
            return o;
        };
        visit_first(-1, root, 1);
        b = a;
    }
    if (b.empty()) {
        cout << -1 << endl;
    } else {
        cout << *max_element(b.begin(), b.end()) << endl;
        for (ll i : b) {
            cout << i << " ";
        }
        cout << endl;
    }
    return 0;
}
