#pragma region Include
#include<algorithm>
#include<iostream>
#include<assert.h>
#include<utility>
#include<fstream>
#include<vector>
#include<random>
#include<map>
#include <cassert>
using namespace std;
#pragma endregion
#pragma region Constant
const int N = 5e5, INF = 1e9, MOD = 1e9 + 21, P = 31;
const long long llINF = 1e18;
#pragma endregion
#pragma region IO
template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
	for (T& el : vec) {
		in >> el;
	}
	return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> const& vec) {
	for (T const& el : vec) {
		out << el << ' ';
	}
	return out;
}

template<typename T, typename P>
istream& operator >> (istream& in, pair<T, P>& p) {
	in >> p.first >> p.second;
	return in;
}

template<typename T, typename P>
ostream& operator << (ostream& out, pair<T, P> const& p) {
	out << p.first << ' ' << p.second;
}
#pragma endregion

vector<int> g[20];
int par[20], d[20];

void dfs_precalc(int v, int p) {
	d[v] = d[p] + 1;
	par[v] = p;

	for (int u : g[v]) {
		if (u != p) {
			dfs_precalc(u, v);
		}
	}
}

vector<int> get_path(int v, int u) {
	vector<int> path_v, path_u;
	while (v != u) {
		if (d[v] >= d[u]) {
			path_v.push_back(v);
			v = par[v];
		} else {
			path_u.push_back(u);
			u = par[u];
		}
	}
	
	path_v.push_back(v);
	reverse(path_u.begin(), path_u.end());

	for (int i : path_u) {
		path_v.push_back(i);
	}
	return path_v;
}

bool dfs_calc_ans(int v, vector<int>& used, vector<int>& res, vector<vector<int>> const& gr) {
	res[v] = 1;
	used[v] = 1;

	for (int u : gr[v]) {
		if (used[u] == 1) {
			return false;
		}

		if (used[u] == 0) {
			if (!dfs_calc_ans(u, used, res, gr)) {
				return false;
			}
		}
		res[v] = max(res[v], res[u] + 1);
	}

	used[v] = 2;
	return true;
}

int main() {
	int n, m, t;
	cin >> n >> m >> t;

	for (int i = 1, v, u; i < n; i++) {
		cin >> v >> u;
		g[v].push_back(u);
		g[u].push_back(v);
	}

	dfs_precalc(1, 0);

	vector<vector<int>> path(m);
	for (int i = 0, v, u; i < m; i++) {
		cin >> v >> u;
		path[i] = get_path(v, u);
	}

	int best_res = INF;
	vector<int> res_fin;

	for (int i = 0; i < (1ll << m); i++) {
		vector<vector<int>> g_or(n + 1);
		vector<int> res(n + 1), used(n + 1);
		vector<char> src(n + 1, true);
		for (int p = 0; p < m; p++) {
			if (1 & (i >> p)) {
				for (int j = 0; j + 1 < path[p].size(); j++) {
					g_or[path[p][j]].push_back(path[p][j + 1]);
					src[path[p][j + 1]] = false;
				}
			} else {
				for (int j = 1; j < path[p].size(); j++) {
					g_or[path[p][j]].push_back(path[p][j - 1]);
					src[path[p][j - 1]] = false;
				}
			}
		}

		bool flag = false;
		for (int v = 1; v <= n; v++) {
			if (used[v] == 0 && src[v]) {
				if (!dfs_calc_ans(v, used, res, g_or)) {
					flag = false;
					break;
				}
				flag = true;
			}
		}

		for (int u = 1; u <= n; u++) {
			if (used[u] != 2) {
				flag = false;
			}
		}

		if (flag) {
			int cur = *max_element(res.begin(), res.end());
			if (cur < best_res) {
				best_res = cur;
				res_fin = res;
			}
		}
	}

	if (best_res == INF) {
		cout << "-1\n";
	} else {
		cout << best_res << '\n';
		if (t == 1) {
			for (int i = 1; i <= n; i++) {
				assert(res_fin[i] != 0);
				cout << res_fin[i] << ' ';
			}
			cout << '\n';
		}
	}
}

/*
7 2 1
1 2
2 3
3 4
5 2
2 6
6 7
1 4
5 7
*/