#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#pragma GCC optimize("Ofast")
#include <map>
#include <vector>
#include <algorithm>
#include <time.h>
#include <set>
#include <math.h>
#include <assert.h>
#include <numeric>
#include <random>
#include <queue>
using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
#define size(x) (ll)x.size()
#define chkmax(x, y) x = max(x, y)

const int N = 1e5 + 1;
vector<int> g[N], goes[N];
int n, m, t;

int tin[N], tout[N], dth[N], par[N];
int timer = 0;

void dfs(int v, int p) {
  dth[v] = dth[p] + 1;
  tin[v] = timer++;
  for(int to : g[v]) {
    if (to != p) {
      dfs(to, v);
      par[to] = v;
    }
  }
  tout[v] = timer;
}

bool is_anc(int a, int b) {
  return tin[a] <= tin[b] && tout[b] <= tout[a];
}

vector<int> get_path(int a, int b) {
  vector<int> path;
  if (is_anc(a, b)) {
    while (b != a) {
      path.push_back(b);
      b = par[b];
    }
    path.push_back(a);
    reverse(all(path));
  } else if (is_anc(b, a)) {
    while (a != b) {
      path.push_back(a);
      a = par[a];
    }
    path.push_back(b);
  } else {
    vector<int> l, r;
    while (dth[a] > dth[b]) {
      l.push_back(a);
      a = par[a];
    }
    while (dth[b] > dth[a]) {
      r.push_back(b);
      b = par[b];
    }
    while (a != b) {
      l.push_back(a);
      r.push_back(b);
      a = par[a], b = par[b];
    }
    l.push_back(a);
    reverse(all(r));
    for(int x : r) l.push_back(x);
    path = l;
  }
  return path;
}

int qa[N], qb[N], qc[N];
int c[N], used[N];
vector<int> ans;
int score = 1e9;

vector<int> path;

void put(int v, int val) {
  if (c[v] == val) return;
  c[v] = val;
  for(int x : goes[v]) {
    if (c[v] >= c[x])
      put(x, c[v] + 1);
  }
}

void push(int pos, int z) {
  if (pos == size(path)) return;
  int v = path[pos];
  put(v, max(c[v], z));
  if (pos + 1 < size(path))
    goes[v].push_back(path[pos + 1]);
  push(pos + 1, c[v] + 1);
}

inline void build(int x) {
  if (qc[x]) path = get_path(qa[x], qb[x]);
  else path = get_path(qb[x], qa[x]);
}

int de = clock();
int dx[101][101];

bool check(int t) {
  build(t);
  for(int i = 0; i < size(path); i++) {
    for(int j = i + 1; j < size(path); j++) {
      int x = path[i];
      int y = path[j];
      if (dx[x][y] == 1) return 0;
    }
  }
  for(int i = 0; i < size(path); i++) {
    for(int j = i + 1; j < size(path); j++) {
      int x = path[i];
      int y = path[j];
      dx[x][y] = 0;
      dx[y][x] = 1;
    }
  }

  return 1;
}



bool check() {
  for(int i = 0; i < m; i++) {
    build(i);
    for(int i = 0; i + 1 < size(path); i++) {
      if (c[path[i]] >= c[path[i + 1]]) return 0;
    }
  }
  return 1;
}

mt19937 gen;

void run() {
  cin >> n >> m >> t;
  fill(c, c + N, 0);
  for(int i = 0; i < n - 1; i++){
    int a, b;
    cin >> a >> b;
    --a; --b;
    g[a].push_back(b);
    g[b].push_back(a);
  }
  dfs(0, 0);
  for(int i = 0; i < m; i++){
    cin >> qa[i] >> qb[i];
    --qa[i]; --qb[i];
  }
  ans.resize(n);
  while ((clock() - de) / double(CLOCKS_PER_SEC) <= 2) {
    bool fl = 1;
    for(int i = 0; i < n; i++){
      for(int j = 0; j < n; j++) {
        dx[i][j] = -1;
      }
    }
    vector<int> kek(m);
    iota(all(kek), 0);
    shuffle(all(kek), gen);
    for(int j : kek) {
      qc[j] = gen() % 2;
      if (!check(j))
        qc[j] ^= 1;
      if (!check(j)) {
        fl = 0;
        break;
      }
    }
    if (!fl) continue;
    vector<int> ord(m);
    iota(all(ord), 0);
    for(int tt = 0; tt < 5; tt++) {
      for(int i = 0; i < n; i++) {
        c[i] = 1;
        goes[i].clear();
      }
      shuffle(all(ord), gen);
      for(int i : ord) {
        build(i);
        push(0, 1);
      }
      if (check()) {
        if (*max_element(c, c + n) < score) {
          score = *max_element(c, c + n);
          for(int i = 0; i < n; i++) {
            ans[i] = c[i];
          }
        }
      }
    }
  }
  if (score == 1e9) {
    cout << -1;
    return;
  }
  cout << score << '\n';
  for(int x : ans) {
    cout << x << ' ';
  }
}

int main()
{
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
  ios::sync_with_stdio(0);
  cin.tie(0);
// gene();

  run();
}
