#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>
#include <queue>
#include <set>
#include <map>
#include <cassert>
#include <unordered_set>
#include <unordered_map>
#include <string>
#include <stack>

#define ll long long
#define ld long double
#define int ll
#define files(in, out) freopen(in, "r", stdin); freopen(out, "w", stdout)
#define pii pair<int, int>
#define ff first
#define ss second
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define rep(i, n) for (int i = 0; i < (n); ++i)

using namespace std;

const int max_n = 5e5 + 5;

vector<vector<int>> g, g_or;
vector<int> path, dfs_path;

void path_build(int v, int f, int p = -1) {
    dfs_path.pb(v);
    if (v == f) {
        path = dfs_path;
        return;
    }
    for (int to : g[v]) {
        if (to == p) continue;
        path_build(to, f, v);
    }
    dfs_path.pop_back();
}

vector<int> h;
vector<bool> used;
vector<int> order;

void top_sort(int v) {
    used[v] = 1;
    for (int to : g_or[v]) {
        if (used[to]) continue;
        top_sort(to);
    }
    order.pb(v);
}

int mx = 1;

void h_calc(int v) {
    used[v] = 1;
    for (int to : g_or[v]) {
        h[to] = max(h[v] + 1, h[to]);
        mx = max(mx, h[to]);
        if (used[to]) continue;
        h_calc(to);
    }
}

int get_bit(int mask, int pos) {
    return (mask & (1 << pos)) != 0;
}

/*
8 3 1
1 2
2 3
2 4
2 5
1 6
6 7
6 8
1 5
4 8
3 5
*/

void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    g.resize(n);
    vector<pii> edg;
    rep(i, n - 1) {
        int v, to;
        cin >> v >> to;
        v--;
        to--;
        g[v].pb(to);
        g[to].pb(v);
    }
    rep(i, m) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        edg.pb({ a, b });
    }
    int ans = 1e9;
    vector<int> res;
    for (int mask = 0; mask < (1 << m); ++mask) {
        bool flag = true;
        set<pii> setik;
        g_or.clear();
        g_or.resize(n);
        h.assign(n, 1);
        mx = 1;
        rep(i, m) {
            int a = edg[i].ff, b = edg[i].ss;
            if (get_bit(mask, i)) swap(a, b);
            path.clear();
            dfs_path.clear();
            path_build(a, b);
            rep(j, ((int)path.size() - 1)) {
                int v = path[j];
                int to = path[j + 1];
                if (setik.count({ to, v }) != 0) {
                    flag = false;
                    break;
                }
                if (setik.count({ v, to }) == 0) {
                    setik.insert({ v, to });
                    g_or[v].pb(to);
                }
                h[v] = max(h[v], j + 1);
                h[to] = max(h[to], j + 2);
                if (j > 0) h[v] = max(h[v], h[path[j - 1]] + 1);
                h[to] = max(h[to], h[v] + 1);
                mx = max(mx, h[v]);
                mx = max(mx, h[to]);
            }
            if (!flag) break;
        }
        if (!flag) continue;

        if (mx < ans) {
            ans = mx;
            res = h;
        }
    }
    if (ans == 1e9) {
        cout << -1;
        return;
    }
    cout << ans << endl;
    for (int x : res) {
        cout << x << ' ';
    }
}

signed main() {
    //files("input.txt", "output.txt");
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}