#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

int tt = 1;
vector<int> tin, tout, anc;

void dfs(int v, const vector<vector<int> > &g) {
    tin[v] = tt++;
    for (auto u : g[v]) {
        if (!tin[u]) {
            dfs(u, g);
            anc[u] = v;
        }
    }
    tout[v] = tt++;
    return;
}

const int INF = 1e9;

bool check(int u, int v) {
    if (tin[u] <= tin[v] && tout[v] <= tout[u]) {
        return true;
    }
    return false;
}

bool dfs1(int v, const vector<vector<int> > &g, vector<int> &used, vector<int> &ans) {
    used[v] = 1;
    ans[v] = 1;
    for (auto u : g[v]) {
        if (used[u] == 1) {
            return false;
        }
        if (used[u] != 2) {
            if (!dfs1(u, g, used, ans)) {
                return false;
            }
        }
        ans[v] = max(ans[v], ans[u] + 1);
    }
    used[v] = 2;
    return true;
}

bool dfs2(int v, const vector<vector<int> > &g, vector<int> &col, int c) {
    col[v] = c;
    for (auto u : g[v]) {
        if (col[u] == c) {
            return false;
        }
        if (!col[u]) {
            if (!dfs2(u, g, col, 3 - c)) {
                return false;
            }
        }
    }
    return true;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    int n, m, t;
    cin >> n >> m >> t;
    tin.resize(n + 1);
    tout.resize(n + 1);
    anc.resize(n + 1, -1);
    vector<vector<int> > g(n + 1);
    vector<int> kol(n + 1);
    for (int i = 1; i < n; i++) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        g[v].push_back(u);
        kol[u]++;
        kol[v]++;
    }
    vector<pair<int, int> > ed(m);
    for (int i = 0; i < m; i++) {
        cin >> ed[i].first >> ed[i].second;
    }
    int beg = 0;
    for (int i = 1; i <= n; i++) {
        if (kol[i] == n - 1) {
            beg = i;
        }
    }
    /*if (beg) {
        vector<int> tmp(n + 1, -1);
        vector<vector<int> > gg(n + 1);
        for (int i = 0; i < m; i++) {
            if (ed[i].first != beg && ed[i].second != beg) {
                gg[ed[i].first].push_back(ed[i].second);
                gg[ed[i].second].push_back(ed[i].first);
            }
        }
        vector<int> col(n + 1);
        for (int i = 1; i <= n; i++) {
            if (i != beg && !col[i]) {
                if (!dfs2(i, gg, col, 1)) {
                    cout << -1;
                    return 0;
                }
            }
        }
        vector<vector<int> > ggg(n + 1);
        for (int i = 1; i <= n; i++) {
            if (i != beg) {
                if (col[i] == 1) {
                    ggg[i].push_back(beg);
                } else {
                    ggg[beg].push_back(i);
                }
            }
        }
        vector<int> used(n + 1), ans(n + 1, 1);
        for (int i = 1; i <= n; i++) {
            if (!used[i]) {
                if (!dfs1(i, ggg, used, ans)) {
                    cout << -1;
                    return 0;
                }
            }
        }
        int cost = 0;
        for (int i = 1; i <= n; i++) {
            cost = max(cost, ans[i]);
        }
        cout << cost << '\n';
        for (int i = 1; i <= n; i++) {
            cout << ans[i] << ' ';
        }
        return 0;
    }*/
    int cost = INF;
    vector<int> ans(n + 1, 1);
    dfs(1, g);
    if (n <= 100 && m <= 100) {
        vector<vector<int> > go(m);
        for (int i = 0; i < m; i++) {
            int u = ed[i].first, v = ed[i].second;
            go[i].push_back(u);
            while (!check(u, v)) {
                u = anc[u];
                go[i].push_back(u);
            }
            stack<int> st;
            while (!check(v, u)) {
                st.push(v);
                v = anc[v];
            }
            while (!st.empty()) {
                go[i].push_back(st.top());
                st.pop();
            }
        }
        vector<int> used_ed(m);
        vector<vector<int> > matr(n + 1);
        for (int i = 0; i <= n; i++) {
            matr[i].resize(n + 1);
        }
        while (true) {
            bool flag = false;
            for (int i = 0; i < m; i++) {
                if (!used_ed[i]) {
                    int sz = go[i].size();
                    int f = 0;
                    for (int j = 0; j + 1 < sz; j++) {
                        if (matr[go[i][j]][go[i][j + 1]] && f == 2) {
                            cout << -1;
                            return 0;
                        }
                        if (matr[go[i][j + 1]][go[i][j]] && f == 1) {
                            cout << -1;
                            return 0;
                        }
                        if (matr[go[i][j]][go[i][j + 1]]) {
                            f = 1;
                        }
                        if (matr[go[i][j + 1]][go[i][j]]) {
                            f = 2;
                        }
                    }
                    if (f) {
                        for (int j = 0; j + 1 < sz; j++) {
                            if (f == 1) {
                                matr[go[i][j]][go[i][j + 1]] = 1;
                            } else {
                                matr[go[i][j + 1]][go[i][j]] = 1;
                            }
                        }
                        flag = true;
                        used_ed[i] = 1;
                    }
                }
            }
            if (!flag) {
                for (int i = 0; i < m; i++) {
                    if (!used_ed[i]) {
                        used_ed[i] = 1;
                        flag = true;
                        int sz = go[i].size();
                        for (int j = 0; j + 1 < sz; j++) {
                            matr[go[i][j]][go[i][j + 1]] = 1;
                        }
                        break;
                    }
                }
                if (!flag) {
                    vector<vector<int> > gg(n + 1);
                    for (int i = 1; i <= n; i++) {
                        for (int j = 1; j <= n; j++) {
                            if (matr[i][j]) {
                                gg[i].push_back(j);
                            }
                        }
                    }
                    vector<int> tmp(n + 1), used(n + 1);
                    for (int k = 1; k <= n; k++) {
                        if (!used[k]) {
                            if (!dfs1(k, gg, used, tmp)) {
                                cout << -1;
                                return 0;
                            }
                        }
                    }
                    int cost = 0;
                    for (int i = 1; i <= n; i++) {
                        cost = max(cost, tmp[i]);
                    }
                    cout << cost << '\n';
                    for (int i = 1; i <= n; i++) {
                        cout << tmp[i] << ' ';
                    }
                    return 0;
                }
            }
        }
        /*for (int i = 0; i < (1 << m); i++) {
            vector<vector<int> > gg(n + 1);
            for (int j = 0; j < m; j++) {
                if (i & (1 << j)) {
                    int u = ed[j].first, v = ed[j].second;
                    while (!check(u, v)) {
                        gg[anc[u]].push_back(u);
                        u = anc[u];
                    }
                    while (!check(v, u)) {
                        gg[v].push_back(anc[v]);
                        v = anc[v];
                    }
                } else {
                    int v = ed[j].first, u = ed[j].second;
                    while (!check(u, v)) {
                        gg[anc[u]].push_back(u);
                        u = anc[u];
                    }
                    while (!check(v, u)) {
                        gg[v].push_back(anc[v]);
                        v = anc[v];
                    }
                }
            }
            vector<int> tmp(n + 1), used(n + 1);
            bool flag = true;
            for (int k = 1; k <= n; k++) {
                if (!used[k]) {
                    if (!dfs1(k, gg, used, tmp)) {
                        flag = false;
                        break;
                    }
                }
            }
            if (flag) {
                int mx = 0;
                for (int k = 1; k <= n; k++) {
                    mx = max(mx, tmp[k]);
                }
                if (mx < cost) {
                    cost = mx;
                    for (int k = 1; k <= n; k++) {
                        ans[k] = tmp[k];
                    }
                }
            }
        }*/
    }
    if (cost == INF) {
        cout << -1;
    } else {
        cout << cost << '\n';
        for (int i = 1; i <= n; i++) {
            cout << ans[i] << ' ';
        }
    }
    return 0;
}
