#include<bits/stdc++.h>
using namespace std;

#define ll long long
#define all(aaa) aaa.begin(), aaa.end()

const int N = 5e5 + 5, L = 20;
vector<int> g[N], g2[N];
vector<pair<int, int>> g3[N];

int pt[N], ord[N], used[N], num[N], res[N], 
	bg[N], en[N], par[N][L], tin[N], tout[N], col[N], w[N];
int len = 0, ord_len = 0, timer;
vector<pair<int, int>> add[N], del[N];
set<int> *st[N][2];
int ct[N][2];
int mx;

int n, m, t;

void dfs(int node, int anc, int fin) {
	pt[len++] = node;
	if (node == fin) {
		for (int i = 0; i < len - 1; i++) {
			g2[pt[i]].push_back(pt[i + 1]);
		}
	}
	for (int to : g[node]) {
		if (to != anc) {
			dfs(to, node, fin);
		}
	}
	len--;
}

bool walk(int node) {
	used[node] = 1;
	for (int to : g2[node]) {
		if (!used[to]) {
			if (walk(to))
				return true;
		}
		else if (used[to] == 1) {
			return true;
		}
	}
	ord[ord_len++] = node;
	used[node] = 2;
	return false;
}

void dive(int node) {
	for (int i = 1; i < L; i++)
		par[node][i] = par[par[node][i - 1]][i - 1];
	tin[node] = ++timer;
	for (int to : g[node]) {
		if (!tin[to]) {
			par[to][0] = node;
			dive(to);
		}
	}
	tout[node] = timer;
}

bool upper(int a, int b) {
	return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int get_prelca(int a, int b) {
	if (upper(a, b))
		return -1;
	for (int i = L - 1; i >= 0; i--) {
		if (!upper(par[a][i], b))
			a = par[a][i];
	}
	return a;
}

int get_lca(int a, int b) {
	if (upper(a, b))
		return a;
	for (int i = L - 1; i >= 0; i--) {
		if (!upper(par[a][i], b))
			a = par[a][i];
	}
	return par[a][0];
}

void add_edge(int x, int y, int z) {
	// cout << x << " " << y << " " << z << "\n";
	g3[x].push_back({y, z});
	g3[y].push_back({x, z});
}

void runrun(int node) {
	st[node][0] = new set<int>();
	st[node][1] = new set<int>();

	for (int to : g[node]) {
		if (to != par[node][0]) {
			runrun(to);

			for (int i = 0; i < 2; i++) {
				if (!st[node][i]->empty() &&
					!st[to][i]->empty()) {
					add_edge(*(st[node][i]->begin()), *(st[to][i]->begin()), 0);
				}
				if (!st[node][i]->empty() &&
					!st[to][i ^ 1]->empty()) {
					add_edge(*(st[node][i]->begin()), *(st[to][i]->begin()), 1);
				}
			}

			for (int i = 0; i < 2; i++) {
				if (st[to][i]->size() > st[node][i]->size())
					swap(st[to][i], st[node][i]);
				st[node][i]->insert(st[to][i]->begin(), st[to][i]->end());
			}
		}
	}

	for (auto p : add[node]) {
		if (!st[node][p.first]->empty()) {
			add_edge(*(st[node][p.first]->begin()), p.second, 0);
		}
		if (!st[node][p.first ^ 1]->empty()) {
			add_edge(*(st[node][p.first ^ 1]->begin()), p.second, 1);
		}
		st[node][p.first]->insert(p.second);
	}
	for (auto p : del[node]) {
		st[node][p.first]->erase(p.second);
	}

	// cout << st[node][0]->size() << "\n";
}

bool dfs777(int node, int c) {
	col[node] = c;
	for (auto e : g3[node]) {
		if (col[e.first] == -1) {
			if (dfs777(e.first, c ^ e.second))
				return true;
		}
		else if (col[e.first] != (col[node] ^ e.second))
			return true;
	}
	return false;
}

void gfs007(int node) {
	for (int to : g[node]) {
		if (to != par[node][0]) {
			gfs007(to);
			ct[node][0] += ct[to][0];
			ct[node][1] += ct[to][1];
		}
	}
	if (ct[node][0]) {
		g2[node].push_back(par[node][0]);
	}
	else if (ct[node][1]) {
		g2[par[node][0]].push_back(node);
	}
}


bool find_ord() {
	ord_len = 0;
	fill(used, used + n, 0);
	bool impos = false;
	for (int j = 0; j < n; j++) {
		if (!used[j] && walk(j)) {
			impos = true;
			break;
		}
	}

	if (!impos) {
		for (int j = 0; j < ord_len; j++) {
			num[ord[j]] = 0;
			for (int to : g2[ord[j]]) {
				num[ord[j]] = max(num[ord[j]], num[to]);
				}
				num[ord[j]]++;
		}
		int cur = 0;
		for (int j = 0; j < n; j++) {
			cur = max(cur, num[j]);
		}
		if (cur < mx) {
			mx = cur;
			for (int j = 0; j < n; j++)
				res[j] = num[j];
		}
		return true;
	}
	return false;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	
	cin >> n >> m >> t;

	mx = n + 1;

	for (int i = 0; i < n - 1; i++) {
		int x, y;
		cin >> x >> y;
		x--, y--;
		g[x].push_back(y);
		g[y].push_back(x);
	}

	for (int i = 0; i < m; i++) {
		cin >> bg[i] >> en[i];
		bg[i]--;
		en[i]--;
	}

	
	if (t == 0) {
		dive(0);
		for (int i = 0; i < m; i++) {
			for (int j = 0; j < 2; j++) {
				int pre_lca = get_prelca(bg[i], en[i]);

				// cout << bg[i] + 1 << " " << en[i] + 1 << " " << pre_lca + 1 << "\n";

				if (pre_lca != -1) {
					add[bg[i]].push_back({j, i});
					del[pre_lca].push_back({j, i});
				}

				swap(bg[i], en[i]);
			}
			
		}
		runrun(0);
		fill(col, col + m, -1);

		for (int i = 0; i < m; i++) {
			if (col[i] == -1) {
				if (dfs777(i, 0)) {
					cout << -1;
					return 0;
				}
			}
		}

		for (int i = 0; i < m; i++) {
			if (col[i]) {
				swap(bg[i], en[i]);
			}

			int lca = get_lca(bg[i], en[i]);



			for (int j = 0; j < 2; j++) {
				ct[bg[i]][j]++;
				ct[lca][j]--;
				swap(bg[i], en[i]);
			}
		}

		gfs007(0);

		if (!find_ord()) {
			cout << -1;
			return 0;
		}

	}
	else {
		for (int i = 0; i < (1 << m); i++) {
			for (int j = 0; j < n; j++)
				g2[j].clear();

			for (int j = 0; j < m; j++) {
				if ((i >> j) & 1) {
					swap(bg[j], en[j]);
				}
				dfs(bg[j], -1, en[j]);
				if ((i >> j) & 1) {
					swap(bg[j], en[j]);
				}
			}

			if (find_ord())
				break;
		}
	}

	if (mx == n + 1) {
		cout << -1;
	}
	else {
		cout << mx << "\n";
		for (int i = 0; i < n; i++) {
			cout << res[i] << " ";
		}
	}


	return 0;
}