#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 5e5 + 7;

vector <int> g[N];

int par[N], tin[N], tout[N];

int timer = 0;

void dfs(int u, int p = -1) {
	tin[u] = timer++;
	par[u] = p;
	for (auto v : g[u]) {
		if (v != p) {
			dfs(v, u);
		}
	}
	tout[u] = timer++;
}

bool anc(int a, int b) {
	return tin[a] <= tin[b] && tout[b] <= tout[a];
}

vector <int> get_path(int a, int b) {
 	vector <int> pa, pb;
 	int ca = a;
 	while (!anc(ca, b)) {
 		pa.push_back(ca);
 		ca = par[ca];
 	}
 	int cb = b;
 	while (!anc(cb, a)) {
 		pb.push_back(cb);
 		cb = par[cb];
 	}
 	pb.push_back(cb);
 	reverse(pb.begin(), pb.end());
 	for (int x : pb) pa.push_back(x);
 	return pa;
}	

const int Inf = 1e9;

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);
	#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	#endif
	int n, m, t;
	cin >> n >> m >> t;
	for (int i = 0; i + 1 < n; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		g[u].push_back(v);
		g[v].push_back(u);
	}	
	dfs(0);
	vector <vector <int>> pt;   
	vector <vector <int>> who(n);
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		--a, --b;
		pt.push_back(get_path(a, b));
		for (auto x : pt.back()) who[x].push_back(i);
	}
	vector <int> ans;
	int best = Inf;
	for (int mask = 0; mask < (1 << m); ++mask) {
	 	vector <int> cur(n, -Inf);
	 	vector <int> used(m);
	 	queue <int> q;
	 	bool bad = false;
	 	while (true) {
	 		if (q.empty()) {
	 			bool ok = false;
	 			for (int i = 0; i < m; ++i) {
	 				if (!used[i]) {
	 					q.push(i);
	 					used[i] = true;
	 					ok = true;
	 					break;
	 				}
	 			}
	 			if (!ok) break;
	 			else continue; 	
	 		}
	 		if (bad) break;
	 		int id = q.front();
	 		q.pop();
	 		vector <int> p = pt[id];
	 		if (mask & (1 << id)) reverse(p.begin(), p.end());
	 		for (int i = 0; i + 1 < (int)p.size(); ++i) {
	 			if (cur[p[i]] != -Inf && cur[p[i + 1]] != -Inf) {
	 				if (cur[p[i]] + 1 != cur[p[i + 1]]) {
	 					bad = true;
	 					break;
	 				}	
	 			}
	 	 	}
	 	 	if (bad) break;
	 	 	bool fnd = false;
	 	 	for (int i = 0; i < (int)p.size(); ++i) {
	 	 		if (cur[p[i]] != -Inf) {
	 	 			fnd = true;
	 	 			for (int j = i + 1; j < (int)p.size(); ++j) {
	 	 				if (cur[p[j]] != -Inf && cur[p[j]] != cur[p[j - 1]] + 1) {
	 	 					bad = true;
	 	 					break;
	 	 				}	
	 	 				cur[p[j]] = cur[p[j - 1]] + 1;	
	 	 		 	}
	 	 		 	for (int j = i - 1; j >= 0; --j) {
	 	 		 		if (cur[p[j]] != -Inf && cur[p[j]] != cur[p[j + 1]] - 1) {
	 	 		 			bad = true;
	 	 		 			break;
	 	 		 		}
	 	 		 		cur[p[j]] = cur[p[j + 1]] - 1;
	 	 		 	}
	 	 		 	break;
	 	 		}
	 	 	}
	 	 	if (bad) break;
	 	 	if (!fnd) {
	 	 		for (int j = 0; j < (int)p.size(); ++j) {
	 	 			cur[p[j]] = j;
	 	 		}
	 	 	}
	 	 	for (int x : p) {
	 	 	 	for (int i : who[x]) {
	 	 	 		if (!used[i]) {
	 	 	 			used[i] = true;
	 	 	 			q.push(i);
	 	 	 		}
	 	 	 	}
	 	 	}
	 	}
	 	if (bad) continue;
	 	for (int i = 0; i < n; ++i) if (cur[i] == -Inf) cur[i] = 0;
	 	int mn = Inf;
	 	for (int i = 0; i < n; ++i) mn = min(mn, cur[i]);
	 	for (int i = 0; i < n; ++i) {
	 		cur[i] -= mn;
	 	}
	 	int res = -Inf;
	 	for (int i = 0; i < n; ++i) res = max(res, cur[i]);
	 	if (res < best) {
	 		best = res;
	 		ans = cur;
	 	}
	}
	if (best == Inf) {
		cout << "-1\n";
	} else {
		cout << best + 1 << '\n';
		for (int i = 0; i < n; ++i) cout << ans[i] + 1 << ' ';
		cout << '\n';
	}	
}