#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <queue>
#include <cstring>
#include <string>
using namespace std;

//#define int long long
#define fi first
#define se second
#define debug(x) cerr << #x << ": " << x << '\n';
#define pb push_back
#define mp make_pair
typedef long long ll;
typedef pair<int, int> pii;

void fast() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

const int N = 5e5 + 10;
int n, m, t;
vector<pii> g[N];
pii w[N];
vector<int> ww[N];
pii par[N];
int tEdge[N];
bool used[N];
int tin[N], tout[N];
int curt = 0;

void dfs(int v) {
    tin[v] = curt++;
    for (pii e : g[v]) {
        if (e.fi == par[v].fi) continue;
        par[e.fi] = mp(v, e.se);
        dfs(e.fi);
    }
    tout[v] = curt++;
}

bool isPar(int p, int v) {
    return tin[p] <= tin[v] && tout[p] >= tout[v];
}

bool used2[N];
int c[N];
vector<int> getW[N];
vector<int> ord;

void dfs2(int v) {
    used2[v] = true;
    for (auto e : g[v]) {
        if (((par[v].fi == e.fi) ^ (!tEdge[e.se])) && tEdge[e.se] != -1) {
            dfs2(e.fi);
        }
    }
    ord.push_back(v);
}

void solve() {
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        g[a].pb(mp(b, i));
        g[b].pb(mp(a, i));
    }
    for (int i = 0; i < m; i++) {
        cin >> w[i].fi >> w[i].se;
        w[i].fi--; w[i].se--;
    }
    par[0].fi = -1;
    dfs(0);
    memset(tEdge, -1, sizeof(tEdge));
    for (int i = 0; i < m; i++) {
        int ta = w[i].fi;
        int tb = w[i].se;
        while (!isPar(ta, tb)) {
            getW[par[ta].se].push_back(i);
            ta = par[ta].fi;
        }
        while (!isPar(tb, ta)) {
            getW[par[tb].se].push_back(i);
            tb = par[tb].fi;
        }
    }
    for (int i = 0; i < m; i++) {
        if (used[i]) continue;
        queue<int> q;
        q.push(i);
        used[i] = true;
        while (!q.empty()) {
            int j = q.front();
            q.pop();
            int ta = w[j].fi;
            int tb = w[j].se;
            int curt = -1;
            while (!isPar(ta, tb)) {
                if (tEdge[par[ta].se] != -1) {
                    if (curt == -1) curt = 1 - tEdge[par[ta].se];
                    if (curt == tEdge[par[ta].se]) {
                        cout << -1;
                        exit(0);
                    }
                }
                ta = par[ta].fi;
            }
            while (!isPar(tb, ta)) {
                if (tEdge[par[tb].se] != -1) {
                    if (curt == -1) curt = tEdge[par[tb].se];
                    if (curt != tEdge[par[tb].se]) {
                        cout << -1;
                        exit(0);
                    }
                }
                tb = par[tb].fi;
            }
            if (curt == -1) curt = 0;
            ta = w[j].fi;
            tb = w[j].se;
            while (!isPar(ta, tb)) {
                if (curt == 0) tEdge[par[ta].se] = 1;
                else tEdge[par[ta].se] = 0;
                for (auto i : getW[par[ta].se]) {
                    if (!used[i]) {
                        used[i] = true;
                        q.push(i);
                    }
                }
                ta = par[ta].fi;
            }
            while (!isPar(tb, ta)) {
                if (curt == 0) tEdge[par[tb].se] = 0;
                else tEdge[par[tb].se] = 1;
                for (auto i : getW[par[tb].se]) {
                    if (!used[i]) {
                        used[i] = true;
                        q.push(i);
                    }
                }
                tb = par[tb].fi;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (!used2[i]) dfs2(i);
    }
    int res = 1;
    for (int v : ord) {
        c[v] = 1;
        for (auto e : g[v]) {
            if ((par[v].fi == e.fi) ^ (!tEdge[e.se])) {
                c[v] = max(c[v], c[e.fi] + 1);
            }
        }
        res = max(res, c[v]);
    }
    cout << res << '\n';
    for (int i = 0; i < n; i++) cout << c[i] << ' ';
}

signed main() {
    fast();
    cin >> n >> m >> t;
    if (t == 0) {
        solve();
        return 0;
    }
    return 0;
}