#include <bits/stdc++.h>

//#pragma GCC optimize("O3")
//#pragma GCC target("sse,sse2,sse3,ssse3,popcnt,abm,mmx,avx")

using namespace std;

struct Edge {
    int v, u;
    bool is_reversed = false;

    Edge() : v(0), u(0) {};

    Edge(int a, int b) : v(a), u(b) {};
};

struct Test {
    int data;
    bool is_ans_unique = false;
    int expected_ans = -1;

    Test(int d, bool ans, int exp) : data(d), is_ans_unique(ans), expected_ans(exp) {};
};

const bool IS_LOCAL = true;
const bool IS_TESTING = false;

int n, m, t;
vector<Edge> edges;
vector<vector<Edge *>> graph;

vector<pair<int, int>> lines;

int solve() {
    return 0;
}

int npown() {
    int a = 1;
    for (int i = 0; i < n; ++i) {
        a *= n;
    }
    return a;
}

vector<vector<int>> routes;

vector<int> used;
int gen = 0;
vector<Edge *> path;

bool dfs(int v, int dest) {
    used[v] = gen;
    if (v == dest) {
        return true;
    }
    for (Edge *u : graph[v]) {
        if (!((u->v == v) ^ u->is_reversed)) continue;
        int uu = u->v + u->u - v;
        if (used[uu] == gen) continue;
        path.emplace_back(u);
        bool ans = dfs(uu, dest);
        if (ans) return true;
        path.pop_back();
    }
    return false;
}

vector<vector<int>> tempograph;
vector<int> pred;
vector<int> depths;

int dfs1(int from, int depth) {
    depths[from] = depth;
    int ans = depth;
    for (int u : tempograph[from]) {
        ans = max(ans, dfs1(u, depth + 1));
    }
    return ans;
}

pair<int, vector<int>> stupid() {
    vector<int> answer_numbers(n, -1);
    int minmax = 1'000'000'000;
    for (int i = 0; i < (1 << (n - 1)); ++i) {
        for (int j = 0; j < n - 1; ++j) {
            edges[j].is_reversed = (i & (1 << j)) != 0;
        }
        tempograph.clear();
        pred.clear();
        depths.clear();
        used.resize(n, 0);
        set<Edge *> included;
        bool ok = true;
        for (auto line : lines) {
            bool first = dfs(line.first, line.second);
            if (first) {
                for (auto e : path) {
                    included.insert(e);
                }
            }
            path.clear();
            gen++;
            bool second = dfs(line.second, line.first);
            if (second) {
                for (auto e : path) {
                    included.insert(e);
                }
            }
            path.clear();
            if (! (first || second)) {
                ok = false;
                break;
            }
            gen++;
        }
        if (!ok) {
            continue;
        }
        tempograph.resize(n);
        pred.resize(n, -1);
        for (auto e : included) {
            if (!e->is_reversed) {
                tempograph[e->v].emplace_back(e->u);
                pred[e->u] = e->v;
            } else {
                tempograph[e->u].emplace_back(e->v);
                pred[e->v] = e->u;
            }
        }
        depths.resize(n, 1);
        int maxmax = 0;
        for (int j = 0; j < n; ++j) {
            if (pred[j] == -1) {
                maxmax = max(maxmax, dfs1(j, 1));
            }
        }
        if (maxmax < minmax) {
            minmax = maxmax;
            for (int ii = 0; ii < n; ++ii) {
                answer_numbers[ii] = depths[ii];
            }
        }
    }
    return {minmax, answer_numbers};
}

void gen_test() {

}

void read() {
    if (!IS_LOCAL) {
        cin.tie();
        cout.tie();
        iostream::sync_with_stdio(false);
    }
    cin >> n >> m >> t;
    graph.resize(n);
    lines.resize(m);
    edges.resize(n - 1);
    int cnt = 0;
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;

        edges[cnt] = Edge(a, b);
        graph[a].emplace_back(&edges[cnt]);
        graph[b].emplace_back(&edges[cnt]);
        cnt++;
    }
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        lines[i] = {a, b};
    }

}

bool check() {
    return false;
}

vector<Test> pretests = {};

bool check_pretests() {
    return true;
}

void precalc() {

}

int main() {
    precalc();
    if (IS_TESTING) {
        check_pretests();
    } else {
        read();
        auto ans = stupid();
        if (ans.first == 1'000'000'000) {
            cout << "-1\n";
        } else {
            cout << ans.first << '\n';
            for (auto e : ans.second) {
                cout << e << ' ';
            }
            cout << '\n';
        }
    }

}