#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <string>
#include <set>
#include <map>
#include <random>

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pa;
typedef pair<ll, ll> pall;
typedef pair<ld, ld> pald;

mt19937 rnd(228228);

void die() {
	int i = 0;
	while (true) {
		++i;
	}
}

struct go {
	int to, id;
};

const int N = 5e5, LG = 22;
int n, m, t, ans = 1;

int lca[N][LG];
vector<go> g[N];
int pS[N], szS[N], deep[N], parid[N], up[N];


int valans[N];
int used[N];
int mor[N];

map<int, vector<int>> ng[N];

void warp() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	for (int i = 0; i < N; ++i) {
		pS[i] = i, szS[i] = 1;
	}
}


void dfs(int v, int p) {
	if (p != -1) {
		lca[v][0] = p;
		for (int h = 1; h < LG; ++h) {
			lca[v][h] = lca[lca[v][h - 1]][h - 1];
		}
		deep[v] = deep[p] + 1;
		up[v] = p;
	}
	for (go e : g[v]) {
		if (e.to != p) {
			parid[e.to] = e.id;
			dfs(e.to, v);
		}
	}

}

vector<pa> arr;

int getlca(int v, int u) {
	if (deep[v] < deep[u])
		swap(v, u);
	for (int h = LG - 1; h >= 0; --h) {
		if (deep[lca[v][h]] >= deep[u])
			v = lca[v][h];
	}
	if (v == u)
		return v;
	for (int h = LG - 1; h >= 0; --h) {
		if (lca[v][h] != lca[u][h])
			v = lca[v][h], u = lca[u][h];
	}
	return lca[v][0];
}

void crass(int v, int u) {
	int p = getlca(v, u);

	int nw = 1;
	vector<int> used;
	while (v != p) {
		used.push_back(v);
		v = lca[v][0];
	}
	used.push_back(p);
	vector<int> nx;
	while (u != p) {
		nx.push_back(u);
		u = lca[u][0];
	}
	for (int i = nx.size() - 1; i >= 0; --i)
		used.push_back(nx[i]);

	for (int i = 0; i < used.size(); ++i)
		valans[used[i]] = i + 1;
}

void print() {
	int answer = 0;
	for (int i = 0; i < n; ++i) {
		if (valans[i] == 0)
			valans[i] = 1;
		answer = max(answer, valans[i]);
	}
	cout << answer << '\n';
	for (int i = 0; i < n; ++i) {
		cout << valans[i] << " ";
	}
}

signed main() {
	warp();

	cin >> n >> m >> t;
	for (int i = 1; i < n; ++i) {
		int u, v;
		cin >> u >> v;
		--u, --v;
		go FF = { u, i }, SS = { v, i };
		g[v].push_back(FF);
		g[u].push_back(SS);
	}

	dfs(0, -1);
	arr.resize(m);
	for (int i = 0; i < m; ++i) {
		cin >> arr[i].first >> arr[i].second;
		--arr[i].first, --arr[i].second;
		
	}
	int mrg = -1;
	if (m >= 2) {
		if (arr[0].first == arr[1].first)
			mrg = arr[0].first;
		else if (arr[0].second == arr[1].first)
			mrg = arr[0].second;
		else if (arr[0].first == arr[1].second)
			mrg = arr[0].first;
		else if (arr[0].second == arr[1].second)
			mrg = arr[0].second;

	}
	for (int i = 2; i < m; ++i) {
		if (mrg == arr[i].first || mrg == arr[i].second)
			mrg = mrg;
		else
			mrg = -1;
	}
	if (mrg == -1) {
		for (pa i : arr) {
			crass(i.first, i.second);
		}
	} else {
		for (pa i : arr) {
			if (i.second == mrg)
				swap(i.second, i.first);
			crass(mrg, i.second);
		}
	}
	print();

}