﻿// C1.cpp : Этот файл содержит функцию "main". Здесь начинается и заканчивается выполнение программы.
//

#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

void dfs(int u, int p, vector<vector<pair<int, int> > >& g, vector<int>& w) {
    for (auto e : g[u]) {
        int v = e.first, d = e.second;
        if (v == p) continue;
        w[v] = w[u] + d;
        dfs(v, u, g, w);
    }
}

vector<int> anspath, path;

void find_path(int u, int p, int to, vector<vector<int> >& g) {
    path.push_back(u);
    if (u == to) {
        anspath = path;
        return;
    }
    for (int v : g[u]) {
        if (v == p) continue;
        find_path(v, u, to, g);
        if (!anspath.empty()) return;
    }
    path.pop_back();
}

int main() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<pair<int, int> > e(n - 1);
    vector<vector<int> > g1(n);
    for (int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
       // cout << u << ' ' << v << endl;
        e[i] = { u - 1, v - 1 };
        g1[u - 1].push_back(v - 1);
        g1[v - 1].push_back(u - 1);
    }
    vector<pair<int, int> > a(m);
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        a[i] = { u - 1, v - 1 };
    }
    vector<vector<int> > paths(m);
    for (int i = 0; i < m; i++) {
        path.clear(), anspath.clear();
        find_path(a[i].first, -1, a[i].second, g1);
        paths[i] = anspath;
    }
    int pw = (1 << (n - 1));
    int ans = 1e9;
    vector<int> answ;
    for (int mask = 0; mask < pw; mask++) {
        vector<vector<pair<int, int> > > g(n);
        for (int i = 0; i < n - 1; i++) {
            int u = e[i].first, v = e[i].second;
            if ((mask >> i) & 1) {
                g[u].push_back({ v, 1 });
                g[v].push_back({ u, -1 });
            } else {
                g[u].push_back({ v, -1 });
                g[v].push_back({ u, 1 });
            }
        }
        vector<int> w(n);
        dfs(0, -1, g, w);
        bool ok = 1;
        for (auto elem : paths) {
            if (elem.size() == 1) continue;
            int sz = (int)elem.size();
            for (int i = 1; i < sz; i++) {
                if (w[elem[i]] - w[elem[i - 1]] != w[elem[1]] - w[elem[0]]) {
                    ok = 0;
                    break;
                }
            }
            if (!ok) {
                break;
            }
        }
        if (!ok) {
            continue;
        }
        int mn = *min_element(w.begin(), w.end());
        for (int i = 0; i < n; i++) {
            w[i] -= mn - 1;
        }
        int val = *max_element(w.begin(), w.end());
        if (val < ans) {
            ans = val;
            answ = w;
        }
    }
    if (answ.empty()) {
        cout << -1 << endl;
        return 0;
    }
    cout << ans << endl;
    if (t == 0) return 0;
    for (int i : answ) cout << i << ' ';
    cout << endl;
}

// Запуск программы: CTRL+F5 или меню "Отладка" > "Запуск без отладки"
// Отладка программы: F5 или меню "Отладка" > "Запустить отладку"

// Советы по началу работы 
//   1. В окне обозревателя решений можно добавлять файлы и управлять ими.
//   2. В окне Team Explorer можно подключиться к системе управления версиями.
//   3. В окне "Выходные данные" можно просматривать выходные данные сборки и другие сообщения.
//   4. В окне "Список ошибок" можно просматривать ошибки.
//   5. Последовательно выберите пункты меню "Проект" > "Добавить новый элемент", чтобы создать файлы кода, или "Проект" > "Добавить существующий элемент", чтобы добавить в проект существующие файлы кода.
//   6. Чтобы снова открыть этот проект позже, выберите пункты меню "Файл" > "Открыть" > "Проект" и выберите SLN-файл.
