#include<iostream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<time.h>
#include<random>
#include<stack>
#include<queue>
#include<deque>
#include<set>
#include<unordered_set>
#include<map>
#include<unordered_map>
#include<string>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()
#define sz(c) (int)(c).size()

const int MAXN= 15;
const int INF = 1e9;

int pr[MAXN];
int go[20][MAXN];
int hgt[MAXN];

vector<int> g[MAXN];

void dfs(int v) {
	for (auto u : g[v]) {
		if (u != pr[v]) {
			hgt[u] = hgt[v] + 1;
			pr[u] = v;
			dfs(u);
		}
	}
}

int n, m, t;

int lca(int v, int u) {
	if (hgt[v] < hgt[u]) {
		swap(u, v);
	}
	for (int lg = 19; lg >= 0; --lg) {
		if (hgt[go[lg][v]] >= hgt[u]) {
			v = go[lg][v];
		}
	}
	if (u == v) {
		return u;
	}
	for (int lg = 19; lg >= 0; --lg) {
		if (go[lg][v] != go[lg][u]) {
			v = go[lg][v];
			u = go[lg][u];
		}
	}
	int res = pr[v];
	return res;
}

int ans = INF;
int mx, mn;
vector<int> c_ans;
vector<int> up;

vector<vector<pair<int, int>>> g2;
vector<int> c;

void solve(int v) {
	for (auto pu : g2[v]) {
		int u = pu.first;
		int w = pu.second;
		if (u != pr[v]) {
			c[u] = c[v] + w;
			mx = max(mx, c[u]);
			mn = min(mn, c[u]);
			solve(u);
		}
	}
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	for (int i = 0; i < MAXN; ++i) {
		pr[i] = -1;
		hgt[i] = 0;
	}
	for (int i = 0; i < 20; ++i) {
		for (int j = 0; j < MAXN; ++j) {
			go[i][j] = -1;
		}
	}
	cin >> n >> m >> t;
	for (int i = 0; i < n - 1; ++i) {
		int x, y;
		cin >> x >> y;
		x--; y--;
		g[x].pb(y);
		g[y].pb(x);
	}
	dfs(0);
	for (int i = 0; i < n; ++i) {
		go[0][i] = pr[i];
	}
	for (int i = 1; i < 20; ++i) {
		for (int j = 0; j < n; ++j) {
			if (go[i -1][j] != -1) {
				go[i][j] = go[i - 1][go[i - 1][j]];
			}
		}
	}



	vector<pair<int, int>> prs;
	for (int i = 0; i < m; ++i) {
		int x, y; cin >> x >> y; x--; y--;
		prs.pb({x, y});
	}



	for (int msk = 0; msk < (1 << (n - 1)); ++msk) {
		bool error = true;
		c.clear();
		c.resize(n, 0);
		mn = 0;
		mx = 0;
		g2.clear();
		g2.resize(n);
		up.clear();
		up.resize(n);
		for (int i = 0; i < (n - 1) && error; ++i) {
			int w = 1;
			if ((msk & (1 << i)) > 0) {
				w = -1;
			}
			g2[pr[i + 1]].pb({ i + 1, w });
			up[i + 1] = w;
		}
		for (int i = 0; i < m && error; ++i) {
			int x = prs[i].first;
			int y = prs[i].second;
			int x0 = x, y0 = y;
			int lc = lca(x, y);
			int k1 = up[x];
			int k2 = up[y];
			while (x != lc && error) {
				if (k1 != up[x]) {
					error = false;
					break;
				}
				x = pr[x];
			}
			while (y != lc && error) {
				if (k2 != up[y]) {
					error = false;
					break;
				}
				y = pr[y];
			}
			if (x0 == lc || y0 == lc || k1 != k2) {
				x++;
			}
			else {
				error = false;
			}
		}
		if (error) {
			solve(0);
			if ((mx - mn + 1) < ans) {
				ans = (mx - mn + 1);
				for (int i = 0; i < n; ++i) {
					c[i] += (1 - mn);
				}
				c_ans = c;
			}
		}
		
	}
	if (ans == INF) {
		cout << -1;
		//system("pause");
		return 0;
	}
	cout << ans << endl;
	
		for (auto el : c_ans) {
			cout << el << " ";
		}
	//system("pause");
	return 0;
}
