#include<bits/stdc++.h>

#define int long long
#define x first
#define y second
#define mp make_pair
#define pb push_back
#define all(v) v.begin(), v.end()
#define sz(v) (int) v.size()
#define TASK ""

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int N = 5e5 + 5;

int n;

vector<int> G[N];
int used[N], deep[N];
bool cycle;

void dfs(int v) {
    used[v] = 1;
    for (int &u : G[v]) {
        if (!used[u]) {
            dfs(u);
        } else if (used[u] == 1) {
            cycle = true;
        }
        deep[v] = max(deep[v], deep[u] + 1);
    }
    used[v] = 2;
}

bool check() {
    cycle = false;
    fill(used, used + n, 0);
    fill(deep, deep + n, 1);
    for (int v = 1; v <= n; ++v) {
        if (!used[v]) {
            dfs(v);
            if (cycle) {
                return false;
            }
        }
    }
    return true;
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#else
if (strlen(TASK) > 0)
    freopen(TASK".in", "r", stdin),
    freopen(TASK".out", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int m, type;
    cin >> n >> m >> type;
    vector<int> cnt(n);
    for (int i = 0; i < n - 1; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        cnt[v]++;
        cnt[u]++;
    }
    int root = 0;
    for (int i = 1; i < n; ++i) {
        if (cnt[i] == n - 1) {
            root = i;
            break;
        }
    }
    assert(cnt[root] == n - 1);
    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int v, u;
        cin >> v >> u;
        --v, --u;
        if (v != root && u != root) {
            g[v].pb(u);
            g[u].pb(v);
        }
    }
    for (int v = 0; v < n; ++v) {
        sort(all(g[v]));
        g[v].resize(unique(all(g[v])) - g[v].begin());
    }
    vector<int> c(n, 1);
    c[root] = 2;
    vector<bool> used(n);
    vector<unordered_map<int, int>> t(n);
    function<void(int, int)> dfs = [&](int v, int tp) {
        used[v] = true;
        for (int &u : g[v]) {
            if (t[u][v] == 1) {
                t[v][u] = -1;
            } else if (t[u][v] == -1) {
                t[v][u] = 1;
            } else {
                t[v][u] = tp;
                dfs(u, (tp == -1 ? 1 : -1));
            }
        }
    };
    for (int v = 0; v < n; ++v) {
        if (used[v]) {
            continue;
        }
        dfs(v, 1);
    }
    for (int v = 0; v < n; ++v) {
        for (int &u : g[v]) {
            if (t[v][u] == 1) {
                G[v].pb(u);
            } else {
                G[u].pb(v);
            }
        }
    }
    if (!check()) {
        cout << "-1\n";
        return 0;
    }
    cout << *max_element(deep, deep + n) << "\n";
    if (type) {
        for (int i = 0; i < n; ++i) {
            cout << deep[i] << " ";
        }
        cout << "\n";
    }

    return 0;
}
