#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ull = unsigned long long;
using ld = long double;
#define all(a) a.begin(), a.end()

template <typename T1, typename T2> inline void chkmin(T1 & x, const T2 & y) {if (y < x) x = y;}
template <typename T1, typename T2> inline void chkmax(T1 & x, const T2 & y) {if (x < y) x = y;}

struct event{
	int a, b;
	event() {}
};

const int MAXN = 5e5 + 10;

struct edge{
	int to, ind;
	edge() {}
	edge(int _to, int _ind) {
		to = _to, ind = _ind;
	}
};

int n, m, t;
vector<edge> g[MAXN];
vector<event> have;
int ind;

void read() {
	//cin >> n >> m >> t;
	ind = 0;
	for (int i = 0; i < n - 1; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back({v, ind});
		g[v].push_back({u, ind});
		ind++;
	}
	have.resize(m);
	for (auto &i : have) {
		cin >> i.a >> i.b;
		i.a--;
		i.b--;
	}
}

const int MAXLOG = 20;

int tin[MAXN], tout[MAXN], dp[MAXN][MAXLOG], timer = 0, h[MAXN];
int Ind[MAXN];

void dfs_lca(int v, int p, int len) {
	tin[v] = timer++;
	h[v] = len++;
	dp[v][0] = p;
	for (int i = 1; i < MAXLOG; i++)
		dp[v][i] = dp[dp[v][i - 1]][i - 1];
	for (auto i : g[v]) {
		if (i.to != p) {
			dfs_lca(i.to, v, len);
		}
		else {
			Ind[v] = i.ind;
		}
	}
	tout[v] = timer++;
}

bool is_upper(int v, int u) {
	return tin[v] <= tin[u] && tout[v] >= tout[u];
}

int lca(int v, int u) {
	if (is_upper(v, u)) return v;
	if (is_upper(u, v)) return u;
	for (int i = MAXLOG - 1; i >= 0; i--)
		if (!is_upper(dp[v][i], u))
			v = dp[v][i];
	return dp[v][0];
}

bool check_group_7_8() {
	// ALERT!!!!!
	//return t == 0;
	return true;
}

int ans;
vector<int> fans;

int par[MAXN], sz[MAXN];

void make() {
	for (int i = 0; i < n; i++)
		par[i] = i, sz[i] = 1;
}

int get_par(int v) {
	if (v == par[v]) return v;
	return par[v] = get_par(par[v]);
}

int root;

void uni(int a, int b) {
	a = get_par(a);
	b = get_par(b);
	if (a == b) return;
	if (sz[a] < sz[b]) swap(a, b);
	par[b] = a;
	sz[a] += sz[b];
}

bool need_add[MAXN];
int make(int v, int LCA) {
	if (v == LCA) return -1;
	int ind = Ind[v];
	need_add[ind] = true;
	while (dp[v][0] != LCA) {
		v = dp[v][0];
		int n_ind = Ind[v];
		uni(ind, n_ind);
		ind = n_ind;
		need_add[ind] = true;
	}
	return ind; 
}

vector<int> g_check[MAXN];

int color[MAXN];

void dfs_check(int v, int p, int c) {
	color[v] = c;
	for (auto i : g_check[v]) {
		if (i == p) continue;
		if (!color[i]) {
			dfs_check(i, v, 3 - c);
		}
		else if (color[i] != 3 - c) {
			cout << -1 << endl;
			exit(0);
		}
	}
}

void check() {
	for (int i = 0; i < n; i++) {
		if (!color[i]) {
			dfs_check(i, -1, 1);
		}
	}
}

void dfs_down(int v, int p) {
	for (auto i : g[v]) {
		if (i.to != p) {
			dfs_down(i.to, v);
		}
	}
	if (p == -1) return;
	if (!need_add[Ind[v]]) return;
	if (color[get_par(Ind[v])] == 2) return;
	chkmax(fans[p], fans[v] + 1);
}

void dfs_up(int v, int p) {
	for (auto i : g[v]) {
		if (i.to != p) {
			if (need_add[i.ind]) {
				if (color[get_par(i.ind)] == 2) {
					chkmax(fans[i.to], fans[v] + 1);
				}
			}
			dfs_up(i.to, v);
		} 
	}
}

int real_ans = 1e9 + 10;
vector<int> real_fans;

void relax() {
	if (ans < real_ans) {
		real_ans = ans;
		real_fans = fans;
	}
}

void make_ans() {
	dfs_down(root, -1);
	dfs_up(root, -1);
	
	dfs_down(root, -1);
	dfs_up(root, -1);
	
	dfs_down(root, -1);
	dfs_up(root, -1);
	
	dfs_down(root, -1);
	dfs_up(root, -1);
	
	dfs_down(root, -1);
	dfs_up(root, -1);
	
	dfs_down(root, -1);
	dfs_up(root, -1);
	
	dfs_down(root, -1);
	dfs_up(root, -1);
	
	dfs_down(root, -1);
	dfs_up(root, -1);
	
	dfs_down(root, -1);
	dfs_up(root, -1);
	
	dfs_down(root, -1);
	dfs_up(root, -1);
	
	dfs_down(root, -1);
	dfs_up(root, -1);
	
	ans = 0;
	for (auto i : fans)
		chkmax(ans, i);

	int Min = ans;
	for (auto i : fans)
		chkmin(Min, i);
	Min--;
	ans -= Min;
	for (auto &i : fans)
		i -= Min;
	relax();
}

void no() {
	cout << -1 << endl;
	exit(0);
}

void check(int v, int p) {
	for (auto i : g[v]) {
		if (i.to == p) continue;
		if (!need_add[i.ind]) continue;
		if (color[get_par(i.ind)] == 1) {
			if (fans[i.to] >= fans[v]) {
				no();
			}
		}
		else {
			if (fans[i.to] <= fans[v]) {
				no();
			}
		}
	}
	for (auto i : g[v]) {
		if (i.to != p) {
			check(i.to, v);
		}
	}
}

void check_ans() {
	check(root, -1);
}

mt19937 rnd(time(0));

void solve_group_7_8() {
	for (int i = 0; i < 100000000 / n; i++) {
		root = rnd() % n;
		dfs_lca(root, root, 0);
		make();
		vector<pair<int, int>> help;
		for (auto i : have) {
			int l = lca(i.a, i.b);
			help.push_back({make(i.a, l), make(i.b, l)});
		}
		
		for (int i = 0; i < n; i++) {
			g_check[i].clear();
		}

		for (int i = 0; i < m; i++) {
			int l = lca(have[i].a, have[i].b);
			if (have[i].a == l || have[i].b == l) continue;
			int u = get_par(help[i].first);
			int v = get_par(help[i].second);
			g_check[u].push_back(v);
			g_check[v].push_back(u);
		}
		check();
		fans.assign(n, 1);
		make_ans();
		check_ans();
	}
}

void run() {
	if (check_group_7_8()) solve_group_7_8();
}

void write() {
	ans = real_ans;
	fans = real_fans;
	cout << ans << endl;
	assert(ans <= 1e7);
	for (auto i : fans) {
		cout << i << " ";
	}
	cout << endl;
}

namespace stupid_solve{

	struct event{
		int a, b;
		event() {}
	};

	const int MAXN = 30;

	int n, m, t;
	vector<int> g[MAXN];
	vector<event> have;

	void read() {
		//cin >> n >> m >> t;
		for (int i = 0; i < n - 1; i++) {
			int u, v;
			cin >> u >> v;
			u--;
			v--;
			g[u].push_back(v);
			g[v].push_back(u);
		}
		have.resize(m);
		for (auto &i : have) {
			cin >> i.a >> i.b;
			i.a--;
			i.b--;
		}
	}

	const int INF = 1e9 + 10;

	int ans;
	vector<int> fans;

	bool check_group_1_2() {
		return n <= 15 && m <= 15;
	}

	vector<int> c;
	vector<vector<int>> path;

	void colored(int ind, int type) {
		if (type == 0) {
			for (int i = 1; i < path[ind].size(); i++) {
				chkmax(c[path[ind][i]], c[path[ind][i - 1]] + 1);
			}
		}
		else {
			for (int i = path[ind].size() - 2; i >= 0; i--) {
				chkmax(c[path[ind][i]], c[path[ind][i + 1]] + 1);
			}
		}
	}

	bool check(int ind, int type) {
		if (type == 0) {
			for (int i = 1; i < path[ind].size(); i++) {
				if (c[path[ind][i]] <= c[path[ind][i - 1]]) return false;
			}
		}
		else {
			for (int i = path[ind].size() - 2; i >= 0; i--) {
				if (c[path[ind][i]] <= c[path[ind][i + 1]]) return false;
			}
		}
		return true;
	}

	vector<int> calc(int mask) {
		c.assign(n, 1);
		for (int i = 0; i < m; i++) {
			colored(i, (mask >> i) & 1);
		}

		/*cout << "c = " << endl;
		for (auto i : c) {
			cout << i << " ";
		}
		cout << endl;*/
		for (int i = 0; i < m; i++) {
			if (!check(i, (mask >> i) & 1)) {
				c.assign(n, INF);
				return c;
			}
		}
		return c;

	}

	vector<int> now;
	bool flag = false;

	void dfs(int v, int p, int need) {
		now.push_back(v);
		if (v == need) {
			flag = true;
			return;
		}
		for (auto i : g[v]) {
			if (i == p) continue;
			if (flag) return;
			dfs(i, v, need);
			if (flag) return;
		}
		now.pop_back();
	}

	vector<int> make_path(int a, int b) {
		flag = false;
		now.clear();
		dfs(a, -1, b);
		return now;
	}

	void make_path() {
		path.clear();
		for (auto i : have) {
			path.push_back(make_path(i.a, i.b));
		}
	}

	void solve_group_1_2() {
		ans = INF;
		make_path();
		/*cout << "path = " << endl;
		for (auto i : path) {
			cout << "now = ";
			for (auto j : i) {
				cout << j << " ";
			}
			cout << endl;
		}
		cout << "end" << endl;*/
		fans = {};
		for (int i = 0; i < (1 << m); i++) {
			vector<int> have = calc(i);
			int my_ans = 0;
			for (auto j : have) chkmax(my_ans, j);
			if (my_ans < ans) {
				ans = my_ans;
				fans = have;
			}
		}
		if (ans == INF) {
			cout << -1 << endl;
			exit(0);
		}
	}

	void run() {
		if (check_group_1_2()) solve_group_1_2();
	}

	void write() {
		cout << ans << endl;
		for (auto i : fans) {
			cout << i << " ";
		}
		cout << endl;
	}

	void main() {
		ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
		read();
		run();
		write();
	}
}


signed main() {
	ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0), cout.setf(ios::fixed), cout.precision(20);
	cin >> n >> m >> t;
	if (n <= 15 && m <= 15) {
		stupid_solve::n = n;
		stupid_solve::m = m;
		stupid_solve::t = t;
		stupid_solve::main();
		return 0;
	}
	read();
	run();
	write();
	return 0;
}


/*
8 8 0
2 1
3 1
4 2
5 1
6 4
7 5
8 1

3 5
7 2
7 5
1 2
2 4
8 2
5 7
7 6


*/