#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <math.h>
#include <cmath>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <deque>

using namespace std;

#define x first
#define y second
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define int long long

vector<int> ans;
vector<bool> usd;

int LOG = 21, tm = 0;

vector<vector<int>> a;
vector<vector<int>> pp;
vector<int> tin, tout;

void dfs(int v, int par = -1)
{
	tin[v] = tm++;
	pp[v][0] = par;
	for (auto i : a[v])
	{
		if (i == par) continue;
		dfs(i, v);
	}
	tout[v] = tm++;
}

bool isPar(int u, int v)
{
	return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}

int lca(int x, int y)
{
	if (isPar(x, y)) return x;
	if (isPar(y, x)) return y;
	for (int i = LOG - 1; i >= 0; i--)
	{
		if (!isPar(pp[x][i], y)) x = pp[x][i];
	}
	return pp[x][0];
}

bool dfs2(int v, int par)
{
	bool flag = usd[v];
	for (auto i : a[v])
	{
		if (i == par) continue;
		if (dfs2(i, v))
		{
			ans[v] = max(ans[v], ans[i] + 1);
			flag = true;
		}
	}
	return flag;
}

vector<vector<int>> nxt;
vector<int> nt(4);

bool dfs3(int v, int col)
{
	usd[v] = true;
	ans[v] = col;
	col = nt[col];
	for (auto i : nxt[v])
	{
		if (usd[i])
		{
			if (ans[i] == ans[v]) return false;
			continue;
		}
		if (!dfs3(i, col)) return false;
	}
	return true;
}

vector<vector<int>> topsort;
vector<int> temp;
vector<int> temp2;

void top(int v)
{
	usd[v] = true;
	for (auto i : a[v])
	{
		if (usd[i]) continue;
		top(i);
	}
	temp.push_back(v);
	
}

bool top2(int v)
{
	usd[v] = true;
	temp2[v] = 1;
	for (auto i : a[v])
	{
		if (usd[i]) return false;
		if (!top2(i)) return false;
		temp2[v] = max(temp2[v], temp2[i] + 1);
	}
	return true;
}

int32_t main()
{
	int n, m, ttt;
	cin >> n >> m >> ttt;
	a.resize(n, vector<int>(0));
	ans.resize(n, 1);
	usd.resize(n, false);
	tin.resize(n);
	tout.resize(n);
	pp.resize(n, vector<int>(LOG));

	for (int i = 1; i < n; i++)
	{
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		a[x].push_back(y);
		a[y].push_back(x);
	}

	
	dfs(0, 0);

	vector<vector<int>> path(0);
	
	for (int i = 0; i < m; i++)
	{
		vector<int> pth;
		int x, y;
		cin >> x >> y;
		x--;
		y--;
		int u = lca(x, y);
		while (x != u)
		{
			pth.push_back(x);
			x = pp[x][0];
		}
		pth.push_back(x);
		vector<int> tmp;
		while (y != u)
		{
			tmp.push_back(y);
			y = pp[y][0];
		}

		for (int j = (int)tmp.size() - 1; j >= 0; j--)
		{
			pth.push_back(tmp[j]);
		}
		if (pth.size() > 2) path.push_back(pth);
	}

	m = path.size();
	if (m == 0)
	{
		cout << 2 << '\n';
		for (int i = 0; i < n; i++)
		{
			if (a[i].size() == n - 1)
			{
				ans[i] = 2;
				break;
			}
		}
		for (auto i : ans) cout << i << " ";
		return 0;
	}
	
	if (n <= 8 && m <= 8)
	{
		int mx = 1e9;
		topsort.resize(n, vector<int>(0));
		for (int i = 0; i < (1 << m); i++)
		{
			bool flag2 = false;
			temp.clear();
			for (int j = 0; j < n; j++) topsort[i].clear();
			for (int j = 0; j < m; j++)
			{
				if ((i >> j) & 1)
				{
					for (int k = 0; k + 1 < path[i].size(); k++) topsort[path[j][k]].push_back(path[j][k + 1]);
				}
				else
				{
					for (int k = 0; k + 1 < path[i].size(); k++) topsort[path[j][k]].push_back(path[j][k + 1]);
				}
			}
			for (int i = 0; i < n; i++) usd[i] = 0;
			for (int i = 0; i < n; i++)
			{
				if (usd[i] != 0) continue;
				if (!top(i)) continue;
			}
			for (int i = 0; i < n; i++) usd[i] = 0;
			reverse(all(temp));
			for (auto i : temp)
			{
				if (usd[i]) continue;
				if (!top2(i)) flag2 = false;
			}
			temp2.clear();
			temp2.resize(n);
			if (!flag2) continue;
			int mx2 = 0;
			for (auto i : temp2)
			{
				mx2 = max(mx2, i);
			}
			if (mx2 < mx)
			{
				ans = temp2;
				mx = mx2;
			}
		}
		if (mx == 1e9)
		{
			cout << -1;
			return 0;
		}
		cout << mx << '\n';
		for (auto i : ans) cout << i;
		return 0;
	}

	int rt = 0;
	for (int i = 0; i < n; i++)
	{
		if (a[i].size() == n - 1)
		{
			rt = i;
			break;
		}
	}

	ans[rt] = 2;

	nxt.resize(n);
	
	nt[3] = 1;
	nt[1] = 3;
	for (int i = 0; i < m; i++)
	{
		nxt[path[i][0]].push_back(path[i][2]);
		nxt[path[i][2]].push_back(path[i][0]);
	}

	for (int i = 0; i < n; i++)
	{
		if (usd[i] || i == rt) continue;
		if (!dfs3(i, 1))
		{
			cout << -1;
			return 0;
		}
	}
	
	cout << 3 << '\n';
	for (auto i : ans) cout << i << " ";
	return 0;
}

