#define _CRT_SECURE_NO_WARNINGS

#include <algorithm>
#include <cassert>
#include <cmath>
#include <cstring>
#include <ctime>
#include <deque>
#include <fstream>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stdio.h>
#include <string>
#include <vector>

using namespace std;

#define mp make_pair
#define all(x) x.begin(), x.end()
#define multi_test 0

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, int> pli;
typedef pair<ll, ll> pll;

void solve();

const ll MAXN = 3e5 + 7;
const ll INF = 2e9 + 11;
const ll MOD = 1e9 + 9;
const ll INF1 = 9e18;
const ld EPS = 1e-8;

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q = 1;
    if (multi_test) cin >> q;
    while (q--) solve();
}

/*----------------------------------------------------------------------------*/

void bfs(int s, vector<int> &par, const vector<vector<int>> &g) {
    par[s] = -1;
    vector<bool> used(g.size());
    used[s] = true;
    queue<int> q;
    q.push(s);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int to : g[v]) {
            if (!used[to]) {
                used[to] = true;
                par[to] = v;
                q.push(to);
            }
        }
    }
}

void dfs(int v, vector<bool> &used, vector<int> &dist, vector<int> &par, const vector<vector<int>> &g) {
    for (int to : g[v]) {
        if (!used[to]) {
            used[to] = true;
            dist[to] = dist[v] + 1;
            par[to] = v;
            dfs(to, used, dist, par, g);
        }
    }
}

void dfs2(int v, vector<bool> &used, vector<int> &dist, const vector<vector<int>> &g, const vector<vector<int>> &revg) {
    for (int to : g[v]) {
        if (!used[to]) {
            used[to] = true;
            dist[to] = dist[v] + 1;
            dfs2(to, used, dist, g, revg);
        }
    }
    for (int to : revg[v]) {
        if (!used[to]) {
            used[to] = true;
            dist[to] = dist[v] - 1;
            dfs2(to, used, dist, g, revg);
        }
    }
}

void solve() {
    int n, m, t;
    cin >> n >> m >> t;
    vector<vector<int>> g(n);
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    vector<vector<vector<int>>> paths(n, vector <vector<int>>(n));
    for (int i = 0; i < n; ++i) {
        vector<int> par(n);
        bfs(i, par, g);
        for (int j = 0; j < n; ++j) {
            vector<int> path;
            for (int k = j; k != -1; k = par[k])
                path.push_back(k);
            reverse(all(path));
            paths[i][j] = path;
        }
    }
    vector<vector<int>> cnt(n, vector<int>(n));
    vector<vector<bool>> g2(n, vector<bool>(n));
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        for (int i = 0; i < paths[a][b].size() - 1; ++i) {
            ++cnt[paths[a][b][i]][paths[a][b][i + 1]];
            g2[paths[a][b][i]][paths[a][b][i + 1]] = true;
            if (cnt[paths[a][b][i + 1]][paths[a][b][i]] > 0) {
                cout << "-1\n";
                exit(0);
            }
        }
    }
    vector<vector<int>> g3(n), revg3(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (g2[i][j]) {
                g3[i].push_back(j);
                revg3[j].push_back(i);
            }
        }
    }
    int best = 0, besta, bestb;
    vector<int> bestp;
    for (int i = 0; i < n; ++i) {
        vector<int> dist(n);
        vector<bool> used(n);
        used[i] = true;
        vector<int> par(n);
        par[i] = -1;
        dfs(i, used, dist, par, g3);
        auto it = max_element(all(dist));
        if (*it > best) {
            best = *it;
            besta = i;
            bestb = (int)(it - dist.begin());
            bestp = par;
        }
    }
    vector<int> ans(n, 1);
    vector<bool> used(n);
    used[besta] = true;
    dfs2(besta, used, ans, g3, revg3);
    cout << best + 1 << '\n';
    for (int i : ans)
        cout << i << ' ';
    cout << '\n';
}